declare type EPhaserLFOType = 'Sine' | 'UpSaw' | 'DownSaw' | 'Square' | 'Triangle' | 'Exponential' | 'RandomSampleHold' | 'Count' | 'EPhaserLFOType_MAX';
declare var EPhaserLFOType : { Sine:'Sine',UpSaw:'UpSaw',DownSaw:'DownSaw',Square:'Square',Triangle:'Triangle',Exponential:'Exponential',RandomSampleHold:'RandomSampleHold',Count:'Count',EPhaserLFOType_MAX:'EPhaserLFOType_MAX', };
declare class SourceEffectPhaserSettings { 
	WetLevel: number;
	Frequency: number;
	Feedback: number;
	LFOType: EPhaserLFOType;
	UseQuadraturePhase: boolean;
	clone() : SourceEffectPhaserSettings;
	static C(Other: UObject | any): SourceEffectPhaserSettings;
}

declare class SourceEffectPhaserPreset extends SoundEffectSourcePreset { 
	Settings: SourceEffectPhaserSettings;
	static Load(ResourceName: string): SourceEffectPhaserPreset;
	static Find(Outer: UObject, ResourceName: string): SourceEffectPhaserPreset;
	static GetDefaultObject(): SourceEffectPhaserPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SourceEffectPhaserPreset;
	SetSettings(InSettings: SourceEffectPhaserSettings): void;
	static C(Other: UObject | any): SourceEffectPhaserPreset;
}

declare type ERingModulatorTypeSourceEffect = 'Sine' | 'Saw' | 'Triangle' | 'Square' | 'Count' | 'ERingModulatorTypeSourceEffect_MAX';
declare var ERingModulatorTypeSourceEffect : { Sine:'Sine',Saw:'Saw',Triangle:'Triangle',Square:'Square',Count:'Count',ERingModulatorTypeSourceEffect_MAX:'ERingModulatorTypeSourceEffect_MAX', };
declare class SourceEffectRingModulationSettings { 
	ModulatorType: ERingModulatorTypeSourceEffect;
	Frequency: number;
	Depth: number;
	DryLevel: number;
	WetLevel: number;
	AudioBusModulator: AudioBus;
	clone() : SourceEffectRingModulationSettings;
	static C(Other: UObject | any): SourceEffectRingModulationSettings;
}

declare class SourceEffectRingModulationPreset extends SoundEffectSourcePreset { 
	Settings: SourceEffectRingModulationSettings;
	static Load(ResourceName: string): SourceEffectRingModulationPreset;
	static Find(Outer: UObject, ResourceName: string): SourceEffectRingModulationPreset;
	static GetDefaultObject(): SourceEffectRingModulationPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SourceEffectRingModulationPreset;
	SetSettings(InSettings: SourceEffectRingModulationSettings): void;
	static C(Other: UObject | any): SourceEffectRingModulationPreset;
}

declare class SourceEffectSimpleDelaySettings { 
	SpeedOfSound: number;
	DelayAmount: number;
	DryAmount: number;
	WetAmount: number;
	Feedback: number;
	bDelayBasedOnDistance: boolean;
	bUseDistanceOverride: boolean;
	clone() : SourceEffectSimpleDelaySettings;
	static C(Other: UObject | any): SourceEffectSimpleDelaySettings;
}

declare class SourceEffectSimpleDelayPreset extends SoundEffectSourcePreset { 
	Settings: SourceEffectSimpleDelaySettings;
	static Load(ResourceName: string): SourceEffectSimpleDelayPreset;
	static Find(Outer: UObject, ResourceName: string): SourceEffectSimpleDelayPreset;
	static GetDefaultObject(): SourceEffectSimpleDelayPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SourceEffectSimpleDelayPreset;
	SetSettings(InSettings: SourceEffectSimpleDelaySettings): void;
	static C(Other: UObject | any): SourceEffectSimpleDelayPreset;
}

declare type EStereoDelaySourceEffect = 'Normal' | 'Cross' | 'PingPong' | 'Count' | 'EStereoDelaySourceEffect_MAX';
declare var EStereoDelaySourceEffect : { Normal:'Normal',Cross:'Cross',PingPong:'PingPong',Count:'Count',EStereoDelaySourceEffect_MAX:'EStereoDelaySourceEffect_MAX', };
declare type EStereoDelayFiltertype = 'Lowpass' | 'Highpass' | 'Bandpass' | 'Notch' | 'Count' | 'EStereoDelayFiltertype_MAX';
declare var EStereoDelayFiltertype : { Lowpass:'Lowpass',Highpass:'Highpass',Bandpass:'Bandpass',Notch:'Notch',Count:'Count',EStereoDelayFiltertype_MAX:'EStereoDelayFiltertype_MAX', };
declare class SourceEffectStereoDelaySettings { 
	DelayMode: EStereoDelaySourceEffect;
	DelayTimeMsec: number;
	Feedback: number;
	DelayRatio: number;
	WetLevel: number;
	DryLevel: number;
	bFilterEnabled: boolean;
	FilterType: EStereoDelayFiltertype;
	FilterFrequency: number;
	FilterQ: number;
	clone() : SourceEffectStereoDelaySettings;
	static C(Other: UObject | any): SourceEffectStereoDelaySettings;
}

declare class SourceEffectStereoDelayPreset extends SoundEffectSourcePreset { 
	Settings: SourceEffectStereoDelaySettings;
	static Load(ResourceName: string): SourceEffectStereoDelayPreset;
	static Find(Outer: UObject, ResourceName: string): SourceEffectStereoDelayPreset;
	static GetDefaultObject(): SourceEffectStereoDelayPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SourceEffectStereoDelayPreset;
	SetSettings(InSettings: SourceEffectStereoDelaySettings): void;
	static C(Other: UObject | any): SourceEffectStereoDelayPreset;
}

declare class SourceEffectWaveShaperSettings { 
	Amount: number;
	OutputGainDb: number;
	clone() : SourceEffectWaveShaperSettings;
	static C(Other: UObject | any): SourceEffectWaveShaperSettings;
}

declare class SourceEffectWaveShaperPreset extends SoundEffectSourcePreset { 
	Settings: SourceEffectWaveShaperSettings;
	static Load(ResourceName: string): SourceEffectWaveShaperPreset;
	static Find(Outer: UObject, ResourceName: string): SourceEffectWaveShaperPreset;
	static GetDefaultObject(): SourceEffectWaveShaperPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SourceEffectWaveShaperPreset;
	SetSettings(InSettings: SourceEffectWaveShaperSettings): void;
	static C(Other: UObject | any): SourceEffectWaveShaperPreset;
}

declare class SubmixEffectConvolutionReverbSettings { 
	NormalizationVolumeDb: number;
	WetVolumeDb: number;
	DryVolumeDb: number;
	bBypass: boolean;
	bMixInputChannelFormatToImpulseResponseFormat: boolean;
	bMixReverbOutputToOutputChannelFormat: boolean;
	SurroundRearChannelBleedDb: number;
	bInvertRearChannelBleedPhase: boolean;
	bSurroundRearChannelFlip: boolean;
	SurroundRearChannelBleedAmount: number;
	ImpulseResponse: AudioImpulseResponse;
	AllowHardwareAcceleration: boolean;
	clone() : SubmixEffectConvolutionReverbSettings;
	static C(Other: UObject | any): SubmixEffectConvolutionReverbSettings;
}

declare class SubmixEffectConvolutionReverbPreset extends SoundEffectSubmixPreset { 
	ImpulseResponse: AudioImpulseResponse;
	Settings: SubmixEffectConvolutionReverbSettings;
	BlockSize: ESubmixEffectConvolutionReverbBlockSize;
	bEnableHardwareAcceleration: boolean;
	static Load(ResourceName: string): SubmixEffectConvolutionReverbPreset;
	static Find(Outer: UObject, ResourceName: string): SubmixEffectConvolutionReverbPreset;
	static GetDefaultObject(): SubmixEffectConvolutionReverbPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubmixEffectConvolutionReverbPreset;
	SetSettings(InSettings: SubmixEffectConvolutionReverbSettings): void;
	SetImpulseResponse(InImpulseResponse: AudioImpulseResponse): void;
	static C(Other: UObject | any): SubmixEffectConvolutionReverbPreset;
}

declare class SubmixEffectDelaySettings { 
	MaximumDelayLength: number;
	InterpolationTime: number;
	DelayLength: number;
	clone() : SubmixEffectDelaySettings;
	static C(Other: UObject | any): SubmixEffectDelaySettings;
	SetDelayLength(DelayLength?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
	SetInterpolationTime(InterpolationTime?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
	SetMaximumDelayLength(MaximumDelayLength?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
	static SetDelayLength(DelaySettings?: SubmixEffectDelaySettings,DelayLength?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
	static SetInterpolationTime(DelaySettings?: SubmixEffectDelaySettings,InterpolationTime?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
	static SetMaximumDelayLength(DelaySettings?: SubmixEffectDelaySettings,MaximumDelayLength?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
}

declare class SubmixEffectDelayStatics extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): SubmixEffectDelayStatics;
	static Find(Outer: UObject, ResourceName: string): SubmixEffectDelayStatics;
	static GetDefaultObject(): SubmixEffectDelayStatics;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubmixEffectDelayStatics;
	static SetMaximumDelayLength(DelaySettings?: SubmixEffectDelaySettings,MaximumDelayLength?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
	static SetInterpolationTime(DelaySettings?: SubmixEffectDelaySettings,InterpolationTime?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
	static SetDelayLength(DelaySettings?: SubmixEffectDelaySettings,DelayLength?: number): {DelaySettings: SubmixEffectDelaySettings, $: SubmixEffectDelaySettings};
	static C(Other: UObject | any): SubmixEffectDelayStatics;
}

declare class SubmixEffectDelayPreset extends SoundEffectSubmixPreset { 
	Settings: SubmixEffectDelaySettings;
	DynamicSettings: SubmixEffectDelaySettings;
	static Load(ResourceName: string): SubmixEffectDelayPreset;
	static Find(Outer: UObject, ResourceName: string): SubmixEffectDelayPreset;
	static GetDefaultObject(): SubmixEffectDelayPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubmixEffectDelayPreset;
	SetSettings(InSettings: SubmixEffectDelaySettings): void;
	SetInterpolationTime(Time: number): void;
	SetDelay(Length: number): void;
	SetDefaultSettings(InSettings: SubmixEffectDelaySettings): void;
	GetMaxDelayInMilliseconds(): number;
	static C(Other: UObject | any): SubmixEffectDelayPreset;
}

declare type ESubmixFilterType = 'LowPass' | 'HighPass' | 'BandPass' | 'BandStop' | 'Count' | 'ESubmixFilterType_MAX';
declare var ESubmixFilterType : { LowPass:'LowPass',HighPass:'HighPass',BandPass:'BandPass',BandStop:'BandStop',Count:'Count',ESubmixFilterType_MAX:'ESubmixFilterType_MAX', };
declare type ESubmixFilterAlgorithm = 'OnePole' | 'StateVariable' | 'Ladder' | 'Count' | 'ESubmixFilterAlgorithm_MAX';
declare var ESubmixFilterAlgorithm : { OnePole:'OnePole',StateVariable:'StateVariable',Ladder:'Ladder',Count:'Count',ESubmixFilterAlgorithm_MAX:'ESubmixFilterAlgorithm_MAX', };
declare class SubmixEffectFilterSettings { 
	FilterType: ESubmixFilterType;
	FilterAlgorithm: ESubmixFilterAlgorithm;
	FilterFrequency: number;
	FilterQ: number;
	clone() : SubmixEffectFilterSettings;
	static C(Other: UObject | any): SubmixEffectFilterSettings;
}

declare class SubmixEffectFilterPreset extends SoundEffectSubmixPreset { 
	Settings: SubmixEffectFilterSettings;
	static Load(ResourceName: string): SubmixEffectFilterPreset;
	static Find(Outer: UObject, ResourceName: string): SubmixEffectFilterPreset;
	static GetDefaultObject(): SubmixEffectFilterPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubmixEffectFilterPreset;
	SetSettings(InSettings: SubmixEffectFilterSettings): void;
	SetFilterType(InType: ESubmixFilterType): void;
	SetFilterQMod(InQ: number): void;
	SetFilterQ(InQ: number): void;
	SetFilterCutoffFrequencyMod(InFrequency: number): void;
	SetFilterCutoffFrequency(InFrequency: number): void;
	SetFilterAlgorithm(InAlgorithm: ESubmixFilterAlgorithm): void;
	static C(Other: UObject | any): SubmixEffectFilterPreset;
}

declare class SubmixEffectFlexiverbSettings { 
	PreDelay: number;
	DecayTime: number;
	RoomDampening: number;
	Complexity: number;
	clone() : SubmixEffectFlexiverbSettings;
	static C(Other: UObject | any): SubmixEffectFlexiverbSettings;
}

declare class SubmixEffectFlexiverbPreset extends SoundEffectSubmixPreset { 
	Settings: SubmixEffectFlexiverbSettings;
	static Load(ResourceName: string): SubmixEffectFlexiverbPreset;
	static Find(Outer: UObject, ResourceName: string): SubmixEffectFlexiverbPreset;
	static GetDefaultObject(): SubmixEffectFlexiverbPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubmixEffectFlexiverbPreset;
	SetSettings(InSettings: SubmixEffectFlexiverbSettings): void;
	static C(Other: UObject | any): SubmixEffectFlexiverbPreset;
}

declare class DynamicsBandSettings { 
	CrossoverTopFrequency: number;
	AttackTimeMsec: number;
	ReleaseTimeMsec: number;
	ThresholdDb: number;
	Ratio: number;
	KneeBandwidthDb: number;
	InputGainDb: number;
	OutputGainDb: number;
	clone() : DynamicsBandSettings;
	static C(Other: UObject | any): DynamicsBandSettings;
}

declare class SubmixEffectMultibandCompressorSettings { 
	DynamicsProcessorType: ESubmixEffectDynamicsProcessorType;
	PeakMode: ESubmixEffectDynamicsPeakMode;
	LinkMode: ESubmixEffectDynamicsChannelLinkMode;
	LookAheadMsec: number;
	bAnalogMode: boolean;
	bFourPole: boolean;
	bBypass: boolean;
	KeySource: ESubmixEffectDynamicsKeySource;
	ExternalAudioBus: AudioBus;
	ExternalSubmix: SoundSubmix;
	KeyGainDb: number;
	bKeyAudition: boolean;
	Bands: DynamicsBandSettings[];
	clone() : SubmixEffectMultibandCompressorSettings;
	static C(Other: UObject | any): SubmixEffectMultibandCompressorSettings;
}

declare class SubmixEffectMultibandCompressorPreset extends SoundEffectSubmixPreset { 
	Settings: SubmixEffectMultibandCompressorSettings;
	static Load(ResourceName: string): SubmixEffectMultibandCompressorPreset;
	static Find(Outer: UObject, ResourceName: string): SubmixEffectMultibandCompressorPreset;
	static GetDefaultObject(): SubmixEffectMultibandCompressorPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubmixEffectMultibandCompressorPreset;
	SetSettings(InSettings: SubmixEffectMultibandCompressorSettings): void;
	SetExternalSubmix(Submix: SoundSubmix): void;
	SetAudioBus(AudioBus: AudioBus): void;
	ResetKey(): void;
	static C(Other: UObject | any): SubmixEffectMultibandCompressorPreset;
}

declare class SubmixEffectStereoDelaySettings { 
	DelayMode: EStereoDelaySourceEffect;
	DelayTimeMsec: number;
	Feedback: number;
	DelayRatio: number;
	WetLevel: number;
	DryLevel: number;
	bFilterEnabled: boolean;
	FilterType: EStereoDelayFiltertype;
	FilterFrequency: number;
	FilterQ: number;
	clone() : SubmixEffectStereoDelaySettings;
	static C(Other: UObject | any): SubmixEffectStereoDelaySettings;
}

declare class SubmixEffectStereoDelayPreset extends SoundEffectSubmixPreset { 
	Settings: SubmixEffectStereoDelaySettings;
	static Load(ResourceName: string): SubmixEffectStereoDelayPreset;
	static Find(Outer: UObject, ResourceName: string): SubmixEffectStereoDelayPreset;
	static GetDefaultObject(): SubmixEffectStereoDelayPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubmixEffectStereoDelayPreset;
	SetSettings(InSettings: SubmixEffectStereoDelaySettings): void;
	static C(Other: UObject | any): SubmixEffectStereoDelayPreset;
}

declare type ETapLineMode = 'SendToChannel' | 'Panning' | 'Disabled' | 'ETapLineMode_MAX';
declare var ETapLineMode : { SendToChannel:'SendToChannel',Panning:'Panning',Disabled:'Disabled',ETapLineMode_MAX:'ETapLineMode_MAX', };
declare class TapDelayInfo { 
	TapLineMode: ETapLineMode;
	DelayLength: number;
	Gain: number;
	OutputChannel: number;
	PanInDegrees: number;
	TapId: number;
	clone() : TapDelayInfo;
	static C(Other: UObject | any): TapDelayInfo;
}

declare class SubmixEffectTapDelaySettings { 
	MaximumDelayLength: number;
	InterpolationTime: number;
	Taps: TapDelayInfo[];
	clone() : SubmixEffectTapDelaySettings;
	static C(Other: UObject | any): SubmixEffectTapDelaySettings;
}

declare class SubmixEffectTapDelayPreset extends SoundEffectSubmixPreset { 
	Settings: SubmixEffectTapDelaySettings;
	static Load(ResourceName: string): SubmixEffectTapDelayPreset;
	static Find(Outer: UObject, ResourceName: string): SubmixEffectTapDelayPreset;
	static GetDefaultObject(): SubmixEffectTapDelayPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubmixEffectTapDelayPreset;
	SetTap(TapId: number,TapInfo: TapDelayInfo): void;
	SetSettings(InSettings: SubmixEffectTapDelaySettings): void;
	SetInterpolationTime(Time: number): void;
	RemoveTap(TapId: number): void;
	GetTapIds(TapIds?: number[]): {TapIds: number[]};
	GetTap(TapId: number,TapInfo?: TapDelayInfo): {TapInfo: TapDelayInfo};
	GetMaxDelayInMilliseconds(): number;
	AddTap(TapId?: number): {TapId: number};
	static C(Other: UObject | any): SubmixEffectTapDelayPreset;
}

declare type EGranularSynthSeekType = 'FromBeginning' | 'FromCurrentPosition' | 'Count' | 'EGranularSynthSeekType_MAX';
declare var EGranularSynthSeekType : { FromBeginning:'FromBeginning',FromCurrentPosition:'FromCurrentPosition',Count:'Count',EGranularSynthSeekType_MAX:'EGranularSynthSeekType_MAX', };
declare type EGranularSynthEnvelopeType = 'Rectangular' | 'Triangle' | 'DownwardTriangle' | 'UpwardTriangle' | 'ExponentialDecay' | 'ExponentialIncrease' | 'Gaussian' | 'Hanning' | 'Lanczos' | 'Cosine' | 'CosineSquared' | 'Welch' | 'Blackman' | 'BlackmanHarris' | 'Count' | 'EGranularSynthEnvelopeType_MAX';
declare var EGranularSynthEnvelopeType : { Rectangular:'Rectangular',Triangle:'Triangle',DownwardTriangle:'DownwardTriangle',UpwardTriangle:'UpwardTriangle',ExponentialDecay:'ExponentialDecay',ExponentialIncrease:'ExponentialIncrease',Gaussian:'Gaussian',Hanning:'Hanning',Lanczos:'Lanczos',Cosine:'Cosine',CosineSquared:'CosineSquared',Welch:'Welch',Blackman:'Blackman',BlackmanHarris:'BlackmanHarris',Count:'Count',EGranularSynthEnvelopeType_MAX:'EGranularSynthEnvelopeType_MAX', };
declare class GranularSynth extends SynthComponent { 
	GranulatedSoundWave: SoundWave;
	static Load(ResourceName: string): GranularSynth;
	static Find(Outer: UObject, ResourceName: string): GranularSynth;
	static GetDefaultObject(): GranularSynth;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GranularSynth;
	SetSustainGain(SustainGain: number): void;
	SetSoundWave(InSoundWave: SoundWave): void;
	SetScrubMode(bScrubMode: boolean): void;
	SetReleaseTimeMsec(ReleaseTimeMsec: number): void;
	SetPlayheadTime(InPositionSec: number,LerpTimeSec: number,SeekType: EGranularSynthSeekType): void;
	SetPlaybackSpeed(InPlayheadRate: number): void;
	SetGrainVolume(BaseVolume: number,VolumeRange: Vector2D): void;
	SetGrainsPerSecond(InGrainsPerSecond: number): void;
	SetGrainProbability(InGrainProbability: number): void;
	SetGrainPitch(BasePitch: number,PitchRange: Vector2D): void;
	SetGrainPan(BasePan: number,PanRange: Vector2D): void;
	SetGrainEnvelopeType(EnvelopeType: EGranularSynthEnvelopeType): void;
	SetGrainDuration(BaseDurationMsec: number,DurationRange: Vector2D): void;
	SetDecayTime(DecayTimeMsec: number): void;
	SetAttackTime(AttackTimeMsec: number): void;
	NoteOn(Note: number,Velocity: number,Duration: number): void;
	NoteOff(Note: number,bKill: boolean): void;
	IsLoaded(): boolean;
	GetSampleDuration(): number;
	GetCurrentPlayheadTime(): number;
	static C(Other: UObject | any): GranularSynth;
}

declare class MonoWaveTableSynthPreset extends UObject { 
	PresetName: string;
	bLockKeyframesToGridBool: boolean;
	LockKeyframesToGrid: number;
	WaveTableResolution: number;
	WaveTable: RuntimeFloatCurve[];
	bNormalizeWaveTables: boolean;
	static Load(ResourceName: string): MonoWaveTableSynthPreset;
	static Find(Outer: UObject, ResourceName: string): MonoWaveTableSynthPreset;
	static GetDefaultObject(): MonoWaveTableSynthPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MonoWaveTableSynthPreset;
	static C(Other: UObject | any): MonoWaveTableSynthPreset;
}

declare type CurveInterpolationType = 'AUTOINTERP' | 'LINEAR' | 'CONSTANT' | 'CurveInterpolationType_MAX';
declare var CurveInterpolationType : { AUTOINTERP:'AUTOINTERP',LINEAR:'LINEAR',CONSTANT:'CONSTANT',CurveInterpolationType_MAX:'CurveInterpolationType_MAX', };
declare class SynthComponentMonoWaveTable extends SynthComponent { 
	OnTableAltered: UnrealEngineMulticastDelegate<(TableIndex: number) => void>;
	OnNumTablesChanged: UnrealEngineMulticastDelegate<() => void>;
	CurrentPreset: MonoWaveTableSynthPreset;
	static Load(ResourceName: string): SynthComponentMonoWaveTable;
	static Find(Outer: UObject, ResourceName: string): SynthComponentMonoWaveTable;
	static GetDefaultObject(): SynthComponentMonoWaveTable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SynthComponentMonoWaveTable;
	SetWaveTablePosition(InPosition: number): void;
	SetSustainPedalState(InSustainPedalState: boolean): void;
	SetPosLfoType(InLfoType: ESynthLFOType): void;
	SetPosLfoFrequency(InLfoFrequency: number): void;
	SetPosLfoDepth(InLfoDepth: number): void;
	SetPositionEnvelopeSustainGain(InSustainGain: number): void;
	SetPositionEnvelopeReleaseTime(InReleaseTimeMsec: number): void;
	SetPositionEnvelopeInvert(bInInvert: boolean): void;
	SetPositionEnvelopeDepth(InDepth: number): void;
	SetPositionEnvelopeDecayTime(InDecayTimeMsec: number): void;
	SetPositionEnvelopeBiasInvert(bInBiasInvert: boolean): void;
	SetPositionEnvelopeBiasDepth(InDepth: number): void;
	SetPositionEnvelopeAttackTime(InAttackTimeMsec: number): void;
	SetLowPassFilterResonance(InNewQ: number): void;
	SetFrequencyWithMidiNote(InMidiNote: number): void;
	SetFrequencyPitchBend(FrequencyOffsetCents: number): void;
	SetFrequency(FrequencyHz: number): void;
	SetFilterEnvelopeSustainGain(InSustainGain: number): void;
	SetFilterEnvelopeReleaseTime(InReleaseTimeMsec: number): void;
	SetFilterEnvelopenDecayTime(InDecayTimeMsec: number): void;
	SetFilterEnvelopeInvert(bInInvert: boolean): void;
	SetFilterEnvelopeDepth(InDepth: number): void;
	SetFilterEnvelopeBiasInvert(bInBiasInvert: boolean): void;
	SetFilterEnvelopeBiasDepth(InDepth: number): void;
	SetFilterEnvelopeAttackTime(InAttackTimeMsec: number): void;
	SetCurveValue(TableIndex: number,KeyframeIndex: number,NewValue: number): boolean;
	SetCurveTangent(TableIndex: number,InNewTangent: number): boolean;
	SetCurveInterpolationType(InterpolationType: CurveInterpolationType,TableIndex: number): boolean;
	SetAmpEnvelopeSustainGain(InSustainGain: number): void;
	SetAmpEnvelopeReleaseTime(InReleaseTimeMsec: number): void;
	SetAmpEnvelopeInvert(bInInvert: boolean): void;
	SetAmpEnvelopeDepth(InDepth: number): void;
	SetAmpEnvelopeDecayTime(InDecayTimeMsec: number): void;
	SetAmpEnvelopeBiasInvert(bInBiasInvert: boolean): void;
	SetAmpEnvelopeBiasDepth(InDepth: number): void;
	SetAmpEnvelopeAttackTime(InAttackTimeMsec: number): void;
	RefreshWaveTable(Index: number): void;
	RefreshAllWaveTables(): void;
	NoteOn(InMidiNote: number,InVelocity: number): void;
	NoteOff(InMidiNote: number): void;
	GetNumTableEntries(): number;
	GetMaxTableIndex(): number;
	GetKeyFrameValuesForTable(TableIndex: number): number[];
	GetCurveTangent(TableIndex: number): number;
	static C(Other: UObject | any): SynthComponentMonoWaveTable;
}

declare class SynthComponentToneGenerator extends SynthComponent { 
	Frequency: number;
	Volume: number;
	DistanceAttenuationCurve: RuntimeFloatCurve;
	DistanceRange: Vector2D;
	AttenuationDbAtMaxRange: number;
	static Load(ResourceName: string): SynthComponentToneGenerator;
	static Find(Outer: UObject, ResourceName: string): SynthComponentToneGenerator;
	static GetDefaultObject(): SynthComponentToneGenerator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SynthComponentToneGenerator;
	SetVolume(InVolume: number): void;
	SetFrequency(InFrequency: number): void;
	static C(Other: UObject | any): SynthComponentToneGenerator;
}

declare type ESamplePlayerSeekType = 'FromBeginning' | 'FromCurrentPosition' | 'FromEnd' | 'Count' | 'ESamplePlayerSeekType_MAX';
declare var ESamplePlayerSeekType : { FromBeginning:'FromBeginning',FromCurrentPosition:'FromCurrentPosition',FromEnd:'FromEnd',Count:'Count',ESamplePlayerSeekType_MAX:'ESamplePlayerSeekType_MAX', };
declare class SynthSamplePlayer extends SynthComponent { 
	SoundWave: SoundWave;
	OnSampleLoaded: UnrealEngineMulticastDelegate<() => void>;
	OnSamplePlaybackProgress: UnrealEngineMulticastDelegate<(ProgressPercent: number, ProgressTimeSeconds: number) => void>;
	static Load(ResourceName: string): SynthSamplePlayer;
	static Find(Outer: UObject, ResourceName: string): SynthSamplePlayer;
	static GetDefaultObject(): SynthSamplePlayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SynthSamplePlayer;
	SetSoundWave(InSoundWave: SoundWave): void;
	SetScrubTimeWidth(InScrubTimeWidthSec: number): void;
	SetScrubMode(bScrubMode: boolean): void;
	SetPitch(InPitch: number,TimeSec: number): void;
	SeekToTime(TimeSec: number,SeekType: ESamplePlayerSeekType,bWrap: boolean): void;
	IsLoaded(): boolean;
	GetSampleDuration(): number;
	GetCurrentPlaybackProgressTime(): number;
	GetCurrentPlaybackProgressPercent(): number;
	static C(Other: UObject | any): SynthSamplePlayer;
}

declare class SynthesisUtilitiesBlueprintFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): SynthesisUtilitiesBlueprintFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): SynthesisUtilitiesBlueprintFunctionLibrary;
	static GetDefaultObject(): SynthesisUtilitiesBlueprintFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SynthesisUtilitiesBlueprintFunctionLibrary;
	static GetLogFrequency(InLinearValue: number,InDomainMin: number,InDomainMax: number,InRangeMin: number,InRangeMax: number): number;
	static GetLinearFrequency(InLogFrequencyValue: number,InDomainMin: number,InDomainMax: number,InRangeMin: number,InRangeMax: number): number;
	static C(Other: UObject | any): SynthesisUtilitiesBlueprintFunctionLibrary;
}

declare class Synth2DSliderStyle extends SlateWidgetStyle { 
	NormalThumbImage: SlateBrush;
	DisabledThumbImage: SlateBrush;
	NormalBarImage: SlateBrush;
	DisabledBarImage: SlateBrush;
	BackgroundImage: SlateBrush;
	BarThickness: number;
	clone() : Synth2DSliderStyle;
	static C(Other: UObject | any): Synth2DSliderStyle;
}

declare class Synth2DSlider extends Widget { 
	ValueX: number;
	ValueY: number;
	ValueXDelegate: UnrealEngineDelegate<() => number>;
	ValueYDelegate: UnrealEngineDelegate<() => number>;
	WidgetStyle: Synth2DSliderStyle;
	SliderHandleColor: LinearColor;
	IndentHandle: boolean;
	Locked: boolean;
	StepSize: number;
	IsFocusable: boolean;
	OnMouseCaptureBegin: UnrealEngineMulticastDelegate<() => void>;
	OnMouseCaptureEnd: UnrealEngineMulticastDelegate<() => void>;
	OnControllerCaptureBegin: UnrealEngineMulticastDelegate<() => void>;
	OnControllerCaptureEnd: UnrealEngineMulticastDelegate<() => void>;
	OnValueChangedX: UnrealEngineMulticastDelegate<(Value: number) => void>;
	OnValueChangedY: UnrealEngineMulticastDelegate<(Value: number) => void>;
	static Load(ResourceName: string): Synth2DSlider;
	static Find(Outer: UObject, ResourceName: string): Synth2DSlider;
	static GetDefaultObject(): Synth2DSlider;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Synth2DSlider;
	SetValue(InValue: Vector2D): void;
	SetStepSize(InValue: number): void;
	SetSliderHandleColor(InValue: LinearColor): void;
	SetLocked(InValue: boolean): void;
	SetIndentHandle(InValue: boolean): void;
	GetValue(): Vector2D;
	static C(Other: UObject | any): Synth2DSlider;
}

declare type ESynthKnobSize = 'Medium' | 'Large' | 'Count' | 'ESynthKnobSize_MAX';
declare var ESynthKnobSize : { Medium:'Medium',Large:'Large',Count:'Count',ESynthKnobSize_MAX:'ESynthKnobSize_MAX', };
declare class SynthKnobStyle extends SlateWidgetStyle { 
	LargeKnob: SlateBrush;
	LargeKnobOverlay: SlateBrush;
	MediumKnob: SlateBrush;
	MediumKnobOverlay: SlateBrush;
	MinValueAngle: number;
	MaxValueAngle: number;
	KnobSize: ESynthKnobSize;
	clone() : SynthKnobStyle;
	static C(Other: UObject | any): SynthKnobStyle;
}

declare class SynthKnob extends Widget { 
	Value: number;
	StepSize: number;
	MouseSpeed: number;
	MouseFineTuneSpeed: number;
	ShowTooltipInfo: boolean;
	ParameterName: string;
	ParameterUnits: string;
	ValueDelegate: UnrealEngineDelegate<() => number>;
	WidgetStyle: SynthKnobStyle;
	Locked: boolean;
	IsFocusable: boolean;
	OnMouseCaptureBegin: UnrealEngineMulticastDelegate<() => void>;
	OnMouseCaptureEnd: UnrealEngineMulticastDelegate<() => void>;
	OnControllerCaptureBegin: UnrealEngineMulticastDelegate<() => void>;
	OnControllerCaptureEnd: UnrealEngineMulticastDelegate<() => void>;
	OnValueChanged: UnrealEngineMulticastDelegate<(Value: number) => void>;
	static Load(ResourceName: string): SynthKnob;
	static Find(Outer: UObject, ResourceName: string): SynthKnob;
	static GetDefaultObject(): SynthKnob;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SynthKnob;
	SetValue(InValue: number): void;
	SetStepSize(InValue: number): void;
	SetLocked(InValue: boolean): void;
	GetValue(): number;
	static C(Other: UObject | any): SynthKnob;
}

declare class ActorRecordedProperty { 
	PropertyName: string;
	bEnabled: boolean;
	RecorderName: string;
	clone() : ActorRecordedProperty;
	static C(Other: UObject | any): ActorRecordedProperty;
}

declare class ActorRecorderPropertyMap extends UObject { 
	RecordedObject: UObject;
	Properties: ActorRecordedProperty[];
	Children: ActorRecorderPropertyMap[];
	static Load(ResourceName: string): ActorRecorderPropertyMap;
	static Find(Outer: UObject, ResourceName: string): ActorRecorderPropertyMap;
	static GetDefaultObject(): ActorRecorderPropertyMap;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorRecorderPropertyMap;
	static C(Other: UObject | any): ActorRecorderPropertyMap;
}

declare class TakesCoreBlueprintLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): TakesCoreBlueprintLibrary;
	static Find(Outer: UObject, ResourceName: string): TakesCoreBlueprintLibrary;
	static GetDefaultObject(): TakesCoreBlueprintLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakesCoreBlueprintLibrary;
	static FindTakes(Slate: string,TakeNumber: number): AssetData[];
	static ComputeNextTakeNumber(Slate: string): number;
	static C(Other: UObject | any): TakesCoreBlueprintLibrary;
}

declare class MovieSceneTakeSection extends MovieSceneSection { 
	HoursCurve: MovieSceneIntegerChannel;
	MinutesCurve: MovieSceneIntegerChannel;
	SecondsCurve: MovieSceneIntegerChannel;
	FramesCurve: MovieSceneIntegerChannel;
	SubFramesCurve: MovieSceneFloatChannel;
	Slate: MovieSceneStringChannel;
	static Load(ResourceName: string): MovieSceneTakeSection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneTakeSection;
	static GetDefaultObject(): MovieSceneTakeSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneTakeSection;
	static C(Other: UObject | any): MovieSceneTakeSection;
}

declare class MovieSceneTakeSettings extends UObject { 
	HoursName: string;
	MinutesName: string;
	SecondsName: string;
	FramesName: string;
	SubFramesName: string;
	SlateName: string;
	static Load(ResourceName: string): MovieSceneTakeSettings;
	static Find(Outer: UObject, ResourceName: string): MovieSceneTakeSettings;
	static GetDefaultObject(): MovieSceneTakeSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneTakeSettings;
	static C(Other: UObject | any): MovieSceneTakeSettings;
}

declare class MovieSceneTakeTrack extends MovieSceneNameableTrack { 
	Sections: MovieSceneSection[];
	static Load(ResourceName: string): MovieSceneTakeTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneTakeTrack;
	static GetDefaultObject(): MovieSceneTakeTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneTakeTrack;
	static C(Other: UObject | any): MovieSceneTakeTrack;
}

declare class MovieSceneTrackRecorder extends UObject { 
	static Load(ResourceName: string): MovieSceneTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieSceneTrackRecorder;
	static GetDefaultObject(): MovieSceneTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneTrackRecorder;
	static C(Other: UObject | any): MovieSceneTrackRecorder;
}

declare class MovieSceneTrackRecorderSettings extends UObject { 
	static Load(ResourceName: string): MovieSceneTrackRecorderSettings;
	static Find(Outer: UObject, ResourceName: string): MovieSceneTrackRecorderSettings;
	static GetDefaultObject(): MovieSceneTrackRecorderSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneTrackRecorderSettings;
	static C(Other: UObject | any): MovieSceneTrackRecorderSettings;
}

declare class MovieScene3DAttachTrackRecorder extends MovieSceneTrackRecorder { 
	static Load(ResourceName: string): MovieScene3DAttachTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieScene3DAttachTrackRecorder;
	static GetDefaultObject(): MovieScene3DAttachTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieScene3DAttachTrackRecorder;
	static C(Other: UObject | any): MovieScene3DAttachTrackRecorder;
}

declare class MovieScene3DTransformTrackRecorder extends MovieSceneTrackRecorder { 
	static Load(ResourceName: string): MovieScene3DTransformTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieScene3DTransformTrackRecorder;
	static GetDefaultObject(): MovieScene3DTransformTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieScene3DTransformTrackRecorder;
	static C(Other: UObject | any): MovieScene3DTransformTrackRecorder;
}

declare class MovieSceneAnimationTrackRecorder extends MovieSceneTrackRecorder { 
	static Load(ResourceName: string): MovieSceneAnimationTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieSceneAnimationTrackRecorder;
	static GetDefaultObject(): MovieSceneAnimationTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneAnimationTrackRecorder;
	static C(Other: UObject | any): MovieSceneAnimationTrackRecorder;
}

declare type ETimecodeBoneMode = 'All' | 'Root' | 'UserDefined' | 'MAX';
declare var ETimecodeBoneMode : { All:'All',Root:'Root',UserDefined:'UserDefined',MAX:'MAX', };
declare class TimecodeBoneMethod { 
	BoneMode: ETimecodeBoneMode;
	BoneName: string;
	clone() : TimecodeBoneMethod;
	static C(Other: UObject | any): TimecodeBoneMethod;
}

declare class MovieSceneAnimationTrackRecorderEditorSettings extends MovieSceneTrackRecorderSettings { 
	AnimationTrackName: string;
	AnimationAssetName: string;
	AnimationSubDirectory: string;
	InterpMode: ERichCurveInterpMode;
	TangentMode: ERichCurveTangentMode;
	bRemoveRootAnimation: boolean;
	TimecodeBoneMethod: TimecodeBoneMethod;
	static Load(ResourceName: string): MovieSceneAnimationTrackRecorderEditorSettings;
	static Find(Outer: UObject, ResourceName: string): MovieSceneAnimationTrackRecorderEditorSettings;
	static GetDefaultObject(): MovieSceneAnimationTrackRecorderEditorSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneAnimationTrackRecorderEditorSettings;
	static C(Other: UObject | any): MovieSceneAnimationTrackRecorderEditorSettings;
}

declare class MovieSceneAnimationTrackRecorderSettings extends MovieSceneAnimationTrackRecorderEditorSettings { 
	static Load(ResourceName: string): MovieSceneAnimationTrackRecorderSettings;
	static Find(Outer: UObject, ResourceName: string): MovieSceneAnimationTrackRecorderSettings;
	static GetDefaultObject(): MovieSceneAnimationTrackRecorderSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneAnimationTrackRecorderSettings;
	static C(Other: UObject | any): MovieSceneAnimationTrackRecorderSettings;
}

declare class MovieSceneParticleTrackRecorder extends MovieSceneTrackRecorder { 
	static Load(ResourceName: string): MovieSceneParticleTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieSceneParticleTrackRecorder;
	static GetDefaultObject(): MovieSceneParticleTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneParticleTrackRecorder;
	OnTriggered(Component: ParticleSystemComponent,bActivating: boolean): void;
	static C(Other: UObject | any): MovieSceneParticleTrackRecorder;
}

declare class MovieScenePropertyTrackRecorder extends MovieSceneTrackRecorder { 
	static Load(ResourceName: string): MovieScenePropertyTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieScenePropertyTrackRecorder;
	static GetDefaultObject(): MovieScenePropertyTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieScenePropertyTrackRecorder;
	static C(Other: UObject | any): MovieScenePropertyTrackRecorder;
}

declare class MovieSceneSpawnTrackRecorder extends MovieSceneTrackRecorder { 
	static Load(ResourceName: string): MovieSceneSpawnTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieSceneSpawnTrackRecorder;
	static GetDefaultObject(): MovieSceneSpawnTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneSpawnTrackRecorder;
	static C(Other: UObject | any): MovieSceneSpawnTrackRecorder;
}

declare class MovieSceneVisibilityTrackRecorder extends MovieSceneTrackRecorder { 
	static Load(ResourceName: string): MovieSceneVisibilityTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieSceneVisibilityTrackRecorder;
	static GetDefaultObject(): MovieSceneVisibilityTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneVisibilityTrackRecorder;
	static C(Other: UObject | any): MovieSceneVisibilityTrackRecorder;
}

declare type ETakeRecorderPanelMode = 'NewRecording' | 'RecordingInto' | 'EditingPreset' | 'ReviewingRecording' | 'ETakeRecorderPanelMode_MAX';
declare var ETakeRecorderPanelMode : { NewRecording:'NewRecording',RecordingInto:'RecordingInto',EditingPreset:'EditingPreset',ReviewingRecording:'ReviewingRecording',ETakeRecorderPanelMode_MAX:'ETakeRecorderPanelMode_MAX', };
declare class TakeRecorderPanel extends UObject { 
	static Load(ResourceName: string): TakeRecorderPanel;
	static Find(Outer: UObject, ResourceName: string): TakeRecorderPanel;
	static GetDefaultObject(): TakeRecorderPanel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorderPanel;
	StopRecording(): void;
	StartRecording(): void;
	SetupForViewing(LevelSequenceAsset: LevelSequence): void;
	SetupForRecordingInto_LevelSequence(LevelSequenceAsset: LevelSequence): void;
	SetupForRecording_TakePreset(TakePresetAsset: TakePreset): void;
	SetupForRecording_LevelSequence(LevelSequenceAsset: LevelSequence): void;
	SetupForEditing(TakePreset: TakePreset): void;
	SetFrameRateFromTimecode(bInFromTimecode: boolean): void;
	SetFrameRate(InFrameRate: FrameRate): void;
	NewTake(): void;
	GetTakeMetaData(): TakeMetaData;
	GetSources(): TakeRecorderSources;
	GetMode(): ETakeRecorderPanelMode;
	GetLevelSequence(): LevelSequence;
	GetLastRecordedLevelSequence(): LevelSequence;
	GetFrameRate(): FrameRate;
	ClearPendingTake(): void;
	CanStartRecording(OutErrorText?: string): {OutErrorText: string, $: boolean};
	static C(Other: UObject | any): TakeRecorderPanel;
}

declare class TakeRecorderBlueprintLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): TakeRecorderBlueprintLibrary;
	static Find(Outer: UObject, ResourceName: string): TakeRecorderBlueprintLibrary;
	static GetDefaultObject(): TakeRecorderBlueprintLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorderBlueprintLibrary;
	static StopRecording(): void;
	static StartRecording(LevelSequence: LevelSequence,Sources: TakeRecorderSources,MetaData: TakeMetaData,Parameters: TakeRecorderParameters): TakeRecorder;
	static SetDefaultParameters(DefaultParameters: TakeRecorderParameters): void;
	static OpenTakeRecorderPanel(): TakeRecorderPanel;
	static IsTakeRecorderEnabled(): boolean;
	static IsRecording(): boolean;
	static GetTakeRecorderPanel(): TakeRecorderPanel;
	static GetDefaultParameters(): TakeRecorderParameters;
	static GetActiveRecorder(): TakeRecorder;
	static CancelRecording(): void;
	static C(Other: UObject | any): TakeRecorderBlueprintLibrary;
}

declare class TakeRecorderUserSettings extends UObject { 
	Settings: TakeRecorderUserParameters;
	PresetSaveDir: DirectoryPath;
	LastOpenedPreset: TakePreset;
	bIsSequenceOpen: boolean;
	bShowUserSettingsOnUI: boolean;
	static Load(ResourceName: string): TakeRecorderUserSettings;
	static Find(Outer: UObject, ResourceName: string): TakeRecorderUserSettings;
	static GetDefaultObject(): TakeRecorderUserSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorderUserSettings;
	static C(Other: UObject | any): TakeRecorderUserSettings;
}

declare class TakeRecorderProjectSettings extends UObject { 
	Settings: TakeRecorderProjectParameters;
	static Load(ResourceName: string): TakeRecorderProjectSettings;
	static Find(Outer: UObject, ResourceName: string): TakeRecorderProjectSettings;
	static GetDefaultObject(): TakeRecorderProjectSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorderProjectSettings;
	static C(Other: UObject | any): TakeRecorderProjectSettings;
}

declare class ActorFactoryCacheManager extends ActorFactory { 
	static Load(ResourceName: string): ActorFactoryCacheManager;
	static Find(Outer: UObject, ResourceName: string): ActorFactoryCacheManager;
	static GetDefaultObject(): ActorFactoryCacheManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorFactoryCacheManager;
	static C(Other: UObject | any): ActorFactoryCacheManager;
}

declare class CacheCollectionFactory extends Factory { 
	static Load(ResourceName: string): CacheCollectionFactory;
	static Find(Outer: UObject, ResourceName: string): CacheCollectionFactory;
	static GetDefaultObject(): CacheCollectionFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CacheCollectionFactory;
	static C(Other: UObject | any): CacheCollectionFactory;
}

declare class MovieSceneChaosCacheTrackRecorder extends MovieSceneTrackRecorder { 
	static Load(ResourceName: string): MovieSceneChaosCacheTrackRecorder;
	static Find(Outer: UObject, ResourceName: string): MovieSceneChaosCacheTrackRecorder;
	static GetDefaultObject(): MovieSceneChaosCacheTrackRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneChaosCacheTrackRecorder;
	static C(Other: UObject | any): MovieSceneChaosCacheTrackRecorder;
}

declare class TakeRecorderChaosCacheSource extends TakeRecorderSource { 
	ChaosCacheManager: ChaosCacheManager;
	TrackRecorder: MovieSceneChaosCacheTrackRecorder;
	static Load(ResourceName: string): TakeRecorderChaosCacheSource;
	static Find(Outer: UObject, ResourceName: string): TakeRecorderChaosCacheSource;
	static GetDefaultObject(): TakeRecorderChaosCacheSource;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorderChaosCacheSource;
	static C(Other: UObject | any): TakeRecorderChaosCacheSource;
}

declare class InternationalizationExportSettings extends UObject { 
	CulturesToGenerate: string[];
	CommandletClass: string;
	SourcePath: string;
	DestinationPath: string;
	PortableObjectName: string;
	ManifestName: string;
	ArchiveName: string;
	bExportLoc: boolean;
	bImportLoc: boolean;
	bUseCultureDirectory: boolean;
	static Load(ResourceName: string): InternationalizationExportSettings;
	static Find(Outer: UObject, ResourceName: string): InternationalizationExportSettings;
	static GetDefaultObject(): InternationalizationExportSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InternationalizationExportSettings;
	static C(Other: UObject | any): InternationalizationExportSettings;
}

declare class TranslationPickerSettings extends UObject { 
	bSubmitTranslationPickerChangesToLocalizationService: boolean;
	static Load(ResourceName: string): TranslationPickerSettings;
	static Find(Outer: UObject, ResourceName: string): TranslationPickerSettings;
	static GetDefaultObject(): TranslationPickerSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TranslationPickerSettings;
	static C(Other: UObject | any): TranslationPickerSettings;
}

declare class TranslationChange { 
	Version: string;
	DateAndTime: DateTime;
	Source: string;
	Translation: string;
	clone() : TranslationChange;
	static C(Other: UObject | any): TranslationChange;
}

declare class TranslationContextInfo { 
	Key: string;
	Context: string;
	Changes: TranslationChange[];
	clone() : TranslationContextInfo;
	static C(Other: UObject | any): TranslationContextInfo;
}

declare class TranslationUnit extends UObject { 
	Namespace: string;
	Key: string;
	Source: string;
	Translation: string;
	Contexts: TranslationContextInfo[];
	HasBeenReviewed: boolean;
	TranslationBeforeImport: string;
	LocresPath: string;
	static Load(ResourceName: string): TranslationUnit;
	static Find(Outer: UObject, ResourceName: string): TranslationUnit;
	static GetDefaultObject(): TranslationUnit;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TranslationUnit;
	static C(Other: UObject | any): TranslationUnit;
}

declare class UndoHistorySettings extends UObject { 
	bShowTransactionDetails: boolean;
	static Load(ResourceName: string): UndoHistorySettings;
	static Find(Outer: UObject, ResourceName: string): UndoHistorySettings;
	static GetDefaultObject(): UndoHistorySettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UndoHistorySettings;
	static C(Other: UObject | any): UndoHistorySettings;
}

declare class LevelAssetEditor extends AssetEditor { 
	static Load(ResourceName: string): LevelAssetEditor;
	static Find(Outer: UObject, ResourceName: string): LevelAssetEditor;
	static GetDefaultObject(): LevelAssetEditor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelAssetEditor;
	static C(Other: UObject | any): LevelAssetEditor;
}

declare class PixelInspectorView extends UObject { 
	FinalColor: LinearColor;
	SceneColor: LinearColor;
	PreExposure: number;
	Luminance: number;
	HdrColor: LinearColor;
	Normal: Vector;
	PerObjectGBufferData: number;
	Metallic: number;
	Specular: number;
	Roughness: number;
	MaterialShadingModel: EMaterialShadingModel;
	SelectiveOutputMask: number;
	BaseColor: LinearColor;
	IndirectIrradiance: number;
	AmbientOcclusion: number;
	SubsurfaceColor: LinearColor;
	SubsurfaceProfile: Vector;
	Opacity: number;
	ClearCoat: number;
	ClearCoatRoughness: number;
	WorldNormal: Vector;
	Backlit: number;
	Cloth: number;
	EyeTangent: Vector;
	IrisMask: number;
	IrisDistance: number;
	static Load(ResourceName: string): PixelInspectorView;
	static Find(Outer: UObject, ResourceName: string): PixelInspectorView;
	static GetDefaultObject(): PixelInspectorView;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PixelInspectorView;
	static C(Other: UObject | any): PixelInspectorView;
}

declare class ContentBrowserFileDataSource extends ContentBrowserDataSource { 
	static Load(ResourceName: string): ContentBrowserFileDataSource;
	static Find(Outer: UObject, ResourceName: string): ContentBrowserFileDataSource;
	static GetDefaultObject(): ContentBrowserFileDataSource;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ContentBrowserFileDataSource;
	static C(Other: UObject | any): ContentBrowserFileDataSource;
}

declare class PyTestInterface extends Interface { 
	static Load(ResourceName: string): PyTestInterface;
	static Find(Outer: UObject, ResourceName: string): PyTestInterface;
	static GetDefaultObject(): PyTestInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestInterface;
	FuncInterface(InValue: number): number;
	static C(Other: UObject | any): PyTestInterface;
}

declare class PyTestChildInterface extends PyTestInterface { 
	static Load(ResourceName: string): PyTestChildInterface;
	static Find(Outer: UObject, ResourceName: string): PyTestChildInterface;
	static GetDefaultObject(): PyTestChildInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestChildInterface;
	FuncInterfaceChild(InValue: number): number;
	static C(Other: UObject | any): PyTestChildInterface;
}

declare class PyTestOtherInterface extends Interface { 
	static Load(ResourceName: string): PyTestOtherInterface;
	static Find(Outer: UObject, ResourceName: string): PyTestOtherInterface;
	static GetDefaultObject(): PyTestOtherInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestOtherInterface;
	FuncInterfaceOther(InValue: number): number;
	static C(Other: UObject | any): PyTestOtherInterface;
}

declare class K2Node_ExecutePythonScript extends K2Node_CallFunction { 
	Inputs: string[];
	Outputs: string[];
	static Load(ResourceName: string): K2Node_ExecutePythonScript;
	static Find(Outer: UObject, ResourceName: string): K2Node_ExecutePythonScript;
	static GetDefaultObject(): K2Node_ExecutePythonScript;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node_ExecutePythonScript;
	static C(Other: UObject | any): K2Node_ExecutePythonScript;
}

declare type EPyTestEnum = 'One' | 'Two' | 'EPyTestEnum_MAX';
declare var EPyTestEnum : { One:'One',Two:'Two',EPyTestEnum_MAX:'EPyTestEnum_MAX', };
declare class PyTestStruct { 
	bool: boolean;
	int: number;
	float: number;
	Enum: EPyTestEnum;
	string: string;
	Name: string;
	Text: string;
	fieldpath: any;
	StructFieldPath: any;
	StringArray: string[];
	StringSet: Set<string>;
	StringIntMap: Map<string, number>;
	LegacyInt: number;
	BoolInstanceOnly: boolean;
	BoolDefaultsOnly: boolean;
	clone() : PyTestStruct;
	static C(Other: UObject | any): PyTestStruct;
	AddFloat(InValue: number): PyTestStruct;
	AddInt(InValue: number): PyTestStruct;
	AddStr(InValue: string): PyTestStruct;
	IsBoolSet(): boolean;
	LegacyIsBoolSet(): boolean;
	static AddFloat(InStruct: PyTestStruct,InValue: number): PyTestStruct;
	static AddInt(InStruct: PyTestStruct,InValue: number): PyTestStruct;
	static AddStr(InStruct: PyTestStruct,InValue: string): PyTestStruct;
	static IsBoolSet(InStruct: PyTestStruct): boolean;
	static LegacyIsBoolSet(InStruct: PyTestStruct): boolean;
}

declare class PyTestStructLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): PyTestStructLibrary;
	static Find(Outer: UObject, ResourceName: string): PyTestStructLibrary;
	static GetDefaultObject(): PyTestStructLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestStructLibrary;
	static LegacyIsBoolSet(InStruct: PyTestStruct): boolean;
	static IsBoolSet(InStruct: PyTestStruct): boolean;
	static GetConstantValue(): number;
	static AddStr(InStruct: PyTestStruct,InValue: string): PyTestStruct;
	static AddInt(InStruct: PyTestStruct,InValue: number): PyTestStruct;
	static AddFloat(InStruct: PyTestStruct,InValue: number): PyTestStruct;
	static C(Other: UObject | any): PyTestStructLibrary;
}

declare class PyTestChildStruct extends PyTestStruct { 
	clone() : PyTestChildStruct;
	static C(Other: UObject | any): PyTestChildStruct;
}

declare class PyTestObject extends UObject { 
	bool: boolean;
	int: number;
	float: number;
	Enum: EPyTestEnum;
	string: string;
	Name: string;
	Text: string;
	fieldpath: any;
	StructFieldPath: any;
	StringArray: string[];
	StringSet: Set<string>;
	StringIntMap: Map<string, number>;
	delegate: UnrealEngineDelegate<(InValue: number) => number>;
	MulticastDelegate: UnrealEngineMulticastDelegate<(InStr: string) => void>;
	struct: PyTestStruct;
	StructArray: PyTestStruct[];
	ChildStruct: PyTestChildStruct;
	BoolInstanceOnly: boolean;
	BoolDefaultsOnly: boolean;
	static Load(ResourceName: string): PyTestObject;
	static Find(Outer: UObject, ResourceName: string): PyTestObject;
	static GetDefaultObject(): PyTestObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestObject;
	static ReturnSet(): Set<number>;
	static ReturnMap(): Map<number, boolean>;
	static ReturnFieldPath(): any;
	static ReturnArray(): number[];
	MulticastDelegatePropertyCallback(InStr: string): void;
	LegacyFuncTakingPyTestStruct(InStruct: PyTestStruct): void;
	static GetConstantValue(): number;
	FuncTakingPyTestStructDefault(InStruct: PyTestStruct): void;
	FuncTakingPyTestStruct(InStruct: PyTestStruct): void;
	FuncTakingPyTestChildStruct(InStruct: PyTestChildStruct): void;
	FuncTakingFieldPath(InFieldPath: any): void;
	FuncBlueprintNativeRef(InOutStruct?: PyTestStruct): {InOutStruct: PyTestStruct};
	FuncBlueprintNative(InValue: number): number;
	FuncBlueprintImplementable(InValue: number): number;
	static EmitScriptWarning(): void;
	static EmitScriptError(): void;
	DelegatePropertyCallback(InValue: number): number;
	CallFuncBlueprintNativeRef(InOutStruct?: PyTestStruct): {InOutStruct: PyTestStruct};
	CallFuncBlueprintNative(InValue: number): number;
	CallFuncBlueprintImplementable(InValue: number): number;
	static C(Other: UObject | any): PyTestObject;
	IsBoolSet(): boolean;
	static IsBoolSet(InObj: PyTestObject): boolean;
}

declare class PyTestChildObject extends PyTestObject { 
	static Load(ResourceName: string): PyTestChildObject;
	static Find(Outer: UObject, ResourceName: string): PyTestChildObject;
	static GetDefaultObject(): PyTestChildObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestChildObject;
	static C(Other: UObject | any): PyTestChildObject;
}

declare class LegacyPyTestObject extends PyTestObject { 
	static Load(ResourceName: string): LegacyPyTestObject;
	static Find(Outer: UObject, ResourceName: string): LegacyPyTestObject;
	static GetDefaultObject(): LegacyPyTestObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LegacyPyTestObject;
	static C(Other: UObject | any): LegacyPyTestObject;
}

declare class PyTestObjectLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): PyTestObjectLibrary;
	static Find(Outer: UObject, ResourceName: string): PyTestObjectLibrary;
	static GetDefaultObject(): PyTestObjectLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestObjectLibrary;
	static IsBoolSet(InObj: PyTestObject): boolean;
	static GetOtherConstantValue(): number;
	static C(Other: UObject | any): PyTestObjectLibrary;
}

declare class PyTestStructDelegate extends UObject { 
	OnNameCollisionTestDelegate: UnrealEngineMulticastDelegate<(PyStruct: PyTestStruct) => void>;
	static Load(ResourceName: string): PyTestStructDelegate;
	static Find(Outer: UObject, ResourceName: string): PyTestStructDelegate;
	static GetDefaultObject(): PyTestStructDelegate;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestStructDelegate;
	static C(Other: UObject | any): PyTestStructDelegate;
}

declare class PyTestVectorDelegate extends UObject { 
	OnNameCollisionTestDelegate: UnrealEngineMulticastDelegate<(Vec: Vector2D) => void>;
	static Load(ResourceName: string): PyTestVectorDelegate;
	static Find(Outer: UObject, ResourceName: string): PyTestVectorDelegate;
	static GetDefaultObject(): PyTestVectorDelegate;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestVectorDelegate;
	static C(Other: UObject | any): PyTestVectorDelegate;
}

declare class PyTestTypeHint extends UObject { 
	BoolProp: boolean;
	IntProp: number;
	FloatProp: number;
	EnumProp: EPyTestEnum;
	StringProp: string;
	NameProp: string;
	TextProp: string;
	FieldPathProp: any;
	StructProp: PyTestStruct;
	ObjectProp: PyTestObject;
	StrArrayProp: string[];
	NameArrayProp: string[];
	TextArrayProp: string[];
	ObjectArrayProp: UObject[];
	SetProp: Set<string>;
	MapProp: Map<number, string>;
	DelegateProp: UnrealEngineDelegate<(InValue: number) => number>;
	MulticastDelegateProp: UnrealEngineMulticastDelegate<(InStr: string) => void>;
	SlateTickDelegate: UnrealEngineDelegate<(InDeltaTime: number) => void>;
	static Load(ResourceName: string): PyTestTypeHint;
	static Find(Outer: UObject, ResourceName: string): PyTestTypeHint;
	static GetDefaultObject(): PyTestTypeHint;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestTypeHint;
	static GetStringConst(): string;
	static GetIntConst(): number;
	static CheckTupleReturnType(InOutString?: string): {InOutString: string, $: number};
	CheckTextTypeHints(Param1: string,Param2: string): string;
	CheckStructTypeHints(Param1: PyTestStruct,Param2: PyTestStruct): PyTestStruct;
	CheckStringTypeHints(Param1: string,Param2: string): string;
	static CheckStaticFunction(Param1: boolean,Param2: number,Param3: number,Param4: string): boolean;
	CheckSetTypeHints(Param1: Set<string>,Param2: Set<string>,Param3: Set<UObject>): Set<string>;
	CheckObjectTypeHints(Param1: PyTestObject,Param4: PyTestObject): PyTestObject;
	CheckNameTypeHints(Param1: string,Param2: string): string;
	CheckMapTypeHints(Param1: Map<number, string>,Param2: Map<number, string>,Param3: Map<number, string>,Param4: Map<number, UObject>): Map<string, UObject>;
	CheckIntegerTypeHints(Param1: number,Param2: number,Param3: number): number;
	CheckFloatTypeHints(Param1: number,Param2: number,Param3: number,Param4: number): number;
	CheckFieldPathTypeHints(Param1: any): any;
	CheckEnumTypeHints(Param1: EPyTestEnum,Param2: EPyTestEnum): EPyTestEnum;
	CheckBoolTypeHints(bParam1: boolean,bParam2: boolean,bParam3: boolean): boolean;
	CheckArrayTypeHints(Param1: string[],Param2: string[],Param3: string[],Param4: UObject[]): string[];
	static C(Other: UObject | any): PyTestTypeHint;
}

declare class PythonOnlineDocsCommandlet extends Commandlet { 
	static Load(ResourceName: string): PythonOnlineDocsCommandlet;
	static Find(Outer: UObject, ResourceName: string): PythonOnlineDocsCommandlet;
	static GetDefaultObject(): PythonOnlineDocsCommandlet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonOnlineDocsCommandlet;
	static C(Other: UObject | any): PythonOnlineDocsCommandlet;
}

declare class PythonScriptCommandlet extends Commandlet { 
	static Load(ResourceName: string): PythonScriptCommandlet;
	static Find(Outer: UObject, ResourceName: string): PythonScriptCommandlet;
	static GetDefaultObject(): PythonScriptCommandlet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonScriptCommandlet;
	static C(Other: UObject | any): PythonScriptCommandlet;
}

declare type EPythonLogOutputType = 'Info' | 'Warning' | 'Error' | 'EPythonLogOutputType_MAX';
declare var EPythonLogOutputType : { Info:'Info',Warning:'Warning',Error:'Error',EPythonLogOutputType_MAX:'EPythonLogOutputType_MAX', };
declare class PythonLogOutputEntry { 
	Type: EPythonLogOutputType;
	Output: string;
	clone() : PythonLogOutputEntry;
	static C(Other: UObject | any): PythonLogOutputEntry;
}

declare type EPythonCommandExecutionMode = 'ExecuteFile' | 'ExecuteStatement' | 'EvaluateStatement' | 'EPythonCommandExecutionMode_MAX';
declare var EPythonCommandExecutionMode : { ExecuteFile:'ExecuteFile',ExecuteStatement:'ExecuteStatement',EvaluateStatement:'EvaluateStatement',EPythonCommandExecutionMode_MAX:'EPythonCommandExecutionMode_MAX', };
declare type EPythonFileExecutionScope = 'Private' | 'Public' | 'EPythonFileExecutionScope_MAX';
declare var EPythonFileExecutionScope : { Private:'Private',Public:'Public',EPythonFileExecutionScope_MAX:'EPythonFileExecutionScope_MAX', };
declare class PythonScriptLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): PythonScriptLibrary;
	static Find(Outer: UObject, ResourceName: string): PythonScriptLibrary;
	static GetDefaultObject(): PythonScriptLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonScriptLibrary;
	static IsPythonAvailable(): boolean;
	static ExecutePythonScript(PythonScript: string,PythonInputs: string[],PythonOutputs: string[]): boolean;
	static ExecutePythonCommandEx(PythonCommand: string,CommandResult?: string,LogOutput?: PythonLogOutputEntry[],ExecutionMode?: EPythonCommandExecutionMode,FileExecutionScope?: EPythonFileExecutionScope): {CommandResult: string, LogOutput: PythonLogOutputEntry[], $: boolean};
	static ExecutePythonCommand(PythonCommand: string): boolean;
	static C(Other: UObject | any): PythonScriptLibrary;
}

declare class PythonScriptPluginSettings extends DeveloperSettings { 
	StartupScripts: string[];
	AdditionalPaths: DirectoryPath[];
	bIsolateInterpreterEnvironment: boolean;
	bDeveloperMode: boolean;
	bRemoteExecution: boolean;
	RemoteExecutionMulticastGroupEndpoint: string;
	RemoteExecutionMulticastBindAddress: string;
	RemoteExecutionSendBufferSizeBytes: number;
	RemoteExecutionReceiveBufferSizeBytes: number;
	RemoteExecutionMulticastTtl: number;
	static Load(ResourceName: string): PythonScriptPluginSettings;
	static Find(Outer: UObject, ResourceName: string): PythonScriptPluginSettings;
	static GetDefaultObject(): PythonScriptPluginSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonScriptPluginSettings;
	static C(Other: UObject | any): PythonScriptPluginSettings;
}

declare type ETypeHintingMode = 'Off' | 'AutoCompletion' | 'TypeChecker' | 'ETypeHintingMode_MAX';
declare var ETypeHintingMode : { Off:'Off',AutoCompletion:'AutoCompletion',TypeChecker:'TypeChecker',ETypeHintingMode_MAX:'ETypeHintingMode_MAX', };
declare class PythonScriptPluginUserSettings extends DeveloperSettings { 
	bDeveloperMode: boolean;
	TypeHintingMode: ETypeHintingMode;
	bEnableContentBrowserIntegration: boolean;
	static Load(ResourceName: string): PythonScriptPluginUserSettings;
	static Find(Outer: UObject, ResourceName: string): PythonScriptPluginUserSettings;
	static GetDefaultObject(): PythonScriptPluginUserSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonScriptPluginUserSettings;
	static C(Other: UObject | any): PythonScriptPluginUserSettings;
}

declare class PythonResourceOwner extends Interface { 
	static Load(ResourceName: string): PythonResourceOwner;
	static Find(Outer: UObject, ResourceName: string): PythonResourceOwner;
	static GetDefaultObject(): PythonResourceOwner;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonResourceOwner;
	static C(Other: UObject | any): PythonResourceOwner;
}

declare class PythonCallableForDelegate extends UObject { 
	static Load(ResourceName: string): PythonCallableForDelegate;
	static Find(Outer: UObject, ResourceName: string): PythonCallableForDelegate;
	static GetDefaultObject(): PythonCallableForDelegate;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonCallableForDelegate;
	static C(Other: UObject | any): PythonCallableForDelegate;
}

declare class PythonGeneratedEnum extends Enum { 
	static Load(ResourceName: string): PythonGeneratedEnum;
	static Find(Outer: UObject, ResourceName: string): PythonGeneratedEnum;
	static GetDefaultObject(): PythonGeneratedEnum;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonGeneratedEnum;
	static C(Other: UObject | any): PythonGeneratedEnum;
}

declare class PythonGeneratedClass extends Class { 
	static Load(ResourceName: string): PythonGeneratedClass;
	static Find(Outer: UObject, ResourceName: string): PythonGeneratedClass;
	static GetDefaultObject(): PythonGeneratedClass;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonGeneratedClass;
	static C(Other: UObject | any): PythonGeneratedClass;
}

declare class PythonGeneratedStruct extends ScriptStruct { 
	static Load(ResourceName: string): PythonGeneratedStruct;
	static Find(Outer: UObject, ResourceName: string): PythonGeneratedStruct;
	static GetDefaultObject(): PythonGeneratedStruct;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PythonGeneratedStruct;
	static C(Other: UObject | any): PythonGeneratedStruct;
}

declare class TypedElementSelectionSet_OnChangeDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TypedElementSelectionSet_OnChangeDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TypedElementSelectionSet_OnChangeDynamic__PythonCallable;
	static GetDefaultObject(): TypedElementSelectionSet_OnChangeDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TypedElementSelectionSet_OnChangeDynamic__PythonCallable;
	static C(Other: UObject | any): TypedElementSelectionSet_OnChangeDynamic__PythonCallable;
}

declare class TypedElementSelectionSet_OnPreChangeDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TypedElementSelectionSet_OnPreChangeDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TypedElementSelectionSet_OnPreChangeDynamic__PythonCallable;
	static GetDefaultObject(): TypedElementSelectionSet_OnPreChangeDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TypedElementSelectionSet_OnPreChangeDynamic__PythonCallable;
	static C(Other: UObject | any): TypedElementSelectionSet_OnPreChangeDynamic__PythonCallable;
}

declare class ToolMenuDynamicCanExecuteAction__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ToolMenuDynamicCanExecuteAction__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ToolMenuDynamicCanExecuteAction__PythonCallable;
	static GetDefaultObject(): ToolMenuDynamicCanExecuteAction__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ToolMenuDynamicCanExecuteAction__PythonCallable;
	static C(Other: UObject | any): ToolMenuDynamicCanExecuteAction__PythonCallable;
}

declare class ToolMenuDynamicExecuteAction__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ToolMenuDynamicExecuteAction__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ToolMenuDynamicExecuteAction__PythonCallable;
	static GetDefaultObject(): ToolMenuDynamicExecuteAction__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ToolMenuDynamicExecuteAction__PythonCallable;
	static C(Other: UObject | any): ToolMenuDynamicExecuteAction__PythonCallable;
}

declare class ToolMenuDynamicGetActionCheckState__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ToolMenuDynamicGetActionCheckState__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ToolMenuDynamicGetActionCheckState__PythonCallable;
	static GetDefaultObject(): ToolMenuDynamicGetActionCheckState__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ToolMenuDynamicGetActionCheckState__PythonCallable;
	static C(Other: UObject | any): ToolMenuDynamicGetActionCheckState__PythonCallable;
}

declare class ToolMenuDynamicIsActionButtonVisible__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ToolMenuDynamicIsActionButtonVisible__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ToolMenuDynamicIsActionButtonVisible__PythonCallable;
	static GetDefaultObject(): ToolMenuDynamicIsActionButtonVisible__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ToolMenuDynamicIsActionButtonVisible__PythonCallable;
	static C(Other: UObject | any): ToolMenuDynamicIsActionButtonVisible__PythonCallable;
}

declare class ToolMenuDynamicIsActionChecked__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ToolMenuDynamicIsActionChecked__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ToolMenuDynamicIsActionChecked__PythonCallable;
	static GetDefaultObject(): ToolMenuDynamicIsActionChecked__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ToolMenuDynamicIsActionChecked__PythonCallable;
	static C(Other: UObject | any): ToolMenuDynamicIsActionChecked__PythonCallable;
}

declare class AnimDataModelModifiedDynamicEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): AnimDataModelModifiedDynamicEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): AnimDataModelModifiedDynamicEvent__PythonCallable;
	static GetDefaultObject(): AnimDataModelModifiedDynamicEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimDataModelModifiedDynamicEvent__PythonCallable;
	static C(Other: UObject | any): AnimDataModelModifiedDynamicEvent__PythonCallable;
}

declare class CharacterMovementUpdatedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): CharacterMovementUpdatedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): CharacterMovementUpdatedSignature__PythonCallable;
	static GetDefaultObject(): CharacterMovementUpdatedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CharacterMovementUpdatedSignature__PythonCallable;
	static C(Other: UObject | any): CharacterMovementUpdatedSignature__PythonCallable;
}

declare class CharacterReachedApexSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): CharacterReachedApexSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): CharacterReachedApexSignature__PythonCallable;
	static GetDefaultObject(): CharacterReachedApexSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CharacterReachedApexSignature__PythonCallable;
	static C(Other: UObject | any): CharacterReachedApexSignature__PythonCallable;
}

declare class ConstraintBrokenSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ConstraintBrokenSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ConstraintBrokenSignature__PythonCallable;
	static GetDefaultObject(): ConstraintBrokenSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ConstraintBrokenSignature__PythonCallable;
	static C(Other: UObject | any): ConstraintBrokenSignature__PythonCallable;
}

declare class EmptyOnlineDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EmptyOnlineDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EmptyOnlineDelegate__PythonCallable;
	static GetDefaultObject(): EmptyOnlineDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EmptyOnlineDelegate__PythonCallable;
	static C(Other: UObject | any): EmptyOnlineDelegate__PythonCallable;
}

declare class InputActionHandlerDynamicSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InputActionHandlerDynamicSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InputActionHandlerDynamicSignature__PythonCallable;
	static GetDefaultObject(): InputActionHandlerDynamicSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputActionHandlerDynamicSignature__PythonCallable;
	static C(Other: UObject | any): InputActionHandlerDynamicSignature__PythonCallable;
}

declare class InputAxisHandlerDynamicSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InputAxisHandlerDynamicSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InputAxisHandlerDynamicSignature__PythonCallable;
	static GetDefaultObject(): InputAxisHandlerDynamicSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputAxisHandlerDynamicSignature__PythonCallable;
	static C(Other: UObject | any): InputAxisHandlerDynamicSignature__PythonCallable;
}

declare class InputGestureHandlerDynamicSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InputGestureHandlerDynamicSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InputGestureHandlerDynamicSignature__PythonCallable;
	static GetDefaultObject(): InputGestureHandlerDynamicSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputGestureHandlerDynamicSignature__PythonCallable;
	static C(Other: UObject | any): InputGestureHandlerDynamicSignature__PythonCallable;
}

declare class InputTouchHandlerDynamicSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InputTouchHandlerDynamicSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InputTouchHandlerDynamicSignature__PythonCallable;
	static GetDefaultObject(): InputTouchHandlerDynamicSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputTouchHandlerDynamicSignature__PythonCallable;
	static C(Other: UObject | any): InputTouchHandlerDynamicSignature__PythonCallable;
}

declare class InputVectorAxisHandlerDynamicSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InputVectorAxisHandlerDynamicSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InputVectorAxisHandlerDynamicSignature__PythonCallable;
	static GetDefaultObject(): InputVectorAxisHandlerDynamicSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputVectorAxisHandlerDynamicSignature__PythonCallable;
	static C(Other: UObject | any): InputVectorAxisHandlerDynamicSignature__PythonCallable;
}

declare class InstigatedAnyDamageSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InstigatedAnyDamageSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InstigatedAnyDamageSignature__PythonCallable;
	static GetDefaultObject(): InstigatedAnyDamageSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InstigatedAnyDamageSignature__PythonCallable;
	static C(Other: UObject | any): InstigatedAnyDamageSignature__PythonCallable;
}

declare class LandedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): LandedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): LandedSignature__PythonCallable;
	static GetDefaultObject(): LandedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LandedSignature__PythonCallable;
	static C(Other: UObject | any): LandedSignature__PythonCallable;
}

declare class LevelStreamingLoadedStatus__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): LevelStreamingLoadedStatus__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): LevelStreamingLoadedStatus__PythonCallable;
	static GetDefaultObject(): LevelStreamingLoadedStatus__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelStreamingLoadedStatus__PythonCallable;
	static C(Other: UObject | any): LevelStreamingLoadedStatus__PythonCallable;
}

declare class LevelStreamingVisibilityStatus__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): LevelStreamingVisibilityStatus__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): LevelStreamingVisibilityStatus__PythonCallable;
	static GetDefaultObject(): LevelStreamingVisibilityStatus__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelStreamingVisibilityStatus__PythonCallable;
	static C(Other: UObject | any): LevelStreamingVisibilityStatus__PythonCallable;
}

declare class MovementModeChangedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MovementModeChangedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MovementModeChangedSignature__PythonCallable;
	static GetDefaultObject(): MovementModeChangedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovementModeChangedSignature__PythonCallable;
	static C(Other: UObject | any): MovementModeChangedSignature__PythonCallable;
}

declare class OnActorReady__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnActorReady__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnActorReady__PythonCallable;
	static GetDefaultObject(): OnActorReady__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnActorReady__PythonCallable;
	static C(Other: UObject | any): OnActorReady__PythonCallable;
}

declare class OnAllMontageInstancesEndedMCDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAllMontageInstancesEndedMCDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAllMontageInstancesEndedMCDelegate__PythonCallable;
	static GetDefaultObject(): OnAllMontageInstancesEndedMCDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAllMontageInstancesEndedMCDelegate__PythonCallable;
	static C(Other: UObject | any): OnAllMontageInstancesEndedMCDelegate__PythonCallable;
}

declare class OnAnimInitialized__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAnimInitialized__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAnimInitialized__PythonCallable;
	static GetDefaultObject(): OnAnimInitialized__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAnimInitialized__PythonCallable;
	static C(Other: UObject | any): OnAnimInitialized__PythonCallable;
}

declare class OnAsyncHandleSaveGame__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAsyncHandleSaveGame__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAsyncHandleSaveGame__PythonCallable;
	static GetDefaultObject(): OnAsyncHandleSaveGame__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAsyncHandleSaveGame__PythonCallable;
	static C(Other: UObject | any): OnAsyncHandleSaveGame__PythonCallable;
}

declare class OnAudioFadeChangeSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioFadeChangeSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioFadeChangeSignature__PythonCallable;
	static GetDefaultObject(): OnAudioFadeChangeSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioFadeChangeSignature__PythonCallable;
	static C(Other: UObject | any): OnAudioFadeChangeSignature__PythonCallable;
}

declare class OnAudioFinished__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioFinished__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioFinished__PythonCallable;
	static GetDefaultObject(): OnAudioFinished__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioFinished__PythonCallable;
	static C(Other: UObject | any): OnAudioFinished__PythonCallable;
}

declare class OnAudioMultiEnvelopeValue__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioMultiEnvelopeValue__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioMultiEnvelopeValue__PythonCallable;
	static GetDefaultObject(): OnAudioMultiEnvelopeValue__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioMultiEnvelopeValue__PythonCallable;
	static C(Other: UObject | any): OnAudioMultiEnvelopeValue__PythonCallable;
}

declare class OnAudioPlaybackPercent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioPlaybackPercent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioPlaybackPercent__PythonCallable;
	static GetDefaultObject(): OnAudioPlaybackPercent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioPlaybackPercent__PythonCallable;
	static C(Other: UObject | any): OnAudioPlaybackPercent__PythonCallable;
}

declare class OnAudioPlayStateChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioPlayStateChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioPlayStateChanged__PythonCallable;
	static GetDefaultObject(): OnAudioPlayStateChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioPlayStateChanged__PythonCallable;
	static C(Other: UObject | any): OnAudioPlayStateChanged__PythonCallable;
}

declare class OnAudioSingleEnvelopeValue__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioSingleEnvelopeValue__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioSingleEnvelopeValue__PythonCallable;
	static GetDefaultObject(): OnAudioSingleEnvelopeValue__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioSingleEnvelopeValue__PythonCallable;
	static C(Other: UObject | any): OnAudioSingleEnvelopeValue__PythonCallable;
}

declare class OnAudioVirtualizationChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioVirtualizationChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioVirtualizationChanged__PythonCallable;
	static GetDefaultObject(): OnAudioVirtualizationChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioVirtualizationChanged__PythonCallable;
	static C(Other: UObject | any): OnAudioVirtualizationChanged__PythonCallable;
}

declare class OnBoneTransformsFinalized__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnBoneTransformsFinalized__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnBoneTransformsFinalized__PythonCallable;
	static GetDefaultObject(): OnBoneTransformsFinalized__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnBoneTransformsFinalized__PythonCallable;
	static C(Other: UObject | any): OnBoneTransformsFinalized__PythonCallable;
}

declare class OnCanvasRenderTargetUpdate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnCanvasRenderTargetUpdate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnCanvasRenderTargetUpdate__PythonCallable;
	static GetDefaultObject(): OnCanvasRenderTargetUpdate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnCanvasRenderTargetUpdate__PythonCallable;
	static C(Other: UObject | any): OnCanvasRenderTargetUpdate__PythonCallable;
}

declare class OnDataLayerRuntimeStateChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnDataLayerRuntimeStateChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnDataLayerRuntimeStateChanged__PythonCallable;
	static GetDefaultObject(): OnDataLayerRuntimeStateChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnDataLayerRuntimeStateChanged__PythonCallable;
	static C(Other: UObject | any): OnDataLayerRuntimeStateChanged__PythonCallable;
}

declare class OnForceFeedbackFinished__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnForceFeedbackFinished__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnForceFeedbackFinished__PythonCallable;
	static GetDefaultObject(): OnForceFeedbackFinished__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnForceFeedbackFinished__PythonCallable;
	static C(Other: UObject | any): OnForceFeedbackFinished__PythonCallable;
}

declare class OnGameUserSettingsUINeedsUpdate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnGameUserSettingsUINeedsUpdate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnGameUserSettingsUINeedsUpdate__PythonCallable;
	static GetDefaultObject(): OnGameUserSettingsUINeedsUpdate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnGameUserSettingsUINeedsUpdate__PythonCallable;
	static C(Other: UObject | any): OnGameUserSettingsUINeedsUpdate__PythonCallable;
}

declare class OnMontageBlendingOutStartedMCDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMontageBlendingOutStartedMCDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMontageBlendingOutStartedMCDelegate__PythonCallable;
	static GetDefaultObject(): OnMontageBlendingOutStartedMCDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMontageBlendingOutStartedMCDelegate__PythonCallable;
	static C(Other: UObject | any): OnMontageBlendingOutStartedMCDelegate__PythonCallable;
}

declare class OnMontageEndedMCDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMontageEndedMCDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMontageEndedMCDelegate__PythonCallable;
	static GetDefaultObject(): OnMontageEndedMCDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMontageEndedMCDelegate__PythonCallable;
	static C(Other: UObject | any): OnMontageEndedMCDelegate__PythonCallable;
}

declare class OnMontageStartedMCDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMontageStartedMCDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMontageStartedMCDelegate__PythonCallable;
	static GetDefaultObject(): OnMontageStartedMCDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMontageStartedMCDelegate__PythonCallable;
	static C(Other: UObject | any): OnMontageStartedMCDelegate__PythonCallable;
}

declare class OnPawnControllerChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPawnControllerChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPawnControllerChanged__PythonCallable;
	static GetDefaultObject(): OnPawnControllerChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPawnControllerChanged__PythonCallable;
	static C(Other: UObject | any): OnPawnControllerChanged__PythonCallable;
}

declare class OnPlayerStatePawnSet__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPlayerStatePawnSet__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPlayerStatePawnSet__PythonCallable;
	static GetDefaultObject(): OnPlayerStatePawnSet__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPlayerStatePawnSet__PythonCallable;
	static C(Other: UObject | any): OnPlayerStatePawnSet__PythonCallable;
}

declare class OnPossessedPawnChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPossessedPawnChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPossessedPawnChanged__PythonCallable;
	static GetDefaultObject(): OnPossessedPawnChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPossessedPawnChanged__PythonCallable;
	static C(Other: UObject | any): OnPossessedPawnChanged__PythonCallable;
}

declare class OnPrimaryAssetBundlesChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPrimaryAssetBundlesChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPrimaryAssetBundlesChanged__PythonCallable;
	static GetDefaultObject(): OnPrimaryAssetBundlesChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPrimaryAssetBundlesChanged__PythonCallable;
	static C(Other: UObject | any): OnPrimaryAssetBundlesChanged__PythonCallable;
}

declare class OnPrimaryAssetClassListLoaded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPrimaryAssetClassListLoaded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPrimaryAssetClassListLoaded__PythonCallable;
	static GetDefaultObject(): OnPrimaryAssetClassListLoaded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPrimaryAssetClassListLoaded__PythonCallable;
	static C(Other: UObject | any): OnPrimaryAssetClassListLoaded__PythonCallable;
}

declare class OnPrimaryAssetClassLoaded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPrimaryAssetClassLoaded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPrimaryAssetClassLoaded__PythonCallable;
	static GetDefaultObject(): OnPrimaryAssetClassLoaded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPrimaryAssetClassLoaded__PythonCallable;
	static C(Other: UObject | any): OnPrimaryAssetClassLoaded__PythonCallable;
}

declare class OnPrimaryAssetListLoaded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPrimaryAssetListLoaded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPrimaryAssetListLoaded__PythonCallable;
	static GetDefaultObject(): OnPrimaryAssetListLoaded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPrimaryAssetListLoaded__PythonCallable;
	static C(Other: UObject | any): OnPrimaryAssetListLoaded__PythonCallable;
}

declare class OnPrimaryAssetLoaded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPrimaryAssetLoaded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPrimaryAssetLoaded__PythonCallable;
	static GetDefaultObject(): OnPrimaryAssetLoaded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPrimaryAssetLoaded__PythonCallable;
	static C(Other: UObject | any): OnPrimaryAssetLoaded__PythonCallable;
}

declare class OnQuartzCommandEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnQuartzCommandEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnQuartzCommandEvent__PythonCallable;
	static GetDefaultObject(): OnQuartzCommandEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnQuartzCommandEvent__PythonCallable;
	static C(Other: UObject | any): OnQuartzCommandEvent__PythonCallable;
}

declare class OnQuartzCommandEventBP__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnQuartzCommandEventBP__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnQuartzCommandEventBP__PythonCallable;
	static GetDefaultObject(): OnQuartzCommandEventBP__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnQuartzCommandEventBP__PythonCallable;
	static C(Other: UObject | any): OnQuartzCommandEventBP__PythonCallable;
}

declare class OnQuartzMetronomeEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnQuartzMetronomeEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnQuartzMetronomeEvent__PythonCallable;
	static GetDefaultObject(): OnQuartzMetronomeEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnQuartzMetronomeEvent__PythonCallable;
	static C(Other: UObject | any): OnQuartzMetronomeEvent__PythonCallable;
}

declare class OnQuartzMetronomeEventBP__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnQuartzMetronomeEventBP__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnQuartzMetronomeEventBP__PythonCallable;
	static GetDefaultObject(): OnQuartzMetronomeEventBP__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnQuartzMetronomeEventBP__PythonCallable;
	static C(Other: UObject | any): OnQuartzMetronomeEventBP__PythonCallable;
}

declare class OnQueueSubtitles__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnQueueSubtitles__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnQueueSubtitles__PythonCallable;
	static GetDefaultObject(): OnQueueSubtitles__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnQueueSubtitles__PythonCallable;
	static C(Other: UObject | any): OnQueueSubtitles__PythonCallable;
}

declare class OnSubmixEnvelope__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSubmixEnvelope__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSubmixEnvelope__PythonCallable;
	static GetDefaultObject(): OnSubmixEnvelope__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSubmixEnvelope__PythonCallable;
	static C(Other: UObject | any): OnSubmixEnvelope__PythonCallable;
}

declare class OnSubmixEnvelopeBP__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSubmixEnvelopeBP__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSubmixEnvelopeBP__PythonCallable;
	static GetDefaultObject(): OnSubmixEnvelopeBP__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSubmixEnvelopeBP__PythonCallable;
	static C(Other: UObject | any): OnSubmixEnvelopeBP__PythonCallable;
}

declare class OnSubmixRecordedFileDone__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSubmixRecordedFileDone__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSubmixRecordedFileDone__PythonCallable;
	static GetDefaultObject(): OnSubmixRecordedFileDone__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSubmixRecordedFileDone__PythonCallable;
	static C(Other: UObject | any): OnSubmixRecordedFileDone__PythonCallable;
}

declare class OnSubmixSpectralAnalysis__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSubmixSpectralAnalysis__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSubmixSpectralAnalysis__PythonCallable;
	static GetDefaultObject(): OnSubmixSpectralAnalysis__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSubmixSpectralAnalysis__PythonCallable;
	static C(Other: UObject | any): OnSubmixSpectralAnalysis__PythonCallable;
}

declare class OnSubmixSpectralAnalysisBP__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSubmixSpectralAnalysisBP__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSubmixSpectralAnalysisBP__PythonCallable;
	static GetDefaultObject(): OnSubmixSpectralAnalysisBP__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSubmixSpectralAnalysisBP__PythonCallable;
	static C(Other: UObject | any): OnSubmixSpectralAnalysisBP__PythonCallable;
}

declare class OnSystemFinished__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSystemFinished__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSystemFinished__PythonCallable;
	static GetDefaultObject(): OnSystemFinished__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSystemFinished__PythonCallable;
	static C(Other: UObject | any): OnSystemFinished__PythonCallable;
}

declare class OnTimelineEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTimelineEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTimelineEvent__PythonCallable;
	static GetDefaultObject(): OnTimelineEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTimelineEvent__PythonCallable;
	static C(Other: UObject | any): OnTimelineEvent__PythonCallable;
}

declare class OnTimelineFloat__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTimelineFloat__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTimelineFloat__PythonCallable;
	static GetDefaultObject(): OnTimelineFloat__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTimelineFloat__PythonCallable;
	static C(Other: UObject | any): OnTimelineFloat__PythonCallable;
}

declare class OnTimelineLinearColor__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTimelineLinearColor__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTimelineLinearColor__PythonCallable;
	static GetDefaultObject(): OnTimelineLinearColor__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTimelineLinearColor__PythonCallable;
	static C(Other: UObject | any): OnTimelineLinearColor__PythonCallable;
}

declare class OnTimelineVector__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTimelineVector__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTimelineVector__PythonCallable;
	static GetDefaultObject(): OnTimelineVector__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTimelineVector__PythonCallable;
	static C(Other: UObject | any): OnTimelineVector__PythonCallable;
}

declare class OnUserClickedBanner__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnUserClickedBanner__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnUserClickedBanner__PythonCallable;
	static GetDefaultObject(): OnUserClickedBanner__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnUserClickedBanner__PythonCallable;
	static C(Other: UObject | any): OnUserClickedBanner__PythonCallable;
}

declare class OnUserClosedAdvertisement__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnUserClosedAdvertisement__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnUserClosedAdvertisement__PythonCallable;
	static GetDefaultObject(): OnUserClosedAdvertisement__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnUserClosedAdvertisement__PythonCallable;
	static C(Other: UObject | any): OnUserClosedAdvertisement__PythonCallable;
}

declare class OnUserInputDeviceConnectionChange__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnUserInputDeviceConnectionChange__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnUserInputDeviceConnectionChange__PythonCallable;
	static GetDefaultObject(): OnUserInputDeviceConnectionChange__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnUserInputDeviceConnectionChange__PythonCallable;
	static C(Other: UObject | any): OnUserInputDeviceConnectionChange__PythonCallable;
}

declare class OnUserInputDevicePairingChange__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnUserInputDevicePairingChange__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnUserInputDevicePairingChange__PythonCallable;
	static GetDefaultObject(): OnUserInputDevicePairingChange__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnUserInputDevicePairingChange__PythonCallable;
	static C(Other: UObject | any): OnUserInputDevicePairingChange__PythonCallable;
}

declare class ParticleBurstSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ParticleBurstSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ParticleBurstSignature__PythonCallable;
	static GetDefaultObject(): ParticleBurstSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleBurstSignature__PythonCallable;
	static C(Other: UObject | any): ParticleBurstSignature__PythonCallable;
}

declare class ParticleCollisionSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ParticleCollisionSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ParticleCollisionSignature__PythonCallable;
	static GetDefaultObject(): ParticleCollisionSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleCollisionSignature__PythonCallable;
	static C(Other: UObject | any): ParticleCollisionSignature__PythonCallable;
}

declare class ParticleDeathSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ParticleDeathSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ParticleDeathSignature__PythonCallable;
	static GetDefaultObject(): ParticleDeathSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleDeathSignature__PythonCallable;
	static C(Other: UObject | any): ParticleDeathSignature__PythonCallable;
}

declare class ParticleSpawnSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ParticleSpawnSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ParticleSpawnSignature__PythonCallable;
	static GetDefaultObject(): ParticleSpawnSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleSpawnSignature__PythonCallable;
	static C(Other: UObject | any): ParticleSpawnSignature__PythonCallable;
}

declare class PlasticDeformationEventSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlasticDeformationEventSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlasticDeformationEventSignature__PythonCallable;
	static GetDefaultObject(): PlasticDeformationEventSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlasticDeformationEventSignature__PythonCallable;
	static C(Other: UObject | any): PlasticDeformationEventSignature__PythonCallable;
}

declare class PlatformInterfaceDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformInterfaceDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformInterfaceDelegate__PythonCallable;
	static GetDefaultObject(): PlatformInterfaceDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformInterfaceDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformInterfaceDelegate__PythonCallable;
}

declare class PlayMontageAnimNotifyDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlayMontageAnimNotifyDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlayMontageAnimNotifyDelegate__PythonCallable;
	static GetDefaultObject(): PlayMontageAnimNotifyDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlayMontageAnimNotifyDelegate__PythonCallable;
	static C(Other: UObject | any): PlayMontageAnimNotifyDelegate__PythonCallable;
}

declare class PostEvaluateAnimEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PostEvaluateAnimEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PostEvaluateAnimEvent__PythonCallable;
	static GetDefaultObject(): PostEvaluateAnimEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PostEvaluateAnimEvent__PythonCallable;
	static C(Other: UObject | any): PostEvaluateAnimEvent__PythonCallable;
}

declare class TimerDynamicDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TimerDynamicDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TimerDynamicDelegate__PythonCallable;
	static GetDefaultObject(): TimerDynamicDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TimerDynamicDelegate__PythonCallable;
	static C(Other: UObject | any): TimerDynamicDelegate__PythonCallable;
}

declare class ViewportDisplayCallback__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ViewportDisplayCallback__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ViewportDisplayCallback__PythonCallable;
	static GetDefaultObject(): ViewportDisplayCallback__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ViewportDisplayCallback__PythonCallable;
	static C(Other: UObject | any): ViewportDisplayCallback__PythonCallable;
}

declare class ApplicationLifecycleComponent_ApplicationLifetimeDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ApplicationLifecycleComponent_ApplicationLifetimeDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ApplicationLifecycleComponent_ApplicationLifetimeDelegate__PythonCallable;
	static GetDefaultObject(): ApplicationLifecycleComponent_ApplicationLifetimeDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ApplicationLifecycleComponent_ApplicationLifetimeDelegate__PythonCallable;
	static C(Other: UObject | any): ApplicationLifecycleComponent_ApplicationLifetimeDelegate__PythonCallable;
}

declare class ApplicationLifecycleComponent_ApplicationStartupArgumentsDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ApplicationLifecycleComponent_ApplicationStartupArgumentsDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ApplicationLifecycleComponent_ApplicationStartupArgumentsDelegate__PythonCallable;
	static GetDefaultObject(): ApplicationLifecycleComponent_ApplicationStartupArgumentsDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ApplicationLifecycleComponent_ApplicationStartupArgumentsDelegate__PythonCallable;
	static C(Other: UObject | any): ApplicationLifecycleComponent_ApplicationStartupArgumentsDelegate__PythonCallable;
}

declare class ApplicationLifecycleComponent_OnLowPowerModeDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ApplicationLifecycleComponent_OnLowPowerModeDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ApplicationLifecycleComponent_OnLowPowerModeDelegate__PythonCallable;
	static GetDefaultObject(): ApplicationLifecycleComponent_OnLowPowerModeDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ApplicationLifecycleComponent_OnLowPowerModeDelegate__PythonCallable;
	static C(Other: UObject | any): ApplicationLifecycleComponent_OnLowPowerModeDelegate__PythonCallable;
}

declare class ApplicationLifecycleComponent_OnTemperatureChangeDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ApplicationLifecycleComponent_OnTemperatureChangeDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ApplicationLifecycleComponent_OnTemperatureChangeDelegate__PythonCallable;
	static GetDefaultObject(): ApplicationLifecycleComponent_OnTemperatureChangeDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ApplicationLifecycleComponent_OnTemperatureChangeDelegate__PythonCallable;
	static C(Other: UObject | any): ApplicationLifecycleComponent_OnTemperatureChangeDelegate__PythonCallable;
}

declare class DataDrivenCVarEngineSubsystem_OnDataDrivenCVarChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): DataDrivenCVarEngineSubsystem_OnDataDrivenCVarChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): DataDrivenCVarEngineSubsystem_OnDataDrivenCVarChanged__PythonCallable;
	static GetDefaultObject(): DataDrivenCVarEngineSubsystem_OnDataDrivenCVarChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataDrivenCVarEngineSubsystem_OnDataDrivenCVarChanged__PythonCallable;
	static C(Other: UObject | any): DataDrivenCVarEngineSubsystem_OnDataDrivenCVarChanged__PythonCallable;
}

declare class InterpToMovementComponent_OnInterpToResetDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InterpToMovementComponent_OnInterpToResetDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InterpToMovementComponent_OnInterpToResetDelegate__PythonCallable;
	static GetDefaultObject(): InterpToMovementComponent_OnInterpToResetDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterpToMovementComponent_OnInterpToResetDelegate__PythonCallable;
	static C(Other: UObject | any): InterpToMovementComponent_OnInterpToResetDelegate__PythonCallable;
}

declare class InterpToMovementComponent_OnInterpToReverseDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InterpToMovementComponent_OnInterpToReverseDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InterpToMovementComponent_OnInterpToReverseDelegate__PythonCallable;
	static GetDefaultObject(): InterpToMovementComponent_OnInterpToReverseDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterpToMovementComponent_OnInterpToReverseDelegate__PythonCallable;
	static C(Other: UObject | any): InterpToMovementComponent_OnInterpToReverseDelegate__PythonCallable;
}

declare class InterpToMovementComponent_OnInterpToStopDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InterpToMovementComponent_OnInterpToStopDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InterpToMovementComponent_OnInterpToStopDelegate__PythonCallable;
	static GetDefaultObject(): InterpToMovementComponent_OnInterpToStopDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterpToMovementComponent_OnInterpToStopDelegate__PythonCallable;
	static C(Other: UObject | any): InterpToMovementComponent_OnInterpToStopDelegate__PythonCallable;
}

declare class InterpToMovementComponent_OnInterpToWaitBeginDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InterpToMovementComponent_OnInterpToWaitBeginDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InterpToMovementComponent_OnInterpToWaitBeginDelegate__PythonCallable;
	static GetDefaultObject(): InterpToMovementComponent_OnInterpToWaitBeginDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterpToMovementComponent_OnInterpToWaitBeginDelegate__PythonCallable;
	static C(Other: UObject | any): InterpToMovementComponent_OnInterpToWaitBeginDelegate__PythonCallable;
}

declare class InterpToMovementComponent_OnInterpToWaitEndDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InterpToMovementComponent_OnInterpToWaitEndDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InterpToMovementComponent_OnInterpToWaitEndDelegate__PythonCallable;
	static GetDefaultObject(): InterpToMovementComponent_OnInterpToWaitEndDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterpToMovementComponent_OnInterpToWaitEndDelegate__PythonCallable;
	static C(Other: UObject | any): InterpToMovementComponent_OnInterpToWaitEndDelegate__PythonCallable;
}

declare class SystemLibrary_OnAssetLoaded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SystemLibrary_OnAssetLoaded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SystemLibrary_OnAssetLoaded__PythonCallable;
	static GetDefaultObject(): SystemLibrary_OnAssetLoaded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SystemLibrary_OnAssetLoaded__PythonCallable;
	static C(Other: UObject | any): SystemLibrary_OnAssetLoaded__PythonCallable;
}

declare class SystemLibrary_OnAssetClassLoaded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SystemLibrary_OnAssetClassLoaded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SystemLibrary_OnAssetClassLoaded__PythonCallable;
	static GetDefaultObject(): SystemLibrary_OnAssetClassLoaded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SystemLibrary_OnAssetClassLoaded__PythonCallable;
	static C(Other: UObject | any): SystemLibrary_OnAssetClassLoaded__PythonCallable;
}

declare class PlatformEventsComponent_PlatformEventDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformEventsComponent_PlatformEventDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformEventsComponent_PlatformEventDelegate__PythonCallable;
	static GetDefaultObject(): PlatformEventsComponent_PlatformEventDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformEventsComponent_PlatformEventDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformEventsComponent_PlatformEventDelegate__PythonCallable;
}

declare class PlatformGameInstance_PlatformDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformGameInstance_PlatformDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformGameInstance_PlatformDelegate__PythonCallable;
	static GetDefaultObject(): PlatformGameInstance_PlatformDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformGameInstance_PlatformDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformGameInstance_PlatformDelegate__PythonCallable;
}

declare class PlatformGameInstance_PlatformFailedToRegisterForRemoteNotificationsDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformGameInstance_PlatformFailedToRegisterForRemoteNotificationsDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformGameInstance_PlatformFailedToRegisterForRemoteNotificationsDelegate__PythonCallable;
	static GetDefaultObject(): PlatformGameInstance_PlatformFailedToRegisterForRemoteNotificationsDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformGameInstance_PlatformFailedToRegisterForRemoteNotificationsDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformGameInstance_PlatformFailedToRegisterForRemoteNotificationsDelegate__PythonCallable;
}

declare class PlatformGameInstance_PlatformReceivedLocalNotificationDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformGameInstance_PlatformReceivedLocalNotificationDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformGameInstance_PlatformReceivedLocalNotificationDelegate__PythonCallable;
	static GetDefaultObject(): PlatformGameInstance_PlatformReceivedLocalNotificationDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformGameInstance_PlatformReceivedLocalNotificationDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformGameInstance_PlatformReceivedLocalNotificationDelegate__PythonCallable;
}

declare class PlatformGameInstance_PlatformReceivedRemoteNotificationDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformGameInstance_PlatformReceivedRemoteNotificationDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformGameInstance_PlatformReceivedRemoteNotificationDelegate__PythonCallable;
	static GetDefaultObject(): PlatformGameInstance_PlatformReceivedRemoteNotificationDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformGameInstance_PlatformReceivedRemoteNotificationDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformGameInstance_PlatformReceivedRemoteNotificationDelegate__PythonCallable;
}

declare class PlatformGameInstance_PlatformRegisteredForRemoteNotificationsDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformGameInstance_PlatformRegisteredForRemoteNotificationsDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformGameInstance_PlatformRegisteredForRemoteNotificationsDelegate__PythonCallable;
	static GetDefaultObject(): PlatformGameInstance_PlatformRegisteredForRemoteNotificationsDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformGameInstance_PlatformRegisteredForRemoteNotificationsDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformGameInstance_PlatformRegisteredForRemoteNotificationsDelegate__PythonCallable;
}

declare class PlatformGameInstance_PlatformRegisteredForUserNotificationsDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformGameInstance_PlatformRegisteredForUserNotificationsDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformGameInstance_PlatformRegisteredForUserNotificationsDelegate__PythonCallable;
	static GetDefaultObject(): PlatformGameInstance_PlatformRegisteredForUserNotificationsDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformGameInstance_PlatformRegisteredForUserNotificationsDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformGameInstance_PlatformRegisteredForUserNotificationsDelegate__PythonCallable;
}

declare class PlatformGameInstance_PlatformScreenOrientationChangedDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformGameInstance_PlatformScreenOrientationChangedDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformGameInstance_PlatformScreenOrientationChangedDelegate__PythonCallable;
	static GetDefaultObject(): PlatformGameInstance_PlatformScreenOrientationChangedDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformGameInstance_PlatformScreenOrientationChangedDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformGameInstance_PlatformScreenOrientationChangedDelegate__PythonCallable;
}

declare class PlatformGameInstance_PlatformStartupArgumentsDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PlatformGameInstance_PlatformStartupArgumentsDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PlatformGameInstance_PlatformStartupArgumentsDelegate__PythonCallable;
	static GetDefaultObject(): PlatformGameInstance_PlatformStartupArgumentsDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlatformGameInstance_PlatformStartupArgumentsDelegate__PythonCallable;
	static C(Other: UObject | any): PlatformGameInstance_PlatformStartupArgumentsDelegate__PythonCallable;
}

declare class ProjectileMovementComponent_OnProjectileBounceDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ProjectileMovementComponent_OnProjectileBounceDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ProjectileMovementComponent_OnProjectileBounceDelegate__PythonCallable;
	static GetDefaultObject(): ProjectileMovementComponent_OnProjectileBounceDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProjectileMovementComponent_OnProjectileBounceDelegate__PythonCallable;
	static C(Other: UObject | any): ProjectileMovementComponent_OnProjectileBounceDelegate__PythonCallable;
}

declare class ProjectileMovementComponent_OnProjectileStopDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ProjectileMovementComponent_OnProjectileStopDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ProjectileMovementComponent_OnProjectileStopDelegate__PythonCallable;
	static GetDefaultObject(): ProjectileMovementComponent_OnProjectileStopDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProjectileMovementComponent_OnProjectileStopDelegate__PythonCallable;
	static C(Other: UObject | any): ProjectileMovementComponent_OnProjectileStopDelegate__PythonCallable;
}

declare class MockDataMeshTrackerComponent_OnMockDataMeshTrackerUpdated__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MockDataMeshTrackerComponent_OnMockDataMeshTrackerUpdated__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MockDataMeshTrackerComponent_OnMockDataMeshTrackerUpdated__PythonCallable;
	static GetDefaultObject(): MockDataMeshTrackerComponent_OnMockDataMeshTrackerUpdated__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MockDataMeshTrackerComponent_OnMockDataMeshTrackerUpdated__PythonCallable;
	static C(Other: UObject | any): MockDataMeshTrackerComponent_OnMockDataMeshTrackerUpdated__PythonCallable;
}

declare class ARGetCandidateObjectPin__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ARGetCandidateObjectPin__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ARGetCandidateObjectPin__PythonCallable;
	static GetDefaultObject(): ARGetCandidateObjectPin__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ARGetCandidateObjectPin__PythonCallable;
	static C(Other: UObject | any): ARGetCandidateObjectPin__PythonCallable;
}

declare class ARSaveWorldPin__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ARSaveWorldPin__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ARSaveWorldPin__PythonCallable;
	static GetDefaultObject(): ARSaveWorldPin__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ARSaveWorldPin__PythonCallable;
	static C(Other: UObject | any): ARSaveWorldPin__PythonCallable;
}

declare class OnARTrackingStateChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnARTrackingStateChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnARTrackingStateChanged__PythonCallable;
	static GetDefaultObject(): OnARTrackingStateChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnARTrackingStateChanged__PythonCallable;
	static C(Other: UObject | any): OnARTrackingStateChanged__PythonCallable;
}

declare class OnARTransformUpdated__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnARTransformUpdated__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnARTransformUpdated__PythonCallable;
	static GetDefaultObject(): OnARTransformUpdated__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnARTransformUpdated__PythonCallable;
	static C(Other: UObject | any): OnARTransformUpdated__PythonCallable;
}

declare class TrackableDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TrackableDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TrackableDelegate__PythonCallable;
	static GetDefaultObject(): TrackableDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TrackableDelegate__PythonCallable;
	static C(Other: UObject | any): TrackableDelegate__PythonCallable;
}

declare class TrackableEnvProbeDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TrackableEnvProbeDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TrackableEnvProbeDelegate__PythonCallable;
	static GetDefaultObject(): TrackableEnvProbeDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TrackableEnvProbeDelegate__PythonCallable;
	static C(Other: UObject | any): TrackableEnvProbeDelegate__PythonCallable;
}

declare class TrackableFaceDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TrackableFaceDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TrackableFaceDelegate__PythonCallable;
	static GetDefaultObject(): TrackableFaceDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TrackableFaceDelegate__PythonCallable;
	static C(Other: UObject | any): TrackableFaceDelegate__PythonCallable;
}

declare class TrackableImageDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TrackableImageDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TrackableImageDelegate__PythonCallable;
	static GetDefaultObject(): TrackableImageDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TrackableImageDelegate__PythonCallable;
	static C(Other: UObject | any): TrackableImageDelegate__PythonCallable;
}

declare class TrackableObjectDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TrackableObjectDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TrackableObjectDelegate__PythonCallable;
	static GetDefaultObject(): TrackableObjectDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TrackableObjectDelegate__PythonCallable;
	static C(Other: UObject | any): TrackableObjectDelegate__PythonCallable;
}

declare class TrackablePlaneDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TrackablePlaneDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TrackablePlaneDelegate__PythonCallable;
	static GetDefaultObject(): TrackablePlaneDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TrackablePlaneDelegate__PythonCallable;
	static C(Other: UObject | any): TrackablePlaneDelegate__PythonCallable;
}

declare class TrackablePointDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TrackablePointDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TrackablePointDelegate__PythonCallable;
	static GetDefaultObject(): TrackablePointDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TrackablePointDelegate__PythonCallable;
	static C(Other: UObject | any): TrackablePointDelegate__PythonCallable;
}

declare class ARLifeCycleComponent_InstanceARActorSpawnedDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ARLifeCycleComponent_InstanceARActorSpawnedDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ARLifeCycleComponent_InstanceARActorSpawnedDelegate__PythonCallable;
	static GetDefaultObject(): ARLifeCycleComponent_InstanceARActorSpawnedDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ARLifeCycleComponent_InstanceARActorSpawnedDelegate__PythonCallable;
	static C(Other: UObject | any): ARLifeCycleComponent_InstanceARActorSpawnedDelegate__PythonCallable;
}

declare class ARLifeCycleComponent_InstanceARActorToBeDestroyedDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ARLifeCycleComponent_InstanceARActorToBeDestroyedDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ARLifeCycleComponent_InstanceARActorToBeDestroyedDelegate__PythonCallable;
	static GetDefaultObject(): ARLifeCycleComponent_InstanceARActorToBeDestroyedDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ARLifeCycleComponent_InstanceARActorToBeDestroyedDelegate__PythonCallable;
	static C(Other: UObject | any): ARLifeCycleComponent_InstanceARActorToBeDestroyedDelegate__PythonCallable;
}

declare class CheckGeoTrackingAvailabilityAsyncTaskBlueprintProxy_GeoTrackingAvailabilityDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): CheckGeoTrackingAvailabilityAsyncTaskBlueprintProxy_GeoTrackingAvailabilityDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): CheckGeoTrackingAvailabilityAsyncTaskBlueprintProxy_GeoTrackingAvailabilityDelegate__PythonCallable;
	static GetDefaultObject(): CheckGeoTrackingAvailabilityAsyncTaskBlueprintProxy_GeoTrackingAvailabilityDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CheckGeoTrackingAvailabilityAsyncTaskBlueprintProxy_GeoTrackingAvailabilityDelegate__PythonCallable;
	static C(Other: UObject | any): CheckGeoTrackingAvailabilityAsyncTaskBlueprintProxy_GeoTrackingAvailabilityDelegate__PythonCallable;
}

declare class GetGeoLocationAsyncTaskBlueprintProxy_GetGeoLocationDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): GetGeoLocationAsyncTaskBlueprintProxy_GetGeoLocationDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): GetGeoLocationAsyncTaskBlueprintProxy_GetGeoLocationDelegate__PythonCallable;
	static GetDefaultObject(): GetGeoLocationAsyncTaskBlueprintProxy_GetGeoLocationDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GetGeoLocationAsyncTaskBlueprintProxy_GetGeoLocationDelegate__PythonCallable;
	static C(Other: UObject | any): GetGeoLocationAsyncTaskBlueprintProxy_GetGeoLocationDelegate__PythonCallable;
}

declare class DeviceModelLoadedDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): DeviceModelLoadedDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): DeviceModelLoadedDelegate__PythonCallable;
	static GetDefaultObject(): DeviceModelLoadedDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DeviceModelLoadedDelegate__PythonCallable;
	static C(Other: UObject | any): DeviceModelLoadedDelegate__PythonCallable;
}

declare class XRDeviceOnDisconnectDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): XRDeviceOnDisconnectDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): XRDeviceOnDisconnectDelegate__PythonCallable;
	static GetDefaultObject(): XRDeviceOnDisconnectDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): XRDeviceOnDisconnectDelegate__PythonCallable;
	static C(Other: UObject | any): XRDeviceOnDisconnectDelegate__PythonCallable;
}

declare class XRTimedInputActionDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): XRTimedInputActionDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): XRTimedInputActionDelegate__PythonCallable;
	static GetDefaultObject(): XRTimedInputActionDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): XRTimedInputActionDelegate__PythonCallable;
	static C(Other: UObject | any): XRTimedInputActionDelegate__PythonCallable;
}

declare class VRNotificationsComponent_VRNotificationsDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): VRNotificationsComponent_VRNotificationsDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): VRNotificationsComponent_VRNotificationsDelegate__PythonCallable;
	static GetDefaultObject(): VRNotificationsComponent_VRNotificationsDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VRNotificationsComponent_VRNotificationsDelegate__PythonCallable;
	static C(Other: UObject | any): VRNotificationsComponent_VRNotificationsDelegate__PythonCallable;
}

declare class OnImportDoneDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnImportDoneDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnImportDoneDynamic__PythonCallable;
	static GetDefaultObject(): OnImportDoneDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnImportDoneDynamic__PythonCallable;
	static C(Other: UObject | any): OnImportDoneDynamic__PythonCallable;
}

declare class OnObjectImportDoneDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnObjectImportDoneDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnObjectImportDoneDynamic__PythonCallable;
	static GetDefaultObject(): OnObjectImportDoneDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnObjectImportDoneDynamic__PythonCallable;
	static C(Other: UObject | any): OnObjectImportDoneDynamic__PythonCallable;
}

declare class GameplayTaskSpawnActorDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): GameplayTaskSpawnActorDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): GameplayTaskSpawnActorDelegate__PythonCallable;
	static GetDefaultObject(): GameplayTaskSpawnActorDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTaskSpawnActorDelegate__PythonCallable;
	static C(Other: UObject | any): GameplayTaskSpawnActorDelegate__PythonCallable;
}

declare class OnClaimedResourcesChangeSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnClaimedResourcesChangeSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnClaimedResourcesChangeSignature__PythonCallable;
	static GetDefaultObject(): OnClaimedResourcesChangeSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnClaimedResourcesChangeSignature__PythonCallable;
	static C(Other: UObject | any): OnClaimedResourcesChangeSignature__PythonCallable;
}

declare class GameplayTask_GenericGameplayTaskDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): GameplayTask_GenericGameplayTaskDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): GameplayTask_GenericGameplayTaskDelegate__PythonCallable;
	static GetDefaultObject(): GameplayTask_GenericGameplayTaskDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTask_GenericGameplayTaskDelegate__PythonCallable;
	static C(Other: UObject | any): GameplayTask_GenericGameplayTaskDelegate__PythonCallable;
}

declare class GameplayTask_TimeLimitedExecution_TaskFinishDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): GameplayTask_TimeLimitedExecution_TaskFinishDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): GameplayTask_TimeLimitedExecution_TaskFinishDelegate__PythonCallable;
	static GetDefaultObject(): GameplayTask_TimeLimitedExecution_TaskFinishDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTask_TimeLimitedExecution_TaskFinishDelegate__PythonCallable;
	static C(Other: UObject | any): GameplayTask_TimeLimitedExecution_TaskFinishDelegate__PythonCallable;
}

declare class GameplayTask_WaitDelay_TaskDelayDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): GameplayTask_WaitDelay_TaskDelayDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): GameplayTask_WaitDelay_TaskDelayDelegate__PythonCallable;
	static GetDefaultObject(): GameplayTask_WaitDelay_TaskDelayDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTask_WaitDelay_TaskDelayDelegate__PythonCallable;
	static C(Other: UObject | any): GameplayTask_WaitDelay_TaskDelayDelegate__PythonCallable;
}

declare class ActorPerceptionInfoUpdatedDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorPerceptionInfoUpdatedDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorPerceptionInfoUpdatedDelegate__PythonCallable;
	static GetDefaultObject(): ActorPerceptionInfoUpdatedDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorPerceptionInfoUpdatedDelegate__PythonCallable;
	static C(Other: UObject | any): ActorPerceptionInfoUpdatedDelegate__PythonCallable;
}

declare class ActorPerceptionUpdatedDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorPerceptionUpdatedDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorPerceptionUpdatedDelegate__PythonCallable;
	static GetDefaultObject(): ActorPerceptionUpdatedDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorPerceptionUpdatedDelegate__PythonCallable;
	static C(Other: UObject | any): ActorPerceptionUpdatedDelegate__PythonCallable;
}

declare class AIMoveCompletedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): AIMoveCompletedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): AIMoveCompletedSignature__PythonCallable;
	static GetDefaultObject(): AIMoveCompletedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AIMoveCompletedSignature__PythonCallable;
	static C(Other: UObject | any): AIMoveCompletedSignature__PythonCallable;
}

declare class MoveTaskCompletedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MoveTaskCompletedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MoveTaskCompletedSignature__PythonCallable;
	static GetDefaultObject(): MoveTaskCompletedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MoveTaskCompletedSignature__PythonCallable;
	static C(Other: UObject | any): MoveTaskCompletedSignature__PythonCallable;
}

declare class OAISimpleDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OAISimpleDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OAISimpleDelegate__PythonCallable;
	static GetDefaultObject(): OAISimpleDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OAISimpleDelegate__PythonCallable;
	static C(Other: UObject | any): OAISimpleDelegate__PythonCallable;
}

declare class PerceptionUpdatedDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PerceptionUpdatedDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PerceptionUpdatedDelegate__PythonCallable;
	static GetDefaultObject(): PerceptionUpdatedDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PerceptionUpdatedDelegate__PythonCallable;
	static C(Other: UObject | any): PerceptionUpdatedDelegate__PythonCallable;
}

declare class SmartLinkReachedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SmartLinkReachedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SmartLinkReachedSignature__PythonCallable;
	static GetDefaultObject(): SmartLinkReachedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SmartLinkReachedSignature__PythonCallable;
	static C(Other: UObject | any): SmartLinkReachedSignature__PythonCallable;
}

declare class EnvQueryInstanceBlueprintWrapper_EQSQueryDoneSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EnvQueryInstanceBlueprintWrapper_EQSQueryDoneSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EnvQueryInstanceBlueprintWrapper_EQSQueryDoneSignature__PythonCallable;
	static GetDefaultObject(): EnvQueryInstanceBlueprintWrapper_EQSQueryDoneSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryInstanceBlueprintWrapper_EQSQueryDoneSignature__PythonCallable;
	static C(Other: UObject | any): EnvQueryInstanceBlueprintWrapper_EQSQueryDoneSignature__PythonCallable;
}

declare class PawnSensingComponent_HearNoiseDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PawnSensingComponent_HearNoiseDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PawnSensingComponent_HearNoiseDelegate__PythonCallable;
	static GetDefaultObject(): PawnSensingComponent_HearNoiseDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PawnSensingComponent_HearNoiseDelegate__PythonCallable;
	static C(Other: UObject | any): PawnSensingComponent_HearNoiseDelegate__PythonCallable;
}

declare class PawnSensingComponent_SeePawnDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PawnSensingComponent_SeePawnDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PawnSensingComponent_SeePawnDelegate__PythonCallable;
	static GetDefaultObject(): PawnSensingComponent_SeePawnDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PawnSensingComponent_SeePawnDelegate__PythonCallable;
	static C(Other: UObject | any): PawnSensingComponent_SeePawnDelegate__PythonCallable;
}

declare class OnNavDataGenericEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnNavDataGenericEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnNavDataGenericEvent__PythonCallable;
	static GetDefaultObject(): OnNavDataGenericEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnNavDataGenericEvent__PythonCallable;
	static C(Other: UObject | any): OnNavDataGenericEvent__PythonCallable;
}

declare class OnNavigationPathUpdated__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnNavigationPathUpdated__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnNavigationPathUpdated__PythonCallable;
	static GetDefaultObject(): OnNavigationPathUpdated__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnNavigationPathUpdated__PythonCallable;
	static C(Other: UObject | any): OnNavigationPathUpdated__PythonCallable;
}

declare class Widget_GenerateWidgetForObject__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GenerateWidgetForObject__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GenerateWidgetForObject__PythonCallable;
	static GetDefaultObject(): Widget_GenerateWidgetForObject__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GenerateWidgetForObject__PythonCallable;
	static C(Other: UObject | any): Widget_GenerateWidgetForObject__PythonCallable;
}

declare class Widget_GenerateWidgetForString__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GenerateWidgetForString__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GenerateWidgetForString__PythonCallable;
	static GetDefaultObject(): Widget_GenerateWidgetForString__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GenerateWidgetForString__PythonCallable;
	static C(Other: UObject | any): Widget_GenerateWidgetForString__PythonCallable;
}

declare class Widget_GetBool__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetBool__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetBool__PythonCallable;
	static GetDefaultObject(): Widget_GetBool__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetBool__PythonCallable;
	static C(Other: UObject | any): Widget_GetBool__PythonCallable;
}

declare class Widget_GetCheckBoxState__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetCheckBoxState__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetCheckBoxState__PythonCallable;
	static GetDefaultObject(): Widget_GetCheckBoxState__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetCheckBoxState__PythonCallable;
	static C(Other: UObject | any): Widget_GetCheckBoxState__PythonCallable;
}

declare class Widget_GetFloat__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetFloat__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetFloat__PythonCallable;
	static GetDefaultObject(): Widget_GetFloat__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetFloat__PythonCallable;
	static C(Other: UObject | any): Widget_GetFloat__PythonCallable;
}

declare class Widget_GetInt32__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetInt32__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetInt32__PythonCallable;
	static GetDefaultObject(): Widget_GetInt32__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetInt32__PythonCallable;
	static C(Other: UObject | any): Widget_GetInt32__PythonCallable;
}

declare class Widget_GetLinearColor__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetLinearColor__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetLinearColor__PythonCallable;
	static GetDefaultObject(): Widget_GetLinearColor__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetLinearColor__PythonCallable;
	static C(Other: UObject | any): Widget_GetLinearColor__PythonCallable;
}

declare class Widget_GetMouseCursor__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetMouseCursor__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetMouseCursor__PythonCallable;
	static GetDefaultObject(): Widget_GetMouseCursor__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetMouseCursor__PythonCallable;
	static C(Other: UObject | any): Widget_GetMouseCursor__PythonCallable;
}

declare class Widget_GetSlateBrush__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetSlateBrush__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetSlateBrush__PythonCallable;
	static GetDefaultObject(): Widget_GetSlateBrush__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetSlateBrush__PythonCallable;
	static C(Other: UObject | any): Widget_GetSlateBrush__PythonCallable;
}

declare class Widget_GetSlateColor__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetSlateColor__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetSlateColor__PythonCallable;
	static GetDefaultObject(): Widget_GetSlateColor__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetSlateColor__PythonCallable;
	static C(Other: UObject | any): Widget_GetSlateColor__PythonCallable;
}

declare class Widget_GetSlateVisibility__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetSlateVisibility__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetSlateVisibility__PythonCallable;
	static GetDefaultObject(): Widget_GetSlateVisibility__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetSlateVisibility__PythonCallable;
	static C(Other: UObject | any): Widget_GetSlateVisibility__PythonCallable;
}

declare class Widget_GetText__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetText__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetText__PythonCallable;
	static GetDefaultObject(): Widget_GetText__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetText__PythonCallable;
	static C(Other: UObject | any): Widget_GetText__PythonCallable;
}

declare class Widget_GetWidget__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_GetWidget__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_GetWidget__PythonCallable;
	static GetDefaultObject(): Widget_GetWidget__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_GetWidget__PythonCallable;
	static C(Other: UObject | any): Widget_GetWidget__PythonCallable;
}

declare class FieldValueChangedDynamicDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): FieldValueChangedDynamicDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): FieldValueChangedDynamicDelegate__PythonCallable;
	static GetDefaultObject(): FieldValueChangedDynamicDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FieldValueChangedDynamicDelegate__PythonCallable;
	static C(Other: UObject | any): FieldValueChangedDynamicDelegate__PythonCallable;
}

declare class Widget_OnPointerEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_OnPointerEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_OnPointerEvent__PythonCallable;
	static GetDefaultObject(): Widget_OnPointerEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_OnPointerEvent__PythonCallable;
	static C(Other: UObject | any): Widget_OnPointerEvent__PythonCallable;
}

declare class Widget_OnReply__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): Widget_OnReply__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): Widget_OnReply__PythonCallable;
	static GetDefaultObject(): Widget_OnReply__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget_OnReply__PythonCallable;
	static C(Other: UObject | any): Widget_OnReply__PythonCallable;
}

declare class CustomWidgetNavigationDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): CustomWidgetNavigationDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): CustomWidgetNavigationDelegate__PythonCallable;
	static GetDefaultObject(): CustomWidgetNavigationDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CustomWidgetNavigationDelegate__PythonCallable;
	static C(Other: UObject | any): CustomWidgetNavigationDelegate__PythonCallable;
}

declare class ComboBoxKey_GenerateWidgetEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComboBoxKey_GenerateWidgetEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComboBoxKey_GenerateWidgetEvent__PythonCallable;
	static GetDefaultObject(): ComboBoxKey_GenerateWidgetEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComboBoxKey_GenerateWidgetEvent__PythonCallable;
	static C(Other: UObject | any): ComboBoxKey_GenerateWidgetEvent__PythonCallable;
}

declare class ComboBoxKey_OnOpeningEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComboBoxKey_OnOpeningEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComboBoxKey_OnOpeningEvent__PythonCallable;
	static GetDefaultObject(): ComboBoxKey_OnOpeningEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComboBoxKey_OnOpeningEvent__PythonCallable;
	static C(Other: UObject | any): ComboBoxKey_OnOpeningEvent__PythonCallable;
}

declare class ComboBoxKey_OnSelectionChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComboBoxKey_OnSelectionChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComboBoxKey_OnSelectionChangedEvent__PythonCallable;
	static GetDefaultObject(): ComboBoxKey_OnSelectionChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComboBoxKey_OnSelectionChangedEvent__PythonCallable;
	static C(Other: UObject | any): ComboBoxKey_OnSelectionChangedEvent__PythonCallable;
}

declare class ComboBoxString_OnOpeningEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComboBoxString_OnOpeningEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComboBoxString_OnOpeningEvent__PythonCallable;
	static GetDefaultObject(): ComboBoxString_OnOpeningEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComboBoxString_OnOpeningEvent__PythonCallable;
	static C(Other: UObject | any): ComboBoxString_OnOpeningEvent__PythonCallable;
}

declare class ComboBoxString_OnSelectionChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComboBoxString_OnSelectionChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComboBoxString_OnSelectionChangedEvent__PythonCallable;
	static GetDefaultObject(): ComboBoxString_OnSelectionChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComboBoxString_OnSelectionChangedEvent__PythonCallable;
	static C(Other: UObject | any): ComboBoxString_OnSelectionChangedEvent__PythonCallable;
}

declare class EditableText_OnEditableTextChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EditableText_OnEditableTextChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EditableText_OnEditableTextChangedEvent__PythonCallable;
	static GetDefaultObject(): EditableText_OnEditableTextChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditableText_OnEditableTextChangedEvent__PythonCallable;
	static C(Other: UObject | any): EditableText_OnEditableTextChangedEvent__PythonCallable;
}

declare class EditableText_OnEditableTextCommittedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EditableText_OnEditableTextCommittedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EditableText_OnEditableTextCommittedEvent__PythonCallable;
	static GetDefaultObject(): EditableText_OnEditableTextCommittedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditableText_OnEditableTextCommittedEvent__PythonCallable;
	static C(Other: UObject | any): EditableText_OnEditableTextCommittedEvent__PythonCallable;
}

declare class EditableTextBox_OnEditableTextBoxChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EditableTextBox_OnEditableTextBoxChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EditableTextBox_OnEditableTextBoxChangedEvent__PythonCallable;
	static GetDefaultObject(): EditableTextBox_OnEditableTextBoxChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditableTextBox_OnEditableTextBoxChangedEvent__PythonCallable;
	static C(Other: UObject | any): EditableTextBox_OnEditableTextBoxChangedEvent__PythonCallable;
}

declare class EditableTextBox_OnEditableTextBoxCommittedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EditableTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EditableTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
	static GetDefaultObject(): EditableTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditableTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
	static C(Other: UObject | any): EditableTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
}

declare class InputKeySelector_OnIsSelectingKeyChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InputKeySelector_OnIsSelectingKeyChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InputKeySelector_OnIsSelectingKeyChanged__PythonCallable;
	static GetDefaultObject(): InputKeySelector_OnIsSelectingKeyChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputKeySelector_OnIsSelectingKeyChanged__PythonCallable;
	static C(Other: UObject | any): InputKeySelector_OnIsSelectingKeyChanged__PythonCallable;
}

declare class InputKeySelector_OnKeySelected__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InputKeySelector_OnKeySelected__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InputKeySelector_OnKeySelected__PythonCallable;
	static GetDefaultObject(): InputKeySelector_OnKeySelected__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputKeySelector_OnKeySelected__PythonCallable;
	static C(Other: UObject | any): InputKeySelector_OnKeySelected__PythonCallable;
}

declare class MenuAnchor_GetUserWidget__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MenuAnchor_GetUserWidget__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MenuAnchor_GetUserWidget__PythonCallable;
	static GetDefaultObject(): MenuAnchor_GetUserWidget__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MenuAnchor_GetUserWidget__PythonCallable;
	static C(Other: UObject | any): MenuAnchor_GetUserWidget__PythonCallable;
}

declare class OnMenuOpenChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMenuOpenChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMenuOpenChangedEvent__PythonCallable;
	static GetDefaultObject(): OnMenuOpenChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMenuOpenChangedEvent__PythonCallable;
	static C(Other: UObject | any): OnMenuOpenChangedEvent__PythonCallable;
}

declare class DownloadImageDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): DownloadImageDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): DownloadImageDelegate__PythonCallable;
	static GetDefaultObject(): DownloadImageDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DownloadImageDelegate__PythonCallable;
	static C(Other: UObject | any): DownloadImageDelegate__PythonCallable;
}

declare class OnButtonClickedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnButtonClickedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnButtonClickedEvent__PythonCallable;
	static GetDefaultObject(): OnButtonClickedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnButtonClickedEvent__PythonCallable;
	static C(Other: UObject | any): OnButtonClickedEvent__PythonCallable;
}

declare class OnButtonHoverEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnButtonHoverEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnButtonHoverEvent__PythonCallable;
	static GetDefaultObject(): OnButtonHoverEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnButtonHoverEvent__PythonCallable;
	static C(Other: UObject | any): OnButtonHoverEvent__PythonCallable;
}

declare class OnButtonPressedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnButtonPressedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnButtonPressedEvent__PythonCallable;
	static GetDefaultObject(): OnButtonPressedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnButtonPressedEvent__PythonCallable;
	static C(Other: UObject | any): OnButtonPressedEvent__PythonCallable;
}

declare class OnButtonReleasedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnButtonReleasedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnButtonReleasedEvent__PythonCallable;
	static GetDefaultObject(): OnButtonReleasedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnButtonReleasedEvent__PythonCallable;
	static C(Other: UObject | any): OnButtonReleasedEvent__PythonCallable;
}

declare class OnCheckBoxComponentStateChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnCheckBoxComponentStateChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnCheckBoxComponentStateChanged__PythonCallable;
	static GetDefaultObject(): OnCheckBoxComponentStateChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnCheckBoxComponentStateChanged__PythonCallable;
	static C(Other: UObject | any): OnCheckBoxComponentStateChanged__PythonCallable;
}

declare class OnConstructEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnConstructEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnConstructEvent__PythonCallable;
	static GetDefaultObject(): OnConstructEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnConstructEvent__PythonCallable;
	static C(Other: UObject | any): OnConstructEvent__PythonCallable;
}

declare class OnControllerCaptureBeginEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnControllerCaptureBeginEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnControllerCaptureBeginEvent__PythonCallable;
	static GetDefaultObject(): OnControllerCaptureBeginEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnControllerCaptureBeginEvent__PythonCallable;
	static C(Other: UObject | any): OnControllerCaptureBeginEvent__PythonCallable;
}

declare class OnControllerCaptureEndEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnControllerCaptureEndEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnControllerCaptureEndEvent__PythonCallable;
	static GetDefaultObject(): OnControllerCaptureEndEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnControllerCaptureEndEvent__PythonCallable;
	static C(Other: UObject | any): OnControllerCaptureEndEvent__PythonCallable;
}

declare class OnDragDropMulticast__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnDragDropMulticast__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnDragDropMulticast__PythonCallable;
	static GetDefaultObject(): OnDragDropMulticast__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnDragDropMulticast__PythonCallable;
	static C(Other: UObject | any): OnDragDropMulticast__PythonCallable;
}

declare class OnExpandableAreaExpansionChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnExpandableAreaExpansionChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnExpandableAreaExpansionChanged__PythonCallable;
	static GetDefaultObject(): OnExpandableAreaExpansionChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnExpandableAreaExpansionChanged__PythonCallable;
	static C(Other: UObject | any): OnExpandableAreaExpansionChanged__PythonCallable;
}

declare class OnFloatValueChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnFloatValueChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnFloatValueChangedEvent__PythonCallable;
	static GetDefaultObject(): OnFloatValueChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnFloatValueChangedEvent__PythonCallable;
	static C(Other: UObject | any): OnFloatValueChangedEvent__PythonCallable;
}

declare class OnGetItemChildrenDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnGetItemChildrenDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnGetItemChildrenDynamic__PythonCallable;
	static GetDefaultObject(): OnGetItemChildrenDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnGetItemChildrenDynamic__PythonCallable;
	static C(Other: UObject | any): OnGetItemChildrenDynamic__PythonCallable;
}

declare class OnHoveredWidgetChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnHoveredWidgetChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnHoveredWidgetChanged__PythonCallable;
	static GetDefaultObject(): OnHoveredWidgetChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnHoveredWidgetChanged__PythonCallable;
	static C(Other: UObject | any): OnHoveredWidgetChanged__PythonCallable;
}

declare class OnInputAction__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnInputAction__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnInputAction__PythonCallable;
	static GetDefaultObject(): OnInputAction__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnInputAction__PythonCallable;
	static C(Other: UObject | any): OnInputAction__PythonCallable;
}

declare class OnItemExpansionChangedDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnItemExpansionChangedDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnItemExpansionChangedDynamic__PythonCallable;
	static GetDefaultObject(): OnItemExpansionChangedDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnItemExpansionChangedDynamic__PythonCallable;
	static C(Other: UObject | any): OnItemExpansionChangedDynamic__PythonCallable;
}

declare class OnItemIsHoveredChangedDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnItemIsHoveredChangedDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnItemIsHoveredChangedDynamic__PythonCallable;
	static GetDefaultObject(): OnItemIsHoveredChangedDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnItemIsHoveredChangedDynamic__PythonCallable;
	static C(Other: UObject | any): OnItemIsHoveredChangedDynamic__PythonCallable;
}

declare class OnListEntryGeneratedDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnListEntryGeneratedDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnListEntryGeneratedDynamic__PythonCallable;
	static GetDefaultObject(): OnListEntryGeneratedDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnListEntryGeneratedDynamic__PythonCallable;
	static C(Other: UObject | any): OnListEntryGeneratedDynamic__PythonCallable;
}

declare class OnListEntryInitializedDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnListEntryInitializedDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnListEntryInitializedDynamic__PythonCallable;
	static GetDefaultObject(): OnListEntryInitializedDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnListEntryInitializedDynamic__PythonCallable;
	static C(Other: UObject | any): OnListEntryInitializedDynamic__PythonCallable;
}

declare class OnListEntryReleasedDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnListEntryReleasedDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnListEntryReleasedDynamic__PythonCallable;
	static GetDefaultObject(): OnListEntryReleasedDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnListEntryReleasedDynamic__PythonCallable;
	static C(Other: UObject | any): OnListEntryReleasedDynamic__PythonCallable;
}

declare class OnListItemScrolledIntoViewDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnListItemScrolledIntoViewDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnListItemScrolledIntoViewDynamic__PythonCallable;
	static GetDefaultObject(): OnListItemScrolledIntoViewDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnListItemScrolledIntoViewDynamic__PythonCallable;
	static C(Other: UObject | any): OnListItemScrolledIntoViewDynamic__PythonCallable;
}

declare class OnListItemSelectionChangedDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnListItemSelectionChangedDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnListItemSelectionChangedDynamic__PythonCallable;
	static GetDefaultObject(): OnListItemSelectionChangedDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnListItemSelectionChangedDynamic__PythonCallable;
	static C(Other: UObject | any): OnListItemSelectionChangedDynamic__PythonCallable;
}

declare class OnMouseCaptureBeginEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMouseCaptureBeginEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMouseCaptureBeginEvent__PythonCallable;
	static GetDefaultObject(): OnMouseCaptureBeginEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMouseCaptureBeginEvent__PythonCallable;
	static C(Other: UObject | any): OnMouseCaptureBeginEvent__PythonCallable;
}

declare class OnMouseCaptureEndEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMouseCaptureEndEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMouseCaptureEndEvent__PythonCallable;
	static GetDefaultObject(): OnMouseCaptureEndEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMouseCaptureEndEvent__PythonCallable;
	static C(Other: UObject | any): OnMouseCaptureEndEvent__PythonCallable;
}

declare class OnUserScrolledEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnUserScrolledEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnUserScrolledEvent__PythonCallable;
	static GetDefaultObject(): OnUserScrolledEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnUserScrolledEvent__PythonCallable;
	static C(Other: UObject | any): OnUserScrolledEvent__PythonCallable;
}

declare class OnVisibilityChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnVisibilityChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnVisibilityChangedEvent__PythonCallable;
	static GetDefaultObject(): OnVisibilityChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnVisibilityChangedEvent__PythonCallable;
	static C(Other: UObject | any): OnVisibilityChangedEvent__PythonCallable;
}

declare class OnWidgetAnimationPlaybackStatusChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnWidgetAnimationPlaybackStatusChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnWidgetAnimationPlaybackStatusChanged__PythonCallable;
	static GetDefaultObject(): OnWidgetAnimationPlaybackStatusChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnWidgetAnimationPlaybackStatusChanged__PythonCallable;
	static C(Other: UObject | any): OnWidgetAnimationPlaybackStatusChanged__PythonCallable;
}

declare class SimpleListItemEventDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SimpleListItemEventDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SimpleListItemEventDynamic__PythonCallable;
	static GetDefaultObject(): SimpleListItemEventDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SimpleListItemEventDynamic__PythonCallable;
	static C(Other: UObject | any): SimpleListItemEventDynamic__PythonCallable;
}

declare class WidgetAnimationDynamicEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): WidgetAnimationDynamicEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): WidgetAnimationDynamicEvent__PythonCallable;
	static GetDefaultObject(): WidgetAnimationDynamicEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WidgetAnimationDynamicEvent__PythonCallable;
	static C(Other: UObject | any): WidgetAnimationDynamicEvent__PythonCallable;
}

declare class WidgetAnimationDynamicEvents__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): WidgetAnimationDynamicEvents__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): WidgetAnimationDynamicEvents__PythonCallable;
	static GetDefaultObject(): WidgetAnimationDynamicEvents__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WidgetAnimationDynamicEvents__PythonCallable;
	static C(Other: UObject | any): WidgetAnimationDynamicEvents__PythonCallable;
}

declare class WidgetAnimationResult__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): WidgetAnimationResult__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): WidgetAnimationResult__PythonCallable;
	static GetDefaultObject(): WidgetAnimationResult__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WidgetAnimationResult__PythonCallable;
	static C(Other: UObject | any): WidgetAnimationResult__PythonCallable;
}

declare class MultiLineEditableText_OnMultiLineEditableTextChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MultiLineEditableText_OnMultiLineEditableTextChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MultiLineEditableText_OnMultiLineEditableTextChangedEvent__PythonCallable;
	static GetDefaultObject(): MultiLineEditableText_OnMultiLineEditableTextChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MultiLineEditableText_OnMultiLineEditableTextChangedEvent__PythonCallable;
	static C(Other: UObject | any): MultiLineEditableText_OnMultiLineEditableTextChangedEvent__PythonCallable;
}

declare class MultiLineEditableText_OnMultiLineEditableTextCommittedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MultiLineEditableText_OnMultiLineEditableTextCommittedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MultiLineEditableText_OnMultiLineEditableTextCommittedEvent__PythonCallable;
	static GetDefaultObject(): MultiLineEditableText_OnMultiLineEditableTextCommittedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MultiLineEditableText_OnMultiLineEditableTextCommittedEvent__PythonCallable;
	static C(Other: UObject | any): MultiLineEditableText_OnMultiLineEditableTextCommittedEvent__PythonCallable;
}

declare class MultiLineEditableTextBox_OnMultiLineEditableTextBoxChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MultiLineEditableTextBox_OnMultiLineEditableTextBoxChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MultiLineEditableTextBox_OnMultiLineEditableTextBoxChangedEvent__PythonCallable;
	static GetDefaultObject(): MultiLineEditableTextBox_OnMultiLineEditableTextBoxChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MultiLineEditableTextBox_OnMultiLineEditableTextBoxChangedEvent__PythonCallable;
	static C(Other: UObject | any): MultiLineEditableTextBox_OnMultiLineEditableTextBoxChangedEvent__PythonCallable;
}

declare class MultiLineEditableTextBox_OnMultiLineEditableTextBoxCommittedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MultiLineEditableTextBox_OnMultiLineEditableTextBoxCommittedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MultiLineEditableTextBox_OnMultiLineEditableTextBoxCommittedEvent__PythonCallable;
	static GetDefaultObject(): MultiLineEditableTextBox_OnMultiLineEditableTextBoxCommittedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MultiLineEditableTextBox_OnMultiLineEditableTextBoxCommittedEvent__PythonCallable;
	static C(Other: UObject | any): MultiLineEditableTextBox_OnMultiLineEditableTextBoxCommittedEvent__PythonCallable;
}

declare class SlateAccessibleWidgetData_GetText__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SlateAccessibleWidgetData_GetText__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SlateAccessibleWidgetData_GetText__PythonCallable;
	static GetDefaultObject(): SlateAccessibleWidgetData_GetText__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SlateAccessibleWidgetData_GetText__PythonCallable;
	static C(Other: UObject | any): SlateAccessibleWidgetData_GetText__PythonCallable;
}

declare class SpinBox_OnSpinBoxBeginSliderMovement__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
	static GetDefaultObject(): SpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
	static C(Other: UObject | any): SpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
}

declare class SpinBox_OnSpinBoxValueChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
	static GetDefaultObject(): SpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
	static C(Other: UObject | any): SpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
}

declare class SpinBox_OnSpinBoxValueCommittedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
	static GetDefaultObject(): SpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
	static C(Other: UObject | any): SpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
}

declare class WidgetLibrary_OnGameWindowCloseButtonClickedDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): WidgetLibrary_OnGameWindowCloseButtonClickedDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): WidgetLibrary_OnGameWindowCloseButtonClickedDelegate__PythonCallable;
	static GetDefaultObject(): WidgetLibrary_OnGameWindowCloseButtonClickedDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WidgetLibrary_OnGameWindowCloseButtonClickedDelegate__PythonCallable;
	static C(Other: UObject | any): WidgetLibrary_OnGameWindowCloseButtonClickedDelegate__PythonCallable;
}

declare class OnNotifyReplaced__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnNotifyReplaced__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnNotifyReplaced__PythonCallable;
	static GetDefaultObject(): OnNotifyReplaced__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnNotifyReplaced__PythonCallable;
	static C(Other: UObject | any): OnNotifyReplaced__PythonCallable;
}

declare class OnNotifyStateReplaced__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnNotifyStateReplaced__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnNotifyStateReplaced__PythonCallable;
	static GetDefaultObject(): OnNotifyStateReplaced__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnNotifyStateReplaced__PythonCallable;
	static C(Other: UObject | any): OnNotifyStateReplaced__PythonCallable;
}

declare class OnMontagePlayDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMontagePlayDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMontagePlayDelegate__PythonCallable;
	static GetDefaultObject(): OnMontagePlayDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMontagePlayDelegate__PythonCallable;
	static C(Other: UObject | any): OnMontagePlayDelegate__PythonCallable;
}

declare class MovieSceneActorPredictionFailure__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MovieSceneActorPredictionFailure__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MovieSceneActorPredictionFailure__PythonCallable;
	static GetDefaultObject(): MovieSceneActorPredictionFailure__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneActorPredictionFailure__PythonCallable;
	static C(Other: UObject | any): MovieSceneActorPredictionFailure__PythonCallable;
}

declare class MovieSceneActorPredictionResult__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): MovieSceneActorPredictionResult__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): MovieSceneActorPredictionResult__PythonCallable;
	static GetDefaultObject(): MovieSceneActorPredictionResult__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneActorPredictionResult__PythonCallable;
	static C(Other: UObject | any): MovieSceneActorPredictionResult__PythonCallable;
}

declare class OnMovieSceneSequencePlayerEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMovieSceneSequencePlayerEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMovieSceneSequencePlayerEvent__PythonCallable;
	static GetDefaultObject(): OnMovieSceneSequencePlayerEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMovieSceneSequencePlayerEvent__PythonCallable;
	static C(Other: UObject | any): OnMovieSceneSequencePlayerEvent__PythonCallable;
}

declare class OnAudioDefaultDeviceChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioDefaultDeviceChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioDefaultDeviceChanged__PythonCallable;
	static GetDefaultObject(): OnAudioDefaultDeviceChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioDefaultDeviceChanged__PythonCallable;
	static C(Other: UObject | any): OnAudioDefaultDeviceChanged__PythonCallable;
}

declare class OnAudioDeviceChange__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioDeviceChange__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioDeviceChange__PythonCallable;
	static GetDefaultObject(): OnAudioDeviceChange__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioDeviceChange__PythonCallable;
	static C(Other: UObject | any): OnAudioDeviceChange__PythonCallable;
}

declare class OnAudioDeviceStateChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioDeviceStateChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioDeviceStateChanged__PythonCallable;
	static GetDefaultObject(): OnAudioDeviceStateChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioDeviceStateChanged__PythonCallable;
	static C(Other: UObject | any): OnAudioDeviceStateChanged__PythonCallable;
}

declare class OnAudioOutputDevicesObtained__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioOutputDevicesObtained__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioOutputDevicesObtained__PythonCallable;
	static GetDefaultObject(): OnAudioOutputDevicesObtained__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioOutputDevicesObtained__PythonCallable;
	static C(Other: UObject | any): OnAudioOutputDevicesObtained__PythonCallable;
}

declare class OnCompletedDeviceSwap__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnCompletedDeviceSwap__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnCompletedDeviceSwap__PythonCallable;
	static GetDefaultObject(): OnCompletedDeviceSwap__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnCompletedDeviceSwap__PythonCallable;
	static C(Other: UObject | any): OnCompletedDeviceSwap__PythonCallable;
}

declare class OnMainAudioOutputDeviceObtained__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMainAudioOutputDeviceObtained__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMainAudioOutputDeviceObtained__PythonCallable;
	static GetDefaultObject(): OnMainAudioOutputDeviceObtained__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMainAudioOutputDeviceObtained__PythonCallable;
	static C(Other: UObject | any): OnMainAudioOutputDeviceObtained__PythonCallable;
}

declare class OnSoundLoadComplete__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSoundLoadComplete__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSoundLoadComplete__PythonCallable;
	static GetDefaultObject(): OnSoundLoadComplete__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSoundLoadComplete__PythonCallable;
	static C(Other: UObject | any): OnSoundLoadComplete__PythonCallable;
}

declare class OnSynthEnvelopeValue__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSynthEnvelopeValue__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSynthEnvelopeValue__PythonCallable;
	static GetDefaultObject(): OnSynthEnvelopeValue__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSynthEnvelopeValue__PythonCallable;
	static C(Other: UObject | any): OnSynthEnvelopeValue__PythonCallable;
}

declare class OnMediaPlayerMediaEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMediaPlayerMediaEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMediaPlayerMediaEvent__PythonCallable;
	static GetDefaultObject(): OnMediaPlayerMediaEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMediaPlayerMediaEvent__PythonCallable;
	static C(Other: UObject | any): OnMediaPlayerMediaEvent__PythonCallable;
}

declare class OnMediaPlayerMediaOpened__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMediaPlayerMediaOpened__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMediaPlayerMediaOpened__PythonCallable;
	static GetDefaultObject(): OnMediaPlayerMediaOpened__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMediaPlayerMediaOpened__PythonCallable;
	static C(Other: UObject | any): OnMediaPlayerMediaOpened__PythonCallable;
}

declare class OnMediaPlayerMediaOpenFailed__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMediaPlayerMediaOpenFailed__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMediaPlayerMediaOpenFailed__PythonCallable;
	static GetDefaultObject(): OnMediaPlayerMediaOpenFailed__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMediaPlayerMediaOpenFailed__PythonCallable;
	static C(Other: UObject | any): OnMediaPlayerMediaOpenFailed__PythonCallable;
}

declare class EditorAssetSubsystem_OnExtractAssetFromFileDynamic__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EditorAssetSubsystem_OnExtractAssetFromFileDynamic__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EditorAssetSubsystem_OnExtractAssetFromFileDynamic__PythonCallable;
	static GetDefaultObject(): EditorAssetSubsystem_OnExtractAssetFromFileDynamic__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorAssetSubsystem_OnExtractAssetFromFileDynamic__PythonCallable;
	static C(Other: UObject | any): EditorAssetSubsystem_OnExtractAssetFromFileDynamic__PythonCallable;
}

declare class ImportSubsystem_OnAssetPostImport_Dyn__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ImportSubsystem_OnAssetPostImport_Dyn__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ImportSubsystem_OnAssetPostImport_Dyn__PythonCallable;
	static GetDefaultObject(): ImportSubsystem_OnAssetPostImport_Dyn__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ImportSubsystem_OnAssetPostImport_Dyn__PythonCallable;
	static C(Other: UObject | any): ImportSubsystem_OnAssetPostImport_Dyn__PythonCallable;
}

declare class ImportSubsystem_OnAssetPostLODImport_Dyn__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ImportSubsystem_OnAssetPostLODImport_Dyn__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ImportSubsystem_OnAssetPostLODImport_Dyn__PythonCallable;
	static GetDefaultObject(): ImportSubsystem_OnAssetPostLODImport_Dyn__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ImportSubsystem_OnAssetPostLODImport_Dyn__PythonCallable;
	static C(Other: UObject | any): ImportSubsystem_OnAssetPostLODImport_Dyn__PythonCallable;
}

declare class ImportSubsystem_OnAssetPreImport_Dyn__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ImportSubsystem_OnAssetPreImport_Dyn__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ImportSubsystem_OnAssetPreImport_Dyn__PythonCallable;
	static GetDefaultObject(): ImportSubsystem_OnAssetPreImport_Dyn__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ImportSubsystem_OnAssetPreImport_Dyn__PythonCallable;
	static C(Other: UObject | any): ImportSubsystem_OnAssetPreImport_Dyn__PythonCallable;
}

declare class ImportSubsystem_OnAssetReimport_Dyn__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ImportSubsystem_OnAssetReimport_Dyn__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ImportSubsystem_OnAssetReimport_Dyn__PythonCallable;
	static GetDefaultObject(): ImportSubsystem_OnAssetReimport_Dyn__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ImportSubsystem_OnAssetReimport_Dyn__PythonCallable;
	static C(Other: UObject | any): ImportSubsystem_OnAssetReimport_Dyn__PythonCallable;
}

declare class OnDeleteActorsBegin__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnDeleteActorsBegin__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnDeleteActorsBegin__PythonCallable;
	static GetDefaultObject(): OnDeleteActorsBegin__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnDeleteActorsBegin__PythonCallable;
	static C(Other: UObject | any): OnDeleteActorsBegin__PythonCallable;
}

declare class OnDeleteActorsEnd__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnDeleteActorsEnd__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnDeleteActorsEnd__PythonCallable;
	static GetDefaultObject(): OnDeleteActorsEnd__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnDeleteActorsEnd__PythonCallable;
	static C(Other: UObject | any): OnDeleteActorsEnd__PythonCallable;
}

declare class OnDuplicateActorsBegin__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnDuplicateActorsBegin__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnDuplicateActorsBegin__PythonCallable;
	static GetDefaultObject(): OnDuplicateActorsBegin__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnDuplicateActorsBegin__PythonCallable;
	static C(Other: UObject | any): OnDuplicateActorsBegin__PythonCallable;
}

declare class OnDuplicateActorsEnd__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnDuplicateActorsEnd__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnDuplicateActorsEnd__PythonCallable;
	static GetDefaultObject(): OnDuplicateActorsEnd__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnDuplicateActorsEnd__PythonCallable;
	static C(Other: UObject | any): OnDuplicateActorsEnd__PythonCallable;
}

declare class OnEditCopyActorsBegin__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnEditCopyActorsBegin__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnEditCopyActorsBegin__PythonCallable;
	static GetDefaultObject(): OnEditCopyActorsBegin__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnEditCopyActorsBegin__PythonCallable;
	static C(Other: UObject | any): OnEditCopyActorsBegin__PythonCallable;
}

declare class OnEditCopyActorsEnd__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnEditCopyActorsEnd__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnEditCopyActorsEnd__PythonCallable;
	static GetDefaultObject(): OnEditCopyActorsEnd__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnEditCopyActorsEnd__PythonCallable;
	static C(Other: UObject | any): OnEditCopyActorsEnd__PythonCallable;
}

declare class OnEditCutActorsBegin__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnEditCutActorsBegin__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnEditCutActorsBegin__PythonCallable;
	static GetDefaultObject(): OnEditCutActorsBegin__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnEditCutActorsBegin__PythonCallable;
	static C(Other: UObject | any): OnEditCutActorsBegin__PythonCallable;
}

declare class OnEditCutActorsEnd__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnEditCutActorsEnd__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnEditCutActorsEnd__PythonCallable;
	static GetDefaultObject(): OnEditCutActorsEnd__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnEditCutActorsEnd__PythonCallable;
	static C(Other: UObject | any): OnEditCutActorsEnd__PythonCallable;
}

declare class OnEditPasteActorsBegin__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnEditPasteActorsBegin__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnEditPasteActorsBegin__PythonCallable;
	static GetDefaultObject(): OnEditPasteActorsBegin__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnEditPasteActorsBegin__PythonCallable;
	static C(Other: UObject | any): OnEditPasteActorsBegin__PythonCallable;
}

declare class OnEditPasteActorsEnd__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnEditPasteActorsEnd__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnEditPasteActorsEnd__PythonCallable;
	static GetDefaultObject(): OnEditPasteActorsEnd__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnEditPasteActorsEnd__PythonCallable;
	static C(Other: UObject | any): OnEditPasteActorsEnd__PythonCallable;
}

declare class InstancePointDamageSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InstancePointDamageSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InstancePointDamageSignature__PythonCallable;
	static GetDefaultObject(): InstancePointDamageSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InstancePointDamageSignature__PythonCallable;
	static C(Other: UObject | any): InstancePointDamageSignature__PythonCallable;
}

declare class InstanceRadialDamageSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InstanceRadialDamageSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InstanceRadialDamageSignature__PythonCallable;
	static GetDefaultObject(): InstanceRadialDamageSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InstanceRadialDamageSignature__PythonCallable;
	static C(Other: UObject | any): InstanceRadialDamageSignature__PythonCallable;
}

declare class OnImageWriteComplete__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnImageWriteComplete__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnImageWriteComplete__PythonCallable;
	static GetDefaultObject(): OnImageWriteComplete__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnImageWriteComplete__PythonCallable;
	static C(Other: UObject | any): OnImageWriteComplete__PythonCallable;
}

declare class OnChaosPhysicsCollision__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnChaosPhysicsCollision__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnChaosPhysicsCollision__PythonCallable;
	static GetDefaultObject(): OnChaosPhysicsCollision__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnChaosPhysicsCollision__PythonCallable;
	static C(Other: UObject | any): OnChaosPhysicsCollision__PythonCallable;
}

declare class OnChaosBreakEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnChaosBreakEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnChaosBreakEvent__PythonCallable;
	static GetDefaultObject(): OnChaosBreakEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnChaosBreakEvent__PythonCallable;
	static C(Other: UObject | any): OnChaosBreakEvent__PythonCallable;
}

declare class OnChaosBreakingEvents__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnChaosBreakingEvents__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnChaosBreakingEvents__PythonCallable;
	static GetDefaultObject(): OnChaosBreakingEvents__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnChaosBreakingEvents__PythonCallable;
	static C(Other: UObject | any): OnChaosBreakingEvents__PythonCallable;
}

declare class OnChaosCollisionEvents__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnChaosCollisionEvents__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnChaosCollisionEvents__PythonCallable;
	static GetDefaultObject(): OnChaosCollisionEvents__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnChaosCollisionEvents__PythonCallable;
	static C(Other: UObject | any): OnChaosCollisionEvents__PythonCallable;
}

declare class OnChaosCrumblingEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnChaosCrumblingEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnChaosCrumblingEvent__PythonCallable;
	static GetDefaultObject(): OnChaosCrumblingEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnChaosCrumblingEvent__PythonCallable;
	static C(Other: UObject | any): OnChaosCrumblingEvent__PythonCallable;
}

declare class OnChaosRemovalEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnChaosRemovalEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnChaosRemovalEvent__PythonCallable;
	static GetDefaultObject(): OnChaosRemovalEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnChaosRemovalEvent__PythonCallable;
	static C(Other: UObject | any): OnChaosRemovalEvent__PythonCallable;
}

declare class OnChaosRemovalEvents__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnChaosRemovalEvents__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnChaosRemovalEvents__PythonCallable;
	static GetDefaultObject(): OnChaosRemovalEvents__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnChaosRemovalEvents__PythonCallable;
	static C(Other: UObject | any): OnChaosRemovalEvents__PythonCallable;
}

declare class OnChaosTrailingEvents__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnChaosTrailingEvents__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnChaosTrailingEvents__PythonCallable;
	static GetDefaultObject(): OnChaosTrailingEvents__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnChaosTrailingEvents__PythonCallable;
	static C(Other: UObject | any): OnChaosTrailingEvents__PythonCallable;
}

declare class GeometryCollectionComponent_NotifyGeometryCollectionPhysicsLoadingStateChange__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsLoadingStateChange__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsLoadingStateChange__PythonCallable;
	static GetDefaultObject(): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsLoadingStateChange__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsLoadingStateChange__PythonCallable;
	static C(Other: UObject | any): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsLoadingStateChange__PythonCallable;
}

declare class GeometryCollectionComponent_NotifyGeometryCollectionPhysicsStateChange__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsStateChange__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsStateChange__PythonCallable;
	static GetDefaultObject(): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsStateChange__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsStateChange__PythonCallable;
	static C(Other: UObject | any): GeometryCollectionComponent_NotifyGeometryCollectionPhysicsStateChange__PythonCallable;
}

declare class OnNiagaraScriptCompilationComplete__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnNiagaraScriptCompilationComplete__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnNiagaraScriptCompilationComplete__PythonCallable;
	static GetDefaultObject(): OnNiagaraScriptCompilationComplete__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnNiagaraScriptCompilationComplete__PythonCallable;
	static C(Other: UObject | any): OnNiagaraScriptCompilationComplete__PythonCallable;
}

declare class AchievementWriteDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): AchievementWriteDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): AchievementWriteDelegate__PythonCallable;
	static GetDefaultObject(): AchievementWriteDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AchievementWriteDelegate__PythonCallable;
	static C(Other: UObject | any): AchievementWriteDelegate__PythonCallable;
}

declare class BlueprintFindSessionsResultDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): BlueprintFindSessionsResultDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): BlueprintFindSessionsResultDelegate__PythonCallable;
	static GetDefaultObject(): BlueprintFindSessionsResultDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BlueprintFindSessionsResultDelegate__PythonCallable;
	static C(Other: UObject | any): BlueprintFindSessionsResultDelegate__PythonCallable;
}

declare class InAppPurchaseQuery2Result__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InAppPurchaseQuery2Result__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InAppPurchaseQuery2Result__PythonCallable;
	static GetDefaultObject(): InAppPurchaseQuery2Result__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InAppPurchaseQuery2Result__PythonCallable;
	static C(Other: UObject | any): InAppPurchaseQuery2Result__PythonCallable;
}

declare class InAppPurchaseRestoreResult2__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InAppPurchaseRestoreResult2__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InAppPurchaseRestoreResult2__PythonCallable;
	static GetDefaultObject(): InAppPurchaseRestoreResult2__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InAppPurchaseRestoreResult2__PythonCallable;
	static C(Other: UObject | any): InAppPurchaseRestoreResult2__PythonCallable;
}

declare class InAppPurchaseResult2__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InAppPurchaseResult2__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InAppPurchaseResult2__PythonCallable;
	static GetDefaultObject(): InAppPurchaseResult2__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InAppPurchaseResult2__PythonCallable;
	static C(Other: UObject | any): InAppPurchaseResult2__PythonCallable;
}

declare class LeaderboardQueryResult__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): LeaderboardQueryResult__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): LeaderboardQueryResult__PythonCallable;
	static GetDefaultObject(): LeaderboardQueryResult__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LeaderboardQueryResult__PythonCallable;
	static C(Other: UObject | any): LeaderboardQueryResult__PythonCallable;
}

declare class OnLeaderboardFlushed__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnLeaderboardFlushed__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnLeaderboardFlushed__PythonCallable;
	static GetDefaultObject(): OnLeaderboardFlushed__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnLeaderboardFlushed__PythonCallable;
	static C(Other: UObject | any): OnLeaderboardFlushed__PythonCallable;
}

declare class OnlineConnectionResult__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnlineConnectionResult__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnlineConnectionResult__PythonCallable;
	static GetDefaultObject(): OnlineConnectionResult__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnlineConnectionResult__PythonCallable;
	static C(Other: UObject | any): OnlineConnectionResult__PythonCallable;
}

declare class OnlineLogoutResult__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnlineLogoutResult__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnlineLogoutResult__PythonCallable;
	static GetDefaultObject(): OnlineLogoutResult__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnlineLogoutResult__PythonCallable;
	static C(Other: UObject | any): OnlineLogoutResult__PythonCallable;
}

declare class OnlineShowLoginUIResult__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnlineShowLoginUIResult__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnlineShowLoginUIResult__PythonCallable;
	static GetDefaultObject(): OnlineShowLoginUIResult__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnlineShowLoginUIResult__PythonCallable;
	static C(Other: UObject | any): OnlineShowLoginUIResult__PythonCallable;
}

declare class OnlineTurnBasedMatchResult__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnlineTurnBasedMatchResult__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnlineTurnBasedMatchResult__PythonCallable;
	static GetDefaultObject(): OnlineTurnBasedMatchResult__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnlineTurnBasedMatchResult__PythonCallable;
	static C(Other: UObject | any): OnlineTurnBasedMatchResult__PythonCallable;
}

declare class SourceControl_QueryFileStateDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): SourceControl_QueryFileStateDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): SourceControl_QueryFileStateDelegate__PythonCallable;
	static GetDefaultObject(): SourceControl_QueryFileStateDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SourceControl_QueryFileStateDelegate__PythonCallable;
	static C(Other: UObject | any): SourceControl_QueryFileStateDelegate__PythonCallable;
}

declare class LevelSequenceActor_OnLevelSequenceLoaded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): LevelSequenceActor_OnLevelSequenceLoaded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): LevelSequenceActor_OnLevelSequenceLoaded__PythonCallable;
	static GetDefaultObject(): LevelSequenceActor_OnLevelSequenceLoaded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelSequenceActor_OnLevelSequenceLoaded__PythonCallable;
	static C(Other: UObject | any): LevelSequenceActor_OnLevelSequenceLoaded__PythonCallable;
}

declare class OnLevelSequencePlayerCameraCutEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnLevelSequencePlayerCameraCutEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnLevelSequencePlayerCameraCutEvent__PythonCallable;
	static GetDefaultObject(): OnLevelSequencePlayerCameraCutEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnLevelSequencePlayerCameraCutEvent__PythonCallable;
	static C(Other: UObject | any): OnLevelSequencePlayerCameraCutEvent__PythonCallable;
}

declare class OnPropertyValueChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPropertyValueChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPropertyValueChanged__PythonCallable;
	static GetDefaultObject(): OnPropertyValueChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPropertyValueChanged__PythonCallable;
	static C(Other: UObject | any): OnPropertyValueChanged__PythonCallable;
}

declare class FunctionalTestAISpawned__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): FunctionalTestAISpawned__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): FunctionalTestAISpawned__PythonCallable;
	static GetDefaultObject(): FunctionalTestAISpawned__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FunctionalTestAISpawned__PythonCallable;
	static C(Other: UObject | any): FunctionalTestAISpawned__PythonCallable;
}

declare class FunctionalTestEventSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): FunctionalTestEventSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): FunctionalTestEventSignature__PythonCallable;
	static GetDefaultObject(): FunctionalTestEventSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FunctionalTestEventSignature__PythonCallable;
	static C(Other: UObject | any): FunctionalTestEventSignature__PythonCallable;
}

declare class EnhancedInputActionHandlerDynamicSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EnhancedInputActionHandlerDynamicSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EnhancedInputActionHandlerDynamicSignature__PythonCallable;
	static GetDefaultObject(): EnhancedInputActionHandlerDynamicSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnhancedInputActionHandlerDynamicSignature__PythonCallable;
	static C(Other: UObject | any): EnhancedInputActionHandlerDynamicSignature__PythonCallable;
}

declare class InputDebugKeyHandlerDynamicSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): InputDebugKeyHandlerDynamicSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): InputDebugKeyHandlerDynamicSignature__PythonCallable;
	static GetDefaultObject(): InputDebugKeyHandlerDynamicSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputDebugKeyHandlerDynamicSignature__PythonCallable;
	static C(Other: UObject | any): InputDebugKeyHandlerDynamicSignature__PythonCallable;
}

declare class EnhancedInputLocalPlayerSubsystem_OnControlMappingsRebuilt__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): EnhancedInputLocalPlayerSubsystem_OnControlMappingsRebuilt__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): EnhancedInputLocalPlayerSubsystem_OnControlMappingsRebuilt__PythonCallable;
	static GetDefaultObject(): EnhancedInputLocalPlayerSubsystem_OnControlMappingsRebuilt__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnhancedInputLocalPlayerSubsystem_OnControlMappingsRebuilt__PythonCallable;
	static C(Other: UObject | any): EnhancedInputLocalPlayerSubsystem_OnControlMappingsRebuilt__PythonCallable;
}

declare class FlipbookFinishedPlaySignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): FlipbookFinishedPlaySignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): FlipbookFinishedPlaySignature__PythonCallable;
	static GetDefaultObject(): FlipbookFinishedPlaySignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FlipbookFinishedPlaySignature__PythonCallable;
	static C(Other: UObject | any): FlipbookFinishedPlaySignature__PythonCallable;
}

declare class RigVMPeformUserWorkflowDynamicDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): RigVMPeformUserWorkflowDynamicDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): RigVMPeformUserWorkflowDynamicDelegate__PythonCallable;
	static GetDefaultObject(): RigVMPeformUserWorkflowDynamicDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RigVMPeformUserWorkflowDynamicDelegate__PythonCallable;
	static C(Other: UObject | any): RigVMPeformUserWorkflowDynamicDelegate__PythonCallable;
}

declare class RigVMGraphModifiedDynamicEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): RigVMGraphModifiedDynamicEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): RigVMGraphModifiedDynamicEvent__PythonCallable;
	static GetDefaultObject(): RigVMGraphModifiedDynamicEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RigVMGraphModifiedDynamicEvent__PythonCallable;
	static C(Other: UObject | any): RigVMGraphModifiedDynamicEvent__PythonCallable;
}

declare class RigVMUserWorkflowProvider__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): RigVMUserWorkflowProvider__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): RigVMUserWorkflowProvider__PythonCallable;
	static GetDefaultObject(): RigVMUserWorkflowProvider__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RigVMUserWorkflowProvider__PythonCallable;
	static C(Other: UObject | any): RigVMUserWorkflowProvider__PythonCallable;
}

declare class ControlRigComponentDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ControlRigComponentDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ControlRigComponentDelegate__PythonCallable;
	static GetDefaultObject(): ControlRigComponentDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ControlRigComponentDelegate__PythonCallable;
	static C(Other: UObject | any): ControlRigComponentDelegate__PythonCallable;
}

declare class OnLatestOverallLoudnessResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnLatestOverallLoudnessResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnLatestOverallLoudnessResults__PythonCallable;
	static GetDefaultObject(): OnLatestOverallLoudnessResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnLatestOverallLoudnessResults__PythonCallable;
	static C(Other: UObject | any): OnLatestOverallLoudnessResults__PythonCallable;
}

declare class OnLatestOverallMeterResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnLatestOverallMeterResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnLatestOverallMeterResults__PythonCallable;
	static GetDefaultObject(): OnLatestOverallMeterResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnLatestOverallMeterResults__PythonCallable;
	static C(Other: UObject | any): OnLatestOverallMeterResults__PythonCallable;
}

declare class OnLatestPerChannelLoudnessResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnLatestPerChannelLoudnessResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnLatestPerChannelLoudnessResults__PythonCallable;
	static GetDefaultObject(): OnLatestPerChannelLoudnessResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnLatestPerChannelLoudnessResults__PythonCallable;
	static C(Other: UObject | any): OnLatestPerChannelLoudnessResults__PythonCallable;
}

declare class OnLatestPerChannelMeterResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnLatestPerChannelMeterResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnLatestPerChannelMeterResults__PythonCallable;
	static GetDefaultObject(): OnLatestPerChannelMeterResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnLatestPerChannelMeterResults__PythonCallable;
	static C(Other: UObject | any): OnLatestPerChannelMeterResults__PythonCallable;
}

declare class OnLatestSpectrumResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnLatestSpectrumResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnLatestSpectrumResults__PythonCallable;
	static GetDefaultObject(): OnLatestSpectrumResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnLatestSpectrumResults__PythonCallable;
	static C(Other: UObject | any): OnLatestSpectrumResults__PythonCallable;
}

declare class OnOverallLoudnessResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnOverallLoudnessResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnOverallLoudnessResults__PythonCallable;
	static GetDefaultObject(): OnOverallLoudnessResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnOverallLoudnessResults__PythonCallable;
	static C(Other: UObject | any): OnOverallLoudnessResults__PythonCallable;
}

declare class OnOverallMeterResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnOverallMeterResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnOverallMeterResults__PythonCallable;
	static GetDefaultObject(): OnOverallMeterResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnOverallMeterResults__PythonCallable;
	static C(Other: UObject | any): OnOverallMeterResults__PythonCallable;
}

declare class OnPerChannelLoudnessResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPerChannelLoudnessResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPerChannelLoudnessResults__PythonCallable;
	static GetDefaultObject(): OnPerChannelLoudnessResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPerChannelLoudnessResults__PythonCallable;
	static C(Other: UObject | any): OnPerChannelLoudnessResults__PythonCallable;
}

declare class OnPerChannelMeterResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnPerChannelMeterResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnPerChannelMeterResults__PythonCallable;
	static GetDefaultObject(): OnPerChannelMeterResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnPerChannelMeterResults__PythonCallable;
	static C(Other: UObject | any): OnPerChannelMeterResults__PythonCallable;
}

declare class OnSpectrumResults__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSpectrumResults__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSpectrumResults__PythonCallable;
	static GetDefaultObject(): OnSpectrumResults__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSpectrumResults__PythonCallable;
	static C(Other: UObject | any): OnSpectrumResults__PythonCallable;
}

declare class LocationServicesData_OnLocationChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): LocationServicesData_OnLocationChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): LocationServicesData_OnLocationChanged__PythonCallable;
	static GetDefaultObject(): LocationServicesData_OnLocationChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LocationServicesData_OnLocationChanged__PythonCallable;
	static C(Other: UObject | any): LocationServicesData_OnLocationChanged__PythonCallable;
}

declare class OnAudioRadialSliderValueChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioRadialSliderValueChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioRadialSliderValueChangedEvent__PythonCallable;
	static GetDefaultObject(): OnAudioRadialSliderValueChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioRadialSliderValueChangedEvent__PythonCallable;
	static C(Other: UObject | any): OnAudioRadialSliderValueChangedEvent__PythonCallable;
}

declare class AudioMeter_GetMeterChannelInfo__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): AudioMeter_GetMeterChannelInfo__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): AudioMeter_GetMeterChannelInfo__PythonCallable;
	static GetDefaultObject(): AudioMeter_GetMeterChannelInfo__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioMeter_GetMeterChannelInfo__PythonCallable;
	static C(Other: UObject | any): AudioMeter_GetMeterChannelInfo__PythonCallable;
}

declare class NumTablesChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): NumTablesChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): NumTablesChanged__PythonCallable;
	static GetDefaultObject(): NumTablesChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NumTablesChanged__PythonCallable;
	static C(Other: UObject | any): NumTablesChanged__PythonCallable;
}

declare class OnControllerCaptureBeginEventSynth2D__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnControllerCaptureBeginEventSynth2D__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnControllerCaptureBeginEventSynth2D__PythonCallable;
	static GetDefaultObject(): OnControllerCaptureBeginEventSynth2D__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnControllerCaptureBeginEventSynth2D__PythonCallable;
	static C(Other: UObject | any): OnControllerCaptureBeginEventSynth2D__PythonCallable;
}

declare class OnControllerCaptureEndEventSynth2D__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnControllerCaptureEndEventSynth2D__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnControllerCaptureEndEventSynth2D__PythonCallable;
	static GetDefaultObject(): OnControllerCaptureEndEventSynth2D__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnControllerCaptureEndEventSynth2D__PythonCallable;
	static C(Other: UObject | any): OnControllerCaptureEndEventSynth2D__PythonCallable;
}

declare class OnEnvelopeFollowerUpdate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnEnvelopeFollowerUpdate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnEnvelopeFollowerUpdate__PythonCallable;
	static GetDefaultObject(): OnEnvelopeFollowerUpdate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnEnvelopeFollowerUpdate__PythonCallable;
	static C(Other: UObject | any): OnEnvelopeFollowerUpdate__PythonCallable;
}

declare class OnFloatValueChangedEventSynth2D__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnFloatValueChangedEventSynth2D__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnFloatValueChangedEventSynth2D__PythonCallable;
	static GetDefaultObject(): OnFloatValueChangedEventSynth2D__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnFloatValueChangedEventSynth2D__PythonCallable;
	static C(Other: UObject | any): OnFloatValueChangedEventSynth2D__PythonCallable;
}

declare class OnMouseCaptureBeginEventSynth2D__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMouseCaptureBeginEventSynth2D__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMouseCaptureBeginEventSynth2D__PythonCallable;
	static GetDefaultObject(): OnMouseCaptureBeginEventSynth2D__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMouseCaptureBeginEventSynth2D__PythonCallable;
	static C(Other: UObject | any): OnMouseCaptureBeginEventSynth2D__PythonCallable;
}

declare class OnMouseCaptureEndEventSynth2D__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnMouseCaptureEndEventSynth2D__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnMouseCaptureEndEventSynth2D__PythonCallable;
	static GetDefaultObject(): OnMouseCaptureEndEventSynth2D__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnMouseCaptureEndEventSynth2D__PythonCallable;
	static C(Other: UObject | any): OnMouseCaptureEndEventSynth2D__PythonCallable;
}

declare class OnSampleLoaded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSampleLoaded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSampleLoaded__PythonCallable;
	static GetDefaultObject(): OnSampleLoaded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSampleLoaded__PythonCallable;
	static C(Other: UObject | any): OnSampleLoaded__PythonCallable;
}

declare class OnSamplePlaybackProgress__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnSamplePlaybackProgress__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnSamplePlaybackProgress__PythonCallable;
	static GetDefaultObject(): OnSamplePlaybackProgress__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnSamplePlaybackProgress__PythonCallable;
	static C(Other: UObject | any): OnSamplePlaybackProgress__PythonCallable;
}

declare class OnTableAltered__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTableAltered__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTableAltered__PythonCallable;
	static GetDefaultObject(): OnTableAltered__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTableAltered__PythonCallable;
	static C(Other: UObject | any): OnTableAltered__PythonCallable;
}

declare class OnTakeRecorderCancelled__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTakeRecorderCancelled__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTakeRecorderCancelled__PythonCallable;
	static GetDefaultObject(): OnTakeRecorderCancelled__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTakeRecorderCancelled__PythonCallable;
	static C(Other: UObject | any): OnTakeRecorderCancelled__PythonCallable;
}

declare class OnTakeRecorderFinished__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTakeRecorderFinished__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTakeRecorderFinished__PythonCallable;
	static GetDefaultObject(): OnTakeRecorderFinished__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTakeRecorderFinished__PythonCallable;
	static C(Other: UObject | any): OnTakeRecorderFinished__PythonCallable;
}

declare class OnTakeRecorderMarkedFrameAdded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTakeRecorderMarkedFrameAdded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTakeRecorderMarkedFrameAdded__PythonCallable;
	static GetDefaultObject(): OnTakeRecorderMarkedFrameAdded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTakeRecorderMarkedFrameAdded__PythonCallable;
	static C(Other: UObject | any): OnTakeRecorderMarkedFrameAdded__PythonCallable;
}

declare class OnTakeRecorderPanelChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTakeRecorderPanelChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTakeRecorderPanelChanged__PythonCallable;
	static GetDefaultObject(): OnTakeRecorderPanelChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTakeRecorderPanelChanged__PythonCallable;
	static C(Other: UObject | any): OnTakeRecorderPanelChanged__PythonCallable;
}

declare class OnTakeRecorderPreInitialize__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTakeRecorderPreInitialize__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTakeRecorderPreInitialize__PythonCallable;
	static GetDefaultObject(): OnTakeRecorderPreInitialize__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTakeRecorderPreInitialize__PythonCallable;
	static C(Other: UObject | any): OnTakeRecorderPreInitialize__PythonCallable;
}

declare class OnTakeRecorderStarted__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTakeRecorderStarted__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTakeRecorderStarted__PythonCallable;
	static GetDefaultObject(): OnTakeRecorderStarted__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTakeRecorderStarted__PythonCallable;
	static C(Other: UObject | any): OnTakeRecorderStarted__PythonCallable;
}

declare class OnTakeRecorderStopped__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnTakeRecorderStopped__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnTakeRecorderStopped__PythonCallable;
	static GetDefaultObject(): OnTakeRecorderStopped__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnTakeRecorderStopped__PythonCallable;
	static C(Other: UObject | any): OnTakeRecorderStopped__PythonCallable;
}

declare class TakesCoreBlueprintLibrary_OnTakeRecorderSlateChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TakesCoreBlueprintLibrary_OnTakeRecorderSlateChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TakesCoreBlueprintLibrary_OnTakeRecorderSlateChanged__PythonCallable;
	static GetDefaultObject(): TakesCoreBlueprintLibrary_OnTakeRecorderSlateChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakesCoreBlueprintLibrary_OnTakeRecorderSlateChanged__PythonCallable;
	static C(Other: UObject | any): TakesCoreBlueprintLibrary_OnTakeRecorderSlateChanged__PythonCallable;
}

declare class TakesCoreBlueprintLibrary_OnTakeRecorderTakeNumberChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TakesCoreBlueprintLibrary_OnTakeRecorderTakeNumberChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TakesCoreBlueprintLibrary_OnTakeRecorderTakeNumberChanged__PythonCallable;
	static GetDefaultObject(): TakesCoreBlueprintLibrary_OnTakeRecorderTakeNumberChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakesCoreBlueprintLibrary_OnTakeRecorderTakeNumberChanged__PythonCallable;
	static C(Other: UObject | any): TakesCoreBlueprintLibrary_OnTakeRecorderTakeNumberChanged__PythonCallable;
}

declare class PyTestDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PyTestDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PyTestDelegate__PythonCallable;
	static GetDefaultObject(): PyTestDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestDelegate__PythonCallable;
	static C(Other: UObject | any): PyTestDelegate__PythonCallable;
}

declare class PyTestMulticastDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PyTestMulticastDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PyTestMulticastDelegate__PythonCallable;
	static GetDefaultObject(): PyTestMulticastDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestMulticastDelegate__PythonCallable;
	static C(Other: UObject | any): PyTestMulticastDelegate__PythonCallable;
}

declare class PyTestSlateTickDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PyTestSlateTickDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PyTestSlateTickDelegate__PythonCallable;
	static GetDefaultObject(): PyTestSlateTickDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestSlateTickDelegate__PythonCallable;
	static C(Other: UObject | any): PyTestSlateTickDelegate__PythonCallable;
}

declare class PyTestStructDelegate_OnNameCollisionDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PyTestStructDelegate_OnNameCollisionDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PyTestStructDelegate_OnNameCollisionDelegate__PythonCallable;
	static GetDefaultObject(): PyTestStructDelegate_OnNameCollisionDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestStructDelegate_OnNameCollisionDelegate__PythonCallable;
	static C(Other: UObject | any): PyTestStructDelegate_OnNameCollisionDelegate__PythonCallable;
}

declare class PyTestVectorDelegate_OnNameCollisionDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PyTestVectorDelegate_OnNameCollisionDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PyTestVectorDelegate_OnNameCollisionDelegate__PythonCallable;
	static GetDefaultObject(): PyTestVectorDelegate_OnNameCollisionDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PyTestVectorDelegate_OnNameCollisionDelegate__PythonCallable;
	static C(Other: UObject | any): PyTestVectorDelegate_OnNameCollisionDelegate__PythonCallable;
}

declare class ActorComponentDeactivateSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorComponentDeactivateSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorComponentDeactivateSignature__PythonCallable;
	static GetDefaultObject(): ActorComponentDeactivateSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorComponentDeactivateSignature__PythonCallable;
	static C(Other: UObject | any): ActorComponentDeactivateSignature__PythonCallable;
}

declare class ActorComponentActivatedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorComponentActivatedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorComponentActivatedSignature__PythonCallable;
	static GetDefaultObject(): ActorComponentActivatedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorComponentActivatedSignature__PythonCallable;
	static C(Other: UObject | any): ActorComponentActivatedSignature__PythonCallable;
}

declare class ActorBeginCursorOverSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorBeginCursorOverSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorBeginCursorOverSignature__PythonCallable;
	static GetDefaultObject(): ActorBeginCursorOverSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorBeginCursorOverSignature__PythonCallable;
	static C(Other: UObject | any): ActorBeginCursorOverSignature__PythonCallable;
}

declare class ActorBeginOverlapSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorBeginOverlapSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorBeginOverlapSignature__PythonCallable;
	static GetDefaultObject(): ActorBeginOverlapSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorBeginOverlapSignature__PythonCallable;
	static C(Other: UObject | any): ActorBeginOverlapSignature__PythonCallable;
}

declare class ActorBeginTouchOverSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorBeginTouchOverSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorBeginTouchOverSignature__PythonCallable;
	static GetDefaultObject(): ActorBeginTouchOverSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorBeginTouchOverSignature__PythonCallable;
	static C(Other: UObject | any): ActorBeginTouchOverSignature__PythonCallable;
}

declare class ActorDestroyedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorDestroyedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorDestroyedSignature__PythonCallable;
	static GetDefaultObject(): ActorDestroyedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorDestroyedSignature__PythonCallable;
	static C(Other: UObject | any): ActorDestroyedSignature__PythonCallable;
}

declare class ActorEndCursorOverSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorEndCursorOverSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorEndCursorOverSignature__PythonCallable;
	static GetDefaultObject(): ActorEndCursorOverSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorEndCursorOverSignature__PythonCallable;
	static C(Other: UObject | any): ActorEndCursorOverSignature__PythonCallable;
}

declare class ActorEndOverlapSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorEndOverlapSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorEndOverlapSignature__PythonCallable;
	static GetDefaultObject(): ActorEndOverlapSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorEndOverlapSignature__PythonCallable;
	static C(Other: UObject | any): ActorEndOverlapSignature__PythonCallable;
}

declare class ActorEndPlaySignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorEndPlaySignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorEndPlaySignature__PythonCallable;
	static GetDefaultObject(): ActorEndPlaySignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorEndPlaySignature__PythonCallable;
	static C(Other: UObject | any): ActorEndPlaySignature__PythonCallable;
}

declare class ActorEndTouchOverSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorEndTouchOverSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorEndTouchOverSignature__PythonCallable;
	static GetDefaultObject(): ActorEndTouchOverSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorEndTouchOverSignature__PythonCallable;
	static C(Other: UObject | any): ActorEndTouchOverSignature__PythonCallable;
}

declare class ActorHitSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorHitSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorHitSignature__PythonCallable;
	static GetDefaultObject(): ActorHitSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorHitSignature__PythonCallable;
	static C(Other: UObject | any): ActorHitSignature__PythonCallable;
}

declare class ActorOnClickedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorOnClickedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorOnClickedSignature__PythonCallable;
	static GetDefaultObject(): ActorOnClickedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorOnClickedSignature__PythonCallable;
	static C(Other: UObject | any): ActorOnClickedSignature__PythonCallable;
}

declare class ActorOnInputTouchBeginSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorOnInputTouchBeginSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorOnInputTouchBeginSignature__PythonCallable;
	static GetDefaultObject(): ActorOnInputTouchBeginSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorOnInputTouchBeginSignature__PythonCallable;
	static C(Other: UObject | any): ActorOnInputTouchBeginSignature__PythonCallable;
}

declare class ActorOnInputTouchEndSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorOnInputTouchEndSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorOnInputTouchEndSignature__PythonCallable;
	static GetDefaultObject(): ActorOnInputTouchEndSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorOnInputTouchEndSignature__PythonCallable;
	static C(Other: UObject | any): ActorOnInputTouchEndSignature__PythonCallable;
}

declare class ActorOnReleasedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ActorOnReleasedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ActorOnReleasedSignature__PythonCallable;
	static GetDefaultObject(): ActorOnReleasedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorOnReleasedSignature__PythonCallable;
	static C(Other: UObject | any): ActorOnReleasedSignature__PythonCallable;
}

declare class ComponentBeginCursorOverSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentBeginCursorOverSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentBeginCursorOverSignature__PythonCallable;
	static GetDefaultObject(): ComponentBeginCursorOverSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentBeginCursorOverSignature__PythonCallable;
	static C(Other: UObject | any): ComponentBeginCursorOverSignature__PythonCallable;
}

declare class ComponentBeginOverlapSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentBeginOverlapSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentBeginOverlapSignature__PythonCallable;
	static GetDefaultObject(): ComponentBeginOverlapSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentBeginOverlapSignature__PythonCallable;
	static C(Other: UObject | any): ComponentBeginOverlapSignature__PythonCallable;
}

declare class ComponentBeginTouchOverSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentBeginTouchOverSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentBeginTouchOverSignature__PythonCallable;
	static GetDefaultObject(): ComponentBeginTouchOverSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentBeginTouchOverSignature__PythonCallable;
	static C(Other: UObject | any): ComponentBeginTouchOverSignature__PythonCallable;
}

declare class ComponentCollisionSettingsChangedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentCollisionSettingsChangedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentCollisionSettingsChangedSignature__PythonCallable;
	static GetDefaultObject(): ComponentCollisionSettingsChangedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentCollisionSettingsChangedSignature__PythonCallable;
	static C(Other: UObject | any): ComponentCollisionSettingsChangedSignature__PythonCallable;
}

declare class ComponentEndCursorOverSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentEndCursorOverSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentEndCursorOverSignature__PythonCallable;
	static GetDefaultObject(): ComponentEndCursorOverSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentEndCursorOverSignature__PythonCallable;
	static C(Other: UObject | any): ComponentEndCursorOverSignature__PythonCallable;
}

declare class ComponentEndOverlapSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentEndOverlapSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentEndOverlapSignature__PythonCallable;
	static GetDefaultObject(): ComponentEndOverlapSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentEndOverlapSignature__PythonCallable;
	static C(Other: UObject | any): ComponentEndOverlapSignature__PythonCallable;
}

declare class ComponentEndTouchOverSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentEndTouchOverSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentEndTouchOverSignature__PythonCallable;
	static GetDefaultObject(): ComponentEndTouchOverSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentEndTouchOverSignature__PythonCallable;
	static C(Other: UObject | any): ComponentEndTouchOverSignature__PythonCallable;
}

declare class ComponentHitSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentHitSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentHitSignature__PythonCallable;
	static GetDefaultObject(): ComponentHitSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentHitSignature__PythonCallable;
	static C(Other: UObject | any): ComponentHitSignature__PythonCallable;
}

declare class ComponentOnClickedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentOnClickedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentOnClickedSignature__PythonCallable;
	static GetDefaultObject(): ComponentOnClickedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentOnClickedSignature__PythonCallable;
	static C(Other: UObject | any): ComponentOnClickedSignature__PythonCallable;
}

declare class ComponentOnInputTouchBeginSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentOnInputTouchBeginSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentOnInputTouchBeginSignature__PythonCallable;
	static GetDefaultObject(): ComponentOnInputTouchBeginSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentOnInputTouchBeginSignature__PythonCallable;
	static C(Other: UObject | any): ComponentOnInputTouchBeginSignature__PythonCallable;
}

declare class ComponentOnInputTouchEndSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentOnInputTouchEndSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentOnInputTouchEndSignature__PythonCallable;
	static GetDefaultObject(): ComponentOnInputTouchEndSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentOnInputTouchEndSignature__PythonCallable;
	static C(Other: UObject | any): ComponentOnInputTouchEndSignature__PythonCallable;
}

declare class ComponentOnReleasedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentOnReleasedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentOnReleasedSignature__PythonCallable;
	static GetDefaultObject(): ComponentOnReleasedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentOnReleasedSignature__PythonCallable;
	static C(Other: UObject | any): ComponentOnReleasedSignature__PythonCallable;
}

declare class ComponentPhysicsStateChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentPhysicsStateChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentPhysicsStateChanged__PythonCallable;
	static GetDefaultObject(): ComponentPhysicsStateChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentPhysicsStateChanged__PythonCallable;
	static C(Other: UObject | any): ComponentPhysicsStateChanged__PythonCallable;
}

declare class ComponentSleepSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentSleepSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentSleepSignature__PythonCallable;
	static GetDefaultObject(): ComponentSleepSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentSleepSignature__PythonCallable;
	static C(Other: UObject | any): ComponentSleepSignature__PythonCallable;
}

declare class ComponentWakeSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ComponentWakeSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ComponentWakeSignature__PythonCallable;
	static GetDefaultObject(): ComponentWakeSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ComponentWakeSignature__PythonCallable;
	static C(Other: UObject | any): ComponentWakeSignature__PythonCallable;
}

declare class IsRootComponentChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): IsRootComponentChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): IsRootComponentChanged__PythonCallable;
	static GetDefaultObject(): IsRootComponentChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): IsRootComponentChanged__PythonCallable;
	static C(Other: UObject | any): IsRootComponentChanged__PythonCallable;
}

declare class PawnControllerChangedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PawnControllerChangedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PawnControllerChangedSignature__PythonCallable;
	static GetDefaultObject(): PawnControllerChangedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PawnControllerChangedSignature__PythonCallable;
	static C(Other: UObject | any): PawnControllerChangedSignature__PythonCallable;
}

declare class PawnRestartedSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PawnRestartedSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PawnRestartedSignature__PythonCallable;
	static GetDefaultObject(): PawnRestartedSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PawnRestartedSignature__PythonCallable;
	static C(Other: UObject | any): PawnRestartedSignature__PythonCallable;
}

declare class PhysicsVolumeChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): PhysicsVolumeChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): PhysicsVolumeChanged__PythonCallable;
	static GetDefaultObject(): PhysicsVolumeChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PhysicsVolumeChanged__PythonCallable;
	static C(Other: UObject | any): PhysicsVolumeChanged__PythonCallable;
}

declare class TakeAnyDamageSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TakeAnyDamageSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TakeAnyDamageSignature__PythonCallable;
	static GetDefaultObject(): TakeAnyDamageSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeAnyDamageSignature__PythonCallable;
	static C(Other: UObject | any): TakeAnyDamageSignature__PythonCallable;
}

declare class TakePointDamageSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TakePointDamageSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TakePointDamageSignature__PythonCallable;
	static GetDefaultObject(): TakePointDamageSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakePointDamageSignature__PythonCallable;
	static C(Other: UObject | any): TakePointDamageSignature__PythonCallable;
}

declare class TakeRadialDamageSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): TakeRadialDamageSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): TakeRadialDamageSignature__PythonCallable;
	static GetDefaultObject(): TakeRadialDamageSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRadialDamageSignature__PythonCallable;
	static C(Other: UObject | any): TakeRadialDamageSignature__PythonCallable;
}

declare class ConstraintsManager_OnConstraintAdded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ConstraintsManager_OnConstraintAdded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ConstraintsManager_OnConstraintAdded__PythonCallable;
	static GetDefaultObject(): ConstraintsManager_OnConstraintAdded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ConstraintsManager_OnConstraintAdded__PythonCallable;
	static C(Other: UObject | any): ConstraintsManager_OnConstraintAdded__PythonCallable;
}

declare class ConstraintsManager_OnConstraintRemoved__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ConstraintsManager_OnConstraintRemoved__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ConstraintsManager_OnConstraintRemoved__PythonCallable;
	static GetDefaultObject(): ConstraintsManager_OnConstraintRemoved__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ConstraintsManager_OnConstraintRemoved__PythonCallable;
	static C(Other: UObject | any): ConstraintsManager_OnConstraintRemoved__PythonCallable;
}

declare class ControlRig_OnControlSelectedBP__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): ControlRig_OnControlSelectedBP__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): ControlRig_OnControlSelectedBP__PythonCallable;
	static GetDefaultObject(): ControlRig_OnControlSelectedBP__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ControlRig_OnControlSelectedBP__PythonCallable;
	static C(Other: UObject | any): ControlRig_OnControlSelectedBP__PythonCallable;
}

declare class EdGraphNode_Reference extends EdGraphNode { 
	static Load(ResourceName: string): EdGraphNode_Reference;
	static Find(Outer: UObject, ResourceName: string): EdGraphNode_Reference;
	static GetDefaultObject(): EdGraphNode_Reference;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdGraphNode_Reference;
	static C(Other: UObject | any): EdGraphNode_Reference;
}

declare class EdGraph_ReferenceViewer extends EdGraph { 
	static Load(ResourceName: string): EdGraph_ReferenceViewer;
	static Find(Outer: UObject, ResourceName: string): EdGraph_ReferenceViewer;
	static GetDefaultObject(): EdGraph_ReferenceViewer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdGraph_ReferenceViewer;
	static C(Other: UObject | any): EdGraph_ReferenceViewer;
}

declare class ReferenceViewerSchema extends EdGraphSchema { 
	static Load(ResourceName: string): ReferenceViewerSchema;
	static Find(Outer: UObject, ResourceName: string): ReferenceViewerSchema;
	static GetDefaultObject(): ReferenceViewerSchema;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ReferenceViewerSchema;
	static C(Other: UObject | any): ReferenceViewerSchema;
}

declare class ilterState { 
	FilterPath: TopLevelAssetPath;
	bIsEnabled: boolean;
	clone() : ilterState;
	static C(Other: UObject | any): ilterState;
}

declare class ReferenceViewerSettings extends UObject { 
	bLimitSearchDepth: boolean;
	bIsShowReferencers: boolean;
	MaxSearchReferencerDepth: number;
	bIsShowDependencies: boolean;
	MaxSearchDependencyDepth: number;
	bLimitSearchBreadth: boolean;
	MaxSearchBreadth: number;
	bEnableCollectionFilter: boolean;
	bIsShowSoftReferences: boolean;
	bIsShowHardReferences: boolean;
	bIsShowEditorOnlyReferences: boolean;
	bIsShowManagementReferences: boolean;
	bIsShowSearchableNames: boolean;
	bIsShowCodePackages: boolean;
	bIsShowDuplicates: boolean;
	bIsShowFilteredPackagesOnly: boolean;
	bIsCompactMode: boolean;
	bIsShowPath: boolean;
	bFiltersEnabled: boolean;
	bAutoUpdateFilters: boolean;
	UserFilters: ilterState[];
	static Load(ResourceName: string): ReferenceViewerSettings;
	static Find(Outer: UObject, ResourceName: string): ReferenceViewerSettings;
	static GetDefaultObject(): ReferenceViewerSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ReferenceViewerSettings;
	static C(Other: UObject | any): ReferenceViewerSettings;
}

declare class TcpMessagingSettings extends UObject { 
	EnableTransport: boolean;
	ListenEndpoint: string;
	ConnectToEndpoints: string[];
	ConnectionRetryDelay: number;
	ConnectionRetryPeriod: number;
	bStopServiceWhenAppDeactivates: boolean;
	static Load(ResourceName: string): TcpMessagingSettings;
	static Find(Outer: UObject, ResourceName: string): TcpMessagingSettings;
	static GetDefaultObject(): TcpMessagingSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TcpMessagingSettings;
	static C(Other: UObject | any): TcpMessagingSettings;
}

declare type EUdpMessageFormat = 'None' | 'Json' | 'TaggedProperty' | 'CborPlatformEndianness' | 'CborStandardEndianness' | 'EUdpMessageFormat_MAX';
declare var EUdpMessageFormat : { None:'None',Json:'Json',TaggedProperty:'TaggedProperty',CborPlatformEndianness:'CborPlatformEndianness',CborStandardEndianness:'CborStandardEndianness',EUdpMessageFormat_MAX:'EUdpMessageFormat_MAX', };
declare class UdpMessagingSettings extends UObject { 
	EnabledByDefault: boolean;
	EnableTransport: boolean;
	bAutoRepair: boolean;
	MaxSendRate: number;
	AutoRepairAttemptLimit: number;
	WorkQueueSize: number;
	bStopServiceWhenAppDeactivates: boolean;
	UnicastEndpoint: string;
	MulticastEndpoint: string;
	MessageFormat: EUdpMessageFormat;
	MulticastTimeToLive: number;
	StaticEndpoints: string[];
	ExcludedEndpoints: string[];
	EnableTunnel: boolean;
	TunnelUnicastEndpoint: string;
	TunnelMulticastEndpoint: string;
	RemoteTunnelEndpoints: string[];
	static Load(ResourceName: string): UdpMessagingSettings;
	static Find(Outer: UObject, ResourceName: string): UdpMessagingSettings;
	static GetDefaultObject(): UdpMessagingSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UdpMessagingSettings;
	static C(Other: UObject | any): UdpMessagingSettings;
}

declare class EditorUtilityObject extends UObject { 
	static Load(ResourceName: string): EditorUtilityObject;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityObject;
	static GetDefaultObject(): EditorUtilityObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityObject;
	Run(): void;
	static C(Other: UObject | any): EditorUtilityObject;
}

declare class ActorActionUtility extends EditorUtilityObject { 
	static Load(ResourceName: string): ActorActionUtility;
	static Find(Outer: UObject, ResourceName: string): ActorActionUtility;
	static GetDefaultObject(): ActorActionUtility;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorActionUtility;
	GetSupportedClass(): UnrealEngineClass;
	static C(Other: UObject | any): ActorActionUtility;
}

declare class AssetActionUtility extends EditorUtilityObject { 
	static Load(ResourceName: string): AssetActionUtility;
	static Find(Outer: UObject, ResourceName: string): AssetActionUtility;
	static GetDefaultObject(): AssetActionUtility;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AssetActionUtility;
	IsActionForBlueprints(): boolean;
	GetSupportedClass(): UnrealEngineClass;
	static C(Other: UObject | any): AssetActionUtility;
}

declare class AsyncCaptureScene extends BlueprintAsyncActionBase { 
	Complete: UnrealEngineMulticastDelegate<(Texture: TextureRenderTarget2D) => void>;
	SceneCapture: SceneCapture2D;
	SceneCaptureRT: TextureRenderTarget2D;
	static Load(ResourceName: string): AsyncCaptureScene;
	static Find(Outer: UObject, ResourceName: string): AsyncCaptureScene;
	static GetDefaultObject(): AsyncCaptureScene;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncCaptureScene;
	static CaptureSceneWithWarmupAsync(ViewCamera: CameraComponent,SceneCaptureClass: UnrealEngineClass,ResX: number,ResY: number,WarmUpFrames: number): AsyncCaptureScene;
	static CaptureSceneAsync(ViewCamera: CameraComponent,SceneCaptureClass: UnrealEngineClass,ResX: number,ResY: number): AsyncCaptureScene;
	static C(Other: UObject | any): AsyncCaptureScene;
}

declare class AsyncImageExport extends BlueprintAsyncActionBase { 
	Complete: UnrealEngineMulticastDelegate<(bSuccess: boolean) => void>;
	TextureToExport: Texture;
	Quality: number;
	TargetFile: string;
	static Load(ResourceName: string): AsyncImageExport;
	static Find(Outer: UObject, ResourceName: string): AsyncImageExport;
	static GetDefaultObject(): AsyncImageExport;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncImageExport;
	static ExportImageAsync(Texture: Texture,OutputFile: string,Quality: number): AsyncImageExport;
	static C(Other: UObject | any): AsyncImageExport;
}

declare class EditorUtilityWidget extends UserWidget { 
	HelpText: string;
	bAlwaysReregisterWithWindowsMenu: boolean;
	bAutoRunDefaultAction: boolean;
	static Load(ResourceName: string): EditorUtilityWidget;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityWidget;
	static GetDefaultObject(): EditorUtilityWidget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityWidget;
	Run(): void;
	static C(Other: UObject | any): EditorUtilityWidget;
}

declare class EditorUtilityWidgetBlueprint extends WidgetBlueprint { 
	CreatedUMGWidget: EditorUtilityWidget;
	static Load(ResourceName: string): EditorUtilityWidgetBlueprint;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityWidgetBlueprint;
	static GetDefaultObject(): EditorUtilityWidgetBlueprint;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityWidgetBlueprint;
	static C(Other: UObject | any): EditorUtilityWidgetBlueprint;
}

declare class EditorUtilitySubsystem extends EditorSubsystem { 
	LoadedUIs: SoftObjectPath[];
	StartupObjects: SoftObjectPath[];
	OnBeginPIE: UnrealEngineMulticastDelegate<(bIsSimulating: boolean) => void>;
	OnEndPIE: UnrealEngineMulticastDelegate<(bIsSimulating: boolean) => void>;
	ObjectInstances: Map<UObject, UObject>;
	ActiveTaskStack: EditorUtilityTask[];
	ReferencedObjects: Set<UObject>;
	static Load(ResourceName: string): EditorUtilitySubsystem;
	static Find(Outer: UObject, ResourceName: string): EditorUtilitySubsystem;
	static GetDefaultObject(): EditorUtilitySubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilitySubsystem;
	TryRun(Asset: UObject): boolean;
	SpawnRegisteredTabByID(NewTabID: string): boolean;
	SpawnAndRegisterTabWithId(InBlueprint: EditorUtilityWidgetBlueprint,InTabID: string): EditorUtilityWidget;
	SpawnAndRegisterTabAndGetID(InBlueprint: EditorUtilityWidgetBlueprint,NewTabID?: string): {NewTabID: string, $: EditorUtilityWidget};
	SpawnAndRegisterTab(InBlueprint: EditorUtilityWidgetBlueprint): EditorUtilityWidget;
	ReleaseInstanceOfAsset(Asset: UObject): void;
	RegisterTabAndGetID(InBlueprint: EditorUtilityWidgetBlueprint,NewTabID?: string): {NewTabID: string};
	RegisterAndExecuteTask(NewTask: EditorUtilityTask,OptionalParentTask: EditorUtilityTask): void;
	FindUtilityWidgetFromBlueprint(InBlueprint: EditorUtilityWidgetBlueprint): EditorUtilityWidget;
	DoesTabExist(NewTabID: string): boolean;
	CloseTabByID(NewTabID: string): boolean;
	CanRun(Asset: UObject): boolean;
	static C(Other: UObject | any): EditorUtilitySubsystem;
}

declare class EditorUtilityTask extends UObject { 
	MyTaskManager: EditorUtilitySubsystem;
	MyParentTask: EditorUtilityTask;
	bCancelRequested: boolean;
	static Load(ResourceName: string): EditorUtilityTask;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityTask;
	static GetDefaultObject(): EditorUtilityTask;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityTask;
	WasCancelRequested(): boolean;
	SetTaskNotificationText(Text: string): void;
	Run(): void;
	ReceiveCancelRequested(): void;
	ReceiveBeginExecution(): void;
	FinishExecutingTask(): void;
	static C(Other: UObject | any): EditorUtilityTask;
}

declare class AsyncRegisterAndExecuteTask extends BlueprintAsyncActionBase { 
	OnFinished: UnrealEngineMulticastDelegate<(Task: EditorUtilityTask) => void>;
	static Load(ResourceName: string): AsyncRegisterAndExecuteTask;
	static Find(Outer: UObject, ResourceName: string): AsyncRegisterAndExecuteTask;
	static GetDefaultObject(): AsyncRegisterAndExecuteTask;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncRegisterAndExecuteTask;
	static RegisterAndExecuteTask(Task: EditorUtilityTask,OptionalParentTask: EditorUtilityTask): AsyncRegisterAndExecuteTask;
	static C(Other: UObject | any): AsyncRegisterAndExecuteTask;
}

declare class EditorUtilityExtension extends Interface { 
	static Load(ResourceName: string): EditorUtilityExtension;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityExtension;
	static GetDefaultObject(): EditorUtilityExtension;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityExtension;
	static C(Other: UObject | any): EditorUtilityExtension;
}

declare class EditorUtilityActor extends Actor { 
	EditorOnlyInputComponent: InputComponent;
	bReceivesEditorInput: boolean;
	static GetDefaultObject(): EditorUtilityActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityActor;
	SetReceivesEditorInput(bInValue: boolean): void;
	Run(): void;
	GetReceivesEditorInput(): boolean;
	GetInputComponent(): InputComponent;
	static C(Other: UObject | any): EditorUtilityActor;
}

declare class EditorUtilityActorComponent extends ActorComponent { 
	static Load(ResourceName: string): EditorUtilityActorComponent;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityActorComponent;
	static GetDefaultObject(): EditorUtilityActorComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityActorComponent;
	static C(Other: UObject | any): EditorUtilityActorComponent;
}

declare class EditorUtilityBlueprint extends Blueprint { 
	static Load(ResourceName: string): EditorUtilityBlueprint;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityBlueprint;
	static GetDefaultObject(): EditorUtilityBlueprint;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityBlueprint;
	static C(Other: UObject | any): EditorUtilityBlueprint;
}

declare class EditorUtilityBlueprintFactory extends Factory { 
	ParentClass: UnrealEngineClass;
	static Load(ResourceName: string): EditorUtilityBlueprintFactory;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityBlueprintFactory;
	static GetDefaultObject(): EditorUtilityBlueprintFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityBlueprintFactory;
	static C(Other: UObject | any): EditorUtilityBlueprintFactory;
}

declare class EditorUtilityCamera extends CameraActor { 
	static GetDefaultObject(): EditorUtilityCamera;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityCamera;
	static C(Other: UObject | any): EditorUtilityCamera;
}

declare class EditorUtilityBlueprintAsyncActionBase extends BlueprintAsyncActionBase { 
	static Load(ResourceName: string): EditorUtilityBlueprintAsyncActionBase;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityBlueprintAsyncActionBase;
	static GetDefaultObject(): EditorUtilityBlueprintAsyncActionBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityBlueprintAsyncActionBase;
	static C(Other: UObject | any): EditorUtilityBlueprintAsyncActionBase;
}

declare class AsyncEditorDelay extends EditorUtilityBlueprintAsyncActionBase { 
	Complete: UnrealEngineMulticastDelegate<() => void>;
	static Load(ResourceName: string): AsyncEditorDelay;
	static Find(Outer: UObject, ResourceName: string): AsyncEditorDelay;
	static GetDefaultObject(): AsyncEditorDelay;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncEditorDelay;
	static AsyncEditorDelay(Seconds: number,MinimumFrames: number): AsyncEditorDelay;
	static C(Other: UObject | any): AsyncEditorDelay;
}

declare class AsyncEditorWaitForGameWorld extends EditorUtilityBlueprintAsyncActionBase { 
	Complete: UnrealEngineMulticastDelegate<(World: World) => void>;
	static Load(ResourceName: string): AsyncEditorWaitForGameWorld;
	static Find(Outer: UObject, ResourceName: string): AsyncEditorWaitForGameWorld;
	static GetDefaultObject(): AsyncEditorWaitForGameWorld;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncEditorWaitForGameWorld;
	static AsyncWaitForGameWorld(Index: number,Server: boolean): AsyncEditorWaitForGameWorld;
	static C(Other: UObject | any): AsyncEditorWaitForGameWorld;
}

declare class AsyncEditorOpenMapAndFocusActor extends EditorUtilityBlueprintAsyncActionBase { 
	Complete: UnrealEngineMulticastDelegate<() => void>;
	static Load(ResourceName: string): AsyncEditorOpenMapAndFocusActor;
	static Find(Outer: UObject, ResourceName: string): AsyncEditorOpenMapAndFocusActor;
	static GetDefaultObject(): AsyncEditorOpenMapAndFocusActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncEditorOpenMapAndFocusActor;
	static AsyncEditorOpenMapAndFocusActor(Map: SoftObjectPath,FocusActorName: string): AsyncEditorOpenMapAndFocusActor;
	static C(Other: UObject | any): AsyncEditorOpenMapAndFocusActor;
}

declare class EditorUtilityLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): EditorUtilityLibrary;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityLibrary;
	static GetDefaultObject(): EditorUtilityLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityLibrary;
	static SyncBrowserToFolders(FolderList: string[]): void;
	static RenameAsset(Asset: UObject,NewName: string): void;
	static GetSelectionSet(): Actor[];
	static GetSelectionBounds(Origin?: Vector,BoxExtent?: Vector,SphereRadius?: number): {Origin: Vector, BoxExtent: Vector, SphereRadius: number};
	static GetSelectedFolderPaths(): string[];
	static GetSelectedBlueprintClasses(): UnrealEngineClass[];
	static GetSelectedAssets(): UObject[];
	static GetSelectedAssetData(): AssetData[];
	static GetCurrentContentBrowserPath(OutPath?: string): {OutPath: string, $: boolean};
	GetActorReference(PathToActor: string): Actor;
	static C(Other: UObject | any): EditorUtilityLibrary;
}

declare class EditorUtilityToolMenuEntry extends ToolMenuEntryScript { 
	static Load(ResourceName: string): EditorUtilityToolMenuEntry;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityToolMenuEntry;
	static GetDefaultObject(): EditorUtilityToolMenuEntry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityToolMenuEntry;
	static C(Other: UObject | any): EditorUtilityToolMenuEntry;
}

declare class EditorUtilityToolMenuSection extends ToolMenuSectionDynamic { 
	static Load(ResourceName: string): EditorUtilityToolMenuSection;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityToolMenuSection;
	static GetDefaultObject(): EditorUtilityToolMenuSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityToolMenuSection;
	static C(Other: UObject | any): EditorUtilityToolMenuSection;
}

declare class EditorUtilityWidgetBlueprintFactory extends Factory { 
	BlueprintType: EBlueprintType;
	ParentClass: UnrealEngineClass;
	static Load(ResourceName: string): EditorUtilityWidgetBlueprintFactory;
	static Find(Outer: UObject, ResourceName: string): EditorUtilityWidgetBlueprintFactory;
	static GetDefaultObject(): EditorUtilityWidgetBlueprintFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorUtilityWidgetBlueprintFactory;
	static C(Other: UObject | any): EditorUtilityWidgetBlueprintFactory;
}

declare class GlobalEditorUtilityBase extends UObject { 
	HelpText: string;
	bDirtiedSelectionSet: boolean;
	bAutoRunDefaultAction: boolean;
	OnEachSelectedActor: UnrealEngineMulticastDelegate<(Actor: Actor, Index: number) => void>;
	OnEachSelectedAsset: UnrealEngineMulticastDelegate<(Asset: UObject, Index: number) => void>;
	static Load(ResourceName: string): GlobalEditorUtilityBase;
	static Find(Outer: UObject, ResourceName: string): GlobalEditorUtilityBase;
	static GetDefaultObject(): GlobalEditorUtilityBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GlobalEditorUtilityBase;
	SetActorSelectionState(Actor: Actor,bShouldBeSelected: boolean): void;
	SelectNothing(): void;
	RenameAsset(Asset: UObject,NewName: string): void;
	OnDefaultActionClicked(): void;
	GetSelectionSet(): Actor[];
	GetSelectionBounds(Origin?: Vector,BoxExtent?: Vector,SphereRadius?: number): {Origin: Vector, BoxExtent: Vector, SphereRadius: number};
	GetSelectedAssets(): UObject[];
	GetEditorUserSettings(): EditorPerProjectUserSettings;
	GetActorReference(PathToActor: string): Actor;
	ForEachSelectedAsset(): void;
	ForEachSelectedActor(): void;
	ClearActorSelectionSet(): void;
	static C(Other: UObject | any): GlobalEditorUtilityBase;
}

declare class PlacedEditorUtilityBase extends Actor { 
	HelpText: string;
	static GetDefaultObject(): PlacedEditorUtilityBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlacedEditorUtilityBase;
	SetLevelViewportCameraInfo(CameraLocation: Vector,CameraRotation: Rotator): void;
	SetActorSelectionState(Actor: Actor,bShouldBeSelected: boolean): void;
	SelectNothing(): void;
	GetSelectionSet(): Actor[];
	GetLevelViewportCameraInfo(CameraLocation?: Vector,CameraRotation?: Rotator): {CameraLocation: Vector, CameraRotation: Rotator, $: boolean};
	GetActorReference(PathToActor: string): Actor;
	ClearActorSelectionSet(): void;
	static C(Other: UObject | any): PlacedEditorUtilityBase;
}

declare class DataValidationChangelist extends UObject { 
	static Load(ResourceName: string): DataValidationChangelist;
	static Find(Outer: UObject, ResourceName: string): DataValidationChangelist;
	static GetDefaultObject(): DataValidationChangelist;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataValidationChangelist;
	static C(Other: UObject | any): DataValidationChangelist;
}

declare class DataValidationCommandlet extends Commandlet { 
	static Load(ResourceName: string): DataValidationCommandlet;
	static Find(Outer: UObject, ResourceName: string): DataValidationCommandlet;
	static GetDefaultObject(): DataValidationCommandlet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataValidationCommandlet;
	static C(Other: UObject | any): DataValidationCommandlet;
}

declare class DataValidationManager extends UObject { 
	ExcludedDirectories: DirectoryPath[];
	bValidateOnSave: boolean;
	DataValidationManagerClassName: SoftClassPath;
	static Load(ResourceName: string): DataValidationManager;
	static Find(Outer: UObject, ResourceName: string): DataValidationManager;
	static GetDefaultObject(): DataValidationManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataValidationManager;
	static C(Other: UObject | any): DataValidationManager;
}

declare type EDataValidationResult = 'Invalid' | 'Valid' | 'NotValidated' | 'EDataValidationResult_MAX';
declare var EDataValidationResult : { Invalid:'Invalid',Valid:'Valid',NotValidated:'NotValidated',EDataValidationResult_MAX:'EDataValidationResult_MAX', };
declare type EDataValidationUsecase = 'None' | 'Manual' | 'Commandlet' | 'Save' | 'PreSubmit' | 'Script' | 'EDataValidationUsecase_MAX';
declare var EDataValidationUsecase : { None:'None',Manual:'Manual',Commandlet:'Commandlet',Save:'Save',PreSubmit:'PreSubmit',Script:'Script',EDataValidationUsecase_MAX:'EDataValidationUsecase_MAX', };
declare class EditorValidatorBase extends UObject { 
	bIsEnabled: boolean;
	static Load(ResourceName: string): EditorValidatorBase;
	static Find(Outer: UObject, ResourceName: string): EditorValidatorBase;
	static GetDefaultObject(): EditorValidatorBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorValidatorBase;
	ValidateLoadedAsset(InAsset: UObject,ValidationErrors?: string[]): {ValidationErrors: string[], $: EDataValidationResult};
	GetValidationResult(): EDataValidationResult;
	CanValidateAsset(InAsset: UObject): boolean;
	CanValidate(InUsecase: EDataValidationUsecase): boolean;
	AssetWarning(InAsset: UObject,InMessage: string): void;
	AssetPasses(InAsset: UObject): void;
	AssetFails(InAsset: UObject,InMessage: string,ValidationErrors?: string[]): {ValidationErrors: string[]};
	static C(Other: UObject | any): EditorValidatorBase;
}

declare class DirtyFilesChangelistValidator extends EditorValidatorBase { 
	static Load(ResourceName: string): DirtyFilesChangelistValidator;
	static Find(Outer: UObject, ResourceName: string): DirtyFilesChangelistValidator;
	static GetDefaultObject(): DirtyFilesChangelistValidator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DirtyFilesChangelistValidator;
	static C(Other: UObject | any): DirtyFilesChangelistValidator;
}

declare class DataValidationSettings extends UObject { 
	bValidateOnSave: boolean;
	static Load(ResourceName: string): DataValidationSettings;
	static Find(Outer: UObject, ResourceName: string): DataValidationSettings;
	static GetDefaultObject(): DataValidationSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataValidationSettings;
	static C(Other: UObject | any): DataValidationSettings;
}

declare class ValidateAssetsSettings { 
	bSkipExcludedDirectories: boolean;
	bShowIfNoFailures: boolean;
	ValidationUsecase: EDataValidationUsecase;
	clone() : ValidateAssetsSettings;
	static C(Other: UObject | any): ValidateAssetsSettings;
}

declare class ValidateAssetsResults { 
	NumChecked: number;
	NumValid: number;
	NumInvalid: number;
	NumSkipped: number;
	NumWarnings: number;
	NumUnableToValidate: number;
	clone() : ValidateAssetsResults;
	static C(Other: UObject | any): ValidateAssetsResults;
}

declare class EditorValidatorSubsystem extends EditorSubsystem { 
	ExcludedDirectories: DirectoryPath[];
	bValidateOnSave: boolean;
	Validators: Map<string, EditorValidatorBase>;
	bValidateAssetsWhileSavingForCook: boolean;
	bAllowBlueprintValidators: boolean;
	static Load(ResourceName: string): EditorValidatorSubsystem;
	static Find(Outer: UObject, ResourceName: string): EditorValidatorSubsystem;
	static GetDefaultObject(): EditorValidatorSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorValidatorSubsystem;
	ValidateAssetsWithSettings(AssetDataList: AssetData[],InSettings: ValidateAssetsSettings,OutResults?: ValidateAssetsResults): {OutResults: ValidateAssetsResults, $: number};
	ValidateAssets(AssetDataList: AssetData[],bSkipExcludedDirectories: boolean,bShowIfNoFailures: boolean): number;
	IsObjectValid(InObject: UObject,ValidationErrors?: string[],ValidationWarnings?: string[],InValidationUsecase?: EDataValidationUsecase): {ValidationErrors: string[], ValidationWarnings: string[], $: EDataValidationResult};
	IsAssetValid(AssetData: AssetData,ValidationErrors?: string[],ValidationWarnings?: string[],InValidationUsecase?: EDataValidationUsecase): {ValidationErrors: string[], ValidationWarnings: string[], $: EDataValidationResult};
	AddValidator(InValidator: EditorValidatorBase): void;
	static C(Other: UObject | any): EditorValidatorSubsystem;
}

declare class EditorValidator_Localization extends EditorValidatorBase { 
	static Load(ResourceName: string): EditorValidator_Localization;
	static Find(Outer: UObject, ResourceName: string): EditorValidator_Localization;
	static GetDefaultObject(): EditorValidator_Localization;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorValidator_Localization;
	static C(Other: UObject | any): EditorValidator_Localization;
}

declare class WorldPartitionChangelistValidator extends EditorValidatorBase { 
	static Load(ResourceName: string): WorldPartitionChangelistValidator;
	static Find(Outer: UObject, ResourceName: string): WorldPartitionChangelistValidator;
	static GetDefaultObject(): WorldPartitionChangelistValidator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldPartitionChangelistValidator;
	static C(Other: UObject | any): WorldPartitionChangelistValidator;
}

declare class AudioCurveSourceComponent extends AudioComponent { 
	CurveSourceBindingName: string;
	CurveSyncOffset: number;
	static Load(ResourceName: string): AudioCurveSourceComponent;
	static Find(Outer: UObject, ResourceName: string): AudioCurveSourceComponent;
	static GetDefaultObject(): AudioCurveSourceComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioCurveSourceComponent;
	static C(Other: UObject | any): AudioCurveSourceComponent;
}

declare class FacialAnimationBulkImporterSettings extends UObject { 
	SourceImportPath: DirectoryPath;
	TargetImportPath: DirectoryPath;
	CurveNodeName: string;
	static Load(ResourceName: string): FacialAnimationBulkImporterSettings;
	static Find(Outer: UObject, ResourceName: string): FacialAnimationBulkImporterSettings;
	static GetDefaultObject(): FacialAnimationBulkImporterSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FacialAnimationBulkImporterSettings;
	static C(Other: UObject | any): FacialAnimationBulkImporterSettings;
}

declare class GameplayTagSearchFilter extends ContentBrowserFrontEndFilterExtension { 
	static Load(ResourceName: string): GameplayTagSearchFilter;
	static Find(Outer: UObject, ResourceName: string): GameplayTagSearchFilter;
	static GetDefaultObject(): GameplayTagSearchFilter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagSearchFilter;
	static C(Other: UObject | any): GameplayTagSearchFilter;
}

declare class GameplayTagsK2Node_LiteralGameplayTag extends K2Node { 
	static Load(ResourceName: string): GameplayTagsK2Node_LiteralGameplayTag;
	static Find(Outer: UObject, ResourceName: string): GameplayTagsK2Node_LiteralGameplayTag;
	static GetDefaultObject(): GameplayTagsK2Node_LiteralGameplayTag;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagsK2Node_LiteralGameplayTag;
	static C(Other: UObject | any): GameplayTagsK2Node_LiteralGameplayTag;
}

declare class GameplayTagsK2Node_MultiCompareBase extends K2Node { 
	NumberOfPins: number;
	PinNames: string[];
	static Load(ResourceName: string): GameplayTagsK2Node_MultiCompareBase;
	static Find(Outer: UObject, ResourceName: string): GameplayTagsK2Node_MultiCompareBase;
	static GetDefaultObject(): GameplayTagsK2Node_MultiCompareBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagsK2Node_MultiCompareBase;
	static C(Other: UObject | any): GameplayTagsK2Node_MultiCompareBase;
}

declare class GameplayTagsK2Node_MultiCompareGameplayTagAssetInterface extends GameplayTagsK2Node_MultiCompareBase { 
	static Load(ResourceName: string): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterface;
	static Find(Outer: UObject, ResourceName: string): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterface;
	static GetDefaultObject(): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterface;
	static C(Other: UObject | any): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterface;
}

declare class GameplayTagsK2Node_MultiCompareGameplayTagAssetInterfaceSingleTags extends GameplayTagsK2Node_MultiCompareBase { 
	static Load(ResourceName: string): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterfaceSingleTags;
	static Find(Outer: UObject, ResourceName: string): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterfaceSingleTags;
	static GetDefaultObject(): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterfaceSingleTags;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterfaceSingleTags;
	static C(Other: UObject | any): GameplayTagsK2Node_MultiCompareGameplayTagAssetInterfaceSingleTags;
}

declare class GameplayTagsK2Node_MultiCompareGameplayTagContainer extends GameplayTagsK2Node_MultiCompareBase { 
	static Load(ResourceName: string): GameplayTagsK2Node_MultiCompareGameplayTagContainer;
	static Find(Outer: UObject, ResourceName: string): GameplayTagsK2Node_MultiCompareGameplayTagContainer;
	static GetDefaultObject(): GameplayTagsK2Node_MultiCompareGameplayTagContainer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagsK2Node_MultiCompareGameplayTagContainer;
	static C(Other: UObject | any): GameplayTagsK2Node_MultiCompareGameplayTagContainer;
}

declare class GameplayTagsK2Node_MultiCompareGameplayTagContainerSingleTags extends GameplayTagsK2Node_MultiCompareBase { 
	static Load(ResourceName: string): GameplayTagsK2Node_MultiCompareGameplayTagContainerSingleTags;
	static Find(Outer: UObject, ResourceName: string): GameplayTagsK2Node_MultiCompareGameplayTagContainerSingleTags;
	static GetDefaultObject(): GameplayTagsK2Node_MultiCompareGameplayTagContainerSingleTags;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagsK2Node_MultiCompareGameplayTagContainerSingleTags;
	static C(Other: UObject | any): GameplayTagsK2Node_MultiCompareGameplayTagContainerSingleTags;
}

declare class GameplayTagsK2Node_SwitchGameplayTag extends K2Node_Switch { 
	PinTags: GameplayTag[];
	PinNames: string[];
	static Load(ResourceName: string): GameplayTagsK2Node_SwitchGameplayTag;
	static Find(Outer: UObject, ResourceName: string): GameplayTagsK2Node_SwitchGameplayTag;
	static GetDefaultObject(): GameplayTagsK2Node_SwitchGameplayTag;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagsK2Node_SwitchGameplayTag;
	static C(Other: UObject | any): GameplayTagsK2Node_SwitchGameplayTag;
}

declare class GameplayTagsK2Node_SwitchGameplayTagContainer extends K2Node_Switch { 
	PinContainers: GameplayTagContainer[];
	PinNames: string[];
	static Load(ResourceName: string): GameplayTagsK2Node_SwitchGameplayTagContainer;
	static Find(Outer: UObject, ResourceName: string): GameplayTagsK2Node_SwitchGameplayTagContainer;
	static GetDefaultObject(): GameplayTagsK2Node_SwitchGameplayTagContainer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTagsK2Node_SwitchGameplayTagContainer;
	static C(Other: UObject | any): GameplayTagsK2Node_SwitchGameplayTagContainer;
}

declare class NiagaraUserParameterBinding { 
	Parameter: NiagaraVariable;
	clone() : NiagaraUserParameterBinding;
	static C(Other: UObject | any): NiagaraUserParameterBinding;
}

declare class NiagaraDataInterfaceSimCacheReader extends NiagaraDataInterface { 
	SimCacheBinding: NiagaraUserParameterBinding;
	SimCache: NiagaraSimCache;
	EmitterBinding: string;
	static Load(ResourceName: string): NiagaraDataInterfaceSimCacheReader;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceSimCacheReader;
	static GetDefaultObject(): NiagaraDataInterfaceSimCacheReader;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceSimCacheReader;
	static C(Other: UObject | any): NiagaraDataInterfaceSimCacheReader;
}

declare type ENiagaraRendererSourceDataMode = 'Particles' | 'Emitter' | 'ENiagaraRendererSourceDataMode_MAX';
declare var ENiagaraRendererSourceDataMode : { Particles:'Particles',Emitter:'Emitter',ENiagaraRendererSourceDataMode_MAX:'ENiagaraRendererSourceDataMode_MAX', };
declare type ENiagaraSpriteAlignment = 'Unaligned' | 'VelocityAligned' | 'CustomAlignment' | 'ENiagaraSpriteAlignment_MAX';
declare var ENiagaraSpriteAlignment : { Unaligned:'Unaligned',VelocityAligned:'VelocityAligned',CustomAlignment:'CustomAlignment',ENiagaraSpriteAlignment_MAX:'ENiagaraSpriteAlignment_MAX', };
declare type ENiagaraSpriteFacingMode = 'FaceCamera' | 'FaceCameraPlane' | 'CustomFacingVector' | 'FaceCameraPosition' | 'FaceCameraDistanceBlend' | 'ENiagaraSpriteFacingMode_MAX';
declare var ENiagaraSpriteFacingMode : { FaceCamera:'FaceCamera',FaceCameraPlane:'FaceCameraPlane',CustomFacingVector:'CustomFacingVector',FaceCameraPosition:'FaceCameraPosition',FaceCameraDistanceBlend:'FaceCameraDistanceBlend',ENiagaraSpriteFacingMode_MAX:'ENiagaraSpriteFacingMode_MAX', };
declare type ENiagaraSortMode = 'None' | 'ViewDepth' | 'ViewDistance' | 'CustomAscending' | 'CustomDecending' | 'ENiagaraSortMode_MAX';
declare var ENiagaraSortMode : { None:'None',ViewDepth:'ViewDepth',ViewDistance:'ViewDistance',CustomAscending:'CustomAscending',CustomDecending:'CustomDecending',ENiagaraSortMode_MAX:'ENiagaraSortMode_MAX', };
declare type ENiagaraRendererSortPrecision = 'Default' | 'Low' | 'High' | 'ENiagaraRendererSortPrecision_MAX';
declare var ENiagaraRendererSortPrecision : { Default:'Default',Low:'Low',High:'High',ENiagaraRendererSortPrecision_MAX:'ENiagaraRendererSortPrecision_MAX', };
declare type ENiagaraRendererGpuTranslucentLatency = 'ProjectDefault' | 'Immediate' | 'Latent' | 'ENiagaraRendererGpuTranslucentLatency_MAX';
declare var ENiagaraRendererGpuTranslucentLatency : { ProjectDefault:'ProjectDefault',Immediate:'Immediate',Latent:'Latent',ENiagaraRendererGpuTranslucentLatency_MAX:'ENiagaraRendererGpuTranslucentLatency_MAX', };
declare type ENiagaraRendererPixelCoverageMode = 'Automatic' | 'Disabled' | 'Enabled' | 'Enabled_RGBA' | 'Enabled_RGB' | 'Enabled_A' | 'ENiagaraRendererPixelCoverageMode_MAX';
declare var ENiagaraRendererPixelCoverageMode : { Automatic:'Automatic',Disabled:'Disabled',Enabled:'Enabled',Enabled_RGBA:'Enabled_RGBA',Enabled_RGB:'Enabled_RGB',Enabled_A:'Enabled_A',ENiagaraRendererPixelCoverageMode_MAX:'ENiagaraRendererPixelCoverageMode_MAX', };
declare class NiagaraMaterialAttributeBinding { 
	MaterialParameterName: string;
	NiagaraVariable: NiagaraVariableBase;
	ResolvedNiagaraVariable: NiagaraVariableBase;
	NiagaraChildVariable: NiagaraVariableBase;
	clone() : NiagaraMaterialAttributeBinding;
	static C(Other: UObject | any): NiagaraMaterialAttributeBinding;
}

declare class NiagaraRendererMaterialScalarParameter { 
	MaterialParameterName: string;
	Value: number;
	clone() : NiagaraRendererMaterialScalarParameter;
	static C(Other: UObject | any): NiagaraRendererMaterialScalarParameter;
}

declare class NiagaraRendererMaterialVectorParameter { 
	MaterialParameterName: string;
	Value: LinearColor;
	clone() : NiagaraRendererMaterialVectorParameter;
	static C(Other: UObject | any): NiagaraRendererMaterialVectorParameter;
}

declare class NiagaraRendererMaterialTextureParameter { 
	MaterialParameterName: string;
	Texture: Texture;
	clone() : NiagaraRendererMaterialTextureParameter;
	static C(Other: UObject | any): NiagaraRendererMaterialTextureParameter;
}

declare class NiagaraRendererMaterialParameters { 
	AttributeBindings: NiagaraMaterialAttributeBinding[];
	ScalarParameters: NiagaraRendererMaterialScalarParameter[];
	VectorParameters: NiagaraRendererMaterialVectorParameter[];
	TextureParameters: NiagaraRendererMaterialTextureParameter[];
	clone() : NiagaraRendererMaterialParameters;
	static C(Other: UObject | any): NiagaraRendererMaterialParameters;
}

declare class NiagaraSpriteRendererProperties extends NiagaraRendererProperties { 
	Material: MaterialInterface;
	SourceMode: ENiagaraRendererSourceDataMode;
	MaterialUserParamBinding: NiagaraUserParameterBinding;
	Alignment: ENiagaraSpriteAlignment;
	FacingMode: ENiagaraSpriteFacingMode;
	PivotInUVSpace: Vector2D;
	MacroUVRadius: number;
	SortMode: ENiagaraSortMode;
	SubImageSize: Vector2D;
	bSubImageBlend: boolean;
	bRemoveHMDRollInVR: boolean;
	bSortOnlyWhenTranslucent: boolean;
	SortPrecision: ENiagaraRendererSortPrecision;
	GpuTranslucentLatency: ENiagaraRendererGpuTranslucentLatency;
	PixelCoverageMode: ENiagaraRendererPixelCoverageMode;
	PixelCoverageBlend: number;
	MinFacingCameraBlendDistance: number;
	MaxFacingCameraBlendDistance: number;
	bEnableCameraDistanceCulling: boolean;
	MinCameraDistance: number;
	MaxCameraDistance: number;
	RendererVisibility: number;
	PositionBinding: NiagaraVariableAttributeBinding;
	ColorBinding: NiagaraVariableAttributeBinding;
	VelocityBinding: NiagaraVariableAttributeBinding;
	SpriteRotationBinding: NiagaraVariableAttributeBinding;
	SpriteSizeBinding: NiagaraVariableAttributeBinding;
	SpriteFacingBinding: NiagaraVariableAttributeBinding;
	SpriteAlignmentBinding: NiagaraVariableAttributeBinding;
	SubImageIndexBinding: NiagaraVariableAttributeBinding;
	DynamicMaterialBinding: NiagaraVariableAttributeBinding;
	DynamicMaterial1Binding: NiagaraVariableAttributeBinding;
	DynamicMaterial2Binding: NiagaraVariableAttributeBinding;
	DynamicMaterial3Binding: NiagaraVariableAttributeBinding;
	CameraOffsetBinding: NiagaraVariableAttributeBinding;
	UVScaleBinding: NiagaraVariableAttributeBinding;
	PivotOffsetBinding: NiagaraVariableAttributeBinding;
	MaterialRandomBinding: NiagaraVariableAttributeBinding;
	CustomSortingBinding: NiagaraVariableAttributeBinding;
	NormalizedAgeBinding: NiagaraVariableAttributeBinding;
	RendererVisibilityTagBinding: NiagaraVariableAttributeBinding;
	MaterialParameters: NiagaraRendererMaterialParameters;
	MaterialParameterBindings: NiagaraMaterialAttributeBinding[];
	PrevPositionBinding: NiagaraVariableAttributeBinding;
	PrevVelocityBinding: NiagaraVariableAttributeBinding;
	PrevSpriteRotationBinding: NiagaraVariableAttributeBinding;
	PrevSpriteSizeBinding: NiagaraVariableAttributeBinding;
	PrevSpriteFacingBinding: NiagaraVariableAttributeBinding;
	PrevSpriteAlignmentBinding: NiagaraVariableAttributeBinding;
	PrevCameraOffsetBinding: NiagaraVariableAttributeBinding;
	PrevPivotOffsetBinding: NiagaraVariableAttributeBinding;
	bUseMaterialCutoutTexture: boolean;
	CutoutTexture: Texture2D;
	BoundingMode: ESubUVBoundingVertexCount;
	OpacitySourceMode: EOpacitySourceMode;
	AlphaThreshold: number;
	static Load(ResourceName: string): NiagaraSpriteRendererProperties;
	static Find(Outer: UObject, ResourceName: string): NiagaraSpriteRendererProperties;
	static GetDefaultObject(): NiagaraSpriteRendererProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSpriteRendererProperties;
	static C(Other: UObject | any): NiagaraSpriteRendererProperties;
}

declare class NiagaraDataInterfaceSpriteRendererInfo extends NiagaraDataInterface { 
	SpriteRenderer: NiagaraSpriteRendererProperties;
	static Load(ResourceName: string): NiagaraDataInterfaceSpriteRendererInfo;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceSpriteRendererInfo;
	static GetDefaultObject(): NiagaraDataInterfaceSpriteRendererInfo;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceSpriteRendererInfo;
	static C(Other: UObject | any): NiagaraDataInterfaceSpriteRendererInfo;
}

declare class NiagaraDataInterfaceVirtualTexture extends NiagaraDataInterface { 
	Texture: RuntimeVirtualTexture;
	TextureUserParameter: NiagaraUserParameterBinding;
	static Load(ResourceName: string): NiagaraDataInterfaceVirtualTexture;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceVirtualTexture;
	static GetDefaultObject(): NiagaraDataInterfaceVirtualTexture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceVirtualTexture;
	static C(Other: UObject | any): NiagaraDataInterfaceVirtualTexture;
}

declare type ENiagaraGpuBufferFormat = 'Float' | 'HalfFloat' | 'UnsignedNormalizedByte' | 'Max' | 'ENiagaraGpuBufferFormat_MAX';
declare var ENiagaraGpuBufferFormat : { Float:'Float',HalfFloat:'HalfFloat',UnsignedNormalizedByte:'UnsignedNormalizedByte',Max:'Max',ENiagaraGpuBufferFormat_MAX:'ENiagaraGpuBufferFormat_MAX', };
declare type ENiagaraDefaultRendererMotionVectorSetting = 'Precise' | 'Approximate' | 'ENiagaraDefaultRendererMotionVectorSetting_MAX';
declare var ENiagaraDefaultRendererMotionVectorSetting : { Precise:'Precise',Approximate:'Approximate',ENiagaraDefaultRendererMotionVectorSetting_MAX:'ENiagaraDefaultRendererMotionVectorSetting_MAX', };
declare type ENiagaraDefaultRendererPixelCoverageMode = 'Enabled' | 'Disabled' | 'ENiagaraDefaultRendererPixelCoverageMode_MAX';
declare var ENiagaraDefaultRendererPixelCoverageMode : { Enabled:'Enabled',Disabled:'Disabled',ENiagaraDefaultRendererPixelCoverageMode_MAX:'ENiagaraDefaultRendererPixelCoverageMode_MAX', };
declare type ENiagaraDefaultSortPrecision = 'Low' | 'High' | 'ENiagaraDefaultSortPrecision_MAX';
declare var ENiagaraDefaultSortPrecision : { Low:'Low',High:'High',ENiagaraDefaultSortPrecision_MAX:'ENiagaraDefaultSortPrecision_MAX', };
declare type ENiagaraDefaultGpuTranslucentLatency = 'Immediate' | 'Latent' | 'ENiagaraDefaultGpuTranslucentLatency_MAX';
declare var ENiagaraDefaultGpuTranslucentLatency : { Immediate:'Immediate',Latent:'Latent',ENiagaraDefaultGpuTranslucentLatency_MAX:'ENiagaraDefaultGpuTranslucentLatency_MAX', };
declare type ENDISkelMesh_GpuMaxInfluences = 'AllowMax4' | 'AllowMax8' | 'Unlimited' | 'ENDISkelMesh_MAX';
declare var ENDISkelMesh_GpuMaxInfluences : { AllowMax4:'AllowMax4',AllowMax8:'AllowMax8',Unlimited:'Unlimited',ENDISkelMesh_MAX:'ENDISkelMesh_MAX', };
declare type ENDISkelMesh_GpuUniformSamplingFormat = 'Full' | 'Limited_24_8' | 'Limited_23_9' | 'ENDISkelMesh_MAX';
declare var ENDISkelMesh_GpuUniformSamplingFormat : { Full:'Full',Limited_24_8:'Limited_24_8',Limited_23_9:'Limited_23_9',ENDISkelMesh_MAX:'ENDISkelMesh_MAX', };
declare type ENDISkelMesh_AdjacencyTriangleIndexFormat = 'Full' | 'Half' | 'ENDISkelMesh_MAX';
declare var ENDISkelMesh_AdjacencyTriangleIndexFormat : { Full:'Full',Half:'Half',ENDISkelMesh_MAX:'ENDISkelMesh_MAX', };
declare type ENDICollisionQuery_AsyncGpuTraceProvider = 'Default' | 'HWRT' | 'GSDF' | 'None' | 'ENDICollisionQuery_MAX';
declare var ENDICollisionQuery_AsyncGpuTraceProvider : { Default:'Default',HWRT:'HWRT',GSDF:'GSDF',None:'None',ENDICollisionQuery_MAX:'ENDICollisionQuery_MAX', };
declare type ENiagaraDeviceProfileRedirectMode = 'CVar' | 'DeviceProfile' | 'ENiagaraDeviceProfileRedirectMode_MAX';
declare var ENiagaraDeviceProfileRedirectMode : { CVar:'CVar',DeviceProfile:'DeviceProfile',ENiagaraDeviceProfileRedirectMode_MAX:'ENiagaraDeviceProfileRedirectMode_MAX', };
declare class NiagaraPlatformSetRedirect { 
	ProfileNames: string[];
	Mode: ENiagaraDeviceProfileRedirectMode;
	RedirectProfileName: string;
	CVarConditionEnabled: NiagaraPlatformSetCVarCondition;
	CVarConditionDisabled: NiagaraPlatformSetCVarCondition;
	clone() : NiagaraPlatformSetRedirect;
	static C(Other: UObject | any): NiagaraPlatformSetRedirect;
}

declare class NiagaraSettings extends DeveloperSettings { 
	AdditionalParameterTypes: SoftObjectPath[];
	AdditionalPayloadTypes: SoftObjectPath[];
	AdditionalParameterEnums: SoftObjectPath[];
	bSystemViewportInOrbitMode: boolean;
	bShowConvertibleInputsInStack: boolean;
	bSystemsSupportLargeWorldCoordinates: boolean;
	bEnforceStrictStackTypes: boolean;
	bExperimentalVMEnabled: boolean;
	DefaultEffectType: SoftObjectPath;
	PositionPinTypeColor: LinearColor;
	QualityLevels: string[];
	ComponentRendererWarningsPerClass: Map<string, string>;
	DefaultRenderTargetFormat: ETextureRenderTargetFormat;
	DefaultGridFormat: ENiagaraGpuBufferFormat;
	DefaultRendererMotionVectorSetting: ENiagaraDefaultRendererMotionVectorSetting;
	DefaultPixelCoverageMode: ENiagaraDefaultRendererPixelCoverageMode;
	DefaultSortPrecision: ENiagaraDefaultSortPrecision;
	DefaultGpuTranslucentLatency: ENiagaraDefaultGpuTranslucentLatency;
	DefaultLightInverseExposureBlend: number;
	NDISkelMesh_GpuMaxInfluences: ENDISkelMesh_GpuMaxInfluences;
	NDISkelMesh_GpuUniformSamplingFormat: ENDISkelMesh_GpuUniformSamplingFormat;
	NDISkelMesh_AdjacencyTriangleIndexFormat: ENDISkelMesh_AdjacencyTriangleIndexFormat;
	NDIStaticMesh_AllowDistanceFields: boolean;
	NDICollisionQuery_AsyncGpuTraceProviderOrder: ENDICollisionQuery_AsyncGpuTraceProvider[];
	PlatformSetRedirects: NiagaraPlatformSetRedirect[];
	static Load(ResourceName: string): NiagaraSettings;
	static Find(Outer: UObject, ResourceName: string): NiagaraSettings;
	static GetDefaultObject(): NiagaraSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSettings;
	static C(Other: UObject | any): NiagaraSettings;
}

declare type ENDIActorComponentSourceMode = 'Default' | 'AttachParent' | 'LocalPlayer' | 'ENDIActorComponentSourceMode_MAX';
declare var ENDIActorComponentSourceMode : { Default:'Default',AttachParent:'AttachParent',LocalPlayer:'LocalPlayer',ENDIActorComponentSourceMode_MAX:'ENDIActorComponentSourceMode_MAX', };
declare class NiagaraDataInterfaceActorComponent extends NiagaraDataInterface { 
	bRequireCurrentFrameData: boolean;
	SourceMode: ENDIActorComponentSourceMode;
	LocalPlayerIndex: number;
	SourceActor: Actor;
	ActorOrComponentParameter: NiagaraUserParameterBinding;
	static Load(ResourceName: string): NiagaraDataInterfaceActorComponent;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceActorComponent;
	static GetDefaultObject(): NiagaraDataInterfaceActorComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceActorComponent;
	static C(Other: UObject | any): NiagaraDataInterfaceActorComponent;
}

declare class NiagaraDataInterfaceAsyncGpuTrace extends NiagaraDataInterface { 
	MaxTracesPerParticle: number;
	MaxRetraces: number;
	TraceProvider: ENDICollisionQuery_AsyncGpuTraceProvider;
	static Load(ResourceName: string): NiagaraDataInterfaceAsyncGpuTrace;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceAsyncGpuTrace;
	static GetDefaultObject(): NiagaraDataInterfaceAsyncGpuTrace;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceAsyncGpuTrace;
	static C(Other: UObject | any): NiagaraDataInterfaceAsyncGpuTrace;
}

declare class NiagaraDataInterfaceDebugDraw extends NiagaraDataInterface { 
	OverrideMaxLineInstances: number;
	static Load(ResourceName: string): NiagaraDataInterfaceDebugDraw;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceDebugDraw;
	static GetDefaultObject(): NiagaraDataInterfaceDebugDraw;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceDebugDraw;
	static C(Other: UObject | any): NiagaraDataInterfaceDebugDraw;
}

declare type ENiagaraDataInterfaceEmitterBindingMode = 'Self' | 'Other' | 'ENiagaraDataInterfaceEmitterBindingMode_MAX';
declare var ENiagaraDataInterfaceEmitterBindingMode : { Self:'Self',Other:'Other',ENiagaraDataInterfaceEmitterBindingMode_MAX:'ENiagaraDataInterfaceEmitterBindingMode_MAX', };
declare class NiagaraDataInterfaceEmitterBinding { 
	BindingMode: ENiagaraDataInterfaceEmitterBindingMode;
	EmitterName: string;
	clone() : NiagaraDataInterfaceEmitterBinding;
	static C(Other: UObject | any): NiagaraDataInterfaceEmitterBinding;
}

declare class NiagaraDataInterfaceEmitterProperties extends NiagaraDataInterface { 
	EmitterBinding: NiagaraDataInterfaceEmitterBinding;
	static Load(ResourceName: string): NiagaraDataInterfaceEmitterProperties;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceEmitterProperties;
	static GetDefaultObject(): NiagaraDataInterfaceEmitterProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceEmitterProperties;
	static C(Other: UObject | any): NiagaraDataInterfaceEmitterProperties;
}

declare class NiagaraDataInterfaceGBuffer extends NiagaraDataInterface { 
	static Load(ResourceName: string): NiagaraDataInterfaceGBuffer;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceGBuffer;
	static GetDefaultObject(): NiagaraDataInterfaceGBuffer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceGBuffer;
	static C(Other: UObject | any): NiagaraDataInterfaceGBuffer;
}

declare class NiagaraDataInterfacePhysicsAsset extends NiagaraDataInterface { 
	DefaultSource: PhysicsAsset;
	SoftSourceActor: Actor;
	SourceActor: Actor;
	MeshUserParameter: NiagaraUserParameterBinding;
	static Load(ResourceName: string): NiagaraDataInterfacePhysicsAsset;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfacePhysicsAsset;
	static GetDefaultObject(): NiagaraDataInterfacePhysicsAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfacePhysicsAsset;
	static C(Other: UObject | any): NiagaraDataInterfacePhysicsAsset;
}

declare class NiagaraPhysicsAssetDICollectorInterface extends Interface { 
	static Load(ResourceName: string): NiagaraPhysicsAssetDICollectorInterface;
	static Find(Outer: UObject, ResourceName: string): NiagaraPhysicsAssetDICollectorInterface;
	static GetDefaultObject(): NiagaraPhysicsAssetDICollectorInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPhysicsAssetDICollectorInterface;
	static C(Other: UObject | any): NiagaraPhysicsAssetDICollectorInterface;
}

declare type ENiagaraGpuSyncMode = 'None' | 'SyncCpuToGpu' | 'SyncGpuToCpu' | 'SyncBoth' | 'ENiagaraGpuSyncMode_MAX';
declare var ENiagaraGpuSyncMode : { None:'None',SyncCpuToGpu:'SyncCpuToGpu',SyncGpuToCpu:'SyncGpuToCpu',SyncBoth:'SyncBoth',ENiagaraGpuSyncMode_MAX:'ENiagaraGpuSyncMode_MAX', };
declare class NiagaraDataInterfaceSimpleCounter extends NiagaraDataInterface { 
	GpuSyncMode: ENiagaraGpuSyncMode;
	InitialValue: number;
	static Load(ResourceName: string): NiagaraDataInterfaceSimpleCounter;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceSimpleCounter;
	static GetDefaultObject(): NiagaraDataInterfaceSimpleCounter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceSimpleCounter;
	static C(Other: UObject | any): NiagaraDataInterfaceSimpleCounter;
}

declare type ENDIStaticMesh_SourceMode = 'Default' | 'Source' | 'AttachParent' | 'DefaultMeshOnly' | 'ENDIStaticMesh_MAX';
declare var ENDIStaticMesh_SourceMode : { Default:'Default',Source:'Source',AttachParent:'AttachParent',DefaultMeshOnly:'DefaultMeshOnly',ENDIStaticMesh_MAX:'ENDIStaticMesh_MAX', };
declare class NDIStaticMeshSectionFilter { 
	AllowedMaterialSlots: number[];
	clone() : NDIStaticMeshSectionFilter;
	static C(Other: UObject | any): NDIStaticMeshSectionFilter;
}

declare class NiagaraDataInterfaceStaticMesh extends NiagaraDataInterface { 
	SourceMode: ENDIStaticMesh_SourceMode;
	PreviewMesh: StaticMesh;
	DefaultMesh: StaticMesh;
	SoftSourceActor: Actor;
	Source: Actor;
	SourceComponent: StaticMeshComponent;
	SectionFilter: NDIStaticMeshSectionFilter;
	bUsePhysicsBodyVelocity: boolean;
	FilteredSockets: string[];
	static Load(ResourceName: string): NiagaraDataInterfaceStaticMesh;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceStaticMesh;
	static GetDefaultObject(): NiagaraDataInterfaceStaticMesh;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceStaticMesh;
	OnSourceEndPlay(InSource: Actor,Reason: EEndPlayReason): void;
	static C(Other: UObject | any): NiagaraDataInterfaceStaticMesh;
}

declare class NiagaraUObjectPropertyReaderRemap { 
	GraphName: string;
	RemapName: string;
	clone() : NiagaraUObjectPropertyReaderRemap;
	static C(Other: UObject | any): NiagaraUObjectPropertyReaderRemap;
}

declare class NiagaraDataInterfaceUObjectPropertyReader extends NiagaraDataInterface { 
	UObjectParameterBinding: NiagaraUserParameterBinding;
	PropertyRemap: NiagaraUObjectPropertyReaderRemap[];
	SourceActor: Actor;
	SourceActorComponentClass: UnrealEngineClass;
	static Load(ResourceName: string): NiagaraDataInterfaceUObjectPropertyReader;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceUObjectPropertyReader;
	static GetDefaultObject(): NiagaraDataInterfaceUObjectPropertyReader;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceUObjectPropertyReader;
	static SetUObjectReaderPropertyRemap(NiagaraComponent: NiagaraComponent,UserParameterName: string,GraphName: string,RemapName: string): void;
	static C(Other: UObject | any): NiagaraDataInterfaceUObjectPropertyReader;
}

declare type ENiagaraSystemSpawnSectionStartBehavior = 'Activate' | 'ENiagaraSystemSpawnSectionStartBehavior_MAX';
declare var ENiagaraSystemSpawnSectionStartBehavior : { Activate:'Activate',ENiagaraSystemSpawnSectionStartBehavior_MAX:'ENiagaraSystemSpawnSectionStartBehavior_MAX', };
declare type ENiagaraSystemSpawnSectionEvaluateBehavior = 'ActivateIfInactive' | 'None' | 'ENiagaraSystemSpawnSectionEvaluateBehavior_MAX';
declare var ENiagaraSystemSpawnSectionEvaluateBehavior : { ActivateIfInactive:'ActivateIfInactive',None:'None',ENiagaraSystemSpawnSectionEvaluateBehavior_MAX:'ENiagaraSystemSpawnSectionEvaluateBehavior_MAX', };
declare type ENiagaraSystemSpawnSectionEndBehavior = 'SetSystemInactive' | 'Deactivate' | 'None' | 'ENiagaraSystemSpawnSectionEndBehavior_MAX';
declare var ENiagaraSystemSpawnSectionEndBehavior : { SetSystemInactive:'SetSystemInactive',Deactivate:'Deactivate',None:'None',ENiagaraSystemSpawnSectionEndBehavior_MAX:'ENiagaraSystemSpawnSectionEndBehavior_MAX', };
declare class MovieSceneNiagaraSystemSpawnSection extends MovieSceneSection { 
	SectionStartBehavior: ENiagaraSystemSpawnSectionStartBehavior;
	SectionEvaluateBehavior: ENiagaraSystemSpawnSectionEvaluateBehavior;
	SectionEndBehavior: ENiagaraSystemSpawnSectionEndBehavior;
	AgeUpdateMode: ENiagaraAgeUpdateMode;
	bAllowScalability: boolean;
	static Load(ResourceName: string): MovieSceneNiagaraSystemSpawnSection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraSystemSpawnSection;
	static GetDefaultObject(): MovieSceneNiagaraSystemSpawnSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraSystemSpawnSection;
	static C(Other: UObject | any): MovieSceneNiagaraSystemSpawnSection;
}

declare class MovieSceneNiagaraTrack extends MovieSceneNameableTrack { 
	Sections: MovieSceneSection[];
	static Load(ResourceName: string): MovieSceneNiagaraTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraTrack;
	static GetDefaultObject(): MovieSceneNiagaraTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraTrack;
	static C(Other: UObject | any): MovieSceneNiagaraTrack;
}

declare class MovieSceneNiagaraSystemTrack extends MovieSceneNiagaraTrack { 
	static Load(ResourceName: string): MovieSceneNiagaraSystemTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraSystemTrack;
	static GetDefaultObject(): MovieSceneNiagaraSystemTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraSystemTrack;
	static C(Other: UObject | any): MovieSceneNiagaraSystemTrack;
}

declare class MovieSceneNiagaraParameterTrack extends MovieSceneNiagaraTrack { 
	Parameter: NiagaraVariable;
	static Load(ResourceName: string): MovieSceneNiagaraParameterTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraParameterTrack;
	static GetDefaultObject(): MovieSceneNiagaraParameterTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraParameterTrack;
	static C(Other: UObject | any): MovieSceneNiagaraParameterTrack;
}

declare class MovieSceneNiagaraBoolParameterTrack extends MovieSceneNiagaraParameterTrack { 
	static Load(ResourceName: string): MovieSceneNiagaraBoolParameterTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraBoolParameterTrack;
	static GetDefaultObject(): MovieSceneNiagaraBoolParameterTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraBoolParameterTrack;
	static C(Other: UObject | any): MovieSceneNiagaraBoolParameterTrack;
}

declare class MovieSceneNiagaraColorParameterTrack extends MovieSceneNiagaraParameterTrack { 
	static Load(ResourceName: string): MovieSceneNiagaraColorParameterTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraColorParameterTrack;
	static GetDefaultObject(): MovieSceneNiagaraColorParameterTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraColorParameterTrack;
	static C(Other: UObject | any): MovieSceneNiagaraColorParameterTrack;
}

declare class MovieSceneNiagaraFloatParameterTrack extends MovieSceneNiagaraParameterTrack { 
	static Load(ResourceName: string): MovieSceneNiagaraFloatParameterTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraFloatParameterTrack;
	static GetDefaultObject(): MovieSceneNiagaraFloatParameterTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraFloatParameterTrack;
	static C(Other: UObject | any): MovieSceneNiagaraFloatParameterTrack;
}

declare class MovieSceneNiagaraIntegerParameterTrack extends MovieSceneNiagaraParameterTrack { 
	static Load(ResourceName: string): MovieSceneNiagaraIntegerParameterTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraIntegerParameterTrack;
	static GetDefaultObject(): MovieSceneNiagaraIntegerParameterTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraIntegerParameterTrack;
	static C(Other: UObject | any): MovieSceneNiagaraIntegerParameterTrack;
}

declare class MovieSceneNiagaraVectorParameterTrack extends MovieSceneNiagaraParameterTrack { 
	ChannelsUsed: number;
	static Load(ResourceName: string): MovieSceneNiagaraVectorParameterTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraVectorParameterTrack;
	static GetDefaultObject(): MovieSceneNiagaraVectorParameterTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraVectorParameterTrack;
	static C(Other: UObject | any): MovieSceneNiagaraVectorParameterTrack;
}

declare class NiagaraActor extends Actor { 
	NiagaraComponent: NiagaraComponent;
	SpriteComponent: BillboardComponent;
	ArrowComponent: ArrowComponent;
	bDestroyOnSystemFinish: boolean;
	static GetDefaultObject(): NiagaraActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraActor;
	SetDestroyOnSystemFinish(bShouldDestroyOnSystemFinish: boolean): void;
	OnNiagaraSystemFinished(FinishedComponent: NiagaraComponent): void;
	static C(Other: UObject | any): NiagaraActor;
}

declare class NiagaraBakerOutputSimCache extends NiagaraBakerOutput { 
	SimCacheAssetPathFormat: string;
	CreateParameters: NiagaraSimCacheCreateParameters;
	static Load(ResourceName: string): NiagaraBakerOutputSimCache;
	static Find(Outer: UObject, ResourceName: string): NiagaraBakerOutputSimCache;
	static GetDefaultObject(): NiagaraBakerOutputSimCache;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraBakerOutputSimCache;
	static C(Other: UObject | any): NiagaraBakerOutputSimCache;
}

declare class NiagaraBakerOutputTexture2D extends NiagaraBakerOutput { 
	SourceBinding: NiagaraBakerTextureSource;
	bGenerateAtlas: boolean;
	bGenerateFrames: boolean;
	bExportFrames: boolean;
	bSetTextureAddressX: boolean;
	bSetTextureAddressY: boolean;
	FrameSize: IntPoint;
	AtlasTextureSize: IntPoint;
	TextureAddressX: TextureAddress;
	TextureAddressY: TextureAddress;
	AtlasAssetPathFormat: string;
	FramesAssetPathFormat: string;
	FramesExportPathFormat: string;
	static Load(ResourceName: string): NiagaraBakerOutputTexture2D;
	static Find(Outer: UObject, ResourceName: string): NiagaraBakerOutputTexture2D;
	static GetDefaultObject(): NiagaraBakerOutputTexture2D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraBakerOutputTexture2D;
	static C(Other: UObject | any): NiagaraBakerOutputTexture2D;
}

declare class NiagaraBakerOutputVolumeTexture extends NiagaraBakerOutput { 
	SourceBinding: NiagaraBakerTextureSource;
	bGenerateAtlas: boolean;
	bGenerateFrames: boolean;
	bExportFrames: boolean;
	AtlasAssetPathFormat: string;
	FramesAssetPathFormat: string;
	FramesExportPathFormat: string;
	static Load(ResourceName: string): NiagaraBakerOutputVolumeTexture;
	static Find(Outer: UObject, ResourceName: string): NiagaraBakerOutputVolumeTexture;
	static GetDefaultObject(): NiagaraBakerOutputVolumeTexture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraBakerOutputVolumeTexture;
	static C(Other: UObject | any): NiagaraBakerOutputVolumeTexture;
}

declare class NCPoolElement { 
	Component: NiagaraComponent;
	clone() : NCPoolElement;
	static C(Other: UObject | any): NCPoolElement;
}

declare class NCPool { 
	FreeElements: NCPoolElement[];
	clone() : NCPool;
	static C(Other: UObject | any): NCPool;
}

declare class NiagaraComponentPool extends UObject { 
	WorldParticleSystemPools: Map<NiagaraSystem, NCPool>;
	static Load(ResourceName: string): NiagaraComponentPool;
	static Find(Outer: UObject, ResourceName: string): NiagaraComponentPool;
	static GetDefaultObject(): NiagaraComponentPool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraComponentPool;
	static C(Other: UObject | any): NiagaraComponentPool;
}

declare class NiagaraComponentPropertyBinding { 
	AttributeBinding: NiagaraVariableAttributeBinding;
	PropertyName: string;
	PropertyType: NiagaraTypeDefinition;
	MetadataSetterName: string;
	PropertySetterParameterDefaults: Map<string, string>;
	clone() : NiagaraComponentPropertyBinding;
	static C(Other: UObject | any): NiagaraComponentPropertyBinding;
}

declare class NiagaraComponentRendererProperties extends NiagaraRendererProperties { 
	ComponentType: UnrealEngineClass;
	ComponentCountLimit: number;
	EnabledBinding: NiagaraVariableAttributeBinding;
	RendererVisibilityTagBinding: NiagaraVariableAttributeBinding;
	bAssignComponentsOnParticleID: boolean;
	bCreateComponentFirstParticleFrame: boolean;
	bOnlyActivateNewlyAquiredComponents: boolean;
	bVisualizeComponents: boolean;
	bOnlyCreateComponentsOnParticleSpawn: boolean;
	RendererVisibility: number;
	TemplateComponent: SceneComponent;
	PropertyBindings: NiagaraComponentPropertyBinding[];
	static Load(ResourceName: string): NiagaraComponentRendererProperties;
	static Find(Outer: UObject, ResourceName: string): NiagaraComponentRendererProperties;
	static GetDefaultObject(): NiagaraComponentRendererProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraComponentRendererProperties;
	static C(Other: UObject | any): NiagaraComponentRendererProperties;
}

declare class NiagaraEmitterNameSettingsRef { 
	SystemName: string;
	EmitterName: string;
	clone() : NiagaraEmitterNameSettingsRef;
	static C(Other: UObject | any): NiagaraEmitterNameSettingsRef;
}

declare class NiagaraComponentSettings extends UObject { 
	SuppressActivationList: Set<string>;
	ForceAutoPooolingList: Set<string>;
	SuppressEmitterList: Set<NiagaraEmitterNameSettingsRef>;
	GPUEmitterAllowList: Set<NiagaraEmitterNameSettingsRef>;
	GpuDataInterfaceDenyList: Set<string>;
	static Load(ResourceName: string): NiagaraComponentSettings;
	static Find(Outer: UObject, ResourceName: string): NiagaraComponentSettings;
	static GetDefaultObject(): NiagaraComponentSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraComponentSettings;
	static C(Other: UObject | any): NiagaraComponentSettings;
}

declare class NiagaraDataInterface2DArrayTexture extends NiagaraDataInterface { 
	Texture: Texture;
	TextureUserParameter: NiagaraUserParameterBinding;
	static Load(ResourceName: string): NiagaraDataInterface2DArrayTexture;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterface2DArrayTexture;
	static GetDefaultObject(): NiagaraDataInterface2DArrayTexture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterface2DArrayTexture;
	static C(Other: UObject | any): NiagaraDataInterface2DArrayTexture;
}

declare class NiagaraDataInterfaceRWBase extends NiagaraDataInterface { 
	static Load(ResourceName: string): NiagaraDataInterfaceRWBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceRWBase;
	static GetDefaultObject(): NiagaraDataInterfaceRWBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceRWBase;
	static C(Other: UObject | any): NiagaraDataInterfaceRWBase;
}

declare class NiagaraDataInterfaceArray extends NiagaraDataInterfaceRWBase { 
	GpuSyncMode: ENiagaraGpuSyncMode;
	MaxElements: number;
	static Load(ResourceName: string): NiagaraDataInterfaceArray;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArray;
	static GetDefaultObject(): NiagaraDataInterfaceArray;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArray;
	static C(Other: UObject | any): NiagaraDataInterfaceArray;
}

declare class NiagaraDataInterfaceArrayFloat extends NiagaraDataInterfaceArray { 
	FloatData: number[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayFloat;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayFloat;
	static GetDefaultObject(): NiagaraDataInterfaceArrayFloat;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayFloat;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayFloat;
}

declare class NiagaraDataInterfaceArrayFloat2 extends NiagaraDataInterfaceArray { 
	FloatData: Vector2D[];
	InternalFloatData: Vector2f[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayFloat2;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayFloat2;
	static GetDefaultObject(): NiagaraDataInterfaceArrayFloat2;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayFloat2;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayFloat2;
}

declare class NiagaraDataInterfaceArrayFloat3 extends NiagaraDataInterfaceArray { 
	FloatData: Vector[];
	InternalFloatData: Vector3f[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayFloat3;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayFloat3;
	static GetDefaultObject(): NiagaraDataInterfaceArrayFloat3;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayFloat3;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayFloat3;
}

declare class NiagaraPosition extends Vector3f { 
	clone() : NiagaraPosition;
	static C(Other: UObject | any): NiagaraPosition;
}

declare class NiagaraDataInterfaceArrayPosition extends NiagaraDataInterfaceArray { 
	PositionData: NiagaraPosition[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayPosition;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayPosition;
	static GetDefaultObject(): NiagaraDataInterfaceArrayPosition;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayPosition;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayPosition;
}

declare class NiagaraDataInterfaceArrayFloat4 extends NiagaraDataInterfaceArray { 
	FloatData: Vector4[];
	InternalFloatData: Vector4f[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayFloat4;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayFloat4;
	static GetDefaultObject(): NiagaraDataInterfaceArrayFloat4;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayFloat4;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayFloat4;
}

declare class NiagaraDataInterfaceArrayColor extends NiagaraDataInterfaceArray { 
	ColorData: LinearColor[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayColor;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayColor;
	static GetDefaultObject(): NiagaraDataInterfaceArrayColor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayColor;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayColor;
}

declare class NiagaraDataInterfaceArrayQuat extends NiagaraDataInterfaceArray { 
	QuatData: Quat[];
	InternalQuatData: Quat4f[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayQuat;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayQuat;
	static GetDefaultObject(): NiagaraDataInterfaceArrayQuat;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayQuat;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayQuat;
}

declare class NiagaraDataInterfaceArrayFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): NiagaraDataInterfaceArrayFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayFunctionLibrary;
	static GetDefaultObject(): NiagaraDataInterfaceArrayFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayFunctionLibrary;
	static SetNiagaraArrayVectorValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Vector,bSizeToFit: boolean): void;
	static SetNiagaraArrayVector4Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Vector4,bSizeToFit: boolean): void;
	static SetNiagaraArrayVector4(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Vector4[]): void;
	static SetNiagaraArrayVector2DValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Vector2D,bSizeToFit: boolean): void;
	static SetNiagaraArrayVector2D(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Vector2D[]): void;
	static SetNiagaraArrayVector(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Vector[]): void;
	static SetNiagaraArrayUInt8Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	static SetNiagaraArrayUInt8(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: number[]): void;
	static SetNiagaraArrayQuatValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Quat,bSizeToFit: boolean): void;
	static SetNiagaraArrayQuat(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Quat[]): void;
	static SetNiagaraArrayPositionValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Vector,bSizeToFit: boolean): void;
	static SetNiagaraArrayPosition(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Vector[]): void;
	static SetNiagaraArrayInt32Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	static SetNiagaraArrayInt32(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: number[]): void;
	static SetNiagaraArrayFloatValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	static SetNiagaraArrayFloat(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: number[]): void;
	static SetNiagaraArrayColorValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: LinearColor,bSizeToFit: boolean): void;
	static SetNiagaraArrayColor(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: LinearColor[]): void;
	static SetNiagaraArrayBoolValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: boolean,bSizeToFit: boolean): void;
	static SetNiagaraArrayBool(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: boolean[]): void;
	static GetNiagaraArrayVectorValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Vector;
	static GetNiagaraArrayVector4Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Vector4;
	static GetNiagaraArrayVector4(NiagaraSystem: NiagaraComponent,OverrideName: string): Vector4[];
	static GetNiagaraArrayVector2DValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Vector2D;
	static GetNiagaraArrayVector2D(NiagaraSystem: NiagaraComponent,OverrideName: string): Vector2D[];
	static GetNiagaraArrayVector(NiagaraSystem: NiagaraComponent,OverrideName: string): Vector[];
	static GetNiagaraArrayUInt8Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): number;
	static GetNiagaraArrayUInt8(NiagaraSystem: NiagaraComponent,OverrideName: string): number[];
	static GetNiagaraArrayQuatValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Quat;
	static GetNiagaraArrayQuat(NiagaraSystem: NiagaraComponent,OverrideName: string): Quat[];
	static GetNiagaraArrayPositionValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Vector;
	static GetNiagaraArrayPosition(NiagaraSystem: NiagaraComponent,OverrideName: string): Vector[];
	static GetNiagaraArrayInt32Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): number;
	static GetNiagaraArrayInt32(NiagaraSystem: NiagaraComponent,OverrideName: string): number[];
	static GetNiagaraArrayFloatValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): number;
	static GetNiagaraArrayFloat(NiagaraSystem: NiagaraComponent,OverrideName: string): number[];
	static GetNiagaraArrayColorValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): LinearColor;
	static GetNiagaraArrayColor(NiagaraSystem: NiagaraComponent,OverrideName: string): LinearColor[];
	static GetNiagaraArrayBoolValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): boolean;
	static GetNiagaraArrayBool(NiagaraSystem: NiagaraComponent,OverrideName: string): boolean[];
	static C(Other: UObject | any): NiagaraDataInterfaceArrayFunctionLibrary;
}

declare class NiagaraDataInterfaceArrayInt32 extends NiagaraDataInterfaceArray { 
	IntData: number[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayInt32;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayInt32;
	static GetDefaultObject(): NiagaraDataInterfaceArrayInt32;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayInt32;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayInt32;
}

declare class NiagaraDataInterfaceArrayUInt8 extends NiagaraDataInterfaceArray { 
	IntData: number[];
	InternalIntData: number[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayUInt8;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayUInt8;
	static GetDefaultObject(): NiagaraDataInterfaceArrayUInt8;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayUInt8;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayUInt8;
}

declare class NiagaraDataInterfaceArrayBool extends NiagaraDataInterfaceArray { 
	BoolData: boolean[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayBool;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayBool;
	static GetDefaultObject(): NiagaraDataInterfaceArrayBool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayBool;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayBool;
}

declare class NiagaraID { 
	Index: number;
	AcquireTag: number;
	clone() : NiagaraID;
	static C(Other: UObject | any): NiagaraID;
}

declare class NiagaraDataInterfaceArrayNiagaraID extends NiagaraDataInterfaceArray { 
	IntData: NiagaraID[];
	static Load(ResourceName: string): NiagaraDataInterfaceArrayNiagaraID;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceArrayNiagaraID;
	static GetDefaultObject(): NiagaraDataInterfaceArrayNiagaraID;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceArrayNiagaraID;
	static C(Other: UObject | any): NiagaraDataInterfaceArrayNiagaraID;
}

declare class NiagaraDataInterfaceAudioSubmix extends NiagaraDataInterface { 
	Submix: SoundSubmix;
	static Load(ResourceName: string): NiagaraDataInterfaceAudioSubmix;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceAudioSubmix;
	static GetDefaultObject(): NiagaraDataInterfaceAudioSubmix;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceAudioSubmix;
	static C(Other: UObject | any): NiagaraDataInterfaceAudioSubmix;
}

declare class NiagaraDataInterfaceAudioOscilloscope extends NiagaraDataInterface { 
	Submix: SoundSubmix;
	Resolution: number;
	ScopeInMilliseconds: number;
	static Load(ResourceName: string): NiagaraDataInterfaceAudioOscilloscope;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceAudioOscilloscope;
	static GetDefaultObject(): NiagaraDataInterfaceAudioOscilloscope;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceAudioOscilloscope;
	static C(Other: UObject | any): NiagaraDataInterfaceAudioOscilloscope;
}

declare class NiagaraDataInterfaceAudioPlayer extends NiagaraDataInterface { 
	SoundToPlay: SoundBase;
	Attenuation: SoundAttenuation;
	Concurrency: SoundConcurrency;
	ParameterNames: string[];
	bLimitPlaysPerTick: boolean;
	MaxPlaysPerTick: number;
	bStopWhenComponentIsDestroyed: boolean;
	bAllowLoopingOneShotSounds: boolean;
	bOnlyActiveDuringGameplay: boolean;
	static Load(ResourceName: string): NiagaraDataInterfaceAudioPlayer;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceAudioPlayer;
	static GetDefaultObject(): NiagaraDataInterfaceAudioPlayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceAudioPlayer;
	static C(Other: UObject | any): NiagaraDataInterfaceAudioPlayer;
}

declare class NiagaraDataInterfaceAudioSpectrum extends NiagaraDataInterfaceAudioSubmix { 
	Resolution: number;
	MinimumFrequency: number;
	MaximumFrequency: number;
	NoiseFloorDb: number;
	static Load(ResourceName: string): NiagaraDataInterfaceAudioSpectrum;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceAudioSpectrum;
	static GetDefaultObject(): NiagaraDataInterfaceAudioSpectrum;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceAudioSpectrum;
	static C(Other: UObject | any): NiagaraDataInterfaceAudioSpectrum;
}

declare class NiagaraDataInterfaceCamera extends NiagaraDataInterface { 
	PlayerControllerIndex: number;
	bRequireCurrentFrameData: boolean;
	static Load(ResourceName: string): NiagaraDataInterfaceCamera;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceCamera;
	static GetDefaultObject(): NiagaraDataInterfaceCamera;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceCamera;
	static C(Other: UObject | any): NiagaraDataInterfaceCamera;
}

declare class NiagaraDataInterfaceCollisionQuery extends NiagaraDataInterface { 
	static Load(ResourceName: string): NiagaraDataInterfaceCollisionQuery;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceCollisionQuery;
	static GetDefaultObject(): NiagaraDataInterfaceCollisionQuery;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceCollisionQuery;
	static C(Other: UObject | any): NiagaraDataInterfaceCollisionQuery;
}

declare class NiagaraDataInterfaceCurveBase extends NiagaraDataInterface { 
	ShaderLUT: number[];
	LUTMinTime: number;
	LUTMaxTime: number;
	LUTInvTimeRange: number;
	LUTNumSamplesMinusOne: number;
	bUseLUT: boolean;
	bExposeCurve: boolean;
	bOptimizeLUT: boolean;
	bOverrideOptimizeThreshold: boolean;
	HasEditorData: boolean;
	OptimizeThreshold: number;
	ExposedName: string;
	ExposedTexture: Texture2D;
	static Load(ResourceName: string): NiagaraDataInterfaceCurveBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceCurveBase;
	static GetDefaultObject(): NiagaraDataInterfaceCurveBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceCurveBase;
	static C(Other: UObject | any): NiagaraDataInterfaceCurveBase;
}

declare class NiagaraDataInterfaceColorCurve extends NiagaraDataInterfaceCurveBase { 
	RedCurve: RichCurve;
	GreenCurve: RichCurve;
	BlueCurve: RichCurve;
	AlphaCurve: RichCurve;
	RedCurveCookedEditorCache: RichCurve;
	GreenCurveCookedEditorCache: RichCurve;
	BlueCurveCookedEditorCache: RichCurve;
	AlphaCurveCookedEditorCache: RichCurve;
	static Load(ResourceName: string): NiagaraDataInterfaceColorCurve;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceColorCurve;
	static GetDefaultObject(): NiagaraDataInterfaceColorCurve;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceColorCurve;
	static C(Other: UObject | any): NiagaraDataInterfaceColorCurve;
}

declare class NiagaraDataInterfaceCubeTexture extends NiagaraDataInterface { 
	Texture: Texture;
	TextureUserParameter: NiagaraUserParameterBinding;
	static Load(ResourceName: string): NiagaraDataInterfaceCubeTexture;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceCubeTexture;
	static GetDefaultObject(): NiagaraDataInterfaceCubeTexture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceCubeTexture;
	static C(Other: UObject | any): NiagaraDataInterfaceCubeTexture;
}

declare class NiagaraDataInterfaceCurlNoise extends NiagaraDataInterface { 
	Seed: number;
	static Load(ResourceName: string): NiagaraDataInterfaceCurlNoise;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceCurlNoise;
	static GetDefaultObject(): NiagaraDataInterfaceCurlNoise;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceCurlNoise;
	static C(Other: UObject | any): NiagaraDataInterfaceCurlNoise;
}

declare class NiagaraDataInterfaceCurve extends NiagaraDataInterfaceCurveBase { 
	Curve: RichCurve;
	CurveCookedEditorCache: RichCurve;
	static Load(ResourceName: string): NiagaraDataInterfaceCurve;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceCurve;
	static GetDefaultObject(): NiagaraDataInterfaceCurve;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceCurve;
	static C(Other: UObject | any): NiagaraDataInterfaceCurve;
}

declare class BasicParticleData { 
	Position: Vector;
	Size: number;
	Velocity: Vector;
	clone() : BasicParticleData;
	static C(Other: UObject | any): BasicParticleData;
}

declare class NiagaraParticleCallbackHandler extends Interface { 
	static Load(ResourceName: string): NiagaraParticleCallbackHandler;
	static Find(Outer: UObject, ResourceName: string): NiagaraParticleCallbackHandler;
	static GetDefaultObject(): NiagaraParticleCallbackHandler;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraParticleCallbackHandler;
	ReceiveParticleData(Data: BasicParticleData[],NiagaraSystem: NiagaraSystem,SimulationPositionOffset: Vector): void;
	static C(Other: UObject | any): NiagaraParticleCallbackHandler;
}

declare type ENDIExport_GPUAllocationMode = 'FixedSize' | 'PerParticle' | 'ENDIExport_MAX';
declare var ENDIExport_GPUAllocationMode : { FixedSize:'FixedSize',PerParticle:'PerParticle',ENDIExport_MAX:'ENDIExport_MAX', };
declare class NiagaraDataInterfaceExport extends NiagaraDataInterface { 
	CallbackHandlerParameter: NiagaraUserParameterBinding;
	GPUAllocationMode: ENDIExport_GPUAllocationMode;
	GPUAllocationFixedSize: number;
	GPUAllocationPerParticleSize: number;
	static Load(ResourceName: string): NiagaraDataInterfaceExport;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceExport;
	static GetDefaultObject(): NiagaraDataInterfaceExport;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceExport;
	static C(Other: UObject | any): NiagaraDataInterfaceExport;
}

declare class NiagaraDataInterfaceGrid2D extends NiagaraDataInterfaceRWBase { 
	NumCellsX: number;
	NumCellsY: number;
	NumCellsMaxAxis: number;
	NumAttributes: number;
	SetGridFromMaxAxis: boolean;
	WorldBBoxSize: Vector2D;
	static Load(ResourceName: string): NiagaraDataInterfaceGrid2D;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceGrid2D;
	static GetDefaultObject(): NiagaraDataInterfaceGrid2D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceGrid2D;
	static C(Other: UObject | any): NiagaraDataInterfaceGrid2D;
}

declare class NiagaraDataInterfaceGrid2DCollection extends NiagaraDataInterfaceGrid2D { 
	RenderTargetUserParameter: NiagaraUserParameterBinding;
	OverrideBufferFormat: ENiagaraGpuBufferFormat;
	bOverrideFormat: boolean;
	bPreviewGrid: boolean;
	PreviewAttribute: string;
	ManagedRenderTargets: Map<number, TextureRenderTarget2DArray>;
	static Load(ResourceName: string): NiagaraDataInterfaceGrid2DCollection;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceGrid2DCollection;
	static GetDefaultObject(): NiagaraDataInterfaceGrid2DCollection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceGrid2DCollection;
	GetTextureSize(Component: NiagaraComponent,SizeX?: number,SizeY?: number): {SizeX: number, SizeY: number};
	GetRawTextureSize(Component: NiagaraComponent,SizeX?: number,SizeY?: number): {SizeX: number, SizeY: number};
	FillTexture2D(Component: NiagaraComponent,Dest: TextureRenderTarget2D,AttributeIndex: number): boolean;
	FillRawTexture2D(Component: NiagaraComponent,Dest: TextureRenderTarget2D,TilesX?: number,TilesY?: number): {TilesX: number, TilesY: number, $: boolean};
	static C(Other: UObject | any): NiagaraDataInterfaceGrid2DCollection;
}

declare class NiagaraDataInterfaceGrid2DCollectionReader extends NiagaraDataInterfaceGrid2DCollection { 
	EmitterName: string;
	DIName: string;
	static Load(ResourceName: string): NiagaraDataInterfaceGrid2DCollectionReader;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceGrid2DCollectionReader;
	static GetDefaultObject(): NiagaraDataInterfaceGrid2DCollectionReader;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceGrid2DCollectionReader;
	static C(Other: UObject | any): NiagaraDataInterfaceGrid2DCollectionReader;
}

declare type ESetResolutionMethod = 'Independent' | 'MaxAxis' | 'CellSize' | 'ESetResolutionMethod_MAX';
declare var ESetResolutionMethod : { Independent:'Independent',MaxAxis:'MaxAxis',CellSize:'CellSize',ESetResolutionMethod_MAX:'ESetResolutionMethod_MAX', };
declare class NiagaraDataInterfaceGrid3D extends NiagaraDataInterfaceRWBase { 
	NumCells: IntVector;
	CellSize: number;
	NumCellsMaxAxis: number;
	SetResolutionMethod: ESetResolutionMethod;
	WorldBBoxSize: Vector;
	static Load(ResourceName: string): NiagaraDataInterfaceGrid3D;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceGrid3D;
	static GetDefaultObject(): NiagaraDataInterfaceGrid3D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceGrid3D;
	static C(Other: UObject | any): NiagaraDataInterfaceGrid3D;
}

declare class NiagaraDataInterfaceGrid3DCollection extends NiagaraDataInterfaceGrid3D { 
	NumAttributes: number;
	RenderTargetUserParameter: NiagaraUserParameterBinding;
	OverrideBufferFormat: ENiagaraGpuBufferFormat;
	bOverrideFormat: boolean;
	bPreviewGrid: boolean;
	PreviewAttribute: string;
	static Load(ResourceName: string): NiagaraDataInterfaceGrid3DCollection;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceGrid3DCollection;
	static GetDefaultObject(): NiagaraDataInterfaceGrid3DCollection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceGrid3DCollection;
	GetTextureSize(Component: NiagaraComponent,SizeX?: number,SizeY?: number,SizeZ?: number): {SizeX: number, SizeY: number, SizeZ: number};
	GetRawTextureSize(Component: NiagaraComponent,SizeX?: number,SizeY?: number,SizeZ?: number): {SizeX: number, SizeY: number, SizeZ: number};
	FillVolumeTexture(Component: NiagaraComponent,Dest: VolumeTexture,AttributeIndex: number): boolean;
	FillRawVolumeTexture(Component: NiagaraComponent,Dest: VolumeTexture,TilesX?: number,TilesY?: number,TileZ?: number): {TilesX: number, TilesY: number, TileZ: number, $: boolean};
	static C(Other: UObject | any): NiagaraDataInterfaceGrid3DCollection;
}

declare class NiagaraDataInterfaceGrid3DCollectionReader extends NiagaraDataInterfaceGrid3DCollection { 
	EmitterName: string;
	DIName: string;
	static Load(ResourceName: string): NiagaraDataInterfaceGrid3DCollectionReader;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceGrid3DCollectionReader;
	static GetDefaultObject(): NiagaraDataInterfaceGrid3DCollectionReader;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceGrid3DCollectionReader;
	static C(Other: UObject | any): NiagaraDataInterfaceGrid3DCollectionReader;
}

declare class NiagaraDataInterfaceIntRenderTarget2D extends NiagaraDataInterfaceRWBase { 
	Size: IntPoint;
	bPreviewRenderTarget: boolean;
	PreviewDisplayRange: Vector2D;
	RenderTargetUserParameter: NiagaraUserParameterBinding;
	ManagedRenderTargets: Map<number, TextureRenderTarget2D>;
	static Load(ResourceName: string): NiagaraDataInterfaceIntRenderTarget2D;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceIntRenderTarget2D;
	static GetDefaultObject(): NiagaraDataInterfaceIntRenderTarget2D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceIntRenderTarget2D;
	static C(Other: UObject | any): NiagaraDataInterfaceIntRenderTarget2D;
}

declare type ENDILandscape_SourceMode = 'Default' | 'Source' | 'AttachParent' | 'ENDILandscape_MAX';
declare var ENDILandscape_SourceMode : { Default:'Default',Source:'Source',AttachParent:'AttachParent',ENDILandscape_MAX:'ENDILandscape_MAX', };
declare class NiagaraDataInterfaceLandscape extends NiagaraDataInterface { 
	SourceLandscape: Actor;
	SourceMode: ENDILandscape_SourceMode;
	PhysicalMaterials: PhysicalMaterial[];
	static Load(ResourceName: string): NiagaraDataInterfaceLandscape;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceLandscape;
	static GetDefaultObject(): NiagaraDataInterfaceLandscape;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceLandscape;
	static C(Other: UObject | any): NiagaraDataInterfaceLandscape;
}

declare type ENiagaraMeshPivotOffsetSpace = 'Mesh' | 'Simulation' | 'World' | 'Local' | 'ENiagaraMeshPivotOffsetSpace_MAX';
declare var ENiagaraMeshPivotOffsetSpace : { Mesh:'Mesh',Simulation:'Simulation',World:'World',Local:'Local',ENiagaraMeshPivotOffsetSpace_MAX:'ENiagaraMeshPivotOffsetSpace_MAX', };
declare class NiagaraMeshRendererMeshProperties { 
	Mesh: StaticMesh;
	UserParamBinding: NiagaraUserParameterBinding;
	Scale: Vector;
	Rotation: Rotator;
	PivotOffset: Vector;
	PivotOffsetSpace: ENiagaraMeshPivotOffsetSpace;
	clone() : NiagaraMeshRendererMeshProperties;
	static C(Other: UObject | any): NiagaraMeshRendererMeshProperties;
}

declare class NiagaraMeshMaterialOverride { 
	ExplicitMat: MaterialInterface;
	UserParamBinding: NiagaraUserParameterBinding;
	clone() : NiagaraMeshMaterialOverride;
	static C(Other: UObject | any): NiagaraMeshMaterialOverride;
}

declare type ENiagaraMeshFacingMode = 'Default' | 'Velocity' | 'CameraPosition' | 'CameraPlane' | 'ENiagaraMeshFacingMode_MAX';
declare var ENiagaraMeshFacingMode : { Default:'Default',Velocity:'Velocity',CameraPosition:'CameraPosition',CameraPlane:'CameraPlane',ENiagaraMeshFacingMode_MAX:'ENiagaraMeshFacingMode_MAX', };
declare type ENiagaraMeshLockedAxisSpace = 'Simulation' | 'World' | 'Local' | 'ENiagaraMeshLockedAxisSpace_MAX';
declare var ENiagaraMeshLockedAxisSpace : { Simulation:'Simulation',World:'World',Local:'Local',ENiagaraMeshLockedAxisSpace_MAX:'ENiagaraMeshLockedAxisSpace_MAX', };
declare class NiagaraMeshRendererProperties extends NiagaraRendererProperties { 
	Meshes: NiagaraMeshRendererMeshProperties[];
	SourceMode: ENiagaraRendererSourceDataMode;
	SortMode: ENiagaraSortMode;
	bOverrideMaterials: boolean;
	bSortOnlyWhenTranslucent: boolean;
	SortPrecision: ENiagaraRendererSortPrecision;
	GpuTranslucentLatency: ENiagaraRendererGpuTranslucentLatency;
	bSubImageBlend: boolean;
	bEnableFrustumCulling: boolean;
	bEnableCameraDistanceCulling: boolean;
	bEnableMeshFlipbook: boolean;
	OverrideMaterials: NiagaraMeshMaterialOverride[];
	SubImageSize: Vector2D;
	FacingMode: ENiagaraMeshFacingMode;
	bLockedAxisEnable: boolean;
	LockedAxis: Vector;
	LockedAxisSpace: ENiagaraMeshLockedAxisSpace;
	MinCameraDistance: number;
	MaxCameraDistance: number;
	RendererVisibility: number;
	PositionBinding: NiagaraVariableAttributeBinding;
	ColorBinding: NiagaraVariableAttributeBinding;
	VelocityBinding: NiagaraVariableAttributeBinding;
	MeshOrientationBinding: NiagaraVariableAttributeBinding;
	ScaleBinding: NiagaraVariableAttributeBinding;
	SubImageIndexBinding: NiagaraVariableAttributeBinding;
	DynamicMaterialBinding: NiagaraVariableAttributeBinding;
	DynamicMaterial1Binding: NiagaraVariableAttributeBinding;
	DynamicMaterial2Binding: NiagaraVariableAttributeBinding;
	DynamicMaterial3Binding: NiagaraVariableAttributeBinding;
	MaterialRandomBinding: NiagaraVariableAttributeBinding;
	CustomSortingBinding: NiagaraVariableAttributeBinding;
	NormalizedAgeBinding: NiagaraVariableAttributeBinding;
	CameraOffsetBinding: NiagaraVariableAttributeBinding;
	RendererVisibilityTagBinding: NiagaraVariableAttributeBinding;
	MeshIndexBinding: NiagaraVariableAttributeBinding;
	MaterialParameters: NiagaraRendererMaterialParameters;
	MaterialParameterBindings: NiagaraMaterialAttributeBinding[];
	PrevPositionBinding: NiagaraVariableAttributeBinding;
	PrevScaleBinding: NiagaraVariableAttributeBinding;
	PrevMeshOrientationBinding: NiagaraVariableAttributeBinding;
	PrevCameraOffsetBinding: NiagaraVariableAttributeBinding;
	PrevVelocityBinding: NiagaraVariableAttributeBinding;
	FirstFlipbookFrame: StaticMesh;
	FlipbookSuffixFormat: string;
	FlipbookSuffixNumDigits: number;
	NumFlipbookFrames: number;
	ParticleMesh: StaticMesh;
	PivotOffset: Vector;
	PivotOffsetSpace: ENiagaraMeshPivotOffsetSpace;
	static Load(ResourceName: string): NiagaraMeshRendererProperties;
	static Find(Outer: UObject, ResourceName: string): NiagaraMeshRendererProperties;
	static GetDefaultObject(): NiagaraMeshRendererProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraMeshRendererProperties;
	static C(Other: UObject | any): NiagaraMeshRendererProperties;
}

declare class NiagaraDataInterfaceMeshRendererInfo extends NiagaraDataInterface { 
	MeshRenderer: NiagaraMeshRendererProperties;
	static Load(ResourceName: string): NiagaraDataInterfaceMeshRendererInfo;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceMeshRendererInfo;
	static GetDefaultObject(): NiagaraDataInterfaceMeshRendererInfo;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceMeshRendererInfo;
	static C(Other: UObject | any): NiagaraDataInterfaceMeshRendererInfo;
}

declare class NiagaraDataInterfaceNeighborGrid3D extends NiagaraDataInterfaceGrid3D { 
	MaxNeighborsPerCell: number;
	static Load(ResourceName: string): NiagaraDataInterfaceNeighborGrid3D;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceNeighborGrid3D;
	static GetDefaultObject(): NiagaraDataInterfaceNeighborGrid3D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceNeighborGrid3D;
	static C(Other: UObject | any): NiagaraDataInterfaceNeighborGrid3D;
}

declare class NiagaraDataInterfaceOcclusion extends NiagaraDataInterface { 
	static Load(ResourceName: string): NiagaraDataInterfaceOcclusion;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceOcclusion;
	static GetDefaultObject(): NiagaraDataInterfaceOcclusion;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceOcclusion;
	static C(Other: UObject | any): NiagaraDataInterfaceOcclusion;
}

declare class NiagaraDataInterfaceParticleRead extends NiagaraDataInterfaceRWBase { 
	EmitterName: string;
	static Load(ResourceName: string): NiagaraDataInterfaceParticleRead;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceParticleRead;
	static GetDefaultObject(): NiagaraDataInterfaceParticleRead;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceParticleRead;
	static C(Other: UObject | any): NiagaraDataInterfaceParticleRead;
}

declare class NiagaraDataInterfacePlatformSet extends NiagaraDataInterface { 
	Platforms: NiagaraPlatformSet;
	static Load(ResourceName: string): NiagaraDataInterfacePlatformSet;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfacePlatformSet;
	static GetDefaultObject(): NiagaraDataInterfacePlatformSet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfacePlatformSet;
	static C(Other: UObject | any): NiagaraDataInterfacePlatformSet;
}

declare class NiagaraDataInterfaceRasterizationGrid3D extends NiagaraDataInterfaceGrid3D { 
	NumAttributes: number;
	Precision: number;
	ResetValue: number;
	static Load(ResourceName: string): NiagaraDataInterfaceRasterizationGrid3D;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceRasterizationGrid3D;
	static GetDefaultObject(): NiagaraDataInterfaceRasterizationGrid3D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceRasterizationGrid3D;
	static C(Other: UObject | any): NiagaraDataInterfaceRasterizationGrid3D;
}

declare type ENiagaraMipMapGeneration = 'Disabled' | 'PostStage' | 'PostSimulate' | 'ENiagaraMipMapGeneration_MAX';
declare var ENiagaraMipMapGeneration : { Disabled:'Disabled',PostStage:'PostStage',PostSimulate:'PostSimulate',ENiagaraMipMapGeneration_MAX:'ENiagaraMipMapGeneration_MAX', };
declare type ENiagaraMipMapGenerationType = 'Unfiltered' | 'Linear' | 'Blur1' | 'Blur2' | 'Blur3' | 'Blur4' | 'ENiagaraMipMapGenerationType_MAX';
declare var ENiagaraMipMapGenerationType : { Unfiltered:'Unfiltered',Linear:'Linear',Blur1:'Blur1',Blur2:'Blur2',Blur3:'Blur3',Blur4:'Blur4',ENiagaraMipMapGenerationType_MAX:'ENiagaraMipMapGenerationType_MAX', };
declare class NiagaraDataInterfaceRenderTarget2D extends NiagaraDataInterfaceRWBase { 
	Size: IntPoint;
	MipMapGeneration: ENiagaraMipMapGeneration;
	MipMapGenerationType: ENiagaraMipMapGenerationType;
	OverrideRenderTargetFormat: ETextureRenderTargetFormat;
	bInheritUserParameterSettings: boolean;
	bOverrideFormat: boolean;
	bPreviewRenderTarget: boolean;
	RenderTargetUserParameter: NiagaraUserParameterBinding;
	ManagedRenderTargets: Map<number, TextureRenderTarget2D>;
	static Load(ResourceName: string): NiagaraDataInterfaceRenderTarget2D;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceRenderTarget2D;
	static GetDefaultObject(): NiagaraDataInterfaceRenderTarget2D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceRenderTarget2D;
	static C(Other: UObject | any): NiagaraDataInterfaceRenderTarget2D;
}

declare class NiagaraDataInterfaceRenderTarget2DArray extends NiagaraDataInterfaceRWBase { 
	Size: IntVector;
	OverrideRenderTargetFormat: ETextureRenderTargetFormat;
	bInheritUserParameterSettings: boolean;
	bOverrideFormat: boolean;
	bPreviewRenderTarget: boolean;
	RenderTargetUserParameter: NiagaraUserParameterBinding;
	ManagedRenderTargets: Map<number, TextureRenderTarget2DArray>;
	static Load(ResourceName: string): NiagaraDataInterfaceRenderTarget2DArray;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceRenderTarget2DArray;
	static GetDefaultObject(): NiagaraDataInterfaceRenderTarget2DArray;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceRenderTarget2DArray;
	static C(Other: UObject | any): NiagaraDataInterfaceRenderTarget2DArray;
}

declare class NiagaraDataInterfaceRenderTargetCube extends NiagaraDataInterfaceRWBase { 
	Size: number;
	OverrideRenderTargetFormat: ETextureRenderTargetFormat;
	bInheritUserParameterSettings: boolean;
	bOverrideFormat: boolean;
	bPreviewRenderTarget: boolean;
	RenderTargetUserParameter: NiagaraUserParameterBinding;
	ManagedRenderTargets: Map<number, TextureRenderTargetCube>;
	static Load(ResourceName: string): NiagaraDataInterfaceRenderTargetCube;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceRenderTargetCube;
	static GetDefaultObject(): NiagaraDataInterfaceRenderTargetCube;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceRenderTargetCube;
	static C(Other: UObject | any): NiagaraDataInterfaceRenderTargetCube;
}

declare class NiagaraDataInterfaceRenderTargetVolume extends NiagaraDataInterfaceRWBase { 
	Size: IntVector;
	OverrideRenderTargetFormat: ETextureRenderTargetFormat;
	bInheritUserParameterSettings: boolean;
	bOverrideFormat: boolean;
	bPreviewRenderTarget: boolean;
	RenderTargetUserParameter: NiagaraUserParameterBinding;
	ManagedRenderTargets: Map<number, TextureRenderTargetVolume>;
	static Load(ResourceName: string): NiagaraDataInterfaceRenderTargetVolume;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceRenderTargetVolume;
	static GetDefaultObject(): NiagaraDataInterfaceRenderTargetVolume;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceRenderTargetVolume;
	static C(Other: UObject | any): NiagaraDataInterfaceRenderTargetVolume;
}

declare class NiagaraDataInterfaceRigidMeshCollisionQuery extends NiagaraDataInterface { 
	Tag: string;
	ActorTags: string[];
	ComponentTags: string[];
	SourceActors: Actor[];
	OnlyUseMoveable: boolean;
	GlobalSearchAllowed: boolean;
	GlobalSearchForced: boolean;
	GlobalSearchFallback_Unscripted: boolean;
	MaxNumPrimitives: number;
	static Load(ResourceName: string): NiagaraDataInterfaceRigidMeshCollisionQuery;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceRigidMeshCollisionQuery;
	static GetDefaultObject(): NiagaraDataInterfaceRigidMeshCollisionQuery;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceRigidMeshCollisionQuery;
	static C(Other: UObject | any): NiagaraDataInterfaceRigidMeshCollisionQuery;
}

declare class NiagaraDIRigidMeshCollisionFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): NiagaraDIRigidMeshCollisionFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): NiagaraDIRigidMeshCollisionFunctionLibrary;
	static GetDefaultObject(): NiagaraDIRigidMeshCollisionFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDIRigidMeshCollisionFunctionLibrary;
	static SetSourceActors(NiagaraSystem: NiagaraComponent,OverrideName: string,SourceActors: Actor[]): void;
	static C(Other: UObject | any): NiagaraDIRigidMeshCollisionFunctionLibrary;
}

declare type ENDISkeletalMesh_SourceMode = 'Default' | 'Source' | 'AttachParent' | 'ENDISkeletalMesh_MAX';
declare var ENDISkeletalMesh_SourceMode : { Default:'Default',Source:'Source',AttachParent:'AttachParent',ENDISkeletalMesh_MAX:'ENDISkeletalMesh_MAX', };
declare type ENDISkeletalMesh_SkinningMode = 'Invalid' | 'None' | 'SkinOnTheFly' | 'PreSkin' | 'ENDISkeletalMesh_MAX';
declare var ENDISkeletalMesh_SkinningMode : { Invalid:'Invalid',None:'None',SkinOnTheFly:'SkinOnTheFly',PreSkin:'PreSkin',ENDISkeletalMesh_MAX:'ENDISkeletalMesh_MAX', };
declare class NiagaraDataInterfaceSkeletalMesh extends NiagaraDataInterface { 
	SourceMode: ENDISkeletalMesh_SourceMode;
	PreviewMesh: SkeletalMesh;
	SoftSourceActor: Actor;
	ComponentTags: string[];
	Source: Actor;
	SourceComponent: SkeletalMeshComponent;
	MeshUserParameter: NiagaraUserParameterBinding;
	SkinningMode: ENDISkeletalMesh_SkinningMode;
	SamplingRegions: string[];
	WholeMeshLOD: number;
	FilteredBones: string[];
	FilteredSockets: string[];
	ExcludeBoneName: string;
	bExcludeBone: boolean;
	UvSetIndex: number;
	bRequireCurrentFrameData: boolean;
	static Load(ResourceName: string): NiagaraDataInterfaceSkeletalMesh;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceSkeletalMesh;
	static GetDefaultObject(): NiagaraDataInterfaceSkeletalMesh;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceSkeletalMesh;
	OnSourceEndPlay(InSource: Actor,Reason: EEndPlayReason): void;
	static C(Other: UObject | any): NiagaraDataInterfaceSkeletalMesh;
}

declare class NiagaraDataInterfaceSpline extends NiagaraDataInterface { 
	Source: Actor;
	SplineUserParameter: NiagaraUserParameterBinding;
	bUseLUT: boolean;
	NumLUTSteps: number;
	static Load(ResourceName: string): NiagaraDataInterfaceSpline;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceSpline;
	static GetDefaultObject(): NiagaraDataInterfaceSpline;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceSpline;
	static C(Other: UObject | any): NiagaraDataInterfaceSpline;
}

declare class NiagaraDataInterfaceTexture extends NiagaraDataInterface { 
	Texture: Texture;
	TextureUserParameter: NiagaraUserParameterBinding;
	static Load(ResourceName: string): NiagaraDataInterfaceTexture;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceTexture;
	static GetDefaultObject(): NiagaraDataInterfaceTexture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceTexture;
	static C(Other: UObject | any): NiagaraDataInterfaceTexture;
}

declare class NiagaraDataInterfaceVector2DCurve extends NiagaraDataInterfaceCurveBase { 
	XCurve: RichCurve;
	YCurve: RichCurve;
	XCurveCookedEditorCache: RichCurve;
	YCurveCookedEditorCache: RichCurve;
	static Load(ResourceName: string): NiagaraDataInterfaceVector2DCurve;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceVector2DCurve;
	static GetDefaultObject(): NiagaraDataInterfaceVector2DCurve;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceVector2DCurve;
	static C(Other: UObject | any): NiagaraDataInterfaceVector2DCurve;
}

declare class NiagaraDataInterfaceVector4Curve extends NiagaraDataInterfaceCurveBase { 
	XCurve: RichCurve;
	YCurve: RichCurve;
	ZCurve: RichCurve;
	WCurve: RichCurve;
	XCurveCookedEditorCache: RichCurve;
	YCurveCookedEditorCache: RichCurve;
	ZCurveCookedEditorCache: RichCurve;
	WCurveCookedEditorCache: RichCurve;
	static Load(ResourceName: string): NiagaraDataInterfaceVector4Curve;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceVector4Curve;
	static GetDefaultObject(): NiagaraDataInterfaceVector4Curve;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceVector4Curve;
	static C(Other: UObject | any): NiagaraDataInterfaceVector4Curve;
}

declare class NiagaraDataInterfaceVectorCurve extends NiagaraDataInterfaceCurveBase { 
	XCurve: RichCurve;
	YCurve: RichCurve;
	ZCurve: RichCurve;
	XCurveCookedEditorCache: RichCurve;
	YCurveCookedEditorCache: RichCurve;
	ZCurveCookedEditorCache: RichCurve;
	static Load(ResourceName: string): NiagaraDataInterfaceVectorCurve;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceVectorCurve;
	static GetDefaultObject(): NiagaraDataInterfaceVectorCurve;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceVectorCurve;
	static C(Other: UObject | any): NiagaraDataInterfaceVectorCurve;
}

declare class NiagaraDataInterfaceVectorField extends NiagaraDataInterface { 
	Field: VectorField;
	bTileX: boolean;
	bTileY: boolean;
	bTileZ: boolean;
	static Load(ResourceName: string): NiagaraDataInterfaceVectorField;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceVectorField;
	static GetDefaultObject(): NiagaraDataInterfaceVectorField;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceVectorField;
	static C(Other: UObject | any): NiagaraDataInterfaceVectorField;
}

declare type EVolumeCacheType = 'OpenVDB' | 'EVolumeCacheType_MAX';
declare var EVolumeCacheType : { OpenVDB:'OpenVDB',EVolumeCacheType_MAX:'EVolumeCacheType_MAX', };
declare class VolumeCache extends UObject { 
	FilePath: string;
	CacheType: EVolumeCacheType;
	Resolution: IntVector;
	FrameRangeStart: number;
	FrameRangeEnd: number;
	static Load(ResourceName: string): VolumeCache;
	static Find(Outer: UObject, ResourceName: string): VolumeCache;
	static GetDefaultObject(): VolumeCache;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VolumeCache;
	static C(Other: UObject | any): VolumeCache;
}

declare class NiagaraDataInterfaceVolumeCache extends NiagaraDataInterface { 
	VolumeCache: VolumeCache;
	static Load(ResourceName: string): NiagaraDataInterfaceVolumeCache;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceVolumeCache;
	static GetDefaultObject(): NiagaraDataInterfaceVolumeCache;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceVolumeCache;
	static C(Other: UObject | any): NiagaraDataInterfaceVolumeCache;
}

declare class NiagaraDataInterfaceVolumeTexture extends NiagaraDataInterface { 
	Texture: Texture;
	TextureUserParameter: NiagaraUserParameterBinding;
	static Load(ResourceName: string): NiagaraDataInterfaceVolumeTexture;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceVolumeTexture;
	static GetDefaultObject(): NiagaraDataInterfaceVolumeTexture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceVolumeTexture;
	static C(Other: UObject | any): NiagaraDataInterfaceVolumeTexture;
}

declare type ENiagaraDebugHUDOverviewMode = 'Overview' | 'Scalability' | 'Performance' | 'GpuComputePerformance' | 'ENiagaraDebugHUDOverviewMode_MAX';
declare var ENiagaraDebugHUDOverviewMode : { Overview:'Overview',Scalability:'Scalability',Performance:'Performance',GpuComputePerformance:'GpuComputePerformance',ENiagaraDebugHUDOverviewMode_MAX:'ENiagaraDebugHUDOverviewMode_MAX', };
declare type ENiagaraDebugHudFont = 'Small' | 'Normal' | 'ENiagaraDebugHudFont_MAX';
declare var ENiagaraDebugHudFont : { Small:'Small',Normal:'Normal',ENiagaraDebugHudFont_MAX:'ENiagaraDebugHudFont_MAX', };
declare type ENiagaraDebugHudVerbosity = 'None' | 'Basic' | 'Verbose' | 'ENiagaraDebugHudVerbosity_MAX';
declare var ENiagaraDebugHudVerbosity : { None:'None',Basic:'Basic',Verbose:'Verbose',ENiagaraDebugHudVerbosity_MAX:'ENiagaraDebugHudVerbosity_MAX', };
declare class NiagaraDebugHUDVariable { 
	bEnabled: boolean;
	Name: string;
	clone() : NiagaraDebugHUDVariable;
	static C(Other: UObject | any): NiagaraDebugHUDVariable;
}

declare type ENiagaraDebugHudHAlign = 'Left' | 'Center' | 'Right' | 'ENiagaraDebugHudHAlign_MAX';
declare var ENiagaraDebugHudHAlign : { Left:'Left',Center:'Center',Right:'Right',ENiagaraDebugHudHAlign_MAX:'ENiagaraDebugHudHAlign_MAX', };
declare type ENiagaraDebugHudVAlign = 'Top' | 'Center' | 'Bottom' | 'ENiagaraDebugHudVAlign_MAX';
declare var ENiagaraDebugHudVAlign : { Top:'Top',Center:'Center',Bottom:'Bottom',ENiagaraDebugHudVAlign_MAX:'ENiagaraDebugHudVAlign_MAX', };
declare class NiagaraDebugHudTextOptions { 
	Font: ENiagaraDebugHudFont;
	HorizontalAlignment: ENiagaraDebugHudHAlign;
	VerticalAlignment: ENiagaraDebugHudVAlign;
	ScreenOffset: Vector2D;
	clone() : NiagaraDebugHudTextOptions;
	static C(Other: UObject | any): NiagaraDebugHudTextOptions;
}

declare type ENiagaraDebugHUDPerfSampleMode = 'FrameTotal' | 'PerInstanceAverage' | 'ENiagaraDebugHUDPerfSampleMode_MAX';
declare var ENiagaraDebugHUDPerfSampleMode : { FrameTotal:'FrameTotal',PerInstanceAverage:'PerInstanceAverage',ENiagaraDebugHUDPerfSampleMode_MAX:'ENiagaraDebugHUDPerfSampleMode_MAX', };
declare type ENiagaraDebugHUDPerfGraphMode = 'None' | 'GameThread' | 'RenderThread' | 'GPU' | 'ENiagaraDebugHUDPerfGraphMode_MAX';
declare var ENiagaraDebugHUDPerfGraphMode : { None:'None',GameThread:'GameThread',RenderThread:'RenderThread',GPU:'GPU',ENiagaraDebugHUDPerfGraphMode_MAX:'ENiagaraDebugHUDPerfGraphMode_MAX', };
declare type ENiagaraDebugPlaybackMode = 'Play' | 'Loop' | 'Paused' | 'Step' | 'ENiagaraDebugPlaybackMode_MAX';
declare var ENiagaraDebugPlaybackMode : { Play:'Play',Loop:'Loop',Paused:'Paused',Step:'Step',ENiagaraDebugPlaybackMode_MAX:'ENiagaraDebugPlaybackMode_MAX', };
declare class NiagaraDebugHUDSettingsData { 
	bWidgetEnabled: boolean;
	bHudEnabled: boolean;
	bHudRenderingEnabled: boolean;
	bValidateSystemSimulationDataBuffers: boolean;
	bValidateParticleDataBuffers: boolean;
	bOverviewEnabled: boolean;
	OverviewMode: ENiagaraDebugHUDOverviewMode;
	OverviewFont: ENiagaraDebugHudFont;
	OverviewLocation: Vector2D;
	bShowRegisteredComponents: boolean;
	bOverviewShowFilteredSystemOnly: boolean;
	ActorFilter: string;
	bComponentFilterEnabled: boolean;
	ComponentFilter: string;
	bSystemFilterEnabled: boolean;
	SystemFilter: string;
	bEmitterFilterEnabled: boolean;
	EmitterFilter: string;
	bActorFilterEnabled: boolean;
	SystemDebugVerbosity: ENiagaraDebugHudVerbosity;
	SystemEmitterVerbosity: ENiagaraDebugHudVerbosity;
	DataInterfaceVerbosity: ENiagaraDebugHudVerbosity;
	bSystemShowBounds: boolean;
	bSystemShowActiveOnlyInWorld: boolean;
	bShowSystemVariables: boolean;
	SystemVariables: NiagaraDebugHUDVariable[];
	SystemTextOptions: NiagaraDebugHudTextOptions;
	bShowParticleVariables: boolean;
	bEnableGpuParticleReadback: boolean;
	bShowParticleIndex: boolean;
	ParticlesVariables: NiagaraDebugHUDVariable[];
	ParticleTextOptions: NiagaraDebugHudTextOptions;
	bShowParticlesVariablesWithSystem: boolean;
	bShowParticleVariablesVertical: boolean;
	bUseMaxParticlesToDisplay: boolean;
	bUseParticleDisplayClip: boolean;
	ParticleDisplayClip: Vector2D;
	bUseParticleDisplayCenterRadius: boolean;
	ParticleDisplayCenterRadius: number;
	MaxParticlesToDisplay: number;
	PerfReportFrames: number;
	PerfSampleMode: ENiagaraDebugHUDPerfSampleMode;
	PerfGraphMode: ENiagaraDebugHUDPerfGraphMode;
	PerfHistoryFrames: number;
	PerfGraphTimeRange: number;
	PerfGraphSize: Vector2D;
	PerfGraphAxisColor: LinearColor;
	bEnableSmoothing: boolean;
	SmoothingWidth: number;
	DefaultBackgroundColor: LinearColor;
	OverviewHeadingColor: LinearColor;
	OverviewDetailColor: LinearColor;
	OverviewDetailHighlightColor: LinearColor;
	InWorldErrorTextColor: LinearColor;
	InWorldTextColor: LinearColor;
	MessageInfoTextColor: LinearColor;
	MessageWarningTextColor: LinearColor;
	MessageErrorTextColor: LinearColor;
	SystemColorTableOpacity: number;
	SystemColorSeed: number;
	SystemColorHSVMin: Vector;
	SystemColorHSVMax: Vector;
	PlaybackMode: ENiagaraDebugPlaybackMode;
	bPlaybackRateEnabled: boolean;
	PlaybackRate: number;
	bLoopTimeEnabled: boolean;
	LoopTime: number;
	bShowGlobalBudgetInfo: boolean;
	clone() : NiagaraDebugHUDSettingsData;
	static C(Other: UObject | any): NiagaraDebugHUDSettingsData;
}

declare class NiagaraDebugHUDSettings extends UObject { 
	Data: NiagaraDebugHUDSettingsData;
	static Load(ResourceName: string): NiagaraDebugHUDSettings;
	static Find(Outer: UObject, ResourceName: string): NiagaraDebugHUDSettings;
	static GetDefaultObject(): NiagaraDebugHUDSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDebugHUDSettings;
	static C(Other: UObject | any): NiagaraDebugHUDSettings;
}

declare class NiagaraSignificanceHandlerDistance extends NiagaraSignificanceHandler { 
	static Load(ResourceName: string): NiagaraSignificanceHandlerDistance;
	static Find(Outer: UObject, ResourceName: string): NiagaraSignificanceHandlerDistance;
	static GetDefaultObject(): NiagaraSignificanceHandlerDistance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSignificanceHandlerDistance;
	static C(Other: UObject | any): NiagaraSignificanceHandlerDistance;
}

declare class NiagaraSignificanceHandlerAge extends NiagaraSignificanceHandler { 
	static Load(ResourceName: string): NiagaraSignificanceHandlerAge;
	static Find(Outer: UObject, ResourceName: string): NiagaraSignificanceHandlerAge;
	static GetDefaultObject(): NiagaraSignificanceHandlerAge;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSignificanceHandlerAge;
	static C(Other: UObject | any): NiagaraSignificanceHandlerAge;
}

declare class NiagaraEventReceiverEmitterAction extends UObject { 
	static Load(ResourceName: string): NiagaraEventReceiverEmitterAction;
	static Find(Outer: UObject, ResourceName: string): NiagaraEventReceiverEmitterAction;
	static GetDefaultObject(): NiagaraEventReceiverEmitterAction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEventReceiverEmitterAction;
	static C(Other: UObject | any): NiagaraEventReceiverEmitterAction;
}

declare class NiagaraEventReceiverEmitterAction_SpawnParticles extends NiagaraEventReceiverEmitterAction { 
	NumParticles: number;
	static Load(ResourceName: string): NiagaraEventReceiverEmitterAction_SpawnParticles;
	static Find(Outer: UObject, ResourceName: string): NiagaraEventReceiverEmitterAction_SpawnParticles;
	static GetDefaultObject(): NiagaraEventReceiverEmitterAction_SpawnParticles;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEventReceiverEmitterAction_SpawnParticles;
	static C(Other: UObject | any): NiagaraEventReceiverEmitterAction_SpawnParticles;
}

declare class FXSystemSpawnParameters { 
	clone() : FXSystemSpawnParameters;
	static C(Other: UObject | any): FXSystemSpawnParameters;
	SpawnSystemAtLocationWithParams(): {SpawnParams: FXSystemSpawnParameters, $: NiagaraComponent};
	SpawnSystemAttachedWithParams(): {SpawnParams: FXSystemSpawnParameters, $: NiagaraComponent};
	static SpawnSystemAtLocationWithParams(SpawnParams?: FXSystemSpawnParameters): {SpawnParams: FXSystemSpawnParameters, $: NiagaraComponent};
	static SpawnSystemAttachedWithParams(SpawnParams?: FXSystemSpawnParameters): {SpawnParams: FXSystemSpawnParameters, $: NiagaraComponent};
}

declare class NiagaraFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): NiagaraFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): NiagaraFunctionLibrary;
	static GetDefaultObject(): NiagaraFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraFunctionLibrary;
	static SpawnSystemAttachedWithParams(SpawnParams?: FXSystemSpawnParameters): {SpawnParams: FXSystemSpawnParameters, $: NiagaraComponent};
	static SpawnSystemAttached(SystemTemplate: NiagaraSystem,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bAutoDestroy: boolean,bAutoActivate: boolean,PoolingMethod: ENCPoolMethod,bPreCullCheck: boolean): NiagaraComponent;
	static SpawnSystemAtLocationWithParams(SpawnParams?: FXSystemSpawnParameters): {SpawnParams: FXSystemSpawnParameters, $: NiagaraComponent};
	static SpawnSystemAtLocation(WorldContextObject: UObject,SystemTemplate: NiagaraSystem,Location: Vector,Rotation: Rotator,Scale: Vector,bAutoDestroy: boolean,bAutoActivate: boolean,PoolingMethod: ENCPoolMethod,bPreCullCheck: boolean): NiagaraComponent;
	static SetVolumeTextureObject(NiagaraSystem: NiagaraComponent,OverrideName: string,Texture: VolumeTexture): void;
	static SetTextureObject(NiagaraSystem: NiagaraComponent,OverrideName: string,Texture: Texture): void;
	static SetTexture2DArrayObject(NiagaraSystem: NiagaraComponent,OverrideName: string,Texture: Texture2DArray): void;
	static SetSkeletalMeshDataInterfaceSamplingRegions(NiagaraSystem: NiagaraComponent,OverrideName: string,SamplingRegions: string[]): void;
	static SetSkeletalMeshDataInterfaceFilteredSockets(NiagaraSystem: NiagaraComponent,OverrideName: string,FilteredSockets: string[]): void;
	static SetSkeletalMeshDataInterfaceFilteredBones(NiagaraSystem: NiagaraComponent,OverrideName: string,FilteredBones: string[]): void;
	static SetComponentNiagaraGPURayTracedCollisionGroup(WorldContextObject: UObject,Primitive: PrimitiveComponent,CollisionGroup: number): void;
	static SetActorNiagaraGPURayTracedCollisionGroup(WorldContextObject: UObject,Actor: Actor,CollisionGroup: number): void;
	static ReleaseNiagaraGPURayTracedCollisionGroup(WorldContextObject: UObject,CollisionGroup: number): void;
	static OverrideSystemUserVariableStaticMeshComponent(NiagaraSystem: NiagaraComponent,OverrideName: string,StaticMeshComponent: StaticMeshComponent): void;
	static OverrideSystemUserVariableStaticMesh(NiagaraSystem: NiagaraComponent,OverrideName: string,StaticMesh: StaticMesh): void;
	static OverrideSystemUserVariableSkeletalMeshComponent(NiagaraSystem: NiagaraComponent,OverrideName: string,SkeletalMeshComponent: SkeletalMeshComponent): void;
	static GetNiagaraParameterCollection(WorldContextObject: UObject,Collection: NiagaraParameterCollection): NiagaraParameterCollectionInstance;
	static AcquireNiagaraGPURayTracedCollisionGroup(WorldContextObject: UObject): number;
	static C(Other: UObject | any): NiagaraFunctionLibrary;
}

declare class NiagaraLensEffectBase extends NiagaraActor { 
	DesiredRelativeTransform: Transform;
	BaseAuthoredFOV: number;
	bAllowMultipleInstances: boolean;
	bResetWhenRetriggered: boolean;
	EmittersToTreatAsSame: UnrealEngineClass[];
	OwningCameraManager: PlayerCameraManager;
	static GetDefaultObject(): NiagaraLensEffectBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraLensEffectBase;
	static C(Other: UObject | any): NiagaraLensEffectBase;
}

declare class NiagaraLightRendererProperties extends NiagaraRendererProperties { 
	bUseInverseSquaredFalloff: boolean;
	bAffectsTranslucency: boolean;
	bAlphaScalesBrightness: boolean;
	bOverrideInverseExposureBlend: boolean;
	RadiusScale: number;
	DefaultExponent: number;
	ColorAdd: Vector3f;
	InverseExposureBlend: number;
	RendererVisibility: number;
	LightRenderingEnabledBinding: NiagaraVariableAttributeBinding;
	LightExponentBinding: NiagaraVariableAttributeBinding;
	PositionBinding: NiagaraVariableAttributeBinding;
	ColorBinding: NiagaraVariableAttributeBinding;
	RadiusBinding: NiagaraVariableAttributeBinding;
	VolumetricScatteringBinding: NiagaraVariableAttributeBinding;
	RendererVisibilityTagBinding: NiagaraVariableAttributeBinding;
	static Load(ResourceName: string): NiagaraLightRendererProperties;
	static Find(Outer: UObject, ResourceName: string): NiagaraLightRendererProperties;
	static GetDefaultObject(): NiagaraLightRendererProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraLightRendererProperties;
	static C(Other: UObject | any): NiagaraLightRendererProperties;
}

declare class NiagaraBaselineController_Basic extends NiagaraBaselineController { 
	NumInstances: number;
	SpawnedComponents: NiagaraComponent[];
	static Load(ResourceName: string): NiagaraBaselineController_Basic;
	static Find(Outer: UObject, ResourceName: string): NiagaraBaselineController_Basic;
	static GetDefaultObject(): NiagaraBaselineController_Basic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraBaselineController_Basic;
	static C(Other: UObject | any): NiagaraBaselineController_Basic;
}

declare class NiagaraPrecompileContainer extends UObject { 
	Scripts: NiagaraScript[];
	System: NiagaraSystem;
	static Load(ResourceName: string): NiagaraPrecompileContainer;
	static Find(Outer: UObject, ResourceName: string): NiagaraPrecompileContainer;
	static GetDefaultObject(): NiagaraPrecompileContainer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPrecompileContainer;
	static C(Other: UObject | any): NiagaraPrecompileContainer;
}

declare class NiagaraPreviewBase extends Actor { 
	static GetDefaultObject(): NiagaraPreviewBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewBase;
	SetSystem(InSystem: NiagaraSystem): void;
	SetLabelText(InXAxisText: string,InYAxisText: string): void;
	static C(Other: UObject | any): NiagaraPreviewBase;
}

declare class NiagaraPreviewAxis extends UObject { 
	static Load(ResourceName: string): NiagaraPreviewAxis;
	static Find(Outer: UObject, ResourceName: string): NiagaraPreviewAxis;
	static GetDefaultObject(): NiagaraPreviewAxis;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewAxis;
	Num(): number;
	ApplyToPreview(PreviewComponent: NiagaraComponent,PreviewIndex: number,bIsXAxis: boolean,OutLabelText?: string): {OutLabelText: string};
	static C(Other: UObject | any): NiagaraPreviewAxis;
}

declare class NiagaraPreviewAxis_InterpParamBase extends NiagaraPreviewAxis { 
	Param: string;
	Count: number;
	static Load(ResourceName: string): NiagaraPreviewAxis_InterpParamBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraPreviewAxis_InterpParamBase;
	static GetDefaultObject(): NiagaraPreviewAxis_InterpParamBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewAxis_InterpParamBase;
	static C(Other: UObject | any): NiagaraPreviewAxis_InterpParamBase;
}

declare class NiagaraPreviewAxis_InterpParamInt32 extends NiagaraPreviewAxis_InterpParamBase { 
	Min: number;
	Max: number;
	static Load(ResourceName: string): NiagaraPreviewAxis_InterpParamInt32;
	static Find(Outer: UObject, ResourceName: string): NiagaraPreviewAxis_InterpParamInt32;
	static GetDefaultObject(): NiagaraPreviewAxis_InterpParamInt32;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewAxis_InterpParamInt32;
	static C(Other: UObject | any): NiagaraPreviewAxis_InterpParamInt32;
}

declare class NiagaraPreviewAxis_InterpParamFloat extends NiagaraPreviewAxis_InterpParamBase { 
	Min: number;
	Max: number;
	static Load(ResourceName: string): NiagaraPreviewAxis_InterpParamFloat;
	static Find(Outer: UObject, ResourceName: string): NiagaraPreviewAxis_InterpParamFloat;
	static GetDefaultObject(): NiagaraPreviewAxis_InterpParamFloat;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewAxis_InterpParamFloat;
	static C(Other: UObject | any): NiagaraPreviewAxis_InterpParamFloat;
}

declare class NiagaraPreviewAxis_InterpParamVector2D extends NiagaraPreviewAxis_InterpParamBase { 
	Min: Vector2D;
	Max: Vector2D;
	static Load(ResourceName: string): NiagaraPreviewAxis_InterpParamVector2D;
	static Find(Outer: UObject, ResourceName: string): NiagaraPreviewAxis_InterpParamVector2D;
	static GetDefaultObject(): NiagaraPreviewAxis_InterpParamVector2D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewAxis_InterpParamVector2D;
	static C(Other: UObject | any): NiagaraPreviewAxis_InterpParamVector2D;
}

declare class NiagaraPreviewAxis_InterpParamVector extends NiagaraPreviewAxis_InterpParamBase { 
	Min: Vector;
	Max: Vector;
	static Load(ResourceName: string): NiagaraPreviewAxis_InterpParamVector;
	static Find(Outer: UObject, ResourceName: string): NiagaraPreviewAxis_InterpParamVector;
	static GetDefaultObject(): NiagaraPreviewAxis_InterpParamVector;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewAxis_InterpParamVector;
	static C(Other: UObject | any): NiagaraPreviewAxis_InterpParamVector;
}

declare class NiagaraPreviewAxis_InterpParamVector4 extends NiagaraPreviewAxis_InterpParamBase { 
	Min: Vector4;
	Max: Vector4;
	static Load(ResourceName: string): NiagaraPreviewAxis_InterpParamVector4;
	static Find(Outer: UObject, ResourceName: string): NiagaraPreviewAxis_InterpParamVector4;
	static GetDefaultObject(): NiagaraPreviewAxis_InterpParamVector4;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewAxis_InterpParamVector4;
	static C(Other: UObject | any): NiagaraPreviewAxis_InterpParamVector4;
}

declare class NiagaraPreviewAxis_InterpParamLinearColor extends NiagaraPreviewAxis_InterpParamBase { 
	Min: LinearColor;
	Max: LinearColor;
	static Load(ResourceName: string): NiagaraPreviewAxis_InterpParamLinearColor;
	static Find(Outer: UObject, ResourceName: string): NiagaraPreviewAxis_InterpParamLinearColor;
	static GetDefaultObject(): NiagaraPreviewAxis_InterpParamLinearColor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewAxis_InterpParamLinearColor;
	static C(Other: UObject | any): NiagaraPreviewAxis_InterpParamLinearColor;
}

declare type ENiagaraPreviewGridResetMode = 'Never' | 'Individual' | 'All' | 'ENiagaraPreviewGridResetMode_MAX';
declare var ENiagaraPreviewGridResetMode : { Never:'Never',Individual:'Individual',All:'All',ENiagaraPreviewGridResetMode_MAX:'ENiagaraPreviewGridResetMode_MAX', };
declare class NiagaraPreviewGrid extends Actor { 
	System: NiagaraSystem;
	ResetMode: ENiagaraPreviewGridResetMode;
	PreviewAxisX: NiagaraPreviewAxis;
	PreviewAxisY: NiagaraPreviewAxis;
	PreviewClass: UnrealEngineClass;
	SpacingX: number;
	SpacingY: number;
	NumX: number;
	NumY: number;
	PreviewComponents: ChildActorComponent[];
	SpriteComponent: BillboardComponent;
	ArrowComponent: ArrowComponent;
	static GetDefaultObject(): NiagaraPreviewGrid;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPreviewGrid;
	SetPaused(bPaused: boolean): void;
	GetPreviews(OutPreviews?: NiagaraComponent[]): {OutPreviews: NiagaraComponent[]};
	DeactivatePreviews(): void;
	ActivatePreviews(bReset: boolean): void;
	static C(Other: UObject | any): NiagaraPreviewGrid;
}

declare type ENiagaraRibbonFacingMode = 'Screen' | 'Custom' | 'CustomSideVector' | 'ENiagaraRibbonFacingMode_MAX';
declare var ENiagaraRibbonFacingMode : { Screen:'Screen',Custom:'Custom',CustomSideVector:'CustomSideVector',ENiagaraRibbonFacingMode_MAX:'ENiagaraRibbonFacingMode_MAX', };
declare type ENiagaraRibbonUVDistributionMode = 'ScaledUniformly' | 'ScaledUsingRibbonSegmentLength' | 'TiledOverRibbonLength' | 'TiledFromStartOverRibbonLength' | 'ENiagaraRibbonUVDistributionMode_MAX';
declare var ENiagaraRibbonUVDistributionMode : { ScaledUniformly:'ScaledUniformly',ScaledUsingRibbonSegmentLength:'ScaledUsingRibbonSegmentLength',TiledOverRibbonLength:'TiledOverRibbonLength',TiledFromStartOverRibbonLength:'TiledFromStartOverRibbonLength',ENiagaraRibbonUVDistributionMode_MAX:'ENiagaraRibbonUVDistributionMode_MAX', };
declare type ENiagaraRibbonUVEdgeMode = 'SmoothTransition' | 'Locked' | 'ENiagaraRibbonUVEdgeMode_MAX';
declare var ENiagaraRibbonUVEdgeMode : { SmoothTransition:'SmoothTransition',Locked:'Locked',ENiagaraRibbonUVEdgeMode_MAX:'ENiagaraRibbonUVEdgeMode_MAX', };
declare class NiagaraRibbonUVSettings { 
	DistributionMode: ENiagaraRibbonUVDistributionMode;
	LeadingEdgeMode: ENiagaraRibbonUVEdgeMode;
	TrailingEdgeMode: ENiagaraRibbonUVEdgeMode;
	TilingLength: number;
	Offset: Vector2D;
	Scale: Vector2D;
	bEnablePerParticleUOverride: boolean;
	bEnablePerParticleVRangeOverride: boolean;
	clone() : NiagaraRibbonUVSettings;
	static C(Other: UObject | any): NiagaraRibbonUVSettings;
}

declare type ENiagaraRibbonAgeOffsetMode = 'Scale' | 'Clip' | 'ENiagaraRibbonAgeOffsetMode_MAX';
declare var ENiagaraRibbonAgeOffsetMode : { Scale:'Scale',Clip:'Clip',ENiagaraRibbonAgeOffsetMode_MAX:'ENiagaraRibbonAgeOffsetMode_MAX', };
declare type ENiagaraRibbonDrawDirection = 'FrontToBack' | 'BackToFront' | 'ENiagaraRibbonDrawDirection_MAX';
declare var ENiagaraRibbonDrawDirection : { FrontToBack:'FrontToBack',BackToFront:'BackToFront',ENiagaraRibbonDrawDirection_MAX:'ENiagaraRibbonDrawDirection_MAX', };
declare type ENiagaraRibbonShapeMode = 'Plane' | 'MultiPlane' | 'Tube' | 'Custom' | 'ENiagaraRibbonShapeMode_MAX';
declare var ENiagaraRibbonShapeMode : { Plane:'Plane',MultiPlane:'MultiPlane',Tube:'Tube',Custom:'Custom',ENiagaraRibbonShapeMode_MAX:'ENiagaraRibbonShapeMode_MAX', };
declare class NiagaraRibbonShapeCustomVertex { 
	Position: Vector2f;
	Normal: Vector2f;
	TextureV: number;
	clone() : NiagaraRibbonShapeCustomVertex;
	static C(Other: UObject | any): NiagaraRibbonShapeCustomVertex;
}

declare type ENiagaraRibbonTessellationMode = 'Automatic' | 'Custom' | 'Disabled' | 'ENiagaraRibbonTessellationMode_MAX';
declare var ENiagaraRibbonTessellationMode : { Automatic:'Automatic',Custom:'Custom',Disabled:'Disabled',ENiagaraRibbonTessellationMode_MAX:'ENiagaraRibbonTessellationMode_MAX', };
declare class NiagaraRibbonRendererProperties extends NiagaraRendererProperties { 
	Material: MaterialInterface;
	MaterialUserParamBinding: NiagaraUserParameterBinding;
	FacingMode: ENiagaraRibbonFacingMode;
	UV0Settings: NiagaraRibbonUVSettings;
	UV1Settings: NiagaraRibbonUVSettings;
	UV0TilingDistance: number;
	UV0Scale: Vector2D;
	UV0Offset: Vector2D;
	UV0AgeOffsetMode: ENiagaraRibbonAgeOffsetMode;
	UV1TilingDistance: number;
	UV1Scale: Vector2D;
	UV1Offset: Vector2D;
	UV1AgeOffsetMode: ENiagaraRibbonAgeOffsetMode;
	MaxNumRibbons: number;
	bUseGPUInit: boolean;
	DrawDirection: ENiagaraRibbonDrawDirection;
	Shape: ENiagaraRibbonShapeMode;
	bEnableAccurateGeometry: boolean;
	WidthSegmentationCount: number;
	MultiPlaneCount: number;
	TubeSubdivisions: number;
	CustomVertices: NiagaraRibbonShapeCustomVertex[];
	CurveTension: number;
	TessellationMode: ENiagaraRibbonTessellationMode;
	TessellationFactor: number;
	bUseConstantFactor: boolean;
	TessellationAngle: number;
	bScreenSpaceTessellation: boolean;
	PositionBinding: NiagaraVariableAttributeBinding;
	ColorBinding: NiagaraVariableAttributeBinding;
	VelocityBinding: NiagaraVariableAttributeBinding;
	NormalizedAgeBinding: NiagaraVariableAttributeBinding;
	RibbonTwistBinding: NiagaraVariableAttributeBinding;
	RibbonWidthBinding: NiagaraVariableAttributeBinding;
	RibbonFacingBinding: NiagaraVariableAttributeBinding;
	RibbonIdBinding: NiagaraVariableAttributeBinding;
	RibbonLinkOrderBinding: NiagaraVariableAttributeBinding;
	MaterialRandomBinding: NiagaraVariableAttributeBinding;
	DynamicMaterialBinding: NiagaraVariableAttributeBinding;
	DynamicMaterial1Binding: NiagaraVariableAttributeBinding;
	DynamicMaterial2Binding: NiagaraVariableAttributeBinding;
	DynamicMaterial3Binding: NiagaraVariableAttributeBinding;
	RibbonUVDistance: NiagaraVariableAttributeBinding;
	U0OverrideBinding: NiagaraVariableAttributeBinding;
	V0RangeOverrideBinding: NiagaraVariableAttributeBinding;
	U1OverrideBinding: NiagaraVariableAttributeBinding;
	V1RangeOverrideBinding: NiagaraVariableAttributeBinding;
	MaterialParameters: NiagaraRendererMaterialParameters;
	MaterialParameterBindings: NiagaraMaterialAttributeBinding[];
	PrevPositionBinding: NiagaraVariableAttributeBinding;
	PrevRibbonWidthBinding: NiagaraVariableAttributeBinding;
	PrevRibbonFacingBinding: NiagaraVariableAttributeBinding;
	PrevRibbonTwistBinding: NiagaraVariableAttributeBinding;
	static Load(ResourceName: string): NiagaraRibbonRendererProperties;
	static Find(Outer: UObject, ResourceName: string): NiagaraRibbonRendererProperties;
	static GetDefaultObject(): NiagaraRibbonRendererProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraRibbonRendererProperties;
	static C(Other: UObject | any): NiagaraRibbonRendererProperties;
}

declare class AsyncNiagaraCaptureSimCache extends BlueprintAsyncActionBase { 
	CaptureSimCache: NiagaraSimCache;
	CaptureComponent: NiagaraComponent;
	CaptureNumFrames: number;
	CaptureFrameRate: number;
	CaptureFrameCounter: number;
	TimeOutCounter: number;
	CaptureComplete: UnrealEngineMulticastDelegate<(bSuccess: boolean) => void>;
	bAdvanceSimulation: boolean;
	AdvanceDeltaTime: number;
	static Load(ResourceName: string): AsyncNiagaraCaptureSimCache;
	static Find(Outer: UObject, ResourceName: string): AsyncNiagaraCaptureSimCache;
	static GetDefaultObject(): AsyncNiagaraCaptureSimCache;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncNiagaraCaptureSimCache;
	static CaptureNiagaraSimCacheUntilComplete(SimCache: NiagaraSimCache,CreateParameters: NiagaraSimCacheCreateParameters,NiagaraComponent: NiagaraComponent,OutSimCache?: NiagaraSimCache,CaptureRate?: number,bAdvanceSimulation?: boolean,AdvanceDeltaTime?: number): {OutSimCache: NiagaraSimCache, $: AsyncNiagaraCaptureSimCache};
	static CaptureNiagaraSimCacheMultiFrame(SimCache: NiagaraSimCache,CreateParameters: NiagaraSimCacheCreateParameters,NiagaraComponent: NiagaraComponent,OutSimCache?: NiagaraSimCache,NumFrames?: number,CaptureRate?: number,bAdvanceSimulation?: boolean,AdvanceDeltaTime?: number): {OutSimCache: NiagaraSimCache, $: AsyncNiagaraCaptureSimCache};
	static C(Other: UObject | any): AsyncNiagaraCaptureSimCache;
}

declare class NiagaraSimCacheFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): NiagaraSimCacheFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): NiagaraSimCacheFunctionLibrary;
	static GetDefaultObject(): NiagaraSimCacheFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSimCacheFunctionLibrary;
	static CreateNiagaraSimCache(WorldContextObject: UObject): NiagaraSimCache;
	static CaptureNiagaraSimCacheImmediate(SimCache: NiagaraSimCache,CreateParameters: NiagaraSimCacheCreateParameters,NiagaraComponent: NiagaraComponent,OutSimCache?: NiagaraSimCache,bAdvanceSimulation?: boolean,AdvanceDeltaTime?: number): {OutSimCache: NiagaraSimCache, $: boolean};
	static C(Other: UObject | any): NiagaraSimCacheFunctionLibrary;
}

declare type ENiagaraIterationSource = 'Particles' | 'DataInterface' | 'ENiagaraIterationSource_MAX';
declare var ENiagaraIterationSource : { Particles:'Particles',DataInterface:'DataInterface',ENiagaraIterationSource_MAX:'ENiagaraIterationSource_MAX', };
declare class NiagaraVariableDataInterfaceBinding { 
	BoundVariable: NiagaraVariable;
	clone() : NiagaraVariableDataInterfaceBinding;
	static C(Other: UObject | any): NiagaraVariableDataInterfaceBinding;
}

declare class NiagaraSimulationStageGeneric extends NiagaraSimulationStageBase { 
	EnabledBinding: NiagaraVariableAttributeBinding;
	ElementCountBinding: NiagaraVariableAttributeBinding;
	ElementCountXBinding: NiagaraVariableAttributeBinding;
	ElementCountYBinding: NiagaraVariableAttributeBinding;
	ElementCountZBinding: NiagaraVariableAttributeBinding;
	IterationSource: ENiagaraIterationSource;
	Iterations: number;
	NumIterationsBinding: NiagaraVariableAttributeBinding;
	bSpawnOnly: boolean;
	ExecuteBehavior: ENiagaraSimStageExecuteBehavior;
	bDisablePartialParticleUpdate: boolean;
	DataInterface: NiagaraVariableDataInterfaceBinding;
	bParticleIterationStateEnabled: boolean;
	ParticleIterationStateBinding: NiagaraVariableAttributeBinding;
	ParticleIterationStateRange: IntPoint;
	bGpuDispatchForceLinear: boolean;
	bOverrideGpuDispatchType: boolean;
	OverrideGpuDispatchType: ENiagaraGpuDispatchType;
	bOverrideGpuDispatchNumThreads: boolean;
	OverrideGpuDispatchNumThreads: IntVector;
	static Load(ResourceName: string): NiagaraSimulationStageGeneric;
	static Find(Outer: UObject, ResourceName: string): NiagaraSimulationStageGeneric;
	static GetDefaultObject(): NiagaraSimulationStageGeneric;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSimulationStageGeneric;
	static C(Other: UObject | any): NiagaraSimulationStageGeneric;
}

declare class ActorFactoryNiagara extends ActorFactory { 
	static Load(ResourceName: string): ActorFactoryNiagara;
	static Find(Outer: UObject, ResourceName: string): ActorFactoryNiagara;
	static GetDefaultObject(): ActorFactoryNiagara;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorFactoryNiagara;
	static C(Other: UObject | any): ActorFactoryNiagara;
}

declare class NiagaraHierarchyItemBase extends UObject { 
	Children: NiagaraHierarchyItemBase[];
	Guid: Guid;
	bFinalized: boolean;
	static Load(ResourceName: string): NiagaraHierarchyItemBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraHierarchyItemBase;
	static GetDefaultObject(): NiagaraHierarchyItemBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraHierarchyItemBase;
	static C(Other: UObject | any): NiagaraHierarchyItemBase;
}

declare class NiagaraHierarchySection extends NiagaraHierarchyItemBase { 
	Section: string;
	Tooltip: string;
	static Load(ResourceName: string): NiagaraHierarchySection;
	static Find(Outer: UObject, ResourceName: string): NiagaraHierarchySection;
	static GetDefaultObject(): NiagaraHierarchySection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraHierarchySection;
	static C(Other: UObject | any): NiagaraHierarchySection;
}

declare class NiagaraHierarchyRoot extends NiagaraHierarchyItemBase { 
	Sections: NiagaraHierarchySection[];
	static Load(ResourceName: string): NiagaraHierarchyRoot;
	static Find(Outer: UObject, ResourceName: string): NiagaraHierarchyRoot;
	static GetDefaultObject(): NiagaraHierarchyRoot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraHierarchyRoot;
	static C(Other: UObject | any): NiagaraHierarchyRoot;
}

declare class NiagaraHierarchyItem extends NiagaraHierarchyItemBase { 
	static Load(ResourceName: string): NiagaraHierarchyItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraHierarchyItem;
	static GetDefaultObject(): NiagaraHierarchyItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraHierarchyItem;
	static C(Other: UObject | any): NiagaraHierarchyItem;
}

declare class NiagaraHierarchyCategory extends NiagaraHierarchyItemBase { 
	Category: string;
	Tooltip: string;
	Section: NiagaraHierarchySection;
	static Load(ResourceName: string): NiagaraHierarchyCategory;
	static Find(Outer: UObject, ResourceName: string): NiagaraHierarchyCategory;
	static GetDefaultObject(): NiagaraHierarchyCategory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraHierarchyCategory;
	static C(Other: UObject | any): NiagaraHierarchyCategory;
}

declare class NiagaraHierarchyViewModelBase extends UObject { 
	SourceRoot: NiagaraHierarchyRoot;
	HierarchyRoot: NiagaraHierarchyRoot;
	static Load(ResourceName: string): NiagaraHierarchyViewModelBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraHierarchyViewModelBase;
	static GetDefaultObject(): NiagaraHierarchyViewModelBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraHierarchyViewModelBase;
	static C(Other: UObject | any): NiagaraHierarchyViewModelBase;
}

declare class NiagaraScriptFactoryNew extends Factory { 
	static Load(ResourceName: string): NiagaraScriptFactoryNew;
	static Find(Outer: UObject, ResourceName: string): NiagaraScriptFactoryNew;
	static GetDefaultObject(): NiagaraScriptFactoryNew;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScriptFactoryNew;
	static C(Other: UObject | any): NiagaraScriptFactoryNew;
}

declare class NiagaraModuleScriptFactory extends NiagaraScriptFactoryNew { 
	static Load(ResourceName: string): NiagaraModuleScriptFactory;
	static Find(Outer: UObject, ResourceName: string): NiagaraModuleScriptFactory;
	static GetDefaultObject(): NiagaraModuleScriptFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraModuleScriptFactory;
	static C(Other: UObject | any): NiagaraModuleScriptFactory;
}

declare class NiagaraFunctionScriptFactory extends NiagaraScriptFactoryNew { 
	static Load(ResourceName: string): NiagaraFunctionScriptFactory;
	static Find(Outer: UObject, ResourceName: string): NiagaraFunctionScriptFactory;
	static GetDefaultObject(): NiagaraFunctionScriptFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraFunctionScriptFactory;
	static C(Other: UObject | any): NiagaraFunctionScriptFactory;
}

declare class NiagaraDynamicInputScriptFactory extends NiagaraScriptFactoryNew { 
	static Load(ResourceName: string): NiagaraDynamicInputScriptFactory;
	static Find(Outer: UObject, ResourceName: string): NiagaraDynamicInputScriptFactory;
	static GetDefaultObject(): NiagaraDynamicInputScriptFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDynamicInputScriptFactory;
	static C(Other: UObject | any): NiagaraDynamicInputScriptFactory;
}

declare type ENiagaraDefaultMode = 'Value' | 'Binding' | 'Custom' | 'FailIfPreviouslyNotSet' | 'ENiagaraDefaultMode_MAX';
declare var ENiagaraDefaultMode : { Value:'Value',Binding:'Binding',Custom:'Custom',FailIfPreviouslyNotSet:'FailIfPreviouslyNotSet',ENiagaraDefaultMode_MAX:'ENiagaraDefaultMode_MAX', };
declare class NiagaraScriptVariableBinding { 
	Name: string;
	clone() : NiagaraScriptVariableBinding;
	static C(Other: UObject | any): NiagaraScriptVariableBinding;
}

declare class NiagaraEnumParameterMetaData { 
	OverrideName: string;
	IconOverride: Texture2D;
	bUseColorOverride: boolean;
	ColorOverride: LinearColor;
	clone() : NiagaraEnumParameterMetaData;
	static C(Other: UObject | any): NiagaraEnumParameterMetaData;
}

declare type ENiagaraBoolDisplayMode = 'DisplayAlways' | 'DisplayIfTrue' | 'DisplayIfFalse' | 'ENiagaraBoolDisplayMode_MAX';
declare var ENiagaraBoolDisplayMode : { DisplayAlways:'DisplayAlways',DisplayIfTrue:'DisplayIfTrue',DisplayIfFalse:'DisplayIfFalse',ENiagaraBoolDisplayMode_MAX:'ENiagaraBoolDisplayMode_MAX', };
declare class NiagaraBoolParameterMetaData { 
	DisplayMode: ENiagaraBoolDisplayMode;
	OverrideNameTrue: string;
	OverrideNameFalse: string;
	IconOverrideTrue: Texture2D;
	IconOverrideFalse: Texture2D;
	clone() : NiagaraBoolParameterMetaData;
	static C(Other: UObject | any): NiagaraBoolParameterMetaData;
}

declare class NiagaraInputConditionMetadata { 
	InputName: string;
	TargetValues: string[];
	clone() : NiagaraInputConditionMetadata;
	static C(Other: UObject | any): NiagaraInputConditionMetadata;
}

declare class NiagaraVariableMetaData { 
	Description: string;
	CategoryName: string;
	bAdvancedDisplay: boolean;
	bDisplayInOverviewStack: boolean;
	InlineParameterSortPriority: number;
	bOverrideColor: boolean;
	InlineParameterColorOverride: LinearColor;
	InlineParameterEnumOverrides: NiagaraEnumParameterMetaData[];
	bEnableBoolOverride: boolean;
	InlineParameterBoolOverride: NiagaraBoolParameterMetaData;
	EditorSortPriority: number;
	bInlineEditConditionToggle: boolean;
	editcondition: NiagaraInputConditionMetadata;
	VisibleCondition: NiagaraInputConditionMetadata;
	PropertyMetaData: Map<string, string>;
	ParentAttribute: string;
	AlternateAliases: string[];
	VariableGuid: Guid;
	bIsStaticSwitch: boolean;
	StaticSwitchDefaultValue: number;
	clone() : NiagaraVariableMetaData;
	static C(Other: UObject | any): NiagaraVariableMetaData;
}

declare class NiagaraScriptVariable extends UObject { 
	DefaultMode: ENiagaraDefaultMode;
	DefaultBinding: NiagaraScriptVariableBinding;
	Variable: NiagaraVariable;
	MetaData: NiagaraVariableMetaData;
	DefaultValueVariant: NiagaraVariant;
	StaticSwitchDefaultValue: number;
	bIsStaticSwitch: boolean;
	bSubscribedToParameterDefinitions: boolean;
	ChangeID: Guid;
	bOverrideParameterDefinitionsDefaultValue: boolean;
	static Load(ResourceName: string): NiagaraScriptVariable;
	static Find(Outer: UObject, ResourceName: string): NiagaraScriptVariable;
	static GetDefaultObject(): NiagaraScriptVariable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScriptVariable;
	static C(Other: UObject | any): NiagaraScriptVariable;
}

declare class NiagaraHierarchyUserParameter extends NiagaraHierarchyItem { 
	UserParameterScriptVariable: NiagaraScriptVariable;
	System: NiagaraSystem;
	static Load(ResourceName: string): NiagaraHierarchyUserParameter;
	static Find(Outer: UObject, ResourceName: string): NiagaraHierarchyUserParameter;
	static GetDefaultObject(): NiagaraHierarchyUserParameter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraHierarchyUserParameter;
	static C(Other: UObject | any): NiagaraHierarchyUserParameter;
}

declare class NiagaraUserParametersHierarchyViewModel extends NiagaraHierarchyViewModelBase { 
	static Load(ResourceName: string): NiagaraUserParametersHierarchyViewModel;
	static Find(Outer: UObject, ResourceName: string): NiagaraUserParametersHierarchyViewModel;
	static GetDefaultObject(): NiagaraUserParametersHierarchyViewModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraUserParametersHierarchyViewModel;
	static C(Other: UObject | any): NiagaraUserParametersHierarchyViewModel;
}

declare class NiagaraDumpByteCodeCommandlet extends Commandlet { 
	static Load(ResourceName: string): NiagaraDumpByteCodeCommandlet;
	static Find(Outer: UObject, ResourceName: string): NiagaraDumpByteCodeCommandlet;
	static GetDefaultObject(): NiagaraDumpByteCodeCommandlet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDumpByteCodeCommandlet;
	static C(Other: UObject | any): NiagaraDumpByteCodeCommandlet;
}

declare class NiagaraDumpModuleInfoCommandlet extends Commandlet { 
	static Load(ResourceName: string): NiagaraDumpModuleInfoCommandlet;
	static Find(Outer: UObject, ResourceName: string): NiagaraDumpModuleInfoCommandlet;
	static GetDefaultObject(): NiagaraDumpModuleInfoCommandlet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDumpModuleInfoCommandlet;
	static C(Other: UObject | any): NiagaraDumpModuleInfoCommandlet;
}

declare class NiagaraSystemAuditCommandlet extends Commandlet { 
	static Load(ResourceName: string): NiagaraSystemAuditCommandlet;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystemAuditCommandlet;
	static GetDefaultObject(): NiagaraSystemAuditCommandlet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystemAuditCommandlet;
	static C(Other: UObject | any): NiagaraSystemAuditCommandlet;
}

declare class EdGraphSchema_Niagara extends EdGraphSchema { 
	static Load(ResourceName: string): EdGraphSchema_Niagara;
	static Find(Outer: UObject, ResourceName: string): EdGraphSchema_Niagara;
	static GetDefaultObject(): EdGraphSchema_Niagara;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdGraphSchema_Niagara;
	static C(Other: UObject | any): EdGraphSchema_Niagara;
}

declare class EdGraphSchema_NiagaraSystemOverview extends EdGraphSchema { 
	static Load(ResourceName: string): EdGraphSchema_NiagaraSystemOverview;
	static Find(Outer: UObject, ResourceName: string): EdGraphSchema_NiagaraSystemOverview;
	static GetDefaultObject(): EdGraphSchema_NiagaraSystemOverview;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdGraphSchema_NiagaraSystemOverview;
	static C(Other: UObject | any): EdGraphSchema_NiagaraSystemOverview;
}

declare type ENiagaraClipboardFunctionInputValueMode = 'Local' | 'Linked' | 'Data' | 'Expression' | 'Dynamic' | 'ENiagaraClipboardFunctionInputValueMode_MAX';
declare var ENiagaraClipboardFunctionInputValueMode : { Local:'Local',Linked:'Linked',Data:'Data',Expression:'Expression',Dynamic:'Dynamic',ENiagaraClipboardFunctionInputValueMode_MAX:'ENiagaraClipboardFunctionInputValueMode_MAX', };
declare type ENiagaraClipboardFunctionScriptMode = 'ScriptAsset' | 'Assignment' | 'ENiagaraClipboardFunctionScriptMode_MAX';
declare var ENiagaraClipboardFunctionScriptMode : { ScriptAsset:'ScriptAsset',Assignment:'Assignment',ENiagaraClipboardFunctionScriptMode_MAX:'ENiagaraClipboardFunctionScriptMode_MAX', };
declare class NiagaraNode extends EdGraphNode { 
	ChangeID: Guid;
	static Load(ResourceName: string): NiagaraNode;
	static Find(Outer: UObject, ResourceName: string): NiagaraNode;
	static GetDefaultObject(): NiagaraNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNode;
	static C(Other: UObject | any): NiagaraNode;
}

declare class NiagaraNodeWithDynamicPins extends NiagaraNode { 
	static Load(ResourceName: string): NiagaraNodeWithDynamicPins;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeWithDynamicPins;
	static GetDefaultObject(): NiagaraNodeWithDynamicPins;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeWithDynamicPins;
	static C(Other: UObject | any): NiagaraNodeWithDynamicPins;
}

declare class NiagaraPropagatedVariable { 
	SwitchParameter: NiagaraVariable;
	PropagatedName: string;
	clone() : NiagaraPropagatedVariable;
	static C(Other: UObject | any): NiagaraPropagatedVariable;
}

declare type ENiagaraFunctionDebugState = 'NoDebug' | 'Basic' | 'ENiagaraFunctionDebugState_MAX';
declare var ENiagaraFunctionDebugState : { NoDebug:'NoDebug',Basic:'Basic',ENiagaraFunctionDebugState_MAX:'ENiagaraFunctionDebugState_MAX', };
declare class NiagaraMessageData extends NiagaraMessageDataBase { 
	static Load(ResourceName: string): NiagaraMessageData;
	static Find(Outer: UObject, ResourceName: string): NiagaraMessageData;
	static GetDefaultObject(): NiagaraMessageData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraMessageData;
	static C(Other: UObject | any): NiagaraMessageData;
}

declare type ENiagaraMessageSeverity = 'CriticalError' | 'Error' | 'PerformanceWarning' | 'Warning' | 'Info' | 'CustomNote' | 'ENiagaraMessageSeverity_MAX';
declare var ENiagaraMessageSeverity : { CriticalError:'CriticalError',Error:'Error',PerformanceWarning:'PerformanceWarning',Warning:'Warning',Info:'Info',CustomNote:'CustomNote',ENiagaraMessageSeverity_MAX:'ENiagaraMessageSeverity_MAX', };
declare class NiagaraStackMessage { 
	MessageText: string;
	ShortDescription: string;
	MessageSeverity: ENiagaraMessageSeverity;
	bAllowDismissal: boolean;
	Guid: Guid;
	clone() : NiagaraStackMessage;
	static C(Other: UObject | any): NiagaraStackMessage;
}

declare class NiagaraNodeFunctionCall extends NiagaraNodeWithDynamicPins { 
	FunctionScript: NiagaraScript;
	SelectedScriptVersion: Guid;
	FunctionScriptAssetObjectPath: string;
	Signature: NiagaraFunctionSignature;
	FunctionSpecifiers: Map<string, string>;
	PropagatedStaticSwitchParameters: NiagaraPropagatedVariable[];
	PreviousScriptVersion: Guid;
	PythonUpgradeScriptWarnings: string;
	DebugState: ENiagaraFunctionDebugState;
	bInheritDebugStatus: boolean;
	CachedChangeId: Guid;
	InvalidScriptVersionReference: Guid;
	FunctionDisplayName: string;
	MessageKeyToMessageMap: Map<Guid, NiagaraMessageData>;
	StackMessages: NiagaraStackMessage[];
	BoundPinNames: Map<Guid, string>;
	static Load(ResourceName: string): NiagaraNodeFunctionCall;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeFunctionCall;
	static GetDefaultObject(): NiagaraNodeFunctionCall;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeFunctionCall;
	static C(Other: UObject | any): NiagaraNodeFunctionCall;
}

declare class NiagaraClipboardFunction extends UObject { 
	FunctionName: string;
	DisplayName: string;
	ScriptMode: ENiagaraClipboardFunctionScriptMode;
	Script: NiagaraScript;
	AssignmentTargets: NiagaraVariable[];
	AssignmentDefaults: string[];
	Inputs: NiagaraClipboardFunctionInput[];
	OnPastedFunctionCallNodeDelegate: UnrealEngineDelegate<(PastedFunctionCall: NiagaraNodeFunctionCall) => void>;
	ScriptVersion: Guid;
	Messages: NiagaraStackMessage[];
	static Load(ResourceName: string): NiagaraClipboardFunction;
	static Find(Outer: UObject, ResourceName: string): NiagaraClipboardFunction;
	static GetDefaultObject(): NiagaraClipboardFunction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraClipboardFunction;
	static C(Other: UObject | any): NiagaraClipboardFunction;
}

declare class NiagaraClipboardFunctionInput extends UObject { 
	InputName: string;
	InputType: NiagaraTypeDefinition;
	bHasEditCondition: boolean;
	bEditConditionValue: boolean;
	ValueMode: ENiagaraClipboardFunctionInputValueMode;
	Local: number[];
	Linked: string;
	Data: NiagaraDataInterface;
	Expression: string;
	Dynamic: NiagaraClipboardFunction;
	static Load(ResourceName: string): NiagaraClipboardFunctionInput;
	static Find(Outer: UObject, ResourceName: string): NiagaraClipboardFunctionInput;
	static GetDefaultObject(): NiagaraClipboardFunctionInput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraClipboardFunctionInput;
	static C(Other: UObject | any): NiagaraClipboardFunctionInput;
}

declare class NiagaraClipboardScriptVariable { 
	ScriptVariable: NiagaraScriptVariable;
	OriginalChangeId: Guid;
	clone() : NiagaraClipboardScriptVariable;
	static C(Other: UObject | any): NiagaraClipboardScriptVariable;
}

declare class NiagaraClipboardContent extends UObject { 
	Functions: NiagaraClipboardFunction[];
	FunctionInputs: NiagaraClipboardFunctionInput[];
	Renderers: NiagaraRendererProperties[];
	Scripts: NiagaraScript[];
	ScriptVariables: NiagaraClipboardScriptVariable[];
	ExportedNodes: string;
	bFixupPasteIndexForScriptDependenciesInStack: boolean;
	static Load(ResourceName: string): NiagaraClipboardContent;
	static Find(Outer: UObject, ResourceName: string): NiagaraClipboardContent;
	static GetDefaultObject(): NiagaraClipboardContent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraClipboardContent;
	static C(Other: UObject | any): NiagaraClipboardContent;
}

declare class NiagaraClipboardEditorScriptingUtilities extends UObject { 
	static Load(ResourceName: string): NiagaraClipboardEditorScriptingUtilities;
	static Find(Outer: UObject, ResourceName: string): NiagaraClipboardEditorScriptingUtilities;
	static GetDefaultObject(): NiagaraClipboardEditorScriptingUtilities;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraClipboardEditorScriptingUtilities;
	static TrySetLocalValueAsInt(InInput: NiagaraClipboardFunctionInput,bOutSucceeded?: boolean,InValue?: number,bLooseTyping?: boolean): {bOutSucceeded: boolean};
	static TryGetLocalValueAsInt(InInput: NiagaraClipboardFunctionInput,bOutSucceeded?: boolean,OutValue?: number): {bOutSucceeded: boolean, OutValue: number};
	static TryGetLocalValueAsFloat(InInput: NiagaraClipboardFunctionInput,bOutSucceeded?: boolean,OutValue?: number): {bOutSucceeded: boolean, OutValue: number};
	static TryGetInputByName(InInputs: NiagaraClipboardFunctionInput[],InInputName: string,bOutSucceeded?: boolean,OutInput?: NiagaraClipboardFunctionInput): {bOutSucceeded: boolean, OutInput: NiagaraClipboardFunctionInput};
	static GetTypeName(InInput: NiagaraClipboardFunctionInput): string;
	static CreateVec3LocalValueInput(InOuter: UObject,InInputName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InVec3Value: Vector): NiagaraClipboardFunctionInput;
	static CreateVec2LocalValueInput(InOuter: UObject,InInputName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InVec2Value: Vector2D): NiagaraClipboardFunctionInput;
	static CreateStructLocalValueInput(InOuter: UObject,InInputName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InStructValue: UserDefinedStruct): NiagaraClipboardFunctionInput;
	static CreateLinkedValueInput(InOuter: UObject,InInputName: string,InInputTypeName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InLinkedValue: string): NiagaraClipboardFunctionInput;
	static CreateIntLocalValueInput(InOuter: UObject,InInputName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InLocalValue: number): NiagaraClipboardFunctionInput;
	static CreateFloatLocalValueInput(InOuter: UObject,InInputName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InLocalValue: number): NiagaraClipboardFunctionInput;
	static CreateExpressionValueInput(InOuter: UObject,InInputName: string,InInputTypeName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InExpressionValue: string): NiagaraClipboardFunctionInput;
	static CreateEnumLocalValueInput(InOuter: UObject,InInputName: string,bInHasEditCondition: boolean,bInEditCoditionValue: boolean,InEnumType: UserDefinedEnum,InEnumValue: number): NiagaraClipboardFunctionInput;
	static CreateDynamicValueInput(InOuter: UObject,InInputName: string,InInputTypeName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InDynamicValueName: string,InDynamicValue: NiagaraScript): NiagaraClipboardFunctionInput;
	static CreateDataValueInput(InOuter: UObject,InInputName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InDataValue: NiagaraDataInterface): NiagaraClipboardFunctionInput;
	static CreateBoolLocalValueInput(InOuter: UObject,InInputName: string,bInHasEditCondition: boolean,bInEditConditionValue: boolean,InBoolValue: boolean): NiagaraClipboardFunctionInput;
	static C(Other: UObject | any): NiagaraClipboardEditorScriptingUtilities;
}

declare class NiagaraConvertInPlaceEmitterAndSystemState extends NiagaraConvertInPlaceUtilityBase { 
	static Load(ResourceName: string): NiagaraConvertInPlaceEmitterAndSystemState;
	static Find(Outer: UObject, ResourceName: string): NiagaraConvertInPlaceEmitterAndSystemState;
	static GetDefaultObject(): NiagaraConvertInPlaceEmitterAndSystemState;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraConvertInPlaceEmitterAndSystemState;
	static C(Other: UObject | any): NiagaraConvertInPlaceEmitterAndSystemState;
}

declare class NiagaraEditorParametersAdapter extends NiagaraEditorParametersAdapterBase { 
	EditorOnlyScriptVars: NiagaraScriptVariable[];
	static Load(ResourceName: string): NiagaraEditorParametersAdapter;
	static Find(Outer: UObject, ResourceName: string): NiagaraEditorParametersAdapter;
	static GetDefaultObject(): NiagaraEditorParametersAdapter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEditorParametersAdapter;
	static C(Other: UObject | any): NiagaraEditorParametersAdapter;
}

declare class NiagaraSpawnShortcut { 
	Name: string;
	Input: InputChord;
	clone() : NiagaraSpawnShortcut;
	static C(Other: UObject | any): NiagaraSpawnShortcut;
}

declare class NiagaraActionColors { 
	NiagaraColor: LinearColor;
	GameColor: LinearColor;
	PluginColor: LinearColor;
	DeveloperColor: LinearColor;
	clone() : NiagaraActionColors;
	static C(Other: UObject | any): NiagaraActionColors;
}

declare class NiagaraNewAssetDialogConfig { 
	SelectedOptionIndex: number;
	WindowSize: Vector2D;
	clone() : NiagaraNewAssetDialogConfig;
	static C(Other: UObject | any): NiagaraNewAssetDialogConfig;
}

declare type ENiagaraNamespaceMetadataOptions = 'HideInScript' | 'HideInSystem' | 'AdvancedInScript' | 'AdvancedInSystem' | 'PreventEditingNamespace' | 'PreventEditingNamespaceModifier' | 'PreventEditingName' | 'PreventCreatingInSystemEditor' | 'HideInDefinitions' | 'ENiagaraNamespaceMetadataOptions_MAX';
declare var ENiagaraNamespaceMetadataOptions : { HideInScript:'HideInScript',HideInSystem:'HideInSystem',AdvancedInScript:'AdvancedInScript',AdvancedInSystem:'AdvancedInSystem',PreventEditingNamespace:'PreventEditingNamespace',PreventEditingNamespaceModifier:'PreventEditingNamespaceModifier',PreventEditingName:'PreventEditingName',PreventCreatingInSystemEditor:'PreventCreatingInSystemEditor',HideInDefinitions:'HideInDefinitions',ENiagaraNamespaceMetadataOptions_MAX:'ENiagaraNamespaceMetadataOptions_MAX', };
declare class NiagaraNamespaceMetadata { 
	Namespaces: string[];
	RequiredNamespaceModifier: string;
	DisplayName: string;
	DisplayNameLong: string;
	Description: string;
	BackgroundColor: LinearColor;
	ForegroundStyle: string;
	SortId: number;
	OptionalNamespaceModifiers: string[];
	Options: ENiagaraNamespaceMetadataOptions[];
	Guid: Guid;
	clone() : NiagaraNamespaceMetadata;
	static C(Other: UObject | any): NiagaraNamespaceMetadata;
}

declare class NiagaraCurveTemplate { 
	DisplayNameOverride: string;
	CurveAsset: SoftObjectPath;
	clone() : NiagaraCurveTemplate;
	static C(Other: UObject | any): NiagaraCurveTemplate;
}

declare class NiagaraParameterPanelSectionStorage { 
	ParamStorageId: Guid;
	ExpandedCategories: Guid[];
	clone() : NiagaraParameterPanelSectionStorage;
	static C(Other: UObject | any): NiagaraParameterPanelSectionStorage;
}

declare class NiagaraEditorSettings extends DeveloperSettings { 
	DefaultScript: SoftObjectPath;
	DefaultDynamicInputScript: SoftObjectPath;
	DefaultFunctionScript: SoftObjectPath;
	DefaultModuleScript: SoftObjectPath;
	RequiredSystemUpdateScript: SoftObjectPath;
	GraphCreationShortcuts: NiagaraSpawnShortcut[];
	bSimplifyStackNodesAtLowResolution: boolean;
	LowResolutionNodeMaxNameChars: number;
	bAlwaysZoomToFitSystemGraph: boolean;
	bAutoCompile: boolean;
	bAutoPlay: boolean;
	bResetSimulationOnChange: boolean;
	bResimulateOnChangeWhilePaused: boolean;
	bResetDependentSystemsWhenEditingEmitters: boolean;
	bDisplayAdvancedParameterPanelCategories: boolean;
	bDisplayAffectedAssetStats: boolean;
	AffectedAssetSearchLimit: number;
	PlaybackSpeeds: number[];
	ActionColors: NiagaraActionColors;
	NewAssetDialogConfigMap: Map<string, NiagaraNewAssetDialogConfig>;
	HLSLKeywordReplacements: Map<string, string>;
	NamespaceMetadata: NiagaraNamespaceMetadata[];
	NamespaceModifierMetadata: NiagaraNamespaceMetadata[];
	DefaultNamespaceMetadata: NiagaraNamespaceMetadata;
	DefaultNamespaceModifierMetadata: NiagaraNamespaceMetadata;
	CurveTemplates: NiagaraCurveTemplate[];
	bShowGridInViewport: boolean;
	bShowInstructionsCount: boolean;
	bShowParticleCountsInViewport: boolean;
	bShowEmitterExecutionOrder: boolean;
	bShowGpuTickInformation: boolean;
	SystemParameterPanelSectionData: NiagaraParameterPanelSectionStorage[];
	static Load(ResourceName: string): NiagaraEditorSettings;
	static Find(Outer: UObject, ResourceName: string): NiagaraEditorSettings;
	static GetDefaultObject(): NiagaraEditorSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEditorSettings;
	static C(Other: UObject | any): NiagaraEditorSettings;
}

declare class NiagaraEffectTypeFactoryNew extends Factory { 
	static Load(ResourceName: string): NiagaraEffectTypeFactoryNew;
	static Find(Outer: UObject, ResourceName: string): NiagaraEffectTypeFactoryNew;
	static GetDefaultObject(): NiagaraEffectTypeFactoryNew;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEffectTypeFactoryNew;
	static C(Other: UObject | any): NiagaraEffectTypeFactoryNew;
}

declare class NiagaraStackEditorData extends NiagaraEditorDataBase { 
	bHideDisabledModules: boolean;
	StackEntryKeyToExpandedMap: Map<string, boolean>;
	StackEntryKeyToExpandedOverviewMap: Map<string, boolean>;
	StackEntryKeyToDisplayName: Map<string, string>;
	DismissedStackIssueIds: string[];
	static Load(ResourceName: string): NiagaraStackEditorData;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEditorData;
	static GetDefaultObject(): NiagaraStackEditorData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEditorData;
	static C(Other: UObject | any): NiagaraStackEditorData;
}

declare class FunctionInputSummaryViewKey { 
	FunctionGuid: Guid;
	InputGuid: Guid;
	InputName: string;
	clone() : FunctionInputSummaryViewKey;
	static C(Other: UObject | any): FunctionInputSummaryViewKey;
}

declare class FunctionInputSummaryViewMetadata { 
	bVisible: boolean;
	DisplayName: string;
	Category: string;
	SortIndex: number;
	clone() : FunctionInputSummaryViewMetadata;
	static C(Other: UObject | any): FunctionInputSummaryViewMetadata;
}

declare class NiagaraEmitterEditorData extends NiagaraEditorDataBase { 
	StackEditorData: NiagaraStackEditorData;
	PlaybackRangeMin: number;
	PlaybackRangeMax: number;
	bShowSummaryView: boolean;
	SummaryViewFunctionInputMetadata: Map<FunctionInputSummaryViewKey, FunctionInputSummaryViewMetadata>;
	SummarySections: NiagaraStackSection[];
	static Load(ResourceName: string): NiagaraEmitterEditorData;
	static Find(Outer: UObject, ResourceName: string): NiagaraEmitterEditorData;
	static GetDefaultObject(): NiagaraEmitterEditorData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEmitterEditorData;
	static C(Other: UObject | any): NiagaraEmitterEditorData;
}

declare class NiagaraEmitterFactoryNew extends Factory { 
	static Load(ResourceName: string): NiagaraEmitterFactoryNew;
	static Find(Outer: UObject, ResourceName: string): NiagaraEmitterFactoryNew;
	static GetDefaultObject(): NiagaraEmitterFactoryNew;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEmitterFactoryNew;
	static C(Other: UObject | any): NiagaraEmitterFactoryNew;
}

declare class NiagaraCompileHashVisitorDebugInfo { 
	UObject: string;
	PropertyKeys: string[];
	PropertyValues: string[];
	clone() : NiagaraCompileHashVisitorDebugInfo;
	static C(Other: UObject | any): NiagaraCompileHashVisitorDebugInfo;
}

declare class NiagaraGraphScriptUsageInfo { 
	BaseId: Guid;
	UsageType: ENiagaraScriptUsage;
	UsageId: Guid;
	CompileHash: NiagaraCompileHash;
	CompileHashFromGraph: NiagaraCompileHash;
	CompileLastObjects: NiagaraCompileHashVisitorDebugInfo[];
	Traversal: NiagaraNode[];
	DataHash: number[];
	GeneratedCompileId: Guid;
	clone() : NiagaraGraphScriptUsageInfo;
	static C(Other: UObject | any): NiagaraGraphScriptUsageInfo;
}

declare class NiagaraGraphParameterReference { 
	Key: Guid;
	Value: UObject;
	bIsUserFacing: boolean;
	clone() : NiagaraGraphParameterReference;
	static C(Other: UObject | any): NiagaraGraphParameterReference;
}

declare class NiagaraGraphParameterReferenceCollection { 
	ParameterReferences: NiagaraGraphParameterReference[];
	Graph: NiagaraGraph;
	bCreatedByUser: boolean;
	clone() : NiagaraGraphParameterReferenceCollection;
	static C(Other: UObject | any): NiagaraGraphParameterReferenceCollection;
}

declare class NiagaraScriptVariableData { 
	DefaultMode: ENiagaraDefaultMode;
	DefaultBinding: NiagaraScriptVariableBinding;
	Variable: NiagaraVariable;
	MetaData: NiagaraVariableMetaData;
	DefaultValueVariant: NiagaraVariant;
	StaticSwitchDefaultValue: number;
	bIsStaticSwitch: boolean;
	bSubscribedToParameterDefinitions: boolean;
	ChangeID: Guid;
	bOverrideParameterDefinitionsDefaultValue: boolean;
	clone() : NiagaraScriptVariableData;
	static C(Other: UObject | any): NiagaraScriptVariableData;
}

declare class NiagaraGraph extends EdGraph { 
	ChangeID: Guid;
	ForceRebuildId: Guid;
	LastBuiltTraversalDataChangeId: Guid;
	CachedUsageInfo: NiagaraGraphScriptUsageInfo[];
	VariableToMetaData: Map<NiagaraVariable, NiagaraVariableMetaData>;
	VariableToScriptVariable: Map<NiagaraVariable, NiagaraScriptVariable>;
	ParameterToReferencesMap: Map<NiagaraVariable, NiagaraGraphParameterReferenceCollection>;
	CompilationScriptVariables: NiagaraScriptVariableData[];
	static Load(ResourceName: string): NiagaraGraph;
	static Find(Outer: UObject, ResourceName: string): NiagaraGraph;
	static GetDefaultObject(): NiagaraGraph;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraGraph;
	static C(Other: UObject | any): NiagaraGraph;
}

declare class NiagaraMessageDataText extends NiagaraMessageData { 
	MessageText: string;
	ShortDescription: string;
	MessageSeverity: ENiagaraMessageSeverity;
	bAllowDismissal: boolean;
	TopicName: string;
	static Load(ResourceName: string): NiagaraMessageDataText;
	static Find(Outer: UObject, ResourceName: string): NiagaraMessageDataText;
	static GetDefaultObject(): NiagaraMessageDataText;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraMessageDataText;
	static C(Other: UObject | any): NiagaraMessageDataText;
}

declare class NiagaraNodeAssignment extends NiagaraNodeFunctionCall { 
	AssignmentTarget: NiagaraVariable;
	AssignmentDefaultValue: string;
	AssignmentTargets: NiagaraVariable[];
	AssignmentDefaultValues: string[];
	OldFunctionCallName: string;
	static Load(ResourceName: string): NiagaraNodeAssignment;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeAssignment;
	static GetDefaultObject(): NiagaraNodeAssignment;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeAssignment;
	static C(Other: UObject | any): NiagaraNodeAssignment;
}

declare class NiagaraConvertConnection { 
	SourcePinId: Guid;
	SourcePath: string[];
	DestinationPinId: Guid;
	DestinationPath: string[];
	SourcePropertyId: Guid;
	DestinationPropertyId: Guid;
	clone() : NiagaraConvertConnection;
	static C(Other: UObject | any): NiagaraConvertConnection;
}

declare class NiagaraConvertPinRecord { 
	PinId: Guid;
	Path: string[];
	clone() : NiagaraConvertPinRecord;
	static C(Other: UObject | any): NiagaraConvertPinRecord;
}

declare class NiagaraNodeConvert extends NiagaraNodeWithDynamicPins { 
	AutowireSwizzle: string;
	AutowireMakeType: NiagaraTypeDefinition;
	AutowireBreakType: NiagaraTypeDefinition;
	Connections: NiagaraConvertConnection[];
	bIsWiringShown: boolean;
	ExpandedItems: NiagaraConvertPinRecord[];
	static Load(ResourceName: string): NiagaraNodeConvert;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeConvert;
	static GetDefaultObject(): NiagaraNodeConvert;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeConvert;
	static C(Other: UObject | any): NiagaraNodeConvert;
}

declare class NiagaraNodeCustomHlsl extends NiagaraNodeFunctionCall { 
	ScriptUsage: ENiagaraScriptUsage;
	CustomHlsl: string;
	AbsoluteIncludeFilePaths: FilePath[];
	VirtualIncludeFilePaths: string[];
	static Load(ResourceName: string): NiagaraNodeCustomHlsl;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeCustomHlsl;
	static GetDefaultObject(): NiagaraNodeCustomHlsl;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeCustomHlsl;
	static C(Other: UObject | any): NiagaraNodeCustomHlsl;
}

declare class NiagaraNodeDataSetBase extends NiagaraNode { 
	DataSet: NiagaraDataSetID;
	Variables: NiagaraVariable[];
	VariableFriendlyNames: string[];
	ExternalStructAsset: Struct;
	static Load(ResourceName: string): NiagaraNodeDataSetBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeDataSetBase;
	static GetDefaultObject(): NiagaraNodeDataSetBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeDataSetBase;
	static C(Other: UObject | any): NiagaraNodeDataSetBase;
}

declare class NiagaraNodeEmitter extends NiagaraNodeWithDynamicPins { 
	OwnerSystem: NiagaraSystem;
	EmitterHandleId: Guid;
	DisplayName: string;
	ScriptType: ENiagaraScriptUsage;
	static Load(ResourceName: string): NiagaraNodeEmitter;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeEmitter;
	static GetDefaultObject(): NiagaraNodeEmitter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeEmitter;
	static C(Other: UObject | any): NiagaraNodeEmitter;
}

declare class PinGuidsForPath { 
	OutputPinGuid: Guid;
	InputTruePinGuid: Guid;
	InputFalsePinGuid: Guid;
	clone() : PinGuidsForPath;
	static C(Other: UObject | any): PinGuidsForPath;
}

declare class NiagaraNodeIf extends NiagaraNodeWithDynamicPins { 
	OutputVars: NiagaraVariable[];
	PathAssociatedPinGuids: PinGuidsForPath[];
	ConditionPinGuid: Guid;
	static Load(ResourceName: string): NiagaraNodeIf;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeIf;
	static GetDefaultObject(): NiagaraNodeIf;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeIf;
	static C(Other: UObject | any): NiagaraNodeIf;
}

declare type ENiagaraInputNodeUsage = 'Undefined' | 'Parameter' | 'Attribute' | 'SystemConstant' | 'TranslatorConstant' | 'RapidIterationParameter' | 'ENiagaraInputNodeUsage_MAX';
declare var ENiagaraInputNodeUsage : { Undefined:'Undefined',Parameter:'Parameter',Attribute:'Attribute',SystemConstant:'SystemConstant',TranslatorConstant:'TranslatorConstant',RapidIterationParameter:'RapidIterationParameter',ENiagaraInputNodeUsage_MAX:'ENiagaraInputNodeUsage_MAX', };
declare class NiagaraInputExposureOptions { 
	bExposed: boolean;
	bRequired: boolean;
	bCanAutoBind: boolean;
	bHidden: boolean;
	clone() : NiagaraInputExposureOptions;
	static C(Other: UObject | any): NiagaraInputExposureOptions;
}

declare class NiagaraNodeInput extends NiagaraNode { 
	Input: NiagaraVariable;
	Usage: ENiagaraInputNodeUsage;
	CallSortPriority: number;
	ExposureOptions: NiagaraInputExposureOptions;
	DataInterface: NiagaraDataInterface;
	static Load(ResourceName: string): NiagaraNodeInput;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeInput;
	static GetDefaultObject(): NiagaraNodeInput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeInput;
	static C(Other: UObject | any): NiagaraNodeInput;
}

declare class AddedPinData { 
	PinType: EdGraphPinType;
	PinName: string;
	clone() : AddedPinData;
	static C(Other: UObject | any): AddedPinData;
}

declare class NiagaraNodeOp extends NiagaraNodeWithDynamicPins { 
	OpName: string;
	AddedPins: AddedPinData[];
	bAllStatic: boolean;
	static Load(ResourceName: string): NiagaraNodeOp;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeOp;
	static GetDefaultObject(): NiagaraNodeOp;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeOp;
	static C(Other: UObject | any): NiagaraNodeOp;
}

declare class NiagaraNodeOutput extends NiagaraNode { 
	Outputs: NiagaraVariable[];
	ScriptType: ENiagaraScriptUsage;
	ScriptTypeId: Guid;
	ScriptTypeIndex: number;
	static Load(ResourceName: string): NiagaraNodeOutput;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeOutput;
	static GetDefaultObject(): NiagaraNodeOutput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeOutput;
	static C(Other: UObject | any): NiagaraNodeOutput;
}

declare class NiagaraNodeOutputTag extends NiagaraNodeWithDynamicPins { 
	bEmitMessageOnFailure: boolean;
	FailureSeverity: FNiagaraCompileEventSeverity;
	static Load(ResourceName: string): NiagaraNodeOutputTag;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeOutputTag;
	static GetDefaultObject(): NiagaraNodeOutputTag;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeOutputTag;
	static C(Other: UObject | any): NiagaraNodeOutputTag;
}

declare class NiagaraNodeParameterMapBase extends NiagaraNodeWithDynamicPins { 
	static Load(ResourceName: string): NiagaraNodeParameterMapBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeParameterMapBase;
	static GetDefaultObject(): NiagaraNodeParameterMapBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeParameterMapBase;
	static C(Other: UObject | any): NiagaraNodeParameterMapBase;
}

declare class NiagaraNodeParameterMapSet extends NiagaraNodeParameterMapBase { 
	static Load(ResourceName: string): NiagaraNodeParameterMapSet;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeParameterMapSet;
	static GetDefaultObject(): NiagaraNodeParameterMapSet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeParameterMapSet;
	static C(Other: UObject | any): NiagaraNodeParameterMapSet;
}

declare class NiagaraNodeParameterMapFor extends NiagaraNodeParameterMapSet { 
	static Load(ResourceName: string): NiagaraNodeParameterMapFor;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeParameterMapFor;
	static GetDefaultObject(): NiagaraNodeParameterMapFor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeParameterMapFor;
	static C(Other: UObject | any): NiagaraNodeParameterMapFor;
}

declare class NiagaraNodeParameterMapForWithContinue extends NiagaraNodeParameterMapFor { 
	static Load(ResourceName: string): NiagaraNodeParameterMapForWithContinue;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeParameterMapForWithContinue;
	static GetDefaultObject(): NiagaraNodeParameterMapForWithContinue;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeParameterMapForWithContinue;
	static C(Other: UObject | any): NiagaraNodeParameterMapForWithContinue;
}

declare class NiagaraNodeParameterMapForIndex extends NiagaraNode { 
	static Load(ResourceName: string): NiagaraNodeParameterMapForIndex;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeParameterMapForIndex;
	static GetDefaultObject(): NiagaraNodeParameterMapForIndex;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeParameterMapForIndex;
	static C(Other: UObject | any): NiagaraNodeParameterMapForIndex;
}

declare class NiagaraNodeParameterMapGet extends NiagaraNodeParameterMapBase { 
	PinOutputToPinDefaultPersistentId: Map<Guid, Guid>;
	static Load(ResourceName: string): NiagaraNodeParameterMapGet;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeParameterMapGet;
	static GetDefaultObject(): NiagaraNodeParameterMapGet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeParameterMapGet;
	static C(Other: UObject | any): NiagaraNodeParameterMapGet;
}

declare class NiagaraNodeReadDataSet extends NiagaraNodeDataSetBase { 
	static Load(ResourceName: string): NiagaraNodeReadDataSet;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeReadDataSet;
	static GetDefaultObject(): NiagaraNodeReadDataSet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeReadDataSet;
	static C(Other: UObject | any): NiagaraNodeReadDataSet;
}

declare class NiagaraNodeReroute extends NiagaraNode { 
	static Load(ResourceName: string): NiagaraNodeReroute;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeReroute;
	static GetDefaultObject(): NiagaraNodeReroute;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeReroute;
	static C(Other: UObject | any): NiagaraNodeReroute;
}

declare class NiagaraNodeUsageSelector extends NiagaraNodeWithDynamicPins { 
	OutputVars: NiagaraVariable[];
	OutputVarGuids: Guid[];
	SelectorGuid: Guid;
	NumOptionsPerVariable: number;
	static Load(ResourceName: string): NiagaraNodeUsageSelector;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeUsageSelector;
	static GetDefaultObject(): NiagaraNodeUsageSelector;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeUsageSelector;
	static C(Other: UObject | any): NiagaraNodeUsageSelector;
}

declare class NiagaraNodeSelect extends NiagaraNodeUsageSelector { 
	SelectorPinType: NiagaraTypeDefinition;
	SelectorPinGuid: Guid;
	static Load(ResourceName: string): NiagaraNodeSelect;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeSelect;
	static GetDefaultObject(): NiagaraNodeSelect;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeSelect;
	static C(Other: UObject | any): NiagaraNodeSelect;
}

declare class NiagaraNodeSimTargetSelector extends NiagaraNodeUsageSelector { 
	static Load(ResourceName: string): NiagaraNodeSimTargetSelector;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeSimTargetSelector;
	static GetDefaultObject(): NiagaraNodeSimTargetSelector;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeSimTargetSelector;
	static C(Other: UObject | any): NiagaraNodeSimTargetSelector;
}

declare type ENiagaraStaticSwitchType = 'Bool' | 'Integer' | 'Enum' | 'ENiagaraStaticSwitchType_MAX';
declare var ENiagaraStaticSwitchType : { Bool:'Bool',Integer:'Integer',Enum:'Enum',ENiagaraStaticSwitchType_MAX:'ENiagaraStaticSwitchType_MAX', };
declare class StaticSwitchTypeData { 
	SwitchType: ENiagaraStaticSwitchType;
	Enum: Enum;
	SwitchConstant: string;
	bAutoRefreshEnabled: boolean;
	bExposeAsPin: boolean;
	clone() : StaticSwitchTypeData;
	static C(Other: UObject | any): StaticSwitchTypeData;
}

declare class NiagaraNodeStaticSwitch extends NiagaraNodeUsageSelector { 
	InputParameterName: string;
	SwitchTypeData: StaticSwitchTypeData;
	static Load(ResourceName: string): NiagaraNodeStaticSwitch;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeStaticSwitch;
	static GetDefaultObject(): NiagaraNodeStaticSwitch;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeStaticSwitch;
	static C(Other: UObject | any): NiagaraNodeStaticSwitch;
}

declare class NiagaraNodeWriteDataSet extends NiagaraNodeDataSetBase { 
	EventName: string;
	static Load(ResourceName: string): NiagaraNodeWriteDataSet;
	static Find(Outer: UObject, ResourceName: string): NiagaraNodeWriteDataSet;
	static GetDefaultObject(): NiagaraNodeWriteDataSet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraNodeWriteDataSet;
	static C(Other: UObject | any): NiagaraNodeWriteDataSet;
}

declare class NiagaraOutlinerCaptureSettings { 
	bTriggerCapture: boolean;
	CaptureDelayFrames: number;
	bGatherPerfData: boolean;
	SimCacheCaptureFrames: number;
	clone() : NiagaraOutlinerCaptureSettings;
	static C(Other: UObject | any): NiagaraOutlinerCaptureSettings;
}

declare type ENiagaraOutlinerViewModes = 'State' | 'Performance' | 'Debug' | 'ENiagaraOutlinerViewModes_MAX';
declare var ENiagaraOutlinerViewModes : { State:'State',Performance:'Performance',Debug:'Debug',ENiagaraOutlinerViewModes_MAX:'ENiagaraOutlinerViewModes_MAX', };
declare type ENiagaraExecutionState = 'Active' | 'Inactive' | 'InactiveClear' | 'Complete' | 'Disabled' | 'Num' | 'ENiagaraExecutionState_MAX';
declare var ENiagaraExecutionState : { Active:'Active',Inactive:'Inactive',InactiveClear:'InactiveClear',Complete:'Complete',Disabled:'Disabled',Num:'Num',ENiagaraExecutionState_MAX:'ENiagaraExecutionState_MAX', };
declare class NiagaraOutlinerFilterSettings { 
	bFilterBySystemExecutionState: boolean;
	bFilterByEmitterExecutionState: boolean;
	bFilterByEmitterSimTarget: boolean;
	bFilterBySystemCullState: boolean;
	SystemExecutionState: ENiagaraExecutionState;
	EmitterExecutionState: ENiagaraExecutionState;
	EmitterSimTarget: ENiagaraSimTarget;
	bSystemCullState: boolean;
	clone() : NiagaraOutlinerFilterSettings;
	static C(Other: UObject | any): NiagaraOutlinerFilterSettings;
}

declare type ENiagaraOutlinerSortMode = 'Auto' | 'FilterMatches' | 'AverageTime' | 'MaxTime' | 'ENiagaraOutlinerSortMode_MAX';
declare var ENiagaraOutlinerSortMode : { Auto:'Auto',FilterMatches:'FilterMatches',AverageTime:'AverageTime',MaxTime:'MaxTime',ENiagaraOutlinerSortMode_MAX:'ENiagaraOutlinerSortMode_MAX', };
declare type ENiagaraOutlinerTimeUnits = 'Microseconds' | 'Milliseconds' | 'Seconds' | 'ENiagaraOutlinerTimeUnits_MAX';
declare var ENiagaraOutlinerTimeUnits : { Microseconds:'Microseconds',Milliseconds:'Milliseconds',Seconds:'Seconds',ENiagaraOutlinerTimeUnits_MAX:'ENiagaraOutlinerTimeUnits_MAX', };
declare class NiagaraOutlinerViewSettings { 
	ViewMode: ENiagaraOutlinerViewModes;
	FilterSettings: NiagaraOutlinerFilterSettings;
	bSortDescending: boolean;
	SortMode: ENiagaraOutlinerSortMode;
	TimeUnits: ENiagaraOutlinerTimeUnits;
	clone() : NiagaraOutlinerViewSettings;
	static C(Other: UObject | any): NiagaraOutlinerViewSettings;
}

declare class NiagaraOutlinerEmitterInstanceData { 
	EmitterName: string;
	SimTarget: ENiagaraSimTarget;
	ExecState: ENiagaraExecutionState;
	NumParticles: number;
	bRequiresPersistentIDs: boolean;
	clone() : NiagaraOutlinerEmitterInstanceData;
	static C(Other: UObject | any): NiagaraOutlinerEmitterInstanceData;
}

declare class NiagaraScalabilityState { 
	Significance: number;
	LastVisibleTime: number;
	bCulled: boolean;
	bPreviousCulled: boolean;
	bCulledByDistance: boolean;
	bCulledByInstanceCount: boolean;
	bCulledByVisibility: boolean;
	bCulledByGlobalBudget: boolean;
	clone() : NiagaraScalabilityState;
	static C(Other: UObject | any): NiagaraScalabilityState;
}

declare class NiagaraOutlinerTimingData { 
	GameThread: number;
	RenderThread: number;
	clone() : NiagaraOutlinerTimingData;
	static C(Other: UObject | any): NiagaraOutlinerTimingData;
}

declare type ENiagaraGpuComputeTickStage = 'PreInitViews' | 'PostInitViews' | 'PostOpaqueRender' | 'Max' | 'First' | 'Last' | 'ENiagaraGpuComputeTickStage_MAX';
declare var ENiagaraGpuComputeTickStage : { PreInitViews:'PreInitViews',PostInitViews:'PostInitViews',PostOpaqueRender:'PostOpaqueRender',Max:'Max',First:'First',Last:'Last',ENiagaraGpuComputeTickStage_MAX:'ENiagaraGpuComputeTickStage_MAX', };
declare class NiagaraOutlinerSystemInstanceData { 
	ComponentName: string;
	LWCTile: Vector3f;
	Emitters: NiagaraOutlinerEmitterInstanceData[];
	ActualExecutionState: ENiagaraExecutionState;
	RequestedExecutionState: ENiagaraExecutionState;
	ScalabilityState: NiagaraScalabilityState;
	bPendingKill: boolean;
	bUsingCullProxy: boolean;
	PoolMethod: ENCPoolMethod;
	AverageTime: NiagaraOutlinerTimingData;
	MaxTime: NiagaraOutlinerTimingData;
	TickGroup: ETickingGroup;
	GpuTickStage: ENiagaraGpuComputeTickStage;
	bIsSolo: boolean;
	bRequiresDistanceFieldData: boolean;
	bRequiresDepthBuffer: boolean;
	bRequiresEarlyViewData: boolean;
	bRequiresViewUniformBuffer: boolean;
	bRequiresRayTracingScene: boolean;
	clone() : NiagaraOutlinerSystemInstanceData;
	static C(Other: UObject | any): NiagaraOutlinerSystemInstanceData;
}

declare class NiagaraOutlinerSystemData { 
	SystemInstances: NiagaraOutlinerSystemInstanceData[];
	AveragePerFrameTime: NiagaraOutlinerTimingData;
	MaxPerFrameTime: NiagaraOutlinerTimingData;
	AveragePerInstanceTime: NiagaraOutlinerTimingData;
	MaxPerInstanceTime: NiagaraOutlinerTimingData;
	clone() : NiagaraOutlinerSystemData;
	static C(Other: UObject | any): NiagaraOutlinerSystemData;
}

declare class NiagaraOutlinerWorldData { 
	Systems: Map<string, NiagaraOutlinerSystemData>;
	bHasBegunPlay: boolean;
	WorldType: number;
	NetMode: number;
	AveragePerFrameTime: NiagaraOutlinerTimingData;
	MaxPerFrameTime: NiagaraOutlinerTimingData;
	clone() : NiagaraOutlinerWorldData;
	static C(Other: UObject | any): NiagaraOutlinerWorldData;
}

declare class NiagaraOutlinerData { 
	WorldData: Map<string, NiagaraOutlinerWorldData>;
	clone() : NiagaraOutlinerData;
	static C(Other: UObject | any): NiagaraOutlinerData;
}

declare class NiagaraOutliner extends UObject { 
	CaptureSettings: NiagaraOutlinerCaptureSettings;
	ViewSettings: NiagaraOutlinerViewSettings;
	Data: NiagaraOutlinerData;
	SystemSimCaches: Map<string, NiagaraSimCache>;
	static Load(ResourceName: string): NiagaraOutliner;
	static Find(Outer: UObject, ResourceName: string): NiagaraOutliner;
	static GetDefaultObject(): NiagaraOutliner;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraOutliner;
	static C(Other: UObject | any): NiagaraOutliner;
}

declare class NiagaraOverviewNode extends EdGraphNode { 
	OwningSystem: NiagaraSystem;
	EmitterHandleGuid: Guid;
	static Load(ResourceName: string): NiagaraOverviewNode;
	static Find(Outer: UObject, ResourceName: string): NiagaraOverviewNode;
	static GetDefaultObject(): NiagaraOverviewNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraOverviewNode;
	static C(Other: UObject | any): NiagaraOverviewNode;
}

declare class NiagaraParameterCollectionFactoryNew extends Factory { 
	static Load(ResourceName: string): NiagaraParameterCollectionFactoryNew;
	static Find(Outer: UObject, ResourceName: string): NiagaraParameterCollectionFactoryNew;
	static GetDefaultObject(): NiagaraParameterCollectionFactoryNew;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraParameterCollectionFactoryNew;
	static C(Other: UObject | any): NiagaraParameterCollectionFactoryNew;
}

declare class NiagaraParameterCollectionInstanceFactoryNew extends Factory { 
	static Load(ResourceName: string): NiagaraParameterCollectionInstanceFactoryNew;
	static Find(Outer: UObject, ResourceName: string): NiagaraParameterCollectionInstanceFactoryNew;
	static GetDefaultObject(): NiagaraParameterCollectionInstanceFactoryNew;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraParameterCollectionInstanceFactoryNew;
	static C(Other: UObject | any): NiagaraParameterCollectionInstanceFactoryNew;
}

declare class ScriptVarBindingNameSubscription { 
	ExternalScriptVarId: Guid;
	InternalScriptVarIds: Guid[];
	clone() : ScriptVarBindingNameSubscription;
	static C(Other: UObject | any): ScriptVarBindingNameSubscription;
}

declare class ParameterDefinitionsBindingNameSubscription { 
	SubscribedParameterDefinitions: NiagaraParameterDefinitions;
	BindingNameSubscriptions: ScriptVarBindingNameSubscription[];
	clone() : ParameterDefinitionsBindingNameSubscription;
	static C(Other: UObject | any): ParameterDefinitionsBindingNameSubscription;
}

declare class NiagaraParameterDefinitions extends NiagaraParameterDefinitionsBase { 
	bPromoteToTopInAddMenus: boolean;
	MenuSortOrder: number;
	ScriptVariables: NiagaraScriptVariable[];
	ExternalParameterDefinitionsSubscriptions: ParameterDefinitionsBindingNameSubscription[];
	static Load(ResourceName: string): NiagaraParameterDefinitions;
	static Find(Outer: UObject, ResourceName: string): NiagaraParameterDefinitions;
	static GetDefaultObject(): NiagaraParameterDefinitions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraParameterDefinitions;
	static C(Other: UObject | any): NiagaraParameterDefinitions;
}

declare class NiagaraParameterDefinitionsFactory extends Factory { 
	static Load(ResourceName: string): NiagaraParameterDefinitionsFactory;
	static Find(Outer: UObject, ResourceName: string): NiagaraParameterDefinitionsFactory;
	static GetDefaultObject(): NiagaraParameterDefinitionsFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraParameterDefinitionsFactory;
	static C(Other: UObject | any): NiagaraParameterDefinitionsFactory;
}

declare class NiagaraScriptSource extends NiagaraScriptSourceBase { 
	NodeGraph: NiagaraGraph;
	static Load(ResourceName: string): NiagaraScriptSource;
	static Find(Outer: UObject, ResourceName: string): NiagaraScriptSource;
	static GetDefaultObject(): NiagaraScriptSource;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScriptSource;
	static C(Other: UObject | any): NiagaraScriptSource;
}

declare class NiagaraSimCacheFactoryNew extends Factory { 
	static Load(ResourceName: string): NiagaraSimCacheFactoryNew;
	static Find(Outer: UObject, ResourceName: string): NiagaraSimCacheFactoryNew;
	static GetDefaultObject(): NiagaraSimCacheFactoryNew;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSimCacheFactoryNew;
	static C(Other: UObject | any): NiagaraSimCacheFactoryNew;
}

declare class NiagaraSystemEditorFolder extends UObject { 
	FolderName: string;
	ChildFolders: NiagaraSystemEditorFolder[];
	ChildEmitterHandleIds: Guid[];
	static Load(ResourceName: string): NiagaraSystemEditorFolder;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystemEditorFolder;
	static GetDefaultObject(): NiagaraSystemEditorFolder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystemEditorFolder;
	static C(Other: UObject | any): NiagaraSystemEditorFolder;
}

declare class NiagaraGraphViewSettings { 
	Location: Vector2D;
	Zoom: number;
	bIsValid: boolean;
	clone() : NiagaraGraphViewSettings;
	static C(Other: UObject | any): NiagaraGraphViewSettings;
}

declare class NiagaraSystemEditorData extends NiagaraEditorDataBase { 
	bSetOrbitModeByAsset: boolean;
	bSystemViewportInOrbitMode: boolean;
	UserParameterHierarchy: NiagaraHierarchyRoot;
	RootFolder: NiagaraSystemEditorFolder;
	StackEditorData: NiagaraStackEditorData;
	OwnerTransform: Transform;
	PlaybackRangeMin: number;
	PlaybackRangeMax: number;
	SystemOverviewGraph: EdGraph;
	OverviewGraphViewSettings: NiagaraGraphViewSettings;
	bSystemIsPlaceholder: boolean;
	UserParameterMetaData: NiagaraScriptVariable[];
	static Load(ResourceName: string): NiagaraSystemEditorData;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystemEditorData;
	static GetDefaultObject(): NiagaraSystemEditorData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystemEditorData;
	static C(Other: UObject | any): NiagaraSystemEditorData;
}

declare class NiagaraSystemFactoryNew extends Factory { 
	static Load(ResourceName: string): NiagaraSystemFactoryNew;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystemFactoryNew;
	static GetDefaultObject(): NiagaraSystemFactoryNew;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystemFactoryNew;
	static C(Other: UObject | any): NiagaraSystemFactoryNew;
}

declare class NiagaraThumbnailRendererBase extends TextureThumbnailRenderer { 
	static Load(ResourceName: string): NiagaraThumbnailRendererBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraThumbnailRendererBase;
	static GetDefaultObject(): NiagaraThumbnailRendererBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraThumbnailRendererBase;
	static C(Other: UObject | any): NiagaraThumbnailRendererBase;
}

declare class NiagaraEmitterThumbnailRenderer extends NiagaraThumbnailRendererBase { 
	static Load(ResourceName: string): NiagaraEmitterThumbnailRenderer;
	static Find(Outer: UObject, ResourceName: string): NiagaraEmitterThumbnailRenderer;
	static GetDefaultObject(): NiagaraEmitterThumbnailRenderer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEmitterThumbnailRenderer;
	static C(Other: UObject | any): NiagaraEmitterThumbnailRenderer;
}

declare class NiagaraSystemThumbnailRenderer extends NiagaraThumbnailRendererBase { 
	static Load(ResourceName: string): NiagaraSystemThumbnailRenderer;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystemThumbnailRenderer;
	static GetDefaultObject(): NiagaraSystemThumbnailRenderer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystemThumbnailRenderer;
	static C(Other: UObject | any): NiagaraSystemThumbnailRenderer;
}

declare class NiagaraValidationRule_NoWarmupTime extends NiagaraValidationRule { 
	static Load(ResourceName: string): NiagaraValidationRule_NoWarmupTime;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_NoWarmupTime;
	static GetDefaultObject(): NiagaraValidationRule_NoWarmupTime;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_NoWarmupTime;
	static C(Other: UObject | any): NiagaraValidationRule_NoWarmupTime;
}

declare class NiagaraValidationRule_FixedGPUBoundsSet extends NiagaraValidationRule { 
	static Load(ResourceName: string): NiagaraValidationRule_FixedGPUBoundsSet;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_FixedGPUBoundsSet;
	static GetDefaultObject(): NiagaraValidationRule_FixedGPUBoundsSet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_FixedGPUBoundsSet;
	static C(Other: UObject | any): NiagaraValidationRule_FixedGPUBoundsSet;
}

declare class NiagaraValidationRule_BannedRenderers extends NiagaraValidationRule { 
	Platforms: NiagaraPlatformSet;
	BannedRenderers: UnrealEngineClass[];
	static Load(ResourceName: string): NiagaraValidationRule_BannedRenderers;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_BannedRenderers;
	static GetDefaultObject(): NiagaraValidationRule_BannedRenderers;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_BannedRenderers;
	static C(Other: UObject | any): NiagaraValidationRule_BannedRenderers;
}

declare class NiagaraValidationRule_BannedModules extends NiagaraValidationRule { 
	Platforms: NiagaraPlatformSet;
	BannedModules: NiagaraScript[];
	static Load(ResourceName: string): NiagaraValidationRule_BannedModules;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_BannedModules;
	static GetDefaultObject(): NiagaraValidationRule_BannedModules;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_BannedModules;
	static C(Other: UObject | any): NiagaraValidationRule_BannedModules;
}

declare class NiagaraValidationRule_InvalidEffectType extends NiagaraValidationRule { 
	static Load(ResourceName: string): NiagaraValidationRule_InvalidEffectType;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_InvalidEffectType;
	static GetDefaultObject(): NiagaraValidationRule_InvalidEffectType;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_InvalidEffectType;
	static C(Other: UObject | any): NiagaraValidationRule_InvalidEffectType;
}

declare class NiagaraValidationRule_LWC extends NiagaraValidationRule { 
	static Load(ResourceName: string): NiagaraValidationRule_LWC;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_LWC;
	static GetDefaultObject(): NiagaraValidationRule_LWC;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_LWC;
	static C(Other: UObject | any): NiagaraValidationRule_LWC;
}

declare class NiagaraValidationRule_NoOpaqueRenderMaterial extends NiagaraValidationRule { 
	static Load(ResourceName: string): NiagaraValidationRule_NoOpaqueRenderMaterial;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_NoOpaqueRenderMaterial;
	static GetDefaultObject(): NiagaraValidationRule_NoOpaqueRenderMaterial;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_NoOpaqueRenderMaterial;
	static C(Other: UObject | any): NiagaraValidationRule_NoOpaqueRenderMaterial;
}

declare class NiagaraValidationRule_NoFixedDeltaTime extends NiagaraValidationRule { 
	static Load(ResourceName: string): NiagaraValidationRule_NoFixedDeltaTime;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_NoFixedDeltaTime;
	static GetDefaultObject(): NiagaraValidationRule_NoFixedDeltaTime;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_NoFixedDeltaTime;
	static C(Other: UObject | any): NiagaraValidationRule_NoFixedDeltaTime;
}

declare class NiagaraValidationRule_SimulationStageBudget extends NiagaraValidationRule { 
	bMaxSimulationStagesEnabled: boolean;
	bMaxIterationsPerStageEnabled: boolean;
	bMaxTotalIterationsEnabled: boolean;
	MaxSimulationStages: number;
	MaxIterationsPerStage: number;
	MaxTotalIterations: number;
	static Load(ResourceName: string): NiagaraValidationRule_SimulationStageBudget;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule_SimulationStageBudget;
	static GetDefaultObject(): NiagaraValidationRule_SimulationStageBudget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule_SimulationStageBudget;
	static C(Other: UObject | any): NiagaraValidationRule_SimulationStageBudget;
}

declare class NiagaraVersionMetaData extends UObject { 
	bIsExposedVersion: boolean;
	ChangeDescription: string;
	bIsVisibleInVersionSelector: boolean;
	bDeprecated: boolean;
	DeprecationMessage: string;
	VersionGuid: Guid;
	UpdateScriptExecution: ENiagaraPythonUpdateScriptReference;
	PythonUpdateScript: string;
	ScriptAsset: FilePath;
	static Load(ResourceName: string): NiagaraVersionMetaData;
	static Find(Outer: UObject, ResourceName: string): NiagaraVersionMetaData;
	static GetDefaultObject(): NiagaraVersionMetaData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraVersionMetaData;
	static C(Other: UObject | any): NiagaraVersionMetaData;
}

declare class MovieSceneNiagaraEmitterSectionBase extends MovieSceneSection { 
	static Load(ResourceName: string): MovieSceneNiagaraEmitterSectionBase;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraEmitterSectionBase;
	static GetDefaultObject(): MovieSceneNiagaraEmitterSectionBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraEmitterSectionBase;
	static C(Other: UObject | any): MovieSceneNiagaraEmitterSectionBase;
}

declare class MovieSceneNiagaraEmitterTrack extends MovieSceneNameableTrack { 
	Sections: MovieSceneSection[];
	bSectionsWereModified: boolean;
	EmitterHandleId: Guid;
	SystemPath: string;
	static Load(ResourceName: string): MovieSceneNiagaraEmitterTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraEmitterTrack;
	static GetDefaultObject(): MovieSceneNiagaraEmitterTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraEmitterTrack;
	static C(Other: UObject | any): MovieSceneNiagaraEmitterTrack;
}

declare class NiagaraSequence extends MovieSceneSequence { 
	MovieScene: MovieScene;
	static Load(ResourceName: string): NiagaraSequence;
	static Find(Outer: UObject, ResourceName: string): NiagaraSequence;
	static GetDefaultObject(): NiagaraSequence;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSequence;
	static C(Other: UObject | any): NiagaraSequence;
}

declare class NiagaraSequencerTrackFilter extends SequencerTrackFilterExtension { 
	static Load(ResourceName: string): NiagaraSequencerTrackFilter;
	static Find(Outer: UObject, ResourceName: string): NiagaraSequencerTrackFilter;
	static GetDefaultObject(): NiagaraSequencerTrackFilter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSequencerTrackFilter;
	static C(Other: UObject | any): NiagaraSequencerTrackFilter;
}

declare class MovieSceneNiagaraEmitterSection extends MovieSceneNiagaraEmitterSectionBase { 
	NumLoops: number;
	bStartTimeIncludedInFirstLoopOnly: boolean;
	static Load(ResourceName: string): MovieSceneNiagaraEmitterSection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNiagaraEmitterSection;
	static GetDefaultObject(): MovieSceneNiagaraEmitterSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNiagaraEmitterSection;
	static C(Other: UObject | any): MovieSceneNiagaraEmitterSection;
}

declare class NiagaraPythonScriptModuleInput extends UObject { 
	Input: NiagaraClipboardFunctionInput;
	static Load(ResourceName: string): NiagaraPythonScriptModuleInput;
	static Find(Outer: UObject, ResourceName: string): NiagaraPythonScriptModuleInput;
	static GetDefaultObject(): NiagaraPythonScriptModuleInput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPythonScriptModuleInput;
	IsSet(): boolean;
	IsLocalValue(): boolean;
	AsVec4(): Vector4;
	AsVec3(): Vector;
	AsVec2(): Vector2D;
	AsQuat(): Quat;
	AsInt(): number;
	AsFloat(): number;
	AsEnum(): string;
	AsColor(): LinearColor;
	AsBool(): boolean;
	static C(Other: UObject | any): NiagaraPythonScriptModuleInput;
}

declare class UpgradeNiagaraScriptResults extends UObject { 
	bCancelledByPythonError: boolean;
	OldInputs: NiagaraPythonScriptModuleInput[];
	NewInputs: NiagaraPythonScriptModuleInput[];
	DummyInput: NiagaraPythonScriptModuleInput;
	static Load(ResourceName: string): UpgradeNiagaraScriptResults;
	static Find(Outer: UObject, ResourceName: string): UpgradeNiagaraScriptResults;
	static GetDefaultObject(): UpgradeNiagaraScriptResults;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UpgradeNiagaraScriptResults;
	SetVec4Input(InputName: string,Value: Vector4): void;
	SetVec3Input(InputName: string,Value: Vector): void;
	SetVec2Input(InputName: string,Value: Vector2D): void;
	SetQuatInput(InputName: string,Value: Quat): void;
	SetIntInput(InputName: string,Value: number): void;
	SetFloatInput(InputName: string,Value: number): void;
	SetEnumInput(InputName: string,Value: string): void;
	SetColorInput(InputName: string,Value: LinearColor): void;
	SetBoolInput(InputName: string,Value: boolean): void;
	GetOldInput(InputName: string): NiagaraPythonScriptModuleInput;
	static C(Other: UObject | any): UpgradeNiagaraScriptResults;
}

declare class NiagaraStackErrorItem extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackErrorItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackErrorItem;
	static GetDefaultObject(): NiagaraStackErrorItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackErrorItem;
	static C(Other: UObject | any): NiagaraStackErrorItem;
}

declare class NiagaraStackEntry extends UObject { 
	StackEditorData: NiagaraStackEditorData;
	Children: NiagaraStackEntry[];
	ErrorChildren: NiagaraStackErrorItem[];
	static Load(ResourceName: string): NiagaraStackEntry;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEntry;
	static GetDefaultObject(): NiagaraStackEntry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEntry;
	static C(Other: UObject | any): NiagaraStackEntry;
}

declare class NiagaraStackItemFooter extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackItemFooter;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackItemFooter;
	static GetDefaultObject(): NiagaraStackItemFooter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackItemFooter;
	static C(Other: UObject | any): NiagaraStackItemFooter;
}

declare class NiagaraStackItem extends NiagaraStackEntry { 
	ItemFooter: NiagaraStackItemFooter;
	static Load(ResourceName: string): NiagaraStackItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackItem;
	static GetDefaultObject(): NiagaraStackItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackItem;
	static C(Other: UObject | any): NiagaraStackItem;
}

declare class NiagaraStackModuleItemLinkedInputCollection extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackModuleItemLinkedInputCollection;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackModuleItemLinkedInputCollection;
	static GetDefaultObject(): NiagaraStackModuleItemLinkedInputCollection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackModuleItemLinkedInputCollection;
	static C(Other: UObject | any): NiagaraStackModuleItemLinkedInputCollection;
}

declare class NiagaraStackItemContent extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackItemContent;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackItemContent;
	static GetDefaultObject(): NiagaraStackItemContent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackItemContent;
	static C(Other: UObject | any): NiagaraStackItemContent;
}

declare class NiagaraStackFunctionInputCollectionBase extends NiagaraStackItemContent { 
	static Load(ResourceName: string): NiagaraStackFunctionInputCollectionBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackFunctionInputCollectionBase;
	static GetDefaultObject(): NiagaraStackFunctionInputCollectionBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackFunctionInputCollectionBase;
	static C(Other: UObject | any): NiagaraStackFunctionInputCollectionBase;
}

declare class NiagaraStackFunctionInputCollection extends NiagaraStackFunctionInputCollectionBase { 
	static Load(ResourceName: string): NiagaraStackFunctionInputCollection;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackFunctionInputCollection;
	static GetDefaultObject(): NiagaraStackFunctionInputCollection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackFunctionInputCollection;
	static C(Other: UObject | any): NiagaraStackFunctionInputCollection;
}

declare class NiagaraStackModuleItemOutputCollection extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackModuleItemOutputCollection;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackModuleItemOutputCollection;
	static GetDefaultObject(): NiagaraStackModuleItemOutputCollection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackModuleItemOutputCollection;
	static C(Other: UObject | any): NiagaraStackModuleItemOutputCollection;
}

declare class NiagaraStackModuleItem extends NiagaraStackItem { 
	LinkedInputCollection: NiagaraStackModuleItemLinkedInputCollection;
	InputCollection: NiagaraStackFunctionInputCollection;
	OutputCollection: NiagaraStackModuleItemOutputCollection;
	static Load(ResourceName: string): NiagaraStackModuleItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackModuleItem;
	static GetDefaultObject(): NiagaraStackModuleItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackModuleItem;
	static C(Other: UObject | any): NiagaraStackModuleItem;
}

declare class NiagaraPythonModule extends UObject { 
	ModuleItem: NiagaraStackModuleItem;
	static Load(ResourceName: string): NiagaraPythonModule;
	static Find(Outer: UObject, ResourceName: string): NiagaraPythonModule;
	static GetDefaultObject(): NiagaraPythonModule;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPythonModule;
	GetObject(): NiagaraStackModuleItem;
	static C(Other: UObject | any): NiagaraPythonModule;
}

declare class NiagaraPythonEmitter extends UObject { 
	static Load(ResourceName: string): NiagaraPythonEmitter;
	static Find(Outer: UObject, ResourceName: string): NiagaraPythonEmitter;
	static GetDefaultObject(): NiagaraPythonEmitter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPythonEmitter;
	SetProperties(Data: VersionedNiagaraEmitterData): void;
	HasModule(ModuleName: string): boolean;
	GetProperties(): VersionedNiagaraEmitterData;
	GetObject(): NiagaraEmitter;
	GetModules(): NiagaraPythonModule[];
	GetModule(ModuleName: string): NiagaraPythonModule;
	static C(Other: UObject | any): NiagaraPythonEmitter;
}

declare class UpgradeNiagaraEmitterContext extends UObject { 
	bCancelledByPythonError: boolean;
	OldEmitter: NiagaraPythonEmitter;
	NewEmitter: NiagaraPythonEmitter;
	static Load(ResourceName: string): UpgradeNiagaraEmitterContext;
	static Find(Outer: UObject, ResourceName: string): UpgradeNiagaraEmitterContext;
	static GetDefaultObject(): UpgradeNiagaraEmitterContext;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UpgradeNiagaraEmitterContext;
	static C(Other: UObject | any): UpgradeNiagaraEmitterContext;
}

declare class NiagaraCurveSelectionViewModel extends UObject { 
	static Load(ResourceName: string): NiagaraCurveSelectionViewModel;
	static Find(Outer: UObject, ResourceName: string): NiagaraCurveSelectionViewModel;
	static GetDefaultObject(): NiagaraCurveSelectionViewModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraCurveSelectionViewModel;
	static C(Other: UObject | any): NiagaraCurveSelectionViewModel;
}

declare class NiagaraScratchPadViewModel extends UObject { 
	static Load(ResourceName: string): NiagaraScratchPadViewModel;
	static Find(Outer: UObject, ResourceName: string): NiagaraScratchPadViewModel;
	static GetDefaultObject(): NiagaraScratchPadViewModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScratchPadViewModel;
	static C(Other: UObject | any): NiagaraScratchPadViewModel;
}

declare class NiagaraScripStatsViewModelSettings extends UObject { 
	EnabledPlatforms: number[];
	static Load(ResourceName: string): NiagaraScripStatsViewModelSettings;
	static Find(Outer: UObject, ResourceName: string): NiagaraScripStatsViewModelSettings;
	static GetDefaultObject(): NiagaraScripStatsViewModelSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScripStatsViewModelSettings;
	static C(Other: UObject | any): NiagaraScripStatsViewModelSettings;
}

declare class NiagaraSystemEditorDocumentsViewModel extends UObject { 
	static Load(ResourceName: string): NiagaraSystemEditorDocumentsViewModel;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystemEditorDocumentsViewModel;
	static GetDefaultObject(): NiagaraSystemEditorDocumentsViewModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystemEditorDocumentsViewModel;
	static C(Other: UObject | any): NiagaraSystemEditorDocumentsViewModel;
}

declare class NiagaraSystemScalabilityViewModel extends UObject { 
	static Load(ResourceName: string): NiagaraSystemScalabilityViewModel;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystemScalabilityViewModel;
	static GetDefaultObject(): NiagaraSystemScalabilityViewModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystemScalabilityViewModel;
	static C(Other: UObject | any): NiagaraSystemScalabilityViewModel;
}

declare class NiagaraStackSelection extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackSelection;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSelection;
	static GetDefaultObject(): NiagaraStackSelection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSelection;
	static C(Other: UObject | any): NiagaraStackSelection;
}

declare class NiagaraStackViewModel extends UObject { 
	RootEntry: NiagaraStackEntry;
	static Load(ResourceName: string): NiagaraStackViewModel;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackViewModel;
	static GetDefaultObject(): NiagaraStackViewModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackViewModel;
	static C(Other: UObject | any): NiagaraStackViewModel;
}

declare class NiagaraSystemSelectionViewModel extends UObject { 
	StackSelection: NiagaraStackSelection;
	SelectionStackViewModel: NiagaraStackViewModel;
	static Load(ResourceName: string): NiagaraSystemSelectionViewModel;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystemSelectionViewModel;
	static GetDefaultObject(): NiagaraSystemSelectionViewModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystemSelectionViewModel;
	static C(Other: UObject | any): NiagaraSystemSelectionViewModel;
}

declare class NiagaraStackItemGroupFooter extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackItemGroupFooter;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackItemGroupFooter;
	static GetDefaultObject(): NiagaraStackItemGroupFooter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackItemGroupFooter;
	static C(Other: UObject | any): NiagaraStackItemGroupFooter;
}

declare class NiagaraStackItemGroup extends NiagaraStackEntry { 
	GroupFooter: NiagaraStackItemGroupFooter;
	static Load(ResourceName: string): NiagaraStackItemGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackItemGroup;
	static GetDefaultObject(): NiagaraStackItemGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackItemGroup;
	static C(Other: UObject | any): NiagaraStackItemGroup;
}

declare class NiagaraStackObject extends NiagaraStackItemContent { 
	static Load(ResourceName: string): NiagaraStackObject;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackObject;
	static GetDefaultObject(): NiagaraStackObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackObject;
	static C(Other: UObject | any): NiagaraStackObject;
}

declare class NiagaraStackEmitterPropertiesItem extends NiagaraStackItem { 
	EmitterObject: NiagaraStackObject;
	static Load(ResourceName: string): NiagaraStackEmitterPropertiesItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEmitterPropertiesItem;
	static GetDefaultObject(): NiagaraStackEmitterPropertiesItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEmitterPropertiesItem;
	static C(Other: UObject | any): NiagaraStackEmitterPropertiesItem;
}

declare class NiagaraStackEmitterPropertiesGroup extends NiagaraStackItemGroup { 
	PropertiesItem: NiagaraStackEmitterPropertiesItem;
	static Load(ResourceName: string): NiagaraStackEmitterPropertiesGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEmitterPropertiesGroup;
	static GetDefaultObject(): NiagaraStackEmitterPropertiesGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEmitterPropertiesGroup;
	static C(Other: UObject | any): NiagaraStackEmitterPropertiesGroup;
}

declare class NiagaraStackSummaryViewObject extends NiagaraStackFunctionInputCollectionBase { 
	static Load(ResourceName: string): NiagaraStackSummaryViewObject;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSummaryViewObject;
	static GetDefaultObject(): NiagaraStackSummaryViewObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSummaryViewObject;
	static C(Other: UObject | any): NiagaraStackSummaryViewObject;
}

declare class NiagaraStackEmitterSummaryItem extends NiagaraStackItem { 
	FilteredObject: NiagaraStackSummaryViewObject;
	SummaryEditorData: NiagaraStackObject;
	static Load(ResourceName: string): NiagaraStackEmitterSummaryItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEmitterSummaryItem;
	static GetDefaultObject(): NiagaraStackEmitterSummaryItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEmitterSummaryItem;
	static C(Other: UObject | any): NiagaraStackEmitterSummaryItem;
}

declare class NiagaraStackEmitterSummaryGroup extends NiagaraStackItemGroup { 
	SummaryItem: NiagaraStackEmitterSummaryItem;
	static Load(ResourceName: string): NiagaraStackEmitterSummaryGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEmitterSummaryGroup;
	static GetDefaultObject(): NiagaraStackEmitterSummaryGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEmitterSummaryGroup;
	static C(Other: UObject | any): NiagaraStackEmitterSummaryGroup;
}

declare class NiagaraStackSummaryViewCollapseButton extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackSummaryViewCollapseButton;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSummaryViewCollapseButton;
	static GetDefaultObject(): NiagaraStackSummaryViewCollapseButton;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSummaryViewCollapseButton;
	static C(Other: UObject | any): NiagaraStackSummaryViewCollapseButton;
}

declare class NiagaraStackSpacer extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackSpacer;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSpacer;
	static GetDefaultObject(): NiagaraStackSpacer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSpacer;
	static C(Other: UObject | any): NiagaraStackSpacer;
}

declare class NiagaraStackErrorItemLongDescription extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackErrorItemLongDescription;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackErrorItemLongDescription;
	static GetDefaultObject(): NiagaraStackErrorItemLongDescription;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackErrorItemLongDescription;
	static C(Other: UObject | any): NiagaraStackErrorItemLongDescription;
}

declare class NiagaraStackErrorItemFix extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackErrorItemFix;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackErrorItemFix;
	static GetDefaultObject(): NiagaraStackErrorItemFix;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackErrorItemFix;
	static C(Other: UObject | any): NiagaraStackErrorItemFix;
}

declare class NiagaraStackErrorItemDismiss extends NiagaraStackErrorItemFix { 
	static Load(ResourceName: string): NiagaraStackErrorItemDismiss;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackErrorItemDismiss;
	static GetDefaultObject(): NiagaraStackErrorItemDismiss;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackErrorItemDismiss;
	static C(Other: UObject | any): NiagaraStackErrorItemDismiss;
}

declare class NiagaraStackEventWrapper extends UObject { 
	EventHandlerScriptProps: NiagaraEventScriptProperties[];
	static Load(ResourceName: string): NiagaraStackEventWrapper;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEventWrapper;
	static GetDefaultObject(): NiagaraStackEventWrapper;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEventWrapper;
	static C(Other: UObject | any): NiagaraStackEventWrapper;
}

declare class NiagaraStackEventHandlerPropertiesItem extends NiagaraStackItem { 
	EmitterObject: NiagaraStackObject;
	EventWrapper: NiagaraStackEventWrapper;
	static Load(ResourceName: string): NiagaraStackEventHandlerPropertiesItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEventHandlerPropertiesItem;
	static GetDefaultObject(): NiagaraStackEventHandlerPropertiesItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEventHandlerPropertiesItem;
	static C(Other: UObject | any): NiagaraStackEventHandlerPropertiesItem;
}

declare class NiagaraStackScriptItemGroup extends NiagaraStackItemGroup { 
	static Load(ResourceName: string): NiagaraStackScriptItemGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackScriptItemGroup;
	static GetDefaultObject(): NiagaraStackScriptItemGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackScriptItemGroup;
	static C(Other: UObject | any): NiagaraStackScriptItemGroup;
}

declare class NiagaraStackEventScriptItemGroup extends NiagaraStackScriptItemGroup { 
	EventHandlerProperties: NiagaraStackEventHandlerPropertiesItem;
	static Load(ResourceName: string): NiagaraStackEventScriptItemGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackEventScriptItemGroup;
	static GetDefaultObject(): NiagaraStackEventScriptItemGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackEventScriptItemGroup;
	static C(Other: UObject | any): NiagaraStackEventScriptItemGroup;
}

declare class NiagaraStackFilteredObject extends NiagaraStackFunctionInputCollectionBase { 
	static Load(ResourceName: string): NiagaraStackFilteredObject;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackFilteredObject;
	static GetDefaultObject(): NiagaraStackFilteredObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackFilteredObject;
	static C(Other: UObject | any): NiagaraStackFilteredObject;
}

declare class NiagaraStackFunctionInput extends NiagaraStackItemContent { 
	static Load(ResourceName: string): NiagaraStackFunctionInput;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackFunctionInput;
	static GetDefaultObject(): NiagaraStackFunctionInput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackFunctionInput;
	static C(Other: UObject | any): NiagaraStackFunctionInput;
}

declare class NiagaraStackInputCategory extends NiagaraStackItemContent { 
	CategorySpacer: NiagaraStackSpacer;
	static Load(ResourceName: string): NiagaraStackInputCategory;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackInputCategory;
	static GetDefaultObject(): NiagaraStackInputCategory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackInputCategory;
	static C(Other: UObject | any): NiagaraStackInputCategory;
}

declare class NiagaraStackItemTextContent extends NiagaraStackItemContent { 
	static Load(ResourceName: string): NiagaraStackItemTextContent;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackItemTextContent;
	static GetDefaultObject(): NiagaraStackItemTextContent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackItemTextContent;
	static C(Other: UObject | any): NiagaraStackItemTextContent;
}

declare class NiagaraStackModuleItemOutput extends NiagaraStackEntry { 
	static Load(ResourceName: string): NiagaraStackModuleItemOutput;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackModuleItemOutput;
	static GetDefaultObject(): NiagaraStackModuleItemOutput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackModuleItemOutput;
	static C(Other: UObject | any): NiagaraStackModuleItemOutput;
}

declare class NiagaraStackParameterStoreEntry extends NiagaraStackItemContent { 
	ValueObjectEntry: NiagaraStackObject;
	static Load(ResourceName: string): NiagaraStackParameterStoreEntry;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackParameterStoreEntry;
	static GetDefaultObject(): NiagaraStackParameterStoreEntry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackParameterStoreEntry;
	static C(Other: UObject | any): NiagaraStackParameterStoreEntry;
}

declare class NiagaraStackPropertyRow extends NiagaraStackItemContent { 
	CategorySpacer: NiagaraStackSpacer;
	static Load(ResourceName: string): NiagaraStackPropertyRow;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackPropertyRow;
	static GetDefaultObject(): NiagaraStackPropertyRow;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackPropertyRow;
	static C(Other: UObject | any): NiagaraStackPropertyRow;
}

declare class NiagaraStackRendererItem extends NiagaraStackItem { 
	RendererObject: NiagaraStackObject;
	static Load(ResourceName: string): NiagaraStackRendererItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackRendererItem;
	static GetDefaultObject(): NiagaraStackRendererItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackRendererItem;
	static C(Other: UObject | any): NiagaraStackRendererItem;
}

declare class NiagaraStackRenderItemGroup extends NiagaraStackItemGroup { 
	static Load(ResourceName: string): NiagaraStackRenderItemGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackRenderItemGroup;
	static GetDefaultObject(): NiagaraStackRenderItemGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackRenderItemGroup;
	static C(Other: UObject | any): NiagaraStackRenderItemGroup;
}

declare class NiagaraStackSystemPropertiesGroup extends NiagaraStackItemGroup { 
	static Load(ResourceName: string): NiagaraStackSystemPropertiesGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSystemPropertiesGroup;
	static GetDefaultObject(): NiagaraStackSystemPropertiesGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSystemPropertiesGroup;
	static C(Other: UObject | any): NiagaraStackSystemPropertiesGroup;
}

declare class NiagaraStackSystemUserParametersGroup extends NiagaraStackItemGroup { 
	static Load(ResourceName: string): NiagaraStackSystemUserParametersGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSystemUserParametersGroup;
	static GetDefaultObject(): NiagaraStackSystemUserParametersGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSystemUserParametersGroup;
	static C(Other: UObject | any): NiagaraStackSystemUserParametersGroup;
}

declare class NiagaraStackRoot extends NiagaraStackEntry { 
	SystemPropertiesGroup: NiagaraStackSystemPropertiesGroup;
	SystemUserParametersGroup: NiagaraStackSystemUserParametersGroup;
	SystemSpawnGroup: NiagaraStackScriptItemGroup;
	SystemUpdateGroup: NiagaraStackScriptItemGroup;
	EmitterPropertiesGroup: NiagaraStackEmitterPropertiesGroup;
	EmitterSummaryGroup: NiagaraStackEmitterSummaryGroup;
	EmitterSpawnGroup: NiagaraStackScriptItemGroup;
	EmitterUpdateGroup: NiagaraStackScriptItemGroup;
	ParticleSpawnGroup: NiagaraStackScriptItemGroup;
	ParticleUpdateGroup: NiagaraStackScriptItemGroup;
	RenderGroup: NiagaraStackRenderItemGroup;
	SummaryCollapseButton: NiagaraStackSummaryViewCollapseButton;
	static Load(ResourceName: string): NiagaraStackRoot;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackRoot;
	static GetDefaultObject(): NiagaraStackRoot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackRoot;
	static C(Other: UObject | any): NiagaraStackRoot;
}

declare class NiagaraStackSimulationStagePropertiesItem extends NiagaraStackItem { 
	SimulationStageObject: NiagaraStackObject;
	static Load(ResourceName: string): NiagaraStackSimulationStagePropertiesItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSimulationStagePropertiesItem;
	static GetDefaultObject(): NiagaraStackSimulationStagePropertiesItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSimulationStagePropertiesItem;
	static C(Other: UObject | any): NiagaraStackSimulationStagePropertiesItem;
}

declare class NiagaraStackSimulationStageGroup extends NiagaraStackScriptItemGroup { 
	SimulationStageProperties: NiagaraStackSimulationStagePropertiesItem;
	static Load(ResourceName: string): NiagaraStackSimulationStageGroup;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSimulationStageGroup;
	static GetDefaultObject(): NiagaraStackSimulationStageGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSimulationStageGroup;
	static C(Other: UObject | any): NiagaraStackSimulationStageGroup;
}

declare class NiagaraStackSystemPropertiesItem extends NiagaraStackItem { 
	SystemObject: NiagaraStackObject;
	static Load(ResourceName: string): NiagaraStackSystemPropertiesItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackSystemPropertiesItem;
	static GetDefaultObject(): NiagaraStackSystemPropertiesItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackSystemPropertiesItem;
	static C(Other: UObject | any): NiagaraStackSystemPropertiesItem;
}

declare class NiagaraStackParameterStoreItem extends NiagaraStackItem { 
	static Load(ResourceName: string): NiagaraStackParameterStoreItem;
	static Find(Outer: UObject, ResourceName: string): NiagaraStackParameterStoreItem;
	static GetDefaultObject(): NiagaraStackParameterStoreItem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraStackParameterStoreItem;
	static C(Other: UObject | any): NiagaraStackParameterStoreItem;
}

declare class VolumeCacheFactory extends Factory { 
	static Load(ResourceName: string): VolumeCacheFactory;
	static Find(Outer: UObject, ResourceName: string): VolumeCacheFactory;
	static GetDefaultObject(): VolumeCacheFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VolumeCacheFactory;
	static C(Other: UObject | any): VolumeCacheFactory;
}

declare class NiagaraClipboardFunction_OnPastedFunctionCallNode__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): NiagaraClipboardFunction_OnPastedFunctionCallNode__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): NiagaraClipboardFunction_OnPastedFunctionCallNode__PythonCallable;
	static GetDefaultObject(): NiagaraClipboardFunction_OnPastedFunctionCallNode__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraClipboardFunction_OnPastedFunctionCallNode__PythonCallable;
	static C(Other: UObject | any): NiagaraClipboardFunction_OnPastedFunctionCallNode__PythonCallable;
}

declare class OnNiagaraSystemFinished__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnNiagaraSystemFinished__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnNiagaraSystemFinished__PythonCallable;
	static GetDefaultObject(): OnNiagaraSystemFinished__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnNiagaraSystemFinished__PythonCallable;
	static C(Other: UObject | any): OnNiagaraSystemFinished__PythonCallable;
}

declare class AsyncNiagaraCaptureSimCache_OnCaptureComplete__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): AsyncNiagaraCaptureSimCache_OnCaptureComplete__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): AsyncNiagaraCaptureSimCache_OnCaptureComplete__PythonCallable;
	static GetDefaultObject(): AsyncNiagaraCaptureSimCache_OnCaptureComplete__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncNiagaraCaptureSimCache_OnCaptureComplete__PythonCallable;
	static C(Other: UObject | any): AsyncNiagaraCaptureSimCache_OnCaptureComplete__PythonCallable;
}

declare class AnimNotifyState_TimedNiagaraEffect extends AnimNotifyState { 
	Template: NiagaraSystem;
	SocketName: string;
	LocationOffset: Vector;
	RotationOffset: Rotator;
	bDestroyAtEnd: boolean;
	static Load(ResourceName: string): AnimNotifyState_TimedNiagaraEffect;
	static Find(Outer: UObject, ResourceName: string): AnimNotifyState_TimedNiagaraEffect;
	static GetDefaultObject(): AnimNotifyState_TimedNiagaraEffect;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimNotifyState_TimedNiagaraEffect;
	GetSpawnedEffect(MeshComp: MeshComponent): FXSystemComponent;
	static C(Other: UObject | any): AnimNotifyState_TimedNiagaraEffect;
}

declare class CurveParameterPair { 
	AnimCurveName: string;
	UserVariableName: string;
	clone() : CurveParameterPair;
	static C(Other: UObject | any): CurveParameterPair;
}

declare class AnimNotifyState_TimedNiagaraEffectAdvanced extends AnimNotifyState_TimedNiagaraEffect { 
	bEnableNormalizedNotifyProgress: boolean;
	NotifyProgressUserParameter: string;
	AnimCurves: CurveParameterPair[];
	static Load(ResourceName: string): AnimNotifyState_TimedNiagaraEffectAdvanced;
	static Find(Outer: UObject, ResourceName: string): AnimNotifyState_TimedNiagaraEffectAdvanced;
	static GetDefaultObject(): AnimNotifyState_TimedNiagaraEffectAdvanced;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimNotifyState_TimedNiagaraEffectAdvanced;
	GetNotifyProgress(MeshComp: MeshComponent): number;
	static C(Other: UObject | any): AnimNotifyState_TimedNiagaraEffectAdvanced;
}

declare class AnimNotify_PlayNiagaraEffect extends AnimNotify { 
	Template: NiagaraSystem;
	LocationOffset: Vector;
	RotationOffset: Rotator;
	Scale: Vector;
	bAbsoluteScale: boolean;
	Attached: boolean;
	SocketName: string;
	static Load(ResourceName: string): AnimNotify_PlayNiagaraEffect;
	static Find(Outer: UObject, ResourceName: string): AnimNotify_PlayNiagaraEffect;
	static GetDefaultObject(): AnimNotify_PlayNiagaraEffect;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimNotify_PlayNiagaraEffect;
	GetSpawnedEffect(): FXSystemComponent;
	static C(Other: UObject | any): AnimNotify_PlayNiagaraEffect;
}

declare class ImgMediaPlaybackComponent extends ActorComponent { 
	LODBias: number;
	static Load(ResourceName: string): ImgMediaPlaybackComponent;
	static Find(Outer: UObject, ResourceName: string): ImgMediaPlaybackComponent;
	static GetDefaultObject(): ImgMediaPlaybackComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ImgMediaPlaybackComponent;
	static C(Other: UObject | any): ImgMediaPlaybackComponent;
}

declare type EActorSequenceObjectReferenceType = 'ContextActor' | 'ExternalActor' | 'Component' | 'EActorSequenceObjectReferenceType_MAX';
declare var EActorSequenceObjectReferenceType : { ContextActor:'ContextActor',ExternalActor:'ExternalActor',Component:'Component',EActorSequenceObjectReferenceType_MAX:'EActorSequenceObjectReferenceType_MAX', };
declare class ActorSequenceObjectReference { 
	Type: EActorSequenceObjectReferenceType;
	ActorId: Guid;
	PathToComponent: string;
	clone() : ActorSequenceObjectReference;
	static C(Other: UObject | any): ActorSequenceObjectReference;
}

declare class ActorSequenceObjectReferences { 
	Array: ActorSequenceObjectReference[];
	clone() : ActorSequenceObjectReferences;
	static C(Other: UObject | any): ActorSequenceObjectReferences;
}

declare class ActorSequenceObjectReferenceMap { 
	BindingIds: Guid[];
	References: ActorSequenceObjectReferences[];
	clone() : ActorSequenceObjectReferenceMap;
	static C(Other: UObject | any): ActorSequenceObjectReferenceMap;
}

declare class ActorSequence extends MovieSceneSequence { 
	MovieScene: MovieScene;
	ObjectReferences: ActorSequenceObjectReferenceMap;
	bHasBeenInitialized: boolean;
	static Load(ResourceName: string): ActorSequence;
	static Find(Outer: UObject, ResourceName: string): ActorSequence;
	static GetDefaultObject(): ActorSequence;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorSequence;
	static C(Other: UObject | any): ActorSequence;
}

declare class ActorSequencePlayer extends MovieSceneSequencePlayer { 
	static Load(ResourceName: string): ActorSequencePlayer;
	static Find(Outer: UObject, ResourceName: string): ActorSequencePlayer;
	static GetDefaultObject(): ActorSequencePlayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorSequencePlayer;
	static C(Other: UObject | any): ActorSequencePlayer;
}

declare class ActorSequenceComponent extends ActorComponent { 
	PlaybackSettings: MovieSceneSequencePlaybackSettings;
	Sequence: ActorSequence;
	SequencePlayer: ActorSequencePlayer;
	static Load(ResourceName: string): ActorSequenceComponent;
	static Find(Outer: UObject, ResourceName: string): ActorSequenceComponent;
	static GetDefaultObject(): ActorSequenceComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorSequenceComponent;
	StopSequence(): void;
	PlaySequence(): void;
	PauseSequence(): void;
	static C(Other: UObject | any): ActorSequenceComponent;
}

declare class V8Config extends UObject { 
	bGenAltPropAccessorForAllProp: boolean;
	bGenGetStructRefArrayFunction: boolean;
	static Load(ResourceName: string): V8Config;
	static Find(Outer: UObject, ResourceName: string): V8Config;
	static GetDefaultObject(): V8Config;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): V8Config;
	static C(Other: UObject | any): V8Config;
}

declare class DirectoryWatcher extends UObject { 
	Added: string[];
	Modified: string[];
	Removed: string[];
	OnChanged: UnrealEngineMulticastDelegate<() => void>;
	static Load(ResourceName: string): DirectoryWatcher;
	static Find(Outer: UObject, ResourceName: string): DirectoryWatcher;
	static GetDefaultObject(): DirectoryWatcher;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DirectoryWatcher;
	Watch(Directory: string): void;
	Unwatch(): void;
	Contains(File: string): boolean;
	static C(Other: UObject | any): DirectoryWatcher;
}

declare class JavascriptContext extends UObject { 
	Paths: string[];
	static Load(ResourceName: string): JavascriptContext;
	static Find(Outer: UObject, ResourceName: string): JavascriptContext;
	static GetDefaultObject(): JavascriptContext;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptContext;
	WriteDTS(Target: string,bIncludingTooltip: boolean): boolean;
	WriteAliases(Target: string): boolean;
	UnregisterConsoleCommand(Command: string): void;
	SetContextId(Name: string): void;
	RunScript(Script: string,bOutput: boolean): string;
	RunFileWithArgs(Filename: string,Args: string[]): string;
	RunFile(Filename: string): string;
	ResetUnrealConsoleDelegate(): void;
	RequestV8GarbageCollection(): void;
	RegisterConsoleCommand(Command: string,Help: string,UFunction: JavascriptFunction): void;
	ReadScriptFile(Filename: string): string;
	IsDebugContext(): boolean;
	GetScriptFileFullPath(Filename: string): string;
	FindPathFile(TargetRootPath: string,TargetFileName: string,OutFiles?: string[]): {OutFiles: string[]};
	Expose(Name: string,UObject: UObject): void;
	DestroyInspector(): void;
	CreateInspector(Port: number): void;
	static C(Other: UObject | any): JavascriptContext;
}

declare class JavascriptHeapStatistics { 
	TotalHeapSize: number;
	TotalHeapSizeExecutable: number;
	TotalPhysicalSize: number;
	TotalAvailableSize: number;
	UsedHeapSize: number;
	HeapSizeLimit: number;
	MallocedMemory: number;
	bDoesZapGarbage: boolean;
	clone() : JavascriptHeapStatistics;
	static C(Other: UObject | any): JavascriptHeapStatistics;
}

declare class JavascriptIsolate extends UObject { 
	static Load(ResourceName: string): JavascriptIsolate;
	static Find(Outer: UObject, ResourceName: string): JavascriptIsolate;
	static GetDefaultObject(): JavascriptIsolate;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptIsolate;
	Init(bIsEditor: boolean): void;
	GetHeapStatistics(Statistics?: JavascriptHeapStatistics): {Statistics: JavascriptHeapStatistics};
	CreateContext(): JavascriptContext;
	static C(Other: UObject | any): JavascriptIsolate;
}

declare class JavascriptAsset { 
	Name: string;
	Asset: SoftObjectPath;
	clone() : JavascriptAsset;
	static C(Other: UObject | any): JavascriptAsset;
}

declare class JavascriptClassAsset { 
	Name: string;
	Class: UnrealEngineClass;
	clone() : JavascriptClassAsset;
	static C(Other: UObject | any): JavascriptClassAsset;
}

declare class JavascriptComponent extends ActorComponent { 
	ScriptSourceFile: string;
	bActiveWithinEditor: boolean;
	JavascriptContext: JavascriptContext;
	JavascriptIsolate: JavascriptIsolate;
	OnTick: UnrealEngineDelegate<(DeltaSeconds: number) => void>;
	OnBeginPlay: UnrealEngineDelegate<() => void>;
	OnEndPlay: UnrealEngineDelegate<() => void>;
	OnInvoke: UnrealEngineDelegate<(Name: string) => void>;
	Assets: JavascriptAsset[];
	ClassAssets: JavascriptClassAsset[];
	static Load(ResourceName: string): JavascriptComponent;
	static Find(Outer: UObject, ResourceName: string): JavascriptComponent;
	static GetDefaultObject(): JavascriptComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComponent;
	ResolveClass(Name: string): UnrealEngineClass;
	ResolveAsset(Name: string,bTryLoad: boolean): UObject;
	Invoke(Name: string): void;
	ForceGC(): void;
	Expose(ExposedAs: string,UObject: UObject): void;
	static C(Other: UObject | any): JavascriptComponent;
}

declare class JavascriptDelegate extends UObject { 
	static Load(ResourceName: string): JavascriptDelegate;
	static Find(Outer: UObject, ResourceName: string): JavascriptDelegate;
	static GetDefaultObject(): JavascriptDelegate;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptDelegate;
	Fire(): void;
	static C(Other: UObject | any): JavascriptDelegate;
}

declare class JavascriptGeneratedClass extends BlueprintGeneratedClass { 
	static Load(ResourceName: string): JavascriptGeneratedClass;
	static Find(Outer: UObject, ResourceName: string): JavascriptGeneratedClass;
	static GetDefaultObject(): JavascriptGeneratedClass;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptGeneratedClass;
	static C(Other: UObject | any): JavascriptGeneratedClass;
}

declare class JavascriptGeneratedClass_Native extends BlueprintGeneratedClass { 
	static Load(ResourceName: string): JavascriptGeneratedClass_Native;
	static Find(Outer: UObject, ResourceName: string): JavascriptGeneratedClass_Native;
	static GetDefaultObject(): JavascriptGeneratedClass_Native;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptGeneratedClass_Native;
	static C(Other: UObject | any): JavascriptGeneratedClass_Native;
}

declare class JavascriptGeneratedFunction extends UFunction { 
	static Load(ResourceName: string): JavascriptGeneratedFunction;
	static Find(Outer: UObject, ResourceName: string): JavascriptGeneratedFunction;
	static GetDefaultObject(): JavascriptGeneratedFunction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptGeneratedFunction;
	static C(Other: UObject | any): JavascriptGeneratedFunction;
}

declare class JavascriptGlobalDelegates extends UObject { 
	static Load(ResourceName: string): JavascriptGlobalDelegates;
	static Find(Outer: UObject, ResourceName: string): JavascriptGlobalDelegates;
	static GetDefaultObject(): JavascriptGlobalDelegates;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptGlobalDelegates;
	UnbindAll(): void;
	Unbind(Key: string): void;
	RedirectorFollowed(PackageName: string,Redirector: UObject): void;
	PreLoadMap(MapName: string): void;
	PreGarbageCollectDelegate(): void;
	PostLoadMapWithWorld(World: World): void;
	PostGarbageCollect(): void;
	PostDemoPlay(): void;
	PostApplyLevelOffset(Level: Level,World: World,Offset: Vector,Flag: boolean): void;
	PackageCreatedForLoad(InPackage: Package): void;
	OnWorldCleanup(World: World,bSessionEnded: boolean,bCleanupResources: boolean): void;
	OnPreWorldInitialization_Friendly(World: World): void;
	OnPreWorldFinishDestroy(World: World): void;
	OnPreObjectPropertyChanged_Friendly(InObject: UObject,Property: any,MemberProperty: any): void;
	OnPostWorldInitialization_Friendly(World: World): void;
	OnPostWorldCreation(World: World): void;
	OnPostDuplicate_Friendly(World: World,bDuplicateForPIE: boolean): void;
	OnObjectPropertyChanged_Friendly(InObject: UObject,Property: any,MemberProperty: any,ChangeType: number): void;
	OnObjectPreSave_Friendly(ObjectSaved: UObject): void;
	OnObjectModified(UObject: UObject): void;
	OnAssetLoaded(UObject: UObject): void;
	OnActorLabelChanged(Actor: Actor): void;
	LevelRemovedFromWorld(Level: Level,World: World): void;
	LevelAddedToWorld(Level: Level,World: World): void;
	Bind(Key: string): void;
	static C(Other: UObject | any): JavascriptGlobalDelegates;
}

declare class JavascriptStaticCache extends UObject { 
	Isolates: JavascriptIsolate[];
	bExecuteTestModePIE: boolean;
	static Load(ResourceName: string): JavascriptStaticCache;
	static Find(Outer: UObject, ResourceName: string): JavascriptStaticCache;
	static GetDefaultObject(): JavascriptStaticCache;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptStaticCache;
	static C(Other: UObject | any): JavascriptStaticCache;
}

declare class JavascriptRow { 
	Values: string[];
	clone() : JavascriptRow;
	static C(Other: UObject | any): JavascriptRow;
}

declare class JavascriptStreamableManager { 
	clone() : JavascriptStreamableManager;
	static C(Other: UObject | any): JavascriptStreamableManager;
	IsAsyncLoadComplete(Target: SoftObjectPath): boolean;
	RequestAsyncLoad(TargetsToStream: SoftObjectPath[],DelegateToCall: JavascriptFunction,Priority: number): void;
	SimpleAsyncLoad(Target: SoftObjectPath,Priority: number): void;
	Unload(Target: SoftObjectPath): void;
	static IsAsyncLoadComplete(Manager: JavascriptStreamableManager,Target: SoftObjectPath): boolean;
	static RequestAsyncLoad(Manager: JavascriptStreamableManager,TargetsToStream: SoftObjectPath[],DelegateToCall: JavascriptFunction,Priority: number): void;
	static SimpleAsyncLoad(Manager: JavascriptStreamableManager,Target: SoftObjectPath,Priority: number): void;
	static Unload(Manager: JavascriptStreamableManager,Target: SoftObjectPath): void;
	static CreateStreamableManager(): JavascriptStreamableManager;
}

declare class JavascriptInternetAddr { 
	clone() : JavascriptInternetAddr;
	static C(Other: UObject | any): JavascriptInternetAddr;
	SetIp(ResolvedAddress?: string,bValid?: boolean): {Addr: JavascriptInternetAddr, bValid: boolean};
	SetPort(Port?: number): {Addr: JavascriptInternetAddr};
	static SetIp(Addr?: JavascriptInternetAddr,ResolvedAddress?: string,bValid?: boolean): {Addr: JavascriptInternetAddr, bValid: boolean};
	static SetPort(Addr?: JavascriptInternetAddr,Port?: number): {Addr: JavascriptInternetAddr};
	static CreateInternetAddr(): JavascriptInternetAddr;
}

declare class JavascriptSocket { 
	clone() : JavascriptSocket;
	static C(Other: UObject | any): JavascriptSocket;
	SendMemoryTo(ToAddr?: JavascriptInternetAddr,NumBytes?: number,BytesSent?: number): {Socket: JavascriptSocket, BytesSent: number, $: boolean};
	static SendMemoryTo(Socket?: JavascriptSocket,ToAddr?: JavascriptInternetAddr,NumBytes?: number,BytesSent?: number): {Socket: JavascriptSocket, BytesSent: number, $: boolean};
	static CreateSocket(SocketType: string,Description: string,bForceUDP: boolean): JavascriptSocket;
}

declare type EJavascriptStatDataType = 'Invalid' | 'ST_None' | 'ST_int64' | 'ST_double' | 'ST_FName' | 'ST_Ptr' | 'EJavascriptStatDataType_MAX';
declare var EJavascriptStatDataType : { Invalid:'Invalid',ST_None:'ST_None',ST_int64:'ST_int64',ST_double:'ST_double',ST_FName:'ST_FName',ST_Ptr:'ST_Ptr',EJavascriptStatDataType_MAX:'EJavascriptStatDataType_MAX', };
declare type EJavascriptStatOperation = 'Invalid' | 'SetLongName' | 'AdvanceFrameEventGameThread' | 'AdvanceFrameEventRenderThread' | 'CycleScopeStart' | 'CycleScopeEnd' | 'SpecialMessageMarker' | 'Set' | 'Clear' | 'Add' | 'Subtract' | 'ChildrenStart' | 'ChildrenEnd' | 'Leaf' | 'MaxVal' | 'Memory' | 'EJavascriptStatOperation_MAX';
declare var EJavascriptStatOperation : { Invalid:'Invalid',SetLongName:'SetLongName',AdvanceFrameEventGameThread:'AdvanceFrameEventGameThread',AdvanceFrameEventRenderThread:'AdvanceFrameEventRenderThread',CycleScopeStart:'CycleScopeStart',CycleScopeEnd:'CycleScopeEnd',SpecialMessageMarker:'SpecialMessageMarker',Set:'Set',Clear:'Clear',Add:'Add',Subtract:'Subtract',ChildrenStart:'ChildrenStart',ChildrenEnd:'ChildrenEnd',Leaf:'Leaf',MaxVal:'MaxVal',Memory:'Memory',EJavascriptStatOperation_MAX:'EJavascriptStatOperation_MAX', };
declare class JavascriptStat { 
	clone() : JavascriptStat;
	static C(Other: UObject | any): JavascriptStat;
	AddMessage(InStatOperation: EJavascriptStatOperation): void;
	AddMessage_float(InStatOperation: EJavascriptStatOperation,Value: number,bIsCycle: boolean): void;
	AddMessage_int(InStatOperation: EJavascriptStatOperation,Value: number,bIsCycle: boolean): void;
	static AddMessage(Stat: JavascriptStat,InStatOperation: EJavascriptStatOperation): void;
	static AddMessage_float(Stat: JavascriptStat,InStatOperation: EJavascriptStatOperation,Value: number,bIsCycle: boolean): void;
	static AddMessage_int(Stat: JavascriptStat,InStatOperation: EJavascriptStatOperation,Value: number,bIsCycle: boolean): void;
	static NewStat(InStatName: string,InStatDesc: string,InGroupName: string,InGroupCategory: string,InGroupDesc: string,bDefaultEnable: boolean,bShouldClearEveryFrame: boolean,InStatType: EJavascriptStatDataType,bCycleStat: boolean,bSortByName: boolean): JavascriptStat;
}

declare type ELogVerbosity_JS = 'NoLogging' | 'Fatal' | 'Error' | 'Warning' | 'Display' | 'Log' | 'Verbose' | 'VeryVerbose' | 'ELogVerbosity_MAX';
declare var ELogVerbosity_JS : { NoLogging:'NoLogging',Fatal:'Fatal',Error:'Error',Warning:'Warning',Display:'Display',Log:'Log',Verbose:'Verbose',VeryVerbose:'VeryVerbose',ELogVerbosity_MAX:'ELogVerbosity_MAX', };
declare class JavascriptLogCategory { 
	clone() : JavascriptLogCategory;
	static C(Other: UObject | any): JavascriptLogCategory;
	GetCategoryName(): string;
	IsSuppressed(Verbosity: ELogVerbosity_JS): boolean;
	Log(Verbosity: ELogVerbosity_JS,Message: string,Filename: string,LineNumber: number): void;
	static GetCategoryName(Category: JavascriptLogCategory): string;
	static IsSuppressed(Category: JavascriptLogCategory,Verbosity: ELogVerbosity_JS): boolean;
	static Log(Category: JavascriptLogCategory,Verbosity: ELogVerbosity_JS,Message: string,Filename: string,LineNumber: number): void;
	static CreateLogCategory(CategoryName: string,InDefaultVerbosity: ELogVerbosity_JS): JavascriptLogCategory;
}

declare class JavscriptProperty { 
	Type: string;
	Name: string;
	clone() : JavscriptProperty;
	static C(Other: UObject | any): JavscriptProperty;
}

declare class JavascriptProfileNode { 
	clone() : JavascriptProfileNode;
	static C(Other: UObject | any): JavascriptProfileNode;
	GetBailoutReason(): string;
	GetChild(Index: number): JavascriptProfileNode;
	GetChildrenCount(): number;
	GetColumnNumber(): number;
	GetDeoptInfo_Reason(Index: number): string;
	GetDeoptInfo_Stack(Index: number): string;
	GetDeoptInfosCount(Index: number): number;
	GetFunctionName(): string;
	GetHitCount(): number;
	GetHitLineCount(): number;
	GetLineNumber(): number;
	GetNodeId(): number;
	GetScriptId(): number;
	GetScriptResourceName(): string;
	static GetBailoutReason(UNode: JavascriptProfileNode): string;
	static GetChild(UNode: JavascriptProfileNode,Index: number): JavascriptProfileNode;
	static GetChildrenCount(UNode: JavascriptProfileNode): number;
	static GetColumnNumber(UNode: JavascriptProfileNode): number;
	static GetDeoptInfo_Reason(UNode: JavascriptProfileNode,Index: number): string;
	static GetDeoptInfo_Stack(UNode: JavascriptProfileNode,Index: number): string;
	static GetDeoptInfosCount(UNode: JavascriptProfileNode,Index: number): number;
	static GetFunctionName(UNode: JavascriptProfileNode): string;
	static GetHitCount(UNode: JavascriptProfileNode): number;
	static GetHitLineCount(UNode: JavascriptProfileNode): number;
	static GetLineNumber(UNode: JavascriptProfileNode): number;
	static GetNodeId(UNode: JavascriptProfileNode): number;
	static GetScriptId(UNode: JavascriptProfileNode): number;
	static GetScriptResourceName(UNode: JavascriptProfileNode): string;
}

declare class JavascriptLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): JavascriptLibrary;
	static Find(Outer: UObject, ResourceName: string): JavascriptLibrary;
	static GetDefaultObject(): JavascriptLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptLibrary;
	static WriteStringToFile(UObject: UObject,Filename: string,Data: string,EncodingOptions: EJavascriptEncodingOptions): boolean;
	static WriteFile(UObject: UObject,Filename: string): boolean;
	static WriteCSV(InPath: string,InData?: JavascriptRow[],EncodingOptions?: EJavascriptEncodingOptions): {InData: JavascriptRow[], $: boolean};
	static V8_SetIdleTaskBudget(BudgetInSeconds: number): void;
	static V8_SetFlagsFromString(V8Flags: string): void;
	static V8_IsEnableHotReload(): boolean;
	static UnregisterComponent(ActorComponent: ActorComponent): void;
	static Unload(Manager: JavascriptStreamableManager,Target: SoftObjectPath): void;
	static TryLoadByPath(Path: string): UObject;
	static SimpleAsyncLoad(Manager: JavascriptStreamableManager,Target: SoftObjectPath,Priority: number): void;
	static SetRootComponent(Actor: Actor,Component: SceneComponent): void;
	static SetPort(Addr?: JavascriptInternetAddr,Port?: number): {Addr: JavascriptInternetAddr};
	static SetObjectFlags(Obj: UObject,Flags: number): void;
	static SetMobility(SceneComponent: SceneComponent,Type: EComponentMobility): void;
	static SetMobile(SceneComponent: SceneComponent): void;
	static SetIp(Addr?: JavascriptInternetAddr,ResolvedAddress?: string,bValid?: boolean): {Addr: JavascriptInternetAddr, bValid: boolean};
	static SetClientTravel(Engine: Engine,InWorld: World,NextURL: string,InTravelType: ETravelType): void;
	static SetActorFlags(Actor: Actor,Flags: number): void;
	static SendMemoryTo(Socket?: JavascriptSocket,ToAddr?: JavascriptInternetAddr,NumBytes?: number,BytesSent?: number): {Socket: JavascriptSocket, BytesSent: number, $: boolean};
	static SegmentIntersection2D(SegmentStartA: Vector,SegmentEndA: Vector,SegmentStartB: Vector,SegmentEndB: Vector,IntersectionPoint?: Vector): {IntersectionPoint: Vector, $: boolean};
	static ResolveIp(HostName: string,OutIp?: string): {OutIp: string, $: boolean};
	static ReregisterComponent(ActorComponent: ActorComponent): void;
	static ReregisterAllComponents(Actor: Actor): void;
	static RequestAsyncLoad(Manager: JavascriptStreamableManager,TargetsToStream: SoftObjectPath[],DelegateToCall: JavascriptFunction,Priority: number): void;
	static RegisterComponent(ActorComponent: ActorComponent): void;
	static ReadStringFromFileAsync(UObject: UObject,Filename: string,UFunction: JavascriptFunction): ReadStringFromFileHandle;
	static ReadStringFromFile(UObject: UObject,Filename: string,ReadFlags: EFileRead_JS): string;
	static ReadFile(UObject: UObject,Filename: string): boolean;
	static ReadDirectory(UObject: UObject,Directory: string,OutItems?: DirectoryItem[]): {OutItems: DirectoryItem[], $: boolean};
	static ReadCSV(InPath: string,OutData?: JavascriptRow[],ReadFlags?: EFileRead_JS): {OutData: JavascriptRow[], $: boolean};
	static NewStat(InStatName: string,InStatDesc: string,InGroupName: string,InGroupCategory: string,InGroupDesc: string,bDefaultEnable: boolean,bShouldClearEveryFrame: boolean,InStatType: EJavascriptStatDataType,bCycleStat: boolean,bSortByName: boolean): JavascriptStat;
	static MarkRenderStateDirty(Component: ActorComponent): void;
	static MakeDirectory(Path: string,Tree: boolean): boolean;
	static Log(Category: JavascriptLogCategory,Verbosity: ELogVerbosity_JS,Message: string,Filename: string,LineNumber: number): void;
	static LoadPackage(InOuter: Package,PackageName: string): Package;
	static IsSuppressed(Category: JavascriptLogCategory,Verbosity: ELogVerbosity_JS): boolean;
	static IsRegistered(ActorComponent: ActorComponent): boolean;
	static IsPlayInPreview(World: World): boolean;
	static IsPlayInEditor(World: World): boolean;
	static IsPendingKill(InActor: Actor): boolean;
	static IsGeneratedByBlueprint(InClass: UnrealEngineClass): boolean;
	static IsGameWorld(World: World): boolean;
	static IsAsyncLoadComplete(Manager: JavascriptStreamableManager,Target: SoftObjectPath): boolean;
	static HasUndo(Engine: Engine): boolean;
	static HasAnyPackageFlags(Package: Package,Flags: number): boolean;
	static HasAnyFlags(UObject: UObject,Flags: number): boolean;
	static HandleSeamlessTravelPlayer(GameMode: GameModeBase,C?: Controller): {C: Controller};
	static GetWorldBounds(InWorld: World): Box;
	static GetSuperClasses(InClass: UnrealEngineClass): UnrealEngineClass[];
	static GetStructProperties(StructName: string,bIncludeSuper: boolean): JavscriptProperty[];
	static GetScriptResourceName(UNode: JavascriptProfileNode): string;
	static GetScriptId(UNode: JavascriptProfileNode): number;
	static GetPlatformName(): string;
	static GetOutermost(UObject: UObject): UObject;
	static GetOuter(UObject: UObject): UObject;
	static GetObjectsWithOuter(Outer: UObject,Results?: UObject[],bIncludeNestedObjects?: boolean,ExclusionFlags?: number,ExclusionInternalFlags?: number): {Results: UObject[]};
	static GetObjectsOfClass(ClassToLookFor: UnrealEngineClass,Results?: UObject[],bIncludeDerivedClasses?: boolean,ExcludeFlags?: number,ExclusionInternalFlags?: number): {Results: UObject[]};
	static GetNodeId(UNode: JavascriptProfileNode): number;
	static GetName(UObject: UObject): string;
	static GetModel(World: World): Model;
	static GetMetaData(Field: Field,Key: string): string;
	static GetLineNumber(UNode: JavascriptProfileNode): number;
	static GetLevels(World: World): Level[];
	static GetLevel(Actor: Actor): Level;
	static GetLastRenderTime(Actor: Actor): number;
	static GetHitLineCount(UNode: JavascriptProfileNode): number;
	static GetHitCount(UNode: JavascriptProfileNode): number;
	static GetFunctionParmsSize(UFunction: UFunction): number;
	static GetFunctionName(UNode: JavascriptProfileNode): string;
	static GetFileSize(UObject: UObject,Filename: string): number;
	static GetFields(UObject: UObject,bIncludeSuper: boolean): Field[];
	static GetEnumListByEnumName(EnumName: string): string[];
	static GetDynamicBinding(Outer: UnrealEngineClass,BindingObjectClass: UnrealEngineClass): DynamicBlueprintBinding;
	static GetDir(UObject: UObject,WhichDir: string): string;
	static GetDerivedClasses(ClassToLookFor: UnrealEngineClass,Results?: UnrealEngineClass[],bRecursive?: boolean): {Results: UnrealEngineClass[]};
	static GetDeoptInfosCount(UNode: JavascriptProfileNode,Index: number): number;
	static GetDeoptInfo_Stack(UNode: JavascriptProfileNode,Index: number): string;
	static GetDeoptInfo_Reason(UNode: JavascriptProfileNode,Index: number): string;
	static GetCurrentProcessId(): number;
	static GetComponentsByClass(Actor: Actor,ComponentClass: UnrealEngineClass): ActorComponent[];
	static GetColumnNumber(UNode: JavascriptProfileNode): number;
	static GetClassPathName(Class: UnrealEngineClass): string;
	static GetChildrenCount(UNode: JavascriptProfileNode): number;
	static GetChild(UNode: JavascriptProfileNode,Index: number): JavascriptProfileNode;
	static GetCategoryName(Category: JavascriptLogCategory): string;
	static GetBlueprintGeneratedClassFromPath(Path: string): UnrealEngineClass;
	static GetBlueprintGeneratedClass(Blueprint: Blueprint): UnrealEngineClass;
	static GetBailoutReason(UNode: JavascriptProfileNode): string;
	static GetArchetypePathName(UObject: UObject): string;
	static GetAllActorsOfClassAndTagsInCurrentLevel(WorldContextObject: UObject,ActorClass: UnrealEngineClass,Tags_Accept: string[],Tags_Deny: string[],OutActors?: Actor[]): {OutActors: Actor[]};
	static GetAllActorsOfClassAndTags(WorldContextObject: UObject,ActorClass: UnrealEngineClass,Tags_Accept: string[],Tags_Deny: string[],OutActors?: Actor[]): {OutActors: Actor[]};
	static GenerateNavigation(InWorld: World,NavData: RecastNavMesh): void;
	static FindPackage(InOuter: UObject,PackageName: string): Package;
	static FindObjectWithOuter(Outer: UObject,ClassToLookFor: UnrealEngineClass,NameToLookFor: string): UObject;
	static FileExists(Filename: string): boolean;
	static Duplicate(UObject: UObject,Outer: UObject,Name: string): UObject;
	static DirectoryExists(InDirectory: string): boolean;
	static DeleteFile(Filename: string,ReadOnly: boolean): boolean;
	static DeleteDirectory(Path: string,RequireExists: boolean,Tree: boolean): boolean;
	static CreateStreamableManager(): JavascriptStreamableManager;
	static CreateSocket(SocketType: string,Description: string,bForceUDP: boolean): JavascriptSocket;
	static CreatePackage(Outer: UObject,PackageName: string): Package;
	static CreateLogCategory(CategoryName: string,InDefaultVerbosity: ELogVerbosity_JS): JavascriptLogCategory;
	static CreateInternetAddr(): JavascriptInternetAddr;
	static CreateEnum(Outer: UObject,Name: string,DisplayNames: string[],Flags: string[]): Enum;
	static ConvertRelativePathToFull(UObject: UObject,RelativePath: string): string;
	static ClipboardPaste(): string;
	static ClipboardCopy(string: string): void;
	static CallJS(UFunction: JavascriptFunction,CustomStruct: JavascriptStubStruct): void;
	static AddMessage_int(Stat: JavascriptStat,InStatOperation: EJavascriptStatOperation,Value: number,bIsCycle: boolean): void;
	static AddMessage_float(Stat: JavascriptStat,InStatOperation: EJavascriptStatOperation,Value: number,bIsCycle: boolean): void;
	static AddMessage(Stat: JavascriptStat,InStatOperation: EJavascriptStatOperation): void;
	static AddDynamicBinding(Outer: UnrealEngineClass,BindingObject: DynamicBlueprintBinding): void;
	static Actor_GetWorld(Actor: Actor): World;
	static C(Other: UObject | any): JavascriptLibrary;
}

declare class JavascriptMemoryObject extends UObject { 
	static Load(ResourceName: string): JavascriptMemoryObject;
	static Find(Outer: UObject, ResourceName: string): JavascriptMemoryObject;
	static GetDefaultObject(): JavascriptMemoryObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMemoryObject;
	static C(Other: UObject | any): JavascriptMemoryObject;
}

declare class JavascriptRef { 
	clone() : JavascriptRef;
	static C(Other: UObject | any): JavascriptRef;
}

declare class JavascriptObject extends UObject { 
	Ref: JavascriptRef;
	Func: JavascriptFunction;
	static Load(ResourceName: string): JavascriptObject;
	static Find(Outer: UObject, ResourceName: string): JavascriptObject;
	static GetDefaultObject(): JavascriptObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptObject;
	static C(Other: UObject | any): JavascriptObject;
}

declare class JavascriptOutputDevice extends UObject { 
	static Load(ResourceName: string): JavascriptOutputDevice;
	static Find(Outer: UObject, ResourceName: string): JavascriptOutputDevice;
	static GetDefaultObject(): JavascriptOutputDevice;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptOutputDevice;
	OnMessage(Message: string,Verbosity: ELogVerbosity_JS,Category: string): void;
	static Log(Category: string,Verbosity: ELogVerbosity_JS,Filename: string,LineNumber: number,Message: string): void;
	Kill(): void;
	static C(Other: UObject | any): JavascriptOutputDevice;
}

declare class JavascriptProcess extends UObject { 
	static Load(ResourceName: string): JavascriptProcess;
	static Find(Outer: UObject, ResourceName: string): JavascriptProcess;
	static GetDefaultObject(): JavascriptProcess;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptProcess;
	WriteToPipe(Message: string,OutWritten?: string): {OutWritten: string, $: boolean};
	Wait(): void;
	Terminate(KillTree: boolean): void;
	static Sleep(Seconds: number): void;
	static SimulateKeypress(KeyEvent: number): void;
	static SetEnvironmentVar(VarName: string,VarValue: string): void;
	ReadFromPipe(): string;
	ReadArrayFromPipe(Array?: number[]): {Array: number[], $: boolean};
	static Open_PID(ProcessId: number): JavascriptProcess;
	static Open(ProcName: string): JavascriptProcess;
	static LaunchURL(URL: string,Parms: string,Error?: string): {Error: string};
	IsRunning(): boolean;
	static IsApplicationRunning_PID(ProcessId: number): boolean;
	static IsApplicationRunning(ProcName: string): boolean;
	static GetString(Key: string,bFlag: boolean): string;
	GetReturnCode(ReturnCode?: number): {ReturnCode: number, $: boolean};
	static GetEnvironmentVar(VarName: string): string;
	static GetCurrentProcessId(): number;
	static GetApplicationName(ProcessId: number): string;
	static Create(URL: string,Parms: string,bLaunchDetached: boolean,bLaunchHidden: boolean,bLaunchReallyHidden: boolean,PriorityModifier: number,OptionalWorkingDirectory: string,bUsePipe: boolean): JavascriptProcess;
	Close(): void;
	static CanLaunchURL(URL: string): boolean;
	static C(Other: UObject | any): JavascriptProcess;
}

declare class JavascriptCpuProfiler { 
	clone() : JavascriptCpuProfiler;
	static C(Other: UObject | any): JavascriptCpuProfiler;
}

declare class JavascriptProfile extends UObject { 
	static Load(ResourceName: string): JavascriptProfile;
	static Find(Outer: UObject, ResourceName: string): JavascriptProfile;
	static GetDefaultObject(): JavascriptProfile;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptProfile;
	static Stop(Profiler: JavascriptCpuProfiler,Title: string): JavascriptProfile;
	static Start(Title: string,bRecordSamples: boolean): JavascriptCpuProfiler;
	static SetSamplingInterval(Profiler: JavascriptCpuProfiler,us: number): void;
	static SetIdle(Profiler: JavascriptCpuProfiler,is_idle: boolean): void;
	GetTopDownRoot(): JavascriptProfileNode;
	GetSampleTimestamp(Index: number): number;
	GetSamplesCount(): number;
	GetSample(Index: number): JavascriptProfileNode;
	static C(Other: UObject | any): JavascriptProfile;
}

declare class JavascriptSemaphore extends UObject { 
	static Load(ResourceName: string): JavascriptSemaphore;
	static Find(Outer: UObject, ResourceName: string): JavascriptSemaphore;
	static GetDefaultObject(): JavascriptSemaphore;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptSemaphore;
	Unlock(): void;
	TryLock(NanosecondsToWait: number): boolean;
	Lock(): void;
	Dispose(): void;
	static Create(Name: string,bCreate: boolean,MaxLocks: number): JavascriptSemaphore;
	static C(Other: UObject | any): JavascriptSemaphore;
}

declare class JavascriptSettings extends UObject { 
	V8Flags: string;
	bEnableHotReload: boolean;
	static Load(ResourceName: string): JavascriptSettings;
	static Find(Outer: UObject, ResourceName: string): JavascriptSettings;
	static GetDefaultObject(): JavascriptSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptSettings;
	static C(Other: UObject | any): JavascriptSettings;
}

declare class JavascriptSharedMemoryRegion extends JavascriptMemoryObject { 
	static Load(ResourceName: string): JavascriptSharedMemoryRegion;
	static Find(Outer: UObject, ResourceName: string): JavascriptSharedMemoryRegion;
	static GetDefaultObject(): JavascriptSharedMemoryRegion;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptSharedMemoryRegion;
	Dispose(): void;
	static Create(Name: string,bCreate: boolean,bRead: boolean,bWrite: boolean,Size: number): JavascriptSharedMemoryRegion;
	static C(Other: UObject | any): JavascriptSharedMemoryRegion;
}

declare class JavascriptAutomatedTestInstance { 
	clone() : JavascriptAutomatedTestInstance;
	static C(Other: UObject | any): JavascriptAutomatedTestInstance;
	AddAnalyticsItem(InAnalyticsItem: string): void;
	AddError(InError: string): void;
	AddLogItem(InLogItem: string): void;
	AddWarning(InWarning: string): void;
	ClearExecutionInfo(): void;
	Destroy(): {Test: JavascriptAutomatedTestInstance};
	SetContinue(bInContinue: boolean): void;
	static AddAnalyticsItem(Test: JavascriptAutomatedTestInstance,InAnalyticsItem: string): void;
	static AddError(Test: JavascriptAutomatedTestInstance,InError: string): void;
	static AddLogItem(Test: JavascriptAutomatedTestInstance,InLogItem: string): void;
	static AddWarning(Test: JavascriptAutomatedTestInstance,InWarning: string): void;
	static ClearExecutionInfo(Test: JavascriptAutomatedTestInstance): void;
	static Destroy(Test?: JavascriptAutomatedTestInstance): {Test: JavascriptAutomatedTestInstance};
	static SetContinue(Test: JavascriptAutomatedTestInstance,bInContinue: boolean): void;
}

declare class JavascriptAutomatedTest { 
	Name: string;
	bComplexTask: boolean;
	TestFlags: number;
	RequiredDeviceNum: number;
	TestFunctionNames: string[];
	UFunction: JavascriptFunction;
	clone() : JavascriptAutomatedTest;
	static C(Other: UObject | any): JavascriptAutomatedTest;
	Create(): JavascriptAutomatedTestInstance;
	static Create(Test: JavascriptAutomatedTest): JavascriptAutomatedTestInstance;
}

declare class JavascriptTestLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): JavascriptTestLibrary;
	static Find(Outer: UObject, ResourceName: string): JavascriptTestLibrary;
	static GetDefaultObject(): JavascriptTestLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTestLibrary;
	static SetContinue(Test: JavascriptAutomatedTestInstance,bInContinue: boolean): void;
	static PushFrameCounter(): void;
	static PopFrameCounter(): void;
	static NewWorld(): World;
	static InitializeActorsForPlay(World: World,URL: URL): void;
	static DestroyWorld(World: World): void;
	static DestroyUObject(UObject: UObject): void;
	static Destroy(Test?: JavascriptAutomatedTestInstance): {Test: JavascriptAutomatedTestInstance};
	static Create(Test: JavascriptAutomatedTest): JavascriptAutomatedTestInstance;
	static ClearExecutionInfo(Test: JavascriptAutomatedTestInstance): void;
	static BeginPlay(World: World): void;
	static AddWarning(Test: JavascriptAutomatedTestInstance,InWarning: string): void;
	static AddLogItem(Test: JavascriptAutomatedTestInstance,InLogItem: string): void;
	static AddError(Test: JavascriptAutomatedTestInstance,InError: string): void;
	static AddAnalyticsItem(Test: JavascriptAutomatedTestInstance,InAnalyticsItem: string): void;
	static C(Other: UObject | any): JavascriptTestLibrary;
}

declare class DirectoryWatcherCallback__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): DirectoryWatcherCallback__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): DirectoryWatcherCallback__PythonCallable;
	static GetDefaultObject(): DirectoryWatcherCallback__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DirectoryWatcherCallback__PythonCallable;
	static C(Other: UObject | any): DirectoryWatcherCallback__PythonCallable;
}

declare class JavascriptComponent_JavascriptNameSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComponent_JavascriptNameSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComponent_JavascriptNameSignature__PythonCallable;
	static GetDefaultObject(): JavascriptComponent_JavascriptNameSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComponent_JavascriptNameSignature__PythonCallable;
	static C(Other: UObject | any): JavascriptComponent_JavascriptNameSignature__PythonCallable;
}

declare class JavascriptComponent_JavascriptNoParamSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComponent_JavascriptNoParamSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComponent_JavascriptNoParamSignature__PythonCallable;
	static GetDefaultObject(): JavascriptComponent_JavascriptNoParamSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComponent_JavascriptNoParamSignature__PythonCallable;
	static C(Other: UObject | any): JavascriptComponent_JavascriptNoParamSignature__PythonCallable;
}

declare class JavascriptComponent_JavascriptTickSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComponent_JavascriptTickSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComponent_JavascriptTickSignature__PythonCallable;
	static GetDefaultObject(): JavascriptComponent_JavascriptTickSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComponent_JavascriptTickSignature__PythonCallable;
	static C(Other: UObject | any): JavascriptComponent_JavascriptTickSignature__PythonCallable;
}

declare class JavascriptComboButton extends ContentWidget { 
	ComboButtonStyle: ComboButtonStyle;
	ButtonStyle: ButtonStyle;
	OnGetMenuContent: UnrealEngineDelegate<() => JavascriptSlateWidget>;
	OnMenuOpenChanged: UnrealEngineDelegate<(Value: boolean) => void>;
	OnComboBoxOpened: UnrealEngineDelegate<() => void>;
	bIsFocusable: boolean;
	bHasDownArrow: boolean;
	ForegroundColor: SlateColor;
	ButtonColorAndOpacity: SlateColor;
	ContentPadding: Margin;
	MenuPlacement: EMenuPlacement;
	HAlign: EHorizontalAlignment;
	VAlign: EVerticalAlignment;
	static Load(ResourceName: string): JavascriptComboButton;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButton;
	static GetDefaultObject(): JavascriptComboButton;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButton;
	SetIsOpen(InIsOpen: boolean,bFocusMenu: boolean): void;
	static C(Other: UObject | any): JavascriptComboButton;
}

declare class JavascriptSlateIcon { 
	StyleSetName: string;
	StyleName: string;
	SmallStyleName: string;
	clone() : JavascriptSlateIcon;
	static C(Other: UObject | any): JavascriptSlateIcon;
}

declare class JavascriptComboButtonContext extends UObject { 
	OnGetLabel: UnrealEngineDelegate<() => string>;
	OnGetTooltip: UnrealEngineDelegate<() => string>;
	OnGetIcon: UnrealEngineDelegate<() => JavascriptSlateIcon>;
	OnGetWidget: UnrealEngineDelegate<(EditingObject: UObject) => JavascriptSlateWidget>;
	OnCanExecute: UnrealEngineDelegate<() => boolean>;
	static Load(ResourceName: string): JavascriptComboButtonContext;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButtonContext;
	static GetDefaultObject(): JavascriptComboButtonContext;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButtonContext;
	UnmarkReferencedObject(): void;
	MarkReferencedObject(): void;
	static C(Other: UObject | any): JavascriptComboButtonContext;
}

declare class JavascriptTextProperty { 
	Key: string;
	Namespace: string;
	Value: string;
	TableId: string;
	clone() : JavascriptTextProperty;
	static C(Other: UObject | any): JavascriptTextProperty;
	static FromStringTable(InTableId: string,InKey: string): JavascriptTextProperty;
}

declare class JavascriptFTextBox extends Widget { 
	OnIsReadOnly: UnrealEngineDelegate<() => boolean>;
	OnIsValidText: UnrealEngineDelegate<(TextValue: string) => string>;
	OnGetDefaultValue: UnrealEngineDelegate<() => JavascriptTextProperty>;
	OnTextCommitted: UnrealEngineMulticastDelegate<(TextProperty: JavascriptTextProperty) => void>;
	WidgetStyle: EditableTextBoxStyle;
	WrapTextAt: number;
	AutoWrapText: boolean;
	static Load(ResourceName: string): JavascriptFTextBox;
	static Find(Outer: UObject, ResourceName: string): JavascriptFTextBox;
	static GetDefaultObject(): JavascriptFTextBox;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptFTextBox;
	SetText(JavascriptTextProperty?: JavascriptTextProperty): {JavascriptTextProperty: JavascriptTextProperty};
	static C(Other: UObject | any): JavascriptFTextBox;
}

declare class JavascriptGameViewport extends ContentWidget { 
	BackgroundColor: LinearColor;
	static Load(ResourceName: string): JavascriptGameViewport;
	static Find(Outer: UObject, ResourceName: string): JavascriptGameViewport;
	static GetDefaultObject(): JavascriptGameViewport;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptGameViewport;
	Spawn(ActorClass: UnrealEngineClass): Actor;
	SetViewRotation(Rotation: Rotator): void;
	SetViewLocation(Location: Vector): void;
	GetViewRotation(): Rotator;
	GetViewportWorld(): World;
	GetViewLocation(): Vector;
	static C(Other: UObject | any): JavascriptGameViewport;
}

declare class JavascriptIntSpinBox extends Widget { 
	Value: number;
	ValueDelegate: UnrealEngineDelegate<() => number>;
	WidgetStyle: SpinBoxStyle;
	Style: SlateWidgetStyleAsset;
	Delta: number;
	SliderExponent: number;
	Font: SlateFontInfo;
	Justification: ETextJustify;
	MinDesiredWidth: number;
	ClearKeyboardFocusOnCommit: boolean;
	SelectAllTextOnCommit: boolean;
	ForegroundColor: SlateColor;
	OnValueChanged: UnrealEngineMulticastDelegate<(InValue: number) => void>;
	OnValueCommitted: UnrealEngineMulticastDelegate<(InValue: number, CommitMethod: ETextCommit) => void>;
	OnBeginSliderMovement: UnrealEngineMulticastDelegate<() => void>;
	OnEndSliderMovement: UnrealEngineMulticastDelegate<(InValue: number) => void>;
	bOverride_MinValue: boolean;
	bOverride_MaxValue: boolean;
	bOverride_MinSliderValue: boolean;
	bOverride_MaxSliderValue: boolean;
	MinValue: number;
	MaxValue: number;
	MinSliderValue: number;
	MaxSliderValue: number;
	static Load(ResourceName: string): JavascriptIntSpinBox;
	static Find(Outer: UObject, ResourceName: string): JavascriptIntSpinBox;
	static GetDefaultObject(): JavascriptIntSpinBox;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptIntSpinBox;
	SetValue(NewValue: number): void;
	SetMinValue(NewValue: number): void;
	SetMinSliderValue(NewValue: number): void;
	SetMaxValue(NewValue: number): void;
	SetMaxSliderValue(NewValue: number): void;
	SetForegroundColor(InForegroundColor: SlateColor): void;
	GetValue(): number;
	GetMinValue(): number;
	GetMinSliderValue(): number;
	GetMaxValue(): number;
	GetMaxSliderValue(): number;
	ClearMinValue(): void;
	ClearMinSliderValue(): void;
	ClearMaxValue(): void;
	ClearMaxSliderValue(): void;
	static C(Other: UObject | any): JavascriptIntSpinBox;
}

declare class TableColumnHeaderStyle extends SlateWidgetStyle { 
	SortPrimaryAscendingImage: SlateBrush;
	SortPrimaryDescendingImage: SlateBrush;
	SortSecondaryAscendingImage: SlateBrush;
	SortSecondaryDescendingImage: SlateBrush;
	NormalBrush: SlateBrush;
	HoveredBrush: SlateBrush;
	MenuDropdownImage: SlateBrush;
	MenuDropdownNormalBorderBrush: SlateBrush;
	MenuDropdownHoveredBorderBrush: SlateBrush;
	clone() : TableColumnHeaderStyle;
	static C(Other: UObject | any): TableColumnHeaderStyle;
}

declare class SplitterStyle extends SlateWidgetStyle { 
	HandleNormalBrush: SlateBrush;
	HandleHighlightBrush: SlateBrush;
	clone() : SplitterStyle;
	static C(Other: UObject | any): SplitterStyle;
}

declare class HeaderRowStyle extends SlateWidgetStyle { 
	ColumnStyle: TableColumnHeaderStyle;
	LastColumnStyle: TableColumnHeaderStyle;
	ColumnSplitterStyle: SplitterStyle;
	SplitterHandleSize: number;
	BackgroundBrush: SlateBrush;
	ForegroundColor: SlateColor;
	HorizontalSeparatorBrush: SlateBrush;
	HorizontalSeparatorThickness: number;
	clone() : HeaderRowStyle;
	static C(Other: UObject | any): HeaderRowStyle;
}

declare class JavascriptColumn { 
	ID: string;
	Width: number;
	Widget: Widget;
	clone() : JavascriptColumn;
	static C(Other: UObject | any): JavascriptColumn;
}

declare class JavascriptTreeView extends ListViewBase { 
	OnGenerateRowEvent: UnrealEngineDelegate<(UObject: UObject, ID: string, Instance: JavascriptTreeView) => Widget>;
	OnExpansionChanged: UnrealEngineDelegate<(Item: UObject, bExpanded: boolean, Instance: JavascriptTreeView) => void>;
	OnContextMenuOpening: UnrealEngineDelegate<(Instance: JavascriptTreeView) => Widget>;
	OnGetChildren: UnrealEngineDelegate<(Item: UObject, Instance: JavascriptTreeView) => void>;
	JavascriptContext: JavascriptContext;
	Items: UObject[];
	HeaderRowStyle: HeaderRowStyle;
	TableRowStyle: TableRowStyle;
	ScrollBarStyle: ScrollBarStyle;
	SelectionMode: ESelectionMode;
	Children: UObject[];
	Columns: JavascriptColumn[];
	ColumnWidgets: Widget[];
	static Load(ResourceName: string): JavascriptTreeView;
	static Find(Outer: UObject, ResourceName: string): JavascriptTreeView;
	static GetDefaultObject(): JavascriptTreeView;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTreeView;
	SetSingleExpandedItem(InItem: UObject): void;
	SetSelection(SoleSelectedItem: UObject): void;
	SetItemSelection(MultiSelectedItems: UObject[],bIsSelected: boolean): void;
	SetItemExpansion(InItem: UObject,InShouldExpandItem: boolean): void;
	SetDoubleClickSelection(SelectedItem: UObject): void;
	RequestTreeRefresh(): void;
	RequestNavigateToItem(Item: UObject): void;
	OnSelectionChanged(UObject: UObject,Type: ESelectInfo): void;
	OnDoubleClick(UObject: UObject): void;
	IsItemExpanded(InItem: UObject): boolean;
	IsDoubleClickSelection(SelectedItem: UObject): boolean;
	GetSelectedItems(OutItems?: UObject[]): {OutItems: UObject[], $: boolean};
	GetDoubleClickedItems(OutItems?: UObject[]): {OutItems: UObject[]};
	ClearSelection(): void;
	ClearDoubleClickSelection(): void;
	static C(Other: UObject | any): JavascriptTreeView;
}

declare class JavascriptListView extends JavascriptTreeView { 
	ItemHeight: number;
	static Load(ResourceName: string): JavascriptListView;
	static Find(Outer: UObject, ResourceName: string): JavascriptListView;
	static GetDefaultObject(): JavascriptListView;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptListView;
	RequestListRefresh(): void;
	OnClick(UObject: UObject): void;
	static C(Other: UObject | any): JavascriptListView;
}

declare type EJavasrciptUserInterfaceActionType = 'None' | 'Button' | 'ToggleButton' | 'RadioButton' | 'Check' | 'CollapsedButton' | 'EJavasrciptUserInterfaceActionType_MAX';
declare var EJavasrciptUserInterfaceActionType : { None:'None',Button:'Button',ToggleButton:'ToggleButton',RadioButton:'RadioButton',Check:'Check',CollapsedButton:'CollapsedButton',EJavasrciptUserInterfaceActionType_MAX:'EJavasrciptUserInterfaceActionType_MAX', };
declare class JavascriptMenuContext extends UObject { 
	Description: string;
	Tooltip: string;
	Icon: JavascriptSlateIcon;
	ActionType: EJavasrciptUserInterfaceActionType;
	OnCanExecute: UnrealEngineDelegate<() => boolean>;
	OnExecute: UnrealEngineDelegate<() => void>;
	OnGetActionCheckState: UnrealEngineDelegate<() => ECheckBoxState>;
	static Load(ResourceName: string): JavascriptMenuContext;
	static Find(Outer: UObject, ResourceName: string): JavascriptMenuContext;
	static GetDefaultObject(): JavascriptMenuContext;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMenuContext;
	static C(Other: UObject | any): JavascriptMenuContext;
}

declare class JavascriptSlateTextRun { 
	clone() : JavascriptSlateTextRun;
	static C(Other: UObject | any): JavascriptSlateTextRun;
}

declare class JavascriptTextModel extends UObject { 
	static Load(ResourceName: string): JavascriptTextModel;
	static Find(Outer: UObject, ResourceName: string): JavascriptTextModel;
	static GetDefaultObject(): JavascriptTextModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTextModel;
	SetString(string: string): void;
	GetString(): string;
	CreateRun(MessageTextStyle: TextBlockStyle,BeginIndex: number,EndIndex: number): JavascriptSlateTextRun;
	static C(Other: UObject | any): JavascriptTextModel;
}

declare class JavascriptTextLayout { 
	clone() : JavascriptTextLayout;
	static C(Other: UObject | any): JavascriptTextLayout;
	AddLine(Model?: JavascriptTextModel,Runs?: JavascriptSlateTextRun[]): {TextLayout: JavascriptTextLayout};
	ClearLines(): {TextLayout: JavascriptTextLayout};
	GetAsText(): string;
	GetLineLength(): number;
	static AddLine(TextLayout?: JavascriptTextLayout,Model?: JavascriptTextModel,Runs?: JavascriptSlateTextRun[]): {TextLayout: JavascriptTextLayout};
	static ClearLines(TextLayout?: JavascriptTextLayout): {TextLayout: JavascriptTextLayout};
	static GetAsText(TextLayout: JavascriptTextLayout): string;
	static GetLineLength(TargetTextLayout: JavascriptTextLayout): number;
}

declare class JavascriptMultiLineEditableTextBox extends MultiLineEditableTextBox { 
	OnVScrollBarUserScrolled: UnrealEngineMulticastDelegate<(Offset: number) => void>;
	GetTextDelegate: UnrealEngineDelegate<(TextLayout: JavascriptTextLayout) => string>;
	SetTextDelegate: UnrealEngineDelegate<(InText: string, TextLayout: JavascriptTextLayout) => void>;
	bAlwaysShowScrollbars: boolean;
	static Load(ResourceName: string): JavascriptMultiLineEditableTextBox;
	static Find(Outer: UObject, ResourceName: string): JavascriptMultiLineEditableTextBox;
	static GetDefaultObject(): JavascriptMultiLineEditableTextBox;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMultiLineEditableTextBox;
	ScrollTo(Line: number,Offset: number): void;
	Refresh(): void;
	GoTo(Line: number,Offset: number): void;
	static C(Other: UObject | any): JavascriptMultiLineEditableTextBox;
}

declare class JavascriptRichTextBlockHyperlinkDecorator extends RichTextBlockDecorator { 
	HyperlinkId: string;
	OnClick: UnrealEngineMulticastDelegate<(Self: JavascriptRichTextBlockHyperlinkDecorator) => void>;
	static Load(ResourceName: string): JavascriptRichTextBlockHyperlinkDecorator;
	static Find(Outer: UObject, ResourceName: string): JavascriptRichTextBlockHyperlinkDecorator;
	static GetDefaultObject(): JavascriptRichTextBlockHyperlinkDecorator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptRichTextBlockHyperlinkDecorator;
	GetMetadata(Key: string): string;
	static C(Other: UObject | any): JavascriptRichTextBlockHyperlinkDecorator;
}

declare class JavascriptSearchBox extends Widget { 
	JavascriptContext: JavascriptContext;
	OnTextChanged: UnrealEngineMulticastDelegate<(Text: string) => void>;
	OnTextCommitted: UnrealEngineMulticastDelegate<(Text: string, CommitMethod: ETextCommit) => void>;
	Text: string;
	TextDelegate: UnrealEngineDelegate<() => string>;
	HintText: string;
	HintTextDelegate: UnrealEngineDelegate<() => string>;
	static Load(ResourceName: string): JavascriptSearchBox;
	static Find(Outer: UObject, ResourceName: string): JavascriptSearchBox;
	static GetDefaultObject(): JavascriptSearchBox;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptSearchBox;
	SetText(InText: string): void;
	SetHintText(InHintText: string): void;
	OnKeyDown(MyGeometry: Geometry,InKeyEvent: KeyEvent): EventReply;
	static C(Other: UObject | any): JavascriptSearchBox;
}

declare class JavascriptStyleSet { 
	StyleSetName: string;
	clone() : JavascriptStyleSet;
	static C(Other: UObject | any): JavascriptStyleSet;
	GetBrush(StyleName: string): SlateBrush;
	GetButtonStyle(StyleName: string): ButtonStyle;
	GetCheckBoxStyle(StyleName: string): CheckBoxStyle;
	GetColor(StyleName: string): LinearColor;
	GetComboBoxStyle(StyleName: string): ComboBoxStyle;
	GetComboButtonStyle(StyleName: string): ComboButtonStyle;
	GetEditableTextBoxStyle(StyleName: string): EditableTextBoxStyle;
	GetEditableTextStyle(StyleName: string): EditableTextStyle;
	GetFloat(StyleName: string): number;
	GetFontStyle(StyleName: string): SlateFontInfo;
	GetMargin(StyleName: string): Margin;
	GetProgressBarStyle(StyleName: string): ProgressBarStyle;
	GetSlateColor(StyleName: string): SlateColor;
	GetSound(StyleName: string): SlateSound;
	GetSpinBoxStyle(StyleName: string): SpinBoxStyle;
	GetTableRowStyle(StyleName: string): TableRowStyle;
	GetTextBlockStyle(StyleName: string): TextBlockStyle;
	GetVector(StyleName: string): Vector2D;
	static GetBrush(Handle: JavascriptStyleSet,StyleName: string): SlateBrush;
	static GetButtonStyle(Handle: JavascriptStyleSet,StyleName: string): ButtonStyle;
	static GetCheckBoxStyle(Handle: JavascriptStyleSet,StyleName: string): CheckBoxStyle;
	static GetColor(Handle: JavascriptStyleSet,StyleName: string): LinearColor;
	static GetComboBoxStyle(Handle: JavascriptStyleSet,StyleName: string): ComboBoxStyle;
	static GetComboButtonStyle(Handle: JavascriptStyleSet,StyleName: string): ComboButtonStyle;
	static GetEditableTextBoxStyle(Handle: JavascriptStyleSet,StyleName: string): EditableTextBoxStyle;
	static GetEditableTextStyle(Handle: JavascriptStyleSet,StyleName: string): EditableTextStyle;
	static GetFloat(Handle: JavascriptStyleSet,StyleName: string): number;
	static GetFontStyle(Handle: JavascriptStyleSet,StyleName: string): SlateFontInfo;
	static GetMargin(Handle: JavascriptStyleSet,StyleName: string): Margin;
	static GetProgressBarStyle(Handle: JavascriptStyleSet,StyleName: string): ProgressBarStyle;
	static GetSlateColor(Handle: JavascriptStyleSet,StyleName: string): SlateColor;
	static GetSound(Handle: JavascriptStyleSet,StyleName: string): SlateSound;
	static GetSpinBoxStyle(Handle: JavascriptStyleSet,StyleName: string): SpinBoxStyle;
	static GetTableRowStyle(Handle: JavascriptStyleSet,StyleName: string): TableRowStyle;
	static GetTextBlockStyle(Handle: JavascriptStyleSet,StyleName: string): TextBlockStyle;
	static GetVector(Handle: JavascriptStyleSet,StyleName: string): Vector2D;
}

declare class JavascriptStyleSetLibrary extends BlueprintFunctionLibrary { 
	SlateColor: SlateColor;
	SlateBrush: SlateBrush;
	ButtonStyle: ButtonStyle;
	TextBlockStyle: TextBlockStyle;
	EditableTextStyle: EditableTextStyle;
	EditableTextBoxStyle: EditableTextBoxStyle;
	CheckBoxStyle: CheckBoxStyle;
	ComboBoxStyle: ComboBoxStyle;
	ComboButtonStyle: ComboButtonStyle;
	ProgressBarStyle: ProgressBarStyle;
	SpinBoxStyle: SpinBoxStyle;
	TableRowStyle: TableRowStyle;
	static Load(ResourceName: string): JavascriptStyleSetLibrary;
	static Find(Outer: UObject, ResourceName: string): JavascriptStyleSetLibrary;
	static GetDefaultObject(): JavascriptStyleSetLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptStyleSetLibrary;
	static GetVector(Handle: JavascriptStyleSet,StyleName: string): Vector2D;
	static GetTextBlockStyle(Handle: JavascriptStyleSet,StyleName: string): TextBlockStyle;
	static GetTableRowStyle(Handle: JavascriptStyleSet,StyleName: string): TableRowStyle;
	static GetSpinBoxStyle(Handle: JavascriptStyleSet,StyleName: string): SpinBoxStyle;
	static GetSound(Handle: JavascriptStyleSet,StyleName: string): SlateSound;
	static GetSlateColor(Handle: JavascriptStyleSet,StyleName: string): SlateColor;
	static GetProgressBarStyle(Handle: JavascriptStyleSet,StyleName: string): ProgressBarStyle;
	static GetMargin(Handle: JavascriptStyleSet,StyleName: string): Margin;
	static GetFontStyle(Handle: JavascriptStyleSet,StyleName: string): SlateFontInfo;
	static GetFloat(Handle: JavascriptStyleSet,StyleName: string): number;
	static GetEditableTextStyle(Handle: JavascriptStyleSet,StyleName: string): EditableTextStyle;
	static GetEditableTextBoxStyle(Handle: JavascriptStyleSet,StyleName: string): EditableTextBoxStyle;
	static GetComboButtonStyle(Handle: JavascriptStyleSet,StyleName: string): ComboButtonStyle;
	static GetComboBoxStyle(Handle: JavascriptStyleSet,StyleName: string): ComboBoxStyle;
	static GetColor(Handle: JavascriptStyleSet,StyleName: string): LinearColor;
	static GetCheckBoxStyle(Handle: JavascriptStyleSet,StyleName: string): CheckBoxStyle;
	static GetButtonStyle(Handle: JavascriptStyleSet,StyleName: string): ButtonStyle;
	static GetBrush(Handle: JavascriptStyleSet,StyleName: string): SlateBrush;
	static C(Other: UObject | any): JavascriptStyleSetLibrary;
}

declare class JavascriptTextBlock extends TextBlock { 
	HighlightText: string;
	HighlightTextDelegate: UnrealEngineDelegate<() => string>;
	static Load(ResourceName: string): JavascriptTextBlock;
	static Find(Outer: UObject, ResourceName: string): JavascriptTextBlock;
	static GetDefaultObject(): JavascriptTextBlock;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTextBlock;
	SetHighlightText(InHighlightText: string): void;
	static C(Other: UObject | any): JavascriptTextBlock;
}

declare class JavascriptTileView extends TileView { 
	JavascriptContext: JavascriptContext;
	TileListItems: UObject[];
	static Load(ResourceName: string): JavascriptTileView;
	static Find(Outer: UObject, ResourceName: string): JavascriptTileView;
	static GetDefaultObject(): JavascriptTileView;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTileView;
	OnSelectionChanged(UObject: UObject,Type: ESelectInfo): void;
	OnDoubleClick(UObject: UObject): void;
	OnClick(UObject: UObject): void;
	static C(Other: UObject | any): JavascriptTileView;
}

declare class JavascriptToolbarButtonContext extends UObject { 
	OnGetLabel: UnrealEngineDelegate<() => string>;
	OnGetTooltip: UnrealEngineDelegate<() => string>;
	OnGetIcon: UnrealEngineDelegate<() => JavascriptSlateIcon>;
	OnExecuteAction: UnrealEngineDelegate<(EditingObject: UObject) => void>;
	OnCanExecuteAction: UnrealEngineDelegate<(EditingObject: UObject) => boolean>;
	OnIsActionChecked: UnrealEngineDelegate<(EditingObject: UObject) => boolean>;
	OnIsActionButtonVisible: UnrealEngineDelegate<(EditingObject: UObject) => boolean>;
	static Load(ResourceName: string): JavascriptToolbarButtonContext;
	static Find(Outer: UObject, ResourceName: string): JavascriptToolbarButtonContext;
	static GetDefaultObject(): JavascriptToolbarButtonContext;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptToolbarButtonContext;
	UnmarkReferencedObject(): void;
	MarkReferencedObject(): void;
	static C(Other: UObject | any): JavascriptToolbarButtonContext;
}

declare class JavascriptUMGBlueprintLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): JavascriptUMGBlueprintLibrary;
	static Find(Outer: UObject, ResourceName: string): JavascriptUMGBlueprintLibrary;
	static GetDefaultObject(): JavascriptUMGBlueprintLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptUMGBlueprintLibrary;
	static SlateColor_UseSubduedForeground(): SlateColor;
	static SlateColor_UseForeground(): SlateColor;
	static GetLineLength(TargetTextLayout: JavascriptTextLayout): number;
	static GetAsText(TextLayout: JavascriptTextLayout): string;
	static DrawSpaceSpline(Context?: PaintContext,InStart?: Vector2D,InStartDir?: Vector2D,InEnd?: Vector2D,InEndDir?: Vector2D,InThickness?: number,InTint?: LinearColor): {Context: PaintContext};
	static ClearLines(TextLayout?: JavascriptTextLayout): {TextLayout: JavascriptTextLayout};
	static AddLine(TextLayout?: JavascriptTextLayout,Model?: JavascriptTextModel,Runs?: JavascriptSlateTextRun[]): {TextLayout: JavascriptTextLayout};
	static C(Other: UObject | any): JavascriptUMGBlueprintLibrary;
}

declare class JavascriptSlateStyle { 
	clone() : JavascriptSlateStyle;
	static C(Other: UObject | any): JavascriptSlateStyle;
	AddBorderBrush(PropertyName: string,InImageName: string,InMargin: Margin,InColorAndOpacity: LinearColor,InImageType: ESlateBrushImageType): void;
	AddBoxBrush(PropertyName: string,InImageName: string,InMargin: Margin,InColorAndOpacity: LinearColor,InImageType: ESlateBrushImageType): void;
	AddButtonStyle(PropertyName: string,ButtonStyle: ButtonStyle): void;
	AddFontInfo(PropertyName: string,FontInfo: SlateFontInfo): void;
	AddImageBrush(PropertyName: string,InImageName: string,InImageSize: Vector2D,InTint: LinearColor,InTiling: ESlateBrushTileType,InImageType: ESlateBrushImageType): void;
	AddSound(PropertyName: string,Sound: SlateSound): void;
	Register(): void;
	RootToContentDir(RelativePath: string): string;
	RootToCoreContentDir(RelativePath: string): string;
	SetContentRoot(InContentRootDir: string): void;
	SetCoreContentRoot(InCoreContentRootDir: string): void;
	SetParentStyleName(InParentStyleName: string): void;
	Unregister(): void;
	static AddBorderBrush(StyleSet: JavascriptSlateStyle,PropertyName: string,InImageName: string,InMargin: Margin,InColorAndOpacity: LinearColor,InImageType: ESlateBrushImageType): void;
	static AddBoxBrush(StyleSet: JavascriptSlateStyle,PropertyName: string,InImageName: string,InMargin: Margin,InColorAndOpacity: LinearColor,InImageType: ESlateBrushImageType): void;
	static AddButtonStyle(StyleSet: JavascriptSlateStyle,PropertyName: string,ButtonStyle: ButtonStyle): void;
	static AddFontInfo(StyleSet: JavascriptSlateStyle,PropertyName: string,FontInfo: SlateFontInfo): void;
	static AddImageBrush(StyleSet: JavascriptSlateStyle,PropertyName: string,InImageName: string,InImageSize: Vector2D,InTint: LinearColor,InTiling: ESlateBrushTileType,InImageType: ESlateBrushImageType): void;
	static AddSound(StyleSet: JavascriptSlateStyle,PropertyName: string,Sound: SlateSound): void;
	static Register(StyleSet: JavascriptSlateStyle): void;
	static RootToContentDir(StyleSet: JavascriptSlateStyle,RelativePath: string): string;
	static RootToCoreContentDir(StyleSet: JavascriptSlateStyle,RelativePath: string): string;
	static SetContentRoot(StyleSet: JavascriptSlateStyle,InContentRootDir: string): void;
	static SetCoreContentRoot(StyleSet: JavascriptSlateStyle,InCoreContentRootDir: string): void;
	static SetParentStyleName(StyleSet: JavascriptSlateStyle,InParentStyleName: string): void;
	static Unregister(StyleSet: JavascriptSlateStyle): void;
	static CreateSlateStyle(InStyleSetName: string): JavascriptSlateStyle;
}

declare class JavascriptUMGLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): JavascriptUMGLibrary;
	static Find(Outer: UObject, ResourceName: string): JavascriptUMGLibrary;
	static GetDefaultObject(): JavascriptUMGLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptUMGLibrary;
	static Unregister(StyleSet: JavascriptSlateStyle): void;
	static TakeWidget(Widget: Widget): JavascriptSlateWidget;
	static ShowWindow(NewWindow: JavascriptSlateWidget): void;
	static SetParentStyleName(StyleSet: JavascriptSlateStyle,InParentStyleName: string): void;
	static SetCoreContentRoot(StyleSet: JavascriptSlateStyle,InCoreContentRootDir: string): void;
	static SetContentRoot(StyleSet: JavascriptSlateStyle,InContentRootDir: string): void;
	static SetContent(TargetWidget: NativeWidgetHost,SlateWidget: JavascriptSlateWidget): Widget;
	static RootToCoreContentDir(StyleSet: JavascriptSlateStyle,RelativePath: string): string;
	static RootToContentDir(StyleSet: JavascriptSlateStyle,RelativePath: string): string;
	static Register(StyleSet: JavascriptSlateStyle): void;
	static GetUIGeometry(Widget: Widget): Geometry;
	static GetRootWindow(): JavascriptSlateWidget;
	static GenerateDynamicImageResource(InDynamicBrushName: string): Vector2D;
	static CreateSlateStyle(InStyleSetName: string): JavascriptSlateStyle;
	static AddWindowAsNativeChild(NewWindow: JavascriptSlateWidget,RootWindow: JavascriptSlateWidget): void;
	static AddWindow(NewWindow: JavascriptSlateWidget,bShowImmediately: boolean): void;
	static AddSound(StyleSet: JavascriptSlateStyle,PropertyName: string,Sound: SlateSound): void;
	static AddImageBrush(StyleSet: JavascriptSlateStyle,PropertyName: string,InImageName: string,InImageSize: Vector2D,InTint: LinearColor,InTiling: ESlateBrushTileType,InImageType: ESlateBrushImageType): void;
	static AddFontInfo(StyleSet: JavascriptSlateStyle,PropertyName: string,FontInfo: SlateFontInfo): void;
	static AddButtonStyle(StyleSet: JavascriptSlateStyle,PropertyName: string,ButtonStyle: ButtonStyle): void;
	static AddBoxBrush(StyleSet: JavascriptSlateStyle,PropertyName: string,InImageName: string,InMargin: Margin,InColorAndOpacity: LinearColor,InImageType: ESlateBrushImageType): void;
	static AddBorderBrush(StyleSet: JavascriptSlateStyle,PropertyName: string,InImageName: string,InMargin: Margin,InColorAndOpacity: LinearColor,InImageType: ESlateBrushImageType): void;
	static C(Other: UObject | any): JavascriptUMGLibrary;
}

declare class JavascriptWidget extends UserWidget { 
	JavascriptContext: JavascriptContext;
	OnInputActionEvent: UnrealEngineMulticastDelegate<(ActionName: string) => void>;
	OnReleaseActionEvent: UnrealEngineMulticastDelegate<(ActionName: string) => void>;
	OnInputAxisEvent: UnrealEngineMulticastDelegate<(Axis: number, AxisName: string) => void>;
	ContentSlot: PanelSlot;
	static Load(ResourceName: string): JavascriptWidget;
	static Find(Outer: UObject, ResourceName: string): JavascriptWidget;
	static GetDefaultObject(): JavascriptWidget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptWidget;
	SetRootWidget(Widget: Widget): void;
	RemoveChild(): boolean;
	OnReleaseInputActionByName(ActionName: string): void;
	OnListenForInputAxis(AxisName: string,EventType: EInputEvent,bConsume: boolean): void;
	OnListenForInputAction(ActionName: string,EventType: EInputEvent,bConsume: boolean): void;
	OnInputAxisByName(Axis: number,ActionName: string): void;
	OnInputActionByName(ActionName: string): void;
	OnDestroy(bReleaseChildren: boolean): void;
	static HasValidCachedWidget(Widget: Widget): boolean;
	static CallSynchronizeProperties(WidgetOrSlot: Visual): void;
	AddChild(Content: Widget): PanelSlot;
	static C(Other: UObject | any): JavascriptWidget;
}

declare type EJavascriptWindowType = 'Normal' | 'Menu' | 'ToolTip' | 'Notification' | 'CursorDecorator' | 'EJavascriptWindowType_MAX';
declare var EJavascriptWindowType : { Normal:'Normal',Menu:'Menu',ToolTip:'ToolTip',Notification:'Notification',CursorDecorator:'CursorDecorator',EJavascriptWindowType_MAX:'EJavascriptWindowType_MAX', };
declare class WindowStyle extends SlateWidgetStyle { 
	MinimizeButtonStyle: ButtonStyle;
	MaximizeButtonStyle: ButtonStyle;
	RestoreButtonStyle: ButtonStyle;
	CloseButtonStyle: ButtonStyle;
	TitleTextStyle: TextBlockStyle;
	ActiveTitleBrush: SlateBrush;
	InactiveTitleBrush: SlateBrush;
	FlashTitleBrush: SlateBrush;
	BackgroundColor: SlateColor;
	OutlineBrush: SlateBrush;
	OutlineColor: SlateColor;
	BorderBrush: SlateBrush;
	BorderColor: SlateColor;
	BackgroundBrush: SlateBrush;
	ChildBackgroundBrush: SlateBrush;
	WindowCornerRadius: number;
	BorderPadding: Margin;
	clone() : WindowStyle;
	static C(Other: UObject | any): WindowStyle;
}

declare type EJavascriptAutoCenter = 'None' | 'PrimaryWorkArea' | 'PreferredWorkArea' | 'EJavascriptAutoCenter_MAX';
declare var EJavascriptAutoCenter : { None:'None',PrimaryWorkArea:'PrimaryWorkArea',PreferredWorkArea:'PreferredWorkArea',EJavascriptAutoCenter_MAX:'EJavascriptAutoCenter_MAX', };
declare type EJavascriptWindowTransparency = 'None' | 'PerWindow' | 'EJavascriptWindowTransparency_MAX';
declare var EJavascriptWindowTransparency : { None:'None',PerWindow:'PerWindow',EJavascriptWindowTransparency_MAX:'EJavascriptWindowTransparency_MAX', };
declare type EJavascriptSizingRule = 'FixedSize' | 'Autosized' | 'UserSized' | 'EJavascriptSizingRule_MAX';
declare var EJavascriptSizingRule : { FixedSize:'FixedSize',Autosized:'Autosized',UserSized:'UserSized',EJavascriptSizingRule_MAX:'EJavascriptSizingRule_MAX', };
declare type EJavascriptWindowActivationPolicy = 'Never' | 'Always' | 'FirstShown' | 'EJavascriptWindowActivationPolicy_MAX';
declare var EJavascriptWindowActivationPolicy : { Never:'Never',Always:'Always',FirstShown:'FirstShown',EJavascriptWindowActivationPolicy_MAX:'EJavascriptWindowActivationPolicy_MAX', };
declare class JavascriptWindow extends ContentWidget { 
	Type: EJavascriptWindowType;
	Style: WindowStyle;
	Title: string;
	bDragAnywhere: boolean;
	AutoCenter: EJavascriptAutoCenter;
	ScreenPosition: Vector2D;
	ClientSize: Vector2D;
	SupportsTransparency: EJavascriptWindowTransparency;
	InitialOpacity: number;
	IsInitiallyMaximized: boolean;
	SizingRule: EJavascriptSizingRule;
	IsPopupWindow: boolean;
	FocusWhenFirstShown: boolean;
	ActivateWhenFirstShown: boolean;
	UseOSWindowBorder: boolean;
	HasCloseButton: boolean;
	SupportsMaximize: boolean;
	SupportsMinimize: boolean;
	CreateTitleBar: boolean;
	SaneWindowPlacement: boolean;
	LayoutBorder: Margin;
	UserResizeBorder: Margin;
	OnWindowClosed: UnrealEngineDelegate<() => void>;
	OnWindowDeactivated: UnrealEngineDelegate<() => void>;
	IsTopmostWindow: boolean;
	AdjustInitialSizeAndPositionForDPIScale: boolean;
	ActivationPolicy: EJavascriptWindowActivationPolicy;
	static Load(ResourceName: string): JavascriptWindow;
	static Find(Outer: UObject, ResourceName: string): JavascriptWindow;
	static GetDefaultObject(): JavascriptWindow;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptWindow;
	ShowWindow(): void;
	SetOpacity(InOpacity: number): void;
	Resize(NewSize: Vector2D): void;
	ReshapeWindow(NewPosition: Vector2D,NewSize: Vector2D): void;
	RequestDestroyWindow(): void;
	MoveWindowTo(NewPosition: Vector2D): void;
	HideWindow(): void;
	FlashWindow(): void;
	EnableWindow(bEnable: boolean): void;
	DestroyWindowImmediately(): void;
	BringToFront(): void;
	static C(Other: UObject | any): JavascriptWindow;
	OpenDirectoryDialog(DialogTitle: string,DefaultPath: string,OutFolderName?: string): {OutFolderName: string, $: boolean};
	OpenFileDialog(DialogTitle: string,DefaultPath: string,DefaultFile: string,FileTypes: string,Flags: number,OutFilenames?: string[]): {OutFilenames: string[], $: boolean};
	SaveFileDialog(DialogTitle: string,DefaultPath: string,DefaultFile: string,FileTypes: string,Flags: number,OutFilenames?: string[]): {OutFilenames: string[], $: boolean};
	static OpenDirectoryDialog(WindowHandle: JavascriptWindow,DialogTitle: string,DefaultPath: string,OutFolderName?: string): {OutFolderName: string, $: boolean};
	static OpenFileDialog(WindowHandle: JavascriptWindow,DialogTitle: string,DefaultPath: string,DefaultFile: string,FileTypes: string,Flags: number,OutFilenames?: string[]): {OutFilenames: string[], $: boolean};
	static SaveFileDialog(WindowHandle: JavascriptWindow,DialogTitle: string,DefaultPath: string,DefaultFile: string,FileTypes: string,Flags: number,OutFilenames?: string[]): {OutFilenames: string[], $: boolean};
}

declare class JavascriptHyperlinkSignature__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptHyperlinkSignature__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptHyperlinkSignature__PythonCallable;
	static GetDefaultObject(): JavascriptHyperlinkSignature__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptHyperlinkSignature__PythonCallable;
	static C(Other: UObject | any): JavascriptHyperlinkSignature__PythonCallable;
}

declare class OnInputActionEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnInputActionEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnInputActionEvent__PythonCallable;
	static GetDefaultObject(): OnInputActionEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnInputActionEvent__PythonCallable;
	static C(Other: UObject | any): OnInputActionEvent__PythonCallable;
}

declare class OnInputAxisEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnInputAxisEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnInputAxisEvent__PythonCallable;
	static GetDefaultObject(): OnInputAxisEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnInputAxisEvent__PythonCallable;
	static C(Other: UObject | any): OnInputAxisEvent__PythonCallable;
}

declare class JavascriptWindow_OnWindowDeactivated__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptWindow_OnWindowDeactivated__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptWindow_OnWindowDeactivated__PythonCallable;
	static GetDefaultObject(): JavascriptWindow_OnWindowDeactivated__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptWindow_OnWindowDeactivated__PythonCallable;
	static C(Other: UObject | any): JavascriptWindow_OnWindowDeactivated__PythonCallable;
}

declare class JavascriptWindow_OnWindowWidgetClosed__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptWindow_OnWindowWidgetClosed__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptWindow_OnWindowWidgetClosed__PythonCallable;
	static GetDefaultObject(): JavascriptWindow_OnWindowWidgetClosed__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptWindow_OnWindowWidgetClosed__PythonCallable;
	static C(Other: UObject | any): JavascriptWindow_OnWindowWidgetClosed__PythonCallable;
}

declare class JavascriptToolbarButtonContext_BoolDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptToolbarButtonContext_BoolDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptToolbarButtonContext_BoolDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptToolbarButtonContext_BoolDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptToolbarButtonContext_BoolDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptToolbarButtonContext_BoolDelegate__PythonCallable;
}

declare class JavascriptToolbarButtonContext_IconDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptToolbarButtonContext_IconDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptToolbarButtonContext_IconDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptToolbarButtonContext_IconDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptToolbarButtonContext_IconDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptToolbarButtonContext_IconDelegate__PythonCallable;
}

declare class JavascriptToolbarButtonContext_JavascriptCanExecuteActionWithEditingObject__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptToolbarButtonContext_JavascriptCanExecuteActionWithEditingObject__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptToolbarButtonContext_JavascriptCanExecuteActionWithEditingObject__PythonCallable;
	static GetDefaultObject(): JavascriptToolbarButtonContext_JavascriptCanExecuteActionWithEditingObject__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptToolbarButtonContext_JavascriptCanExecuteActionWithEditingObject__PythonCallable;
	static C(Other: UObject | any): JavascriptToolbarButtonContext_JavascriptCanExecuteActionWithEditingObject__PythonCallable;
}

declare class JavascriptToolbarButtonContext_JavascriptExecuteActionWithEditingObject__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptToolbarButtonContext_JavascriptExecuteActionWithEditingObject__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptToolbarButtonContext_JavascriptExecuteActionWithEditingObject__PythonCallable;
	static GetDefaultObject(): JavascriptToolbarButtonContext_JavascriptExecuteActionWithEditingObject__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptToolbarButtonContext_JavascriptExecuteActionWithEditingObject__PythonCallable;
	static C(Other: UObject | any): JavascriptToolbarButtonContext_JavascriptExecuteActionWithEditingObject__PythonCallable;
}

declare class JavascriptToolbarButtonContext_TextDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptToolbarButtonContext_TextDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptToolbarButtonContext_TextDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptToolbarButtonContext_TextDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptToolbarButtonContext_TextDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptToolbarButtonContext_TextDelegate__PythonCallable;
}

declare class JavascriptSearchBox_OnEditableTextChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptSearchBox_OnEditableTextChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptSearchBox_OnEditableTextChangedEvent__PythonCallable;
	static GetDefaultObject(): JavascriptSearchBox_OnEditableTextChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptSearchBox_OnEditableTextChangedEvent__PythonCallable;
	static C(Other: UObject | any): JavascriptSearchBox_OnEditableTextChangedEvent__PythonCallable;
}

declare class JavascriptSearchBox_OnEditableTextCommittedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptSearchBox_OnEditableTextCommittedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptSearchBox_OnEditableTextCommittedEvent__PythonCallable;
	static GetDefaultObject(): JavascriptSearchBox_OnEditableTextCommittedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptSearchBox_OnEditableTextCommittedEvent__PythonCallable;
	static C(Other: UObject | any): JavascriptSearchBox_OnEditableTextCommittedEvent__PythonCallable;
}

declare class JavascriptMultiLineEditableTextBox_GetText__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptMultiLineEditableTextBox_GetText__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptMultiLineEditableTextBox_GetText__PythonCallable;
	static GetDefaultObject(): JavascriptMultiLineEditableTextBox_GetText__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMultiLineEditableTextBox_GetText__PythonCallable;
	static C(Other: UObject | any): JavascriptMultiLineEditableTextBox_GetText__PythonCallable;
}

declare class JavascriptMultiLineEditableTextBox_OnVScrollBarUserScrolled__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptMultiLineEditableTextBox_OnVScrollBarUserScrolled__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptMultiLineEditableTextBox_OnVScrollBarUserScrolled__PythonCallable;
	static GetDefaultObject(): JavascriptMultiLineEditableTextBox_OnVScrollBarUserScrolled__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMultiLineEditableTextBox_OnVScrollBarUserScrolled__PythonCallable;
	static C(Other: UObject | any): JavascriptMultiLineEditableTextBox_OnVScrollBarUserScrolled__PythonCallable;
}

declare class JavascriptMultiLineEditableTextBox_SetText__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptMultiLineEditableTextBox_SetText__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptMultiLineEditableTextBox_SetText__PythonCallable;
	static GetDefaultObject(): JavascriptMultiLineEditableTextBox_SetText__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMultiLineEditableTextBox_SetText__PythonCallable;
	static C(Other: UObject | any): JavascriptMultiLineEditableTextBox_SetText__PythonCallable;
}

declare class JavascriptMenuContext_ActionCheckStateDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptMenuContext_ActionCheckStateDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptMenuContext_ActionCheckStateDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptMenuContext_ActionCheckStateDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMenuContext_ActionCheckStateDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptMenuContext_ActionCheckStateDelegate__PythonCallable;
}

declare class JavascriptMenuContext_BoolDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptMenuContext_BoolDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptMenuContext_BoolDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptMenuContext_BoolDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMenuContext_BoolDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptMenuContext_BoolDelegate__PythonCallable;
}

declare class JavascriptMenuContext_ExecuteAction__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptMenuContext_ExecuteAction__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptMenuContext_ExecuteAction__PythonCallable;
	static GetDefaultObject(): JavascriptMenuContext_ExecuteAction__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptMenuContext_ExecuteAction__PythonCallable;
	static C(Other: UObject | any): JavascriptMenuContext_ExecuteAction__PythonCallable;
}

declare class JavascriptTreeView_OnContextMenuOpening__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptTreeView_OnContextMenuOpening__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptTreeView_OnContextMenuOpening__PythonCallable;
	static GetDefaultObject(): JavascriptTreeView_OnContextMenuOpening__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTreeView_OnContextMenuOpening__PythonCallable;
	static C(Other: UObject | any): JavascriptTreeView_OnContextMenuOpening__PythonCallable;
}

declare class JavascriptTreeView_OnExpansionChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptTreeView_OnExpansionChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptTreeView_OnExpansionChanged__PythonCallable;
	static GetDefaultObject(): JavascriptTreeView_OnExpansionChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTreeView_OnExpansionChanged__PythonCallable;
	static C(Other: UObject | any): JavascriptTreeView_OnExpansionChanged__PythonCallable;
}

declare class JavascriptTreeView_OnGenerateRow__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptTreeView_OnGenerateRow__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptTreeView_OnGenerateRow__PythonCallable;
	static GetDefaultObject(): JavascriptTreeView_OnGenerateRow__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTreeView_OnGenerateRow__PythonCallable;
	static C(Other: UObject | any): JavascriptTreeView_OnGenerateRow__PythonCallable;
}

declare class JavascriptTreeView_OnGetChildrenUObject__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptTreeView_OnGetChildrenUObject__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptTreeView_OnGetChildrenUObject__PythonCallable;
	static GetDefaultObject(): JavascriptTreeView_OnGetChildrenUObject__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptTreeView_OnGetChildrenUObject__PythonCallable;
	static C(Other: UObject | any): JavascriptTreeView_OnGetChildrenUObject__PythonCallable;
}

declare class JavascriptIntSpinBox_OnSpinBoxBeginSliderMovement__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptIntSpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptIntSpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
	static GetDefaultObject(): JavascriptIntSpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptIntSpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
	static C(Other: UObject | any): JavascriptIntSpinBox_OnSpinBoxBeginSliderMovement__PythonCallable;
}

declare class JavascriptIntSpinBox_OnSpinBoxValueChangedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptIntSpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptIntSpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
	static GetDefaultObject(): JavascriptIntSpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptIntSpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
	static C(Other: UObject | any): JavascriptIntSpinBox_OnSpinBoxValueChangedEvent__PythonCallable;
}

declare class JavascriptIntSpinBox_OnSpinBoxValueCommittedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptIntSpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptIntSpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
	static GetDefaultObject(): JavascriptIntSpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptIntSpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
	static C(Other: UObject | any): JavascriptIntSpinBox_OnSpinBoxValueCommittedEvent__PythonCallable;
}

declare class JavascriptFTextBox_OnEditableTextBoxCommittedEvent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptFTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptFTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
	static GetDefaultObject(): JavascriptFTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptFTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
	static C(Other: UObject | any): JavascriptFTextBox_OnEditableTextBoxCommittedEvent__PythonCallable;
}

declare class JavascriptFTextBox_OnGetDefaultValue__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptFTextBox_OnGetDefaultValue__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptFTextBox_OnGetDefaultValue__PythonCallable;
	static GetDefaultObject(): JavascriptFTextBox_OnGetDefaultValue__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptFTextBox_OnGetDefaultValue__PythonCallable;
	static C(Other: UObject | any): JavascriptFTextBox_OnGetDefaultValue__PythonCallable;
}

declare class JavascriptFTextBox_OnIsReadOnly__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptFTextBox_OnIsReadOnly__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptFTextBox_OnIsReadOnly__PythonCallable;
	static GetDefaultObject(): JavascriptFTextBox_OnIsReadOnly__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptFTextBox_OnIsReadOnly__PythonCallable;
	static C(Other: UObject | any): JavascriptFTextBox_OnIsReadOnly__PythonCallable;
}

declare class JavascriptFTextBox_OnIsValidText__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptFTextBox_OnIsValidText__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptFTextBox_OnIsValidText__PythonCallable;
	static GetDefaultObject(): JavascriptFTextBox_OnIsValidText__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptFTextBox_OnIsValidText__PythonCallable;
	static C(Other: UObject | any): JavascriptFTextBox_OnIsValidText__PythonCallable;
}

declare class JavascriptComboButtonContext_BoolDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComboButtonContext_BoolDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButtonContext_BoolDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptComboButtonContext_BoolDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButtonContext_BoolDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptComboButtonContext_BoolDelegate__PythonCallable;
}

declare class JavascriptComboButtonContext_IconDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComboButtonContext_IconDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButtonContext_IconDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptComboButtonContext_IconDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButtonContext_IconDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptComboButtonContext_IconDelegate__PythonCallable;
}

declare class JavascriptComboButtonContext_JavascriptGetWidgetWithEditingObject__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComboButtonContext_JavascriptGetWidgetWithEditingObject__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButtonContext_JavascriptGetWidgetWithEditingObject__PythonCallable;
	static GetDefaultObject(): JavascriptComboButtonContext_JavascriptGetWidgetWithEditingObject__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButtonContext_JavascriptGetWidgetWithEditingObject__PythonCallable;
	static C(Other: UObject | any): JavascriptComboButtonContext_JavascriptGetWidgetWithEditingObject__PythonCallable;
}

declare class JavascriptComboButtonContext_TextDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComboButtonContext_TextDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButtonContext_TextDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptComboButtonContext_TextDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButtonContext_TextDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptComboButtonContext_TextDelegate__PythonCallable;
}

declare class JavascriptComboButton_OnComboBoxOpened__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComboButton_OnComboBoxOpened__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButton_OnComboBoxOpened__PythonCallable;
	static GetDefaultObject(): JavascriptComboButton_OnComboBoxOpened__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButton_OnComboBoxOpened__PythonCallable;
	static C(Other: UObject | any): JavascriptComboButton_OnComboBoxOpened__PythonCallable;
}

declare class JavascriptComboButton_OnGetContent__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComboButton_OnGetContent__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButton_OnGetContent__PythonCallable;
	static GetDefaultObject(): JavascriptComboButton_OnGetContent__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButton_OnGetContent__PythonCallable;
	static C(Other: UObject | any): JavascriptComboButton_OnGetContent__PythonCallable;
}

declare class JavascriptComboButton_OnIsOpenChanged__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptComboButton_OnIsOpenChanged__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptComboButton_OnIsOpenChanged__PythonCallable;
	static GetDefaultObject(): JavascriptComboButton_OnIsOpenChanged__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptComboButton_OnIsOpenChanged__PythonCallable;
	static C(Other: UObject | any): JavascriptComboButton_OnIsOpenChanged__PythonCallable;
}

declare type EJavascriptHttpRequestStatus = 'NotStarted' | 'Processing' | 'Failed' | 'Succeeded' | 'EJavascriptHttpRequestStatus_MAX';
declare var EJavascriptHttpRequestStatus : { NotStarted:'NotStarted',Processing:'Processing',Failed:'Failed',Succeeded:'Succeeded',EJavascriptHttpRequestStatus_MAX:'EJavascriptHttpRequestStatus_MAX', };
declare class JavascriptHttpRequest extends UObject { 
	OnComplete: UnrealEngineDelegate<(successful: boolean) => void>;
	OnProgress: UnrealEngineDelegate<(sent: number, recv: number) => void>;
	static Load(ResourceName: string): JavascriptHttpRequest;
	static Find(Outer: UObject, ResourceName: string): JavascriptHttpRequest;
	static GetDefaultObject(): JavascriptHttpRequest;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptHttpRequest;
	SetVerb(Verb: string): void;
	SetURL(URL: string): void;
	SetHeader(HeaderName: string,HeaderValue: string): void;
	SetContentWithFiles(FilePaths: string[],Boundary: string,Content: string): void;
	SetContentFromMemory(): void;
	SetContentAsString(ContentString: string): void;
	ProcessRequest(): boolean;
	GetVerb(): string;
	GetStatus(): EJavascriptHttpRequestStatus;
	GetResponseCode(): number;
	GetElapsedTime(): number;
	GetContentToMemory(): void;
	GetContentLength(): number;
	GetContentAsString(): string;
	CancelRequest(): void;
	static C(Other: UObject | any): JavascriptHttpRequest;
}

declare class JavascriptHttpRequest_JavascriptHttpRequestCompleteDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptHttpRequest_JavascriptHttpRequestCompleteDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptHttpRequest_JavascriptHttpRequestCompleteDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptHttpRequest_JavascriptHttpRequestCompleteDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptHttpRequest_JavascriptHttpRequestCompleteDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptHttpRequest_JavascriptHttpRequestCompleteDelegate__PythonCallable;
}

declare class JavascriptHttpRequest_JavascriptHttpRequestProgressDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptHttpRequest_JavascriptHttpRequestProgressDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptHttpRequest_JavascriptHttpRequestProgressDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptHttpRequest_JavascriptHttpRequestProgressDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptHttpRequest_JavascriptHttpRequestProgressDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptHttpRequest_JavascriptHttpRequestProgressDelegate__PythonCallable;
}

declare class JavascriptWebSocket extends UObject { 
	OnReceived: UnrealEngineMulticastDelegate<() => void>;
	OnConnected: UnrealEngineMulticastDelegate<() => void>;
	OnError: UnrealEngineMulticastDelegate<() => void>;
	static Load(ResourceName: string): JavascriptWebSocket;
	static Find(Outer: UObject, ResourceName: string): JavascriptWebSocket;
	static GetDefaultObject(): JavascriptWebSocket;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptWebSocket;
	Tick(): void;
	SendMemory(NumBytes: number): void;
	RemoteEndPoint(bAppendPort: boolean): string;
	LocalEndPoint(bAppendPort: boolean): string;
	GetReceivedBytes(): number;
	Flush(): void;
	Dispose(): void;
	CopyBuffer(): void;
	static Connect(Endpoint: string): JavascriptWebSocket;
	static C(Other: UObject | any): JavascriptWebSocket;
}

declare class JavascriptWebSocketServer extends UObject { 
	OnConnected: UnrealEngineMulticastDelegate<(WebSocket: JavascriptWebSocket) => void>;
	Connections: JavascriptWebSocket[];
	static Load(ResourceName: string): JavascriptWebSocketServer;
	static Find(Outer: UObject, ResourceName: string): JavascriptWebSocketServer;
	static GetDefaultObject(): JavascriptWebSocketServer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptWebSocketServer;
	Tick(): void;
	Info(): string;
	Dispose(): void;
	static Create(Port: number): JavascriptWebSocketServer;
	static C(Other: UObject | any): JavascriptWebSocketServer;
}

declare class JavascriptWebSocketServer_OnWebSocketServerDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptWebSocketServer_OnWebSocketServerDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptWebSocketServer_OnWebSocketServerDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptWebSocketServer_OnWebSocketServerDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptWebSocketServer_OnWebSocketServerDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptWebSocketServer_OnWebSocketServerDelegate__PythonCallable;
}

declare class JavascriptWebSocket_OnWebSocketDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): JavascriptWebSocket_OnWebSocketDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): JavascriptWebSocket_OnWebSocketDelegate__PythonCallable;
	static GetDefaultObject(): JavascriptWebSocket_OnWebSocketDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): JavascriptWebSocket_OnWebSocketDelegate__PythonCallable;
	static C(Other: UObject | any): JavascriptWebSocket_OnWebSocketDelegate__PythonCallable;
}

declare class DefaultContextSetting { 
	InputMappingContext: InputMappingContext;
	Priority: number;
	clone() : DefaultContextSetting;
	static C(Other: UObject | any): DefaultContextSetting;
}

declare class EnhancedInputEditorProjectSettings extends DeveloperSettings { 
	DefaultEditorInputClass: Class;
	DefaultMappingContexts: DefaultContextSetting[];
	static Load(ResourceName: string): EnhancedInputEditorProjectSettings;
	static Find(Outer: UObject, ResourceName: string): EnhancedInputEditorProjectSettings;
	static GetDefaultObject(): EnhancedInputEditorProjectSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnhancedInputEditorProjectSettings;
	static C(Other: UObject | any): EnhancedInputEditorProjectSettings;
}

declare class EnhancedInputEditorSettings extends DeveloperSettingsBackedByCVars { 
	bLogAllInput: boolean;
	bAutomaticallyStartConsumingInput: boolean;
	static Load(ResourceName: string): EnhancedInputEditorSettings;
	static Find(Outer: UObject, ResourceName: string): EnhancedInputEditorSettings;
	static GetDefaultObject(): EnhancedInputEditorSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnhancedInputEditorSettings;
	static C(Other: UObject | any): EnhancedInputEditorSettings;
}

declare class EnhancedInputEditorSubsystem extends EditorSubsystem { 
	PlayerInput: EnhancedPlayerInput;
	CurrentInputStack: InputComponent[];
	static Load(ResourceName: string): EnhancedInputEditorSubsystem;
	static Find(Outer: UObject, ResourceName: string): EnhancedInputEditorSubsystem;
	static GetDefaultObject(): EnhancedInputEditorSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnhancedInputEditorSubsystem;
	StopConsumingInput(): void;
	StartConsumingInput(): void;
	PushInputComponent(InInputComponent: InputComponent): void;
	PopInputComponent(InInputComponent: InputComponent): boolean;
	IsConsumingInput(): boolean;
	static C(Other: UObject | any): EnhancedInputEditorSubsystem;
}

declare class InputMappingContext_Factory extends Factory { 
	static Load(ResourceName: string): InputMappingContext_Factory;
	static Find(Outer: UObject, ResourceName: string): InputMappingContext_Factory;
	static GetDefaultObject(): InputMappingContext_Factory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputMappingContext_Factory;
	static C(Other: UObject | any): InputMappingContext_Factory;
}

declare class InputAction_Factory extends Factory { 
	static Load(ResourceName: string): InputAction_Factory;
	static Find(Outer: UObject, ResourceName: string): InputAction_Factory;
	static GetDefaultObject(): InputAction_Factory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputAction_Factory;
	static C(Other: UObject | any): InputAction_Factory;
}

declare class PlayerMappableInputConfig_Factory extends Factory { 
	static Load(ResourceName: string): PlayerMappableInputConfig_Factory;
	static Find(Outer: UObject, ResourceName: string): PlayerMappableInputConfig_Factory;
	static GetDefaultObject(): PlayerMappableInputConfig_Factory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlayerMappableInputConfig_Factory;
	static C(Other: UObject | any): PlayerMappableInputConfig_Factory;
}

declare class InputBindingTarget extends UObject { 
	static Load(ResourceName: string): InputBindingTarget;
	static Find(Outer: UObject, ResourceName: string): InputBindingTarget;
	static GetDefaultObject(): InputBindingTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputBindingTarget;
	static C(Other: UObject | any): InputBindingTarget;
}

declare class BindingTargets { 
	Started: InputBindingTarget;
	Ongoing: InputBindingTarget;
	Canceled: InputBindingTarget;
	Completed: InputBindingTarget;
	Triggered: InputBindingTarget;
	clone() : BindingTargets;
	static C(Other: UObject | any): BindingTargets;
}

declare class ControllablePlayer extends UObject { 
	Player: PlayerController;
	BindingTargets: Map<string, BindingTargets>;
	InputContext: Map<string, InputMappingContext>;
	InputAction: Map<string, InputAction>;
	static Load(ResourceName: string): ControllablePlayer;
	static Find(Outer: UObject, ResourceName: string): ControllablePlayer;
	static GetDefaultObject(): ControllablePlayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ControllablePlayer;
	static C(Other: UObject | any): ControllablePlayer;
}

declare class PropertyTemplateObject extends UObject { 
	CapturedByteProperty: number;
	CapturedUInt16Property: number;
	CapturedUInt32Property: number;
	CapturedUInt64Property: number;
	CapturedInt8Property: number;
	CapturedInt16Property: number;
	CapturedIntProperty: number;
	CapturedInt64Property: number;
	CapturedFloatProperty: number;
	CapturedDoubleProperty: number;
	bCapturedBoolProperty: boolean;
	CapturedObjectProperty: UObject;
	CapturedSoftObjectProperty: UObject;
	CapturedInterfaceProperty: Interface;
	CapturedNameProperty: string;
	CapturedStrProperty: string;
	CapturedTextProperty: string;
	CapturedVectorProperty: Vector;
	static Load(ResourceName: string): PropertyTemplateObject;
	static Find(Outer: UObject, ResourceName: string): PropertyTemplateObject;
	static GetDefaultObject(): PropertyTemplateObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PropertyTemplateObject;
	static C(Other: UObject | any): PropertyTemplateObject;
}

declare class VariantManagerBlueprintLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): VariantManagerBlueprintLibrary;
	static Find(Outer: UObject, ResourceName: string): VariantManagerBlueprintLibrary;
	static GetDefaultObject(): VariantManagerBlueprintLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VariantManagerBlueprintLibrary;
	static SetValueVector4(Property: PropertyValue,InValue: Vector4): void;
	static SetValueVector2D(Property: PropertyValue,InValue: Vector2D): void;
	static SetValueVector(Property: PropertyValue,InValue: Vector): void;
	static SetValueString(Property: PropertyValue,InValue: string): void;
	static SetValueRotator(Property: PropertyValue,InValue: Rotator): void;
	static SetValueQuat(Property: PropertyValue,InValue: Quat): void;
	static SetValueObject(Property: PropertyValue,InValue: UObject): void;
	static SetValueLinearColor(Property: PropertyValue,InValue: LinearColor): void;
	static SetValueIntPoint(Property: PropertyValue,InValue: IntPoint): void;
	static SetValueInt(Property: PropertyValue,InValue: number): void;
	static SetValueFloat(Property: PropertyValue,InValue: number): void;
	static SetValueColor(Property: PropertyValue,InValue: Color): void;
	static SetValueBool(Property: PropertyValue,InValue: boolean): void;
	static SetDependency(Variant: Variant,Index: number,Dependency?: VariantDependency): {Dependency: VariantDependency};
	static RemoveVariantSetByName(LevelVariantSets: LevelVariantSets,VariantSetName: string): void;
	static RemoveVariantSet(LevelVariantSets: LevelVariantSets,VariantSet: VariantSet): void;
	static RemoveVariantByName(VariantSet: VariantSet,VariantName: string): void;
	static RemoveVariant(VariantSet: VariantSet,Variant: Variant): void;
	static RemoveCapturedPropertyByName(Variant: Variant,Actor: Actor,PropertyPath: string): void;
	static RemoveCapturedProperty(Variant: Variant,Actor: Actor,Property: PropertyValue): void;
	static RemoveActorBindingByName(Variant: Variant,ActorName: string): void;
	static RemoveActorBinding(Variant: Variant,Actor: Actor): void;
	static Record(PropVal: PropertyValue): void;
	static GetValueVector4(Property: PropertyValue): Vector4;
	static GetValueVector2D(Property: PropertyValue): Vector2D;
	static GetValueVector(Property: PropertyValue): Vector;
	static GetValueString(Property: PropertyValue): string;
	static GetValueRotator(Property: PropertyValue): Rotator;
	static GetValueQuat(Property: PropertyValue): Quat;
	static GetValueObject(Property: PropertyValue): UObject;
	static GetValueLinearColor(Property: PropertyValue): LinearColor;
	static GetValueIntPoint(Property: PropertyValue): IntPoint;
	static GetValueInt(Property: PropertyValue): number;
	static GetValueFloat(Property: PropertyValue): number;
	static GetValueColor(Property: PropertyValue): Color;
	static GetValueBool(Property: PropertyValue): boolean;
	static GetPropertyTypeString(PropVal: PropertyValue): string;
	static GetCapturedProperties(Variant: Variant,Actor: Actor): PropertyValue[];
	static GetCapturableProperties(ActorOrClass: UObject): string[];
	static DeleteDependency(Variant: Variant,Index: number): void;
	static CreateLevelVariantSetsAsset(AssetName: string,AssetPath: string): LevelVariantSets;
	static CreateLevelVariantSetsActor(LevelVariantSetsAsset: LevelVariantSets): LevelVariantSetsActor;
	static CaptureProperty(Variant: Variant,Actor: Actor,PropertyPath: string): PropertyValue;
	static Apply(PropVal: PropertyValue): void;
	static AddVariantSet(LevelVariantSets: LevelVariantSets,VariantSet: VariantSet): void;
	static AddVariant(VariantSet: VariantSet,Variant: Variant): void;
	static AddDependency(Variant: Variant,Dependency?: VariantDependency): {Dependency: VariantDependency, $: number};
	static AddActorBinding(Variant: Variant,Actor: Actor): void;
	static C(Other: UObject | any): VariantManagerBlueprintLibrary;
}

declare class InterchangeAnimationTrackSetNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeAnimationTrackSetNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimationTrackSetNode;
	static GetDefaultObject(): InterchangeAnimationTrackSetNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimationTrackSetNode;
	SetCustomFrameRate(AttributeValue: number): boolean;
	RemoveCustomAnimationTrackUid(AnimationTrackUid: string): boolean;
	GetCustomFrameRate(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAnimationTrackUids(OutAnimationTrackUids?: string[]): {OutAnimationTrackUids: string[]};
	GetCustomAnimationTrackUidCount(): number;
	GetCustomAnimationTrackUid(Index: number,OutAnimationTrackUid?: string): {OutAnimationTrackUid: string};
	AddCustomAnimationTrackUid(AnimationTrackUid: string): boolean;
	static C(Other: UObject | any): InterchangeAnimationTrackSetNode;
}

declare class InterchangeAnimationTrackBaseNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeAnimationTrackBaseNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimationTrackBaseNode;
	static GetDefaultObject(): InterchangeAnimationTrackBaseNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimationTrackBaseNode;
	SetCustomCompletionMode(AttributeValue: number): boolean;
	GetCustomCompletionMode(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeAnimationTrackBaseNode;
}

declare class InterchangeAnimationTrackSetInstanceNode extends InterchangeAnimationTrackBaseNode { 
	static Load(ResourceName: string): InterchangeAnimationTrackSetInstanceNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimationTrackSetInstanceNode;
	static GetDefaultObject(): InterchangeAnimationTrackSetInstanceNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimationTrackSetInstanceNode;
	SetCustomTrackSetDependencyUid(AttributeValue: string): boolean;
	SetCustomTimeScale(AttributeValue: number): boolean;
	SetCustomStartFrame(AttributeValue: number): boolean;
	SetCustomDuration(AttributeValue: number): boolean;
	GetCustomTrackSetDependencyUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomTimeScale(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomStartFrame(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomDuration(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeAnimationTrackSetInstanceNode;
}

declare class InterchangeAnimationTrackNode extends InterchangeAnimationTrackBaseNode { 
	static Load(ResourceName: string): InterchangeAnimationTrackNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimationTrackNode;
	static GetDefaultObject(): InterchangeAnimationTrackNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimationTrackNode;
	SetCustomTargetedProperty(TargetedProperty: number): boolean;
	SetCustomFrameCount(AttributeValue: number): boolean;
	SetCustomAnimationPayloadKey(PayloadKey: string): boolean;
	SetCustomActorDependencyUid(DependencyUid: string): boolean;
	GetCustomTargetedProperty(TargetedProperty?: number): {TargetedProperty: number, $: boolean};
	GetCustomFrameCount(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAnimationPayloadKey(PayloadKey?: string): {PayloadKey: string, $: boolean};
	GetCustomActorDependencyUid(DependencyUid?: string): {DependencyUid: string, $: boolean};
	static C(Other: UObject | any): InterchangeAnimationTrackNode;
}

declare class InterchangeTransformAnimationTrackNode extends InterchangeAnimationTrackNode { 
	static Load(ResourceName: string): InterchangeTransformAnimationTrackNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTransformAnimationTrackNode;
	static GetDefaultObject(): InterchangeTransformAnimationTrackNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTransformAnimationTrackNode;
	SetCustomUsedChannels(AttributeValue: number): boolean;
	GetCustomUsedChannels(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeTransformAnimationTrackNode;
}

declare class InterchangeSkeletalAnimationTrackNode extends InterchangeAnimationTrackBaseNode { 
	static Load(ResourceName: string): InterchangeSkeletalAnimationTrackNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSkeletalAnimationTrackNode;
	static GetDefaultObject(): InterchangeSkeletalAnimationTrackNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSkeletalAnimationTrackNode;
	SetCustomSkeletonNodeUid(AttributeValue: string): boolean;
	SetCustomSkeletalMeshNodeUid(AttributeValue: string): boolean;
	SetCustomAnimationStopTime(StopTime: number): boolean;
	SetCustomAnimationStartTime(StartTime: number): boolean;
	SetCustomAnimationSampleRate(SampleRate: number): boolean;
	SetAnimationPayloadKeyForSceneNodeUid(SceneNodeUid: string,PayloadKey: string): boolean;
	SetAnimationPayloadKeyForMorphTargetNodeUid(MorphTargetNodeUid: string,PayloadKey: string): boolean;
	RemoveAnimationPayloadKeyForSceneNodeUid(SceneNodeUid: string): boolean;
	RemoveAnimationPayloadKeyForMorphTargetNodeUid(MorphTargetNodeUid: string): boolean;
	GetSceneNodeAnimationPayloadKeys(OutSceneNodeAnimationPayloadKeys?: Map<string, string>): {OutSceneNodeAnimationPayloadKeys: Map<string, string>};
	GetMorphTargetNodeAnimationPayloadKeys(OutMorphTargetNodeAnimationPayloads?: Map<string, string>): {OutMorphTargetNodeAnimationPayloads: Map<string, string>};
	GetCustomSkeletonNodeUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomSkeletalMeshNodeUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomAnimationStopTime(StopTime?: number): {StopTime: number, $: boolean};
	GetCustomAnimationStartTime(StartTime?: number): {StartTime: number, $: boolean};
	GetCustomAnimationSampleRate(SampleRate?: number): {SampleRate: number, $: boolean};
	GetAnimationPayloadKeyFromSceneNodeUid(SceneNodeUid: string,OutPayloadKey?: string): {OutPayloadKey: string, $: boolean};
	GetAnimationPayloadKeyFromMorphTargetNodeUid(MorphTargetNodeUid: string,OutPayloadKey?: string): {OutPayloadKey: string, $: boolean};
	static C(Other: UObject | any): InterchangeSkeletalAnimationTrackNode;
}

declare class InterchangeCameraNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeCameraNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeCameraNode;
	static GetDefaultObject(): InterchangeCameraNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeCameraNode;
	SetCustomSensorWidth(AttributeValue: number): boolean;
	SetCustomSensorHeight(AttributeValue: number): boolean;
	SetCustomFocalLength(AttributeValue: number): boolean;
	SetCustomEnableDepthOfField(AttributeValue: boolean): boolean;
	GetCustomSensorWidth(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomSensorHeight(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomFocalLength(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomEnableDepthOfField(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	static C(Other: UObject | any): InterchangeCameraNode;
}

declare class InterchangeBaseLightNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeBaseLightNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeBaseLightNode;
	static GetDefaultObject(): InterchangeBaseLightNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeBaseLightNode;
	SetCustomUseTemperature(AttributeValue: boolean): boolean;
	SetCustomTemperature(AttributeValue: number): boolean;
	SetCustomLightColor(AttributeValue: LinearColor): boolean;
	SetCustomIntensity(AttributeValue: number): boolean;
	GetCustomUseTemperature(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomTemperature(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomLightColor(AttributeValue?: LinearColor): {AttributeValue: LinearColor, $: boolean};
	GetCustomIntensity(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeBaseLightNode;
}

declare type EInterchangeLightUnits = 'Unitless' | 'Candelas' | 'Lumens' | 'EInterchangeLightUnits_MAX';
declare var EInterchangeLightUnits : { Unitless:'Unitless',Candelas:'Candelas',Lumens:'Lumens',EInterchangeLightUnits_MAX:'EInterchangeLightUnits_MAX', };
declare class InterchangeLightNode extends InterchangeBaseLightNode { 
	static Load(ResourceName: string): InterchangeLightNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeLightNode;
	static GetDefaultObject(): InterchangeLightNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeLightNode;
	SetCustomIntensityUnits(AttributeValue: EInterchangeLightUnits): boolean;
	SetCustomIESTexture(AttributeValue: string): boolean;
	SetCustomAttenuationRadius(AttributeValue: number): boolean;
	GetCustomIntensityUnits(AttributeValue?: EInterchangeLightUnits): {AttributeValue: EInterchangeLightUnits, $: boolean};
	GetCustomIESTexture(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomAttenuationRadius(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeLightNode;
}

declare class InterchangePointLightNode extends InterchangeLightNode { 
	static Load(ResourceName: string): InterchangePointLightNode;
	static Find(Outer: UObject, ResourceName: string): InterchangePointLightNode;
	static GetDefaultObject(): InterchangePointLightNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangePointLightNode;
	SetCustomUseInverseSquaredFalloff(AttributeValue: boolean): boolean;
	SetCustomLightFalloffExponent(AttributeValue: number): boolean;
	GetCustomUseInverseSquaredFalloff(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomLightFalloffExponent(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangePointLightNode;
}

declare class InterchangeSpotLightNode extends InterchangePointLightNode { 
	static Load(ResourceName: string): InterchangeSpotLightNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSpotLightNode;
	static GetDefaultObject(): InterchangeSpotLightNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSpotLightNode;
	SetCustomOuterConeAngle(AttributeValue: number): boolean;
	SetCustomInnerConeAngle(AttributeValue: number): boolean;
	GetCustomOuterConeAngle(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomInnerConeAngle(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeSpotLightNode;
}

declare class InterchangeRectLightNode extends InterchangeLightNode { 
	static Load(ResourceName: string): InterchangeRectLightNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeRectLightNode;
	static GetDefaultObject(): InterchangeRectLightNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeRectLightNode;
	SetCustomSourceWidth(AttributeValue: number): boolean;
	SetCustomSourceHeight(AttributeValue: number): boolean;
	GetCustomSourceWidth(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomSourceHeight(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeRectLightNode;
}

declare class InterchangeDirectionalLightNode extends InterchangeBaseLightNode { 
	static Load(ResourceName: string): InterchangeDirectionalLightNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeDirectionalLightNode;
	static GetDefaultObject(): InterchangeDirectionalLightNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeDirectionalLightNode;
	static C(Other: UObject | any): InterchangeDirectionalLightNode;
}

declare type EInterchangeTextureFilterMode = 'Nearest' | 'Bilinear' | 'Trilinear' | 'Default' | 'EInterchangeTextureFilterMode_MAX';
declare var EInterchangeTextureFilterMode : { Nearest:'Nearest',Bilinear:'Bilinear',Trilinear:'Trilinear',Default:'Default',EInterchangeTextureFilterMode_MAX:'EInterchangeTextureFilterMode_MAX', };
declare class InterchangeTextureNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeTextureNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureNode;
	static GetDefaultObject(): InterchangeTextureNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureNode;
	SetPayLoadKey(PayloadKey: string): void;
	SetCustomSRGB(AttributeValue: boolean): boolean;
	SetCustomFilter(AttributeValue: EInterchangeTextureFilterMode): boolean;
	SetCustombFlipGreenChannel(AttributeValue: boolean): boolean;
	GetCustomSRGB(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomFilter(AttributeValue?: EInterchangeTextureFilterMode): {AttributeValue: EInterchangeTextureFilterMode, $: boolean};
	GetCustombFlipGreenChannel(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	static C(Other: UObject | any): InterchangeTextureNode;
}

declare class InterchangeTexture2DArrayNode extends InterchangeTextureNode { 
	static Load(ResourceName: string): InterchangeTexture2DArrayNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTexture2DArrayNode;
	static GetDefaultObject(): InterchangeTexture2DArrayNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTexture2DArrayNode;
	static C(Other: UObject | any): InterchangeTexture2DArrayNode;
}

declare class InterchangeTextureCubeArrayNode extends InterchangeTextureNode { 
	static Load(ResourceName: string): InterchangeTextureCubeArrayNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureCubeArrayNode;
	static GetDefaultObject(): InterchangeTextureCubeArrayNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureCubeArrayNode;
	static C(Other: UObject | any): InterchangeTextureCubeArrayNode;
}

declare class InterchangeTextureCubeNode extends InterchangeTextureNode { 
	static Load(ResourceName: string): InterchangeTextureCubeNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureCubeNode;
	static GetDefaultObject(): InterchangeTextureCubeNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureCubeNode;
	static C(Other: UObject | any): InterchangeTextureCubeNode;
}

declare class InterchangeTextureLightProfileNode extends InterchangeTextureNode { 
	static Load(ResourceName: string): InterchangeTextureLightProfileNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureLightProfileNode;
	static GetDefaultObject(): InterchangeTextureLightProfileNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureLightProfileNode;
	static C(Other: UObject | any): InterchangeTextureLightProfileNode;
}

declare class InterchangeVariantSetNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeVariantSetNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeVariantSetNode;
	static GetDefaultObject(): InterchangeVariantSetNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeVariantSetNode;
	SetCustomVariantsPayloadKey(PayloadKey: string): boolean;
	SetCustomDisplayText(AttributeValue: string): boolean;
	RemoveCustomDependencyUid(DependencyUid: string): boolean;
	GetCustomVariantsPayloadKey(PayloadKey?: string): {PayloadKey: string, $: boolean};
	GetCustomDisplayText(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomDependencyUids(OutDependencyUids?: string[]): {OutDependencyUids: string[]};
	GetCustomDependencyUidCount(): number;
	GetCustomDependencyUid(Index: number,OutDependencyUid?: string): {OutDependencyUid: string};
	AddCustomDependencyUid(DependencyUid: string): boolean;
	static C(Other: UObject | any): InterchangeVariantSetNode;
}

declare class InterchangeSceneVariantSetsNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeSceneVariantSetsNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSceneVariantSetsNode;
	static GetDefaultObject(): InterchangeSceneVariantSetsNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSceneVariantSetsNode;
	RemoveCustomVariantSetUid(VariantUid: string): boolean;
	GetCustomVariantSetUids(OutVariantUids?: string[]): {OutVariantUids: string[]};
	GetCustomVariantSetUidCount(): number;
	GetCustomVariantSetUid(Index: number,OutVariantUid?: string): {OutVariantUid: string};
	AddCustomVariantSetUid(VariantUid: string): boolean;
	static C(Other: UObject | any): InterchangeSceneVariantSetsNode;
}

declare class InterchangeVolumeTextureNode extends InterchangeTextureNode { 
	static Load(ResourceName: string): InterchangeVolumeTextureNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeVolumeTextureNode;
	static GetDefaultObject(): InterchangeVolumeTextureNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeVolumeTextureNode;
	static C(Other: UObject | any): InterchangeVolumeTextureNode;
}

declare class InterchangeMeshNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeMeshNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeMeshNode;
	static GetDefaultObject(): InterchangeMeshNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMeshNode;
	SetSlotMaterialDependencyUid(SlotName: string,MaterialDependencyUid: string): boolean;
	SetSkinnedMesh(bIsSkinnedMesh: boolean): boolean;
	SetSkeletonDependencyUid(DependencyUid: string): boolean;
	SetSceneInstanceUid(DependencyUid: string): boolean;
	SetPayLoadKey(PayloadKey: string): void;
	SetMorphTargetName(MorphTargetName: string): boolean;
	SetMorphTargetDependencyUid(DependencyUid: string): boolean;
	SetMorphTarget(bIsMorphTarget: boolean): boolean;
	SetCustomVertexCount(AttributeValue: number): boolean;
	SetCustomUVCount(AttributeValue: number): boolean;
	SetCustomPolygonCount(AttributeValue: number): boolean;
	SetCustomHasVertexTangent(AttributeValue: boolean): boolean;
	SetCustomHasVertexNormal(AttributeValue: boolean): boolean;
	SetCustomHasVertexColor(AttributeValue: boolean): boolean;
	SetCustomHasVertexBinormal(AttributeValue: boolean): boolean;
	SetCustomHasSmoothGroup(AttributeValue: boolean): boolean;
	SetCustomBoundingBox(AttributeValue: Box): boolean;
	SetAnimationCurvePayLoadKey(PayloadKey: string): void;
	RemoveSlotMaterialDependencyUid(SlotName: string): boolean;
	RemoveSkeletonDependencyUid(DependencyUid: string): boolean;
	RemoveSceneInstanceUid(DependencyUid: string): boolean;
	RemoveMorphTargetDependencyUid(DependencyUid: string): boolean;
	IsSkinnedMesh(): boolean;
	IsMorphTarget(): boolean;
	GetSlotMaterialDependencyUid(SlotName: string,OutMaterialDependency?: string): {OutMaterialDependency: string, $: boolean};
	GetSlotMaterialDependencies(OutMaterialDependencies?: Map<string, string>): {OutMaterialDependencies: Map<string, string>};
	GetSkeletonDependency(Index: number,OutDependency?: string): {OutDependency: string};
	GetSkeletonDependencies(OutDependencies?: string[]): {OutDependencies: string[]};
	GetSkeletonDependeciesCount(): number;
	GetSceneInstanceUidsCount(): number;
	GetSceneInstanceUids(OutDependencies?: string[]): {OutDependencies: string[]};
	GetSceneInstanceUid(Index: number,OutDependency?: string): {OutDependency: string};
	GetMorphTargetName(OutMorphTargetName?: string): {OutMorphTargetName: string, $: boolean};
	GetMorphTargetDependency(Index: number,OutDependency?: string): {OutDependency: string};
	GetMorphTargetDependencies(OutDependencies?: string[]): {OutDependencies: string[]};
	GetMorphTargetDependeciesCount(): number;
	GetCustomVertexCount(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomUVCount(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomPolygonCount(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomHasVertexTangent(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomHasVertexNormal(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomHasVertexColor(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomHasVertexBinormal(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomHasSmoothGroup(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomBoundingBox(AttributeValue?: Box): {AttributeValue: Box, $: boolean};
	static C(Other: UObject | any): InterchangeMeshNode;
}

declare class InterchangeSceneNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeSceneNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSceneNode;
	static GetDefaultObject(): InterchangeSceneNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSceneNode;
	SetSlotMaterialDependencyUid(SlotName: string,MaterialDependencyUid: string): boolean;
	SetCustomTimeZeroLocalTransform(BaseNodeContainer: InterchangeBaseNodeContainer,AttributeValue: Transform,bResetCache: boolean): boolean;
	SetCustomLocalTransform(BaseNodeContainer: InterchangeBaseNodeContainer,AttributeValue: Transform,bResetCache: boolean): boolean;
	SetCustomGeometricTransform(AttributeValue: Transform): boolean;
	SetCustomBindPoseLocalTransform(BaseNodeContainer: InterchangeBaseNodeContainer,AttributeValue: Transform,bResetCache: boolean): boolean;
	SetCustomAssetInstanceUid(AttributeValue: string): boolean;
	RemoveSpecializedType(SpecializedType: string): boolean;
	RemoveSlotMaterialDependencyUid(SlotName: string): boolean;
	IsSpecializedTypeContains(SpecializedType: string): boolean;
	GetSpecializedTypes(OutSpecializedTypes?: string[]): {OutSpecializedTypes: string[]};
	GetSpecializedTypeCount(): number;
	GetSpecializedType(Index: number,OutSpecializedType?: string): {OutSpecializedType: string};
	GetSlotMaterialDependencyUid(SlotName: string,OutMaterialDependency?: string): {OutMaterialDependency: string, $: boolean};
	GetSlotMaterialDependencies(OutMaterialDependencies?: Map<string, string>): {OutMaterialDependencies: Map<string, string>};
	GetCustomTimeZeroLocalTransform(AttributeValue?: Transform): {AttributeValue: Transform, $: boolean};
	GetCustomTimeZeroGlobalTransform(BaseNodeContainer: InterchangeBaseNodeContainer,GlobalOffsetTransform: Transform,AttributeValue?: Transform,bForceRecache?: boolean): {AttributeValue: Transform, $: boolean};
	GetCustomLocalTransform(AttributeValue?: Transform): {AttributeValue: Transform, $: boolean};
	GetCustomGlobalTransform(BaseNodeContainer: InterchangeBaseNodeContainer,GlobalOffsetTransform: Transform,AttributeValue?: Transform,bForceRecache?: boolean): {AttributeValue: Transform, $: boolean};
	GetCustomGeometricTransform(AttributeValue?: Transform): {AttributeValue: Transform, $: boolean};
	GetCustomBindPoseLocalTransform(AttributeValue?: Transform): {AttributeValue: Transform, $: boolean};
	GetCustomBindPoseGlobalTransform(BaseNodeContainer: InterchangeBaseNodeContainer,GlobalOffsetTransform: Transform,AttributeValue?: Transform,bForceRecache?: boolean): {AttributeValue: Transform, $: boolean};
	GetCustomAssetInstanceUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	AddSpecializedType(SpecializedType: string): boolean;
	static C(Other: UObject | any): InterchangeSceneNode;
}

declare class InterchangeShaderPortsAPI extends UObject { 
	static Load(ResourceName: string): InterchangeShaderPortsAPI;
	static Find(Outer: UObject, ResourceName: string): InterchangeShaderPortsAPI;
	static GetDefaultObject(): InterchangeShaderPortsAPI;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeShaderPortsAPI;
	static MakeInputValueKey(InputName: string): string;
	static MakeInputName(InputKey: string): string;
	static MakeInputConnectionKey(InputName: string): string;
	static IsAnInput(AttributeKey: string): boolean;
	static HasInput(InterchangeNode: InterchangeBaseNode,InInputName: string): boolean;
	static GetInputConnection(InterchangeNode: InterchangeBaseNode,InputName: string,OutExpressionUid?: string,OutputName?: string): {OutExpressionUid: string, OutputName: string, $: boolean};
	static GatherInputs(InterchangeNode: InterchangeBaseNode,OutInputNames?: string[]): {OutInputNames: string[]};
	static ConnectOuputToInput(InterchangeNode: InterchangeBaseNode,InputName: string,ExpressionUid: string,OutputName: string): boolean;
	static ConnectDefaultOuputToInput(InterchangeNode: InterchangeBaseNode,InputName: string,ExpressionUid: string): boolean;
	static C(Other: UObject | any): InterchangeShaderPortsAPI;
}

declare class InterchangeShaderNode extends InterchangeBaseNode { 
	static Load(ResourceName: string): InterchangeShaderNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeShaderNode;
	static GetDefaultObject(): InterchangeShaderNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeShaderNode;
	SetCustomShaderType(AttributeValue: string): boolean;
	GetCustomShaderType(AttributeValue?: string): {AttributeValue: string, $: boolean};
	static C(Other: UObject | any): InterchangeShaderNode;
}

declare class InterchangeFunctionCallShaderNode extends InterchangeShaderNode { 
	static Load(ResourceName: string): InterchangeFunctionCallShaderNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeFunctionCallShaderNode;
	static GetDefaultObject(): InterchangeFunctionCallShaderNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeFunctionCallShaderNode;
	SetCustomMaterialFunction(AttributeValue: string): boolean;
	GetCustomMaterialFunction(AttributeValue?: string): {AttributeValue: string, $: boolean};
	static C(Other: UObject | any): InterchangeFunctionCallShaderNode;
}

declare class InterchangeShaderGraphNode extends InterchangeShaderNode { 
	static Load(ResourceName: string): InterchangeShaderGraphNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeShaderGraphNode;
	static GetDefaultObject(): InterchangeShaderGraphNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeShaderGraphNode;
	SetCustomTwoSided(AttributeValue: boolean): boolean;
	SetCustomOpacityMaskClipValue(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomIsAShaderFunction(AttributeValue: boolean): boolean;
	GetCustomTwoSided(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomOpacityMaskClipValue(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomIsAShaderFunction(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	static C(Other: UObject | any): InterchangeShaderGraphNode;
}

declare type EInterchangeTextureWrapMode = 'Wrap' | 'Clamp' | 'Mirror' | 'EInterchangeTextureWrapMode_MAX';
declare var EInterchangeTextureWrapMode : { Wrap:'Wrap',Clamp:'Clamp',Mirror:'Mirror',EInterchangeTextureWrapMode_MAX:'EInterchangeTextureWrapMode_MAX', };
declare class InterchangeTexture2DNode extends InterchangeTextureNode { 
	static Load(ResourceName: string): InterchangeTexture2DNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTexture2DNode;
	static GetDefaultObject(): InterchangeTexture2DNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTexture2DNode;
	SetCustomWrapV(AttributeValue: EInterchangeTextureWrapMode): boolean;
	SetCustomWrapU(AttributeValue: EInterchangeTextureWrapMode): boolean;
	GetSourceBlocks(): Map<number, string>;
	GetCustomWrapV(AttributeValue?: EInterchangeTextureWrapMode): {AttributeValue: EInterchangeTextureWrapMode, $: boolean};
	GetCustomWrapU(AttributeValue?: EInterchangeTextureWrapMode): {AttributeValue: EInterchangeTextureWrapMode, $: boolean};
	static C(Other: UObject | any): InterchangeTexture2DNode;
}

declare class InterchangeAnimationTrackSetFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeAnimationTrackSetFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimationTrackSetFactoryNode;
	static GetDefaultObject(): InterchangeAnimationTrackSetFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimationTrackSetFactoryNode;
	SetCustomFrameRate(AttributeValue: number): boolean;
	RemoveCustomAnimationTrackUid(AnimationTrackUid: string): boolean;
	GetObjectClass(): UnrealEngineClass;
	GetCustomFrameRate(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAnimationTrackUids(OutAnimationTrackUids?: string[]): {OutAnimationTrackUids: string[]};
	GetCustomAnimationTrackUidCount(): number;
	GetCustomAnimationTrackUid(Index: number,OutAnimationTrackUid?: string): {OutAnimationTrackUid: string};
	AddCustomAnimationTrackUid(AnimationTrackUid: string): boolean;
	static C(Other: UObject | any): InterchangeAnimationTrackSetFactoryNode;
}

declare class InterchangeActorFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeActorFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeActorFactoryNode;
	static GetDefaultObject(): InterchangeActorFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeActorFactoryNode;
	SetCustomMobility(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomGlobalTransform(AttributeValue: Transform): boolean;
	SetCustomActorClassName(AttributeValue: string): boolean;
	GetCustomMobility(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomGlobalTransform(AttributeValue?: Transform): {AttributeValue: Transform, $: boolean};
	GetCustomActorClassName(AttributeValue?: string): {AttributeValue: string, $: boolean};
	static C(Other: UObject | any): InterchangeActorFactoryNode;
}

declare class InterchangeCineCameraFactoryNode extends InterchangeActorFactoryNode { 
	static Load(ResourceName: string): InterchangeCineCameraFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeCineCameraFactoryNode;
	static GetDefaultObject(): InterchangeCineCameraFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeCineCameraFactoryNode;
	SetCustomSensorWidth(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomSensorHeight(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomFocusMethod(AttributeValue: ECameraFocusMethod,bAddApplyDelegate: boolean): boolean;
	SetCustomFocalLength(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	GetCustomSensorWidth(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomSensorHeight(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomFocusMethod(AttributeValue?: ECameraFocusMethod): {AttributeValue: ECameraFocusMethod, $: boolean};
	GetCustomFocalLength(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeCineCameraFactoryNode;
}

declare class InterchangeBaseLightFactoryNode extends InterchangeActorFactoryNode { 
	static Load(ResourceName: string): InterchangeBaseLightFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeBaseLightFactoryNode;
	static GetDefaultObject(): InterchangeBaseLightFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeBaseLightFactoryNode;
	SetCustomUseTemperature(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomTemperature(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomLightColor(AttributeValue: Color,bAddApplyDelegate: boolean): boolean;
	SetCustomIntensity(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	GetCustomUseTemperature(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomTemperature(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomLightColor(AttributeValue?: Color): {AttributeValue: Color, $: boolean};
	GetCustomIntensity(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeBaseLightFactoryNode;
}

declare class InterchangeDirectionalLightFactoryNode extends InterchangeBaseLightFactoryNode { 
	static Load(ResourceName: string): InterchangeDirectionalLightFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeDirectionalLightFactoryNode;
	static GetDefaultObject(): InterchangeDirectionalLightFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeDirectionalLightFactoryNode;
	static C(Other: UObject | any): InterchangeDirectionalLightFactoryNode;
}

declare class InterchangeLightFactoryNode extends InterchangeBaseLightFactoryNode { 
	static Load(ResourceName: string): InterchangeLightFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeLightFactoryNode;
	static GetDefaultObject(): InterchangeLightFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeLightFactoryNode;
	SetCustomIntensityUnits(AttributeValue: ELightUnits,bAddApplyDelegate: boolean): boolean;
	SetCustomIESTexture(AttributeValue: string): boolean;
	SetCustomAttenuationRadius(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	GetCustomIntensityUnits(AttributeValue?: ELightUnits): {AttributeValue: ELightUnits, $: boolean};
	GetCustomIESTexture(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomAttenuationRadius(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeLightFactoryNode;
}

declare class InterchangeRectLightFactoryNode extends InterchangeLightFactoryNode { 
	static Load(ResourceName: string): InterchangeRectLightFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeRectLightFactoryNode;
	static GetDefaultObject(): InterchangeRectLightFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeRectLightFactoryNode;
	SetCustomSourceWidth(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomSourceHeight(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	GetCustomSourceWidth(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomSourceHeight(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeRectLightFactoryNode;
}

declare class InterchangePointLightFactoryNode extends InterchangeLightFactoryNode { 
	static Load(ResourceName: string): InterchangePointLightFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangePointLightFactoryNode;
	static GetDefaultObject(): InterchangePointLightFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangePointLightFactoryNode;
	SetCustomUseInverseSquaredFalloff(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomLightFalloffExponent(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	GetCustomUseInverseSquaredFalloff(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomLightFalloffExponent(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangePointLightFactoryNode;
}

declare class InterchangeSpotLightFactoryNode extends InterchangePointLightFactoryNode { 
	static Load(ResourceName: string): InterchangeSpotLightFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSpotLightFactoryNode;
	static GetDefaultObject(): InterchangeSpotLightFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSpotLightFactoryNode;
	SetCustomOuterConeAngle(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomInnerConeAngle(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	GetCustomOuterConeAngle(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomInnerConeAngle(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeSpotLightFactoryNode;
}

declare class InterchangePhysicsAssetFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangePhysicsAssetFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangePhysicsAssetFactoryNode;
	static GetDefaultObject(): InterchangePhysicsAssetFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangePhysicsAssetFactoryNode;
	SetCustomSkeletalMeshUid(AttributeValue: string): boolean;
	InitializePhysicsAssetNode(UniqueId: string,DisplayLabel: string,InAssetClass: string): void;
	GetObjectClass(): UnrealEngineClass;
	GetCustomSkeletalMeshUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	static C(Other: UObject | any): InterchangePhysicsAssetFactoryNode;
}

declare class InterchangeSceneVariantSetsFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeSceneVariantSetsFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSceneVariantSetsFactoryNode;
	static GetDefaultObject(): InterchangeSceneVariantSetsFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSceneVariantSetsFactoryNode;
	RemoveCustomVariantSetUid(VariantUid: string): boolean;
	GetObjectClass(): UnrealEngineClass;
	GetCustomVariantSetUids(OutVariantUids?: string[]): {OutVariantUids: string[]};
	GetCustomVariantSetUidCount(): number;
	GetCustomVariantSetUid(Index: number,OutVariantUid?: string): {OutVariantUid: string};
	AddCustomVariantSetUid(VariantUid: string): boolean;
	static C(Other: UObject | any): InterchangeSceneVariantSetsFactoryNode;
}

declare class InterchangeSkeletonFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeSkeletonFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSkeletonFactoryNode;
	static GetDefaultObject(): InterchangeSkeletonFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSkeletonFactoryNode;
	SetCustomUseTimeZeroForBindPose(AttributeValue: boolean): boolean;
	SetCustomSkeletalMeshFactoryNodeUid(AttributeValue: string): boolean;
	SetCustomRootJointUid(AttributeValue: string): boolean;
	InitializeSkeletonNode(UniqueId: string,DisplayLabel: string,InAssetClass: string): void;
	GetObjectClass(): UnrealEngineClass;
	GetCustomUseTimeZeroForBindPose(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomSkeletalMeshFactoryNodeUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomRootJointUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	static C(Other: UObject | any): InterchangeSkeletonFactoryNode;
}

declare class InterchangeTextureFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeTextureFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureFactoryNode;
	static GetDefaultObject(): InterchangeTextureFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureFactoryNode;
	SetCustomVirtualTextureStreaming(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomTranslatedTextureNodeUid(AttributeValue: string): boolean;
	SetCustomSRGB(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomPreferCompressedSourceData(AttributeValue: boolean): boolean;
	SetCustomPowerOfTwoMode(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomPaddingColor(AttributeValue: Color,bAddApplyDelegate: boolean): boolean;
	SetCustomMipLoadOptions(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomMipGenSettings(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomMaxTextureSize(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomLossyCompressionAmount(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomLODGroup(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomLODBias(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomFilter(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomDownscaleOptions(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomDownscale(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomDeferCompression(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomCompressionSettings(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomCompressionQuality(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomCompressionNoAlpha(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomCompositeTextureMode(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomCompositePower(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomChromaKeyThreshold(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomChromaKeyColor(AttributeValue: Color,bAddApplyDelegate: boolean): boolean;
	SetCustombUseLegacyGamma(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustombPreserveBorder(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustombFlipGreenChannel(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustombDoScaleMipsForAlphaCoverage(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustombChromaKeyTexture(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomAlphaCoverageThresholds(AttributeValue: Vector4,bAddApplyDelegate: boolean): boolean;
	SetCustomAllowNonPowerOfTwo(AttributeValue: boolean): boolean;
	SetCustomAdjustVibrance(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomAdjustSaturation(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomAdjustRGBCurve(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomAdjustMinAlpha(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomAdjustMaxAlpha(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomAdjustHue(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomAdjustBrightnessCurve(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomAdjustBrightness(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	InitializeTextureNode(UniqueId: string,DisplayLabel: string,InAssetName: string): void;
	GetObjectClass(): UnrealEngineClass;
	GetCustomVirtualTextureStreaming(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomTranslatedTextureNodeUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomSRGB(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomPreferCompressedSourceData(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomPowerOfTwoMode(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomPaddingColor(AttributeValue?: Color): {AttributeValue: Color, $: boolean};
	GetCustomMipLoadOptions(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomMipGenSettings(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomMaxTextureSize(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomLossyCompressionAmount(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomLODGroup(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomLODBias(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomFilter(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomDownscaleOptions(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomDownscale(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomDeferCompression(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomCompressionSettings(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomCompressionQuality(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomCompressionNoAlpha(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomCompositeTextureMode(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomCompositePower(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomChromaKeyThreshold(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomChromaKeyColor(AttributeValue?: Color): {AttributeValue: Color, $: boolean};
	GetCustombUseLegacyGamma(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustombPreserveBorder(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustombFlipGreenChannel(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustombDoScaleMipsForAlphaCoverage(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustombChromaKeyTexture(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomAlphaCoverageThresholds(AttributeValue?: Vector4): {AttributeValue: Vector4, $: boolean};
	GetCustomAllowNonPowerOfTwo(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomAdjustVibrance(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAdjustSaturation(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAdjustRGBCurve(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAdjustMinAlpha(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAdjustMaxAlpha(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAdjustHue(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAdjustBrightnessCurve(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAdjustBrightness(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeTextureFactoryNode;
}

declare class InterchangeTexture2DArrayFactoryNode extends InterchangeTextureFactoryNode { 
	static Load(ResourceName: string): InterchangeTexture2DArrayFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTexture2DArrayFactoryNode;
	static GetDefaultObject(): InterchangeTexture2DArrayFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTexture2DArrayFactoryNode;
	SetCustomAddressZ(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	GetCustomAddressZ(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAddressY(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomAddressX(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeTexture2DArrayFactoryNode;
}

declare class InterchangeTexture2DFactoryNode extends InterchangeTextureFactoryNode { 
	static Load(ResourceName: string): InterchangeTexture2DFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTexture2DFactoryNode;
	static GetDefaultObject(): InterchangeTexture2DFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTexture2DFactoryNode;
	SetSourceBlocks(InSourceBlocks: Map<number, string>): void;
	SetSourceBlockByCoordinates(X: number,Y: number,InSourceFile: string): void;
	SetSourceBlock(BlockIndex: number,InSourceFile: string): void;
	SetCustomAddressY(AttributeValue: TextureAddress,bAddApplyDelegate: boolean): boolean;
	SetCustomAddressX(AttributeValue: TextureAddress,bAddApplyDelegate: boolean): boolean;
	GetSourceBlocks(): Map<number, string>;
	GetSourceBlockByCoordinates(X: number,Y: number,OutSourceFile?: string): {OutSourceFile: string, $: boolean};
	GetSourceBlock(BlockIndex: number,OutSourceFile?: string): {OutSourceFile: string, $: boolean};
	GetCustomAddressY(AttributeValue?: TextureAddress): {AttributeValue: TextureAddress, $: boolean};
	GetCustomAddressX(AttributeValue?: TextureAddress): {AttributeValue: TextureAddress, $: boolean};
	static C(Other: UObject | any): InterchangeTexture2DFactoryNode;
}

declare class InterchangeTextureCubeArrayFactoryNode extends InterchangeTextureFactoryNode { 
	static Load(ResourceName: string): InterchangeTextureCubeArrayFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureCubeArrayFactoryNode;
	static GetDefaultObject(): InterchangeTextureCubeArrayFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureCubeArrayFactoryNode;
	static C(Other: UObject | any): InterchangeTextureCubeArrayFactoryNode;
}

declare class InterchangeTextureCubeFactoryNode extends InterchangeTextureFactoryNode { 
	static Load(ResourceName: string): InterchangeTextureCubeFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureCubeFactoryNode;
	static GetDefaultObject(): InterchangeTextureCubeFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureCubeFactoryNode;
	static C(Other: UObject | any): InterchangeTextureCubeFactoryNode;
}

declare class InterchangeTextureLightProfileFactoryNode extends InterchangeTexture2DFactoryNode { 
	static Load(ResourceName: string): InterchangeTextureLightProfileFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureLightProfileFactoryNode;
	static GetDefaultObject(): InterchangeTextureLightProfileFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureLightProfileFactoryNode;
	SetCustomTextureMultiplier(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomBrightness(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	GetCustomTextureMultiplier(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomBrightness(AttributeValue?: number): {AttributeValue: number, $: boolean};
	static C(Other: UObject | any): InterchangeTextureLightProfileFactoryNode;
}

declare class InterchangeVolumeTextureFactoryNode extends InterchangeTextureFactoryNode { 
	static Load(ResourceName: string): InterchangeVolumeTextureFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeVolumeTextureFactoryNode;
	static GetDefaultObject(): InterchangeVolumeTextureFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeVolumeTextureFactoryNode;
	static C(Other: UObject | any): InterchangeVolumeTextureFactoryNode;
}

declare class InterchangeAnimSequenceFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeAnimSequenceFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimSequenceFactoryNode;
	static GetDefaultObject(): InterchangeAnimSequenceFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimSequenceFactoryNode;
	SetCustomSkeletonSoftObjectPath(AttributeValue: SoftObjectPath): boolean;
	SetCustomSkeletonFactoryNodeUid(AttributeValue: string): boolean;
	SetCustomRemoveCurveRedundantKeys(AttributeValue: boolean): boolean;
	SetCustomMaterialDriveParameterOnCustomAttribute(AttributeValue: boolean): boolean;
	SetCustomImportBoneTracksSampleRate(AttributeValue: number): boolean;
	SetCustomImportBoneTracksRangeStop(AttributeValue: number): boolean;
	SetCustomImportBoneTracksRangeStart(AttributeValue: number): boolean;
	SetCustomImportBoneTracks(AttributeValue: boolean): boolean;
	SetCustomImportAttributeCurves(AttributeValue: boolean): boolean;
	SetCustomDoNotImportCurveWithZero(AttributeValue: boolean): boolean;
	SetCustomDeleteExistingNonCurveCustomAttributes(AttributeValue: boolean): boolean;
	SetCustomDeleteExistingMorphTargetCurves(AttributeValue: boolean): boolean;
	SetCustomDeleteExistingCustomAttributeCurves(AttributeValue: boolean): boolean;
	SetAnimationPayloadKeyForSceneNodeUid(SceneNodeUid: string,PayloadKey: string): boolean;
	SetAnimationPayloadKeyForMorphTargetNodeUid(MorphTargetNodeUid: string,PayloadKey: string): boolean;
	SetAnimatedMorphTargetDependencyUid(DependencyUid: string): boolean;
	SetAnimatedMaterialCurveSuffixe(MaterialCurveSuffixe: string): boolean;
	SetAnimatedAttributeStepCurveName(AttributeStepCurveName: string): boolean;
	SetAnimatedAttributeCurveName(AttributeCurveName: string): boolean;
	RemoveAnimationPayloadKeyForSceneNodeUid(SceneNodeUid: string): boolean;
	RemoveAnimationPayloadKeyForMorphTargetNodeUid(MorphTargetNodeUid: string): boolean;
	RemoveAnimatedMorphTargetDependencyUid(DependencyUid: string): boolean;
	RemoveAnimatedMaterialCurveSuffixe(MaterialCurveSuffixe: string): boolean;
	RemoveAnimatedAttributeStepCurveName(AttributeStepCurveName: string): boolean;
	RemoveAnimatedAttributeCurveName(AttributeCurveName: string): boolean;
	InitializeAnimSequenceNode(UniqueId: string,DisplayLabel: string): void;
	GetSceneNodeAnimationPayloadKeys(OutSceneNodeAnimationPayloads?: Map<string, string>): {OutSceneNodeAnimationPayloads: Map<string, string>};
	GetObjectClass(): UnrealEngineClass;
	GetMorphTargetNodeAnimationPayloadKeys(OutMorphTargetNodeAnimationPayloads?: Map<string, string>): {OutMorphTargetNodeAnimationPayloads: Map<string, string>};
	GetCustomSkeletonSoftObjectPath(AttributeValue?: SoftObjectPath): {AttributeValue: SoftObjectPath, $: boolean};
	GetCustomSkeletonFactoryNodeUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomRemoveCurveRedundantKeys(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomMaterialDriveParameterOnCustomAttribute(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomImportBoneTracksSampleRate(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomImportBoneTracksRangeStop(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomImportBoneTracksRangeStart(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomImportBoneTracks(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomImportAttributeCurves(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomDoNotImportCurveWithZero(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomDeleteExistingNonCurveCustomAttributes(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomDeleteExistingMorphTargetCurves(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomDeleteExistingCustomAttributeCurves(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetAnimationPayloadKeyFromSceneNodeUid(SceneNodeUid: string,OutPayloadKey?: string): {OutPayloadKey: string, $: boolean};
	GetAnimationPayloadKeyFromMorphTargetNodeUid(MorphTargetNodeUid: string,OutPayloadKey?: string): {OutPayloadKey: string, $: boolean};
	GetAnimatedMorphTargetDependency(Index: number,OutDependency?: string): {OutDependency: string};
	GetAnimatedMorphTargetDependencies(OutDependencies?: string[]): {OutDependencies: string[]};
	GetAnimatedMorphTargetDependeciesCount(): number;
	GetAnimatedMaterialCurveSuffixesCount(): number;
	GetAnimatedMaterialCurveSuffixes(OutMaterialCurveSuffixes?: string[]): {OutMaterialCurveSuffixes: string[]};
	GetAnimatedMaterialCurveSuffixe(Index: number,OutMaterialCurveSuffixe?: string): {OutMaterialCurveSuffixe: string};
	GetAnimatedAttributeStepCurveNamesCount(): number;
	GetAnimatedAttributeStepCurveNames(OutAttributeStepCurveNames?: string[]): {OutAttributeStepCurveNames: string[]};
	GetAnimatedAttributeStepCurveName(Index: number,OutAttributeStepCurveName?: string): {OutAttributeStepCurveName: string};
	GetAnimatedAttributeCurveNamesCount(): number;
	GetAnimatedAttributeCurveNames(OutAttributeCurveNames?: string[]): {OutAttributeCurveNames: string[]};
	GetAnimatedAttributeCurveName(Index: number,OutAttributeCurveName?: string): {OutAttributeCurveName: string};
	static C(Other: UObject | any): InterchangeAnimSequenceFactoryNode;
}

declare class InterchangeCommonPipelineDataFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeCommonPipelineDataFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeCommonPipelineDataFactoryNode;
	static GetDefaultObject(): InterchangeCommonPipelineDataFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeCommonPipelineDataFactoryNode;
	SetCustomGlobalOffsetTransform(NodeContainer: InterchangeBaseNodeContainer,AttributeValue: Transform): boolean;
	SetBakeMeshes(NodeContainer: InterchangeBaseNodeContainer,AttributeValue: boolean): boolean;
	GetCustomGlobalOffsetTransform(AttributeValue?: Transform): {AttributeValue: Transform, $: boolean};
	GetBakeMeshes(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	static C(Other: UObject | any): InterchangeCommonPipelineDataFactoryNode;
}

declare class InterchangeBaseMaterialFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeBaseMaterialFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeBaseMaterialFactoryNode;
	static GetDefaultObject(): InterchangeBaseMaterialFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeBaseMaterialFactoryNode;
	static C(Other: UObject | any): InterchangeBaseMaterialFactoryNode;
}

declare class InterchangeMaterialFactoryNode extends InterchangeBaseMaterialFactoryNode { 
	static Load(ResourceName: string): InterchangeMaterialFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeMaterialFactoryNode;
	static GetDefaultObject(): InterchangeMaterialFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMaterialFactoryNode;
	SetCustomTwoSided(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomTranslucencyLightingMode(AttributeValue: ETranslucencyLightingMode,bAddApplyDelegate: boolean): boolean;
	SetCustomShadingModel(AttributeValue: EMaterialShadingModel,bAddApplyDelegate: boolean): boolean;
	SetCustomOpacityMaskClipValue(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomBlendMode(AttributeValue: EBlendMode,bAddApplyDelegate: boolean): boolean;
	GetTransmissionColorConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetTangentConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetSubsurfaceConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetSpecularConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetRoughnessConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetRefractionConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetOpacityConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetOcclusionConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetObjectClass(): UnrealEngineClass;
	GetNormalConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetMetallicConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetFuzzColorConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetEmissiveColorConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetCustomTwoSided(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomTranslucencyLightingMode(AttributeValue?: ETranslucencyLightingMode): {AttributeValue: ETranslucencyLightingMode, $: boolean};
	GetCustomShadingModel(AttributeValue?: EMaterialShadingModel): {AttributeValue: EMaterialShadingModel, $: boolean};
	GetCustomOpacityMaskClipValue(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomBlendMode(AttributeValue?: EBlendMode): {AttributeValue: EBlendMode, $: boolean};
	GetClothConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetClearCoatRoughnessConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetClearCoatNormalConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetClearCoatConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetBaseColorConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	GetAnisotropyConnection(ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	ConnectToTransmissionColor(AttributeValue: string): boolean;
	ConnectToTangent(ExpressionNodeUid: string): boolean;
	ConnectToSubsurface(ExpressionNodeUid: string): boolean;
	ConnectToSpecular(ExpressionNodeUid: string): boolean;
	ConnectToRoughness(ExpressionNodeUid: string): boolean;
	ConnectToRefraction(AttributeValue: string): boolean;
	ConnectToOpacity(AttributeValue: string): boolean;
	ConnectToOcclusion(AttributeValue: string): boolean;
	ConnectToNormal(ExpressionNodeUid: string): boolean;
	ConnectToMetallic(AttributeValue: string): boolean;
	ConnectToFuzzColor(AttributeValue: string): boolean;
	ConnectToEmissiveColor(ExpressionNodeUid: string): boolean;
	ConnectToCloth(AttributeValue: string): boolean;
	ConnectToClearCoatRoughness(AttributeValue: string): boolean;
	ConnectToClearCoatNormal(AttributeValue: string): boolean;
	ConnectToClearCoat(AttributeValue: string): boolean;
	ConnectToBaseColor(AttributeValue: string): boolean;
	ConnectToAnisotropy(ExpressionNodeUid: string): boolean;
	ConnectOutputToTransmissionColor(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToTangent(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToSubsurface(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToSpecular(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToRoughness(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToRefraction(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToOpacity(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToOcclusion(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToNormal(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToMetallic(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToFuzzColor(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToEmissiveColor(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToCloth(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToClearCoatRoughness(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToClearCoatNormal(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToClearCoat(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToBaseColor(ExpressionNodeUid: string,OutputName: string): boolean;
	ConnectOutputToAnisotropy(ExpressionNodeUid: string,OutputName: string): boolean;
	static C(Other: UObject | any): InterchangeMaterialFactoryNode;
}

declare class InterchangeMaterialExpressionFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeMaterialExpressionFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeMaterialExpressionFactoryNode;
	static GetDefaultObject(): InterchangeMaterialExpressionFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMaterialExpressionFactoryNode;
	SetCustomExpressionClassName(AttributeValue: string): boolean;
	GetCustomExpressionClassName(AttributeValue?: string): {AttributeValue: string, $: boolean};
	static C(Other: UObject | any): InterchangeMaterialExpressionFactoryNode;
}

declare class InterchangeMaterialInstanceFactoryNode extends InterchangeBaseMaterialFactoryNode { 
	static Load(ResourceName: string): InterchangeMaterialInstanceFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeMaterialInstanceFactoryNode;
	static GetDefaultObject(): InterchangeMaterialInstanceFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMaterialInstanceFactoryNode;
	SetCustomParent(AttributeValue: string): boolean;
	SetCustomInstanceClassName(AttributeValue: string): boolean;
	GetCustomParent(AttributeValue?: string): {AttributeValue: string, $: boolean};
	GetCustomInstanceClassName(AttributeValue?: string): {AttributeValue: string, $: boolean};
	static C(Other: UObject | any): InterchangeMaterialInstanceFactoryNode;
}

declare class InterchangeMaterialFunctionCallExpressionFactoryNode extends InterchangeMaterialExpressionFactoryNode { 
	static Load(ResourceName: string): InterchangeMaterialFunctionCallExpressionFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeMaterialFunctionCallExpressionFactoryNode;
	static GetDefaultObject(): InterchangeMaterialFunctionCallExpressionFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMaterialFunctionCallExpressionFactoryNode;
	SetCustomMaterialFunctionDependency(AttributeValue: string): boolean;
	GetCustomMaterialFunctionDependency(AttributeValue?: string): {AttributeValue: string, $: boolean};
	static C(Other: UObject | any): InterchangeMaterialFunctionCallExpressionFactoryNode;
}

declare class InterchangeMaterialFunctionFactoryNode extends InterchangeBaseMaterialFactoryNode { 
	static Load(ResourceName: string): InterchangeMaterialFunctionFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeMaterialFunctionFactoryNode;
	static GetDefaultObject(): InterchangeMaterialFunctionFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMaterialFunctionFactoryNode;
	GetObjectClass(): UnrealEngineClass;
	GetInputConnection(InputName: string,ExpressionNodeUid?: string,OutputName?: string): {ExpressionNodeUid: string, OutputName: string, $: boolean};
	static C(Other: UObject | any): InterchangeMaterialFunctionFactoryNode;
}

declare class InterchangeMeshActorFactoryNode extends InterchangeActorFactoryNode { 
	static Load(ResourceName: string): InterchangeMeshActorFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeMeshActorFactoryNode;
	static GetDefaultObject(): InterchangeMeshActorFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMeshActorFactoryNode;
	SetSlotMaterialDependencyUid(SlotName: string,MaterialDependencyUid: string): boolean;
	RemoveSlotMaterialDependencyUid(SlotName: string): boolean;
	GetSlotMaterialDependencyUid(SlotName: string,OutMaterialDependency?: string): {OutMaterialDependency: string, $: boolean};
	GetSlotMaterialDependencies(OutMaterialDependencies?: Map<string, string>): {OutMaterialDependencies: Map<string, string>};
	static C(Other: UObject | any): InterchangeMeshActorFactoryNode;
}

declare class InterchangeMeshFactoryNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeMeshFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeMeshFactoryNode;
	static GetDefaultObject(): InterchangeMeshFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMeshFactoryNode;
	SetSlotMaterialDependencyUid(SlotName: string,MaterialDependencyUid: string): boolean;
	SetCustomVertexColorReplace(AttributeValue: boolean): boolean;
	SetCustomVertexColorOverride(AttributeValue: Color): boolean;
	SetCustomVertexColorIgnore(AttributeValue: boolean): boolean;
	SetCustomUseMikkTSpace(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomUseHighPrecisionTangentBasis(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomUseFullPrecisionUVs(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomUseBackwardsCompatibleF16TruncUVs(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomRemoveDegenerates(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomRecomputeTangents(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomRecomputeNormals(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomComputeWeightedNormals(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	RemoveSlotMaterialDependencyUid(SlotName: string): boolean;
	RemoveLodDataUniqueId(LodDataUniqueId: string): boolean;
	GetSlotMaterialDependencyUid(SlotName: string,OutMaterialDependency?: string): {OutMaterialDependency: string, $: boolean};
	GetSlotMaterialDependencies(OutMaterialDependencies?: Map<string, string>): {OutMaterialDependencies: Map<string, string>};
	GetLodDataUniqueIds(OutLodDataUniqueIds?: string[]): {OutLodDataUniqueIds: string[]};
	GetLodDataCount(): number;
	GetCustomVertexColorReplace(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomVertexColorOverride(AttributeValue?: Color): {AttributeValue: Color, $: boolean};
	GetCustomVertexColorIgnore(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomUseMikkTSpace(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomUseHighPrecisionTangentBasis(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomUseFullPrecisionUVs(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomUseBackwardsCompatibleF16TruncUVs(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomRemoveDegenerates(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomRecomputeTangents(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomRecomputeNormals(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomComputeWeightedNormals(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	AddLodDataUniqueId(LodDataUniqueId: string): boolean;
	static C(Other: UObject | any): InterchangeMeshFactoryNode;
}

declare type EInterchangeSkeletalMeshContentType = 'All' | 'Geometry' | 'SkinningWeights' | 'MAX';
declare var EInterchangeSkeletalMeshContentType : { All:'All',Geometry:'Geometry',SkinningWeights:'SkinningWeights',MAX:'MAX', };
declare class InterchangeSkeletalMeshFactoryNode extends InterchangeMeshFactoryNode { 
	static Load(ResourceName: string): InterchangeSkeletalMeshFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSkeletalMeshFactoryNode;
	static GetDefaultObject(): InterchangeSkeletalMeshFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSkeletalMeshFactoryNode;
	SetCustomThresholdUV(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomThresholdTangentNormal(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomThresholdPosition(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomSkeletonSoftObjectPath(AttributeValue: SoftObjectPath): boolean;
	SetCustomPhysicAssetSoftObjectPath(AttributeValue: SoftObjectPath): boolean;
	SetCustomMorphThresholdPosition(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomImportMorphTarget(AttributeValue: boolean): boolean;
	SetCustomImportContentType(AttributeValue: EInterchangeSkeletalMeshContentType): boolean;
	SetCustomCreatePhysicsAsset(AttributeValue: boolean): boolean;
	InitializeSkeletalMeshNode(UniqueId: string,DisplayLabel: string,InAssetClass: string): void;
	GetObjectClass(): UnrealEngineClass;
	GetCustomThresholdUV(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomThresholdTangentNormal(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomThresholdPosition(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomSkeletonSoftObjectPath(AttributeValue?: SoftObjectPath): {AttributeValue: SoftObjectPath, $: boolean};
	GetCustomPhysicAssetSoftObjectPath(AttributeValue?: SoftObjectPath): {AttributeValue: SoftObjectPath, $: boolean};
	GetCustomMorphThresholdPosition(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomImportMorphTarget(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomImportContentType(AttributeValue?: EInterchangeSkeletalMeshContentType): {AttributeValue: EInterchangeSkeletalMeshContentType, $: boolean};
	GetCustomCreatePhysicsAsset(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	static C(Other: UObject | any): InterchangeSkeletalMeshFactoryNode;
}

declare class InterchangeSkeletalMeshLodDataNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeSkeletalMeshLodDataNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeSkeletalMeshLodDataNode;
	static GetDefaultObject(): InterchangeSkeletalMeshLodDataNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSkeletalMeshLodDataNode;
	SetCustomSkeletonUid(AttributeValue: string): boolean;
	RemoveMeshUid(MeshName: string): boolean;
	RemoveAllMeshes(): boolean;
	GetMeshUidsCount(): number;
	GetMeshUids(OutMeshNames?: string[]): {OutMeshNames: string[]};
	GetCustomSkeletonUid(AttributeValue?: string): {AttributeValue: string, $: boolean};
	AddMeshUid(MeshName: string): boolean;
	static C(Other: UObject | any): InterchangeSkeletalMeshLodDataNode;
}

declare class InterchangeStaticMeshFactoryNode extends InterchangeMeshFactoryNode { 
	static Load(ResourceName: string): InterchangeStaticMeshFactoryNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeStaticMeshFactoryNode;
	static GetDefaultObject(): InterchangeStaticMeshFactoryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeStaticMeshFactoryNode;
	SetCustomSupportFaceRemap(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomSrcLightmapIndex(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomMinLightmapResolution(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomMaxLumenMeshCards(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomGenerateLightmapUVs(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomGenerateDistanceFieldAsIfTwoSided(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomDstLightmapIndex(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomDistanceFieldResolutionScale(AttributeValue: number,bAddApplyDelegate: boolean): boolean;
	SetCustomDistanceFieldReplacementMesh(AttributeValue: SoftObjectPath,bAddApplyDelegate: boolean): boolean;
	SetCustomBuildScale3D(AttributeValue: Vector,bAddApplyDelegate: boolean): boolean;
	SetCustomBuildReversedIndexBuffer(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	SetCustomBuildNanite(AttributeValue: boolean,bAddApplyDelegate: boolean): boolean;
	RemoveSocketUd(SocketUid: string): boolean;
	InitializeStaticMeshNode(UniqueId: string,DisplayLabel: string,InAssetClass: string): void;
	GetSocketUids(OutSocketUids?: string[]): {OutSocketUids: string[]};
	GetSocketUidCount(): number;
	GetObjectClass(): UnrealEngineClass;
	GetCustomSupportFaceRemap(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomSrcLightmapIndex(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomMinLightmapResolution(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomMaxLumenMeshCards(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomGenerateLightmapUVs(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomGenerateDistanceFieldAsIfTwoSided(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomDstLightmapIndex(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomDistanceFieldResolutionScale(AttributeValue?: number): {AttributeValue: number, $: boolean};
	GetCustomDistanceFieldReplacementMesh(AttributeValue?: SoftObjectPath): {AttributeValue: SoftObjectPath, $: boolean};
	GetCustomBuildScale3D(AttributeValue?: Vector): {AttributeValue: Vector, $: boolean};
	GetCustomBuildReversedIndexBuffer(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetCustomBuildNanite(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	AddSocketUids(InSocketUids: string[]): boolean;
	AddSocketUid(SocketUid: string): boolean;
	static C(Other: UObject | any): InterchangeStaticMeshFactoryNode;
}

declare class InterchangeStaticMeshLodDataNode extends InterchangeFactoryBaseNode { 
	static Load(ResourceName: string): InterchangeStaticMeshLodDataNode;
	static Find(Outer: UObject, ResourceName: string): InterchangeStaticMeshLodDataNode;
	static GetDefaultObject(): InterchangeStaticMeshLodDataNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeStaticMeshLodDataNode;
	SetOneConvexHullPerUCX(AttributeValue: boolean): boolean;
	RemoveSphereCollisionMeshUid(MeshName: string): boolean;
	RemoveMeshUid(MeshName: string): boolean;
	RemoveConvexCollisionMeshUid(MeshName: string): boolean;
	RemoveCapsuleCollisionMeshUid(MeshName: string): boolean;
	RemoveBoxCollisionMeshUid(MeshName: string): boolean;
	RemoveAllSphereCollisionMeshes(): boolean;
	RemoveAllMeshes(): boolean;
	RemoveAllConvexCollisionMeshes(): boolean;
	RemoveAllCapsuleCollisionMeshes(): boolean;
	RemoveAllBoxCollisionMeshes(): boolean;
	GetSphereCollisionMeshUidsCount(): number;
	GetSphereCollisionMeshUids(OutMeshNames?: string[]): {OutMeshNames: string[]};
	GetOneConvexHullPerUCX(AttributeValue?: boolean): {AttributeValue: boolean, $: boolean};
	GetMeshUidsCount(): number;
	GetMeshUids(OutMeshNames?: string[]): {OutMeshNames: string[]};
	GetConvexCollisionMeshUidsCount(): number;
	GetConvexCollisionMeshUids(OutMeshNames?: string[]): {OutMeshNames: string[]};
	GetCapsuleCollisionMeshUidsCount(): number;
	GetCapsuleCollisionMeshUids(OutMeshNames?: string[]): {OutMeshNames: string[]};
	GetBoxCollisionMeshUidsCount(): number;
	GetBoxCollisionMeshUids(OutMeshNames?: string[]): {OutMeshNames: string[]};
	AddSphereCollisionMeshUid(MeshName: string): boolean;
	AddMeshUid(MeshName: string): boolean;
	AddConvexCollisionMeshUid(MeshName: string): boolean;
	AddCapsuleCollisionMeshUid(MeshName: string): boolean;
	AddBoxCollisionMeshUid(MeshName: string): boolean;
	static C(Other: UObject | any): InterchangeStaticMeshLodDataNode;
}

declare class InterchangeAnimationPayloadInterface extends Interface { 
	static Load(ResourceName: string): InterchangeAnimationPayloadInterface;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimationPayloadInterface;
	static GetDefaultObject(): InterchangeAnimationPayloadInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimationPayloadInterface;
	static C(Other: UObject | any): InterchangeAnimationPayloadInterface;
}

declare class InterchangeAnimationTrackSetFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeAnimationTrackSetFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimationTrackSetFactory;
	static GetDefaultObject(): InterchangeAnimationTrackSetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimationTrackSetFactory;
	static C(Other: UObject | any): InterchangeAnimationTrackSetFactory;
}

declare class InterchangeBlockedTexturePayloadInterface extends Interface { 
	static Load(ResourceName: string): InterchangeBlockedTexturePayloadInterface;
	static Find(Outer: UObject, ResourceName: string): InterchangeBlockedTexturePayloadInterface;
	static GetDefaultObject(): InterchangeBlockedTexturePayloadInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeBlockedTexturePayloadInterface;
	static C(Other: UObject | any): InterchangeBlockedTexturePayloadInterface;
}

declare class InterchangeLightActorFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeLightActorFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeLightActorFactory;
	static GetDefaultObject(): InterchangeLightActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeLightActorFactory;
	static C(Other: UObject | any): InterchangeLightActorFactory;
}

declare class InterchangeSceneVariantSetsFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeSceneVariantSetsFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeSceneVariantSetsFactory;
	static GetDefaultObject(): InterchangeSceneVariantSetsFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSceneVariantSetsFactory;
	static C(Other: UObject | any): InterchangeSceneVariantSetsFactory;
}

declare class InterchangeSkeletalMeshPayloadInterface extends Interface { 
	static Load(ResourceName: string): InterchangeSkeletalMeshPayloadInterface;
	static Find(Outer: UObject, ResourceName: string): InterchangeSkeletalMeshPayloadInterface;
	static GetDefaultObject(): InterchangeSkeletalMeshPayloadInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSkeletalMeshPayloadInterface;
	static C(Other: UObject | any): InterchangeSkeletalMeshPayloadInterface;
}

declare class InterchangeSlicedTexturePayloadInterface extends Interface { 
	static Load(ResourceName: string): InterchangeSlicedTexturePayloadInterface;
	static Find(Outer: UObject, ResourceName: string): InterchangeSlicedTexturePayloadInterface;
	static GetDefaultObject(): InterchangeSlicedTexturePayloadInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSlicedTexturePayloadInterface;
	static C(Other: UObject | any): InterchangeSlicedTexturePayloadInterface;
}

declare class InterchangeStaticMeshPayloadInterface extends Interface { 
	static Load(ResourceName: string): InterchangeStaticMeshPayloadInterface;
	static Find(Outer: UObject, ResourceName: string): InterchangeStaticMeshPayloadInterface;
	static GetDefaultObject(): InterchangeStaticMeshPayloadInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeStaticMeshPayloadInterface;
	static C(Other: UObject | any): InterchangeStaticMeshPayloadInterface;
}

declare class InterchangeTextureLightProfilePayloadInterface extends Interface { 
	static Load(ResourceName: string): InterchangeTextureLightProfilePayloadInterface;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureLightProfilePayloadInterface;
	static GetDefaultObject(): InterchangeTextureLightProfilePayloadInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureLightProfilePayloadInterface;
	static C(Other: UObject | any): InterchangeTextureLightProfilePayloadInterface;
}

declare class InterchangeTexturePayloadInterface extends Interface { 
	static Load(ResourceName: string): InterchangeTexturePayloadInterface;
	static Find(Outer: UObject, ResourceName: string): InterchangeTexturePayloadInterface;
	static GetDefaultObject(): InterchangeTexturePayloadInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTexturePayloadInterface;
	static C(Other: UObject | any): InterchangeTexturePayloadInterface;
}

declare class InterchangeVariantSetPayloadInterface extends Interface { 
	static Load(ResourceName: string): InterchangeVariantSetPayloadInterface;
	static Find(Outer: UObject, ResourceName: string): InterchangeVariantSetPayloadInterface;
	static GetDefaultObject(): InterchangeVariantSetPayloadInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeVariantSetPayloadInterface;
	static C(Other: UObject | any): InterchangeVariantSetPayloadInterface;
}

declare class MaterialExpressionAppend3Vector extends MaterialExpression { 
	A: ExpressionInput;
	B: ExpressionInput;
	C: ExpressionInput;
	static Load(ResourceName: string): MaterialExpressionAppend3Vector;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionAppend3Vector;
	static GetDefaultObject(): MaterialExpressionAppend3Vector;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionAppend3Vector;
	static C(Other: UObject | any): MaterialExpressionAppend3Vector;
}

declare class MaterialExpressionAppend4Vector extends MaterialExpression { 
	A: ExpressionInput;
	B: ExpressionInput;
	C: ExpressionInput;
	D: ExpressionInput;
	static Load(ResourceName: string): MaterialExpressionAppend4Vector;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionAppend4Vector;
	static GetDefaultObject(): MaterialExpressionAppend4Vector;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionAppend4Vector;
	static C(Other: UObject | any): MaterialExpressionAppend4Vector;
}

declare class MaterialExpressionExponential extends MaterialExpression { 
	Input: ExpressionInput;
	static Load(ResourceName: string): MaterialExpressionExponential;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionExponential;
	static GetDefaultObject(): MaterialExpressionExponential;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionExponential;
	static C(Other: UObject | any): MaterialExpressionExponential;
}

declare class MaterialExpressionHsvToRgb extends MaterialExpression { 
	Input: ExpressionInput;
	static Load(ResourceName: string): MaterialExpressionHsvToRgb;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionHsvToRgb;
	static GetDefaultObject(): MaterialExpressionHsvToRgb;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionHsvToRgb;
	static C(Other: UObject | any): MaterialExpressionHsvToRgb;
}

declare class MaterialExpressionLength extends MaterialExpression { 
	Input: ExpressionInput;
	static Load(ResourceName: string): MaterialExpressionLength;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionLength;
	static GetDefaultObject(): MaterialExpressionLength;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionLength;
	static C(Other: UObject | any): MaterialExpressionLength;
}

declare class MaterialExpressionLogarithm extends MaterialExpression { 
	Input: ExpressionInput;
	static Load(ResourceName: string): MaterialExpressionLogarithm;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionLogarithm;
	static GetDefaultObject(): MaterialExpressionLogarithm;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionLogarithm;
	static C(Other: UObject | any): MaterialExpressionLogarithm;
}

declare type ELuminanceMode = 'ACEScg' | 'Rec709' | 'Rec2020' | 'Rec2100' | 'Custom' | 'ELuminanceMode_MAX';
declare var ELuminanceMode : { ACEScg:'ACEScg',Rec709:'Rec709',Rec2020:'Rec2020',Rec2100:'Rec2100',Custom:'Custom',ELuminanceMode_MAX:'ELuminanceMode_MAX', };
declare class MaterialExpressionLuminance extends MaterialExpression { 
	Input: ExpressionInput;
	LuminanceFactors: LinearColor;
	LuminanceMode: ELuminanceMode;
	static Load(ResourceName: string): MaterialExpressionLuminance;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionLuminance;
	static GetDefaultObject(): MaterialExpressionLuminance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionLuminance;
	static C(Other: UObject | any): MaterialExpressionLuminance;
}

declare class MaterialExpressionRampLeftRight extends MaterialExpression { 
	Coordinates: ExpressionInput;
	A: ExpressionInput;
	B: ExpressionInput;
	ConstCoordinate: number;
	static Load(ResourceName: string): MaterialExpressionRampLeftRight;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionRampLeftRight;
	static GetDefaultObject(): MaterialExpressionRampLeftRight;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionRampLeftRight;
	static C(Other: UObject | any): MaterialExpressionRampLeftRight;
}

declare class MaterialExpressionRampTopBottom extends MaterialExpression { 
	Coordinates: ExpressionInput;
	A: ExpressionInput;
	B: ExpressionInput;
	ConstCoordinate: number;
	static Load(ResourceName: string): MaterialExpressionRampTopBottom;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionRampTopBottom;
	static GetDefaultObject(): MaterialExpressionRampTopBottom;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionRampTopBottom;
	static C(Other: UObject | any): MaterialExpressionRampTopBottom;
}

declare class MaterialExpressionRemap extends MaterialExpression { 
	Input: ExpressionInput;
	InputLow: ExpressionInput;
	InputHigh: ExpressionInput;
	TargetLow: ExpressionInput;
	TargetHigh: ExpressionInput;
	InputLowDefault: number;
	InputHighDefault: number;
	TargetLowDefault: number;
	TargetHighDefault: number;
	static Load(ResourceName: string): MaterialExpressionRemap;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionRemap;
	static GetDefaultObject(): MaterialExpressionRemap;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionRemap;
	static C(Other: UObject | any): MaterialExpressionRemap;
}

declare class MaterialExpressionRgbToHsv extends MaterialExpression { 
	Input: ExpressionInput;
	static Load(ResourceName: string): MaterialExpressionRgbToHsv;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionRgbToHsv;
	static GetDefaultObject(): MaterialExpressionRgbToHsv;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionRgbToHsv;
	static C(Other: UObject | any): MaterialExpressionRgbToHsv;
}

declare class MaterialExpressionSplitLeftRight extends MaterialExpression { 
	Coordinates: ExpressionInput;
	A: ExpressionInput;
	B: ExpressionInput;
	Center: ExpressionInput;
	ConstCenter: number;
	ConstCoordinate: number;
	static Load(ResourceName: string): MaterialExpressionSplitLeftRight;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionSplitLeftRight;
	static GetDefaultObject(): MaterialExpressionSplitLeftRight;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionSplitLeftRight;
	static C(Other: UObject | any): MaterialExpressionSplitLeftRight;
}

declare class MaterialExpressionSplitTopBottom extends MaterialExpression { 
	Coordinates: ExpressionInput;
	A: ExpressionInput;
	B: ExpressionInput;
	Center: ExpressionInput;
	ConstCenter: number;
	ConstCoordinate: number;
	static Load(ResourceName: string): MaterialExpressionSplitTopBottom;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionSplitTopBottom;
	static GetDefaultObject(): MaterialExpressionSplitTopBottom;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionSplitTopBottom;
	static C(Other: UObject | any): MaterialExpressionSplitTopBottom;
}

declare class InterchangeAnimSequenceFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeAnimSequenceFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeAnimSequenceFactory;
	static GetDefaultObject(): InterchangeAnimSequenceFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeAnimSequenceFactory;
	static C(Other: UObject | any): InterchangeAnimSequenceFactory;
}

declare class InterchangeFbxTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangeFbxTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangeFbxTranslator;
	static GetDefaultObject(): InterchangeFbxTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeFbxTranslator;
	static C(Other: UObject | any): InterchangeFbxTranslator;
}

declare class InterchangeGltfTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangeGltfTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangeGltfTranslator;
	static GetDefaultObject(): InterchangeGltfTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGltfTranslator;
	static C(Other: UObject | any): InterchangeGltfTranslator;
}

declare class InterchangeMaterialXTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangeMaterialXTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangeMaterialXTranslator;
	static GetDefaultObject(): InterchangeMaterialXTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMaterialXTranslator;
	static C(Other: UObject | any): InterchangeMaterialXTranslator;
}

declare class InterchangeMaterialFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeMaterialFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeMaterialFactory;
	static GetDefaultObject(): InterchangeMaterialFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMaterialFactory;
	static C(Other: UObject | any): InterchangeMaterialFactory;
}

declare class InterchangeMaterialFunctionFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeMaterialFunctionFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeMaterialFunctionFactory;
	static GetDefaultObject(): InterchangeMaterialFunctionFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeMaterialFunctionFactory;
	static C(Other: UObject | any): InterchangeMaterialFunctionFactory;
}

declare class InterchangeOBJTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangeOBJTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangeOBJTranslator;
	static GetDefaultObject(): InterchangeOBJTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeOBJTranslator;
	static C(Other: UObject | any): InterchangeOBJTranslator;
}

declare class InterchangePhysicsAssetFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangePhysicsAssetFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangePhysicsAssetFactory;
	static GetDefaultObject(): InterchangePhysicsAssetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangePhysicsAssetFactory;
	static C(Other: UObject | any): InterchangePhysicsAssetFactory;
}

declare class InterchangeSkeletalMeshFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeSkeletalMeshFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeSkeletalMeshFactory;
	static GetDefaultObject(): InterchangeSkeletalMeshFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSkeletalMeshFactory;
	static C(Other: UObject | any): InterchangeSkeletalMeshFactory;
}

declare class InterchangeSkeletonFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeSkeletonFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeSkeletonFactory;
	static GetDefaultObject(): InterchangeSkeletonFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSkeletonFactory;
	static C(Other: UObject | any): InterchangeSkeletonFactory;
}

declare class InterchangeStaticMeshFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeStaticMeshFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeStaticMeshFactory;
	static GetDefaultObject(): InterchangeStaticMeshFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeStaticMeshFactory;
	static C(Other: UObject | any): InterchangeStaticMeshFactory;
}

declare class InterchangeActorFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeActorFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeActorFactory;
	static GetDefaultObject(): InterchangeActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeActorFactory;
	static C(Other: UObject | any): InterchangeActorFactory;
}

declare class InterchangeCineCameraActorFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeCineCameraActorFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeCineCameraActorFactory;
	static GetDefaultObject(): InterchangeCineCameraActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeCineCameraActorFactory;
	static C(Other: UObject | any): InterchangeCineCameraActorFactory;
}

declare class InterchangeSkeletalMeshActorFactory extends InterchangeActorFactory { 
	static Load(ResourceName: string): InterchangeSkeletalMeshActorFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeSkeletalMeshActorFactory;
	static GetDefaultObject(): InterchangeSkeletalMeshActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeSkeletalMeshActorFactory;
	static C(Other: UObject | any): InterchangeSkeletalMeshActorFactory;
}

declare class InterchangeStaticMeshActorFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeStaticMeshActorFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeStaticMeshActorFactory;
	static GetDefaultObject(): InterchangeStaticMeshActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeStaticMeshActorFactory;
	static C(Other: UObject | any): InterchangeStaticMeshActorFactory;
}

declare class InterchangeDDSTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangeDDSTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangeDDSTranslator;
	static GetDefaultObject(): InterchangeDDSTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeDDSTranslator;
	static C(Other: UObject | any): InterchangeDDSTranslator;
}

declare class InterchangeIESTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangeIESTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangeIESTranslator;
	static GetDefaultObject(): InterchangeIESTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeIESTranslator;
	static C(Other: UObject | any): InterchangeIESTranslator;
}

declare class InterchangeImageWrapperTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangeImageWrapperTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangeImageWrapperTranslator;
	static GetDefaultObject(): InterchangeImageWrapperTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeImageWrapperTranslator;
	static C(Other: UObject | any): InterchangeImageWrapperTranslator;
}

declare class InterchangeJPGTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangeJPGTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangeJPGTranslator;
	static GetDefaultObject(): InterchangeJPGTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeJPGTranslator;
	static C(Other: UObject | any): InterchangeJPGTranslator;
}

declare class InterchangePCXTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangePCXTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangePCXTranslator;
	static GetDefaultObject(): InterchangePCXTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangePCXTranslator;
	static C(Other: UObject | any): InterchangePCXTranslator;
}

declare class InterchangePSDTranslator extends InterchangeTranslatorBase { 
	static Load(ResourceName: string): InterchangePSDTranslator;
	static Find(Outer: UObject, ResourceName: string): InterchangePSDTranslator;
	static GetDefaultObject(): InterchangePSDTranslator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangePSDTranslator;
	static C(Other: UObject | any): InterchangePSDTranslator;
}

declare class InterchangeTextureFactory extends InterchangeFactoryBase { 
	static Load(ResourceName: string): InterchangeTextureFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeTextureFactory;
	static GetDefaultObject(): InterchangeTextureFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeTextureFactory;
	static C(Other: UObject | any): InterchangeTextureFactory;
}

declare type EInterchangeForceMeshType = 'IFMT_None' | 'IFMT_StaticMesh' | 'IFMT_SkeletalMesh' | 'IFMT_MAX';
declare var EInterchangeForceMeshType : { IFMT_None:'IFMT_None',IFMT_StaticMesh:'IFMT_StaticMesh',IFMT_SkeletalMesh:'IFMT_SkeletalMesh',IFMT_MAX:'IFMT_MAX', };
declare type EInterchangeVertexColorImportOption = 'IVCIO_Replace' | 'IVCIO_Ignore' | 'IVCIO_Override' | 'IVCIO_MAX';
declare var EInterchangeVertexColorImportOption : { IVCIO_Replace:'IVCIO_Replace',IVCIO_Ignore:'IVCIO_Ignore',IVCIO_Override:'IVCIO_Override',IVCIO_MAX:'IVCIO_MAX', };
declare class InterchangeGenericCommonMeshesProperties extends InterchangePipelineBase { 
	ForceAllMeshAsType: EInterchangeForceMeshType;
	bImportLods: boolean;
	bBakeMeshes: boolean;
	VertexColorImportOption: EInterchangeVertexColorImportOption;
	VertexOverrideColor: Color;
	bRecomputeNormals: boolean;
	bRecomputeTangents: boolean;
	bUseMikkTSpace: boolean;
	bComputeWeightedNormals: boolean;
	bUseHighPrecisionTangentBasis: boolean;
	bUseFullPrecisionUVs: boolean;
	bUseBackwardsCompatibleF16TruncUVs: boolean;
	bRemoveDegenerates: boolean;
	static Load(ResourceName: string): InterchangeGenericCommonMeshesProperties;
	static Find(Outer: UObject, ResourceName: string): InterchangeGenericCommonMeshesProperties;
	static GetDefaultObject(): InterchangeGenericCommonMeshesProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGenericCommonMeshesProperties;
	static C(Other: UObject | any): InterchangeGenericCommonMeshesProperties;
}

declare class InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties extends InterchangePipelineBase { 
	bImportOnlyAnimations: boolean;
	Skeleton: Skeleton;
	bImportMeshesInBoneHierarchy: boolean;
	bUseT0AsRefPose: boolean;
	static Load(ResourceName: string): InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties;
	static Find(Outer: UObject, ResourceName: string): InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties;
	static GetDefaultObject(): InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties;
	static C(Other: UObject | any): InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties;
}

declare type EInterchangeAnimationRange = 'Timeline' | 'Animated' | 'SetRange' | 'MAX';
declare var EInterchangeAnimationRange : { Timeline:'Timeline',Animated:'Animated',SetRange:'SetRange',MAX:'MAX', };
declare class InterchangeGenericAnimationPipeline extends InterchangePipelineBase { 
	CommonSkeletalMeshesAndAnimationsProperties: InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties;
	bImportAnimations: boolean;
	bImportBoneTracks: boolean;
	AnimationRange: EInterchangeAnimationRange;
	FrameImportRange: Int32Interval;
	bUse30HzToBakeBoneAnimation: boolean;
	CustomBoneAnimationSampleRate: number;
	bSnapToClosestFrameBoundary: boolean;
	bImportCustomAttribute: boolean;
	bSetMaterialDriveParameterOnCustomAttribute: boolean;
	MaterialCurveSuffixes: string[];
	bRemoveCurveRedundantKeys: boolean;
	bDoNotImportCurveWithZero: boolean;
	bDeleteExistingNonCurveCustomAttributes: boolean;
	bDeleteExistingCustomAttributeCurves: boolean;
	bDeleteExistingMorphTargetCurves: boolean;
	SourceAnimationName: string;
	static Load(ResourceName: string): InterchangeGenericAnimationPipeline;
	static Find(Outer: UObject, ResourceName: string): InterchangeGenericAnimationPipeline;
	static GetDefaultObject(): InterchangeGenericAnimationPipeline;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGenericAnimationPipeline;
	static C(Other: UObject | any): InterchangeGenericAnimationPipeline;
}

declare class InterchangeGenericMeshPipeline extends InterchangePipelineBase { 
	CommonMeshesProperties: InterchangeGenericCommonMeshesProperties;
	CommonSkeletalMeshesAndAnimationsProperties: InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties;
	bImportStaticMeshes: boolean;
	bCombineStaticMeshes: boolean;
	bImportCollisionAccordingToMeshName: boolean;
	bOneConvexHullPerUCX: boolean;
	bBuildNanite: boolean;
	bBuildReversedIndexBuffer: boolean;
	bGenerateLightmapUVs: boolean;
	bGenerateDistanceFieldAsIfTwoSided: boolean;
	bSupportFaceRemap: boolean;
	MinLightmapResolution: number;
	SrcLightmapIndex: number;
	DstLightmapIndex: number;
	BuildScale3D: Vector;
	DistanceFieldResolutionScale: number;
	DistanceFieldReplacementMesh: StaticMesh;
	MaxLumenMeshCards: number;
	bImportSkeletalMeshes: boolean;
	SkeletalMeshImportContentType: EInterchangeSkeletalMeshContentType;
	LastSkeletalMeshImportContentType: EInterchangeSkeletalMeshContentType;
	bCombineSkeletalMeshes: boolean;
	bImportMorphTargets: boolean;
	bUpdateSkeletonReferencePose: boolean;
	bCreatePhysicsAsset: boolean;
	PhysicsAsset: PhysicsAsset;
	ThresholdPosition: number;
	ThresholdTangentNormal: number;
	ThresholdUV: number;
	MorphThresholdPosition: number;
	static Load(ResourceName: string): InterchangeGenericMeshPipeline;
	static Find(Outer: UObject, ResourceName: string): InterchangeGenericMeshPipeline;
	static GetDefaultObject(): InterchangeGenericMeshPipeline;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGenericMeshPipeline;
	static C(Other: UObject | any): InterchangeGenericMeshPipeline;
}

declare type EInterchangeMaterialImportOption = 'ImportAsMaterials' | 'ImportAsMaterialInstances' | 'EInterchangeMaterialImportOption_MAX';
declare var EInterchangeMaterialImportOption : { ImportAsMaterials:'ImportAsMaterials',ImportAsMaterialInstances:'ImportAsMaterialInstances',EInterchangeMaterialImportOption_MAX:'EInterchangeMaterialImportOption_MAX', };
declare class InterchangeGenericTexturePipeline extends InterchangePipelineBase { 
	bImportTextures: boolean;
	bDetectNormalMapTexture: boolean;
	bFlipNormalMapGreenChannel: boolean;
	bImportUDIMs: boolean;
	FileExtensionsToImportAsLongLatCubemap: Set<string>;
	bPreferCompressedSourceData: boolean;
	bAllowNonPowerOfTwo: boolean;
	BaseNodeContainer: InterchangeBaseNodeContainer;
	static Load(ResourceName: string): InterchangeGenericTexturePipeline;
	static Find(Outer: UObject, ResourceName: string): InterchangeGenericTexturePipeline;
	static GetDefaultObject(): InterchangeGenericTexturePipeline;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGenericTexturePipeline;
	static C(Other: UObject | any): InterchangeGenericTexturePipeline;
}

declare class InterchangeGenericMaterialPipeline extends InterchangePipelineBase { 
	bImportMaterials: boolean;
	MaterialImport: EInterchangeMaterialImportOption;
	ParentMaterial: SoftObjectPath;
	TexturePipeline: InterchangeGenericTexturePipeline;
	BaseNodeContainer: InterchangeBaseNodeContainer;
	static Load(ResourceName: string): InterchangeGenericMaterialPipeline;
	static Find(Outer: UObject, ResourceName: string): InterchangeGenericMaterialPipeline;
	static GetDefaultObject(): InterchangeGenericMaterialPipeline;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGenericMaterialPipeline;
	static C(Other: UObject | any): InterchangeGenericMaterialPipeline;
}

declare class InterchangeGenericAssetsPipeline extends InterchangePipelineBase { 
	ReimportStrategy: EReimportStrategyFlags;
	bUseSourceNameForAsset: boolean;
	ImportOffsetTranslation: Vector;
	ImportOffsetRotation: Rotator;
	ImportOffsetUniformScale: number;
	CommonMeshesProperties: InterchangeGenericCommonMeshesProperties;
	CommonSkeletalMeshesAndAnimationsProperties: InterchangeGenericCommonSkeletalMeshesAndAnimationsProperties;
	MeshPipeline: InterchangeGenericMeshPipeline;
	AnimationPipeline: InterchangeGenericAnimationPipeline;
	MaterialPipeline: InterchangeGenericMaterialPipeline;
	static Load(ResourceName: string): InterchangeGenericAssetsPipeline;
	static Find(Outer: UObject, ResourceName: string): InterchangeGenericAssetsPipeline;
	static GetDefaultObject(): InterchangeGenericAssetsPipeline;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGenericAssetsPipeline;
	static C(Other: UObject | any): InterchangeGenericAssetsPipeline;
}

declare class InterchangeGenericLevelPipeline extends InterchangePipelineBase { 
	static Load(ResourceName: string): InterchangeGenericLevelPipeline;
	static Find(Outer: UObject, ResourceName: string): InterchangeGenericLevelPipeline;
	static GetDefaultObject(): InterchangeGenericLevelPipeline;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeGenericLevelPipeline;
	static C(Other: UObject | any): InterchangeGenericLevelPipeline;
}

declare class InterchangeLodSceneNodeContainer { 
	SceneNodes: InterchangeSceneNode[];
	clone() : InterchangeLodSceneNodeContainer;
	static C(Other: UObject | any): InterchangeLodSceneNodeContainer;
}

declare class InterchangeMeshInstance { 
	MeshInstanceUid: string;
	LodGroupNode: InterchangeSceneNode;
	bReferenceSkinnedMesh: boolean;
	bReferenceMorphTarget: boolean;
	SceneNodePerLodIndex: Map<number, InterchangeLodSceneNodeContainer>;
	ReferencingMeshGeometryUids: string[];
	clone() : InterchangeMeshInstance;
	static C(Other: UObject | any): InterchangeMeshInstance;
}

declare class InterchangeMeshGeometry { 
	MeshUid: string;
	MeshNode: InterchangeMeshNode;
	ReferencingMeshInstanceUids: string[];
	AttachedSocketUids: string[];
	clone() : InterchangeMeshGeometry;
	static C(Other: UObject | any): InterchangeMeshGeometry;
}

declare class InterchangePipelineMeshesUtilities extends UObject { 
	static Load(ResourceName: string): InterchangePipelineMeshesUtilities;
	static Find(Outer: UObject, ResourceName: string): InterchangePipelineMeshesUtilities;
	static GetDefaultObject(): InterchangePipelineMeshesUtilities;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangePipelineMeshesUtilities;
	IsValidMeshInstanceUid(MeshInstanceUid: string): boolean;
	IsValidMeshGeometryUid(MeshGeometryUid: string): boolean;
	GetMeshInstanceSkeletonRootUid(MeshInstanceUid: string): string;
	GetMeshInstanceByUid(MeshInstanceUid: string): InterchangeMeshInstance;
	GetMeshGeometrySkeletonRootUid(MeshGeometryUid: string): string;
	GetMeshGeometryByUid(MeshGeometryUid: string): InterchangeMeshGeometry;
	GetAllStaticMeshInstance(MeshInstanceUids?: string[],bConvertSkeletalMeshToStaticMesh?: boolean): {MeshInstanceUids: string[]};
	GetAllStaticMeshGeometry(MeshGeometryUids?: string[],bConvertSkeletalMeshToStaticMesh?: boolean): {MeshGeometryUids: string[]};
	GetAllSkinnedMeshInstance(MeshInstanceUids?: string[],bConvertStaticMeshToSkeletalMesh?: boolean): {MeshInstanceUids: string[]};
	GetAllSkinnedMeshGeometry(MeshGeometryUids?: string[]): {MeshGeometryUids: string[]};
	GetAllMeshInstanceUidsUsingMeshGeometryUid(MeshGeometryUid: string,MeshInstanceUids?: string[]): {MeshInstanceUids: string[]};
	GetAllMeshInstanceUids(MeshInstanceUids?: string[]): {MeshInstanceUids: string[]};
	GetAllMeshGeometryNotInstanced(MeshGeometryUids?: string[]): {MeshGeometryUids: string[]};
	GetAllMeshGeometry(MeshGeometryUids?: string[]): {MeshGeometryUids: string[]};
	static CreateInterchangePipelineMeshesUtilities(BaseNodeContainer: InterchangeBaseNodeContainer): InterchangePipelineMeshesUtilities;
	static C(Other: UObject | any): InterchangePipelineMeshesUtilities;
}

declare class MeshPaintingSubsystem extends EngineSubsystem { 
	static Load(ResourceName: string): MeshPaintingSubsystem;
	static Find(Outer: UObject, ResourceName: string): MeshPaintingSubsystem;
	static GetDefaultObject(): MeshPaintingSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshPaintingSubsystem;
	static C(Other: UObject | any): MeshPaintingSubsystem;
}

declare class MeshPaintSelectionInterface extends Interface { 
	static Load(ResourceName: string): MeshPaintSelectionInterface;
	static Find(Outer: UObject, ResourceName: string): MeshPaintSelectionInterface;
	static GetDefaultObject(): MeshPaintSelectionInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshPaintSelectionInterface;
	static C(Other: UObject | any): MeshPaintSelectionInterface;
}

declare class MeshPaintSelectionMechanic extends InteractionMechanic { 
	CachedClickedComponents: MeshComponent[];
	CachedClickedActors: Actor[];
	static Load(ResourceName: string): MeshPaintSelectionMechanic;
	static Find(Outer: UObject, ResourceName: string): MeshPaintSelectionMechanic;
	static GetDefaultObject(): MeshPaintSelectionMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshPaintSelectionMechanic;
	static C(Other: UObject | any): MeshPaintSelectionMechanic;
}

declare class VertexAdapterClickToolBuilder extends SingleClickToolBuilder { 
	static Load(ResourceName: string): VertexAdapterClickToolBuilder;
	static Find(Outer: UObject, ResourceName: string): VertexAdapterClickToolBuilder;
	static GetDefaultObject(): VertexAdapterClickToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VertexAdapterClickToolBuilder;
	static C(Other: UObject | any): VertexAdapterClickToolBuilder;
}

declare class TextureAdapterClickToolBuilder extends SingleClickToolBuilder { 
	static Load(ResourceName: string): TextureAdapterClickToolBuilder;
	static Find(Outer: UObject, ResourceName: string): TextureAdapterClickToolBuilder;
	static GetDefaultObject(): TextureAdapterClickToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextureAdapterClickToolBuilder;
	static C(Other: UObject | any): TextureAdapterClickToolBuilder;
}

declare class MeshClickTool extends SingleClickTool { 
	SelectionMechanic: MeshPaintSelectionMechanic;
	static Load(ResourceName: string): MeshClickTool;
	static Find(Outer: UObject, ResourceName: string): MeshClickTool;
	static GetDefaultObject(): MeshClickTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshClickTool;
	static C(Other: UObject | any): MeshClickTool;
}

declare class VertexAdapterClickTool extends MeshClickTool { 
	static Load(ResourceName: string): VertexAdapterClickTool;
	static Find(Outer: UObject, ResourceName: string): VertexAdapterClickTool;
	static GetDefaultObject(): VertexAdapterClickTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VertexAdapterClickTool;
	static C(Other: UObject | any): VertexAdapterClickTool;
}

declare class TextureAdapterClickTool extends MeshClickTool { 
	static Load(ResourceName: string): TextureAdapterClickTool;
	static Find(Outer: UObject, ResourceName: string): TextureAdapterClickTool;
	static GetDefaultObject(): TextureAdapterClickTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextureAdapterClickTool;
	static C(Other: UObject | any): TextureAdapterClickTool;
}

declare class MeshTexturePaintingToolBuilder extends InteractiveToolBuilder { 
	static Load(ResourceName: string): MeshTexturePaintingToolBuilder;
	static Find(Outer: UObject, ResourceName: string): MeshTexturePaintingToolBuilder;
	static GetDefaultObject(): MeshTexturePaintingToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshTexturePaintingToolBuilder;
	static C(Other: UObject | any): MeshTexturePaintingToolBuilder;
}

declare class MeshTexturePaintingToolProperties extends BrushBaseProperties { 
	PaintColor: LinearColor;
	EraseColor: LinearColor;
	bWriteRed: boolean;
	bWriteGreen: boolean;
	bWriteBlue: boolean;
	bWriteAlpha: boolean;
	UVChannel: number;
	bEnableSeamPainting: boolean;
	PaintTexture: Texture2D;
	bEnableFlow: boolean;
	bOnlyFrontFacingTriangles: boolean;
	static Load(ResourceName: string): MeshTexturePaintingToolProperties;
	static Find(Outer: UObject, ResourceName: string): MeshTexturePaintingToolProperties;
	static GetDefaultObject(): MeshTexturePaintingToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshTexturePaintingToolProperties;
	static C(Other: UObject | any): MeshTexturePaintingToolProperties;
}

declare class PaintTexture2DData { 
	PaintingTexture2D: Texture2D;
	PaintingTexture2DDuplicate: Texture2D;
	PaintRenderTargetTexture: TextureRenderTarget2D;
	CloneRenderTargetTexture: TextureRenderTarget2D;
	PaintingMaterials: MaterialInterface[];
	clone() : PaintTexture2DData;
	static C(Other: UObject | any): PaintTexture2DData;
}

declare class MeshTexturePaintingTool extends BaseBrushTool { 
	SelectionMechanic: MeshPaintSelectionMechanic;
	TextureProperties: MeshTexturePaintingToolProperties;
	Textures: Texture[];
	BrushRenderTargetTexture: TextureRenderTarget2D;
	BrushMaskRenderTargetTexture: TextureRenderTarget2D;
	SeamMaskRenderTargetTexture: TextureRenderTarget2D;
	PaintTargetData: Map<Texture2D, PaintTexture2DData>;
	TexturePaintingCurrentMeshComponent: MeshComponent;
	PaintingTexture2D: Texture2D;
	static Load(ResourceName: string): MeshTexturePaintingTool;
	static Find(Outer: UObject, ResourceName: string): MeshTexturePaintingTool;
	static GetDefaultObject(): MeshTexturePaintingTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshTexturePaintingTool;
	static C(Other: UObject | any): MeshTexturePaintingTool;
}

declare class MeshColorPaintingToolBuilder extends InteractiveToolBuilder { 
	static Load(ResourceName: string): MeshColorPaintingToolBuilder;
	static Find(Outer: UObject, ResourceName: string): MeshColorPaintingToolBuilder;
	static GetDefaultObject(): MeshColorPaintingToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshColorPaintingToolBuilder;
	static C(Other: UObject | any): MeshColorPaintingToolBuilder;
}

declare class MeshWeightPaintingToolBuilder extends InteractiveToolBuilder { 
	static Load(ResourceName: string): MeshWeightPaintingToolBuilder;
	static Find(Outer: UObject, ResourceName: string): MeshWeightPaintingToolBuilder;
	static GetDefaultObject(): MeshWeightPaintingToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshWeightPaintingToolBuilder;
	static C(Other: UObject | any): MeshWeightPaintingToolBuilder;
}

declare class MeshVertexPaintingToolProperties extends BrushBaseProperties { 
	PaintColor: LinearColor;
	EraseColor: LinearColor;
	bEnableFlow: boolean;
	bOnlyFrontFacingTriangles: boolean;
	VertexPreviewSize: number;
	static Load(ResourceName: string): MeshVertexPaintingToolProperties;
	static Find(Outer: UObject, ResourceName: string): MeshVertexPaintingToolProperties;
	static GetDefaultObject(): MeshVertexPaintingToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshVertexPaintingToolProperties;
	static C(Other: UObject | any): MeshVertexPaintingToolProperties;
}

declare class MeshColorPaintingToolProperties extends MeshVertexPaintingToolProperties { 
	bWriteRed: boolean;
	bWriteGreen: boolean;
	bWriteBlue: boolean;
	bWriteAlpha: boolean;
	bPaintOnSpecificLOD: boolean;
	LODIndex: number;
	static Load(ResourceName: string): MeshColorPaintingToolProperties;
	static Find(Outer: UObject, ResourceName: string): MeshColorPaintingToolProperties;
	static GetDefaultObject(): MeshColorPaintingToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshColorPaintingToolProperties;
	static C(Other: UObject | any): MeshColorPaintingToolProperties;
}

declare type EMeshPaintWeightTypes = 'AlphaLerp' | 'RGB' | 'ARGB' | 'OneMinusARGB' | 'EMeshPaintWeightTypes_MAX';
declare var EMeshPaintWeightTypes : { AlphaLerp:'AlphaLerp',RGB:'RGB',ARGB:'ARGB',OneMinusARGB:'OneMinusARGB',EMeshPaintWeightTypes_MAX:'EMeshPaintWeightTypes_MAX', };
declare type EMeshPaintTextureIndex = 'TextureOne' | 'TextureTwo' | 'TextureThree' | 'TextureFour' | 'TextureFive' | 'EMeshPaintTextureIndex_MAX';
declare var EMeshPaintTextureIndex : { TextureOne:'TextureOne',TextureTwo:'TextureTwo',TextureThree:'TextureThree',TextureFour:'TextureFour',TextureFive:'TextureFive',EMeshPaintTextureIndex_MAX:'EMeshPaintTextureIndex_MAX', };
declare class MeshWeightPaintingToolProperties extends MeshVertexPaintingToolProperties { 
	TextureWeightType: EMeshPaintWeightTypes;
	PaintTextureWeightIndex: EMeshPaintTextureIndex;
	EraseTextureWeightIndex: EMeshPaintTextureIndex;
	static Load(ResourceName: string): MeshWeightPaintingToolProperties;
	static Find(Outer: UObject, ResourceName: string): MeshWeightPaintingToolProperties;
	static GetDefaultObject(): MeshWeightPaintingToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshWeightPaintingToolProperties;
	static C(Other: UObject | any): MeshWeightPaintingToolProperties;
}

declare class MeshVertexPaintingTool extends BaseBrushTool { 
	SelectionMechanic: MeshPaintSelectionMechanic;
	VertexProperties: MeshVertexPaintingToolProperties;
	static Load(ResourceName: string): MeshVertexPaintingTool;
	static Find(Outer: UObject, ResourceName: string): MeshVertexPaintingTool;
	static GetDefaultObject(): MeshVertexPaintingTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshVertexPaintingTool;
	static C(Other: UObject | any): MeshVertexPaintingTool;
}

declare class MeshColorPaintingTool extends MeshVertexPaintingTool { 
	ColorProperties: MeshColorPaintingToolProperties;
	static Load(ResourceName: string): MeshColorPaintingTool;
	static Find(Outer: UObject, ResourceName: string): MeshColorPaintingTool;
	static GetDefaultObject(): MeshColorPaintingTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshColorPaintingTool;
	static C(Other: UObject | any): MeshColorPaintingTool;
}

declare class MeshWeightPaintingTool extends MeshVertexPaintingTool { 
	WeightProperties: MeshWeightPaintingToolProperties;
	static Load(ResourceName: string): MeshWeightPaintingTool;
	static Find(Outer: UObject, ResourceName: string): MeshWeightPaintingTool;
	static GetDefaultObject(): MeshWeightPaintingTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshWeightPaintingTool;
	static C(Other: UObject | any): MeshWeightPaintingTool;
}

declare class TexturePaintToolset extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): TexturePaintToolset;
	static Find(Outer: UObject, ResourceName: string): TexturePaintToolset;
	static GetDefaultObject(): TexturePaintToolset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TexturePaintToolset;
	static C(Other: UObject | any): TexturePaintToolset;
}

declare class ImportVertexColorOptions extends UObject { 
	UVIndex: number;
	LODIndex: number;
	bRed: boolean;
	bBlue: boolean;
	bGreen: boolean;
	bAlpha: boolean;
	bImportToInstance: boolean;
	bCanImportToInstance: boolean;
	static Load(ResourceName: string): ImportVertexColorOptions;
	static Find(Outer: UObject, ResourceName: string): ImportVertexColorOptions;
	static GetDefaultObject(): ImportVertexColorOptions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ImportVertexColorOptions;
	static C(Other: UObject | any): ImportVertexColorOptions;
}

declare type EMeshPaintDataColorViewMode = 'Normal' | 'RGB' | 'Alpha' | 'Red' | 'Green' | 'Blue' | 'EMeshPaintDataColorViewMode_MAX';
declare var EMeshPaintDataColorViewMode : { Normal:'Normal',RGB:'RGB',Alpha:'Alpha',Red:'Red',Green:'Green',Blue:'Blue',EMeshPaintDataColorViewMode_MAX:'EMeshPaintDataColorViewMode_MAX', };
declare class MeshPaintModeSettings extends UObject { 
	ColorViewMode: EMeshPaintDataColorViewMode;
	static Load(ResourceName: string): MeshPaintModeSettings;
	static Find(Outer: UObject, ResourceName: string): MeshPaintModeSettings;
	static GetDefaultObject(): MeshPaintModeSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshPaintModeSettings;
	static C(Other: UObject | any): MeshPaintModeSettings;
}

declare class MeshPaintMode extends EdMode { 
	ModeSettings: MeshPaintModeSettings;
	static Load(ResourceName: string): MeshPaintMode;
	static Find(Outer: UObject, ResourceName: string): MeshPaintMode;
	static GetDefaultObject(): MeshPaintMode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshPaintMode;
	static C(Other: UObject | any): MeshPaintMode;
}

declare class TraceUtilLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): TraceUtilLibrary;
	static Find(Outer: UObject, ResourceName: string): TraceUtilLibrary;
	static GetDefaultObject(): TraceUtilLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TraceUtilLibrary;
	static TraceMarkRegionStart(Name: string): void;
	static TraceMarkRegionEnd(Name: string): void;
	static TraceBookmark(Name: string): void;
	static ToggleChannel(ChannelName: string,Enabled: boolean): boolean;
	static StopTracing(): boolean;
	static StartTraceToFile(Filename: string,Channels: string[]): boolean;
	static StartTraceSendTo(Target: string,Channels: string[]): boolean;
	static ResumeTracing(): boolean;
	static PauseTracing(): boolean;
	static IsTracing(): boolean;
	static IsChannelEnabled(ChannelName: string): boolean;
	static GetEnabledChannels(): string[];
	static GetAllChannels(): string[];
	static C(Other: UObject | any): TraceUtilLibrary;
}

declare type EMeshPaintColorViewMode = 'Normal' | 'RGB' | 'Alpha' | 'Red' | 'Green' | 'Blue' | 'EMeshPaintColorViewMode_MAX';
declare var EMeshPaintColorViewMode : { Normal:'Normal',RGB:'RGB',Alpha:'Alpha',Red:'Red',Green:'Green',Blue:'Blue',EMeshPaintColorViewMode_MAX:'EMeshPaintColorViewMode_MAX', };
declare class PaintBrushSettings extends UObject { 
	BrushRadius: number;
	BrushStrength: number;
	BrushFalloffAmount: number;
	bEnableFlow: boolean;
	bOnlyFrontFacingTriangles: boolean;
	ColorViewMode: EMeshPaintColorViewMode;
	static Load(ResourceName: string): PaintBrushSettings;
	static Find(Outer: UObject, ResourceName: string): PaintBrushSettings;
	static GetDefaultObject(): PaintBrushSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaintBrushSettings;
	static C(Other: UObject | any): PaintBrushSettings;
}

declare class MeshPaintSettings extends UObject { 
	VertexPreviewSize: number;
	static Load(ResourceName: string): MeshPaintSettings;
	static Find(Outer: UObject, ResourceName: string): MeshPaintSettings;
	static GetDefaultObject(): MeshPaintSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshPaintSettings;
	static C(Other: UObject | any): MeshPaintSettings;
}

declare class VertexColorImportOptions extends UObject { 
	UVIndex: number;
	LODIndex: number;
	bRed: boolean;
	bBlue: boolean;
	bGreen: boolean;
	bAlpha: boolean;
	bImportToInstance: boolean;
	bCanImportToInstance: boolean;
	static Load(ResourceName: string): VertexColorImportOptions;
	static Find(Outer: UObject, ResourceName: string): VertexColorImportOptions;
	static GetDefaultObject(): VertexColorImportOptions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VertexColorImportOptions;
	static C(Other: UObject | any): VertexColorImportOptions;
}

declare class PaperSpriteAtlasFactory extends Factory { 
	static Load(ResourceName: string): PaperSpriteAtlasFactory;
	static Find(Outer: UObject, ResourceName: string): PaperSpriteAtlasFactory;
	static GetDefaultObject(): PaperSpriteAtlasFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperSpriteAtlasFactory;
	static C(Other: UObject | any): PaperSpriteAtlasFactory;
}

declare type ESpriteExtractMode = 'Auto' | 'Grid' | 'ESpriteExtractMode_MAX';
declare var ESpriteExtractMode : { Auto:'Auto',Grid:'Grid',ESpriteExtractMode_MAX:'ESpriteExtractMode_MAX', };
declare class PaperExtractSpritesSettings extends UObject { 
	SpriteExtractMode: ESpriteExtractMode;
	OutlineColor: LinearColor;
	ViewportTextureTint: LinearColor;
	BackgroundColor: LinearColor;
	NamingTemplate: string;
	NamingStartIndex: number;
	static Load(ResourceName: string): PaperExtractSpritesSettings;
	static Find(Outer: UObject, ResourceName: string): PaperExtractSpritesSettings;
	static GetDefaultObject(): PaperExtractSpritesSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperExtractSpritesSettings;
	static C(Other: UObject | any): PaperExtractSpritesSettings;
}

declare class PaperExtractSpriteGridSettings extends UObject { 
	CellWidth: number;
	CellHeight: number;
	NumCellsX: number;
	NumCellsY: number;
	MarginX: number;
	MarginY: number;
	SpacingX: number;
	SpacingY: number;
	static Load(ResourceName: string): PaperExtractSpriteGridSettings;
	static Find(Outer: UObject, ResourceName: string): PaperExtractSpriteGridSettings;
	static GetDefaultObject(): PaperExtractSpriteGridSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperExtractSpriteGridSettings;
	static C(Other: UObject | any): PaperExtractSpriteGridSettings;
}

declare class FlipbookEditorSettings extends UObject { 
	BackgroundColor: Color;
	bShowGridByDefault: boolean;
	static Load(ResourceName: string): FlipbookEditorSettings;
	static Find(Outer: UObject, ResourceName: string): FlipbookEditorSettings;
	static GetDefaultObject(): FlipbookEditorSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FlipbookEditorSettings;
	static C(Other: UObject | any): FlipbookEditorSettings;
}

declare class PaperFlipbookActorFactory extends ActorFactory { 
	static Load(ResourceName: string): PaperFlipbookActorFactory;
	static Find(Outer: UObject, ResourceName: string): PaperFlipbookActorFactory;
	static GetDefaultObject(): PaperFlipbookActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperFlipbookActorFactory;
	static C(Other: UObject | any): PaperFlipbookActorFactory;
}

declare class PaperFlipbookFactory extends Factory { 
	static Load(ResourceName: string): PaperFlipbookFactory;
	static Find(Outer: UObject, ResourceName: string): PaperFlipbookFactory;
	static GetDefaultObject(): PaperFlipbookFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperFlipbookFactory;
	static C(Other: UObject | any): PaperFlipbookFactory;
}

declare class PaperSpriteThumbnailRenderer extends DefaultSizedThumbnailRenderer { 
	static Load(ResourceName: string): PaperSpriteThumbnailRenderer;
	static Find(Outer: UObject, ResourceName: string): PaperSpriteThumbnailRenderer;
	static GetDefaultObject(): PaperSpriteThumbnailRenderer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperSpriteThumbnailRenderer;
	static C(Other: UObject | any): PaperSpriteThumbnailRenderer;
}

declare class PaperFlipbookThumbnailRenderer extends PaperSpriteThumbnailRenderer { 
	static Load(ResourceName: string): PaperFlipbookThumbnailRenderer;
	static Find(Outer: UObject, ResourceName: string): PaperFlipbookThumbnailRenderer;
	static GetDefaultObject(): PaperFlipbookThumbnailRenderer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperFlipbookThumbnailRenderer;
	static C(Other: UObject | any): PaperFlipbookThumbnailRenderer;
}

declare class PaperImporterSettings extends UObject { 
	bPickBestMaterialWhenCreatingSprites: boolean;
	bPickBestMaterialWhenCreatingTileMaps: boolean;
	bAnalysisCanUseOpaque: boolean;
	DefaultPixelsPerUnrealUnit: number;
	NormalMapTextureSuffixes: string[];
	BaseMapTextureSuffixes: string[];
	DefaultSpriteTextureGroup: TextureGroup;
	bOverrideTextureCompression: boolean;
	DefaultSpriteTextureCompression: TextureCompressionSettings;
	UnlitDefaultMaskedMaterialName: SoftObjectPath;
	UnlitDefaultTranslucentMaterialName: SoftObjectPath;
	UnlitDefaultOpaqueMaterialName: SoftObjectPath;
	LitDefaultMaskedMaterialName: SoftObjectPath;
	LitDefaultTranslucentMaterialName: SoftObjectPath;
	LitDefaultOpaqueMaterialName: SoftObjectPath;
	static Load(ResourceName: string): PaperImporterSettings;
	static Find(Outer: UObject, ResourceName: string): PaperImporterSettings;
	static GetDefaultObject(): PaperImporterSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperImporterSettings;
	static C(Other: UObject | any): PaperImporterSettings;
}

declare class PaperSpriteActorFactory extends ActorFactory { 
	static Load(ResourceName: string): PaperSpriteActorFactory;
	static Find(Outer: UObject, ResourceName: string): PaperSpriteActorFactory;
	static GetDefaultObject(): PaperSpriteActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperSpriteActorFactory;
	static C(Other: UObject | any): PaperSpriteActorFactory;
}

declare class PaperSpriteFactory extends Factory { 
	static Load(ResourceName: string): PaperSpriteFactory;
	static Find(Outer: UObject, ResourceName: string): PaperSpriteFactory;
	static GetDefaultObject(): PaperSpriteFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperSpriteFactory;
	static C(Other: UObject | any): PaperSpriteFactory;
}

declare class PaperTileMapFactory extends Factory { 
	static Load(ResourceName: string): PaperTileMapFactory;
	static Find(Outer: UObject, ResourceName: string): PaperTileMapFactory;
	static GetDefaultObject(): PaperTileMapFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperTileMapFactory;
	static C(Other: UObject | any): PaperTileMapFactory;
}

declare class PaperTileMapPromotionFactory extends Factory { 
	AssetToRename: PaperTileMap;
	static Load(ResourceName: string): PaperTileMapPromotionFactory;
	static Find(Outer: UObject, ResourceName: string): PaperTileMapPromotionFactory;
	static GetDefaultObject(): PaperTileMapPromotionFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperTileMapPromotionFactory;
	static C(Other: UObject | any): PaperTileMapPromotionFactory;
}

declare class PaperTileSetFactory extends Factory { 
	static Load(ResourceName: string): PaperTileSetFactory;
	static Find(Outer: UObject, ResourceName: string): PaperTileSetFactory;
	static GetDefaultObject(): PaperTileSetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperTileSetFactory;
	static C(Other: UObject | any): PaperTileSetFactory;
}

declare class PaperTileSetThumbnailRenderer extends DefaultSizedThumbnailRenderer { 
	static Load(ResourceName: string): PaperTileSetThumbnailRenderer;
	static Find(Outer: UObject, ResourceName: string): PaperTileSetThumbnailRenderer;
	static GetDefaultObject(): PaperTileSetThumbnailRenderer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperTileSetThumbnailRenderer;
	static C(Other: UObject | any): PaperTileSetThumbnailRenderer;
}

declare class SpriteEditorSettings extends UObject { 
	BackgroundColor: Color;
	bShowGridByDefault: boolean;
	static Load(ResourceName: string): SpriteEditorSettings;
	static Find(Outer: UObject, ResourceName: string): SpriteEditorSettings;
	static GetDefaultObject(): SpriteEditorSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpriteEditorSettings;
	static C(Other: UObject | any): SpriteEditorSettings;
}

declare class TerrainSplineActorFactory extends ActorFactory { 
	static Load(ResourceName: string): TerrainSplineActorFactory;
	static Find(Outer: UObject, ResourceName: string): TerrainSplineActorFactory;
	static GetDefaultObject(): TerrainSplineActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TerrainSplineActorFactory;
	static C(Other: UObject | any): TerrainSplineActorFactory;
}

declare class TileMapActorFactory extends ActorFactory { 
	static Load(ResourceName: string): TileMapActorFactory;
	static Find(Outer: UObject, ResourceName: string): TileMapActorFactory;
	static GetDefaultObject(): TileMapActorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TileMapActorFactory;
	static C(Other: UObject | any): TileMapActorFactory;
}

declare class TileSetImportMapping { 
	SourceName: string;
	ImportedTileSet: PaperTileSet;
	ImportedTexture: Texture;
	clone() : TileSetImportMapping;
	static C(Other: UObject | any): TileSetImportMapping;
}

declare class TileMapAssetImportData extends AssetImportData { 
	TileSetMap: TileSetImportMapping[];
	static Load(ResourceName: string): TileMapAssetImportData;
	static Find(Outer: UObject, ResourceName: string): TileMapAssetImportData;
	static GetDefaultObject(): TileMapAssetImportData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TileMapAssetImportData;
	static C(Other: UObject | any): TileMapAssetImportData;
}

declare class TileMapEditorSettings extends UObject { 
	DefaultBackgroundColor: Color;
	bShowGridByDefault: boolean;
	DefaultTileGridColor: Color;
	DefaultMultiTileGridColor: Color;
	DefaultMultiTileGridWidth: number;
	DefaultMultiTileGridHeight: number;
	DefaultMultiTileGridOffsetX: number;
	DefaultMultiTileGridOffsetY: number;
	DefaultLayerGridColor: Color;
	static Load(ResourceName: string): TileMapEditorSettings;
	static Find(Outer: UObject, ResourceName: string): TileMapEditorSettings;
	static GetDefaultObject(): TileMapEditorSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TileMapEditorSettings;
	static C(Other: UObject | any): TileMapEditorSettings;
}

declare class TileSetEditorSettings extends UObject { 
	DefaultBackgroundColor: Color;
	bShowGridByDefault: boolean;
	ExtrusionAmount: number;
	bPadToPowerOf2: boolean;
	bFillWithTransparentBlack: boolean;
	static Load(ResourceName: string): TileSetEditorSettings;
	static Find(Outer: UObject, ResourceName: string): TileSetEditorSettings;
	static GetDefaultObject(): TileSetEditorSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TileSetEditorSettings;
	static C(Other: UObject | any): TileSetEditorSettings;
}

declare class TileSheetPaddingFactory extends Factory { 
	SourceTileSet: PaperTileSet;
	ExtrusionAmount: number;
	bPadToPowerOf2: boolean;
	bFillWithTransparentBlack: boolean;
	static Load(ResourceName: string): TileSheetPaddingFactory;
	static Find(Outer: UObject, ResourceName: string): TileSheetPaddingFactory;
	static GetDefaultObject(): TileSheetPaddingFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TileSheetPaddingFactory;
	static C(Other: UObject | any): TileSheetPaddingFactory;
}

declare class PaperSpriteSheet extends UObject { 
	SpriteNames: string[];
	Sprites: PaperSprite[];
	TextureName: string;
	Texture: Texture2D;
	NormalMapTextureName: string;
	NormalMapTexture: Texture2D;
	AssetImportData: AssetImportData;
	static Load(ResourceName: string): PaperSpriteSheet;
	static Find(Outer: UObject, ResourceName: string): PaperSpriteSheet;
	static GetDefaultObject(): PaperSpriteSheet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperSpriteSheet;
	static C(Other: UObject | any): PaperSpriteSheet;
}

declare class PaperSpriteSheetImportFactory extends Factory { 
	static Load(ResourceName: string): PaperSpriteSheetImportFactory;
	static Find(Outer: UObject, ResourceName: string): PaperSpriteSheetImportFactory;
	static GetDefaultObject(): PaperSpriteSheetImportFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperSpriteSheetImportFactory;
	static C(Other: UObject | any): PaperSpriteSheetImportFactory;
}

declare class PaperSpriteSheetReimportFactory extends PaperSpriteSheetImportFactory { 
	static Load(ResourceName: string): PaperSpriteSheetReimportFactory;
	static Find(Outer: UObject, ResourceName: string): PaperSpriteSheetReimportFactory;
	static GetDefaultObject(): PaperSpriteSheetReimportFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperSpriteSheetReimportFactory;
	static C(Other: UObject | any): PaperSpriteSheetReimportFactory;
}

declare class PaperTiledImporterFactory extends Factory { 
	static Load(ResourceName: string): PaperTiledImporterFactory;
	static Find(Outer: UObject, ResourceName: string): PaperTiledImporterFactory;
	static GetDefaultObject(): PaperTiledImporterFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PaperTiledImporterFactory;
	static C(Other: UObject | any): PaperTiledImporterFactory;
}

declare class OodleNetworkTrainerCommandlet extends Commandlet { 
	bCompressionTest: boolean;
	bWriteV5Dictionaries: boolean;
	HashTableSize: number;
	DictionarySize: number;
	DictionaryTrials: number;
	TrialRandomness: number;
	TrialGenerations: number;
	bNoTrials: boolean;
	static Load(ResourceName: string): OodleNetworkTrainerCommandlet;
	static Find(Outer: UObject, ResourceName: string): OodleNetworkTrainerCommandlet;
	static GetDefaultObject(): OodleNetworkTrainerCommandlet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OodleNetworkTrainerCommandlet;
	static C(Other: UObject | any): OodleNetworkTrainerCommandlet;
}

declare class AnimationSharingSetupFactory extends Factory { 
	static Load(ResourceName: string): AnimationSharingSetupFactory;
	static Find(Outer: UObject, ResourceName: string): AnimationSharingSetupFactory;
	static GetDefaultObject(): AnimationSharingSetupFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimationSharingSetupFactory;
	static C(Other: UObject | any): AnimationSharingSetupFactory;
}

declare class BoneReferencePair { 
	SourceBone: BoneReference;
	TargetBone: BoneReference;
	clone() : BoneReferencePair;
	static C(Other: UObject | any): BoneReferencePair;
}

declare class CopyBonesModifier extends AnimationModifier { 
	BonePairs: BoneReferencePair[];
	BonePoseSpace: EAnimPoseSpaces;
	static Load(ResourceName: string): CopyBonesModifier;
	static Find(Outer: UObject, ResourceName: string): CopyBonesModifier;
	static GetDefaultObject(): CopyBonesModifier;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CopyBonesModifier;
	static C(Other: UObject | any): CopyBonesModifier;
}

declare class MotionExtractorUtilityLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): MotionExtractorUtilityLibrary;
	static Find(Outer: UObject, ResourceName: string): MotionExtractorUtilityLibrary;
	static GetDefaultObject(): MotionExtractorUtilityLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MotionExtractorUtilityLibrary;
	static GetStoppedRangesFromRootMotion(AnimSequence: AnimSequence,StopSpeedThreshold: number,SampleRate: number): Vector2D[];
	static GetMovingRangesFromRootMotion(AnimSequence: AnimSequence,StopSpeedThreshold: number,SampleRate: number): Vector2D[];
	static GetDesiredValue(BoneTransform: Transform,LastBoneTransform: Transform,DeltaTime: number,MotionType: EMotionExtractor_MotionType,Axis: EMotionExtractor_Axis): number;
	static GenerateCurveName(BoneName: string,MotionType: EMotionExtractor_MotionType,Axis: EMotionExtractor_Axis): string;
	static C(Other: UObject | any): MotionExtractorUtilityLibrary;
}

declare class ReOrientRootBoneModifier extends AnimationModifier { 
	Rotator: Rotator;
	static Load(ResourceName: string): ReOrientRootBoneModifier;
	static Find(Outer: UObject, ResourceName: string): ReOrientRootBoneModifier;
	static GetDefaultObject(): ReOrientRootBoneModifier;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ReOrientRootBoneModifier;
	static C(Other: UObject | any): ReOrientRootBoneModifier;
}

declare type EMotionExtractor_MathOperation = 'None' | 'Addition' | 'Subtraction' | 'Division' | 'Multiplication' | 'EMotionExtractor_MAX';
declare var EMotionExtractor_MathOperation : { None:'None',Addition:'Addition',Subtraction:'Subtraction',Division:'Division',Multiplication:'Multiplication',EMotionExtractor_MAX:'EMotionExtractor_MAX', };
declare class MotionExtractorModifier extends AnimationModifier { 
	BoneName: string;
	MotionType: EMotionExtractor_MotionType;
	Axis: EMotionExtractor_Axis;
	bRemoveCurveOnRevert: boolean;
	bRelativeToFirstFrame: boolean;
	bComponentSpace: boolean;
	bAbsoluteValue: boolean;
	MathOperation: EMotionExtractor_MathOperation;
	Modifier: number;
	bNormalize: boolean;
	SampleRate: number;
	bUseCustomCurveName: boolean;
	CustomCurveName: string;
	static Load(ResourceName: string): MotionExtractorModifier;
	static Find(Outer: UObject, ResourceName: string): MotionExtractorModifier;
	static GetDefaultObject(): MotionExtractorModifier;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MotionExtractorModifier;
	static C(Other: UObject | any): MotionExtractorModifier;
}

declare class CachedMotionAnalysisProperties extends CachedAnalysisProperties { 
	static Load(ResourceName: string): CachedMotionAnalysisProperties;
	static Find(Outer: UObject, ResourceName: string): CachedMotionAnalysisProperties;
	static GetDefaultObject(): CachedMotionAnalysisProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CachedMotionAnalysisProperties;
	static C(Other: UObject | any): CachedMotionAnalysisProperties;
}

declare type EAnalysisLocomotionAxis = 'Speed' | 'Direction' | 'ForwardSpeed' | 'RightwardSpeed' | 'UpwardSpeed' | 'ForwardSlope' | 'RightwardSlope' | 'EAnalysisLocomotionAxis_MAX';
declare var EAnalysisLocomotionAxis : { Speed:'Speed',Direction:'Direction',ForwardSpeed:'ForwardSpeed',RightwardSpeed:'RightwardSpeed',UpwardSpeed:'UpwardSpeed',ForwardSlope:'ForwardSlope',RightwardSlope:'RightwardSlope',EAnalysisLocomotionAxis_MAX:'EAnalysisLocomotionAxis_MAX', };
declare class LocomotionAnalysisProperties extends AnalysisProperties { 
	FunctionAxis: EAnalysisLocomotionAxis;
	PrimaryBoneSocket: BoneSocketTarget;
	SecondaryBoneSocket: BoneSocketTarget;
	CharacterFacingAxis: EAnalysisLinearAxis;
	CharacterUpAxis: EAnalysisLinearAxis;
	static Load(ResourceName: string): LocomotionAnalysisProperties;
	static Find(Outer: UObject, ResourceName: string): LocomotionAnalysisProperties;
	static GetDefaultObject(): LocomotionAnalysisProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LocomotionAnalysisProperties;
	static C(Other: UObject | any): LocomotionAnalysisProperties;
}

declare type EAnalysisRootMotionAxis = 'Speed' | 'Direction' | 'ForwardSpeed' | 'RightwardSpeed' | 'UpwardSpeed' | 'ForwardSlope' | 'RightwardSlope' | 'EAnalysisRootMotionAxis_MAX';
declare var EAnalysisRootMotionAxis : { Speed:'Speed',Direction:'Direction',ForwardSpeed:'ForwardSpeed',RightwardSpeed:'RightwardSpeed',UpwardSpeed:'UpwardSpeed',ForwardSlope:'ForwardSlope',RightwardSlope:'RightwardSlope',EAnalysisRootMotionAxis_MAX:'EAnalysisRootMotionAxis_MAX', };
declare class RootMotionAnalysisProperties extends AnalysisProperties { 
	FunctionAxis: EAnalysisRootMotionAxis;
	BoneSocket: BoneSocketTarget;
	Space: EAnalysisSpace;
	SpaceBoneSocket: BoneSocketTarget;
	CharacterFacingAxis: EAnalysisLinearAxis;
	CharacterUpAxis: EAnalysisLinearAxis;
	StartTimeFraction: number;
	EndTimeFraction: number;
	static Load(ResourceName: string): RootMotionAnalysisProperties;
	static Find(Outer: UObject, ResourceName: string): RootMotionAnalysisProperties;
	static GetDefaultObject(): RootMotionAnalysisProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RootMotionAnalysisProperties;
	static C(Other: UObject | any): RootMotionAnalysisProperties;
}

declare class PlasticSourceControlProjectSettings extends DeveloperSettings { 
	UserNameToDisplayName: Map<string, string>;
	bHideEmailDomainInUsername: boolean;
	bPromptForCheckoutOnChange: boolean;
	static Load(ResourceName: string): PlasticSourceControlProjectSettings;
	static Find(Outer: UObject, ResourceName: string): PlasticSourceControlProjectSettings;
	static GetDefaultObject(): PlasticSourceControlProjectSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlasticSourceControlProjectSettings;
	static C(Other: UObject | any): PlasticSourceControlProjectSettings;
}

declare class LayersBlueprintLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): LayersBlueprintLibrary;
	static Find(Outer: UObject, ResourceName: string): LayersBlueprintLibrary;
	static GetDefaultObject(): LayersBlueprintLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LayersBlueprintLibrary;
	static RemoveActorFromLayer(InActor: Actor,Layer: ActorLayer): void;
	static GetActors(WorldContextObject: UObject,ActorLayer: ActorLayer): Actor[];
	static AddActorToLayer(InActor: Actor,Layer: ActorLayer): void;
	static C(Other: UObject | any): LayersBlueprintLibrary;
}

declare class MyPluginStruct { 
	TestString: string;
	clone() : MyPluginStruct;
	static C(Other: UObject | any): MyPluginStruct;
}

declare class MyPluginObject extends UObject { 
	MyStruct: MyPluginStruct;
	static Load(ResourceName: string): MyPluginObject;
	static Find(Outer: UObject, ResourceName: string): MyPluginObject;
	static GetDefaultObject(): MyPluginObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MyPluginObject;
	static C(Other: UObject | any): MyPluginObject;
}

declare class AndroidPermissionCallbackProxy extends UObject { 
	OnPermissionsGrantedDynamicDelegate: UnrealEngineMulticastDelegate<(Permissions: string[], GrantResults: boolean[]) => void>;
	static Load(ResourceName: string): AndroidPermissionCallbackProxy;
	static Find(Outer: UObject, ResourceName: string): AndroidPermissionCallbackProxy;
	static GetDefaultObject(): AndroidPermissionCallbackProxy;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AndroidPermissionCallbackProxy;
	static C(Other: UObject | any): AndroidPermissionCallbackProxy;
}

declare class AndroidPermissionFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): AndroidPermissionFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): AndroidPermissionFunctionLibrary;
	static GetDefaultObject(): AndroidPermissionFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AndroidPermissionFunctionLibrary;
	static CheckPermission(permission: string): boolean;
	static AcquirePermissions(Permissions: string[]): AndroidPermissionCallbackProxy;
	static C(Other: UObject | any): AndroidPermissionFunctionLibrary;
}

declare class AndroidPermissionDynamicDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): AndroidPermissionDynamicDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): AndroidPermissionDynamicDelegate__PythonCallable;
	static GetDefaultObject(): AndroidPermissionDynamicDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AndroidPermissionDynamicDelegate__PythonCallable;
	static C(Other: UObject | any): AndroidPermissionDynamicDelegate__PythonCallable;
}

declare class AppleImageInterface extends Interface { 
	static Load(ResourceName: string): AppleImageInterface;
	static Find(Outer: UObject, ResourceName: string): AppleImageInterface;
	static GetDefaultObject(): AppleImageInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AppleImageInterface;
	static C(Other: UObject | any): AppleImageInterface;
}

declare class AppleImageUtilsImageConversionResult { 
	Error: string;
	ImageData: number[];
	clone() : AppleImageUtilsImageConversionResult;
	static C(Other: UObject | any): AppleImageUtilsImageConversionResult;
}

declare type ETextureRotationDirection = 'None' | 'Left' | 'Right' | 'Down' | 'LeftMirrored' | 'RightMirrored' | 'DownMirrored' | 'UpMirrored' | 'ETextureRotationDirection_MAX';
declare var ETextureRotationDirection : { None:'None',Left:'Left',Right:'Right',Down:'Down',LeftMirrored:'LeftMirrored',RightMirrored:'RightMirrored',DownMirrored:'DownMirrored',UpMirrored:'UpMirrored',ETextureRotationDirection_MAX:'ETextureRotationDirection_MAX', };
declare class AppleImageUtilsBaseAsyncTaskBlueprintProxy extends UObject { 
	OnSuccess: UnrealEngineMulticastDelegate<(ConversionResult: AppleImageUtilsImageConversionResult) => void>;
	OnFailure: UnrealEngineMulticastDelegate<(ConversionResult: AppleImageUtilsImageConversionResult) => void>;
	ConversionResult: AppleImageUtilsImageConversionResult;
	static Load(ResourceName: string): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
	static Find(Outer: UObject, ResourceName: string): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
	static GetDefaultObject(): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
	static CreateProxyObjectForConvertToTIFF(SourceImage: Texture,bWantColor: boolean,bUseGpu: boolean,Scale: number,Rotate: ETextureRotationDirection): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
	static CreateProxyObjectForConvertToPNG(SourceImage: Texture,bWantColor: boolean,bUseGpu: boolean,Scale: number,Rotate: ETextureRotationDirection): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
	static CreateProxyObjectForConvertToJPEG(SourceImage: Texture,Quality: number,bWantColor: boolean,bUseGpu: boolean,Scale: number,Rotate: ETextureRotationDirection): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
	static CreateProxyObjectForConvertToHEIF(SourceImage: Texture,Quality: number,bWantColor: boolean,bUseGpu: boolean,Scale: number,Rotate: ETextureRotationDirection): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
	static C(Other: UObject | any): AppleImageUtilsBaseAsyncTaskBlueprintProxy;
}

declare class AppleImageConversionDelegate__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): AppleImageConversionDelegate__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): AppleImageConversionDelegate__PythonCallable;
	static GetDefaultObject(): AppleImageConversionDelegate__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AppleImageConversionDelegate__PythonCallable;
	static C(Other: UObject | any): AppleImageConversionDelegate__PythonCallable;
}

declare class K2Node_ConvertToJPEG extends K2Node_BaseAsyncTask { 
	static Load(ResourceName: string): K2Node_ConvertToJPEG;
	static Find(Outer: UObject, ResourceName: string): K2Node_ConvertToJPEG;
	static GetDefaultObject(): K2Node_ConvertToJPEG;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node_ConvertToJPEG;
	static C(Other: UObject | any): K2Node_ConvertToJPEG;
}

declare class K2Node_ConvertToHEIF extends K2Node_BaseAsyncTask { 
	static Load(ResourceName: string): K2Node_ConvertToHEIF;
	static Find(Outer: UObject, ResourceName: string): K2Node_ConvertToHEIF;
	static GetDefaultObject(): K2Node_ConvertToHEIF;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node_ConvertToHEIF;
	static C(Other: UObject | any): K2Node_ConvertToHEIF;
}

declare class K2Node_ConvertToTIFF extends K2Node_BaseAsyncTask { 
	static Load(ResourceName: string): K2Node_ConvertToTIFF;
	static Find(Outer: UObject, ResourceName: string): K2Node_ConvertToTIFF;
	static GetDefaultObject(): K2Node_ConvertToTIFF;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node_ConvertToTIFF;
	static C(Other: UObject | any): K2Node_ConvertToTIFF;
}

declare class K2Node_ConvertToPNG extends K2Node_BaseAsyncTask { 
	static Load(ResourceName: string): K2Node_ConvertToPNG;
	static Find(Outer: UObject, ResourceName: string): K2Node_ConvertToPNG;
	static GetDefaultObject(): K2Node_ConvertToPNG;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node_ConvertToPNG;
	static C(Other: UObject | any): K2Node_ConvertToPNG;
}

declare class ArchVisCharacter extends Character { 
	LookUpAxisName: string;
	LookUpAtRateAxisName: string;
	TurnAxisName: string;
	TurnAtRateAxisName: string;
	MoveForwardAxisName: string;
	MoveRightAxisName: string;
	MouseSensitivityScale_Pitch: number;
	MouseSensitivityScale_Yaw: number;
	static GetDefaultObject(): ArchVisCharacter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ArchVisCharacter;
	static C(Other: UObject | any): ArchVisCharacter;
}

declare class ArchVisCharMovementComponent extends CharacterMovementComponent { 
	RotationalAcceleration: Rotator;
	RotationalDeceleration: Rotator;
	MaxRotationalVelocity: Rotator;
	MinPitch: number;
	MaxPitch: number;
	WalkingFriction: number;
	WalkingSpeed: number;
	WalkingAcceleration: number;
	static Load(ResourceName: string): ArchVisCharMovementComponent;
	static Find(Outer: UObject, ResourceName: string): ArchVisCharMovementComponent;
	static GetDefaultObject(): ArchVisCharMovementComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ArchVisCharMovementComponent;
	static C(Other: UObject | any): ArchVisCharMovementComponent;
}

declare type ECollectionScriptingShareType = 'Local' | 'Private' | 'Shared' | 'ECollectionScriptingShareType_MAX';
declare var ECollectionScriptingShareType : { Local:'Local',Private:'Private',Shared:'Shared',ECollectionScriptingShareType_MAX:'ECollectionScriptingShareType_MAX', };
declare class AssetTagsSubsystem extends EngineSubsystem { 
	static Load(ResourceName: string): AssetTagsSubsystem;
	static Find(Outer: UObject, ResourceName: string): AssetTagsSubsystem;
	static GetDefaultObject(): AssetTagsSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AssetTagsSubsystem;
	ReparentCollection(Name: string,NewParentName: string): boolean;
	RenameCollection(Name: string,NewName: string): boolean;
	RemoveAssetsFromCollection(Name: string,AssetPathNames: string[]): boolean;
	RemoveAssetPtrsFromCollection(Name: string,AssetPtrs: UObject[]): boolean;
	RemoveAssetPtrFromCollection(Name: string,AssetPtr: UObject): boolean;
	RemoveAssetFromCollection(Name: string,AssetPathName: string): boolean;
	RemoveAssetDatasFromCollection(Name: string,AssetDatas: AssetData[]): boolean;
	RemoveAssetDataFromCollection(Name: string,AssetData: AssetData): boolean;
	K2_RemoveAssetsFromCollection(Name: string,AssetPaths: SoftObjectPath[]): boolean;
	K2_RemoveAssetFromCollection(Name: string,AssetPath: SoftObjectPath): boolean;
	K2_GetCollectionsContainingAsset(AssetPath: SoftObjectPath): string[];
	K2_AddAssetToCollection(Name: string,AssetPath: SoftObjectPath): boolean;
	K2_AddAssetsToCollection(Name: string,AssetPaths: SoftObjectPath[]): boolean;
	GetCollectionsContainingAssetPtr(AssetPtr: UObject): string[];
	GetCollectionsContainingAssetData(AssetData: AssetData): string[];
	GetCollectionsContainingAsset(AssetPathName: string): string[];
	GetCollections(): string[];
	GetAssetsInCollection(Name: string): AssetData[];
	EmptyCollection(Name: string): boolean;
	DestroyCollection(Name: string): boolean;
	CreateCollection(Name: string,ShareType: ECollectionScriptingShareType): boolean;
	CollectionExists(Name: string): boolean;
	AddAssetToCollection(Name: string,AssetPathName: string): boolean;
	AddAssetsToCollection(Name: string,AssetPathNames: string[]): boolean;
	AddAssetPtrToCollection(Name: string,AssetPtr: UObject): boolean;
	AddAssetPtrsToCollection(Name: string,AssetPtrs: UObject[]): boolean;
	AddAssetDataToCollection(Name: string,AssetData: AssetData): boolean;
	AddAssetDatasToCollection(Name: string,AssetDatas: AssetData[]): boolean;
	static C(Other: UObject | any): AssetTagsSubsystem;
}

declare class AudioCaptureDeviceInfo { 
	DeviceName: string;
	NumInputChannels: number;
	SampleRate: number;
	clone() : AudioCaptureDeviceInfo;
	static C(Other: UObject | any): AudioCaptureDeviceInfo;
}

declare class AudioCapture extends AudioGenerator { 
	static Load(ResourceName: string): AudioCapture;
	static Find(Outer: UObject, ResourceName: string): AudioCapture;
	static GetDefaultObject(): AudioCapture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioCapture;
	StopCapturingAudio(): void;
	StartCapturingAudio(): void;
	IsCapturingAudio(): boolean;
	GetAudioCaptureDeviceInfo(OutInfo?: AudioCaptureDeviceInfo): {OutInfo: AudioCaptureDeviceInfo, $: boolean};
	static C(Other: UObject | any): AudioCapture;
}

declare class AudioCaptureFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): AudioCaptureFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): AudioCaptureFunctionLibrary;
	static GetDefaultObject(): AudioCaptureFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioCaptureFunctionLibrary;
	static CreateAudioCapture(): AudioCapture;
	static C(Other: UObject | any): AudioCaptureFunctionLibrary;
}

declare class AudioCaptureBlueprintLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): AudioCaptureBlueprintLibrary;
	static Find(Outer: UObject, ResourceName: string): AudioCaptureBlueprintLibrary;
	static GetDefaultObject(): AudioCaptureBlueprintLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioCaptureBlueprintLibrary;
	static Conv_AudioInputDeviceInfoToString(Info: AudioInputDeviceInfo): string;
	static C(Other: UObject | any): AudioCaptureBlueprintLibrary;
}

declare class AudioCaptureComponent extends SynthComponent { 
	JitterLatencyFrames: number;
	static Load(ResourceName: string): AudioCaptureComponent;
	static Find(Outer: UObject, ResourceName: string): AudioCaptureComponent;
	static GetDefaultObject(): AudioCaptureComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioCaptureComponent;
	static C(Other: UObject | any): AudioCaptureComponent;
}

declare class OnAudioInputDevicesObtained__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnAudioInputDevicesObtained__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnAudioInputDevicesObtained__PythonCallable;
	static GetDefaultObject(): OnAudioInputDevicesObtained__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAudioInputDevicesObtained__PythonCallable;
	static C(Other: UObject | any): OnAudioInputDevicesObtained__PythonCallable;
}

declare class GeometryCacheTrack extends UObject { 
	Duration: number;
	static Load(ResourceName: string): GeometryCacheTrack;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheTrack;
	static GetDefaultObject(): GeometryCacheTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheTrack;
	static C(Other: UObject | any): GeometryCacheTrack;
}

declare class GeometryCache extends UObject { 
	AssetImportData: AssetImportData;
	ThumbnailInfo: ThumbnailInfo;
	Materials: MaterialInterface[];
	Tracks: GeometryCacheTrack[];
	StartFrame: number;
	EndFrame: number;
	Hash: number;
	static Load(ResourceName: string): GeometryCache;
	static Find(Outer: UObject, ResourceName: string): GeometryCache;
	static GetDefaultObject(): GeometryCache;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCache;
	static C(Other: UObject | any): GeometryCache;
}

declare class GeometryCacheComponent extends MeshComponent { 
	GeometryCache: GeometryCache;
	bRunning: boolean;
	bLooping: boolean;
	bExtrapolateFrames: boolean;
	StartTimeOffset: number;
	PlaybackSpeed: number;
	MotionVectorScale: number;
	NumTracks: number;
	ElapsedTime: number;
	Duration: number;
	bManualTick: boolean;
	bOverrideWireframeColor: boolean;
	WireframeOverrideColor: LinearColor;
	static Load(ResourceName: string): GeometryCacheComponent;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheComponent;
	static GetDefaultObject(): GeometryCacheComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheComponent;
	TickAtThisTime(Time: number,bInIsRunning: boolean,bInBackwards: boolean,bInIsLooping: boolean): void;
	Stop(): void;
	SetWireframeOverrideColor(Color: LinearColor): void;
	SetStartTimeOffset(NewStartTimeOffset: number): void;
	SetPlaybackSpeed(NewPlaybackSpeed: number): void;
	SetOverrideWireframeColor(bOverride: boolean): void;
	SetMotionVectorScale(NewMotionVectorScale: number): void;
	SetLooping(bNewLooping: boolean): void;
	SetGeometryCache(NewGeomCache: GeometryCache): boolean;
	SetExtrapolateFrames(bNewExtrapolating: boolean): void;
	PlayReversedFromEnd(): void;
	PlayReversed(): void;
	PlayFromStart(): void;
	Play(): void;
	Pause(): void;
	IsPlayingReversed(): boolean;
	IsPlaying(): boolean;
	IsLooping(): boolean;
	IsExtrapolatingFrames(): boolean;
	GetWireframeOverrideColor(): LinearColor;
	GetStartTimeOffset(): number;
	GetPlaybackSpeed(): number;
	GetPlaybackDirection(): number;
	GetOverrideWireframeColor(): boolean;
	GetNumberOfFrames(): number;
	GetMotionVectorScale(): number;
	GetDuration(): number;
	GetAnimationTime(): number;
	static C(Other: UObject | any): GeometryCacheComponent;
}

declare class GeometryCacheActor extends Actor { 
	GeometryCacheComponent: GeometryCacheComponent;
	static GetDefaultObject(): GeometryCacheActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheActor;
	GetGeometryCacheComponent(): GeometryCacheComponent;
	static C(Other: UObject | any): GeometryCacheActor;
}

declare class GeometryCacheCodecBase extends UObject { 
	TopologyRanges: number[];
	static Load(ResourceName: string): GeometryCacheCodecBase;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheCodecBase;
	static GetDefaultObject(): GeometryCacheCodecBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheCodecBase;
	static C(Other: UObject | any): GeometryCacheCodecBase;
}

declare class GeometryCacheCodecRaw extends GeometryCacheCodecBase { 
	DummyProperty: number;
	static Load(ResourceName: string): GeometryCacheCodecRaw;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheCodecRaw;
	static GetDefaultObject(): GeometryCacheCodecRaw;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheCodecRaw;
	static C(Other: UObject | any): GeometryCacheCodecRaw;
}

declare class GeometryCacheCodecV1 extends GeometryCacheCodecBase { 
	static Load(ResourceName: string): GeometryCacheCodecV1;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheCodecV1;
	static GetDefaultObject(): GeometryCacheCodecV1;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheCodecV1;
	static C(Other: UObject | any): GeometryCacheCodecV1;
}

declare class GeometryCacheMeshData { 
	clone() : GeometryCacheMeshData;
	static C(Other: UObject | any): GeometryCacheMeshData;
}

declare class GeometryCacheTrack_FlipbookAnimation extends GeometryCacheTrack { 
	NumMeshSamples: number;
	static Load(ResourceName: string): GeometryCacheTrack_FlipbookAnimation;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheTrack_FlipbookAnimation;
	static GetDefaultObject(): GeometryCacheTrack_FlipbookAnimation;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheTrack_FlipbookAnimation;
	AddMeshSample(MeshData: GeometryCacheMeshData,SampleTime: number): void;
	static C(Other: UObject | any): GeometryCacheTrack_FlipbookAnimation;
}

declare class GeometryCacheTrackStreamable extends GeometryCacheTrack { 
	Codec: GeometryCacheCodecBase;
	StartSampleTime: number;
	static Load(ResourceName: string): GeometryCacheTrackStreamable;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheTrackStreamable;
	static GetDefaultObject(): GeometryCacheTrackStreamable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheTrackStreamable;
	static C(Other: UObject | any): GeometryCacheTrackStreamable;
}

declare class GeometryCacheTrack_TransformAnimation extends GeometryCacheTrack { 
	static Load(ResourceName: string): GeometryCacheTrack_TransformAnimation;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheTrack_TransformAnimation;
	static GetDefaultObject(): GeometryCacheTrack_TransformAnimation;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheTrack_TransformAnimation;
	SetMesh(NewMeshData: GeometryCacheMeshData): void;
	static C(Other: UObject | any): GeometryCacheTrack_TransformAnimation;
}

declare class GeometryCacheTrack_TransformGroupAnimation extends GeometryCacheTrack { 
	static Load(ResourceName: string): GeometryCacheTrack_TransformGroupAnimation;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheTrack_TransformGroupAnimation;
	static GetDefaultObject(): GeometryCacheTrack_TransformGroupAnimation;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheTrack_TransformGroupAnimation;
	SetMesh(NewMeshData: GeometryCacheMeshData): void;
	static C(Other: UObject | any): GeometryCacheTrack_TransformGroupAnimation;
}

declare class NiagaraGeometryCacheReference { 
	GeometryCache: GeometryCache;
	GeometryCacheUserParamBinding: NiagaraUserParameterBinding;
	OverrideMaterials: MaterialInterface[];
	clone() : NiagaraGeometryCacheReference;
	static C(Other: UObject | any): NiagaraGeometryCacheReference;
}

declare class NiagaraGeometryCacheRendererProperties extends NiagaraRendererProperties { 
	GeometryCaches: NiagaraGeometryCacheReference[];
	bIsLooping: boolean;
	ComponentCountLimit: number;
	PositionBinding: NiagaraVariableAttributeBinding;
	RotationBinding: NiagaraVariableAttributeBinding;
	ScaleBinding: NiagaraVariableAttributeBinding;
	ElapsedTimeBinding: NiagaraVariableAttributeBinding;
	EnabledBinding: NiagaraVariableAttributeBinding;
	ArrayIndexBinding: NiagaraVariableAttributeBinding;
	RendererVisibilityTagBinding: NiagaraVariableAttributeBinding;
	RendererVisibility: number;
	bAssignComponentsOnParticleID: boolean;
	static Load(ResourceName: string): NiagaraGeometryCacheRendererProperties;
	static Find(Outer: UObject, ResourceName: string): NiagaraGeometryCacheRendererProperties;
	static GetDefaultObject(): NiagaraGeometryCacheRendererProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraGeometryCacheRendererProperties;
	static C(Other: UObject | any): NiagaraGeometryCacheRendererProperties;
}

declare class ActorFactoryGeometryCache extends ActorFactory { 
	static Load(ResourceName: string): ActorFactoryGeometryCache;
	static Find(Outer: UObject, ResourceName: string): ActorFactoryGeometryCache;
	static GetDefaultObject(): ActorFactoryGeometryCache;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorFactoryGeometryCache;
	static C(Other: UObject | any): ActorFactoryGeometryCache;
}

declare class GeometryCacheThumbnailRenderer extends DefaultSizedThumbnailRenderer { 
	static Load(ResourceName: string): GeometryCacheThumbnailRenderer;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheThumbnailRenderer;
	static GetDefaultObject(): GeometryCacheThumbnailRenderer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheThumbnailRenderer;
	static C(Other: UObject | any): GeometryCacheThumbnailRenderer;
}

declare class MovieSceneGeometryCacheParams { 
	GeometryCacheAsset: GeometryCache;
	FirstLoopStartFrameOffset: FrameNumber;
	StartFrameOffset: FrameNumber;
	EndFrameOffset: FrameNumber;
	PlayRate: number;
	bReverse: boolean;
	StartOffset: number;
	EndOffset: number;
	GeometryCache: SoftObjectPath;
	clone() : MovieSceneGeometryCacheParams;
	static C(Other: UObject | any): MovieSceneGeometryCacheParams;
}

declare class MovieSceneGeometryCacheSection extends MovieSceneSection { 
	Params: MovieSceneGeometryCacheParams;
	static Load(ResourceName: string): MovieSceneGeometryCacheSection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneGeometryCacheSection;
	static GetDefaultObject(): MovieSceneGeometryCacheSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneGeometryCacheSection;
	static C(Other: UObject | any): MovieSceneGeometryCacheSection;
}

declare class MovieSceneGeometryCacheTrack extends MovieSceneNameableTrack { 
	AnimationSections: MovieSceneSection[];
	static Load(ResourceName: string): MovieSceneGeometryCacheTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneGeometryCacheTrack;
	static GetDefaultObject(): MovieSceneGeometryCacheTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneGeometryCacheTrack;
	static C(Other: UObject | any): MovieSceneGeometryCacheTrack;
}

declare class GeometryCacheStreamerSettings extends DeveloperSettings { 
	LookAheadBuffer: number;
	MaxMemoryAllowed: number;
	static Load(ResourceName: string): GeometryCacheStreamerSettings;
	static Find(Outer: UObject, ResourceName: string): GeometryCacheStreamerSettings;
	static GetDefaultObject(): GeometryCacheStreamerSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometryCacheStreamerSettings;
	static C(Other: UObject | any): GeometryCacheStreamerSettings;
}

declare type EGooglePADErrorCode = 'AssetPack_NO_ERROR' | 'AssetPack_APP_UNAVAILABLE' | 'AssetPack_UNAVAILABLE' | 'AssetPack_INVALID_REQUEST' | 'AssetPack_DOWNLOAD_NOT_FOUND' | 'AssetPack_API_NOT_AVAILABLE' | 'AssetPack_NETWORK_ERROR' | 'AssetPack_ACCESS_DENIED' | 'AssetPack_INSUFFICIENT_STORAGE' | 'AssetPack_PLAY_STORE_NOT_FOUND' | 'AssetPack_NETWORK_UNRESTRICTED' | 'AssetPack_INTERNAL_ERROR' | 'AssetPack_INITIALIZATION_NEEDED' | 'AssetPack_INITIALIZATION_FAILED' | 'AssetPack_MAX';
declare var EGooglePADErrorCode : { AssetPack_NO_ERROR:'AssetPack_NO_ERROR',AssetPack_APP_UNAVAILABLE:'AssetPack_APP_UNAVAILABLE',AssetPack_UNAVAILABLE:'AssetPack_UNAVAILABLE',AssetPack_INVALID_REQUEST:'AssetPack_INVALID_REQUEST',AssetPack_DOWNLOAD_NOT_FOUND:'AssetPack_DOWNLOAD_NOT_FOUND',AssetPack_API_NOT_AVAILABLE:'AssetPack_API_NOT_AVAILABLE',AssetPack_NETWORK_ERROR:'AssetPack_NETWORK_ERROR',AssetPack_ACCESS_DENIED:'AssetPack_ACCESS_DENIED',AssetPack_INSUFFICIENT_STORAGE:'AssetPack_INSUFFICIENT_STORAGE',AssetPack_PLAY_STORE_NOT_FOUND:'AssetPack_PLAY_STORE_NOT_FOUND',AssetPack_NETWORK_UNRESTRICTED:'AssetPack_NETWORK_UNRESTRICTED',AssetPack_INTERNAL_ERROR:'AssetPack_INTERNAL_ERROR',AssetPack_INITIALIZATION_NEEDED:'AssetPack_INITIALIZATION_NEEDED',AssetPack_INITIALIZATION_FAILED:'AssetPack_INITIALIZATION_FAILED',AssetPack_MAX:'AssetPack_MAX', };
declare type EGooglePADStorageMethod = 'AssetPack_STORAGE_FILES' | 'AssetPack_STORAGE_APK' | 'AssetPack_STORAGE_UNKNOWN' | 'AssetPack_STORAGE_NOT_INSTALLED' | 'AssetPack_STORAGE_MAX';
declare var EGooglePADStorageMethod : { AssetPack_STORAGE_FILES:'AssetPack_STORAGE_FILES',AssetPack_STORAGE_APK:'AssetPack_STORAGE_APK',AssetPack_STORAGE_UNKNOWN:'AssetPack_STORAGE_UNKNOWN',AssetPack_STORAGE_NOT_INSTALLED:'AssetPack_STORAGE_NOT_INSTALLED',AssetPack_STORAGE_MAX:'AssetPack_STORAGE_MAX', };
declare type EGooglePADCellularDataConfirmStatus = 'AssetPack_CONFIRM_UNKNOWN' | 'AssetPack_CONFIRM_PENDING' | 'AssetPack_CONFIRM_USER_APPROVED' | 'AssetPack_CONFIRM_USER_CANCELED' | 'AssetPack_CONFIRM_MAX';
declare var EGooglePADCellularDataConfirmStatus : { AssetPack_CONFIRM_UNKNOWN:'AssetPack_CONFIRM_UNKNOWN',AssetPack_CONFIRM_PENDING:'AssetPack_CONFIRM_PENDING',AssetPack_CONFIRM_USER_APPROVED:'AssetPack_CONFIRM_USER_APPROVED',AssetPack_CONFIRM_USER_CANCELED:'AssetPack_CONFIRM_USER_CANCELED',AssetPack_CONFIRM_MAX:'AssetPack_CONFIRM_MAX', };
declare type EGooglePADDownloadStatus = 'AssetPack_UNKNOWN' | 'AssetPack_DOWNLOAD_PENDING' | 'AssetPack_DOWNLOADING' | 'AssetPack_TRANSFERRING' | 'AssetPack_DOWNLOAD_COMPLETED' | 'AssetPack_DOWNLOAD_FAILED' | 'AssetPack_DOWNLOAD_CANCELED' | 'AssetPack_WAITING_FOR_WIFI' | 'AssetPack_NOT_INSTALLED' | 'AssetPack_INFO_PENDING' | 'AssetPack_INFO_FAILED' | 'AssetPack_REMOVAL_PENDING' | 'AssetPack_REMOVAL_FAILED' | 'AssetPack_MAX';
declare var EGooglePADDownloadStatus : { AssetPack_UNKNOWN:'AssetPack_UNKNOWN',AssetPack_DOWNLOAD_PENDING:'AssetPack_DOWNLOAD_PENDING',AssetPack_DOWNLOADING:'AssetPack_DOWNLOADING',AssetPack_TRANSFERRING:'AssetPack_TRANSFERRING',AssetPack_DOWNLOAD_COMPLETED:'AssetPack_DOWNLOAD_COMPLETED',AssetPack_DOWNLOAD_FAILED:'AssetPack_DOWNLOAD_FAILED',AssetPack_DOWNLOAD_CANCELED:'AssetPack_DOWNLOAD_CANCELED',AssetPack_WAITING_FOR_WIFI:'AssetPack_WAITING_FOR_WIFI',AssetPack_NOT_INSTALLED:'AssetPack_NOT_INSTALLED',AssetPack_INFO_PENDING:'AssetPack_INFO_PENDING',AssetPack_INFO_FAILED:'AssetPack_INFO_FAILED',AssetPack_REMOVAL_PENDING:'AssetPack_REMOVAL_PENDING',AssetPack_REMOVAL_FAILED:'AssetPack_REMOVAL_FAILED',AssetPack_MAX:'AssetPack_MAX', };
declare class GooglePADFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): GooglePADFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): GooglePADFunctionLibrary;
	static GetDefaultObject(): GooglePADFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GooglePADFunctionLibrary;
	static ShowCellularDataConfirmation(): EGooglePADErrorCode;
	static RequestRemoval(Name: string): EGooglePADErrorCode;
	static RequestInfo(AssetPacks: string[]): EGooglePADErrorCode;
	static RequestDownload(AssetPacks: string[]): EGooglePADErrorCode;
	static ReleaseDownloadState(State: number): void;
	static ReleaseAssetPackLocation(Location: number): void;
	static GetTotalBytesToDownload(State: number): number;
	static GetStorageMethod(Location: number): EGooglePADStorageMethod;
	static GetShowCellularDataConfirmationStatus(Status?: EGooglePADCellularDataConfirmStatus): {Status: EGooglePADCellularDataConfirmStatus, $: EGooglePADErrorCode};
	static GetDownloadStatus(State: number): EGooglePADDownloadStatus;
	static GetDownloadState(Name: string,State?: number): {State: number, $: EGooglePADErrorCode};
	static GetBytesDownloaded(State: number): number;
	static GetAssetsPath(Location: number): string;
	static GetAssetPackLocation(Name: string,Location?: number): {Location: number, $: EGooglePADErrorCode};
	static CancelDownload(AssetPacks: string[]): EGooglePADErrorCode;
	static C(Other: UObject | any): GooglePADFunctionLibrary;
}

declare class MeshCommandChangeTarget extends Interface { 
	static Load(ResourceName: string): MeshCommandChangeTarget;
	static Find(Outer: UObject, ResourceName: string): MeshCommandChangeTarget;
	static GetDefaultObject(): MeshCommandChangeTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshCommandChangeTarget;
	static C(Other: UObject | any): MeshCommandChangeTarget;
}

declare class MeshReplacementCommandChangeTarget extends Interface { 
	static Load(ResourceName: string): MeshReplacementCommandChangeTarget;
	static Find(Outer: UObject, ResourceName: string): MeshReplacementCommandChangeTarget;
	static GetDefaultObject(): MeshReplacementCommandChangeTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshReplacementCommandChangeTarget;
	static C(Other: UObject | any): MeshReplacementCommandChangeTarget;
}

declare class MeshVertexCommandChangeTarget extends Interface { 
	static Load(ResourceName: string): MeshVertexCommandChangeTarget;
	static Find(Outer: UObject, ResourceName: string): MeshVertexCommandChangeTarget;
	static GetDefaultObject(): MeshVertexCommandChangeTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshVertexCommandChangeTarget;
	static C(Other: UObject | any): MeshVertexCommandChangeTarget;
}

declare type EDynamicMeshComponentColorOverrideMode = 'None' | 'VertexColors' | 'Polygroups' | 'Constant' | 'EDynamicMeshComponentColorOverrideMode_MAX';
declare var EDynamicMeshComponentColorOverrideMode : { None:'None',VertexColors:'VertexColors',Polygroups:'Polygroups',Constant:'Constant',EDynamicMeshComponentColorOverrideMode_MAX:'EDynamicMeshComponentColorOverrideMode_MAX', };
declare class DynamicMeshGenerator extends UObject { 
	static Load(ResourceName: string): DynamicMeshGenerator;
	static Find(Outer: UObject, ResourceName: string): DynamicMeshGenerator;
	static GetDefaultObject(): DynamicMeshGenerator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshGenerator;
	static C(Other: UObject | any): DynamicMeshGenerator;
}

declare class DynamicMesh extends UObject { 
	MeshModifiedBPEvent: UnrealEngineMulticastDelegate<(Mesh: DynamicMesh) => void>;
	MeshGenerator: DynamicMeshGenerator;
	bEnableMeshGenerator: boolean;
	static Load(ResourceName: string): DynamicMesh;
	static Find(Outer: UObject, ResourceName: string): DynamicMesh;
	static GetDefaultObject(): DynamicMesh;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMesh;
	ResetToCube(): DynamicMesh;
	Reset(): DynamicMesh;
	IsEmpty(): boolean;
	GetTriangleCount(): number;
	static C(Other: UObject | any): DynamicMesh;
}

declare class BaseDynamicMeshComponent extends MeshComponent { 
	bExplicitShowWireframe: boolean;
	WireframeColor: LinearColor;
	ColorMode: EDynamicMeshComponentColorOverrideMode;
	ConstantColor: Color;
	bEnableFlatShading: boolean;
	bEnableViewModeOverrides: boolean;
	OverrideRenderMaterial: MaterialInterface;
	SecondaryRenderMaterial: MaterialInterface;
	bEnableRayTracing: boolean;
	BaseMaterials: MaterialInterface[];
	static Load(ResourceName: string): BaseDynamicMeshComponent;
	static Find(Outer: UObject, ResourceName: string): BaseDynamicMeshComponent;
	static GetDefaultObject(): BaseDynamicMeshComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BaseDynamicMeshComponent;
	SetViewModeOverridesEnabled(bEnabled: boolean): void;
	SetShadowsEnabled(bEnabled: boolean): void;
	SetSecondaryRenderMaterial(Material: MaterialInterface): void;
	SetSecondaryBuffersVisibility(bSetVisible: boolean): void;
	SetOverrideRenderMaterial(Material: MaterialInterface): void;
	SetEnableWireframeRenderPass(bEnable: boolean): void;
	SetEnableRaytracing(bSetEnabled: boolean): void;
	SetEnableFlatShading(bEnable: boolean): void;
	SetConstantOverrideColor(NewColor: Color): void;
	SetColorOverrideMode(NewMode: EDynamicMeshComponentColorOverrideMode): void;
	HasOverrideRenderMaterial(K: number): boolean;
	GetViewModeOverridesEnabled(): boolean;
	GetShadowsEnabled(): boolean;
	GetSecondaryRenderMaterial(): MaterialInterface;
	GetSecondaryBuffersVisibility(): boolean;
	GetOverrideRenderMaterial(MaterialIndex: number): MaterialInterface;
	GetFlatShadingEnabled(): boolean;
	GetEnableWireframeRenderPass(): boolean;
	GetEnableRaytracing(): boolean;
	GetDynamicMesh(): DynamicMesh;
	GetConstantOverrideColor(): Color;
	GetColorOverrideMode(): EDynamicMeshComponentColorOverrideMode;
	ClearSecondaryRenderMaterial(): void;
	ClearOverrideRenderMaterial(): void;
	static C(Other: UObject | any): BaseDynamicMeshComponent;
}

declare type EDynamicMeshComponentTangentsMode = 'NoTangents' | 'AutoCalculated' | 'ExternallyProvided' | 'EDynamicMeshComponentTangentsMode_MAX';
declare var EDynamicMeshComponentTangentsMode : { NoTangents:'NoTangents',AutoCalculated:'AutoCalculated',ExternallyProvided:'ExternallyProvided',EDynamicMeshComponentTangentsMode_MAX:'EDynamicMeshComponentTangentsMode_MAX', };
declare class DynamicMeshComponent extends BaseDynamicMeshComponent { 
	MeshObject: DynamicMesh;
	TangentsType: EDynamicMeshComponentTangentsMode;
	CollisionType: ECollisionTraceFlag;
	bUseAsyncCooking: boolean;
	bEnableComplexCollision: boolean;
	bDeferCollisionUpdates: boolean;
	MeshBodySetup: BodySetup;
	AggGeom: KAggregateGeom;
	AsyncBodySetupQueue: BodySetup[];
	static Load(ResourceName: string): DynamicMeshComponent;
	static Find(Outer: UObject, ResourceName: string): DynamicMeshComponent;
	static GetDefaultObject(): DynamicMeshComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshComponent;
	ValidateMaterialSlots(bCreateIfMissing: boolean,bDeleteExtraSlots: boolean): boolean;
	UpdateCollision(bOnlyIfPending: boolean): void;
	SetTangentsType(NewTangentsType: EDynamicMeshComponentTangentsMode): void;
	SetDynamicMesh(NewMesh: DynamicMesh): void;
	SetDeferredCollisionUpdatesEnabled(bEnabled: boolean,bImmediateUpdate: boolean): void;
	SetComplexAsSimpleCollisionEnabled(bEnabled: boolean,bImmediateUpdate: boolean): void;
	GetTangentsType(): EDynamicMeshComponentTangentsMode;
	EnableComplexAsSimpleCollision(): void;
	ConfigureMaterialSet(NewMaterialSet: MaterialInterface[]): void;
	static C(Other: UObject | any): DynamicMeshComponent;
}

declare class DynamicMeshPool extends UObject { 
	CachedMeshes: DynamicMesh[];
	AllCreatedMeshes: DynamicMesh[];
	static Load(ResourceName: string): DynamicMeshPool;
	static Find(Outer: UObject, ResourceName: string): DynamicMeshPool;
	static GetDefaultObject(): DynamicMeshPool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshPool;
	ReturnMesh(Mesh: DynamicMesh): void;
	ReturnAllMeshes(): void;
	RequestMesh(): DynamicMesh;
	FreeAllMeshes(): void;
	static C(Other: UObject | any): DynamicMeshPool;
}

declare class DynamicMeshActor extends Actor { 
	DynamicMeshComponent: DynamicMeshComponent;
	bEnableComputeMeshPool: boolean;
	DynamicMeshPool: DynamicMeshPool;
	static GetDefaultObject(): DynamicMeshActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshActor;
	ReleaseComputeMesh(Mesh: DynamicMesh): boolean;
	ReleaseAllComputeMeshes(): void;
	GetDynamicMeshComponent(): DynamicMeshComponent;
	GetComputeMeshPool(): DynamicMeshPool;
	FreeAllComputeMeshes(): void;
	AllocateComputeMesh(): DynamicMesh;
	static C(Other: UObject | any): DynamicMeshActor;
}

declare class DynamicMeshCommitter extends Interface { 
	static Load(ResourceName: string): DynamicMeshCommitter;
	static Find(Outer: UObject, ResourceName: string): DynamicMeshCommitter;
	static GetDefaultObject(): DynamicMeshCommitter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshCommitter;
	static C(Other: UObject | any): DynamicMeshCommitter;
}

declare class DynamicMeshProvider extends Interface { 
	static Load(ResourceName: string): DynamicMeshProvider;
	static Find(Outer: UObject, ResourceName: string): DynamicMeshProvider;
	static GetDefaultObject(): DynamicMeshProvider;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshProvider;
	static C(Other: UObject | any): DynamicMeshProvider;
}

declare class PersistentDynamicMeshSource extends Interface { 
	static Load(ResourceName: string): PersistentDynamicMeshSource;
	static Find(Outer: UObject, ResourceName: string): PersistentDynamicMeshSource;
	static GetDefaultObject(): PersistentDynamicMeshSource;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PersistentDynamicMeshSource;
	static C(Other: UObject | any): PersistentDynamicMeshSource;
}

declare class GeometrySelectionEditCommandArguments extends InteractiveCommandArguments { 
	static Load(ResourceName: string): GeometrySelectionEditCommandArguments;
	static Find(Outer: UObject, ResourceName: string): GeometrySelectionEditCommandArguments;
	static GetDefaultObject(): GeometrySelectionEditCommandArguments;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometrySelectionEditCommandArguments;
	static C(Other: UObject | any): GeometrySelectionEditCommandArguments;
}

declare class PersistentMeshSelection extends UObject { 
	static Load(ResourceName: string): PersistentMeshSelection;
	static Find(Outer: UObject, ResourceName: string): PersistentMeshSelection;
	static GetDefaultObject(): PersistentMeshSelection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PersistentMeshSelection;
	static C(Other: UObject | any): PersistentMeshSelection;
}

declare class GeometrySelectionManager extends UObject { 
	SelectionArguments: GeometrySelectionEditCommandArguments;
	ToolsContext: InteractiveToolsContext;
	OldSelection: PersistentMeshSelection;
	static Load(ResourceName: string): GeometrySelectionManager;
	static Find(Outer: UObject, ResourceName: string): GeometrySelectionManager;
	static GetDefaultObject(): GeometrySelectionManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometrySelectionManager;
	static C(Other: UObject | any): GeometrySelectionManager;
}

declare class InteractiveToolActivity extends InteractionMechanic { 
	static Load(ResourceName: string): InteractiveToolActivity;
	static Find(Outer: UObject, ResourceName: string): InteractiveToolActivity;
	static GetDefaultObject(): InteractiveToolActivity;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InteractiveToolActivity;
	static C(Other: UObject | any): InteractiveToolActivity;
}

declare class ToolActivityHost extends Interface { 
	static Load(ResourceName: string): ToolActivityHost;
	static Find(Outer: UObject, ResourceName: string): ToolActivityHost;
	static GetDefaultObject(): ToolActivityHost;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ToolActivityHost;
	static C(Other: UObject | any): ToolActivityHost;
}

declare class GeometrySelectionEditCommand extends InteractiveCommand { 
	static Load(ResourceName: string): GeometrySelectionEditCommand;
	static Find(Outer: UObject, ResourceName: string): GeometrySelectionEditCommand;
	static GetDefaultObject(): GeometrySelectionEditCommand;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GeometrySelectionEditCommand;
	static C(Other: UObject | any): GeometrySelectionEditCommand;
}

declare class VoxelProperties extends InteractiveToolPropertySet { 
	VoxelCount: number;
	bAutoSimplify: boolean;
	bRemoveInternalSurfaces: boolean;
	SimplifyMaxErrorFactor: number;
	CubeRootMinComponentVolume: number;
	static Load(ResourceName: string): VoxelProperties;
	static Find(Outer: UObject, ResourceName: string): VoxelProperties;
	static GetDefaultObject(): VoxelProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VoxelProperties;
	static C(Other: UObject | any): VoxelProperties;
}

declare class MultiSelectionMeshEditingToolBuilder extends InteractiveToolWithToolTargetsBuilder { 
	static Load(ResourceName: string): MultiSelectionMeshEditingToolBuilder;
	static Find(Outer: UObject, ResourceName: string): MultiSelectionMeshEditingToolBuilder;
	static GetDefaultObject(): MultiSelectionMeshEditingToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MultiSelectionMeshEditingToolBuilder;
	static C(Other: UObject | any): MultiSelectionMeshEditingToolBuilder;
}

declare class BaseCreateFromSelectedToolBuilder extends MultiSelectionMeshEditingToolBuilder { 
	static Load(ResourceName: string): BaseCreateFromSelectedToolBuilder;
	static Find(Outer: UObject, ResourceName: string): BaseCreateFromSelectedToolBuilder;
	static GetDefaultObject(): BaseCreateFromSelectedToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BaseCreateFromSelectedToolBuilder;
	static C(Other: UObject | any): BaseCreateFromSelectedToolBuilder;
}

declare class OnAcceptHandleSourcesPropertiesBase extends InteractiveToolPropertySet { 
	static Load(ResourceName: string): OnAcceptHandleSourcesPropertiesBase;
	static Find(Outer: UObject, ResourceName: string): OnAcceptHandleSourcesPropertiesBase;
	static GetDefaultObject(): OnAcceptHandleSourcesPropertiesBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAcceptHandleSourcesPropertiesBase;
	static C(Other: UObject | any): OnAcceptHandleSourcesPropertiesBase;
}

declare type EHandleSourcesMethod = 'DeleteSources' | 'HideSources' | 'KeepSources' | 'KeepFirstSource' | 'KeepLastSource' | 'EHandleSourcesMethod_MAX';
declare var EHandleSourcesMethod : { DeleteSources:'DeleteSources',HideSources:'HideSources',KeepSources:'KeepSources',KeepFirstSource:'KeepFirstSource',KeepLastSource:'KeepLastSource',EHandleSourcesMethod_MAX:'EHandleSourcesMethod_MAX', };
declare class OnAcceptHandleSourcesProperties extends OnAcceptHandleSourcesPropertiesBase { 
	HandleInputs: EHandleSourcesMethod;
	static Load(ResourceName: string): OnAcceptHandleSourcesProperties;
	static Find(Outer: UObject, ResourceName: string): OnAcceptHandleSourcesProperties;
	static GetDefaultObject(): OnAcceptHandleSourcesProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAcceptHandleSourcesProperties;
	static C(Other: UObject | any): OnAcceptHandleSourcesProperties;
}

declare type EBaseCreateFromSelectedTargetType = 'NewObject' | 'FirstInputObject' | 'LastInputObject' | 'EBaseCreateFromSelectedTargetType_MAX';
declare var EBaseCreateFromSelectedTargetType : { NewObject:'NewObject',FirstInputObject:'FirstInputObject',LastInputObject:'LastInputObject',EBaseCreateFromSelectedTargetType_MAX:'EBaseCreateFromSelectedTargetType_MAX', };
declare class BaseCreateFromSelectedHandleSourceProperties extends OnAcceptHandleSourcesProperties { 
	OutputWriteTo: EBaseCreateFromSelectedTargetType;
	OutputNewName: string;
	OutputExistingName: string;
	static Load(ResourceName: string): BaseCreateFromSelectedHandleSourceProperties;
	static Find(Outer: UObject, ResourceName: string): BaseCreateFromSelectedHandleSourceProperties;
	static GetDefaultObject(): BaseCreateFromSelectedHandleSourceProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BaseCreateFromSelectedHandleSourceProperties;
	static C(Other: UObject | any): BaseCreateFromSelectedHandleSourceProperties;
}

declare class TransformInputsToolProperties extends InteractiveToolPropertySet { 
	bShowTransformGizmo: boolean;
	static Load(ResourceName: string): TransformInputsToolProperties;
	static Find(Outer: UObject, ResourceName: string): TransformInputsToolProperties;
	static GetDefaultObject(): TransformInputsToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TransformInputsToolProperties;
	static C(Other: UObject | any): TransformInputsToolProperties;
}

declare class MultiSelectionMeshEditingTool extends MultiSelectionTool { 
	TargetWorld: World;
	static Load(ResourceName: string): MultiSelectionMeshEditingTool;
	static Find(Outer: UObject, ResourceName: string): MultiSelectionMeshEditingTool;
	static GetDefaultObject(): MultiSelectionMeshEditingTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MultiSelectionMeshEditingTool;
	static C(Other: UObject | any): MultiSelectionMeshEditingTool;
}

declare type ECreateObjectTypeHint = 'Undefined' | 'StaticMesh' | 'Volume' | 'DynamicMeshActor' | 'ECreateObjectTypeHint_MAX';
declare var ECreateObjectTypeHint : { Undefined:'Undefined',StaticMesh:'StaticMesh',Volume:'Volume',DynamicMeshActor:'DynamicMeshActor',ECreateObjectTypeHint_MAX:'ECreateObjectTypeHint_MAX', };
declare class CreateMeshObjectTypeProperties extends InteractiveToolPropertySet { 
	OutputType: string;
	VolumeType: UnrealEngineClass;
	OutputTypeNamesList: string[];
	bShowVolumeList: boolean;
	static Load(ResourceName: string): CreateMeshObjectTypeProperties;
	static Find(Outer: UObject, ResourceName: string): CreateMeshObjectTypeProperties;
	static GetDefaultObject(): CreateMeshObjectTypeProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CreateMeshObjectTypeProperties;
	ShouldShowPropertySet(): boolean;
	GetOutputTypeNamesFunc(): string[];
	GetCurrentCreateMeshType(): ECreateObjectTypeHint;
	static C(Other: UObject | any): CreateMeshObjectTypeProperties;
}

declare class PreviewMesh extends UObject { 
	bBuildSpatialDataStructure: boolean;
	DynamicMeshComponent: DynamicMeshComponent;
	static Load(ResourceName: string): PreviewMesh;
	static Find(Outer: UObject, ResourceName: string): PreviewMesh;
	static GetDefaultObject(): PreviewMesh;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PreviewMesh;
	static C(Other: UObject | any): PreviewMesh;
}

declare class MeshOpPreviewWithBackgroundCompute extends UObject { 
	PreviewMesh: PreviewMesh;
	StandardMaterials: MaterialInterface[];
	OverrideMaterial: MaterialInterface;
	WorkingMaterial: MaterialInterface;
	SecondaryMaterial: MaterialInterface;
	PreviewWorld: World;
	static Load(ResourceName: string): MeshOpPreviewWithBackgroundCompute;
	static Find(Outer: UObject, ResourceName: string): MeshOpPreviewWithBackgroundCompute;
	static GetDefaultObject(): MeshOpPreviewWithBackgroundCompute;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshOpPreviewWithBackgroundCompute;
	static C(Other: UObject | any): MeshOpPreviewWithBackgroundCompute;
}

declare class BaseCreateFromSelectedTool extends MultiSelectionMeshEditingTool { 
	TransformProperties: TransformInputsToolProperties;
	OutputTypeProperties: CreateMeshObjectTypeProperties;
	HandleSourcesProperties: BaseCreateFromSelectedHandleSourceProperties;
	Preview: MeshOpPreviewWithBackgroundCompute;
	TransformProxies: TransformProxy[];
	TransformGizmos: CombinedTransformGizmo[];
	static Load(ResourceName: string): BaseCreateFromSelectedTool;
	static Find(Outer: UObject, ResourceName: string): BaseCreateFromSelectedTool;
	static GetDefaultObject(): BaseCreateFromSelectedTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BaseCreateFromSelectedTool;
	static C(Other: UObject | any): BaseCreateFromSelectedTool;
}

declare class BaseMeshProcessingToolBuilder extends InteractiveToolWithToolTargetsBuilder { 
	static Load(ResourceName: string): BaseMeshProcessingToolBuilder;
	static Find(Outer: UObject, ResourceName: string): BaseMeshProcessingToolBuilder;
	static GetDefaultObject(): BaseMeshProcessingToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BaseMeshProcessingToolBuilder;
	static C(Other: UObject | any): BaseMeshProcessingToolBuilder;
}

declare class BaseMeshProcessingTool extends SingleSelectionTool { 
	Preview: MeshOpPreviewWithBackgroundCompute;
	static Load(ResourceName: string): BaseMeshProcessingTool;
	static Find(Outer: UObject, ResourceName: string): BaseMeshProcessingTool;
	static GetDefaultObject(): BaseMeshProcessingTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BaseMeshProcessingTool;
	static C(Other: UObject | any): BaseMeshProcessingTool;
}

declare class BaseVoxelTool extends BaseCreateFromSelectedTool { 
	VoxProperties: VoxelProperties;
	static Load(ResourceName: string): BaseVoxelTool;
	static Find(Outer: UObject, ResourceName: string): BaseVoxelTool;
	static GetDefaultObject(): BaseVoxelTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BaseVoxelTool;
	static C(Other: UObject | any): BaseVoxelTool;
}

declare class MeshSurfacePointMeshEditingToolBuilder extends MeshSurfacePointToolBuilder { 
	static Load(ResourceName: string): MeshSurfacePointMeshEditingToolBuilder;
	static Find(Outer: UObject, ResourceName: string): MeshSurfacePointMeshEditingToolBuilder;
	static GetDefaultObject(): MeshSurfacePointMeshEditingToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshSurfacePointMeshEditingToolBuilder;
	static C(Other: UObject | any): MeshSurfacePointMeshEditingToolBuilder;
}

declare class SingleSelectionMeshEditingToolBuilder extends InteractiveToolWithToolTargetsBuilder { 
	static Load(ResourceName: string): SingleSelectionMeshEditingToolBuilder;
	static Find(Outer: UObject, ResourceName: string): SingleSelectionMeshEditingToolBuilder;
	static GetDefaultObject(): SingleSelectionMeshEditingToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SingleSelectionMeshEditingToolBuilder;
	static C(Other: UObject | any): SingleSelectionMeshEditingToolBuilder;
}

declare class SingleSelectionMeshEditingTool extends SingleSelectionTool { 
	TargetWorld: World;
	InputSelection: PersistentMeshSelection;
	static Load(ResourceName: string): SingleSelectionMeshEditingTool;
	static Find(Outer: UObject, ResourceName: string): SingleSelectionMeshEditingTool;
	static GetDefaultObject(): SingleSelectionMeshEditingTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SingleSelectionMeshEditingTool;
	static C(Other: UObject | any): SingleSelectionMeshEditingTool;
}

declare class DynamicMeshReplacementChangeTarget extends UObject { 
	static Load(ResourceName: string): DynamicMeshReplacementChangeTarget;
	static Find(Outer: UObject, ResourceName: string): DynamicMeshReplacementChangeTarget;
	static GetDefaultObject(): DynamicMeshReplacementChangeTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshReplacementChangeTarget;
	static C(Other: UObject | any): DynamicMeshReplacementChangeTarget;
}

declare class OctreeDynamicMeshComponent extends BaseDynamicMeshComponent { 
	MeshObject: DynamicMesh;
	static Load(ResourceName: string): OctreeDynamicMeshComponent;
	static Find(Outer: UObject, ResourceName: string): OctreeDynamicMeshComponent;
	static GetDefaultObject(): OctreeDynamicMeshComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OctreeDynamicMeshComponent;
	SetDynamicMesh(NewMesh: DynamicMesh): void;
	static C(Other: UObject | any): OctreeDynamicMeshComponent;
}

declare class LineSetComponent extends MeshComponent { 
	LineMaterial: MaterialInterface;
	Bounds: BoxSphereBounds;
	bBoundsDirty: boolean;
	static Load(ResourceName: string): LineSetComponent;
	static Find(Outer: UObject, ResourceName: string): LineSetComponent;
	static GetDefaultObject(): LineSetComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LineSetComponent;
	static C(Other: UObject | any): LineSetComponent;
}

declare class MeshElementsVisualizerProperties extends InteractiveToolPropertySet { 
	bVisible: boolean;
	bShowWireframe: boolean;
	bShowBorders: boolean;
	bShowUVSeams: boolean;
	bShowNormalSeams: boolean;
	bShowColorSeams: boolean;
	ThicknessScale: number;
	WireframeColor: Color;
	BoundaryEdgeColor: Color;
	UVSeamColor: Color;
	NormalSeamColor: Color;
	ColorSeamColor: Color;
	DepthBias: number;
	bAdjustDepthBiasUsingMeshSize: boolean;
	static Load(ResourceName: string): MeshElementsVisualizerProperties;
	static Find(Outer: UObject, ResourceName: string): MeshElementsVisualizerProperties;
	static GetDefaultObject(): MeshElementsVisualizerProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshElementsVisualizerProperties;
	static C(Other: UObject | any): MeshElementsVisualizerProperties;
}

declare class PreviewGeometryActor extends InternalToolFrameworkActor { 
	static GetDefaultObject(): PreviewGeometryActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PreviewGeometryActor;
	static C(Other: UObject | any): PreviewGeometryActor;
}

declare class PointSetComponent extends MeshComponent { 
	PointMaterial: MaterialInterface;
	Bounds: BoxSphereBounds;
	bBoundsDirty: boolean;
	static Load(ResourceName: string): PointSetComponent;
	static Find(Outer: UObject, ResourceName: string): PointSetComponent;
	static GetDefaultObject(): PointSetComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PointSetComponent;
	static C(Other: UObject | any): PointSetComponent;
}

declare class PreviewGeometry extends UObject { 
	ParentActor: PreviewGeometryActor;
	LineSets: Map<string, LineSetComponent>;
	PointSets: Map<string, PointSetComponent>;
	static Load(ResourceName: string): PreviewGeometry;
	static Find(Outer: UObject, ResourceName: string): PreviewGeometry;
	static GetDefaultObject(): PreviewGeometry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PreviewGeometry;
	SetPointSetVisibility(PointSetIdentifier: string,bVisible: boolean): boolean;
	SetPointSetMaterial(PointSetIdentifier: string,NewMaterial: MaterialInterface): boolean;
	SetLineSetVisibility(LineSetIdentifier: string,bVisible: boolean): boolean;
	SetLineSetMaterial(LineSetIdentifier: string,NewMaterial: MaterialInterface): boolean;
	SetAllPointSetsMaterial(Material: MaterialInterface): void;
	SetAllLineSetsMaterial(Material: MaterialInterface): void;
	RemovePointSet(PointSetIdentifier: string,bDestroy: boolean): boolean;
	RemoveLineSet(LineSetIdentifier: string,bDestroy: boolean): boolean;
	RemoveAllPointSets(bDestroy: boolean): void;
	RemoveAllLineSets(bDestroy: boolean): void;
	GetActor(): PreviewGeometryActor;
	FindPointSet(PointSetIdentifier: string): PointSetComponent;
	FindLineSet(LineSetIdentifier: string): LineSetComponent;
	Disconnect(): void;
	CreateInWorld(World: World,WithTransform: Transform): void;
	AddPointSet(PointSetIdentifier: string): PointSetComponent;
	AddLineSet(LineSetIdentifier: string): LineSetComponent;
	static C(Other: UObject | any): PreviewGeometry;
}

declare class MeshWireframeComponent extends MeshComponent { 
	LineDepthBias: number;
	LineDepthBiasSizeScale: number;
	ThicknessScale: number;
	bEnableWireframe: boolean;
	WireframeColor: Color;
	WireframeThickness: number;
	bEnableBoundaryEdges: boolean;
	BoundaryEdgeColor: Color;
	BoundaryEdgeThickness: number;
	bEnableUVSeams: boolean;
	UVSeamColor: Color;
	UVSeamThickness: number;
	bEnableNormalSeams: boolean;
	NormalSeamColor: Color;
	NormalSeamThickness: number;
	bEnableColorSeams: boolean;
	ColorSeamColor: Color;
	ColorSeamThickness: number;
	LineMaterial: MaterialInterface;
	LocalBounds: BoxSphereBounds;
	static Load(ResourceName: string): MeshWireframeComponent;
	static Find(Outer: UObject, ResourceName: string): MeshWireframeComponent;
	static GetDefaultObject(): MeshWireframeComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshWireframeComponent;
	static C(Other: UObject | any): MeshWireframeComponent;
}

declare class MeshElementsVisualizer extends PreviewGeometry { 
	Settings: MeshElementsVisualizerProperties;
	WireframeComponent: MeshWireframeComponent;
	static Load(ResourceName: string): MeshElementsVisualizer;
	static Find(Outer: UObject, ResourceName: string): MeshElementsVisualizer;
	static GetDefaultObject(): MeshElementsVisualizer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshElementsVisualizer;
	static C(Other: UObject | any): MeshElementsVisualizer;
}

declare class PolyEditPreviewMesh extends PreviewMesh { 
	static Load(ResourceName: string): PolyEditPreviewMesh;
	static Find(Outer: UObject, ResourceName: string): PolyEditPreviewMesh;
	static GetDefaultObject(): PolyEditPreviewMesh;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditPreviewMesh;
	static C(Other: UObject | any): PolyEditPreviewMesh;
}

declare class TriangleSetComponent extends MeshComponent { 
	Bounds: BoxSphereBounds;
	bBoundsDirty: boolean;
	static Load(ResourceName: string): TriangleSetComponent;
	static Find(Outer: UObject, ResourceName: string): TriangleSetComponent;
	static GetDefaultObject(): TriangleSetComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TriangleSetComponent;
	static C(Other: UObject | any): TriangleSetComponent;
}

declare type EUVLayoutPreviewSide = 'Left' | 'Right' | 'EUVLayoutPreviewSide_MAX';
declare var EUVLayoutPreviewSide : { Left:'Left',Right:'Right',EUVLayoutPreviewSide_MAX:'EUVLayoutPreviewSide_MAX', };
declare class UVLayoutPreviewProperties extends InteractiveToolPropertySet { 
	bEnabled: boolean;
	Side: EUVLayoutPreviewSide;
	Scale: number;
	Offset: Vector2D;
	bShowWireframe: boolean;
	static Load(ResourceName: string): UVLayoutPreviewProperties;
	static Find(Outer: UObject, ResourceName: string): UVLayoutPreviewProperties;
	static GetDefaultObject(): UVLayoutPreviewProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVLayoutPreviewProperties;
	static C(Other: UObject | any): UVLayoutPreviewProperties;
}

declare class UVLayoutPreview extends UObject { 
	Settings: UVLayoutPreviewProperties;
	PreviewMesh: PreviewMesh;
	TriangleComponent: TriangleSetComponent;
	bShowBackingRectangle: boolean;
	BackingRectangleMaterial: MaterialInterface;
	static Load(ResourceName: string): UVLayoutPreview;
	static Find(Outer: UObject, ResourceName: string): UVLayoutPreview;
	static GetDefaultObject(): UVLayoutPreview;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVLayoutPreview;
	static C(Other: UObject | any): UVLayoutPreview;
}

declare class CollectSurfacePathMechanic extends InteractionMechanic { 
	static Load(ResourceName: string): CollectSurfacePathMechanic;
	static Find(Outer: UObject, ResourceName: string): CollectSurfacePathMechanic;
	static GetDefaultObject(): CollectSurfacePathMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CollectSurfacePathMechanic;
	static C(Other: UObject | any): CollectSurfacePathMechanic;
}

declare class ConstructionPlaneMechanic extends InteractionMechanic { 
	PlaneTransformGizmo: CombinedTransformGizmo;
	PlaneTransformProxy: TransformProxy;
	ClickToSetPlaneBehavior: SingleClickInputBehavior;
	static Load(ResourceName: string): ConstructionPlaneMechanic;
	static Find(Outer: UObject, ResourceName: string): ConstructionPlaneMechanic;
	static GetDefaultObject(): ConstructionPlaneMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ConstructionPlaneMechanic;
	static C(Other: UObject | any): ConstructionPlaneMechanic;
}

declare class CurveControlPointsMechanic extends InteractionMechanic { 
	ClickBehavior: SingleClickInputBehavior;
	HoverBehavior: MouseHoverBehavior;
	PreviewGeometryActor: PreviewGeometryActor;
	DrawnControlPoints: PointSetComponent;
	DrawnControlSegments: LineSetComponent;
	PreviewPoint: PointSetComponent;
	PreviewSegment: LineSetComponent;
	PointTransformProxy: TransformProxy;
	PointTransformGizmo: CombinedTransformGizmo;
	static Load(ResourceName: string): CurveControlPointsMechanic;
	static Find(Outer: UObject, ResourceName: string): CurveControlPointsMechanic;
	static GetDefaultObject(): CurveControlPointsMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CurveControlPointsMechanic;
	static C(Other: UObject | any): CurveControlPointsMechanic;
}

declare class DragAlignmentMechanic extends InteractionMechanic { 
	static Load(ResourceName: string): DragAlignmentMechanic;
	static Find(Outer: UObject, ResourceName: string): DragAlignmentMechanic;
	static GetDefaultObject(): DragAlignmentMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DragAlignmentMechanic;
	static C(Other: UObject | any): DragAlignmentMechanic;
}

declare class RectangleMarqueeMechanic extends InteractionMechanic { 
	bUseExternalClickDragBehavior: boolean;
	bUseExternalUpdateCameraState: boolean;
	OnDragRectangleChangedDeferredThreshold: number;
	ClickDragBehavior: ClickDragInputBehavior;
	static Load(ResourceName: string): RectangleMarqueeMechanic;
	static Find(Outer: UObject, ResourceName: string): RectangleMarqueeMechanic;
	static GetDefaultObject(): RectangleMarqueeMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RectangleMarqueeMechanic;
	static C(Other: UObject | any): RectangleMarqueeMechanic;
}

declare class LatticeControlPointsMechanic extends InteractionMechanic { 
	PreviewGeometryActor: PreviewGeometryActor;
	DrawnControlPoints: PointSetComponent;
	DrawnLatticeEdges: LineSetComponent;
	PointTransformProxy: TransformProxy;
	PointTransformGizmo: CombinedTransformGizmo;
	MarqueeMechanic: RectangleMarqueeMechanic;
	static Load(ResourceName: string): LatticeControlPointsMechanic;
	static Find(Outer: UObject, ResourceName: string): LatticeControlPointsMechanic;
	static GetDefaultObject(): LatticeControlPointsMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LatticeControlPointsMechanic;
	static C(Other: UObject | any): LatticeControlPointsMechanic;
}

declare class PlaneDistanceFromHitMechanic extends InteractionMechanic { 
	static Load(ResourceName: string): PlaneDistanceFromHitMechanic;
	static Find(Outer: UObject, ResourceName: string): PlaneDistanceFromHitMechanic;
	static GetDefaultObject(): PlaneDistanceFromHitMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlaneDistanceFromHitMechanic;
	static C(Other: UObject | any): PlaneDistanceFromHitMechanic;
}

declare class PolyLassoMarqueeMechanic extends InteractionMechanic { 
	SpacingTolerance: number;
	LineThickness: number;
	LineColor: LinearColor;
	ClosedColor: LinearColor;
	bEnableFreehandPolygons: boolean;
	bEnableMultiClickPolygons: boolean;
	ClickDragBehavior: ClickDragInputBehavior;
	HoverBehavior: MouseHoverBehavior;
	static Load(ResourceName: string): PolyLassoMarqueeMechanic;
	static Find(Outer: UObject, ResourceName: string): PolyLassoMarqueeMechanic;
	static GetDefaultObject(): PolyLassoMarqueeMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyLassoMarqueeMechanic;
	static C(Other: UObject | any): PolyLassoMarqueeMechanic;
}

declare type ESpaceCurveControlPointTransformMode = 'Shared' | 'PerVertex' | 'ESpaceCurveControlPointTransformMode_MAX';
declare var ESpaceCurveControlPointTransformMode : { Shared:'Shared',PerVertex:'PerVertex',ESpaceCurveControlPointTransformMode_MAX:'ESpaceCurveControlPointTransformMode_MAX', };
declare type ESpaceCurveControlPointOriginMode = 'Shared' | 'First' | 'Last' | 'ESpaceCurveControlPointOriginMode_MAX';
declare var ESpaceCurveControlPointOriginMode : { Shared:'Shared',First:'First',Last:'Last',ESpaceCurveControlPointOriginMode_MAX:'ESpaceCurveControlPointOriginMode_MAX', };
declare type ESpaceCurveControlPointFalloffType = 'Linear' | 'Smooth' | 'ESpaceCurveControlPointFalloffType_MAX';
declare var ESpaceCurveControlPointFalloffType : { Linear:'Linear',Smooth:'Smooth',ESpaceCurveControlPointFalloffType_MAX:'ESpaceCurveControlPointFalloffType_MAX', };
declare class SpaceCurveDeformationMechanicPropertySet extends InteractiveToolPropertySet { 
	TransformMode: ESpaceCurveControlPointTransformMode;
	TransformOrigin: ESpaceCurveControlPointOriginMode;
	Softness: number;
	SoftFalloff: ESpaceCurveControlPointFalloffType;
	static Load(ResourceName: string): SpaceCurveDeformationMechanicPropertySet;
	static Find(Outer: UObject, ResourceName: string): SpaceCurveDeformationMechanicPropertySet;
	static GetDefaultObject(): SpaceCurveDeformationMechanicPropertySet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpaceCurveDeformationMechanicPropertySet;
	static C(Other: UObject | any): SpaceCurveDeformationMechanicPropertySet;
}

declare class SpaceCurveDeformationMechanic extends InteractionMechanic { 
	ClickBehavior: SingleClickInputBehavior;
	HoverBehavior: MouseHoverBehavior;
	TransformProperties: SpaceCurveDeformationMechanicPropertySet;
	PreviewGeometryActor: PreviewGeometryActor;
	RenderPoints: PointSetComponent;
	RenderSegments: LineSetComponent;
	PointTransformProxy: TransformProxy;
	PointTransformGizmo: CombinedTransformGizmo;
	static Load(ResourceName: string): SpaceCurveDeformationMechanic;
	static Find(Outer: UObject, ResourceName: string): SpaceCurveDeformationMechanic;
	static GetDefaultObject(): SpaceCurveDeformationMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpaceCurveDeformationMechanic;
	static C(Other: UObject | any): SpaceCurveDeformationMechanic;
}

declare class SpatialCurveDistanceMechanic extends InteractionMechanic { 
	static Load(ResourceName: string): SpatialCurveDistanceMechanic;
	static Find(Outer: UObject, ResourceName: string): SpatialCurveDistanceMechanic;
	static GetDefaultObject(): SpatialCurveDistanceMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpatialCurveDistanceMechanic;
	static C(Other: UObject | any): SpatialCurveDistanceMechanic;
}

declare class ModelingComponentsSettings extends DeveloperSettings { 
	bEnableRayTracingWhileEditing: boolean;
	bEnableRayTracing: boolean;
	bEnableCollision: boolean;
	CollisionMode: ECollisionTraceFlag;
	static Load(ResourceName: string): ModelingComponentsSettings;
	static Find(Outer: UObject, ResourceName: string): ModelingComponentsSettings;
	static GetDefaultObject(): ModelingComponentsSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ModelingComponentsSettings;
	static C(Other: UObject | any): ModelingComponentsSettings;
}

declare class CreateTextureObjectParams { 
	TypeHintExtended: number;
	TargetWorld: World;
	StoreRelativeToObject: UObject;
	BaseName: string;
	GeneratedTransientTexture: Texture2D;
	clone() : CreateTextureObjectParams;
	static C(Other: UObject | any): CreateTextureObjectParams;
}

declare type ECreateModelingObjectResult = 'Ok' | 'Cancelled' | 'Failed_Unknown' | 'Failed_NoAPIFound' | 'Failed_InvalidWorld' | 'Failed_InvalidMesh' | 'Failed_InvalidTexture' | 'Failed_AssetCreationFailed' | 'Failed_ActorCreationFailed' | 'ECreateModelingObjectResult_MAX';
declare var ECreateModelingObjectResult : { Ok:'Ok',Cancelled:'Cancelled',Failed_Unknown:'Failed_Unknown',Failed_NoAPIFound:'Failed_NoAPIFound',Failed_InvalidWorld:'Failed_InvalidWorld',Failed_InvalidMesh:'Failed_InvalidMesh',Failed_InvalidTexture:'Failed_InvalidTexture',Failed_AssetCreationFailed:'Failed_AssetCreationFailed',Failed_ActorCreationFailed:'Failed_ActorCreationFailed',ECreateModelingObjectResult_MAX:'ECreateModelingObjectResult_MAX', };
declare class CreateTextureObjectResult { 
	ResultCode: ECreateModelingObjectResult;
	NewAsset: UObject;
	clone() : CreateTextureObjectResult;
	static C(Other: UObject | any): CreateTextureObjectResult;
}

declare class CreateMeshObjectParams { 
	SourceComponent: PrimitiveComponent;
	TypeHint: ECreateObjectTypeHint;
	TypeHintClass: UnrealEngineClass;
	TypeHintExtended: number;
	TargetWorld: World;
	Transform: Transform;
	BaseName: string;
	Materials: MaterialInterface[];
	AssetMaterials: MaterialInterface[];
	bEnableCollision: boolean;
	CollisionMode: ECollisionTraceFlag;
	bEnableRaytracingSupport: boolean;
	bEnableRecomputeNormals: boolean;
	bEnableRecomputeTangents: boolean;
	bEnableNanite: boolean;
	NaniteProxyTrianglePercent: number;
	NaniteSettings: MeshNaniteSettings;
	clone() : CreateMeshObjectParams;
	static C(Other: UObject | any): CreateMeshObjectParams;
}

declare class CreateMeshObjectResult { 
	ResultCode: ECreateModelingObjectResult;
	NewActor: Actor;
	NewComponent: PrimitiveComponent;
	NewAsset: UObject;
	clone() : CreateMeshObjectResult;
	static C(Other: UObject | any): CreateMeshObjectResult;
}

declare class ModelingObjectsCreationAPI extends UObject { 
	static Load(ResourceName: string): ModelingObjectsCreationAPI;
	static Find(Outer: UObject, ResourceName: string): ModelingObjectsCreationAPI;
	static GetDefaultObject(): ModelingObjectsCreationAPI;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ModelingObjectsCreationAPI;
	CreateTextureObject(CreateTexParams: CreateTextureObjectParams): CreateTextureObjectResult;
	CreateMeshObject(CreateMeshParams: CreateMeshObjectParams): CreateMeshObjectResult;
	static C(Other: UObject | any): ModelingObjectsCreationAPI;
}

declare class PreviewMeshActor extends InternalToolFrameworkActor { 
	static GetDefaultObject(): PreviewMeshActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PreviewMeshActor;
	static C(Other: UObject | any): PreviewMeshActor;
}

declare class OnAcceptHandleSourcesPropertiesSingle extends OnAcceptHandleSourcesPropertiesBase { 
	HandleInputs: EHandleSourcesMethod;
	static Load(ResourceName: string): OnAcceptHandleSourcesPropertiesSingle;
	static Find(Outer: UObject, ResourceName: string): OnAcceptHandleSourcesPropertiesSingle;
	static GetDefaultObject(): OnAcceptHandleSourcesPropertiesSingle;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnAcceptHandleSourcesPropertiesSingle;
	static C(Other: UObject | any): OnAcceptHandleSourcesPropertiesSingle;
}

declare class PolygroupLayersProperties extends InteractiveToolPropertySet { 
	ActiveGroupLayer: string;
	GroupLayersList: string[];
	static Load(ResourceName: string): PolygroupLayersProperties;
	static Find(Outer: UObject, ResourceName: string): PolygroupLayersProperties;
	static GetDefaultObject(): PolygroupLayersProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolygroupLayersProperties;
	GetGroupLayersFunc(): string[];
	static C(Other: UObject | any): PolygroupLayersProperties;
}

declare class WeightMapSetProperties extends InteractiveToolPropertySet { 
	WeightMap: string;
	WeightMapsList: string[];
	bInvertWeightMap: boolean;
	static Load(ResourceName: string): WeightMapSetProperties;
	static Find(Outer: UObject, ResourceName: string): WeightMapSetProperties;
	static GetDefaultObject(): WeightMapSetProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WeightMapSetProperties;
	GetWeightMapsFunc(): string[];
	static C(Other: UObject | any): WeightMapSetProperties;
}

declare class PersistentMeshSelectionManager extends UObject { 
	ParentContext: InteractiveToolsContext;
	ActiveSelection: PersistentMeshSelection;
	SelectionDisplay: PreviewGeometry;
	static Load(ResourceName: string): PersistentMeshSelectionManager;
	static Find(Outer: UObject, ResourceName: string): PersistentMeshSelectionManager;
	static GetDefaultObject(): PersistentMeshSelectionManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PersistentMeshSelectionManager;
	static C(Other: UObject | any): PersistentMeshSelectionManager;
}

declare class PolygonSelectionMechanicProperties extends InteractiveToolPropertySet { 
	bSelectVertices: boolean;
	bSelectEdges: boolean;
	bSelectFaces: boolean;
	bSelectEdgeLoops: boolean;
	bSelectEdgeRings: boolean;
	bHitBackFaces: boolean;
	bEnableMarquee: boolean;
	bMarqueeIgnoreOcclusion: boolean;
	bPreferProjectedElement: boolean;
	bSelectDownRay: boolean;
	bIgnoreOcclusion: boolean;
	static Load(ResourceName: string): PolygonSelectionMechanicProperties;
	static Find(Outer: UObject, ResourceName: string): PolygonSelectionMechanicProperties;
	static GetDefaultObject(): PolygonSelectionMechanicProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolygonSelectionMechanicProperties;
	SelectAll(): void;
	InvertSelection(): void;
	static C(Other: UObject | any): PolygonSelectionMechanicProperties;
}

declare class PolygonSelectionMechanic extends InteractionMechanic { 
	Properties: PolygonSelectionMechanicProperties;
	HoverBehavior: MouseHoverBehavior;
	ClickOrDragBehavior: SingleClickOrDragInputBehavior;
	MarqueeMechanic: RectangleMarqueeMechanic;
	PreviewGeometryActor: PreviewGeometryActor;
	DrawnTriangleSetComponent: TriangleSetComponent;
	HighlightedFaceMaterial: MaterialInterface;
	static Load(ResourceName: string): PolygonSelectionMechanic;
	static Find(Outer: UObject, ResourceName: string): PolygonSelectionMechanic;
	static GetDefaultObject(): PolygonSelectionMechanic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolygonSelectionMechanic;
	static C(Other: UObject | any): PolygonSelectionMechanic;
}

declare class ModelingSceneSnappingManager extends SceneSnappingManager { 
	ParentContext: InteractiveToolsContext;
	static Load(ResourceName: string): ModelingSceneSnappingManager;
	static Find(Outer: UObject, ResourceName: string): ModelingSceneSnappingManager;
	static GetDefaultObject(): ModelingSceneSnappingManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ModelingSceneSnappingManager;
	static C(Other: UObject | any): ModelingSceneSnappingManager;
}

declare class MultiTransformer extends UObject { 
	GizmoManager: InteractiveGizmoManager;
	TransformGizmo: CombinedTransformGizmo;
	TransformProxy: TransformProxy;
	DragAlignmentMechanic: DragAlignmentMechanic;
	static Load(ResourceName: string): MultiTransformer;
	static Find(Outer: UObject, ResourceName: string): MultiTransformer;
	static GetDefaultObject(): MultiTransformer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MultiTransformer;
	static C(Other: UObject | any): MultiTransformer;
}

declare type ERecomputeUVsPropertiesIslandMode = 'PolyGroups' | 'ExistingUVs' | 'ERecomputeUVsPropertiesIslandMode_MAX';
declare var ERecomputeUVsPropertiesIslandMode : { PolyGroups:'PolyGroups',ExistingUVs:'ExistingUVs',ERecomputeUVsPropertiesIslandMode_MAX:'ERecomputeUVsPropertiesIslandMode_MAX', };
declare type ERecomputeUVsPropertiesUnwrapType = 'ExpMap' | 'Conformal' | 'SpectralConformal' | 'IslandMerging' | 'ERecomputeUVsPropertiesUnwrapType_MAX';
declare var ERecomputeUVsPropertiesUnwrapType : { ExpMap:'ExpMap',Conformal:'Conformal',SpectralConformal:'SpectralConformal',IslandMerging:'IslandMerging',ERecomputeUVsPropertiesUnwrapType_MAX:'ERecomputeUVsPropertiesUnwrapType_MAX', };
declare type ERecomputeUVsToolOrientationMode = 'None' | 'MinBounds' | 'ERecomputeUVsToolOrientationMode_MAX';
declare var ERecomputeUVsToolOrientationMode : { None:'None',MinBounds:'MinBounds',ERecomputeUVsToolOrientationMode_MAX:'ERecomputeUVsToolOrientationMode_MAX', };
declare type ERecomputeUVsPropertiesLayoutType = 'None' | 'Repack' | 'NormalizeToBounds' | 'NormalizeToWorld' | 'ERecomputeUVsPropertiesLayoutType_MAX';
declare var ERecomputeUVsPropertiesLayoutType : { None:'None',Repack:'Repack',NormalizeToBounds:'NormalizeToBounds',NormalizeToWorld:'NormalizeToWorld',ERecomputeUVsPropertiesLayoutType_MAX:'ERecomputeUVsPropertiesLayoutType_MAX', };
declare class RecomputeUVsToolProperties extends InteractiveToolPropertySet { 
	bEnablePolygroupSupport: boolean;
	IslandGeneration: ERecomputeUVsPropertiesIslandMode;
	UnwrapType: ERecomputeUVsPropertiesUnwrapType;
	AutoRotation: ERecomputeUVsToolOrientationMode;
	bPreserveIrregularity: boolean;
	SmoothingSteps: number;
	SmoothingAlpha: number;
	MergingDistortionThreshold: number;
	MergingAngleThreshold: number;
	LayoutType: ERecomputeUVsPropertiesLayoutType;
	TextureResolution: number;
	NormalizeScale: number;
	static Load(ResourceName: string): RecomputeUVsToolProperties;
	static Find(Outer: UObject, ResourceName: string): RecomputeUVsToolProperties;
	static GetDefaultObject(): RecomputeUVsToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RecomputeUVsToolProperties;
	static C(Other: UObject | any): RecomputeUVsToolProperties;
}

declare type EUVLayoutType = 'Transform' | 'Stack' | 'Repack' | 'EUVLayoutType_MAX';
declare var EUVLayoutType : { Transform:'Transform',Stack:'Stack',Repack:'Repack',EUVLayoutType_MAX:'EUVLayoutType_MAX', };
declare class UVLayoutProperties extends InteractiveToolPropertySet { 
	LayoutType: EUVLayoutType;
	TextureResolution: number;
	Scale: number;
	Translation: Vector2D;
	bAllowFlips: boolean;
	static Load(ResourceName: string): UVLayoutProperties;
	static Find(Outer: UObject, ResourceName: string): UVLayoutProperties;
	static GetDefaultObject(): UVLayoutProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVLayoutProperties;
	static C(Other: UObject | any): UVLayoutProperties;
}

declare class RecomputeUVsOpFactory extends UObject { 
	Settings: RecomputeUVsToolProperties;
	static Load(ResourceName: string): RecomputeUVsOpFactory;
	static Find(Outer: UObject, ResourceName: string): RecomputeUVsOpFactory;
	static GetDefaultObject(): RecomputeUVsOpFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RecomputeUVsOpFactory;
	static C(Other: UObject | any): RecomputeUVsOpFactory;
}

declare class UVLayoutOperatorFactory extends UObject { 
	Settings: UVLayoutProperties;
	static Load(ResourceName: string): UVLayoutOperatorFactory;
	static Find(Outer: UObject, ResourceName: string): UVLayoutOperatorFactory;
	static GetDefaultObject(): UVLayoutOperatorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVLayoutOperatorFactory;
	static C(Other: UObject | any): UVLayoutOperatorFactory;
}

declare class DeleteGeometrySelectionCommand extends GeometrySelectionEditCommand { 
	static Load(ResourceName: string): DeleteGeometrySelectionCommand;
	static Find(Outer: UObject, ResourceName: string): DeleteGeometrySelectionCommand;
	static GetDefaultObject(): DeleteGeometrySelectionCommand;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DeleteGeometrySelectionCommand;
	static C(Other: UObject | any): DeleteGeometrySelectionCommand;
}

declare type ELocalFrameMode = 'FromObject' | 'FromGeometry' | 'ELocalFrameMode_MAX';
declare var ELocalFrameMode : { FromObject:'FromObject',FromGeometry:'FromGeometry',ELocalFrameMode_MAX:'ELocalFrameMode_MAX', };
declare class PolyEditCommonProperties extends InteractiveToolPropertySet { 
	bShowWireframe: boolean;
	bShowSelectableCorners: boolean;
	bGizmoVisible: boolean;
	LocalFrameMode: ELocalFrameMode;
	bLockRotation: boolean;
	bLocalCoordSystem: boolean;
	static Load(ResourceName: string): PolyEditCommonProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditCommonProperties;
	static GetDefaultObject(): PolyEditCommonProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditCommonProperties;
	static C(Other: UObject | any): PolyEditCommonProperties;
}

declare class PolyEditActivityContext extends UObject { 
	CommonProperties: PolyEditCommonProperties;
	Preview: MeshOpPreviewWithBackgroundCompute;
	SelectionMechanic: PolygonSelectionMechanic;
	static Load(ResourceName: string): PolyEditActivityContext;
	static Find(Outer: UObject, ResourceName: string): PolyEditActivityContext;
	static GetDefaultObject(): PolyEditActivityContext;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditActivityContext;
	static C(Other: UObject | any): PolyEditActivityContext;
}

declare class AddPrimitiveToolBuilder extends InteractiveToolBuilder { 
	static Load(ResourceName: string): AddPrimitiveToolBuilder;
	static Find(Outer: UObject, ResourceName: string): AddPrimitiveToolBuilder;
	static GetDefaultObject(): AddPrimitiveToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddPrimitiveToolBuilder;
	static C(Other: UObject | any): AddPrimitiveToolBuilder;
}

declare type EMakeMeshPolygroupMode = 'PerShape' | 'PerFace' | 'PerQuad' | 'EMakeMeshPolygroupMode_MAX';
declare var EMakeMeshPolygroupMode : { PerShape:'PerShape',PerFace:'PerFace',PerQuad:'PerQuad',EMakeMeshPolygroupMode_MAX:'EMakeMeshPolygroupMode_MAX', };
declare type EMakeMeshPlacementType = 'GroundPlane' | 'OnScene' | 'EMakeMeshPlacementType_MAX';
declare var EMakeMeshPlacementType : { GroundPlane:'GroundPlane',OnScene:'OnScene',EMakeMeshPlacementType_MAX:'EMakeMeshPlacementType_MAX', };
declare type EMakeMeshPivotLocation = 'Base' | 'Centered' | 'Top' | 'EMakeMeshPivotLocation_MAX';
declare var EMakeMeshPivotLocation : { Base:'Base',Centered:'Centered',Top:'Top',EMakeMeshPivotLocation_MAX:'EMakeMeshPivotLocation_MAX', };
declare class ProceduralShapeToolProperties extends InteractiveToolPropertySet { 
	PolygroupMode: EMakeMeshPolygroupMode;
	TargetSurface: EMakeMeshPlacementType;
	PivotLocation: EMakeMeshPivotLocation;
	Rotation: number;
	bAlignToNormal: boolean;
	bShowGizmo: boolean;
	bShowGizmoOptions: boolean;
	static Load(ResourceName: string): ProceduralShapeToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralShapeToolProperties;
	static GetDefaultObject(): ProceduralShapeToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralShapeToolProperties;
	static C(Other: UObject | any): ProceduralShapeToolProperties;
}

declare class ProceduralBoxToolProperties extends ProceduralShapeToolProperties { 
	Width: number;
	Depth: number;
	Height: number;
	WidthSubdivisions: number;
	DepthSubdivisions: number;
	HeightSubdivisions: number;
	static Load(ResourceName: string): ProceduralBoxToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralBoxToolProperties;
	static GetDefaultObject(): ProceduralBoxToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralBoxToolProperties;
	static C(Other: UObject | any): ProceduralBoxToolProperties;
}

declare type EProceduralRectType = 'Rectangle' | 'RoundedRectangle' | 'EProceduralRectType_MAX';
declare var EProceduralRectType : { Rectangle:'Rectangle',RoundedRectangle:'RoundedRectangle',EProceduralRectType_MAX:'EProceduralRectType_MAX', };
declare class ProceduralRectangleToolProperties extends ProceduralShapeToolProperties { 
	RectangleType: EProceduralRectType;
	Width: number;
	Depth: number;
	WidthSubdivisions: number;
	DepthSubdivisions: number;
	CornerRadius: number;
	CornerSlices: number;
	static Load(ResourceName: string): ProceduralRectangleToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralRectangleToolProperties;
	static GetDefaultObject(): ProceduralRectangleToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralRectangleToolProperties;
	static C(Other: UObject | any): ProceduralRectangleToolProperties;
}

declare type EProceduralDiscType = 'Disc' | 'PuncturedDisc' | 'EProceduralDiscType_MAX';
declare var EProceduralDiscType : { Disc:'Disc',PuncturedDisc:'PuncturedDisc',EProceduralDiscType_MAX:'EProceduralDiscType_MAX', };
declare class ProceduralDiscToolProperties extends ProceduralShapeToolProperties { 
	DiscType: EProceduralDiscType;
	Radius: number;
	RadialSlices: number;
	RadialSubdivisions: number;
	HoleRadius: number;
	static Load(ResourceName: string): ProceduralDiscToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralDiscToolProperties;
	static GetDefaultObject(): ProceduralDiscToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralDiscToolProperties;
	static C(Other: UObject | any): ProceduralDiscToolProperties;
}

declare class ProceduralTorusToolProperties extends ProceduralShapeToolProperties { 
	MajorRadius: number;
	MinorRadius: number;
	MajorSlices: number;
	MinorSlices: number;
	static Load(ResourceName: string): ProceduralTorusToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralTorusToolProperties;
	static GetDefaultObject(): ProceduralTorusToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralTorusToolProperties;
	static C(Other: UObject | any): ProceduralTorusToolProperties;
}

declare class ProceduralCylinderToolProperties extends ProceduralShapeToolProperties { 
	Radius: number;
	Height: number;
	RadialSlices: number;
	HeightSubdivisions: number;
	static Load(ResourceName: string): ProceduralCylinderToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralCylinderToolProperties;
	static GetDefaultObject(): ProceduralCylinderToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralCylinderToolProperties;
	static C(Other: UObject | any): ProceduralCylinderToolProperties;
}

declare class ProceduralConeToolProperties extends ProceduralShapeToolProperties { 
	Radius: number;
	Height: number;
	RadialSlices: number;
	HeightSubdivisions: number;
	static Load(ResourceName: string): ProceduralConeToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralConeToolProperties;
	static GetDefaultObject(): ProceduralConeToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralConeToolProperties;
	static C(Other: UObject | any): ProceduralConeToolProperties;
}

declare class ProceduralArrowToolProperties extends ProceduralShapeToolProperties { 
	ShaftRadius: number;
	ShaftHeight: number;
	HeadRadius: number;
	HeadHeight: number;
	RadialSlices: number;
	HeightSubdivisions: number;
	static Load(ResourceName: string): ProceduralArrowToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralArrowToolProperties;
	static GetDefaultObject(): ProceduralArrowToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralArrowToolProperties;
	static C(Other: UObject | any): ProceduralArrowToolProperties;
}

declare type EProceduralSphereType = 'LatLong' | 'Box' | 'EProceduralSphereType_MAX';
declare var EProceduralSphereType : { LatLong:'LatLong',Box:'Box',EProceduralSphereType_MAX:'EProceduralSphereType_MAX', };
declare class ProceduralSphereToolProperties extends ProceduralShapeToolProperties { 
	Radius: number;
	SubdivisionType: EProceduralSphereType;
	Subdivisions: number;
	HorizontalSlices: number;
	VerticalSlices: number;
	static Load(ResourceName: string): ProceduralSphereToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralSphereToolProperties;
	static GetDefaultObject(): ProceduralSphereToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralSphereToolProperties;
	static C(Other: UObject | any): ProceduralSphereToolProperties;
}

declare type EProceduralStairsType = 'Linear' | 'Floating' | 'Curved' | 'Spiral' | 'EProceduralStairsType_MAX';
declare var EProceduralStairsType : { Linear:'Linear',Floating:'Floating',Curved:'Curved',Spiral:'Spiral',EProceduralStairsType_MAX:'EProceduralStairsType_MAX', };
declare class ProceduralStairsToolProperties extends ProceduralShapeToolProperties { 
	StairsType: EProceduralStairsType;
	NumSteps: number;
	StepWidth: number;
	StepHeight: number;
	StepDepth: number;
	CurveAngle: number;
	SpiralAngle: number;
	InnerRadius: number;
	static Load(ResourceName: string): ProceduralStairsToolProperties;
	static Find(Outer: UObject, ResourceName: string): ProceduralStairsToolProperties;
	static GetDefaultObject(): ProceduralStairsToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralStairsToolProperties;
	static C(Other: UObject | any): ProceduralStairsToolProperties;
}

declare class NewMeshMaterialProperties extends InteractiveToolPropertySet { 
	Material: MaterialInterface;
	UVScale: number;
	bWorldSpaceUVScale: boolean;
	bShowWireframe: boolean;
	bShowExtendedOptions: boolean;
	static Load(ResourceName: string): NewMeshMaterialProperties;
	static Find(Outer: UObject, ResourceName: string): NewMeshMaterialProperties;
	static GetDefaultObject(): NewMeshMaterialProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NewMeshMaterialProperties;
	static C(Other: UObject | any): NewMeshMaterialProperties;
}

declare class AddPrimitiveTool extends SingleClickTool { 
	OutputTypeProperties: CreateMeshObjectTypeProperties;
	ShapeSettings: ProceduralShapeToolProperties;
	MaterialProperties: NewMeshMaterialProperties;
	PreviewMesh: PreviewMesh;
	Gizmo: CombinedTransformGizmo;
	DragAlignmentMechanic: DragAlignmentMechanic;
	AssetName: string;
	static Load(ResourceName: string): AddPrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddPrimitiveTool;
	static GetDefaultObject(): AddPrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddPrimitiveTool;
	static C(Other: UObject | any): AddPrimitiveTool;
}

declare class AddBoxPrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddBoxPrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddBoxPrimitiveTool;
	static GetDefaultObject(): AddBoxPrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddBoxPrimitiveTool;
	static C(Other: UObject | any): AddBoxPrimitiveTool;
}

declare class AddCylinderPrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddCylinderPrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddCylinderPrimitiveTool;
	static GetDefaultObject(): AddCylinderPrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddCylinderPrimitiveTool;
	static C(Other: UObject | any): AddCylinderPrimitiveTool;
}

declare class AddConePrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddConePrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddConePrimitiveTool;
	static GetDefaultObject(): AddConePrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddConePrimitiveTool;
	static C(Other: UObject | any): AddConePrimitiveTool;
}

declare class AddRectanglePrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddRectanglePrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddRectanglePrimitiveTool;
	static GetDefaultObject(): AddRectanglePrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddRectanglePrimitiveTool;
	static C(Other: UObject | any): AddRectanglePrimitiveTool;
}

declare class AddDiscPrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddDiscPrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddDiscPrimitiveTool;
	static GetDefaultObject(): AddDiscPrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddDiscPrimitiveTool;
	static C(Other: UObject | any): AddDiscPrimitiveTool;
}

declare class AddTorusPrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddTorusPrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddTorusPrimitiveTool;
	static GetDefaultObject(): AddTorusPrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddTorusPrimitiveTool;
	static C(Other: UObject | any): AddTorusPrimitiveTool;
}

declare class AddArrowPrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddArrowPrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddArrowPrimitiveTool;
	static GetDefaultObject(): AddArrowPrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddArrowPrimitiveTool;
	static C(Other: UObject | any): AddArrowPrimitiveTool;
}

declare class AddSpherePrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddSpherePrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddSpherePrimitiveTool;
	static GetDefaultObject(): AddSpherePrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddSpherePrimitiveTool;
	static C(Other: UObject | any): AddSpherePrimitiveTool;
}

declare class AddStairsPrimitiveTool extends AddPrimitiveTool { 
	static Load(ResourceName: string): AddStairsPrimitiveTool;
	static Find(Outer: UObject, ResourceName: string): AddStairsPrimitiveTool;
	static GetDefaultObject(): AddStairsPrimitiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AddStairsPrimitiveTool;
	static C(Other: UObject | any): AddStairsPrimitiveTool;
}

declare class CombineMeshesToolBuilder extends MultiSelectionMeshEditingToolBuilder { 
	static Load(ResourceName: string): CombineMeshesToolBuilder;
	static Find(Outer: UObject, ResourceName: string): CombineMeshesToolBuilder;
	static GetDefaultObject(): CombineMeshesToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CombineMeshesToolBuilder;
	static C(Other: UObject | any): CombineMeshesToolBuilder;
}

declare class CombineMeshesToolProperties extends InteractiveToolPropertySet { 
	bIsDuplicateMode: boolean;
	OutputWriteTo: EBaseCreateFromSelectedTargetType;
	OutputNewName: string;
	OutputExistingName: string;
	static Load(ResourceName: string): CombineMeshesToolProperties;
	static Find(Outer: UObject, ResourceName: string): CombineMeshesToolProperties;
	static GetDefaultObject(): CombineMeshesToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CombineMeshesToolProperties;
	static C(Other: UObject | any): CombineMeshesToolProperties;
}

declare class CombineMeshesTool extends MultiSelectionMeshEditingTool { 
	BasicProperties: CombineMeshesToolProperties;
	OutputTypeProperties: CreateMeshObjectTypeProperties;
	HandleSourceProperties: OnAcceptHandleSourcesPropertiesBase;
	static Load(ResourceName: string): CombineMeshesTool;
	static Find(Outer: UObject, ResourceName: string): CombineMeshesTool;
	static GetDefaultObject(): CombineMeshesTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CombineMeshesTool;
	static C(Other: UObject | any): CombineMeshesTool;
}

declare type ECSGOperation = 'DifferenceAB' | 'DifferenceBA' | 'Intersect' | 'Union' | 'ECSGOperation_MAX';
declare var ECSGOperation : { DifferenceAB:'DifferenceAB',DifferenceBA:'DifferenceBA',Intersect:'Intersect',Union:'Union',ECSGOperation_MAX:'ECSGOperation_MAX', };
declare class CSGMeshesToolProperties extends InteractiveToolPropertySet { 
	Operation: ECSGOperation;
	bTryFixHoles: boolean;
	bTryCollapseEdges: boolean;
	WindingThreshold: number;
	bShowNewBoundaries: boolean;
	bShowSubtractedMesh: boolean;
	SubtractedMeshOpacity: number;
	SubtractedMeshColor: LinearColor;
	bUseFirstMeshMaterials: boolean;
	static Load(ResourceName: string): CSGMeshesToolProperties;
	static Find(Outer: UObject, ResourceName: string): CSGMeshesToolProperties;
	static GetDefaultObject(): CSGMeshesToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CSGMeshesToolProperties;
	static C(Other: UObject | any): CSGMeshesToolProperties;
}

declare type ETrimOperation = 'TrimA' | 'TrimB' | 'ETrimOperation_MAX';
declare var ETrimOperation : { TrimA:'TrimA',TrimB:'TrimB',ETrimOperation_MAX:'ETrimOperation_MAX', };
declare type ETrimSide = 'RemoveInside' | 'RemoveOutside' | 'ETrimSide_MAX';
declare var ETrimSide : { RemoveInside:'RemoveInside',RemoveOutside:'RemoveOutside',ETrimSide_MAX:'ETrimSide_MAX', };
declare class TrimMeshesToolProperties extends InteractiveToolPropertySet { 
	WhichMesh: ETrimOperation;
	TrimSide: ETrimSide;
	WindingThreshold: number;
	bShowTrimmingMesh: boolean;
	OpacityOfTrimmingMesh: number;
	ColorOfTrimmingMesh: LinearColor;
	static Load(ResourceName: string): TrimMeshesToolProperties;
	static Find(Outer: UObject, ResourceName: string): TrimMeshesToolProperties;
	static GetDefaultObject(): TrimMeshesToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TrimMeshesToolProperties;
	static C(Other: UObject | any): TrimMeshesToolProperties;
}

declare class CSGMeshesTool extends BaseCreateFromSelectedTool { 
	CSGProperties: CSGMeshesToolProperties;
	TrimProperties: TrimMeshesToolProperties;
	OriginalMeshPreviews: PreviewMesh[];
	PreviewsGhostMaterial: MaterialInstanceDynamic;
	DrawnLineSet: LineSetComponent;
	static Load(ResourceName: string): CSGMeshesTool;
	static Find(Outer: UObject, ResourceName: string): CSGMeshesTool;
	static GetDefaultObject(): CSGMeshesTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CSGMeshesTool;
	static C(Other: UObject | any): CSGMeshesTool;
}

declare class CSGMeshesToolBuilder extends BaseCreateFromSelectedToolBuilder { 
	static Load(ResourceName: string): CSGMeshesToolBuilder;
	static Find(Outer: UObject, ResourceName: string): CSGMeshesToolBuilder;
	static GetDefaultObject(): CSGMeshesToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CSGMeshesToolBuilder;
	static C(Other: UObject | any): CSGMeshesToolBuilder;
}

declare class CutMeshWithMeshToolProperties extends InteractiveToolPropertySet { 
	bTryFixHoles: boolean;
	bTryCollapseEdges: boolean;
	WindingThreshold: number;
	bShowNewBoundaries: boolean;
	bUseFirstMeshMaterials: boolean;
	static Load(ResourceName: string): CutMeshWithMeshToolProperties;
	static Find(Outer: UObject, ResourceName: string): CutMeshWithMeshToolProperties;
	static GetDefaultObject(): CutMeshWithMeshToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CutMeshWithMeshToolProperties;
	static C(Other: UObject | any): CutMeshWithMeshToolProperties;
}

declare class CutMeshWithMeshTool extends BaseCreateFromSelectedTool { 
	CutProperties: CutMeshWithMeshToolProperties;
	IntersectPreviewMesh: PreviewMesh;
	DrawnLineSet: LineSetComponent;
	static Load(ResourceName: string): CutMeshWithMeshTool;
	static Find(Outer: UObject, ResourceName: string): CutMeshWithMeshTool;
	static GetDefaultObject(): CutMeshWithMeshTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CutMeshWithMeshTool;
	static C(Other: UObject | any): CutMeshWithMeshTool;
}

declare class CutMeshWithMeshToolBuilder extends BaseCreateFromSelectedToolBuilder { 
	static Load(ResourceName: string): CutMeshWithMeshToolBuilder;
	static Find(Outer: UObject, ResourceName: string): CutMeshWithMeshToolBuilder;
	static GetDefaultObject(): CutMeshWithMeshToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CutMeshWithMeshToolBuilder;
	static C(Other: UObject | any): CutMeshWithMeshToolBuilder;
}

declare class DrawAndRevolveToolBuilder extends InteractiveToolBuilder { 
	static Load(ResourceName: string): DrawAndRevolveToolBuilder;
	static Find(Outer: UObject, ResourceName: string): DrawAndRevolveToolBuilder;
	static GetDefaultObject(): DrawAndRevolveToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DrawAndRevolveToolBuilder;
	static C(Other: UObject | any): DrawAndRevolveToolBuilder;
}

declare type ERevolvePropertiesPolygroupMode = 'PerShape' | 'PerFace' | 'PerRevolveStep' | 'PerPathSegment' | 'ERevolvePropertiesPolygroupMode_MAX';
declare var ERevolvePropertiesPolygroupMode : { PerShape:'PerShape',PerFace:'PerFace',PerRevolveStep:'PerRevolveStep',PerPathSegment:'PerPathSegment',ERevolvePropertiesPolygroupMode_MAX:'ERevolvePropertiesPolygroupMode_MAX', };
declare type ERevolvePropertiesQuadSplit = 'Uniform' | 'Compact' | 'ERevolvePropertiesQuadSplit_MAX';
declare var ERevolvePropertiesQuadSplit : { Uniform:'Uniform',Compact:'Compact',ERevolvePropertiesQuadSplit_MAX:'ERevolvePropertiesQuadSplit_MAX', };
declare class RevolveProperties extends InteractiveToolPropertySet { 
	RevolveDegreesClamped: number;
	RevolveDegrees: number;
	RevolveDegreesOffset: number;
	StepsMaxDegrees: number;
	bExplicitSteps: boolean;
	NumExplicitSteps: number;
	HeightOffsetPerDegree: number;
	bReverseRevolutionDirection: boolean;
	bFlipMesh: boolean;
	bSharpNormals: boolean;
	SharpNormalsDegreeThreshold: number;
	bPathAtMidpointOfStep: boolean;
	PolygroupMode: ERevolvePropertiesPolygroupMode;
	QuadSplitMode: ERevolvePropertiesQuadSplit;
	static Load(ResourceName: string): RevolveProperties;
	static Find(Outer: UObject, ResourceName: string): RevolveProperties;
	static GetDefaultObject(): RevolveProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RevolveProperties;
	static C(Other: UObject | any): RevolveProperties;
}

declare type ERevolvePropertiesCapFillMode = 'None' | 'CenterFan' | 'Delaunay' | 'EarClipping' | 'ERevolvePropertiesCapFillMode_MAX';
declare var ERevolvePropertiesCapFillMode : { None:'None',CenterFan:'CenterFan',Delaunay:'Delaunay',EarClipping:'EarClipping',ERevolvePropertiesCapFillMode_MAX:'ERevolvePropertiesCapFillMode_MAX', };
declare class RevolveToolProperties extends RevolveProperties { 
	CapFillMode: ERevolvePropertiesCapFillMode;
	bClosePathToAxis: boolean;
	DrawPlaneOrigin: Vector;
	DrawPlaneOrientation: Rotator;
	bEnableSnapping: boolean;
	bAllowedToEditDrawPlane: boolean;
	static Load(ResourceName: string): RevolveToolProperties;
	static Find(Outer: UObject, ResourceName: string): RevolveToolProperties;
	static GetDefaultObject(): RevolveToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RevolveToolProperties;
	static C(Other: UObject | any): RevolveToolProperties;
}

declare class DrawAndRevolveTool extends InteractiveTool { 
	ControlPointsMechanic: CurveControlPointsMechanic;
	PlaneMechanic: ConstructionPlaneMechanic;
	OutputTypeProperties: CreateMeshObjectTypeProperties;
	Settings: RevolveToolProperties;
	MaterialProperties: NewMeshMaterialProperties;
	Preview: MeshOpPreviewWithBackgroundCompute;
	static Load(ResourceName: string): DrawAndRevolveTool;
	static Find(Outer: UObject, ResourceName: string): DrawAndRevolveTool;
	static GetDefaultObject(): DrawAndRevolveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DrawAndRevolveTool;
	static C(Other: UObject | any): DrawAndRevolveTool;
}

declare class RevolveOperatorFactory extends UObject { 
	RevolveTool: DrawAndRevolveTool;
	static Load(ResourceName: string): RevolveOperatorFactory;
	static Find(Outer: UObject, ResourceName: string): RevolveOperatorFactory;
	static GetDefaultObject(): RevolveOperatorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RevolveOperatorFactory;
	static C(Other: UObject | any): RevolveOperatorFactory;
}

declare class DrawPolygonToolBuilder extends InteractiveToolBuilder { 
	static Load(ResourceName: string): DrawPolygonToolBuilder;
	static Find(Outer: UObject, ResourceName: string): DrawPolygonToolBuilder;
	static GetDefaultObject(): DrawPolygonToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DrawPolygonToolBuilder;
	static C(Other: UObject | any): DrawPolygonToolBuilder;
}

declare type EDrawPolygonDrawMode = 'Freehand' | 'Circle' | 'Square' | 'Rectangle' | 'RoundedRectangle' | 'Ring' | 'EDrawPolygonDrawMode_MAX';
declare var EDrawPolygonDrawMode : { Freehand:'Freehand',Circle:'Circle',Square:'Square',Rectangle:'Rectangle',RoundedRectangle:'RoundedRectangle',Ring:'Ring',EDrawPolygonDrawMode_MAX:'EDrawPolygonDrawMode_MAX', };
declare type EDrawPolygonExtrudeMode = 'Flat' | 'Fixed' | 'Interactive' | 'EDrawPolygonExtrudeMode_MAX';
declare var EDrawPolygonExtrudeMode : { Flat:'Flat',Fixed:'Fixed',Interactive:'Interactive',EDrawPolygonExtrudeMode_MAX:'EDrawPolygonExtrudeMode_MAX', };
declare class DrawPolygonToolStandardProperties extends InteractiveToolPropertySet { 
	PolygonDrawMode: EDrawPolygonDrawMode;
	bAllowSelfIntersections: boolean;
	FeatureSizeRatio: number;
	RadialSlices: number;
	Distance: number;
	bShowGridGizmo: boolean;
	ExtrudeMode: EDrawPolygonExtrudeMode;
	ExtrudeHeight: number;
	static Load(ResourceName: string): DrawPolygonToolStandardProperties;
	static Find(Outer: UObject, ResourceName: string): DrawPolygonToolStandardProperties;
	static GetDefaultObject(): DrawPolygonToolStandardProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DrawPolygonToolStandardProperties;
	static C(Other: UObject | any): DrawPolygonToolStandardProperties;
}

declare class DrawPolygonToolSnapProperties extends InteractiveToolPropertySet { 
	bEnableSnapping: boolean;
	bSnapToWorldGrid: boolean;
	bSnapToVertices: boolean;
	bSnapToEdges: boolean;
	bSnapToAxes: boolean;
	bSnapToLengths: boolean;
	bSnapToSurfaces: boolean;
	SnapToSurfacesOffset: number;
	static Load(ResourceName: string): DrawPolygonToolSnapProperties;
	static Find(Outer: UObject, ResourceName: string): DrawPolygonToolSnapProperties;
	static GetDefaultObject(): DrawPolygonToolSnapProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DrawPolygonToolSnapProperties;
	static C(Other: UObject | any): DrawPolygonToolSnapProperties;
}

declare class DrawPolygonTool extends InteractiveTool { 
	OutputTypeProperties: CreateMeshObjectTypeProperties;
	PolygonProperties: DrawPolygonToolStandardProperties;
	SnapProperties: DrawPolygonToolSnapProperties;
	MaterialProperties: NewMeshMaterialProperties;
	PreviewMesh: PreviewMesh;
	PlaneTransformGizmo: CombinedTransformGizmo;
	PlaneTransformProxy: TransformProxy;
	HeightMechanic: PlaneDistanceFromHitMechanic;
	DragAlignmentMechanic: DragAlignmentMechanic;
	static Load(ResourceName: string): DrawPolygonTool;
	static Find(Outer: UObject, ResourceName: string): DrawPolygonTool;
	static GetDefaultObject(): DrawPolygonTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DrawPolygonTool;
	static C(Other: UObject | any): DrawPolygonTool;
}

declare class EditMeshPolygonsToolBuilder extends SingleSelectionMeshEditingToolBuilder { 
	static Load(ResourceName: string): EditMeshPolygonsToolBuilder;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolBuilder;
	static GetDefaultObject(): EditMeshPolygonsToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolBuilder;
	static C(Other: UObject | any): EditMeshPolygonsToolBuilder;
}

declare class EditMeshPolygonsActionModeToolBuilder extends EditMeshPolygonsToolBuilder { 
	static Load(ResourceName: string): EditMeshPolygonsActionModeToolBuilder;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsActionModeToolBuilder;
	static GetDefaultObject(): EditMeshPolygonsActionModeToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsActionModeToolBuilder;
	static C(Other: UObject | any): EditMeshPolygonsActionModeToolBuilder;
}

declare class EditMeshPolygonsSelectionModeToolBuilder extends EditMeshPolygonsToolBuilder { 
	static Load(ResourceName: string): EditMeshPolygonsSelectionModeToolBuilder;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsSelectionModeToolBuilder;
	static GetDefaultObject(): EditMeshPolygonsSelectionModeToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsSelectionModeToolBuilder;
	static C(Other: UObject | any): EditMeshPolygonsSelectionModeToolBuilder;
}

declare class EditMeshPolygonsToolActionPropertySet extends InteractiveToolPropertySet { 
	static Load(ResourceName: string): EditMeshPolygonsToolActionPropertySet;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolActionPropertySet;
	static GetDefaultObject(): EditMeshPolygonsToolActionPropertySet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolActionPropertySet;
	static C(Other: UObject | any): EditMeshPolygonsToolActionPropertySet;
}

declare class PolyEditTopologyProperties extends EditMeshPolygonsToolActionPropertySet { 
	bAddExtraCorners: boolean;
	ExtraCornerAngleThresholdDegrees: number;
	static Load(ResourceName: string): PolyEditTopologyProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditTopologyProperties;
	static GetDefaultObject(): PolyEditTopologyProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditTopologyProperties;
	RegenerateExtraCorners(): void;
	static C(Other: UObject | any): PolyEditTopologyProperties;
}

declare class EditMeshPolygonsToolActions extends EditMeshPolygonsToolActionPropertySet { 
	static Load(ResourceName: string): EditMeshPolygonsToolActions;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolActions;
	static GetDefaultObject(): EditMeshPolygonsToolActions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolActions;
	SimplifyByGroups(): void;
	Retriangulate(): void;
	RecalcNormals(): void;
	PushPull(): void;
	Outset(): void;
	Offset(): void;
	Merge(): void;
	Inset(): void;
	InsertEdgeLoop(): void;
	InsertEdge(): void;
	Flip(): void;
	Extrude(): void;
	Duplicate(): void;
	Disconnect(): void;
	Delete(): void;
	Decompose(): void;
	CutFaces(): void;
	Bevel(): void;
	static C(Other: UObject | any): EditMeshPolygonsToolActions;
}

declare class EditMeshPolygonsToolActions_Triangles extends EditMeshPolygonsToolActionPropertySet { 
	static Load(ResourceName: string): EditMeshPolygonsToolActions_Triangles;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolActions_Triangles;
	static GetDefaultObject(): EditMeshPolygonsToolActions_Triangles;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolActions_Triangles;
	RecalcNormals(): void;
	PushPull(): void;
	Poke(): void;
	Outset(): void;
	Offset(): void;
	Inset(): void;
	Flip(): void;
	Extrude(): void;
	Duplicate(): void;
	Disconnect(): void;
	Delete(): void;
	CutFaces(): void;
	static C(Other: UObject | any): EditMeshPolygonsToolActions_Triangles;
}

declare class EditMeshPolygonsToolUVActions extends EditMeshPolygonsToolActionPropertySet { 
	static Load(ResourceName: string): EditMeshPolygonsToolUVActions;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolUVActions;
	static GetDefaultObject(): EditMeshPolygonsToolUVActions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolUVActions;
	PlanarProjection(): void;
	static C(Other: UObject | any): EditMeshPolygonsToolUVActions;
}

declare class EditMeshPolygonsToolEdgeActions extends EditMeshPolygonsToolActionPropertySet { 
	static Load(ResourceName: string): EditMeshPolygonsToolEdgeActions;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolEdgeActions;
	static GetDefaultObject(): EditMeshPolygonsToolEdgeActions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolEdgeActions;
	Weld(): void;
	Straighten(): void;
	FillHole(): void;
	Bridge(): void;
	Bevel(): void;
	static C(Other: UObject | any): EditMeshPolygonsToolEdgeActions;
}

declare class EditMeshPolygonsToolEdgeActions_Triangles extends EditMeshPolygonsToolActionPropertySet { 
	static Load(ResourceName: string): EditMeshPolygonsToolEdgeActions_Triangles;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolEdgeActions_Triangles;
	static GetDefaultObject(): EditMeshPolygonsToolEdgeActions_Triangles;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolEdgeActions_Triangles;
	Weld(): void;
	Split(): void;
	Flip(): void;
	FillHole(): void;
	Collapse(): void;
	static C(Other: UObject | any): EditMeshPolygonsToolEdgeActions_Triangles;
}

declare class EditMeshPolygonsToolCancelAction extends EditMeshPolygonsToolActionPropertySet { 
	static Load(ResourceName: string): EditMeshPolygonsToolCancelAction;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolCancelAction;
	static GetDefaultObject(): EditMeshPolygonsToolCancelAction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolCancelAction;
	Done(): void;
	static C(Other: UObject | any): EditMeshPolygonsToolCancelAction;
}

declare class EditMeshPolygonsToolAcceptCancelAction extends EditMeshPolygonsToolActionPropertySet { 
	static Load(ResourceName: string): EditMeshPolygonsToolAcceptCancelAction;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsToolAcceptCancelAction;
	static GetDefaultObject(): EditMeshPolygonsToolAcceptCancelAction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsToolAcceptCancelAction;
	Cancel(): void;
	Apply(): void;
	static C(Other: UObject | any): EditMeshPolygonsToolAcceptCancelAction;
}

declare type EPolyEditExtrudeDistanceMode = 'ClickInViewport' | 'Fixed' | 'EPolyEditExtrudeDistanceMode_MAX';
declare var EPolyEditExtrudeDistanceMode : { ClickInViewport:'ClickInViewport',Fixed:'Fixed',EPolyEditExtrudeDistanceMode_MAX:'EPolyEditExtrudeDistanceMode_MAX', };
declare type EPolyEditExtrudeDirection = 'SelectionNormal' | 'WorldX' | 'WorldY' | 'WorldZ' | 'LocalX' | 'LocalY' | 'LocalZ' | 'EPolyEditExtrudeDirection_MAX';
declare var EPolyEditExtrudeDirection : { SelectionNormal:'SelectionNormal',WorldX:'WorldX',WorldY:'WorldY',WorldZ:'WorldZ',LocalX:'LocalX',LocalY:'LocalY',LocalZ:'LocalZ',EPolyEditExtrudeDirection_MAX:'EPolyEditExtrudeDirection_MAX', };
declare type EPolyEditExtrudeModeOptions = 'SingleDirection' | 'SelectedTriangleNormals' | 'SelectedTriangleNormalsEven' | 'EPolyEditExtrudeModeOptions_MAX';
declare var EPolyEditExtrudeModeOptions : { SingleDirection:'SingleDirection',SelectedTriangleNormals:'SelectedTriangleNormals',SelectedTriangleNormalsEven:'SelectedTriangleNormalsEven',EPolyEditExtrudeModeOptions_MAX:'EPolyEditExtrudeModeOptions_MAX', };
declare class PolyEditExtrudeProperties extends InteractiveToolPropertySet { 
	DistanceMode: EPolyEditExtrudeDistanceMode;
	Distance: number;
	Direction: EPolyEditExtrudeDirection;
	MeasureDirection: EPolyEditExtrudeDirection;
	bShellsToSolids: boolean;
	DirectionMode: EPolyEditExtrudeModeOptions;
	MaxDistanceScaleFactor: number;
	bUseColinearityForSettingBorderGroups: boolean;
	static Load(ResourceName: string): PolyEditExtrudeProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditExtrudeProperties;
	static GetDefaultObject(): PolyEditExtrudeProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditExtrudeProperties;
	static C(Other: UObject | any): PolyEditExtrudeProperties;
}

declare type EPolyEditOffsetModeOptions = 'VertexNormals' | 'SelectedTriangleNormals' | 'SelectedTriangleNormalsEven' | 'EPolyEditOffsetModeOptions_MAX';
declare var EPolyEditOffsetModeOptions : { VertexNormals:'VertexNormals',SelectedTriangleNormals:'SelectedTriangleNormals',SelectedTriangleNormalsEven:'SelectedTriangleNormalsEven',EPolyEditOffsetModeOptions_MAX:'EPolyEditOffsetModeOptions_MAX', };
declare class PolyEditOffsetProperties extends InteractiveToolPropertySet { 
	DistanceMode: EPolyEditExtrudeDistanceMode;
	Distance: number;
	DirectionMode: EPolyEditOffsetModeOptions;
	MaxDistanceScaleFactor: number;
	bShellsToSolids: boolean;
	MeasureDirection: EPolyEditExtrudeDirection;
	bUseColinearityForSettingBorderGroups: boolean;
	static Load(ResourceName: string): PolyEditOffsetProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditOffsetProperties;
	static GetDefaultObject(): PolyEditOffsetProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditOffsetProperties;
	static C(Other: UObject | any): PolyEditOffsetProperties;
}

declare type EPolyEditPushPullModeOptions = 'SelectedTriangleNormals' | 'SelectedTriangleNormalsEven' | 'SingleDirection' | 'VertexNormals' | 'EPolyEditPushPullModeOptions_MAX';
declare var EPolyEditPushPullModeOptions : { SelectedTriangleNormals:'SelectedTriangleNormals',SelectedTriangleNormalsEven:'SelectedTriangleNormalsEven',SingleDirection:'SingleDirection',VertexNormals:'VertexNormals',EPolyEditPushPullModeOptions_MAX:'EPolyEditPushPullModeOptions_MAX', };
declare class PolyEditPushPullProperties extends InteractiveToolPropertySet { 
	DistanceMode: EPolyEditExtrudeDistanceMode;
	Distance: number;
	DirectionMode: EPolyEditPushPullModeOptions;
	MaxDistanceScaleFactor: number;
	bShellsToSolids: boolean;
	MeasureDirection: EPolyEditExtrudeDirection;
	bUseColinearityForSettingBorderGroups: boolean;
	static Load(ResourceName: string): PolyEditPushPullProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditPushPullProperties;
	static GetDefaultObject(): PolyEditPushPullProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditPushPullProperties;
	static C(Other: UObject | any): PolyEditPushPullProperties;
}

declare class PolyEditExtrudeActivity extends InteractiveToolActivity { 
	ExtrudeProperties: PolyEditExtrudeProperties;
	OffsetProperties: PolyEditOffsetProperties;
	PushPullProperties: PolyEditPushPullProperties;
	ExtrudeHeightMechanic: PlaneDistanceFromHitMechanic;
	ActivityContext: PolyEditActivityContext;
	static Load(ResourceName: string): PolyEditExtrudeActivity;
	static Find(Outer: UObject, ResourceName: string): PolyEditExtrudeActivity;
	static GetDefaultObject(): PolyEditExtrudeActivity;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditExtrudeActivity;
	static C(Other: UObject | any): PolyEditExtrudeActivity;
}

declare class PolyEditInsetOutsetProperties extends InteractiveToolPropertySet { 
	Softness: number;
	bBoundaryOnly: boolean;
	AreaScale: number;
	bReproject: boolean;
	bOutset: boolean;
	static Load(ResourceName: string): PolyEditInsetOutsetProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditInsetOutsetProperties;
	static GetDefaultObject(): PolyEditInsetOutsetProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditInsetOutsetProperties;
	static C(Other: UObject | any): PolyEditInsetOutsetProperties;
}

declare class PolyEditInsetOutsetActivity extends InteractiveToolActivity { 
	Settings: PolyEditInsetOutsetProperties;
	EditPreview: PolyEditPreviewMesh;
	CurveDistMechanic: SpatialCurveDistanceMechanic;
	ActivityContext: PolyEditActivityContext;
	static Load(ResourceName: string): PolyEditInsetOutsetActivity;
	static Find(Outer: UObject, ResourceName: string): PolyEditInsetOutsetActivity;
	static GetDefaultObject(): PolyEditInsetOutsetActivity;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditInsetOutsetActivity;
	static C(Other: UObject | any): PolyEditInsetOutsetActivity;
}

declare type EPolyEditCutPlaneOrientation = 'FaceNormals' | 'ViewDirection' | 'EPolyEditCutPlaneOrientation_MAX';
declare var EPolyEditCutPlaneOrientation : { FaceNormals:'FaceNormals',ViewDirection:'ViewDirection',EPolyEditCutPlaneOrientation_MAX:'EPolyEditCutPlaneOrientation_MAX', };
declare class PolyEditCutProperties extends InteractiveToolPropertySet { 
	Orientation: EPolyEditCutPlaneOrientation;
	bSnapToVertices: boolean;
	static Load(ResourceName: string): PolyEditCutProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditCutProperties;
	static GetDefaultObject(): PolyEditCutProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditCutProperties;
	static C(Other: UObject | any): PolyEditCutProperties;
}

declare class PolyEditCutFacesActivity extends InteractiveToolActivity { 
	CutProperties: PolyEditCutProperties;
	EditPreview: PolyEditPreviewMesh;
	SurfacePathMechanic: CollectSurfacePathMechanic;
	ActivityContext: PolyEditActivityContext;
	static Load(ResourceName: string): PolyEditCutFacesActivity;
	static Find(Outer: UObject, ResourceName: string): PolyEditCutFacesActivity;
	static GetDefaultObject(): PolyEditCutFacesActivity;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditCutFacesActivity;
	static C(Other: UObject | any): PolyEditCutFacesActivity;
}

declare class PolyEditSetUVProperties extends InteractiveToolPropertySet { 
	bShowMaterial: boolean;
	static Load(ResourceName: string): PolyEditSetUVProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditSetUVProperties;
	static GetDefaultObject(): PolyEditSetUVProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditSetUVProperties;
	static C(Other: UObject | any): PolyEditSetUVProperties;
}

declare class PolyEditPlanarProjectionUVActivity extends InteractiveToolActivity { 
	SetUVProperties: PolyEditSetUVProperties;
	EditPreview: PolyEditPreviewMesh;
	SurfacePathMechanic: CollectSurfacePathMechanic;
	ActivityContext: PolyEditActivityContext;
	static Load(ResourceName: string): PolyEditPlanarProjectionUVActivity;
	static Find(Outer: UObject, ResourceName: string): PolyEditPlanarProjectionUVActivity;
	static GetDefaultObject(): PolyEditPlanarProjectionUVActivity;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditPlanarProjectionUVActivity;
	static C(Other: UObject | any): PolyEditPlanarProjectionUVActivity;
}

declare type EGroupEdgeInsertionMode = 'Retriangulate' | 'PlaneCut' | 'EGroupEdgeInsertionMode_MAX';
declare var EGroupEdgeInsertionMode : { Retriangulate:'Retriangulate',PlaneCut:'PlaneCut',EGroupEdgeInsertionMode_MAX:'EGroupEdgeInsertionMode_MAX', };
declare class GroupEdgeInsertionProperties extends InteractiveToolPropertySet { 
	InsertionMode: EGroupEdgeInsertionMode;
	VertexTolerance: number;
	static Load(ResourceName: string): GroupEdgeInsertionProperties;
	static Find(Outer: UObject, ResourceName: string): GroupEdgeInsertionProperties;
	static GetDefaultObject(): GroupEdgeInsertionProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GroupEdgeInsertionProperties;
	static C(Other: UObject | any): GroupEdgeInsertionProperties;
}

declare class PolyEditInsertEdgeActivity extends InteractiveToolActivity { 
	Settings: GroupEdgeInsertionProperties;
	ActivityContext: PolyEditActivityContext;
	static Load(ResourceName: string): PolyEditInsertEdgeActivity;
	static Find(Outer: UObject, ResourceName: string): PolyEditInsertEdgeActivity;
	static GetDefaultObject(): PolyEditInsertEdgeActivity;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditInsertEdgeActivity;
	static C(Other: UObject | any): PolyEditInsertEdgeActivity;
}

declare type EEdgeLoopPositioningMode = 'Even' | 'ProportionOffset' | 'DistanceOffset' | 'EEdgeLoopPositioningMode_MAX';
declare var EEdgeLoopPositioningMode : { Even:'Even',ProportionOffset:'ProportionOffset',DistanceOffset:'DistanceOffset',EEdgeLoopPositioningMode_MAX:'EEdgeLoopPositioningMode_MAX', };
declare type EEdgeLoopInsertionMode = 'Retriangulate' | 'PlaneCut' | 'EEdgeLoopInsertionMode_MAX';
declare var EEdgeLoopInsertionMode : { Retriangulate:'Retriangulate',PlaneCut:'PlaneCut',EEdgeLoopInsertionMode_MAX:'EEdgeLoopInsertionMode_MAX', };
declare class EdgeLoopInsertionProperties extends InteractiveToolPropertySet { 
	PositionMode: EEdgeLoopPositioningMode;
	InsertionMode: EEdgeLoopInsertionMode;
	NumLoops: number;
	ProportionOffset: number;
	DistanceOffset: number;
	bInteractive: boolean;
	bFlipOffsetDirection: boolean;
	bHighlightProblemGroups: boolean;
	VertexTolerance: number;
	static Load(ResourceName: string): EdgeLoopInsertionProperties;
	static Find(Outer: UObject, ResourceName: string): EdgeLoopInsertionProperties;
	static GetDefaultObject(): EdgeLoopInsertionProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdgeLoopInsertionProperties;
	static C(Other: UObject | any): EdgeLoopInsertionProperties;
}

declare class PolyEditInsertEdgeLoopActivity extends InteractiveToolActivity { 
	Settings: EdgeLoopInsertionProperties;
	ActivityContext: PolyEditActivityContext;
	static Load(ResourceName: string): PolyEditInsertEdgeLoopActivity;
	static Find(Outer: UObject, ResourceName: string): PolyEditInsertEdgeLoopActivity;
	static GetDefaultObject(): PolyEditInsertEdgeLoopActivity;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditInsertEdgeLoopActivity;
	static C(Other: UObject | any): PolyEditInsertEdgeLoopActivity;
}

declare class PolyEditBevelEdgeProperties extends InteractiveToolPropertySet { 
	BevelDistance: number;
	static Load(ResourceName: string): PolyEditBevelEdgeProperties;
	static Find(Outer: UObject, ResourceName: string): PolyEditBevelEdgeProperties;
	static GetDefaultObject(): PolyEditBevelEdgeProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditBevelEdgeProperties;
	static C(Other: UObject | any): PolyEditBevelEdgeProperties;
}

declare class PolyEditBevelEdgeActivity extends InteractiveToolActivity { 
	BevelProperties: PolyEditBevelEdgeProperties;
	ActivityContext: PolyEditActivityContext;
	static Load(ResourceName: string): PolyEditBevelEdgeActivity;
	static Find(Outer: UObject, ResourceName: string): PolyEditBevelEdgeActivity;
	static GetDefaultObject(): PolyEditBevelEdgeActivity;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PolyEditBevelEdgeActivity;
	static C(Other: UObject | any): PolyEditBevelEdgeActivity;
}

declare class EditMeshPolygonsTool extends SingleSelectionMeshEditingTool { 
	Preview: MeshOpPreviewWithBackgroundCompute;
	CommonProps: PolyEditCommonProperties;
	EditActions: EditMeshPolygonsToolActions;
	EditActions_Triangles: EditMeshPolygonsToolActions_Triangles;
	EditEdgeActions: EditMeshPolygonsToolEdgeActions;
	EditEdgeActions_Triangles: EditMeshPolygonsToolEdgeActions_Triangles;
	EditUVActions: EditMeshPolygonsToolUVActions;
	CancelAction: EditMeshPolygonsToolCancelAction;
	AcceptCancelAction: EditMeshPolygonsToolAcceptCancelAction;
	TopologyProperties: PolyEditTopologyProperties;
	ExtrudeActivity: PolyEditExtrudeActivity;
	InsetOutsetActivity: PolyEditInsetOutsetActivity;
	CutFacesActivity: PolyEditCutFacesActivity;
	PlanarProjectionUVActivity: PolyEditPlanarProjectionUVActivity;
	InsertEdgeActivity: PolyEditInsertEdgeActivity;
	InsertEdgeLoopActivity: PolyEditInsertEdgeLoopActivity;
	BevelEdgeActivity: PolyEditBevelEdgeActivity;
	ActivityContext: PolyEditActivityContext;
	SelectionMechanic: PolygonSelectionMechanic;
	DragAlignmentMechanic: DragAlignmentMechanic;
	TransformGizmo: CombinedTransformGizmo;
	TransformProxy: TransformProxy;
	static Load(ResourceName: string): EditMeshPolygonsTool;
	static Find(Outer: UObject, ResourceName: string): EditMeshPolygonsTool;
	static GetDefaultObject(): EditMeshPolygonsTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditMeshPolygonsTool;
	static C(Other: UObject | any): EditMeshPolygonsTool;
}

declare type ESetMeshMaterialMode = 'Original' | 'Checkerboard' | 'Override' | 'ESetMeshMaterialMode_MAX';
declare var ESetMeshMaterialMode : { Original:'Original',Checkerboard:'Checkerboard',Override:'Override',ESetMeshMaterialMode_MAX:'ESetMeshMaterialMode_MAX', };
declare class ExistingMeshMaterialProperties extends InteractiveToolPropertySet { 
	MaterialMode: ESetMeshMaterialMode;
	CheckerDensity: number;
	OverrideMaterial: MaterialInterface;
	UVChannel: string;
	UVChannelNamesList: string[];
	CheckerMaterial: MaterialInstanceDynamic;
	static Load(ResourceName: string): ExistingMeshMaterialProperties;
	static Find(Outer: UObject, ResourceName: string): ExistingMeshMaterialProperties;
	static GetDefaultObject(): ExistingMeshMaterialProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ExistingMeshMaterialProperties;
	GetUVChannelNamesFunc(): string[];
	static C(Other: UObject | any): ExistingMeshMaterialProperties;
}

declare type EMeshEditingMaterialModes = 'ExistingMaterial' | 'Diffuse' | 'Grey' | 'Soft' | 'Transparent' | 'TangentNormal' | 'VertexColor' | 'CustomImage' | 'Custom' | 'EMeshEditingMaterialModes_MAX';
declare var EMeshEditingMaterialModes : { ExistingMaterial:'ExistingMaterial',Diffuse:'Diffuse',Grey:'Grey',Soft:'Soft',Transparent:'Transparent',TangentNormal:'TangentNormal',VertexColor:'VertexColor',CustomImage:'CustomImage',Custom:'Custom',EMeshEditingMaterialModes_MAX:'EMeshEditingMaterialModes_MAX', };
declare class MeshEditingViewProperties extends InteractiveToolPropertySet { 
	bShowWireframe: boolean;
	MaterialMode: EMeshEditingMaterialModes;
	bFlatShading: boolean;
	Color: LinearColor;
	UImage: Texture2D;
	Opacity: number;
	TransparentMaterialColor: LinearColor;
	bTwoSided: boolean;
	CustomMaterial: MaterialInterface;
	static Load(ResourceName: string): MeshEditingViewProperties;
	static Find(Outer: UObject, ResourceName: string): MeshEditingViewProperties;
	static GetDefaultObject(): MeshEditingViewProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshEditingViewProperties;
	static C(Other: UObject | any): MeshEditingViewProperties;
}

declare class MeshUVChannelProperties extends InteractiveToolPropertySet { 
	UVChannel: string;
	UVChannelNamesList: string[];
	static Load(ResourceName: string): MeshUVChannelProperties;
	static Find(Outer: UObject, ResourceName: string): MeshUVChannelProperties;
	static GetDefaultObject(): MeshUVChannelProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshUVChannelProperties;
	GetUVChannelNamesFunc(): string[];
	static C(Other: UObject | any): MeshUVChannelProperties;
}

declare class RecomputeUVsToolBuilder extends SingleSelectionMeshEditingToolBuilder { 
	static Load(ResourceName: string): RecomputeUVsToolBuilder;
	static Find(Outer: UObject, ResourceName: string): RecomputeUVsToolBuilder;
	static GetDefaultObject(): RecomputeUVsToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RecomputeUVsToolBuilder;
	static C(Other: UObject | any): RecomputeUVsToolBuilder;
}

declare class RecomputeUVsTool extends SingleSelectionMeshEditingTool { 
	UVChannelProperties: MeshUVChannelProperties;
	Settings: RecomputeUVsToolProperties;
	PolygroupLayerProperties: PolygroupLayersProperties;
	MaterialSettings: ExistingMeshMaterialProperties;
	bCreateUVLayoutViewOnSetup: boolean;
	UVLayoutView: UVLayoutPreview;
	RecomputeUVsOpFactory: RecomputeUVsOpFactory;
	Preview: MeshOpPreviewWithBackgroundCompute;
	static Load(ResourceName: string): RecomputeUVsTool;
	static Find(Outer: UObject, ResourceName: string): RecomputeUVsTool;
	static GetDefaultObject(): RecomputeUVsTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RecomputeUVsTool;
	static C(Other: UObject | any): RecomputeUVsTool;
}

declare class UVLayoutToolBuilder extends MultiSelectionMeshEditingToolBuilder { 
	static Load(ResourceName: string): UVLayoutToolBuilder;
	static Find(Outer: UObject, ResourceName: string): UVLayoutToolBuilder;
	static GetDefaultObject(): UVLayoutToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVLayoutToolBuilder;
	static C(Other: UObject | any): UVLayoutToolBuilder;
}

declare class UVLayoutTool extends MultiSelectionMeshEditingTool { 
	UVChannelProperties: MeshUVChannelProperties;
	BasicProperties: UVLayoutProperties;
	MaterialSettings: ExistingMeshMaterialProperties;
	Previews: MeshOpPreviewWithBackgroundCompute[];
	Factories: UVLayoutOperatorFactory[];
	UVLayoutView: UVLayoutPreview;
	static Load(ResourceName: string): UVLayoutTool;
	static Find(Outer: UObject, ResourceName: string): UVLayoutTool;
	static GetDefaultObject(): UVLayoutTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVLayoutTool;
	static C(Other: UObject | any): UVLayoutTool;
}

declare class UVProjectionToolBuilder extends SingleSelectionMeshEditingToolBuilder { 
	static Load(ResourceName: string): UVProjectionToolBuilder;
	static Find(Outer: UObject, ResourceName: string): UVProjectionToolBuilder;
	static GetDefaultObject(): UVProjectionToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVProjectionToolBuilder;
	static C(Other: UObject | any): UVProjectionToolBuilder;
}

declare class UVProjectionToolEditActions extends InteractiveToolPropertySet { 
	static Load(ResourceName: string): UVProjectionToolEditActions;
	static Find(Outer: UObject, ResourceName: string): UVProjectionToolEditActions;
	static GetDefaultObject(): UVProjectionToolEditActions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVProjectionToolEditActions;
	Reset(): void;
	AutoFitAlign(): void;
	AutoFit(): void;
	static C(Other: UObject | any): UVProjectionToolEditActions;
}

declare type EUVProjectionMethod = 'Box' | 'Cylinder' | 'Plane' | 'ExpMap' | 'EUVProjectionMethod_MAX';
declare var EUVProjectionMethod : { Box:'Box',Cylinder:'Cylinder',Plane:'Plane',ExpMap:'ExpMap',EUVProjectionMethod_MAX:'EUVProjectionMethod_MAX', };
declare type EUVProjectionToolInitializationMode = 'Default' | 'UsePrevious' | 'AutoFit' | 'AutoFitAlign' | 'EUVProjectionToolInitializationMode_MAX';
declare var EUVProjectionToolInitializationMode : { Default:'Default',UsePrevious:'UsePrevious',AutoFit:'AutoFit',AutoFitAlign:'AutoFitAlign',EUVProjectionToolInitializationMode_MAX:'EUVProjectionToolInitializationMode_MAX', };
declare class UVProjectionToolProperties extends InteractiveToolPropertySet { 
	ProjectionType: EUVProjectionMethod;
	Dimensions: Vector;
	bUniformDimensions: boolean;
	Initialization: EUVProjectionToolInitializationMode;
	CylinderSplitAngle: number;
	ExpMapNormalBlending: number;
	ExpMapSmoothingSteps: number;
	ExpMapSmoothingAlpha: number;
	Rotation: number;
	Scale: Vector2D;
	Translation: Vector2D;
	SavedDimensions: Vector;
	bSavedUniformDimensions: boolean;
	SavedTransform: Transform;
	static Load(ResourceName: string): UVProjectionToolProperties;
	static Find(Outer: UObject, ResourceName: string): UVProjectionToolProperties;
	static GetDefaultObject(): UVProjectionToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVProjectionToolProperties;
	static C(Other: UObject | any): UVProjectionToolProperties;
}

declare class UVProjectionTool extends SingleSelectionMeshEditingTool { 
	UVChannelProperties: MeshUVChannelProperties;
	BasicProperties: UVProjectionToolProperties;
	EditActions: UVProjectionToolEditActions;
	MaterialSettings: ExistingMeshMaterialProperties;
	Preview: MeshOpPreviewWithBackgroundCompute;
	CheckerMaterial: MaterialInstanceDynamic;
	TransformGizmo: CombinedTransformGizmo;
	TransformProxy: TransformProxy;
	OperatorFactory: UVProjectionOperatorFactory;
	EdgeRenderer: PreviewGeometry;
	ClickToSetPlaneBehavior: SingleClickInputBehavior;
	static Load(ResourceName: string): UVProjectionTool;
	static Find(Outer: UObject, ResourceName: string): UVProjectionTool;
	static GetDefaultObject(): UVProjectionTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVProjectionTool;
	static C(Other: UObject | any): UVProjectionTool;
}

declare class UVProjectionOperatorFactory extends UObject { 
	Tool: UVProjectionTool;
	static Load(ResourceName: string): UVProjectionOperatorFactory;
	static Find(Outer: UObject, ResourceName: string): UVProjectionOperatorFactory;
	static GetDefaultObject(): UVProjectionOperatorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UVProjectionOperatorFactory;
	static C(Other: UObject | any): UVProjectionOperatorFactory;
}

declare type EParameterizeMeshUVMethod = 'PatchBuilder' | 'UVAtlas' | 'XAtlas' | 'EParameterizeMeshUVMethod_MAX';
declare var EParameterizeMeshUVMethod : { PatchBuilder:'PatchBuilder',UVAtlas:'UVAtlas',XAtlas:'XAtlas',EParameterizeMeshUVMethod_MAX:'EParameterizeMeshUVMethod_MAX', };
declare class ParameterizeMeshToolProperties extends InteractiveToolPropertySet { 
	Method: EParameterizeMeshUVMethod;
	static Load(ResourceName: string): ParameterizeMeshToolProperties;
	static Find(Outer: UObject, ResourceName: string): ParameterizeMeshToolProperties;
	static GetDefaultObject(): ParameterizeMeshToolProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParameterizeMeshToolProperties;
	static C(Other: UObject | any): ParameterizeMeshToolProperties;
}

declare class ParameterizeMeshToolUVAtlasProperties extends InteractiveToolPropertySet { 
	IslandStretch: number;
	NumIslands: number;
	TextureResolution: number;
	static Load(ResourceName: string): ParameterizeMeshToolUVAtlasProperties;
	static Find(Outer: UObject, ResourceName: string): ParameterizeMeshToolUVAtlasProperties;
	static GetDefaultObject(): ParameterizeMeshToolUVAtlasProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParameterizeMeshToolUVAtlasProperties;
	static C(Other: UObject | any): ParameterizeMeshToolUVAtlasProperties;
}

declare class ParameterizeMeshToolXAtlasProperties extends InteractiveToolPropertySet { 
	MaxIterations: number;
	static Load(ResourceName: string): ParameterizeMeshToolXAtlasProperties;
	static Find(Outer: UObject, ResourceName: string): ParameterizeMeshToolXAtlasProperties;
	static GetDefaultObject(): ParameterizeMeshToolXAtlasProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParameterizeMeshToolXAtlasProperties;
	static C(Other: UObject | any): ParameterizeMeshToolXAtlasProperties;
}

declare class ParameterizeMeshToolPatchBuilderProperties extends InteractiveToolPropertySet { 
	InitialPatches: number;
	CurvatureAlignment: number;
	MergingDistortionThreshold: number;
	MergingAngleThreshold: number;
	SmoothingSteps: number;
	SmoothingAlpha: number;
	bRepack: boolean;
	TextureResolution: number;
	static Load(ResourceName: string): ParameterizeMeshToolPatchBuilderProperties;
	static Find(Outer: UObject, ResourceName: string): ParameterizeMeshToolPatchBuilderProperties;
	static GetDefaultObject(): ParameterizeMeshToolPatchBuilderProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParameterizeMeshToolPatchBuilderProperties;
	static C(Other: UObject | any): ParameterizeMeshToolPatchBuilderProperties;
}

declare class ParameterizeMeshOperatorFactory extends UObject { 
	Settings: ParameterizeMeshToolProperties;
	UVAtlasProperties: ParameterizeMeshToolUVAtlasProperties;
	XAtlasProperties: ParameterizeMeshToolXAtlasProperties;
	PatchBuilderProperties: ParameterizeMeshToolPatchBuilderProperties;
	static Load(ResourceName: string): ParameterizeMeshOperatorFactory;
	static Find(Outer: UObject, ResourceName: string): ParameterizeMeshOperatorFactory;
	static GetDefaultObject(): ParameterizeMeshOperatorFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParameterizeMeshOperatorFactory;
	static C(Other: UObject | any): ParameterizeMeshOperatorFactory;
}

declare class ParameterizeMeshToolBuilder extends SingleSelectionMeshEditingToolBuilder { 
	static Load(ResourceName: string): ParameterizeMeshToolBuilder;
	static Find(Outer: UObject, ResourceName: string): ParameterizeMeshToolBuilder;
	static GetDefaultObject(): ParameterizeMeshToolBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParameterizeMeshToolBuilder;
	static C(Other: UObject | any): ParameterizeMeshToolBuilder;
}

declare class ParameterizeMeshToolPatchBuilderGroupLayerProperties extends PolygroupLayersProperties { 
	bConstrainToPolygroups: boolean;
	static Load(ResourceName: string): ParameterizeMeshToolPatchBuilderGroupLayerProperties;
	static Find(Outer: UObject, ResourceName: string): ParameterizeMeshToolPatchBuilderGroupLayerProperties;
	static GetDefaultObject(): ParameterizeMeshToolPatchBuilderGroupLayerProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParameterizeMeshToolPatchBuilderGroupLayerProperties;
	static C(Other: UObject | any): ParameterizeMeshToolPatchBuilderGroupLayerProperties;
}

declare class ParameterizeMeshTool extends SingleSelectionMeshEditingTool { 
	UVChannelProperties: MeshUVChannelProperties;
	Settings: ParameterizeMeshToolProperties;
	UVAtlasProperties: ParameterizeMeshToolUVAtlasProperties;
	XAtlasProperties: ParameterizeMeshToolXAtlasProperties;
	PatchBuilderProperties: ParameterizeMeshToolPatchBuilderProperties;
	PolygroupLayerProperties: ParameterizeMeshToolPatchBuilderGroupLayerProperties;
	MaterialSettings: ExistingMeshMaterialProperties;
	bCreateUVLayoutViewOnSetup: boolean;
	UVLayoutView: UVLayoutPreview;
	Preview: MeshOpPreviewWithBackgroundCompute;
	static Load(ResourceName: string): ParameterizeMeshTool;
	static Find(Outer: UObject, ResourceName: string): ParameterizeMeshTool;
	static GetDefaultObject(): ParameterizeMeshTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParameterizeMeshTool;
	static C(Other: UObject | any): ParameterizeMeshTool;
}

declare class OnDynamicMeshModifiedBP__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnDynamicMeshModifiedBP__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnDynamicMeshModifiedBP__PythonCallable;
	static GetDefaultObject(): OnDynamicMeshModifiedBP__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnDynamicMeshModifiedBP__PythonCallable;
	static C(Other: UObject | any): OnDynamicMeshModifiedBP__PythonCallable;
}

declare class EditorModelingObjectsCreationAPI extends ModelingObjectsCreationAPI { 
	static Load(ResourceName: string): EditorModelingObjectsCreationAPI;
	static Find(Outer: UObject, ResourceName: string): EditorModelingObjectsCreationAPI;
	static GetDefaultObject(): EditorModelingObjectsCreationAPI;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorModelingObjectsCreationAPI;
	static C(Other: UObject | any): EditorModelingObjectsCreationAPI;
}

declare class DynamicMeshComponentToolTarget extends PrimitiveComponentToolTarget { 
	static Load(ResourceName: string): DynamicMeshComponentToolTarget;
	static Find(Outer: UObject, ResourceName: string): DynamicMeshComponentToolTarget;
	static GetDefaultObject(): DynamicMeshComponentToolTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshComponentToolTarget;
	static C(Other: UObject | any): DynamicMeshComponentToolTarget;
}

declare class DynamicMeshComponentToolTargetFactory extends ToolTargetFactory { 
	static Load(ResourceName: string): DynamicMeshComponentToolTargetFactory;
	static Find(Outer: UObject, ResourceName: string): DynamicMeshComponentToolTargetFactory;
	static GetDefaultObject(): DynamicMeshComponentToolTargetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicMeshComponentToolTargetFactory;
	static C(Other: UObject | any): DynamicMeshComponentToolTargetFactory;
}

declare class SkeletalMeshComponentReadOnlyToolTarget extends PrimitiveComponentToolTarget { 
	static Load(ResourceName: string): SkeletalMeshComponentReadOnlyToolTarget;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshComponentReadOnlyToolTarget;
	static GetDefaultObject(): SkeletalMeshComponentReadOnlyToolTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshComponentReadOnlyToolTarget;
	static C(Other: UObject | any): SkeletalMeshComponentReadOnlyToolTarget;
}

declare class SkeletalMeshComponentToolTarget extends SkeletalMeshComponentReadOnlyToolTarget { 
	static Load(ResourceName: string): SkeletalMeshComponentToolTarget;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshComponentToolTarget;
	static GetDefaultObject(): SkeletalMeshComponentToolTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshComponentToolTarget;
	static C(Other: UObject | any): SkeletalMeshComponentToolTarget;
}

declare class SkeletalMeshComponentReadOnlyToolTargetFactory extends ToolTargetFactory { 
	static Load(ResourceName: string): SkeletalMeshComponentReadOnlyToolTargetFactory;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshComponentReadOnlyToolTargetFactory;
	static GetDefaultObject(): SkeletalMeshComponentReadOnlyToolTargetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshComponentReadOnlyToolTargetFactory;
	static C(Other: UObject | any): SkeletalMeshComponentReadOnlyToolTargetFactory;
}

declare class SkeletalMeshComponentToolTargetFactory extends ToolTargetFactory { 
	static Load(ResourceName: string): SkeletalMeshComponentToolTargetFactory;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshComponentToolTargetFactory;
	static GetDefaultObject(): SkeletalMeshComponentToolTargetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshComponentToolTargetFactory;
	static C(Other: UObject | any): SkeletalMeshComponentToolTargetFactory;
}

declare class SkeletalMeshReadOnlyToolTarget extends ToolTarget { 
	static Load(ResourceName: string): SkeletalMeshReadOnlyToolTarget;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshReadOnlyToolTarget;
	static GetDefaultObject(): SkeletalMeshReadOnlyToolTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshReadOnlyToolTarget;
	static C(Other: UObject | any): SkeletalMeshReadOnlyToolTarget;
}

declare class SkeletalMeshToolTarget extends SkeletalMeshReadOnlyToolTarget { 
	static Load(ResourceName: string): SkeletalMeshToolTarget;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshToolTarget;
	static GetDefaultObject(): SkeletalMeshToolTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshToolTarget;
	static C(Other: UObject | any): SkeletalMeshToolTarget;
}

declare class SkeletalMeshReadOnlyToolTargetFactory extends ToolTargetFactory { 
	static Load(ResourceName: string): SkeletalMeshReadOnlyToolTargetFactory;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshReadOnlyToolTargetFactory;
	static GetDefaultObject(): SkeletalMeshReadOnlyToolTargetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshReadOnlyToolTargetFactory;
	static C(Other: UObject | any): SkeletalMeshReadOnlyToolTargetFactory;
}

declare class SkeletalMeshToolTargetFactory extends ToolTargetFactory { 
	static Load(ResourceName: string): SkeletalMeshToolTargetFactory;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshToolTargetFactory;
	static GetDefaultObject(): SkeletalMeshToolTargetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshToolTargetFactory;
	static C(Other: UObject | any): SkeletalMeshToolTargetFactory;
}

declare class StaticMeshComponentToolTarget extends PrimitiveComponentToolTarget { 
	static Load(ResourceName: string): StaticMeshComponentToolTarget;
	static Find(Outer: UObject, ResourceName: string): StaticMeshComponentToolTarget;
	static GetDefaultObject(): StaticMeshComponentToolTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshComponentToolTarget;
	static C(Other: UObject | any): StaticMeshComponentToolTarget;
}

declare class StaticMeshComponentToolTargetFactory extends ToolTargetFactory { 
	static Load(ResourceName: string): StaticMeshComponentToolTargetFactory;
	static Find(Outer: UObject, ResourceName: string): StaticMeshComponentToolTargetFactory;
	static GetDefaultObject(): StaticMeshComponentToolTargetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshComponentToolTargetFactory;
	static C(Other: UObject | any): StaticMeshComponentToolTargetFactory;
}

declare class StaticMeshToolTarget extends ToolTarget { 
	static Load(ResourceName: string): StaticMeshToolTarget;
	static Find(Outer: UObject, ResourceName: string): StaticMeshToolTarget;
	static GetDefaultObject(): StaticMeshToolTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshToolTarget;
	static C(Other: UObject | any): StaticMeshToolTarget;
}

declare class StaticMeshToolTargetFactory extends ToolTargetFactory { 
	static Load(ResourceName: string): StaticMeshToolTargetFactory;
	static Find(Outer: UObject, ResourceName: string): StaticMeshToolTargetFactory;
	static GetDefaultObject(): StaticMeshToolTargetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshToolTargetFactory;
	static C(Other: UObject | any): StaticMeshToolTargetFactory;
}

declare class VolumeComponentToolTarget extends PrimitiveComponentToolTarget { 
	static Load(ResourceName: string): VolumeComponentToolTarget;
	static Find(Outer: UObject, ResourceName: string): VolumeComponentToolTarget;
	static GetDefaultObject(): VolumeComponentToolTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VolumeComponentToolTarget;
	static C(Other: UObject | any): VolumeComponentToolTarget;
}

declare class VolumeComponentToolTargetFactory extends ToolTargetFactory { 
	static Load(ResourceName: string): VolumeComponentToolTargetFactory;
	static Find(Outer: UObject, ResourceName: string): VolumeComponentToolTargetFactory;
	static GetDefaultObject(): VolumeComponentToolTargetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VolumeComponentToolTargetFactory;
	static C(Other: UObject | any): VolumeComponentToolTargetFactory;
}

declare class MobileInstalledContent extends UObject { 
	static Load(ResourceName: string): MobileInstalledContent;
	static Find(Outer: UObject, ResourceName: string): MobileInstalledContent;
	static GetDefaultObject(): MobileInstalledContent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MobileInstalledContent;
	Mount(PakOrder: number,MountPoint: string): boolean;
	GetInstalledContentSize(): number;
	GetDiskFreeSpace(): number;
	static C(Other: UObject | any): MobileInstalledContent;
}

declare class MobilePendingContent extends MobileInstalledContent { 
	static Load(ResourceName: string): MobilePendingContent;
	static Find(Outer: UObject, ResourceName: string): MobilePendingContent;
	static GetDefaultObject(): MobilePendingContent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MobilePendingContent;
	GetTotalDownloadedSize(): number;
	GetRequiredDiskSpace(): number;
	GetInstallProgress(): number;
	GetDownloadStatusText(): string;
	GetDownloadSpeed(): number;
	GetDownloadSize(): number;
	static C(Other: UObject | any): MobilePendingContent;
}

declare class MobilePatchingLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): MobilePatchingLibrary;
	static Find(Outer: UObject, ResourceName: string): MobilePatchingLibrary;
	static GetDefaultObject(): MobilePatchingLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MobilePatchingLibrary;
	static HasActiveWiFiConnection(): boolean;
	static GetSupportedPlatformNames(): string[];
	static GetInstalledContent(InstallDirectory: string): MobileInstalledContent;
	static GetActiveDeviceProfileName(): string;
	static C(Other: UObject | any): MobilePatchingLibrary;
}

declare class OnContentInstallFailed__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnContentInstallFailed__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnContentInstallFailed__PythonCallable;
	static GetDefaultObject(): OnContentInstallFailed__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnContentInstallFailed__PythonCallable;
	static C(Other: UObject | any): OnContentInstallFailed__PythonCallable;
}

declare class OnContentInstallSucceeded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnContentInstallSucceeded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnContentInstallSucceeded__PythonCallable;
	static GetDefaultObject(): OnContentInstallSucceeded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnContentInstallSucceeded__PythonCallable;
	static C(Other: UObject | any): OnContentInstallSucceeded__PythonCallable;
}

declare class OnRequestContentFailed__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnRequestContentFailed__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnRequestContentFailed__PythonCallable;
	static GetDefaultObject(): OnRequestContentFailed__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnRequestContentFailed__PythonCallable;
	static C(Other: UObject | any): OnRequestContentFailed__PythonCallable;
}

declare class OnRequestContentSucceeded__PythonCallable extends PythonCallableForDelegate { 
	static Load(ResourceName: string): OnRequestContentSucceeded__PythonCallable;
	static Find(Outer: UObject, ResourceName: string): OnRequestContentSucceeded__PythonCallable;
	static GetDefaultObject(): OnRequestContentSucceeded__PythonCallable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnRequestContentSucceeded__PythonCallable;
	static C(Other: UObject | any): OnRequestContentSucceeded__PythonCallable;
}

declare type EResonanceRenderMode = 'StereoPanning' | 'BinauralLowQuality' | 'BinauralMediumQuality' | 'BinauralHighQuality' | 'RoomEffectsOnly' | 'EResonanceRenderMode_MAX';
declare var EResonanceRenderMode : { StereoPanning:'StereoPanning',BinauralLowQuality:'BinauralLowQuality',BinauralMediumQuality:'BinauralMediumQuality',BinauralHighQuality:'BinauralHighQuality',RoomEffectsOnly:'RoomEffectsOnly',EResonanceRenderMode_MAX:'EResonanceRenderMode_MAX', };
declare class ResonanceAudioSoundfieldSettings extends SoundfieldEncodingSettingsBase { 
	RenderMode: EResonanceRenderMode;
	static Load(ResourceName: string): ResonanceAudioSoundfieldSettings;
	static Find(Outer: UObject, ResourceName: string): ResonanceAudioSoundfieldSettings;
	static GetDefaultObject(): ResonanceAudioSoundfieldSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ResonanceAudioSoundfieldSettings;
	static C(Other: UObject | any): ResonanceAudioSoundfieldSettings;
}

declare type ERaMaterialName = 'TRANSPARENT' | 'ACOUSTIC_CEILING_TILES' | 'BRICK_BARE' | 'BRICK_PAINTED' | 'CONCRETE_BLOCK_COARSE' | 'CONCRETE_BLOCK_PAINTED' | 'CURTAIN_HEAVY' | 'FIBER_GLASS_INSULATION' | 'GLASS_THIN' | 'GLASS_THICK' | 'GRASS' | 'LINOLEUM_ON_CONCRETE' | 'MARBLE' | 'METAL' | 'PARQUET_ONCONCRETE' | 'PLASTER_ROUGH' | 'PLASTER_SMOOTH' | 'PLYWOOD_PANEL' | 'POLISHED_CONCRETE_OR_TILE' | 'SHEETROCK' | 'WATER_OR_ICE_SURFACE' | 'WOOD_CEILING' | 'WOOD_PANEL' | 'UNIFORM' | 'ERaMaterialName_MAX';
declare var ERaMaterialName : { TRANSPARENT:'TRANSPARENT',ACOUSTIC_CEILING_TILES:'ACOUSTIC_CEILING_TILES',BRICK_BARE:'BRICK_BARE',BRICK_PAINTED:'BRICK_PAINTED',CONCRETE_BLOCK_COARSE:'CONCRETE_BLOCK_COARSE',CONCRETE_BLOCK_PAINTED:'CONCRETE_BLOCK_PAINTED',CURTAIN_HEAVY:'CURTAIN_HEAVY',FIBER_GLASS_INSULATION:'FIBER_GLASS_INSULATION',GLASS_THIN:'GLASS_THIN',GLASS_THICK:'GLASS_THICK',GRASS:'GRASS',LINOLEUM_ON_CONCRETE:'LINOLEUM_ON_CONCRETE',MARBLE:'MARBLE',METAL:'METAL',PARQUET_ONCONCRETE:'PARQUET_ONCONCRETE',PLASTER_ROUGH:'PLASTER_ROUGH',PLASTER_SMOOTH:'PLASTER_SMOOTH',PLYWOOD_PANEL:'PLYWOOD_PANEL',POLISHED_CONCRETE_OR_TILE:'POLISHED_CONCRETE_OR_TILE',SHEETROCK:'SHEETROCK',WATER_OR_ICE_SURFACE:'WATER_OR_ICE_SURFACE',WOOD_CEILING:'WOOD_CEILING',WOOD_PANEL:'WOOD_PANEL',UNIFORM:'UNIFORM',ERaMaterialName_MAX:'ERaMaterialName_MAX', };
declare class ResonanceAudioReverbPluginSettings { 
	bEnableRoomEffects: boolean;
	bGetTransformFromAudioVolume: boolean;
	RoomPosition: Vector;
	RoomRotation: Quat;
	RoomDimensions: Vector;
	LeftWallMaterial: ERaMaterialName;
	RightWallMaterial: ERaMaterialName;
	FloorMaterial: ERaMaterialName;
	CeilingMaterial: ERaMaterialName;
	FrontWallMaterial: ERaMaterialName;
	BackWallMaterial: ERaMaterialName;
	ReflectionScalar: number;
	ReverbGain: number;
	ReverbTimeModifier: number;
	ReverbBrightness: number;
	clone() : ResonanceAudioReverbPluginSettings;
	static C(Other: UObject | any): ResonanceAudioReverbPluginSettings;
}

declare class ResonanceAudioReverbPluginPreset extends SoundEffectSubmixPreset { 
	Settings: ResonanceAudioReverbPluginSettings;
	static Load(ResourceName: string): ResonanceAudioReverbPluginPreset;
	static Find(Outer: UObject, ResourceName: string): ResonanceAudioReverbPluginPreset;
	static GetDefaultObject(): ResonanceAudioReverbPluginPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ResonanceAudioReverbPluginPreset;
	SetRoomRotation(InRotation: Quat): void;
	SetRoomPosition(InPosition: Vector): void;
	SetRoomMaterials(InMaterials: ERaMaterialName[]): void;
	SetRoomDimensions(InDimensions: Vector): void;
	SetReverbTimeModifier(InReverbTimeModifier: number): void;
	SetReverbGain(InReverbGain: number): void;
	SetReverbBrightness(InReverbBrightness: number): void;
	SetReflectionScalar(InReflectionScalar: number): void;
	SetEnableRoomEffects(bInEnableRoomEffects: boolean): void;
	static C(Other: UObject | any): ResonanceAudioReverbPluginPreset;
	SetGlobalReverbPreset(): void;
	static SetGlobalReverbPreset(InPreset: ResonanceAudioReverbPluginPreset): void;
}

declare class ResonanceAudioBlueprintFunctionLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): ResonanceAudioBlueprintFunctionLibrary;
	static Find(Outer: UObject, ResourceName: string): ResonanceAudioBlueprintFunctionLibrary;
	static GetDefaultObject(): ResonanceAudioBlueprintFunctionLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ResonanceAudioBlueprintFunctionLibrary;
	static SetGlobalReverbPreset(InPreset: ResonanceAudioReverbPluginPreset): void;
	static GetGlobalReverbPreset(): ResonanceAudioReverbPluginPreset;
	static C(Other: UObject | any): ResonanceAudioBlueprintFunctionLibrary;
}

declare type ERaSpatializationMethod = 'STEREO_PANNING' | 'HRTF' | 'ERaSpatializationMethod_MAX';
declare var ERaSpatializationMethod : { STEREO_PANNING:'STEREO_PANNING',HRTF:'HRTF',ERaSpatializationMethod_MAX:'ERaSpatializationMethod_MAX', };
declare type ERaDistanceRolloffModel = 'LOGARITHMIC' | 'LINEAR' | 'NONE' | 'ERaDistanceRolloffModel_MAX';
declare var ERaDistanceRolloffModel : { LOGARITHMIC:'LOGARITHMIC',LINEAR:'LINEAR',NONE:'NONE',ERaDistanceRolloffModel_MAX:'ERaDistanceRolloffModel_MAX', };
declare class ResonanceAudioSpatializationSourceSettings extends SpatializationPluginSourceSettingsBase { 
	SpatializationMethod: ERaSpatializationMethod;
	Pattern: number;
	Sharpness: number;
	bToggleVisualization: boolean;
	Scale: number;
	Spread: number;
	Rolloff: ERaDistanceRolloffModel;
	MinDistance: number;
	MaxDistance: number;
	static Load(ResourceName: string): ResonanceAudioSpatializationSourceSettings;
	static Find(Outer: UObject, ResourceName: string): ResonanceAudioSpatializationSourceSettings;
	static GetDefaultObject(): ResonanceAudioSpatializationSourceSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ResonanceAudioSpatializationSourceSettings;
	SetSoundSourceSpread(InSpread: number): void;
	SetSoundSourceDirectivity(InPattern: number,InSharpness: number): void;
	static C(Other: UObject | any): ResonanceAudioSpatializationSourceSettings;
}

declare class ResonanceAudioDirectivityVisualizer extends Actor { 
	Material: Material;
	Settings: ResonanceAudioSpatializationSourceSettings;
	static GetDefaultObject(): ResonanceAudioDirectivityVisualizer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ResonanceAudioDirectivityVisualizer;
	static C(Other: UObject | any): ResonanceAudioDirectivityVisualizer;
}

declare type ERaQualityMode = 'STEREO_PANNING' | 'BINAURAL_LOW' | 'BINAURAL_MEDIUM' | 'BINAURAL_HIGH' | 'ERaQualityMode_MAX';
declare var ERaQualityMode : { STEREO_PANNING:'STEREO_PANNING',BINAURAL_LOW:'BINAURAL_LOW',BINAURAL_MEDIUM:'BINAURAL_MEDIUM',BINAURAL_HIGH:'BINAURAL_HIGH',ERaQualityMode_MAX:'ERaQualityMode_MAX', };
declare class ResonanceAudioSettings extends UObject { 
	OutputSubmix: SoftObjectPath;
	QualityMode: ERaQualityMode;
	GlobalReverbPreset: SoftObjectPath;
	GlobalSourcePreset: SoftObjectPath;
	static Load(ResourceName: string): ResonanceAudioSettings;
	static Find(Outer: UObject, ResourceName: string): ResonanceAudioSettings;
	static GetDefaultObject(): ResonanceAudioSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ResonanceAudioSettings;
	static C(Other: UObject | any): ResonanceAudioSettings;
}

declare class InterchangeImportTestSettings extends UObject { 
	ImportTestsPath: string;
	ImportFiles: string[];
	static Load(ResourceName: string): InterchangeImportTestSettings;
	static Find(Outer: UObject, ResourceName: string): InterchangeImportTestSettings;
	static GetDefaultObject(): InterchangeImportTestSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeImportTestSettings;
	static C(Other: UObject | any): InterchangeImportTestSettings;
}

declare class ImportTestFunctionsBase extends UObject { 
	static Load(ResourceName: string): ImportTestFunctionsBase;
	static Find(Outer: UObject, ResourceName: string): ImportTestFunctionsBase;
	static GetDefaultObject(): ImportTestFunctionsBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ImportTestFunctionsBase;
	static C(Other: UObject | any): ImportTestFunctionsBase;
}

declare class InterchangeTestFunctionResult { 
	Infos: string[];
	Warnings: string[];
	Errors: string[];
	clone() : InterchangeTestFunctionResult;
	static C(Other: UObject | any): InterchangeTestFunctionResult;
}

declare class MaterialXTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): MaterialXTestFunctions;
	static Find(Outer: UObject, ResourceName: string): MaterialXTestFunctions;
	static GetDefaultObject(): MaterialXTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialXTestFunctions;
	static CheckInputConnected(MaterialInterface: MaterialInterface,InputName: string,bIsConnected: boolean): InterchangeTestFunctionResult;
	static CheckConnectedInputCount(MaterialInterface: MaterialInterface,ExpectedNumber: number): InterchangeTestFunctionResult;
	static C(Other: UObject | any): MaterialXTestFunctions;
}

declare class ActorImportTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): ActorImportTestFunctions;
	static Find(Outer: UObject, ResourceName: string): ActorImportTestFunctions;
	static GetDefaultObject(): ActorImportTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorImportTestFunctions;
	static CheckImportedActorCount(Actors: Actor[],ExpectedNumberOfImportedActors: number): InterchangeTestFunctionResult;
	static C(Other: UObject | any): ActorImportTestFunctions;
}

declare class AnimationImportTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): AnimationImportTestFunctions;
	static Find(Outer: UObject, ResourceName: string): AnimationImportTestFunctions;
	static GetDefaultObject(): AnimationImportTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimationImportTestFunctions;
	static C(Other: UObject | any): AnimationImportTestFunctions;
}

declare class AssetImportTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): AssetImportTestFunctions;
	static Find(Outer: UObject, ResourceName: string): AssetImportTestFunctions;
	static GetDefaultObject(): AssetImportTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AssetImportTestFunctions;
	static CheckMetadataValue(UObject: UObject,ExpectedMetadataKey: string,ExpectedMetadataValue: string): InterchangeTestFunctionResult;
	static CheckMetadataExist(UObject: UObject,ExpectedMetadataKey: string): InterchangeTestFunctionResult;
	static CheckImportedMetadataCount(UObject: UObject,ExpectedNumberOfMetadataForThisObject: number): InterchangeTestFunctionResult;
	static C(Other: UObject | any): AssetImportTestFunctions;
}

declare class InterchangeResultImportTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): InterchangeResultImportTestFunctions;
	static Find(Outer: UObject, ResourceName: string): InterchangeResultImportTestFunctions;
	static GetDefaultObject(): InterchangeResultImportTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeResultImportTestFunctions;
	static CheckIfErrorOrWarningWasGenerated(ResultsContainer: InterchangeResultsContainer,ErrorOrWarningClass: UnrealEngineClass): InterchangeTestFunctionResult;
	static C(Other: UObject | any): InterchangeResultImportTestFunctions;
}

declare class MaterialImportTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): MaterialImportTestFunctions;
	static Find(Outer: UObject, ResourceName: string): MaterialImportTestFunctions;
	static GetDefaultObject(): MaterialImportTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialImportTestFunctions;
	static CheckImportedMaterialInstanceCount(MaterialInterfaces: MaterialInterface[],ExpectedNumberOfImportedMaterialInstances: number): InterchangeTestFunctionResult;
	static CheckImportedMaterialCount(MaterialInterfaces: MaterialInterface[],ExpectedNumberOfImportedMaterials: number): InterchangeTestFunctionResult;
	static C(Other: UObject | any): MaterialImportTestFunctions;
}

declare class SkeletalMeshImportTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): SkeletalMeshImportTestFunctions;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshImportTestFunctions;
	static GetDefaultObject(): SkeletalMeshImportTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshImportTestFunctions;
	static CheckVertexIndexPosition(Mesh: SkeletalMesh,LODIndex: number,VertexIndex: number,ExpectedVertexPosition: Vector): InterchangeTestFunctionResult;
	static CheckUVChannelCount(Mesh: SkeletalMesh,LODIndex: number,ExpectedNumberOfUVChannels: number): InterchangeTestFunctionResult;
	static CheckTriangleCountInSection(Mesh: SkeletalMesh,LODIndex: number,SectionIndex: number,ExpectedNumberOfTriangles: number): InterchangeTestFunctionResult;
	static CheckSkinnedVertexCountForBone(Mesh: SkeletalMesh,BoneName: string,bTestFirstAlternateProfile: boolean,ExpectedSkinnedVertexCount: number): InterchangeTestFunctionResult;
	static CheckSectionMaterialName(Mesh: SkeletalMesh,LODIndex: number,SectionIndex: number,ExpectedMaterialName: string): InterchangeTestFunctionResult;
	static CheckSectionCount(Mesh: SkeletalMesh,LODIndex: number,ExpectedNumberOfSections: number): InterchangeTestFunctionResult;
	static CheckRenderVertexCount(Mesh: SkeletalMesh,LODIndex: number,ExpectedNumberOfRenderVertices: number): InterchangeTestFunctionResult;
	static CheckMaterialSlotCount(Mesh: SkeletalMesh,ExpectedNumberOfMaterialSlots: number): InterchangeTestFunctionResult;
	static CheckLodCount(Mesh: SkeletalMesh,ExpectedNumberOfLods: number): InterchangeTestFunctionResult;
	static CheckImportedSkeletalMeshCount(Meshes: SkeletalMesh[],ExpectedNumberOfImportedSkeletalMeshes: number): InterchangeTestFunctionResult;
	static CheckBonePosition(Mesh: SkeletalMesh,BoneIndex: number,ExpectedBonePosition: Vector): InterchangeTestFunctionResult;
	static CheckBoneCount(Mesh: SkeletalMesh,ExpectedNumberOfBones: number): InterchangeTestFunctionResult;
	static C(Other: UObject | any): SkeletalMeshImportTestFunctions;
}

declare class StaticMeshImportTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): StaticMeshImportTestFunctions;
	static Find(Outer: UObject, ResourceName: string): StaticMeshImportTestFunctions;
	static GetDefaultObject(): StaticMeshImportTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshImportTestFunctions;
	static CheckVertexIndexPosition(Mesh: StaticMesh,LODIndex: number,VertexIndex: number,ExpectedVertexPosition: Vector): InterchangeTestFunctionResult;
	static CheckVertexCount(Mesh: StaticMesh,LODIndex: number,ExpectedNumberOfVertices: number): InterchangeTestFunctionResult;
	static CheckUVChannelCount(Mesh: StaticMesh,LODIndex: number,ExpectedNumberOfUVChannels: number): InterchangeTestFunctionResult;
	static CheckTriangleCountInPolygonGroup(Mesh: StaticMesh,LODIndex: number,PolygonGroupIndex: number,ExpectedNumberOfTriangles: number): InterchangeTestFunctionResult;
	static CheckTotalTriangleCount(Mesh: StaticMesh,LODIndex: number,ExpectedTotalNumberOfTriangles: number): InterchangeTestFunctionResult;
	static CheckTotalPolygonCount(Mesh: StaticMesh,LODIndex: number,ExpectedNumberOfPolygons: number): InterchangeTestFunctionResult;
	static CheckThatMeshHasQuadsOrNgons(Mesh: StaticMesh,LODIndex: number,bMeshHasQuadsOrNgons: boolean): InterchangeTestFunctionResult;
	static CheckSocketName(Mesh: StaticMesh,SocketIndex: number,ExpectedSocketName: string): InterchangeTestFunctionResult;
	static CheckSocketLocation(Mesh: StaticMesh,SocketIndex: number,ExpectedSocketLocation: Vector): InterchangeTestFunctionResult;
	static CheckSocketCount(Mesh: StaticMesh,ExpectedSocketCount: number): InterchangeTestFunctionResult;
	static CheckSimpleCollisionPrimitiveCount(Mesh: StaticMesh,ExpectedSphereElementCount: number,ExpectedBoxElementCount: number,ExpectedCapsuleElementCount: number,ExpectedConvexElementCount: number,ExpectedTaperedCapsuleElementCount: number): InterchangeTestFunctionResult;
	static CheckSectionMaterialName(Mesh: StaticMesh,LODIndex: number,SectionIndex: number,ExpectedMaterialName: string): InterchangeTestFunctionResult;
	static CheckSectionMaterialIndex(Mesh: StaticMesh,LODIndex: number,SectionIndex: number,ExpectedMaterialIndex: number): InterchangeTestFunctionResult;
	static CheckSectionCount(Mesh: StaticMesh,LODIndex: number,ExpectedNumberOfSections: number): InterchangeTestFunctionResult;
	static CheckRenderVertexCount(Mesh: StaticMesh,LODIndex: number,ExpectedNumberOfRenderVertices: number): InterchangeTestFunctionResult;
	static CheckPolygonGroupImportedMaterialSlotName(Mesh: StaticMesh,LODIndex: number,PolygonGroupIndex: number,ExpectedImportedMaterialSlotName: string): InterchangeTestFunctionResult;
	static CheckPolygonGroupCount(Mesh: StaticMesh,LODIndex: number,ExpectedNumberOfPolygonGroups: number): InterchangeTestFunctionResult;
	static CheckPolygonCountInPolygonGroup(Mesh: StaticMesh,LODIndex: number,PolygonGroupIndex: number,ExpectedNumberOfPolygons: number): InterchangeTestFunctionResult;
	static CheckNaniteSettings(Mesh: StaticMesh,ExpectedNaniteSettings: MeshNaniteSettings): InterchangeTestFunctionResult;
	static CheckMaterialSlotCount(Mesh: StaticMesh,ExpectedNumberOfMaterialSlots: number): InterchangeTestFunctionResult;
	static CheckLodCount(Mesh: StaticMesh,ExpectedNumberOfLods: number): InterchangeTestFunctionResult;
	static CheckImportedStaticMeshCount(Meshes: StaticMesh[],ExpectedNumberOfImportedStaticMeshes: number): InterchangeTestFunctionResult;
	static CheckBuildSettings(Mesh: StaticMesh,LODIndex: number,ExpectedBuildSettings: MeshBuildSettings): InterchangeTestFunctionResult;
	static CheckAgainstGroundTruth(Mesh: StaticMesh,MeshToCompare: StaticMesh,bCheckVertexCountEqual: boolean,bCheckTriangleCountEqual: boolean,bCheckUVChannelCountEqual: boolean,bCheckCollisionPrimitiveCountEqual: boolean,bCheckVertexPositionsEqual: boolean,bCheckNormalsEqual: boolean): InterchangeTestFunctionResult;
	static C(Other: UObject | any): StaticMeshImportTestFunctions;
}

declare class TextureImportTestFunctions extends ImportTestFunctionsBase { 
	static Load(ResourceName: string): TextureImportTestFunctions;
	static Find(Outer: UObject, ResourceName: string): TextureImportTestFunctions;
	static GetDefaultObject(): TextureImportTestFunctions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextureImportTestFunctions;
	static CheckImportedTextureCount(Textures: Texture[],ExpectedNumberOfImportedTextures: number): InterchangeTestFunctionResult;
	static C(Other: UObject | any): TextureImportTestFunctions;
}

declare class InterchangeTestFunction { 
	AssetClass: UnrealEngineClass;
	OptionalAssetName: string;
	CheckFunction: UFunction;
	Parameters: Map<string, string>;
	clone() : InterchangeTestFunction;
	static C(Other: UObject | any): InterchangeTestFunction;
}

declare class InterchangeImportTestStepBase extends UObject { 
	Tests: InterchangeTestFunction[];
	static Load(ResourceName: string): InterchangeImportTestStepBase;
	static Find(Outer: UObject, ResourceName: string): InterchangeImportTestStepBase;
	static GetDefaultObject(): InterchangeImportTestStepBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeImportTestStepBase;
	static C(Other: UObject | any): InterchangeImportTestStepBase;
}

declare class InterchangeImportTestPlan extends UObject { 
	Steps: InterchangeImportTestStepBase[];
	bIsEnabledInAutomationTests: boolean;
	DisabledTestReason: string;
	static Load(ResourceName: string): InterchangeImportTestPlan;
	static Find(Outer: UObject, ResourceName: string): InterchangeImportTestPlan;
	static GetDefaultObject(): InterchangeImportTestPlan;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeImportTestPlan;
	RunThisTest(): void;
	static C(Other: UObject | any): InterchangeImportTestPlan;
}

declare class InterchangeImportTestStepImport extends InterchangeImportTestStepBase { 
	SourceFile: FilePath;
	PipelineStack: InterchangePipelineBase[];
	bEmptyDestinationFolderPriorToImport: boolean;
	bSaveThenReloadImportedAssets: boolean;
	bImportIntoLevel: boolean;
	static Load(ResourceName: string): InterchangeImportTestStepImport;
	static Find(Outer: UObject, ResourceName: string): InterchangeImportTestStepImport;
	static GetDefaultObject(): InterchangeImportTestStepImport;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeImportTestStepImport;
	static C(Other: UObject | any): InterchangeImportTestStepImport;
}

declare class InterchangeImportTestStepReimport extends InterchangeImportTestStepBase { 
	SourceFileToReimport: FilePath;
	AssetTypeToReimport: UnrealEngineClass;
	AssetNameToReimport: string;
	bSaveThenReloadImportedAssets: boolean;
	static Load(ResourceName: string): InterchangeImportTestStepReimport;
	static Find(Outer: UObject, ResourceName: string): InterchangeImportTestStepReimport;
	static GetDefaultObject(): InterchangeImportTestStepReimport;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeImportTestStepReimport;
	static C(Other: UObject | any): InterchangeImportTestStepReimport;
}

declare class InterchangeImportTestPlanFactory extends Factory { 
	static Load(ResourceName: string): InterchangeImportTestPlanFactory;
	static Find(Outer: UObject, ResourceName: string): InterchangeImportTestPlanFactory;
	static GetDefaultObject(): InterchangeImportTestPlanFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterchangeImportTestPlanFactory;
	static C(Other: UObject | any): InterchangeImportTestPlanFactory;
}

declare class SynthesisEditorSettings extends DeveloperSettings { 
	static Load(ResourceName: string): SynthesisEditorSettings;
	static Find(Outer: UObject, ResourceName: string): SynthesisEditorSettings;
	static GetDefaultObject(): SynthesisEditorSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SynthesisEditorSettings;
	static C(Other: UObject | any): SynthesisEditorSettings;
}

declare class AudioImpulseResponseFactory extends Factory { 
	static Load(ResourceName: string): AudioImpulseResponseFactory;
	static Find(Outer: UObject, ResourceName: string): AudioImpulseResponseFactory;
	static GetDefaultObject(): AudioImpulseResponseFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioImpulseResponseFactory;
	static C(Other: UObject | any): AudioImpulseResponseFactory;
}

declare class ModularSynthPresetBankFactory extends Factory { 
	static Load(ResourceName: string): ModularSynthPresetBankFactory;
	static Find(Outer: UObject, ResourceName: string): ModularSynthPresetBankFactory;
	static GetDefaultObject(): ModularSynthPresetBankFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ModularSynthPresetBankFactory;
	static C(Other: UObject | any): ModularSynthPresetBankFactory;
}

declare class MonoWaveTableSynthPresetFactory extends Factory { 
	static Load(ResourceName: string): MonoWaveTableSynthPresetFactory;
	static Find(Outer: UObject, ResourceName: string): MonoWaveTableSynthPresetFactory;
	static GetDefaultObject(): MonoWaveTableSynthPresetFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MonoWaveTableSynthPresetFactory;
	static C(Other: UObject | any): MonoWaveTableSynthPresetFactory;
}

declare class AutomationUtilsBlueprintLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): AutomationUtilsBlueprintLibrary;
	static Find(Outer: UObject, ResourceName: string): AutomationUtilsBlueprintLibrary;
	static GetDefaultObject(): AutomationUtilsBlueprintLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AutomationUtilsBlueprintLibrary;
	static TakeGameplayAutomationScreenshot(ScreenShotName: string,MaxGlobalError: number,MaxLocalError: number,MapNameOverride: string): void;
	static C(Other: UObject | any): AutomationUtilsBlueprintLibrary;
}

declare class ScreenshotComparisonCommandlet extends Commandlet { 
	static Load(ResourceName: string): ScreenshotComparisonCommandlet;
	static Find(Outer: UObject, ResourceName: string): ScreenshotComparisonCommandlet;
	static GetDefaultObject(): ScreenshotComparisonCommandlet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ScreenshotComparisonCommandlet;
	static C(Other: UObject | any): ScreenshotComparisonCommandlet;
}

declare class SkeletalMeshEditorContextMenuContext extends UObject { 
	static Load(ResourceName: string): SkeletalMeshEditorContextMenuContext;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshEditorContextMenuContext;
	static GetDefaultObject(): SkeletalMeshEditorContextMenuContext;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshEditorContextMenuContext;
	static C(Other: UObject | any): SkeletalMeshEditorContextMenuContext;
}

declare class SkeletalMeshEditorSubsystem extends EditorSubsystem { 
	static Load(ResourceName: string): SkeletalMeshEditorSubsystem;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshEditorSubsystem;
	static GetDefaultObject(): SkeletalMeshEditorSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshEditorSubsystem;
	SetSectionVisibleInRayTracing(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number,bVisibleInRayTracing: boolean): boolean;
	SetSectionRecomputeTangentsVertexMaskChannel(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number,RecomputeTangentsVertexMaskChannel: number): boolean;
	SetSectionRecomputeTangent(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number,bRecomputeTangent: boolean): boolean;
	SetSectionCastShadow(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number,bCastShadow: boolean): boolean;
	static SetLodBuildSettings(SkeletalMesh: SkeletalMesh,LODIndex: number,BuildOptions: SkeletalMeshBuildSettings): void;
	static RenameSocket(SkeletalMesh: SkeletalMesh,OldName: string,NewName: string): boolean;
	static ReimportAllCustomLODs(SkeletalMesh: SkeletalMesh): boolean;
	static RegenerateLOD(SkeletalMesh: SkeletalMesh,NewLODCount: number,bRegenerateEvenIfImported: boolean,bGenerateBaseLOD: boolean): boolean;
	static ImportLOD(BaseMesh: SkeletalMesh,LODIndex: number,SourceFilename: string): number;
	GetSectionVisibleInRayTracing(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number,bOutVisibleInRayTracing?: boolean): {bOutVisibleInRayTracing: boolean, $: boolean};
	GetSectionRecomputeTangentsVertexMaskChannel(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number,OutRecomputeTangentsVertexMaskChannel?: number): {OutRecomputeTangentsVertexMaskChannel: number, $: boolean};
	GetSectionRecomputeTangent(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number,bOutRecomputeTangent?: boolean): {bOutRecomputeTangent: boolean, $: boolean};
	GetSectionCastShadow(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number,bOutCastShadow?: boolean): {bOutCastShadow: boolean, $: boolean};
	GetNumVerts(SkeletalMesh: SkeletalMesh,LODIndex: number): number;
	GetNumSections(SkeletalMesh: SkeletalMesh,LODIndex: number): number;
	GetLODMaterialSlot(SkeletalMesh: SkeletalMesh,LODIndex: number,SectionIndex: number): number;
	static GetLODCount(SkeletalMesh: SkeletalMesh): number;
	static GetLodBuildSettings(SkeletalMesh: SkeletalMesh,LODIndex: number,OutBuildOptions?: SkeletalMeshBuildSettings): {OutBuildOptions: SkeletalMeshBuildSettings};
	static CreatePhysicsAsset(SkeletalMesh: SkeletalMesh): PhysicsAsset;
	static C(Other: UObject | any): SkeletalMeshEditorSubsystem;
}

declare class StaticMeshEditorUISubsystem extends AssetEditorUISubsystem { 
	static Load(ResourceName: string): StaticMeshEditorUISubsystem;
	static Find(Outer: UObject, ResourceName: string): StaticMeshEditorUISubsystem;
	static GetDefaultObject(): StaticMeshEditorUISubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshEditorUISubsystem;
	static C(Other: UObject | any): StaticMeshEditorUISubsystem;
}

declare class JoinStaticMeshActorsOptions { 
	bDestroySourceActors: boolean;
	NewActorLabel: string;
	bRenameComponentsFromSource: boolean;
	clone() : JoinStaticMeshActorsOptions;
	static C(Other: UObject | any): JoinStaticMeshActorsOptions;
}

declare class MergeStaticMeshActorsOptions extends JoinStaticMeshActorsOptions { 
	bSpawnMergedActor: boolean;
	BasePackageName: string;
	MeshMergingSettings: MeshMergingSettings;
	clone() : MergeStaticMeshActorsOptions;
	static C(Other: UObject | any): MergeStaticMeshActorsOptions;
}

declare class CreateProxyMeshActorOptions extends JoinStaticMeshActorsOptions { 
	bSpawnMergedActor: boolean;
	BasePackageName: string;
	MeshProxySettings: MeshProxySettings;
	clone() : CreateProxyMeshActorOptions;
	static C(Other: UObject | any): CreateProxyMeshActorOptions;
}

declare class StaticMeshEditorSubsystem extends EditorSubsystem { 
	static Load(ResourceName: string): StaticMeshEditorSubsystem;
	static Find(Outer: UObject, ResourceName: string): StaticMeshEditorSubsystem;
	static GetDefaultObject(): StaticMeshEditorSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshEditorSubsystem;
	SetNaniteSettings(StaticMesh: StaticMesh,NaniteSettings: MeshNaniteSettings,bApplyChanges: boolean): void;
	SetLodsWithNotification(StaticMesh: StaticMesh,ReductionOptions: StaticMeshReductionOptions,bApplyChanges: boolean): number;
	SetLodScreenSizes(StaticMesh: StaticMesh,ScreenSizes: number[]): boolean;
	SetLods(StaticMesh: StaticMesh,ReductionOptions: StaticMeshReductionOptions): number;
	SetLodReductionSettings(StaticMesh: StaticMesh,LODIndex: number,ReductionOptions: MeshReductionSettings): void;
	SetLODMaterialSlot(StaticMesh: StaticMesh,MaterialSlotIndex: number,LODIndex: number,SectionIndex: number): void;
	SetLODGroup(StaticMesh: StaticMesh,LODGroup: string,bRebuildImmediately: boolean): boolean;
	SetLodFromStaticMesh(DestinationStaticMesh: StaticMesh,DestinationLodIndex: number,SourceStaticMesh: StaticMesh,SourceLodIndex: number,bReuseExistingMaterialSlots: boolean): number;
	SetLodBuildSettings(StaticMesh: StaticMesh,LODIndex: number,BuildOptions: MeshBuildSettings): void;
	SetGenerateLightmapUVs(StaticMesh: StaticMesh,bGenerateLightmapUVs: boolean): boolean;
	SetConvexDecompositionCollisionsWithNotification(StaticMesh: StaticMesh,HullCount: number,MaxHullVerts: number,HullPrecision: number,bApplyChanges: boolean): boolean;
	SetConvexDecompositionCollisions(StaticMesh: StaticMesh,HullCount: number,MaxHullVerts: number,HullPrecision: number): boolean;
	SetAllowCPUAccess(StaticMesh: StaticMesh,bAllowCPUAccess: boolean): void;
	ReplaceMeshComponentsMeshesOnActors(Actors: Actor[],MeshToBeReplaced: StaticMesh,NewMesh: StaticMesh): void;
	ReplaceMeshComponentsMeshes(MeshComponents: StaticMeshComponent[],MeshToBeReplaced: StaticMesh,NewMesh: StaticMesh): void;
	ReplaceMeshComponentsMaterialsOnActors(Actors: Actor[],MaterialToBeReplaced: MaterialInterface,NewMaterial: MaterialInterface): void;
	ReplaceMeshComponentsMaterials(MeshComponents: MeshComponent[],MaterialToBeReplaced: MaterialInterface,NewMaterial: MaterialInterface): void;
	RemoveUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number): boolean;
	RemoveLods(StaticMesh: StaticMesh): boolean;
	RemoveCollisionsWithNotification(StaticMesh: StaticMesh,bApplyChanges: boolean): boolean;
	RemoveCollisions(StaticMesh: StaticMesh): boolean;
	ReimportAllCustomLODs(StaticMesh: StaticMesh): boolean;
	MergeStaticMeshActors(ActorsToMerge: StaticMeshActor[],MergeOptions: MergeStaticMeshActorsOptions,OutMergedActor?: StaticMeshActor): {OutMergedActor: StaticMeshActor, $: boolean};
	JoinStaticMeshActors(ActorsToJoin: StaticMeshActor[],JoinOptions: JoinStaticMeshActorsOptions): Actor;
	IsSectionCollisionEnabled(StaticMesh: StaticMesh,LODIndex: number,SectionIndex: number): boolean;
	InsertUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number): boolean;
	ImportLOD(BaseStaticMesh: StaticMesh,LODIndex: number,SourceFilename: string): number;
	HasVertexColors(StaticMesh: StaticMesh): boolean;
	HasInstanceVertexColors(StaticMeshComponent: StaticMeshComponent): boolean;
	GetSimpleCollisionCount(StaticMesh: StaticMesh): number;
	GetNumUVChannels(StaticMesh: StaticMesh,LODIndex: number): number;
	GetNumberVerts(StaticMesh: StaticMesh,LODIndex: number): number;
	GetNumberMaterials(StaticMesh: StaticMesh): number;
	GetNaniteSettings(StaticMesh: StaticMesh): MeshNaniteSettings;
	GetLodScreenSizes(StaticMesh: StaticMesh): number[];
	GetLodReductionSettings(StaticMesh: StaticMesh,LODIndex: number,OutReductionOptions?: MeshReductionSettings): {OutReductionOptions: MeshReductionSettings};
	GetLODMaterialSlot(StaticMesh: StaticMesh,LODIndex: number,SectionIndex: number): number;
	GetLODGroup(StaticMesh: StaticMesh): string;
	GetLodCount(StaticMesh: StaticMesh): number;
	GetLodBuildSettings(StaticMesh: StaticMesh,LODIndex: number,OutBuildOptions?: MeshBuildSettings): {OutBuildOptions: MeshBuildSettings};
	GetConvexCollisionCount(StaticMesh: StaticMesh): number;
	GetCollisionComplexity(StaticMesh: StaticMesh): ECollisionTraceFlag;
	GeneratePlanarUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Tiling: Vector2D): boolean;
	GenerateCylindricalUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Tiling: Vector2D): boolean;
	GenerateBoxUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Size: Vector): boolean;
	EnableSectionCollision(StaticMesh: StaticMesh,bCollisionEnabled: boolean,LODIndex: number,SectionIndex: number): void;
	EnableSectionCastShadow(StaticMesh: StaticMesh,bCastShadow: boolean,LODIndex: number,SectionIndex: number): void;
	CreateProxyMeshActor(ActorsToMerge: StaticMeshActor[],MergeOptions: CreateProxyMeshActorOptions,OutMergedActor?: StaticMeshActor): {OutMergedActor: StaticMeshActor, $: boolean};
	BulkSetConvexDecompositionCollisionsWithNotification(StaticMeshes: StaticMesh[],HullCount: number,MaxHullVerts: number,HullPrecision: number,bApplyChanges: boolean): boolean;
	BulkSetConvexDecompositionCollisions(StaticMeshes: StaticMesh[],HullCount: number,MaxHullVerts: number,HullPrecision: number): boolean;
	AddUVChannel(StaticMesh: StaticMesh,LODIndex: number): boolean;
	AddSimpleCollisionsWithNotification(StaticMesh: StaticMesh,ShapeType: EScriptCollisionShapeType,bApplyChanges: boolean): number;
	AddSimpleCollisions(StaticMesh: StaticMesh,ShapeType: EScriptCollisionShapeType): number;
	static C(Other: UObject | any): StaticMeshEditorSubsystem;
}

declare class EditorAssetLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): EditorAssetLibrary;
	static Find(Outer: UObject, ResourceName: string): EditorAssetLibrary;
	static GetDefaultObject(): EditorAssetLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorAssetLibrary;
	static SyncBrowserToObjects(AssetPaths: string[]): void;
	static SetMetadataTag(UObject: UObject,Tag: string,Value: string): void;
	static SaveLoadedAssets(AssetsToSave: UObject[],bOnlyIfIsDirty: boolean): boolean;
	static SaveLoadedAsset(AssetToSave: UObject,bOnlyIfIsDirty: boolean): boolean;
	static SaveDirectory(DirectoryPath: string,bOnlyIfIsDirty: boolean,bRecursive: boolean): boolean;
	static SaveAsset(AssetToSave: string,bOnlyIfIsDirty: boolean): boolean;
	static RenameLoadedAsset(SourceAsset: UObject,DestinationAssetPath: string): boolean;
	static RenameDirectory(SourceDirectoryPath: string,DestinationDirectoryPath: string): boolean;
	static RenameAsset(SourceAssetPath: string,DestinationAssetPath: string): boolean;
	static RemoveMetadataTag(UObject: UObject,Tag: string): void;
	static MakeDirectory(DirectoryPath: string): boolean;
	static LoadBlueprintClass(AssetPath: string): UnrealEngineClass;
	static LoadAsset(AssetPath: string): UObject;
	static ListAssets(DirectoryPath: string,bRecursive: boolean,bIncludeFolder: boolean): string[];
	static ListAssetByTagValue(TagName: string,TagValue: string): string[];
	static GetTagValues(AssetPath: string): Map<string, string>;
	static GetPathNameForLoadedAsset(LoadedAsset: UObject): string;
	static GetMetadataTagValues(UObject: UObject): Map<string, string>;
	static GetMetadataTag(UObject: UObject,Tag: string): string;
	static FindPackageReferencersForAsset(AssetPath: string,bLoadAssetsToConfirm: boolean): string[];
	static FindAssetData(AssetPath: string): AssetData;
	static DuplicateLoadedAsset(SourceAsset: UObject,DestinationAssetPath: string): UObject;
	static DuplicateDirectory(SourceDirectoryPath: string,DestinationDirectoryPath: string): boolean;
	static DuplicateAsset(SourceAssetPath: string,DestinationAssetPath: string): UObject;
	static DoesDirectoryHaveAssets(DirectoryPath: string,bRecursive: boolean): boolean;
	static DoesDirectoryExist(DirectoryPath: string): boolean;
	static DoesAssetExist(AssetPath: string): boolean;
	static DoAssetsExist(AssetPaths: string[]): boolean;
	static DeleteLoadedAssets(AssetsToDelete: UObject[]): boolean;
	static DeleteLoadedAsset(AssetToDelete: UObject): boolean;
	static DeleteDirectory(DirectoryPath: string): boolean;
	static DeleteAsset(AssetPathToDelete: string): boolean;
	static ConsolidateAssets(AssetToConsolidateTo: UObject,AssetsToConsolidate: UObject[]): boolean;
	static CheckoutLoadedAssets(AssetsToCheckout: UObject[]): boolean;
	static CheckoutLoadedAsset(AssetToCheckout: UObject): boolean;
	static CheckoutDirectory(DirectoryPath: string,bRecursive: boolean): boolean;
	static CheckoutAsset(AssetToCheckout: string): boolean;
	static C(Other: UObject | any): EditorAssetLibrary;
}

declare class EditorDialogLibraryObjectDetailsViewOptions { 
	bShowObjectName: boolean;
	bAllowSearch: boolean;
	MinWidth: number;
	MinHeight: number;
	ValueColumnWidthRatio: number;
	clone() : EditorDialogLibraryObjectDetailsViewOptions;
	static C(Other: UObject | any): EditorDialogLibraryObjectDetailsViewOptions;
}

declare type EAppMsgType = 'Ok' | 'YesNo' | 'OkCancel' | 'YesNoCancel' | 'CancelRetryContinue' | 'YesNoYesAllNoAll' | 'YesNoYesAllNoAllCancel' | 'YesNoYesAll' | 'EAppMsgType_MAX';
declare var EAppMsgType : { Ok:'Ok',YesNo:'YesNo',OkCancel:'OkCancel',YesNoCancel:'YesNoCancel',CancelRetryContinue:'CancelRetryContinue',YesNoYesAllNoAll:'YesNoYesAllNoAll',YesNoYesAllNoAllCancel:'YesNoYesAllNoAllCancel',YesNoYesAll:'YesNoYesAll',EAppMsgType_MAX:'EAppMsgType_MAX', };
declare class EditorDialogLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): EditorDialogLibrary;
	static Find(Outer: UObject, ResourceName: string): EditorDialogLibrary;
	static GetDefaultObject(): EditorDialogLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorDialogLibrary;
	static ShowSuppressableWarningDialog(Title: string,Message: string,InIniSettingName: string,InIniSettingFileNameOverride: string,bDefaultValue: boolean): boolean;
	static ShowObjectsDetailsView(Title: string,InOutObjects: UObject[],Options: EditorDialogLibraryObjectDetailsViewOptions): boolean;
	static ShowObjectDetailsView(Title: string,InOutObject: UObject,Options: EditorDialogLibraryObjectDetailsViewOptions): boolean;
	static ShowMessage(Title: string,Message: string,MessageType: EAppMsgType,DefaultValue: EAppReturnType): EAppReturnType;
	static C(Other: UObject | any): EditorDialogLibrary;
}

declare type EEditorScriptingFilterType = 'Include' | 'Exclude' | 'EEditorScriptingFilterType_MAX';
declare var EEditorScriptingFilterType : { Include:'Include',Exclude:'Exclude',EEditorScriptingFilterType_MAX:'EEditorScriptingFilterType_MAX', };
declare type EEditorScriptingStringMatchType = 'Contains' | 'MatchesWildcard' | 'ExactMatch' | 'EEditorScriptingStringMatchType_MAX';
declare var EEditorScriptingStringMatchType : { Contains:'Contains',MatchesWildcard:'MatchesWildcard',ExactMatch:'ExactMatch',EEditorScriptingStringMatchType_MAX:'EEditorScriptingStringMatchType_MAX', };
declare class EditorFilterLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): EditorFilterLibrary;
	static Find(Outer: UObject, ResourceName: string): EditorFilterLibrary;
	static GetDefaultObject(): EditorFilterLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorFilterLibrary;
	static BySelection(TargetArray: Actor[],FilterType: EEditorScriptingFilterType): Actor[];
	static ByLevelName(TargetArray: Actor[],LevelName: string,FilterType: EEditorScriptingFilterType): Actor[];
	static ByLayer(TargetArray: Actor[],LayerName: string,FilterType: EEditorScriptingFilterType): Actor[];
	static ByIDName(TargetArray: UObject[],NameSubString: string,StringMatch: EEditorScriptingStringMatchType,FilterType: EEditorScriptingFilterType): UObject[];
	static ByClass(TargetArray: UObject[],ObjectClass: UnrealEngineClass,FilterType: EEditorScriptingFilterType): UObject[];
	static ByActorTag(TargetArray: Actor[],Tag: string,FilterType: EEditorScriptingFilterType): Actor[];
	static ByActorLabel(TargetArray: Actor[],NameSubString: string,StringMatch: EEditorScriptingStringMatchType,FilterType: EEditorScriptingFilterType,bIgnoreCase: boolean): Actor[];
	static C(Other: UObject | any): EditorFilterLibrary;
}

declare class EditorLevelLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): EditorLevelLibrary;
	static Find(Outer: UObject, ResourceName: string): EditorLevelLibrary;
	static GetDefaultObject(): EditorLevelLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorLevelLibrary;
	static SpawnActorFromObject(ObjectToUse: UObject,Location: Vector,Rotation: Rotator,bTransient: boolean): Actor;
	static SpawnActorFromClass(ActorClass: UnrealEngineClass,Location: Vector,Rotation: Rotator,bTransient: boolean): Actor;
	static SetSelectedLevelActors(ActorsToSelect: Actor[]): void;
	static SetLevelViewportCameraInfo(CameraLocation: Vector,CameraRotation: Rotator): void;
	static SetCurrentLevelByName(LevelName: string): boolean;
	static SetActorSelectionState(Actor: Actor,bShouldBeSelected: boolean): void;
	static SelectNothing(): void;
	static SaveCurrentLevel(): boolean;
	static SaveAllDirtyLevels(): boolean;
	static ReplaceSelectedActors(InAssetPath: string): void;
	static ReplaceMeshComponentsMeshesOnActors(Actors: Actor[],MeshToBeReplaced: StaticMesh,NewMesh: StaticMesh): void;
	static ReplaceMeshComponentsMeshes(MeshComponents: StaticMeshComponent[],MeshToBeReplaced: StaticMesh,NewMesh: StaticMesh): void;
	static ReplaceMeshComponentsMaterialsOnActors(Actors: Actor[],MaterialToBeReplaced: MaterialInterface,NewMaterial: MaterialInterface): void;
	static ReplaceMeshComponentsMaterials(MeshComponents: MeshComponent[],MaterialToBeReplaced: MaterialInterface,NewMaterial: MaterialInterface): void;
	static PilotLevelActor(ActorToPilot: Actor): void;
	static NewLevelFromTemplate(AssetPath: string,TemplateAssetPath: string): boolean;
	static NewLevel(AssetPath: string): boolean;
	static MergeStaticMeshActors(ActorsToMerge: StaticMeshActor[],MergeOptions: MergeStaticMeshActorsOptions,OutMergedActor?: StaticMeshActor): {OutMergedActor: StaticMeshActor, $: boolean};
	static LoadLevel(AssetPath: string): boolean;
	static JoinStaticMeshActors(ActorsToJoin: StaticMeshActor[],JoinOptions: JoinStaticMeshActorsOptions): Actor;
	static GetSelectedLevelActors(): Actor[];
	static GetPIEWorlds(bIncludeDedicatedServer: boolean): World[];
	static GetLevelViewportCameraInfo(CameraLocation?: Vector,CameraRotation?: Rotator): {CameraLocation: Vector, CameraRotation: Rotator, $: boolean};
	static GetGameWorld(): World;
	static GetEditorWorld(): World;
	static GetAllLevelActorsComponents(): ActorComponent[];
	static GetAllLevelActors(): Actor[];
	static GetActorReference(PathToActor: string): Actor;
	static EjectPilotLevelActor(): void;
	static EditorSetGameView(bGameView: boolean): void;
	static EditorPlaySimulate(): void;
	static EditorInvalidateViewports(): void;
	static EditorEndPlay(): void;
	static DestroyActor(ActorToDestroy: Actor): boolean;
	static CreateProxyMeshActor(ActorsToMerge: StaticMeshActor[],MergeOptions: CreateProxyMeshActorOptions,OutMergedActor?: StaticMeshActor): {OutMergedActor: StaticMeshActor, $: boolean};
	static ConvertActors(Actors: Actor[],ActorClass: UnrealEngineClass,StaticMeshPackagePath: string): Actor[];
	static ClearActorSelectionSet(): void;
	static C(Other: UObject | any): EditorLevelLibrary;
}

declare class EditorSkeletalMeshLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): EditorSkeletalMeshLibrary;
	static Find(Outer: UObject, ResourceName: string): EditorSkeletalMeshLibrary;
	static GetDefaultObject(): EditorSkeletalMeshLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorSkeletalMeshLibrary;
	static StripLODGeometry(SkeletalMesh: SkeletalMesh,LODIndex: number,TextureMask: Texture2D,Threshold: number): boolean;
	static SetLodBuildSettings(SkeletalMesh: SkeletalMesh,LODIndex: number,BuildOptions: SkeletalMeshBuildSettings): void;
	static RenameSocket(SkeletalMesh: SkeletalMesh,OldName: string,NewName: string): boolean;
	static RemoveLODs(SkeletalMesh: SkeletalMesh,ToRemoveLODs: number[]): boolean;
	static ReimportAllCustomLODs(SkeletalMesh: SkeletalMesh): boolean;
	static RegenerateLOD(SkeletalMesh: SkeletalMesh,NewLODCount: number,bRegenerateEvenIfImported: boolean,bGenerateBaseLOD: boolean): boolean;
	static ImportLOD(BaseMesh: SkeletalMesh,LODIndex: number,SourceFilename: string): number;
	static GetNumVerts(SkeletalMesh: SkeletalMesh,LODIndex: number): number;
	static GetLODCount(SkeletalMesh: SkeletalMesh): number;
	static GetLodBuildSettings(SkeletalMesh: SkeletalMesh,LODIndex: number,OutBuildOptions?: SkeletalMeshBuildSettings): {OutBuildOptions: SkeletalMeshBuildSettings};
	static CreatePhysicsAsset(SkeletalMesh: SkeletalMesh): PhysicsAsset;
	static C(Other: UObject | any): EditorSkeletalMeshLibrary;
}

declare class EditorStaticMeshLibrary extends BlueprintFunctionLibrary { 
	static Load(ResourceName: string): EditorStaticMeshLibrary;
	static Find(Outer: UObject, ResourceName: string): EditorStaticMeshLibrary;
	static GetDefaultObject(): EditorStaticMeshLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorStaticMeshLibrary;
	static SetLodsWithNotification(StaticMesh: StaticMesh,ReductionOptions: StaticMeshReductionOptions,bApplyChanges: boolean): number;
	static SetLods(StaticMesh: StaticMesh,ReductionOptions: StaticMeshReductionOptions): number;
	static SetLodReductionSettings(StaticMesh: StaticMesh,LODIndex: number,ReductionOptions: MeshReductionSettings): void;
	static SetLodFromStaticMesh(DestinationStaticMesh: StaticMesh,DestinationLodIndex: number,SourceStaticMesh: StaticMesh,SourceLodIndex: number,bReuseExistingMaterialSlots: boolean): number;
	static SetLodBuildSettings(StaticMesh: StaticMesh,LODIndex: number,BuildOptions: MeshBuildSettings): void;
	static SetGenerateLightmapUVs(StaticMesh: StaticMesh,bGenerateLightmapUVs: boolean): boolean;
	static SetConvexDecompositionCollisionsWithNotification(StaticMesh: StaticMesh,HullCount: number,MaxHullVerts: number,HullPrecision: number,bApplyChanges: boolean): boolean;
	static SetConvexDecompositionCollisions(StaticMesh: StaticMesh,HullCount: number,MaxHullVerts: number,HullPrecision: number): boolean;
	static SetAllowCPUAccess(StaticMesh: StaticMesh,bAllowCPUAccess: boolean): void;
	static RemoveUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number): boolean;
	static RemoveLods(StaticMesh: StaticMesh): boolean;
	static RemoveCollisionsWithNotification(StaticMesh: StaticMesh,bApplyChanges: boolean): boolean;
	static RemoveCollisions(StaticMesh: StaticMesh): boolean;
	static ReimportAllCustomLODs(StaticMesh: StaticMesh): boolean;
	static IsSectionCollisionEnabled(StaticMesh: StaticMesh,LODIndex: number,SectionIndex: number): boolean;
	static InsertUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number): boolean;
	static ImportLOD(BaseStaticMesh: StaticMesh,LODIndex: number,SourceFilename: string): number;
	static HasVertexColors(StaticMesh: StaticMesh): boolean;
	static HasInstanceVertexColors(StaticMeshComponent: StaticMeshComponent): boolean;
	static GetSimpleCollisionCount(StaticMesh: StaticMesh): number;
	static GetNumUVChannels(StaticMesh: StaticMesh,LODIndex: number): number;
	static GetNumberVerts(StaticMesh: StaticMesh,LODIndex: number): number;
	static GetNumberMaterials(StaticMesh: StaticMesh): number;
	static GetLodScreenSizes(StaticMesh: StaticMesh): number[];
	static GetLodReductionSettings(StaticMesh: StaticMesh,LODIndex: number,OutReductionOptions?: MeshReductionSettings): {OutReductionOptions: MeshReductionSettings};
	static GetLodCount(StaticMesh: StaticMesh): number;
	static GetLodBuildSettings(StaticMesh: StaticMesh,LODIndex: number,OutBuildOptions?: MeshBuildSettings): {OutBuildOptions: MeshBuildSettings};
	static GetConvexCollisionCount(StaticMesh: StaticMesh): number;
	static GetCollisionComplexity(StaticMesh: StaticMesh): ECollisionTraceFlag;
	static GeneratePlanarUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Tiling: Vector2D): boolean;
	static GenerateCylindricalUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Tiling: Vector2D): boolean;
	static GenerateBoxUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Size: Vector): boolean;
	static EnableSectionCollision(StaticMesh: StaticMesh,bCollisionEnabled: boolean,LODIndex: number,SectionIndex: number): void;
	static EnableSectionCastShadow(StaticMesh: StaticMesh,bCastShadow: boolean,LODIndex: number,SectionIndex: number): void;
	static BulkSetConvexDecompositionCollisionsWithNotification(StaticMeshes: StaticMesh[],HullCount: number,MaxHullVerts: number,HullPrecision: number,bApplyChanges: boolean): boolean;
	static BulkSetConvexDecompositionCollisions(StaticMeshes: StaticMesh[],HullCount: number,MaxHullVerts: number,HullPrecision: number): boolean;
	static AddUVChannel(StaticMesh: StaticMesh,LODIndex: number): boolean;
	static AddSimpleCollisionsWithNotification(StaticMesh: StaticMesh,ShapeType: EScriptCollisionShapeType,bApplyChanges: boolean): number;
	static AddSimpleCollisions(StaticMesh: StaticMesh,ShapeType: EScriptCollisionShapeType): number;
	static C(Other: UObject | any): EditorStaticMeshLibrary;
}

declare class FractureEditorMode extends BaseLegacyWidgetEdMode { 
	static Load(ResourceName: string): FractureEditorMode;
	static Find(Outer: UObject, ResourceName: string): FractureEditorMode;
	static GetDefaultObject(): FractureEditorMode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureEditorMode;
	static C(Other: UObject | any): FractureEditorMode;
}

declare class FractureModeCustomSectionColor { 
	SectionName: string;
	Color: LinearColor;
	clone() : FractureModeCustomSectionColor;
	static C(Other: UObject | any): FractureModeCustomSectionColor;
}

declare class FractureModeCustomToolColor { 
	ToolName: string;
	Color: LinearColor;
	clone() : FractureModeCustomToolColor;
	static C(Other: UObject | any): FractureModeCustomToolColor;
}

declare class FractureModeCustomizationSettings extends DeveloperSettings { 
	ToolSectionOrder: string[];
	ToolFavorites: string[];
	SectionColors: FractureModeCustomSectionColor[];
	ToolColors: FractureModeCustomToolColor[];
	static Load(ResourceName: string): FractureModeCustomizationSettings;
	static Find(Outer: UObject, ResourceName: string): FractureModeCustomizationSettings;
	static GetDefaultObject(): FractureModeCustomizationSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureModeCustomizationSettings;
	static C(Other: UObject | any): FractureModeCustomizationSettings;
}

declare type EConvexOverlapRemoval = 'None' | 'All' | 'OnlyClusters' | 'OnlyClustersVsClusters' | 'EConvexOverlapRemoval_MAX';
declare var EConvexOverlapRemoval : { None:'None',All:'All',OnlyClusters:'OnlyClusters',OnlyClustersVsClusters:'OnlyClustersVsClusters',EConvexOverlapRemoval_MAX:'EConvexOverlapRemoval_MAX', };
declare class FractureModeSettings extends DeveloperSettings { 
	ConvexCanExceedFraction: number;
	ConvexSimplificationDistanceThreshold: number;
	ConvexRemoveOverlaps: EConvexOverlapRemoval;
	ConvexOverlapRemovalShrinkPercent: number;
	ConvexFractionAllowRemove: number;
	static Load(ResourceName: string): FractureModeSettings;
	static Find(Outer: UObject, ResourceName: string): FractureModeSettings;
	static GetDefaultObject(): FractureModeSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureModeSettings;
	static C(Other: UObject | any): FractureModeSettings;
}

declare class FractureSettings extends UObject { 
	ExplodeAmount: number;
	FractureLevel: number;
	bHideUnselected: boolean;
	static Load(ResourceName: string): FractureSettings;
	static Find(Outer: UObject, ResourceName: string): FractureSettings;
	static GetDefaultObject(): FractureSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureSettings;
	static C(Other: UObject | any): FractureSettings;
}

declare class FractureActionTool extends UObject { 
	static Load(ResourceName: string): FractureActionTool;
	static Find(Outer: UObject, ResourceName: string): FractureActionTool;
	static GetDefaultObject(): FractureActionTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureActionTool;
	static C(Other: UObject | any): FractureActionTool;
}

declare class FractureModalTool extends FractureActionTool { 
	VisualizedCollections: GeometryCollectionComponent[];
	static Load(ResourceName: string): FractureModalTool;
	static Find(Outer: UObject, ResourceName: string): FractureModalTool;
	static GetDefaultObject(): FractureModalTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureModalTool;
	static C(Other: UObject | any): FractureModalTool;
}

declare class FractureToolSettings extends UObject { 
	OwnerTool: FractureModalTool;
	static Load(ResourceName: string): FractureToolSettings;
	static Find(Outer: UObject, ResourceName: string): FractureToolSettings;
	static GetDefaultObject(): FractureToolSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolSettings;
	static C(Other: UObject | any): FractureToolSettings;
}

declare type EFractureAutoClusterMode = 'BoundingBox' | 'Proximity' | 'Distance' | 'Voronoi' | 'EFractureAutoClusterMode_MAX';
declare var EFractureAutoClusterMode : { BoundingBox:'BoundingBox',Proximity:'Proximity',Distance:'Distance',Voronoi:'Voronoi',EFractureAutoClusterMode_MAX:'EFractureAutoClusterMode_MAX', };
declare type EClusterSizeMethod = 'ByNumber' | 'ByFractionOfInput' | 'EClusterSizeMethod_MAX';
declare var EClusterSizeMethod : { ByNumber:'ByNumber',ByFractionOfInput:'ByFractionOfInput',EClusterSizeMethod_MAX:'EClusterSizeMethod_MAX', };
declare class FractureAutoClusterSettings extends FractureToolSettings { 
	AutoClusterMode: EFractureAutoClusterMode;
	ClusterSizeMethod: EClusterSizeMethod;
	SiteCount: number;
	SiteCountFraction: number;
	bEnforceConnectivity: boolean;
	bAvoidIsolated: boolean;
	static Load(ResourceName: string): FractureAutoClusterSettings;
	static Find(Outer: UObject, ResourceName: string): FractureAutoClusterSettings;
	static GetDefaultObject(): FractureAutoClusterSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureAutoClusterSettings;
	static C(Other: UObject | any): FractureAutoClusterSettings;
}

declare class FractureToolAutoCluster extends FractureModalTool { 
	AutoClusterSettings: FractureAutoClusterSettings;
	static Load(ResourceName: string): FractureToolAutoCluster;
	static Find(Outer: UObject, ResourceName: string): FractureToolAutoCluster;
	static GetDefaultObject(): FractureToolAutoCluster;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolAutoCluster;
	static C(Other: UObject | any): FractureToolAutoCluster;
}

declare type EFractureBrickBond = 'Stretcher' | 'Stack' | 'English' | 'Header' | 'Flemish' | 'EFractureBrickBond_MAX';
declare var EFractureBrickBond : { Stretcher:'Stretcher',Stack:'Stack',English:'English',Header:'Header',Flemish:'Flemish',EFractureBrickBond_MAX:'EFractureBrickBond_MAX', };
declare class FractureBrickSettings extends FractureToolSettings { 
	Bond: EFractureBrickBond;
	BrickLength: number;
	BrickHeight: number;
	BrickDepth: number;
	static Load(ResourceName: string): FractureBrickSettings;
	static Find(Outer: UObject, ResourceName: string): FractureBrickSettings;
	static GetDefaultObject(): FractureBrickSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureBrickSettings;
	static C(Other: UObject | any): FractureBrickSettings;
}

declare class FractureInteractiveTool extends FractureModalTool { 
	static Load(ResourceName: string): FractureInteractiveTool;
	static Find(Outer: UObject, ResourceName: string): FractureInteractiveTool;
	static GetDefaultObject(): FractureInteractiveTool;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureInteractiveTool;
	static C(Other: UObject | any): FractureInteractiveTool;
}

declare class FractureCutterSettings extends FractureToolSettings { 
	RandomSeed: number;
	ChanceToFracture: number;
	bGroupFracture: boolean;
	bGroupFractureToggleEnabled: boolean;
	bDrawSites: boolean;
	bDrawSitesToggleEnabled: boolean;
	bDrawDiagram: boolean;
	Grout: number;
	bGroutSettingEnabled: boolean;
	Amplitude: number;
	Frequency: number;
	Persistence: number;
	Lacunarity: number;
	OctaveNumber: number;
	PointSpacing: number;
	bNoiseSettingsEnabled: boolean;
	static Load(ResourceName: string): FractureCutterSettings;
	static Find(Outer: UObject, ResourceName: string): FractureCutterSettings;
	static GetDefaultObject(): FractureCutterSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureCutterSettings;
	static C(Other: UObject | any): FractureCutterSettings;
}

declare class FractureCollisionSettings extends FractureToolSettings { 
	bAddSamplesForCollision: boolean;
	PointSpacing: number;
	static Load(ResourceName: string): FractureCollisionSettings;
	static Find(Outer: UObject, ResourceName: string): FractureCollisionSettings;
	static GetDefaultObject(): FractureCollisionSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureCollisionSettings;
	static C(Other: UObject | any): FractureCollisionSettings;
}

declare class FractureToolCutterBase extends FractureInteractiveTool { 
	CutterSettings: FractureCutterSettings;
	CollisionSettings: FractureCollisionSettings;
	static Load(ResourceName: string): FractureToolCutterBase;
	static Find(Outer: UObject, ResourceName: string): FractureToolCutterBase;
	static GetDefaultObject(): FractureToolCutterBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolCutterBase;
	static C(Other: UObject | any): FractureToolCutterBase;
}

declare class FractureToolBrick extends FractureToolCutterBase { 
	BrickSettings: FractureBrickSettings;
	static Load(ResourceName: string): FractureToolBrick;
	static Find(Outer: UObject, ResourceName: string): FractureToolBrick;
	static GetDefaultObject(): FractureToolBrick;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolBrick;
	static C(Other: UObject | any): FractureToolBrick;
}

declare class FractureClusterCutterSettings extends FractureToolSettings { 
	NumberClustersMin: number;
	NumberClustersMax: number;
	SitesPerClusterMin: number;
	SitesPerClusterMax: number;
	ClusterRadiusFractionMin: number;
	ClusterRadiusFractionMax: number;
	ClusterRadiusOffset: number;
	static Load(ResourceName: string): FractureClusterCutterSettings;
	static Find(Outer: UObject, ResourceName: string): FractureClusterCutterSettings;
	static GetDefaultObject(): FractureClusterCutterSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureClusterCutterSettings;
	static C(Other: UObject | any): FractureClusterCutterSettings;
}

declare class FractureToolVoronoiCutterBase extends FractureToolCutterBase { 
	VoronoiLineSets: LineSetComponent[];
	static Load(ResourceName: string): FractureToolVoronoiCutterBase;
	static Find(Outer: UObject, ResourceName: string): FractureToolVoronoiCutterBase;
	static GetDefaultObject(): FractureToolVoronoiCutterBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolVoronoiCutterBase;
	static C(Other: UObject | any): FractureToolVoronoiCutterBase;
}

declare class FractureToolClusterCutter extends FractureToolVoronoiCutterBase { 
	ClusterSettings: FractureClusterCutterSettings;
	static Load(ResourceName: string): FractureToolClusterCutter;
	static Find(Outer: UObject, ResourceName: string): FractureToolClusterCutter;
	static GetDefaultObject(): FractureToolClusterCutter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolClusterCutter;
	static C(Other: UObject | any): FractureToolClusterCutter;
}

declare class FractureToolFlattenAll extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolFlattenAll;
	static Find(Outer: UObject, ResourceName: string): FractureToolFlattenAll;
	static GetDefaultObject(): FractureToolFlattenAll;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolFlattenAll;
	static C(Other: UObject | any): FractureToolFlattenAll;
}

declare class FractureToolCluster extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolCluster;
	static Find(Outer: UObject, ResourceName: string): FractureToolCluster;
	static GetDefaultObject(): FractureToolCluster;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolCluster;
	static C(Other: UObject | any): FractureToolCluster;
}

declare class FractureToolUncluster extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolUncluster;
	static Find(Outer: UObject, ResourceName: string): FractureToolUncluster;
	static GetDefaultObject(): FractureToolUncluster;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolUncluster;
	static C(Other: UObject | any): FractureToolUncluster;
}

declare class FractureToolMoveUp extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolMoveUp;
	static Find(Outer: UObject, ResourceName: string): FractureToolMoveUp;
	static GetDefaultObject(): FractureToolMoveUp;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolMoveUp;
	static C(Other: UObject | any): FractureToolMoveUp;
}

declare class FractureToolClusterMerge extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolClusterMerge;
	static Find(Outer: UObject, ResourceName: string): FractureToolClusterMerge;
	static GetDefaultObject(): FractureToolClusterMerge;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolClusterMerge;
	static C(Other: UObject | any): FractureToolClusterMerge;
}

declare class FractureClusterMagnetSettings extends FractureToolSettings { 
	Iterations: number;
	static Load(ResourceName: string): FractureClusterMagnetSettings;
	static Find(Outer: UObject, ResourceName: string): FractureClusterMagnetSettings;
	static GetDefaultObject(): FractureClusterMagnetSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureClusterMagnetSettings;
	static C(Other: UObject | any): FractureClusterMagnetSettings;
}

declare class FractureToolClusterMagnet extends FractureModalTool { 
	ClusterMagnetSettings: FractureClusterMagnetSettings;
	static Load(ResourceName: string): FractureToolClusterMagnet;
	static Find(Outer: UObject, ResourceName: string): FractureToolClusterMagnet;
	static GetDefaultObject(): FractureToolClusterMagnet;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolClusterMagnet;
	static C(Other: UObject | any): FractureToolClusterMagnet;
}

declare class FractureConvertSettings extends FractureToolSettings { 
	bPromptForBaseName: boolean;
	bPerBone: boolean;
	bCenterPivots: boolean;
	bPlaceInWorld: boolean;
	bSelectNewActors: boolean;
	static Load(ResourceName: string): FractureConvertSettings;
	static Find(Outer: UObject, ResourceName: string): FractureConvertSettings;
	static GetDefaultObject(): FractureConvertSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureConvertSettings;
	static C(Other: UObject | any): FractureConvertSettings;
}

declare class FractureToolConvert extends FractureModalTool { 
	ConvertSettings: FractureConvertSettings;
	static Load(ResourceName: string): FractureToolConvert;
	static Find(Outer: UObject, ResourceName: string): FractureToolConvert;
	static GetDefaultObject(): FractureToolConvert;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolConvert;
	static C(Other: UObject | any): FractureToolConvert;
}

declare class FractureConvexSettings extends FractureToolSettings { 
	CanExceedFraction: number;
	SimplificationDistanceThreshold: number;
	RemoveOverlaps: EConvexOverlapRemoval;
	OverlapRemovalShrinkPercent: number;
	FractionAllowRemove: number;
	static Load(ResourceName: string): FractureConvexSettings;
	static Find(Outer: UObject, ResourceName: string): FractureConvexSettings;
	static GetDefaultObject(): FractureConvexSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureConvexSettings;
	DeleteFromSelected(): void;
	ClearCustomConvex(): void;
	static C(Other: UObject | any): FractureConvexSettings;
}

declare class FractureConvexActions extends FractureToolSettings { 
	static Load(ResourceName: string): FractureConvexActions;
	static Find(Outer: UObject, ResourceName: string): FractureConvexActions;
	static GetDefaultObject(): FractureConvexActions;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureConvexActions;
	SetFromDefaults(): void;
	SaveAsDefaults(): void;
	static C(Other: UObject | any): FractureConvexActions;
}

declare class FractureToolConvex extends FractureModalTool { 
	ConvexSettings: FractureConvexSettings;
	ConvexActions: FractureConvexActions;
	static Load(ResourceName: string): FractureToolConvex;
	static Find(Outer: UObject, ResourceName: string): FractureToolConvex;
	static GetDefaultObject(): FractureToolConvex;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolConvex;
	static C(Other: UObject | any): FractureToolConvex;
}

declare type EVoronoiPattern = 'Centered' | 'Uniform' | 'Grid' | 'MeshVertices' | 'SelectedBones' | 'EVoronoiPattern_MAX';
declare var EVoronoiPattern : { Centered:'Centered',Uniform:'Uniform',Grid:'Grid',MeshVertices:'MeshVertices',SelectedBones:'SelectedBones',EVoronoiPattern_MAX:'EVoronoiPattern_MAX', };
declare type EDownsamplingMode = 'Random' | 'UniformSpacing' | 'KeepSharp' | 'EDownsamplingMode_MAX';
declare var EDownsamplingMode : { Random:'Random',UniformSpacing:'UniformSpacing',KeepSharp:'KeepSharp',EDownsamplingMode_MAX:'EDownsamplingMode_MAX', };
declare class FractureCustomVoronoiSettings extends FractureToolSettings { 
	VoronoiPattern: EVoronoiPattern;
	NormalOffset: number;
	Variability: number;
	SitesToAdd: number;
	GridX: number;
	GridY: number;
	GridZ: number;
	SkipFraction: number;
	SkipMode: EDownsamplingMode;
	ReferenceMesh: StaticMeshActor;
	bStartAtActor: boolean;
	static Load(ResourceName: string): FractureCustomVoronoiSettings;
	static Find(Outer: UObject, ResourceName: string): FractureCustomVoronoiSettings;
	static GetDefaultObject(): FractureCustomVoronoiSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureCustomVoronoiSettings;
	UnfreezeSites(): void;
	RegenerateLiveSites(): void;
	FreezeLiveSites(): void;
	ClearFrozenSites(): void;
	static C(Other: UObject | any): FractureCustomVoronoiSettings;
}

declare class FractureTransformGizmoSettings extends FractureToolSettings { 
	bUseGizmo: boolean;
	bCenterOnSelection: boolean;
	bShowUseGizmoOption: boolean;
	TransformGizmo: CombinedTransformGizmo;
	TransformProxy: TransformProxy;
	AttachedCutter: FractureToolCutterBase;
	UsedToolsContext: InteractiveToolsContext;
	static Load(ResourceName: string): FractureTransformGizmoSettings;
	static Find(Outer: UObject, ResourceName: string): FractureTransformGizmoSettings;
	static GetDefaultObject(): FractureTransformGizmoSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureTransformGizmoSettings;
	static C(Other: UObject | any): FractureTransformGizmoSettings;
}

declare class FractureToolCustomVoronoi extends FractureToolVoronoiCutterBase { 
	CustomVoronoiSettings: FractureCustomVoronoiSettings;
	GizmoSettings: FractureTransformGizmoSettings;
	static Load(ResourceName: string): FractureToolCustomVoronoi;
	static Find(Outer: UObject, ResourceName: string): FractureToolCustomVoronoi;
	static GetDefaultObject(): FractureToolCustomVoronoi;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolCustomVoronoi;
	static C(Other: UObject | any): FractureToolCustomVoronoi;
}

declare class FractureToolDeleteBranch extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolDeleteBranch;
	static Find(Outer: UObject, ResourceName: string): FractureToolDeleteBranch;
	static GetDefaultObject(): FractureToolDeleteBranch;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolDeleteBranch;
	static C(Other: UObject | any): FractureToolDeleteBranch;
}

declare class FractureToolMergeSelected extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolMergeSelected;
	static Find(Outer: UObject, ResourceName: string): FractureToolMergeSelected;
	static GetDefaultObject(): FractureToolMergeSelected;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolMergeSelected;
	static C(Other: UObject | any): FractureToolMergeSelected;
}

declare class FractureToolSplitSelected extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolSplitSelected;
	static Find(Outer: UObject, ResourceName: string): FractureToolSplitSelected;
	static GetDefaultObject(): FractureToolSplitSelected;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolSplitSelected;
	static C(Other: UObject | any): FractureToolSplitSelected;
}

declare class FractureToolHide extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolHide;
	static Find(Outer: UObject, ResourceName: string): FractureToolHide;
	static GetDefaultObject(): FractureToolHide;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolHide;
	static C(Other: UObject | any): FractureToolHide;
}

declare class FractureToolUnhide extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolUnhide;
	static Find(Outer: UObject, ResourceName: string): FractureToolUnhide;
	static GetDefaultObject(): FractureToolUnhide;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolUnhide;
	static C(Other: UObject | any): FractureToolUnhide;
}

declare class FractureValidateSettings extends FractureToolSettings { 
	bRemoveUnreferencedGeometry: boolean;
	bRemoveClustersOfOne: boolean;
	bRemoveDanglingClusters: boolean;
	static Load(ResourceName: string): FractureValidateSettings;
	static Find(Outer: UObject, ResourceName: string): FractureValidateSettings;
	static GetDefaultObject(): FractureValidateSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureValidateSettings;
	static C(Other: UObject | any): FractureValidateSettings;
}

declare class FractureToolValidate extends FractureModalTool { 
	ValidationSettings: FractureValidateSettings;
	static Load(ResourceName: string): FractureToolValidate;
	static Find(Outer: UObject, ResourceName: string): FractureToolValidate;
	static GetDefaultObject(): FractureToolValidate;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolValidate;
	static C(Other: UObject | any): FractureToolValidate;
}

declare class FractureToolAddEmbeddedGeometry extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolAddEmbeddedGeometry;
	static Find(Outer: UObject, ResourceName: string): FractureToolAddEmbeddedGeometry;
	static GetDefaultObject(): FractureToolAddEmbeddedGeometry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolAddEmbeddedGeometry;
	static C(Other: UObject | any): FractureToolAddEmbeddedGeometry;
}

declare class FractureToolAutoEmbedGeometry extends FractureActionTool { 
	static Load(ResourceName: string): FractureToolAutoEmbedGeometry;
	static Find(Outer: UObject, ResourceName: string): FractureToolAutoEmbedGeometry;
	static GetDefaultObject(): FractureToolAutoEmbedGeometry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolAutoEmbedGeometry;
	static C(Other: UObject | any): FractureToolAutoEmbedGeometry;
}

declare class FractureToolFlushEmbeddedGeometrySettings extends FractureToolSettings { 
	bExtractAsStaticMeshActors: boolean;
	static Load(ResourceName: string): FractureToolFlushEmbeddedGeometrySettings;
	static Find(Outer: UObject, ResourceName: string): FractureToolFlushEmbeddedGeometrySettings;
	static GetDefaultObject(): FractureToolFlushEmbeddedGeometrySettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolFlushEmbeddedGeometrySettings;
	static C(Other: UObject | any): FractureToolFlushEmbeddedGeometrySettings;
}

declare class FractureToolFlushEmbeddedGeometry extends FractureModalTool { 
	FlushEmbeddedGeometrySettings: FractureToolFlushEmbeddedGeometrySettings;
	static Load(ResourceName: string): FractureToolFlushEmbeddedGeometry;
	static Find(Outer: UObject, ResourceName: string): FractureToolFlushEmbeddedGeometry;
	static GetDefaultObject(): FractureToolFlushEmbeddedGeometry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolFlushEmbeddedGeometry;
	static C(Other: UObject | any): FractureToolFlushEmbeddedGeometry;
}

declare type ENeighborSelectionMethod = 'LargestNeighbor' | 'NearestCenter' | 'ENeighborSelectionMethod_MAX';
declare var ENeighborSelectionMethod : { LargestNeighbor:'LargestNeighbor',NearestCenter:'NearestCenter',ENeighborSelectionMethod_MAX:'ENeighborSelectionMethod_MAX', };
declare type EUseBoneSelection = 'NoEffect' | 'AlsoMergeSelected' | 'OnlyMergeSelected' | 'EUseBoneSelection_MAX';
declare var EUseBoneSelection : { NoEffect:'NoEffect',AlsoMergeSelected:'AlsoMergeSelected',OnlyMergeSelected:'OnlyMergeSelected',EUseBoneSelection_MAX:'EUseBoneSelection_MAX', };
declare type EGeometrySelectionMethod = 'VolumeCubeRoot' | 'RelativeVolume' | 'EGeometrySelectionMethod_MAX';
declare var EGeometrySelectionMethod : { VolumeCubeRoot:'VolumeCubeRoot',RelativeVolume:'RelativeVolume',EGeometrySelectionMethod_MAX:'EGeometrySelectionMethod_MAX', };
declare class FractureTinyGeoSettings extends FractureToolSettings { 
	NeighborSelection: ENeighborSelectionMethod;
	UseBoneSelection: EUseBoneSelection;
	SelectionMethod: EGeometrySelectionMethod;
	MinVolumeCubeRoot: number;
	RelativeVolume: number;
	static Load(ResourceName: string): FractureTinyGeoSettings;
	static Find(Outer: UObject, ResourceName: string): FractureTinyGeoSettings;
	static GetDefaultObject(): FractureTinyGeoSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureTinyGeoSettings;
	static C(Other: UObject | any): FractureTinyGeoSettings;
}

declare class FractureToolFixTinyGeo extends FractureToolCutterBase { 
	TinyGeoSettings: FractureTinyGeoSettings;
	static Load(ResourceName: string): FractureToolFixTinyGeo;
	static Find(Outer: UObject, ResourceName: string): FractureToolFixTinyGeo;
	static GetDefaultObject(): FractureToolFixTinyGeo;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolFixTinyGeo;
	static C(Other: UObject | any): FractureToolFixTinyGeo;
}

declare class FractureToolGenerateAsset extends FractureActionTool { 
	AssetPath: string;
	static Load(ResourceName: string): FractureToolGenerateAsset;
	static Find(Outer: UObject, ResourceName: string): FractureToolGenerateAsset;
	static GetDefaultObject(): FractureToolGenerateAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolGenerateAsset;
	static C(Other: UObject | any): FractureToolGenerateAsset;
}

declare class FractureToolResetAsset extends FractureToolGenerateAsset { 
	static Load(ResourceName: string): FractureToolResetAsset;
	static Find(Outer: UObject, ResourceName: string): FractureToolResetAsset;
	static GetDefaultObject(): FractureToolResetAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolResetAsset;
	static C(Other: UObject | any): FractureToolResetAsset;
}

declare type EMeshCutDistribution = 'SingleCut' | 'UniformRandom' | 'Grid' | 'EMeshCutDistribution_MAX';
declare var EMeshCutDistribution : { SingleCut:'SingleCut',UniformRandom:'UniformRandom',Grid:'Grid',EMeshCutDistribution_MAX:'EMeshCutDistribution_MAX', };
declare class FractureMeshCutSettings extends FractureToolSettings { 
	CuttingActor: StaticMeshActor;
	CutDistribution: EMeshCutDistribution;
	NumberToScatter: number;
	GridX: number;
	GridY: number;
	GridZ: number;
	Variability: number;
	MinScaleFactor: number;
	MaxScaleFactor: number;
	bRandomOrientation: boolean;
	RollRange: number;
	PitchRange: number;
	YawRange: number;
	static Load(ResourceName: string): FractureMeshCutSettings;
	static Find(Outer: UObject, ResourceName: string): FractureMeshCutSettings;
	static GetDefaultObject(): FractureMeshCutSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureMeshCutSettings;
	static C(Other: UObject | any): FractureMeshCutSettings;
}

declare class FractureToolMeshCut extends FractureToolCutterBase { 
	MeshCutSettings: FractureMeshCutSettings;
	static Load(ResourceName: string): FractureToolMeshCut;
	static Find(Outer: UObject, ResourceName: string): FractureToolMeshCut;
	static GetDefaultObject(): FractureToolMeshCut;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FractureToolMeshCut;
	static C(Other: UObject | any): FractureToolMeshCut;
}

declare class FracturePlaneCutSettings extends FractureToolSettings { 
	NumberPlanarCuts: number;
	bCanCutWithMultiplePlanes: boolean;
	static Load(ResourceName: string): FracturePlaneCutSettings;
	static Find(Outer: UObject, ResourceName: string): FracturePlaneCutSettings;
	static GetDefaultObject(): FracturePlaneCutSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FracturePlaneCutSettings;
	static C(Other: UObject | any): FracturePlaneCutSettings;
}

